

#include <string>
#include <sstream>

#include "common_cl.c"

#include "double_pre_cl.c"
#include "double_pre_r_cl.c"
#include "double_pre_c_cl.c"
#include "double_pre_m_cl.c"
#include "double_post_cl.c"
#include "double_post_r_cl.c"
#include "double_post_c_cl.c"
#include "double_post_m_cl.c"

#include "floatexp_pre_cl.c"
#include "floatexp_pre_r_cl.c"
#include "floatexp_pre_c_cl.c"
#include "floatexp_pre_m_cl.c"
#include "floatexp_post_cl.c"
#include "floatexp_post_r_cl.c"
#include "floatexp_post_c_cl.c"
#include "floatexp_post_m_cl.c"

#if 0
#include "softfloat_pre_cl.c"
#include "softfloat_pre_r_cl.c"
#include "softfloat_pre_c_cl.c"
#include "softfloat_pre_m_cl.c"
#include "softfloat_post_cl.c"
#include "softfloat_post_r_cl.c"
#include "softfloat_post_c_cl.c"
#include "softfloat_post_m_cl.c"
#endif

#define STR(s) #s



static const char *perturbation_opencl_double_0_2_0 = STR(

{xrn=d_add(d_sub(d_mul(d_add(d_imul(2,Xr),xr),xr),d_mul(d_add(d_imul(2,Xi),xi),xi)),cr);
xin=d_add(d_imul(2,d_add(d_mul(Xxr,xi),d_mul(Xi,xr))),ci);
}

);

static const char *perturbation_opencl_double_0_2_1 = STR(

{drn=d_add(d_imul(2,d_sub(d_mul(Xxr,dr),d_mul(Xxi,di))),dr0);
din=d_add(d_imul(2,d_add(d_mul(Xxi,dr),d_mul(Xxr,di))),di0);
}

{xrn=d_add(d_sub(d_mul(d_add(d_imul(2,Xr),xr),xr),d_mul(d_add(d_imul(2,Xi),xi),xi)),cr);
xin=d_add(d_imul(2,d_add(d_mul(Xxr,xi),d_mul(Xi,xr))),ci);
}

);

static const char *perturbation_opencl_floatexp_0_2_0 = STR(

{xrn=fe_add(fe_sub(fe_mul(fe_add(fe_imul(2,Xr),xr),xr),fe_mul(fe_add(fe_imul(2,Xi),xi),xi)),cr);
xin=fe_add(fe_imul(2,fe_add(fe_mul(Xxr,xi),fe_mul(Xi,xr))),ci);
}

);

static const char *perturbation_opencl_floatexp_0_2_1 = STR(

{drn=fe_add(fe_imul(2,fe_sub(fe_mul(Xxr,dr),fe_mul(Xxi,di))),dr0);
din=fe_add(fe_imul(2,fe_add(fe_mul(Xxi,dr),fe_mul(Xxr,di))),di0);
}

{xrn=fe_add(fe_sub(fe_mul(fe_add(fe_imul(2,Xr),xr),xr),fe_mul(fe_add(fe_imul(2,Xi),xi),xi)),cr);
xin=fe_add(fe_imul(2,fe_add(fe_mul(Xxr,xi),fe_mul(Xi,xr))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_0_2_0 = STR(

{xrn=sf_add(sf_sub(sf_mul(sf_add(sf_imul(2,Xr),xr),xr),sf_mul(sf_add(sf_imul(2,Xi),xi),xi)),cr);
xin=sf_add(sf_imul(2,sf_add(sf_mul(Xxr,xi),sf_mul(Xi,xr))),ci);
}

);
#endif


static const char *perturbation_opencl_double_0_3_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_add(d_imul(3,d_add(d_sub(d_mul(d_sub(Xr2,Xi2),xr),d_mul(d_mul(d_imul(2,Xxr),Xi),xi)),d_mul(Xr,d_sub(xr2,xi2)))),d_mul(xr,d_sub(xr2,d_imul(3,xi2)))),cr);
xin=d_add(d_add(d_imul(3,d_add(d_add(d_mul(d_sub(Xr2,Xi2),xi),d_mul(d_mul(d_imul(2,Xr),xr),Xxi)),d_mul(Xi,d_sub(xr2,xi2)))),d_mul(xi,d_sub(d_imul(3,xr2),xi2))),ci);
}

);

static const char *perturbation_opencl_double_0_3_1 = STR(

{drn=d_add(d_sub(d_mul(d_imul(3,d_sub(Xxr2,Xxi2)),dr),d_mul(d_imul(6,d_mul(Xxi,Xxr)),di)),dr0);
din=d_add(d_add(d_mul(d_imul(3,d_sub(Xxr2,Xxi2)),di),d_mul(d_imul(6,d_mul(Xxi,Xxr)),dr)),di0);
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_add(d_imul(3,d_add(d_sub(d_mul(d_sub(Xr2,Xi2),xr),d_mul(d_mul(d_imul(2,Xxr),Xi),xi)),d_mul(Xr,d_sub(xr2,xi2)))),d_mul(xr,d_sub(xr2,d_imul(3,xi2)))),cr);
xin=d_add(d_add(d_imul(3,d_add(d_add(d_mul(d_sub(Xr2,Xi2),xi),d_mul(d_mul(d_imul(2,Xr),xr),Xxi)),d_mul(Xi,d_sub(xr2,xi2)))),d_mul(xi,d_sub(d_imul(3,xr2),xi2))),ci);
}

);

static const char *perturbation_opencl_floatexp_0_3_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_imul(3,fe_add(fe_sub(fe_mul(fe_sub(Xr2,Xi2),xr),fe_mul(fe_mul(fe_imul(2,Xxr),Xi),xi)),fe_mul(Xr,fe_sub(xr2,xi2)))),fe_mul(xr,fe_sub(xr2,fe_imul(3,xi2)))),cr);
xin=fe_add(fe_add(fe_imul(3,fe_add(fe_add(fe_mul(fe_sub(Xr2,Xi2),xi),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xxi)),fe_mul(Xi,fe_sub(xr2,xi2)))),fe_mul(xi,fe_sub(fe_imul(3,xr2),xi2))),ci);
}

);

static const char *perturbation_opencl_floatexp_0_3_1 = STR(

{drn=fe_add(fe_sub(fe_mul(fe_imul(3,fe_sub(Xxr2,Xxi2)),dr),fe_mul(fe_imul(6,fe_mul(Xxi,Xxr)),di)),dr0);
din=fe_add(fe_add(fe_mul(fe_imul(3,fe_sub(Xxr2,Xxi2)),di),fe_mul(fe_imul(6,fe_mul(Xxi,Xxr)),dr)),di0);
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_imul(3,fe_add(fe_sub(fe_mul(fe_sub(Xr2,Xi2),xr),fe_mul(fe_mul(fe_imul(2,Xxr),Xi),xi)),fe_mul(Xr,fe_sub(xr2,xi2)))),fe_mul(xr,fe_sub(xr2,fe_imul(3,xi2)))),cr);
xin=fe_add(fe_add(fe_imul(3,fe_add(fe_add(fe_mul(fe_sub(Xr2,Xi2),xi),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xxi)),fe_mul(Xi,fe_sub(xr2,xi2)))),fe_mul(xi,fe_sub(fe_imul(3,xr2),xi2))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_0_3_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_add(sf_imul(3,sf_add(sf_sub(sf_mul(sf_sub(Xr2,Xi2),xr),sf_mul(sf_mul(sf_imul(2,Xxr),Xi),xi)),sf_mul(Xr,sf_sub(xr2,xi2)))),sf_mul(xr,sf_sub(xr2,sf_imul(3,xi2)))),cr);
xin=sf_add(sf_add(sf_imul(3,sf_add(sf_add(sf_mul(sf_sub(Xr2,Xi2),xi),sf_mul(sf_mul(sf_imul(2,Xr),xr),Xxi)),sf_mul(Xi,sf_sub(xr2,xi2)))),sf_mul(xi,sf_sub(sf_imul(3,xr2),xi2))),ci);
}

);
#endif


static const char *perturbation_opencl_double_0_4_0 = STR(

{
  const dcomplex X = { Xr COMMA Xi } COMMA x = { xr COMMA xi } COMMA Xx = { Xxr COMMA Xxi } COMMA c = { cr COMMA ci };
  dcomplex xn;
{xn=dc_add(dc_add(dc_add(dc_add(dc_mul(dc_imul(4,dc_powi(X,3)),x),dc_mul(dc_imul(6,dc_powi(X,2)),dc_powi(x,2))),dc_mul(dc_imul(4,X),dc_powi(x,3))),dc_powi(x,4)),c);
}
  xrn = xn.re;
  xin = xn.im;
}

);

static const char *perturbation_opencl_double_0_4_1 = STR(

{dn=dc_add(dc_mul(dc_imul(4,d),dc_powi(Xx,3)),d0);
}

{xn=dc_add(dc_add(dc_add(dc_add(dc_mul(dc_imul(4,dc_powi(X,3)),x),dc_mul(dc_imul(6,dc_powi(X,2)),dc_powi(x,2))),dc_mul(dc_imul(4,X),dc_powi(x,3))),dc_powi(x,4)),c);
}

);

static const char *perturbation_opencl_floatexp_0_4_0 = STR(

{
  const fecomplex X = { Xr COMMA Xi } COMMA x = { xr COMMA xi } COMMA Xx = { Xxr COMMA Xxi } COMMA c = { cr COMMA ci };
  fecomplex xn;
{xn=fec_add(fec_add(fec_add(fec_add(fec_mul(fec_imul(4,fec_powi(X,3)),x),fec_mul(fec_imul(6,fec_powi(X,2)),fec_powi(x,2))),fec_mul(fec_imul(4,X),fec_powi(x,3))),fec_powi(x,4)),c);
}
  xrn = xn.re;
  xin = xn.im;
}

);

static const char *perturbation_opencl_floatexp_0_4_1 = STR(

{dn=fec_add(fec_mul(fec_imul(4,d),fec_powi(Xx,3)),d0);
}

{xn=fec_add(fec_add(fec_add(fec_add(fec_mul(fec_imul(4,fec_powi(X,3)),x),fec_mul(fec_imul(6,fec_powi(X,2)),fec_powi(x,2))),fec_mul(fec_imul(4,X),fec_powi(x,3))),fec_powi(x,4)),c);
}

);

#if 0
static const char *perturbation_opencl_softfloat_0_4_0 = STR(

{xn=sfc_add(sfc_add(sfc_add(sfc_add(sfc_mul(sfc_imul(4,sfc_powi(X,3)),x),sfc_mul(sfc_imul(6,sfc_powi(X,2)),sfc_powi(x,2))),sfc_mul(sfc_imul(4,X),sfc_powi(x,3))),sfc_powi(x,4)),c);
}

);
#endif


static const char *perturbation_opencl_double_0_5_0 = STR(

{
  const dcomplex X = { Xr COMMA Xi } COMMA x = { xr COMMA xi } COMMA Xx = { Xxr COMMA Xxi } COMMA c = { cr COMMA ci };
  dcomplex xn;
{xn=dc_add(dc_add(dc_add(dc_add(dc_add(dc_mul(dc_imul(5,dc_powi(X,4)),x),dc_mul(dc_imul(10,dc_powi(X,3)),dc_powi(x,2))),dc_mul(dc_imul(10,dc_powi(X,2)),dc_powi(x,3))),dc_mul(dc_imul(5,X),dc_powi(x,4))),dc_powi(x,5)),c);
}
  xrn = xn.re;
  xin = xn.im;
}

);

static const char *perturbation_opencl_double_0_5_1 = STR(

{dn=dc_add(dc_mul(dc_imul(5,d),dc_powi(Xx,4)),d0);
}

{xn=dc_add(dc_add(dc_add(dc_add(dc_add(dc_mul(dc_imul(5,dc_powi(X,4)),x),dc_mul(dc_imul(10,dc_powi(X,3)),dc_powi(x,2))),dc_mul(dc_imul(10,dc_powi(X,2)),dc_powi(x,3))),dc_mul(dc_imul(5,X),dc_powi(x,4))),dc_powi(x,5)),c);
}

);

static const char *perturbation_opencl_floatexp_0_5_0 = STR(

{
  const fecomplex X = { Xr COMMA Xi } COMMA x = { xr COMMA xi } COMMA Xx = { Xxr COMMA Xxi } COMMA c = { cr COMMA ci };
  fecomplex xn;
{xn=fec_add(fec_add(fec_add(fec_add(fec_add(fec_mul(fec_imul(5,fec_powi(X,4)),x),fec_mul(fec_imul(10,fec_powi(X,3)),fec_powi(x,2))),fec_mul(fec_imul(10,fec_powi(X,2)),fec_powi(x,3))),fec_mul(fec_imul(5,X),fec_powi(x,4))),fec_powi(x,5)),c);
}
  xrn = xn.re;
  xin = xn.im;
}

);

static const char *perturbation_opencl_floatexp_0_5_1 = STR(

{dn=fec_add(fec_mul(fec_imul(5,d),fec_powi(Xx,4)),d0);
}

{xn=fec_add(fec_add(fec_add(fec_add(fec_add(fec_mul(fec_imul(5,fec_powi(X,4)),x),fec_mul(fec_imul(10,fec_powi(X,3)),fec_powi(x,2))),fec_mul(fec_imul(10,fec_powi(X,2)),fec_powi(x,3))),fec_mul(fec_imul(5,X),fec_powi(x,4))),fec_powi(x,5)),c);
}

);

#if 0
static const char *perturbation_opencl_softfloat_0_5_0 = STR(

{xn=sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_mul(sfc_imul(5,sfc_powi(X,4)),x),sfc_mul(sfc_imul(10,sfc_powi(X,3)),sfc_powi(x,2))),sfc_mul(sfc_imul(10,sfc_powi(X,2)),sfc_powi(x,3))),sfc_mul(sfc_imul(5,X),sfc_powi(x,4))),sfc_powi(x,5)),c);
}

);
#endif


static const char *perturbation_opencl_double_0_6_0 = STR(

{
  const dcomplex X = { Xr COMMA Xi } COMMA x = { xr COMMA xi } COMMA Xx = { Xxr COMMA Xxi } COMMA c = { cr COMMA ci };
  dcomplex xn;
{xn=dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_mul(dc_imul(6,dc_powi(X,5)),x),dc_mul(dc_imul(15,dc_powi(X,4)),dc_powi(x,2))),dc_mul(dc_imul(20,dc_powi(X,3)),dc_powi(x,3))),dc_mul(dc_imul(15,dc_powi(X,2)),dc_powi(x,4))),dc_mul(dc_imul(6,X),dc_powi(x,5))),dc_powi(x,6)),c);
}
  xrn = xn.re;
  xin = xn.im;
}

);

static const char *perturbation_opencl_double_0_6_1 = STR(

{dn=dc_add(dc_mul(dc_imul(6,d),dc_powi(Xx,5)),d0);
}

{xn=dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_mul(dc_imul(6,dc_powi(X,5)),x),dc_mul(dc_imul(15,dc_powi(X,4)),dc_powi(x,2))),dc_mul(dc_imul(20,dc_powi(X,3)),dc_powi(x,3))),dc_mul(dc_imul(15,dc_powi(X,2)),dc_powi(x,4))),dc_mul(dc_imul(6,X),dc_powi(x,5))),dc_powi(x,6)),c);
}

);

static const char *perturbation_opencl_floatexp_0_6_0 = STR(

{
  const fecomplex X = { Xr COMMA Xi } COMMA x = { xr COMMA xi } COMMA Xx = { Xxr COMMA Xxi } COMMA c = { cr COMMA ci };
  fecomplex xn;
{xn=fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_mul(fec_imul(6,fec_powi(X,5)),x),fec_mul(fec_imul(15,fec_powi(X,4)),fec_powi(x,2))),fec_mul(fec_imul(20,fec_powi(X,3)),fec_powi(x,3))),fec_mul(fec_imul(15,fec_powi(X,2)),fec_powi(x,4))),fec_mul(fec_imul(6,X),fec_powi(x,5))),fec_powi(x,6)),c);
}
  xrn = xn.re;
  xin = xn.im;
}

);

static const char *perturbation_opencl_floatexp_0_6_1 = STR(

{dn=fec_add(fec_mul(fec_imul(6,d),fec_powi(Xx,5)),d0);
}

{xn=fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_mul(fec_imul(6,fec_powi(X,5)),x),fec_mul(fec_imul(15,fec_powi(X,4)),fec_powi(x,2))),fec_mul(fec_imul(20,fec_powi(X,3)),fec_powi(x,3))),fec_mul(fec_imul(15,fec_powi(X,2)),fec_powi(x,4))),fec_mul(fec_imul(6,X),fec_powi(x,5))),fec_powi(x,6)),c);
}

);

#if 0
static const char *perturbation_opencl_softfloat_0_6_0 = STR(

{xn=sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_mul(sfc_imul(6,sfc_powi(X,5)),x),sfc_mul(sfc_imul(15,sfc_powi(X,4)),sfc_powi(x,2))),sfc_mul(sfc_imul(20,sfc_powi(X,3)),sfc_powi(x,3))),sfc_mul(sfc_imul(15,sfc_powi(X,2)),sfc_powi(x,4))),sfc_mul(sfc_imul(6,X),sfc_powi(x,5))),sfc_powi(x,6)),c);
}

);
#endif


static const char *perturbation_opencl_double_0_7_0 = STR(

{
  const dcomplex X = { Xr COMMA Xi } COMMA x = { xr COMMA xi } COMMA Xx = { Xxr COMMA Xxi } COMMA c = { cr COMMA ci };
  dcomplex xn;
{xn=dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_mul(dc_imul(7,dc_powi(X,6)),x),dc_mul(dc_imul(21,dc_powi(X,5)),dc_powi(x,2))),dc_mul(dc_imul(35,dc_powi(X,4)),dc_powi(x,3))),dc_mul(dc_imul(35,dc_powi(X,3)),dc_powi(x,4))),dc_mul(dc_imul(21,dc_powi(X,2)),dc_powi(x,5))),dc_mul(dc_imul(7,X),dc_powi(x,6))),dc_powi(x,7)),c);
}
  xrn = xn.re;
  xin = xn.im;
}

);

static const char *perturbation_opencl_double_0_7_1 = STR(

{dn=dc_add(dc_mul(dc_imul(7,d),dc_powi(Xx,6)),d0);
}

{xn=dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_mul(dc_imul(7,dc_powi(X,6)),x),dc_mul(dc_imul(21,dc_powi(X,5)),dc_powi(x,2))),dc_mul(dc_imul(35,dc_powi(X,4)),dc_powi(x,3))),dc_mul(dc_imul(35,dc_powi(X,3)),dc_powi(x,4))),dc_mul(dc_imul(21,dc_powi(X,2)),dc_powi(x,5))),dc_mul(dc_imul(7,X),dc_powi(x,6))),dc_powi(x,7)),c);
}

);

static const char *perturbation_opencl_floatexp_0_7_0 = STR(

{
  const fecomplex X = { Xr COMMA Xi } COMMA x = { xr COMMA xi } COMMA Xx = { Xxr COMMA Xxi } COMMA c = { cr COMMA ci };
  fecomplex xn;
{xn=fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_mul(fec_imul(7,fec_powi(X,6)),x),fec_mul(fec_imul(21,fec_powi(X,5)),fec_powi(x,2))),fec_mul(fec_imul(35,fec_powi(X,4)),fec_powi(x,3))),fec_mul(fec_imul(35,fec_powi(X,3)),fec_powi(x,4))),fec_mul(fec_imul(21,fec_powi(X,2)),fec_powi(x,5))),fec_mul(fec_imul(7,X),fec_powi(x,6))),fec_powi(x,7)),c);
}
  xrn = xn.re;
  xin = xn.im;
}

);

static const char *perturbation_opencl_floatexp_0_7_1 = STR(

{dn=fec_add(fec_mul(fec_imul(7,d),fec_powi(Xx,6)),d0);
}

{xn=fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_mul(fec_imul(7,fec_powi(X,6)),x),fec_mul(fec_imul(21,fec_powi(X,5)),fec_powi(x,2))),fec_mul(fec_imul(35,fec_powi(X,4)),fec_powi(x,3))),fec_mul(fec_imul(35,fec_powi(X,3)),fec_powi(x,4))),fec_mul(fec_imul(21,fec_powi(X,2)),fec_powi(x,5))),fec_mul(fec_imul(7,X),fec_powi(x,6))),fec_powi(x,7)),c);
}

);

#if 0
static const char *perturbation_opencl_softfloat_0_7_0 = STR(

{xn=sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_mul(sfc_imul(7,sfc_powi(X,6)),x),sfc_mul(sfc_imul(21,sfc_powi(X,5)),sfc_powi(x,2))),sfc_mul(sfc_imul(35,sfc_powi(X,4)),sfc_powi(x,3))),sfc_mul(sfc_imul(35,sfc_powi(X,3)),sfc_powi(x,4))),sfc_mul(sfc_imul(21,sfc_powi(X,2)),sfc_powi(x,5))),sfc_mul(sfc_imul(7,X),sfc_powi(x,6))),sfc_powi(x,7)),c);
}

);
#endif


static const char *perturbation_opencl_double_0_8_0 = STR(

{
  const dcomplex X = { Xr COMMA Xi } COMMA x = { xr COMMA xi } COMMA Xx = { Xxr COMMA Xxi } COMMA c = { cr COMMA ci };
  dcomplex xn;
{xn=dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_mul(dc_imul(8,dc_powi(X,7)),x),dc_mul(dc_imul(28,dc_powi(X,6)),dc_powi(x,2))),dc_mul(dc_imul(56,dc_powi(X,5)),dc_powi(x,3))),dc_mul(dc_imul(70,dc_powi(X,4)),dc_powi(x,4))),dc_mul(dc_imul(56,dc_powi(X,3)),dc_powi(x,5))),dc_mul(dc_imul(28,dc_powi(X,2)),dc_powi(x,6))),dc_mul(dc_imul(8,X),dc_powi(x,7))),dc_powi(x,8)),c);
}
  xrn = xn.re;
  xin = xn.im;
}

);

static const char *perturbation_opencl_double_0_8_1 = STR(

{dn=dc_add(dc_mul(dc_imul(8,d),dc_powi(Xx,7)),d0);
}

{xn=dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_mul(dc_imul(8,dc_powi(X,7)),x),dc_mul(dc_imul(28,dc_powi(X,6)),dc_powi(x,2))),dc_mul(dc_imul(56,dc_powi(X,5)),dc_powi(x,3))),dc_mul(dc_imul(70,dc_powi(X,4)),dc_powi(x,4))),dc_mul(dc_imul(56,dc_powi(X,3)),dc_powi(x,5))),dc_mul(dc_imul(28,dc_powi(X,2)),dc_powi(x,6))),dc_mul(dc_imul(8,X),dc_powi(x,7))),dc_powi(x,8)),c);
}

);

static const char *perturbation_opencl_floatexp_0_8_0 = STR(

{
  const fecomplex X = { Xr COMMA Xi } COMMA x = { xr COMMA xi } COMMA Xx = { Xxr COMMA Xxi } COMMA c = { cr COMMA ci };
  fecomplex xn;
{xn=fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_mul(fec_imul(8,fec_powi(X,7)),x),fec_mul(fec_imul(28,fec_powi(X,6)),fec_powi(x,2))),fec_mul(fec_imul(56,fec_powi(X,5)),fec_powi(x,3))),fec_mul(fec_imul(70,fec_powi(X,4)),fec_powi(x,4))),fec_mul(fec_imul(56,fec_powi(X,3)),fec_powi(x,5))),fec_mul(fec_imul(28,fec_powi(X,2)),fec_powi(x,6))),fec_mul(fec_imul(8,X),fec_powi(x,7))),fec_powi(x,8)),c);
}
  xrn = xn.re;
  xin = xn.im;
}

);

static const char *perturbation_opencl_floatexp_0_8_1 = STR(

{dn=fec_add(fec_mul(fec_imul(8,d),fec_powi(Xx,7)),d0);
}

{xn=fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_mul(fec_imul(8,fec_powi(X,7)),x),fec_mul(fec_imul(28,fec_powi(X,6)),fec_powi(x,2))),fec_mul(fec_imul(56,fec_powi(X,5)),fec_powi(x,3))),fec_mul(fec_imul(70,fec_powi(X,4)),fec_powi(x,4))),fec_mul(fec_imul(56,fec_powi(X,3)),fec_powi(x,5))),fec_mul(fec_imul(28,fec_powi(X,2)),fec_powi(x,6))),fec_mul(fec_imul(8,X),fec_powi(x,7))),fec_powi(x,8)),c);
}

);

#if 0
static const char *perturbation_opencl_softfloat_0_8_0 = STR(

{xn=sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_mul(sfc_imul(8,sfc_powi(X,7)),x),sfc_mul(sfc_imul(28,sfc_powi(X,6)),sfc_powi(x,2))),sfc_mul(sfc_imul(56,sfc_powi(X,5)),sfc_powi(x,3))),sfc_mul(sfc_imul(70,sfc_powi(X,4)),sfc_powi(x,4))),sfc_mul(sfc_imul(56,sfc_powi(X,3)),sfc_powi(x,5))),sfc_mul(sfc_imul(28,sfc_powi(X,2)),sfc_powi(x,6))),sfc_mul(sfc_imul(8,X),sfc_powi(x,7))),sfc_powi(x,8)),c);
}

);
#endif


static const char *perturbation_opencl_double_0_9_0 = STR(

{
  const dcomplex X = { Xr COMMA Xi } COMMA x = { xr COMMA xi } COMMA Xx = { Xxr COMMA Xxi } COMMA c = { cr COMMA ci };
  dcomplex xn;
{xn=dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_mul(dc_imul(9,dc_powi(X,8)),x),dc_mul(dc_imul(36,dc_powi(X,7)),dc_powi(x,2))),dc_mul(dc_imul(84,dc_powi(X,6)),dc_powi(x,3))),dc_mul(dc_imul(126,dc_powi(X,5)),dc_powi(x,4))),dc_mul(dc_imul(126,dc_powi(X,4)),dc_powi(x,5))),dc_mul(dc_imul(84,dc_powi(X,3)),dc_powi(x,6))),dc_mul(dc_imul(36,dc_powi(X,2)),dc_powi(x,7))),dc_mul(dc_imul(9,X),dc_powi(x,8))),dc_powi(x,9)),c);
}
  xrn = xn.re;
  xin = xn.im;
}

);

static const char *perturbation_opencl_double_0_9_1 = STR(

{dn=dc_add(dc_mul(dc_imul(9,d),dc_powi(Xx,8)),d0);
}

{xn=dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_mul(dc_imul(9,dc_powi(X,8)),x),dc_mul(dc_imul(36,dc_powi(X,7)),dc_powi(x,2))),dc_mul(dc_imul(84,dc_powi(X,6)),dc_powi(x,3))),dc_mul(dc_imul(126,dc_powi(X,5)),dc_powi(x,4))),dc_mul(dc_imul(126,dc_powi(X,4)),dc_powi(x,5))),dc_mul(dc_imul(84,dc_powi(X,3)),dc_powi(x,6))),dc_mul(dc_imul(36,dc_powi(X,2)),dc_powi(x,7))),dc_mul(dc_imul(9,X),dc_powi(x,8))),dc_powi(x,9)),c);
}

);

static const char *perturbation_opencl_floatexp_0_9_0 = STR(

{
  const fecomplex X = { Xr COMMA Xi } COMMA x = { xr COMMA xi } COMMA Xx = { Xxr COMMA Xxi } COMMA c = { cr COMMA ci };
  fecomplex xn;
{xn=fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_mul(fec_imul(9,fec_powi(X,8)),x),fec_mul(fec_imul(36,fec_powi(X,7)),fec_powi(x,2))),fec_mul(fec_imul(84,fec_powi(X,6)),fec_powi(x,3))),fec_mul(fec_imul(126,fec_powi(X,5)),fec_powi(x,4))),fec_mul(fec_imul(126,fec_powi(X,4)),fec_powi(x,5))),fec_mul(fec_imul(84,fec_powi(X,3)),fec_powi(x,6))),fec_mul(fec_imul(36,fec_powi(X,2)),fec_powi(x,7))),fec_mul(fec_imul(9,X),fec_powi(x,8))),fec_powi(x,9)),c);
}
  xrn = xn.re;
  xin = xn.im;
}

);

static const char *perturbation_opencl_floatexp_0_9_1 = STR(

{dn=fec_add(fec_mul(fec_imul(9,d),fec_powi(Xx,8)),d0);
}

{xn=fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_mul(fec_imul(9,fec_powi(X,8)),x),fec_mul(fec_imul(36,fec_powi(X,7)),fec_powi(x,2))),fec_mul(fec_imul(84,fec_powi(X,6)),fec_powi(x,3))),fec_mul(fec_imul(126,fec_powi(X,5)),fec_powi(x,4))),fec_mul(fec_imul(126,fec_powi(X,4)),fec_powi(x,5))),fec_mul(fec_imul(84,fec_powi(X,3)),fec_powi(x,6))),fec_mul(fec_imul(36,fec_powi(X,2)),fec_powi(x,7))),fec_mul(fec_imul(9,X),fec_powi(x,8))),fec_powi(x,9)),c);
}

);

#if 0
static const char *perturbation_opencl_softfloat_0_9_0 = STR(

{xn=sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_mul(sfc_imul(9,sfc_powi(X,8)),x),sfc_mul(sfc_imul(36,sfc_powi(X,7)),sfc_powi(x,2))),sfc_mul(sfc_imul(84,sfc_powi(X,6)),sfc_powi(x,3))),sfc_mul(sfc_imul(126,sfc_powi(X,5)),sfc_powi(x,4))),sfc_mul(sfc_imul(126,sfc_powi(X,4)),sfc_powi(x,5))),sfc_mul(sfc_imul(84,sfc_powi(X,3)),sfc_powi(x,6))),sfc_mul(sfc_imul(36,sfc_powi(X,2)),sfc_powi(x,7))),sfc_mul(sfc_imul(9,X),sfc_powi(x,8))),sfc_powi(x,9)),c);
}

);
#endif


static const char *perturbation_opencl_double_0_10_0 = STR(

{
  const dcomplex X = { Xr COMMA Xi } COMMA x = { xr COMMA xi } COMMA Xx = { Xxr COMMA Xxi } COMMA c = { cr COMMA ci };
  dcomplex xn;
{xn=dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_mul(dc_imul(10,dc_powi(X,9)),x),dc_mul(dc_imul(45,dc_powi(X,8)),dc_powi(x,2))),dc_mul(dc_imul(120,dc_powi(X,7)),dc_powi(x,3))),dc_mul(dc_imul(210,dc_powi(X,6)),dc_powi(x,4))),dc_mul(dc_imul(252,dc_powi(X,5)),dc_powi(x,5))),dc_mul(dc_imul(210,dc_powi(X,4)),dc_powi(x,6))),dc_mul(dc_imul(120,dc_powi(X,3)),dc_powi(x,7))),dc_mul(dc_imul(45,dc_powi(X,2)),dc_powi(x,8))),dc_mul(dc_imul(10,X),dc_powi(x,9))),dc_powi(x,10)),c);
}
  xrn = xn.re;
  xin = xn.im;
}

);

static const char *perturbation_opencl_double_0_10_1 = STR(

{dn=dc_add(dc_mul(dc_imul(10,d),dc_powi(Xx,9)),d0);
}

{xn=dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_mul(dc_imul(10,dc_powi(X,9)),x),dc_mul(dc_imul(45,dc_powi(X,8)),dc_powi(x,2))),dc_mul(dc_imul(120,dc_powi(X,7)),dc_powi(x,3))),dc_mul(dc_imul(210,dc_powi(X,6)),dc_powi(x,4))),dc_mul(dc_imul(252,dc_powi(X,5)),dc_powi(x,5))),dc_mul(dc_imul(210,dc_powi(X,4)),dc_powi(x,6))),dc_mul(dc_imul(120,dc_powi(X,3)),dc_powi(x,7))),dc_mul(dc_imul(45,dc_powi(X,2)),dc_powi(x,8))),dc_mul(dc_imul(10,X),dc_powi(x,9))),dc_powi(x,10)),c);
}

);

static const char *perturbation_opencl_floatexp_0_10_0 = STR(

{
  const fecomplex X = { Xr COMMA Xi } COMMA x = { xr COMMA xi } COMMA Xx = { Xxr COMMA Xxi } COMMA c = { cr COMMA ci };
  fecomplex xn;
{xn=fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_mul(fec_imul(10,fec_powi(X,9)),x),fec_mul(fec_imul(45,fec_powi(X,8)),fec_powi(x,2))),fec_mul(fec_imul(120,fec_powi(X,7)),fec_powi(x,3))),fec_mul(fec_imul(210,fec_powi(X,6)),fec_powi(x,4))),fec_mul(fec_imul(252,fec_powi(X,5)),fec_powi(x,5))),fec_mul(fec_imul(210,fec_powi(X,4)),fec_powi(x,6))),fec_mul(fec_imul(120,fec_powi(X,3)),fec_powi(x,7))),fec_mul(fec_imul(45,fec_powi(X,2)),fec_powi(x,8))),fec_mul(fec_imul(10,X),fec_powi(x,9))),fec_powi(x,10)),c);
}
  xrn = xn.re;
  xin = xn.im;
}

);

static const char *perturbation_opencl_floatexp_0_10_1 = STR(

{dn=fec_add(fec_mul(fec_imul(10,d),fec_powi(Xx,9)),d0);
}

{xn=fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_mul(fec_imul(10,fec_powi(X,9)),x),fec_mul(fec_imul(45,fec_powi(X,8)),fec_powi(x,2))),fec_mul(fec_imul(120,fec_powi(X,7)),fec_powi(x,3))),fec_mul(fec_imul(210,fec_powi(X,6)),fec_powi(x,4))),fec_mul(fec_imul(252,fec_powi(X,5)),fec_powi(x,5))),fec_mul(fec_imul(210,fec_powi(X,4)),fec_powi(x,6))),fec_mul(fec_imul(120,fec_powi(X,3)),fec_powi(x,7))),fec_mul(fec_imul(45,fec_powi(X,2)),fec_powi(x,8))),fec_mul(fec_imul(10,X),fec_powi(x,9))),fec_powi(x,10)),c);
}

);

#if 0
static const char *perturbation_opencl_softfloat_0_10_0 = STR(

{xn=sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_mul(sfc_imul(10,sfc_powi(X,9)),x),sfc_mul(sfc_imul(45,sfc_powi(X,8)),sfc_powi(x,2))),sfc_mul(sfc_imul(120,sfc_powi(X,7)),sfc_powi(x,3))),sfc_mul(sfc_imul(210,sfc_powi(X,6)),sfc_powi(x,4))),sfc_mul(sfc_imul(252,sfc_powi(X,5)),sfc_powi(x,5))),sfc_mul(sfc_imul(210,sfc_powi(X,4)),sfc_powi(x,6))),sfc_mul(sfc_imul(120,sfc_powi(X,3)),sfc_powi(x,7))),sfc_mul(sfc_imul(45,sfc_powi(X,2)),sfc_powi(x,8))),sfc_mul(sfc_imul(10,X),sfc_powi(x,9))),sfc_powi(x,10)),c);
}

);
#endif


static const char *perturbation_opencl_double_1_2_0 = STR(

{xrn=d_add(d_sub(d_mul(d_add(d_imul(2,Xr),xr),xr),d_mul(d_add(d_imul(2,Xi),xi),xi)),cr);
xin=d_add(d_imul(2,d_diffabs(d_mul(Xr,Xi),d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi)))),ci);
}

);

static const char *perturbation_opencl_double_1_2_1 = STR(

{dxan=d_add(d_imul(2,d_mul(Xxr,dxa)),d_add(d_imul(-2,d_mul(Xxi,dya)),daa));
dxbn=d_add(d_imul(2,d_mul(Xxr,dxb)),d_add(d_imul(-2,d_mul(Xxi,dyb)),dab));
dyan=d_add(d_imul(2,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(dxa,d_sgn(Xxr))))),d_add(d_imul(2,d_mul(d_sgn(Xxi),d_mul(Xxr,d_mul(dya,d_sgn(Xxr))))),dba));
dybn=d_add(d_imul(2,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(dxb,d_sgn(Xxr))))),d_add(d_imul(2,d_mul(d_sgn(Xxi),d_mul(Xxr,d_mul(dyb,d_sgn(Xxr))))),dbb));
}

{xrn=d_add(d_sub(d_mul(d_add(d_imul(2,Xr),xr),xr),d_mul(d_add(d_imul(2,Xi),xi),xi)),cr);
xin=d_add(d_imul(2,d_diffabs(d_mul(Xr,Xi),d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi)))),ci);
}

);

static const char *perturbation_opencl_floatexp_1_2_0 = STR(

{xrn=fe_add(fe_sub(fe_mul(fe_add(fe_imul(2,Xr),xr),xr),fe_mul(fe_add(fe_imul(2,Xi),xi),xi)),cr);
xin=fe_add(fe_imul(2,fe_diffabs(fe_mul(Xr,Xi),fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi)))),ci);
}

);

static const char *perturbation_opencl_floatexp_1_2_1 = STR(

{dxan=fe_add(fe_imul(2,fe_mul(Xxr,dxa)),fe_add(fe_imul(-2,fe_mul(Xxi,dya)),daa));
dxbn=fe_add(fe_imul(2,fe_mul(Xxr,dxb)),fe_add(fe_imul(-2,fe_mul(Xxi,dyb)),dab));
dyan=fe_add(fe_imul(2,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(dxa,fe_sgn(Xxr))))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxi),fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxr))))),dba));
dybn=fe_add(fe_imul(2,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(dxb,fe_sgn(Xxr))))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxi),fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxr))))),dbb));
}

{xrn=fe_add(fe_sub(fe_mul(fe_add(fe_imul(2,Xr),xr),xr),fe_mul(fe_add(fe_imul(2,Xi),xi),xi)),cr);
xin=fe_add(fe_imul(2,fe_diffabs(fe_mul(Xr,Xi),fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi)))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_1_2_0 = STR(

{xrn=sf_add(sf_sub(sf_mul(sf_add(sf_imul(2,Xr),xr),xr),sf_mul(sf_add(sf_imul(2,Xi),xi),xi)),cr);
xin=sf_add(sf_imul(2,sf_diffabs(sf_mul(Xr,Xi),sf_add(sf_add(sf_mul(Xr,xi),sf_mul(xr,Xi)),sf_mul(xr,xi)))),ci);
}

);
#endif


static const char *perturbation_opencl_double_1_3_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_add(d_mul(d_sub(Xr2,d_imul(3,Xi2)),d_diffabs(Xr,xr)),d_mul(d_sub(d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),d_mul(d_imul(6,Xi),xi)),d_imul(3,xi2)),d_abs(d_add(Xr,xr)))),cr);
xin=d_add(d_add(d_mul(d_sub(d_imul(3,Xr2),Xi2),d_diffabs(Xi,xi)),d_mul(d_sub(d_sub(d_add(d_mul(d_imul(6,Xr),xr),d_imul(3,xr2)),d_mul(d_imul(2,Xi),xi)),xi2),d_abs(d_add(Xi,xi)))),ci);
}

);

static const char *perturbation_opencl_double_1_3_1 = STR(

{dxan=d_add(d_imul(3,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr))))))),d_add(d_imul(-3,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(dxa,d_sgn(Xxr))))))),d_add(d_imul(-6,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_sgn(Xxr))))))),daa)));
dxbn=d_add(d_imul(3,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr))))))),d_add(d_imul(-3,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(dxb,d_sgn(Xxr))))))),d_add(d_imul(-6,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_sgn(Xxr))))))),dab)));
dyan=d_add(d_imul(3,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(Xxr))))))),d_add(d_imul(-3,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(dya,d_sgn(Xxi))))))),d_add(d_imul(6,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr))))))),dba)));
dybn=d_add(d_imul(3,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(Xxr))))))),d_add(d_imul(-3,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(dyb,d_sgn(Xxi))))))),d_add(d_imul(6,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr))))))),dbb)));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_add(d_mul(d_sub(Xr2,d_imul(3,Xi2)),d_diffabs(Xr,xr)),d_mul(d_sub(d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),d_mul(d_imul(6,Xi),xi)),d_imul(3,xi2)),d_abs(d_add(Xr,xr)))),cr);
xin=d_add(d_add(d_mul(d_sub(d_imul(3,Xr2),Xi2),d_diffabs(Xi,xi)),d_mul(d_sub(d_sub(d_add(d_mul(d_imul(6,Xr),xr),d_imul(3,xr2)),d_mul(d_imul(2,Xi),xi)),xi2),d_abs(d_add(Xi,xi)))),ci);
}

);

static const char *perturbation_opencl_floatexp_1_3_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_mul(fe_sub(Xr2,fe_imul(3,Xi2)),fe_diffabs(Xr,xr)),fe_mul(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),fe_mul(fe_imul(6,Xi),xi)),fe_imul(3,xi2)),fe_abs(fe_add(Xr,xr)))),cr);
xin=fe_add(fe_add(fe_mul(fe_sub(fe_imul(3,Xr2),Xi2),fe_diffabs(Xi,xi)),fe_mul(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(6,Xr),xr),fe_imul(3,xr2)),fe_mul(fe_imul(2,Xi),xi)),xi2),fe_abs(fe_add(Xi,xi)))),ci);
}

);

static const char *perturbation_opencl_floatexp_1_3_1 = STR(

{dxan=fe_add(fe_imul(3,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr))))))),fe_add(fe_imul(-3,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxa,fe_sgn(Xxr))))))),fe_add(fe_imul(-6,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxr))))))),daa)));
dxbn=fe_add(fe_imul(3,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr))))))),fe_add(fe_imul(-3,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxb,fe_sgn(Xxr))))))),fe_add(fe_imul(-6,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxr))))))),dab)));
dyan=fe_add(fe_imul(3,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxr))))))),fe_add(fe_imul(-3,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(dya,fe_sgn(Xxi))))))),fe_add(fe_imul(6,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr))))))),dba)));
dybn=fe_add(fe_imul(3,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxr))))))),fe_add(fe_imul(-3,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(dyb,fe_sgn(Xxi))))))),fe_add(fe_imul(6,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr))))))),dbb)));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_mul(fe_sub(Xr2,fe_imul(3,Xi2)),fe_diffabs(Xr,xr)),fe_mul(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),fe_mul(fe_imul(6,Xi),xi)),fe_imul(3,xi2)),fe_abs(fe_add(Xr,xr)))),cr);
xin=fe_add(fe_add(fe_mul(fe_sub(fe_imul(3,Xr2),Xi2),fe_diffabs(Xi,xi)),fe_mul(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(6,Xr),xr),fe_imul(3,xr2)),fe_mul(fe_imul(2,Xi),xi)),xi2),fe_abs(fe_add(Xi,xi)))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_1_3_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_add(sf_mul(sf_sub(Xr2,sf_imul(3,Xi2)),sf_diffabs(Xr,xr)),sf_mul(sf_sub(sf_sub(sf_add(sf_mul(sf_imul(2,Xr),xr),xr2),sf_mul(sf_imul(6,Xi),xi)),sf_imul(3,xi2)),sf_abs(sf_add(Xr,xr)))),cr);
xin=sf_add(sf_add(sf_mul(sf_sub(sf_imul(3,Xr2),Xi2),sf_diffabs(Xi,xi)),sf_mul(sf_sub(sf_sub(sf_add(sf_mul(sf_imul(6,Xr),xr),sf_imul(3,xr2)),sf_mul(sf_imul(2,Xi),xi)),xi2),sf_abs(sf_add(Xi,xi)))),ci);
}

);
#endif


static const char *perturbation_opencl_double_1_4_0 = STR(

{xrn=d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_mul(d_imul(4,Xr),Xr),Xr),xr),d_mul(d_mul(d_mul(d_imul(6,Xr),Xr),xr),xr)),d_mul(d_mul(d_mul(d_imul(4,Xr),xr),xr),xr)),d_mul(d_mul(d_mul(xr,xr),xr),xr)),d_mul(d_mul(d_mul(d_imul(4,Xi),Xi),Xi),xi)),d_mul(d_mul(d_mul(d_imul(6,Xi),Xi),xi),xi)),d_mul(d_mul(d_mul(d_imul(4,Xi),xi),xi),xi)),d_mul(d_mul(d_mul(xi,xi),xi),xi)),d_mul(d_mul(d_mul(d_imul(12,Xr),Xr),Xi),xi)),d_mul(d_mul(d_mul(d_imul(6,Xr),Xr),xi),xi)),d_mul(d_mul(d_mul(d_imul(12,Xr),xr),Xi),Xi)),d_mul(d_mul(d_mul(d_imul(24,Xr),xr),Xi),xi)),d_mul(d_mul(d_mul(d_imul(12,Xr),xr),xi),xi)),d_mul(d_mul(d_mul(d_imul(6,xr),xr),Xi),Xi)),d_mul(d_mul(d_mul(d_imul(12,xr),xr),Xi),xi)),d_mul(d_mul(d_mul(d_imul(6,xr),xr),xi),xi)),cr);
xin=d_add(d_add(d_mul(d_imul(4,d_sub(d_mul(Xr,Xr),d_mul(Xi,Xi))),d_diffabs(d_mul(Xr,Xi),d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi)))),d_mul(d_imul(4,d_abs(d_add(d_add(d_add(d_mul(Xr,Xi),d_mul(Xr,xi)),d_mul(xr,Xi)),d_mul(xr,xi)))),d_sub(d_sub(d_add(d_mul(d_imul(2,xr),Xr),d_mul(xr,xr)),d_mul(d_imul(2,xi),Xi)),d_mul(xi,xi)))),ci);
}

);

static const char *perturbation_opencl_double_1_4_1 = STR(

{dxan=d_add(d_imul(4,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dya,d_sgn(Xxi))))))))),d_add(d_imul(4,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr))))))))),d_add(d_imul(-12,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr))))))))),d_add(d_imul(-12,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(Xxr))))))))),daa))));
dxbn=d_add(d_imul(4,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dyb,d_sgn(Xxi))))))))),d_add(d_imul(4,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr))))))))),d_add(d_imul(-12,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr))))))))),d_add(d_imul(-12,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(Xxr))))))))),dab))));
dyan=d_add(d_imul(4,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(Xxr))))))))),d_add(d_imul(-4,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxa,d_sgn(Xxr))))))))),d_add(d_imul(-12,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_sgn(Xxr))))))))),d_add(d_imul(12,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr))))))))),dba))));
dybn=d_add(d_imul(4,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(Xxr))))))))),d_add(d_imul(-4,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxb,d_sgn(Xxr))))))))),d_add(d_imul(-12,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_sgn(Xxr))))))))),d_add(d_imul(12,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr))))))))),dbb))));
}

{xrn=d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_mul(d_imul(4,Xr),Xr),Xr),xr),d_mul(d_mul(d_mul(d_imul(6,Xr),Xr),xr),xr)),d_mul(d_mul(d_mul(d_imul(4,Xr),xr),xr),xr)),d_mul(d_mul(d_mul(xr,xr),xr),xr)),d_mul(d_mul(d_mul(d_imul(4,Xi),Xi),Xi),xi)),d_mul(d_mul(d_mul(d_imul(6,Xi),Xi),xi),xi)),d_mul(d_mul(d_mul(d_imul(4,Xi),xi),xi),xi)),d_mul(d_mul(d_mul(xi,xi),xi),xi)),d_mul(d_mul(d_mul(d_imul(12,Xr),Xr),Xi),xi)),d_mul(d_mul(d_mul(d_imul(6,Xr),Xr),xi),xi)),d_mul(d_mul(d_mul(d_imul(12,Xr),xr),Xi),Xi)),d_mul(d_mul(d_mul(d_imul(24,Xr),xr),Xi),xi)),d_mul(d_mul(d_mul(d_imul(12,Xr),xr),xi),xi)),d_mul(d_mul(d_mul(d_imul(6,xr),xr),Xi),Xi)),d_mul(d_mul(d_mul(d_imul(12,xr),xr),Xi),xi)),d_mul(d_mul(d_mul(d_imul(6,xr),xr),xi),xi)),cr);
xin=d_add(d_add(d_mul(d_imul(4,d_sub(d_mul(Xr,Xr),d_mul(Xi,Xi))),d_diffabs(d_mul(Xr,Xi),d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi)))),d_mul(d_imul(4,d_abs(d_add(d_add(d_add(d_mul(Xr,Xi),d_mul(Xr,xi)),d_mul(xr,Xi)),d_mul(xr,xi)))),d_sub(d_sub(d_add(d_mul(d_imul(2,xr),Xr),d_mul(xr,xr)),d_mul(d_imul(2,xi),Xi)),d_mul(xi,xi)))),ci);
}

);

static const char *perturbation_opencl_floatexp_1_4_0 = STR(

{xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_mul(fe_imul(4,Xr),Xr),Xr),xr),fe_mul(fe_mul(fe_mul(fe_imul(6,Xr),Xr),xr),xr)),fe_mul(fe_mul(fe_mul(fe_imul(4,Xr),xr),xr),xr)),fe_mul(fe_mul(fe_mul(xr,xr),xr),xr)),fe_mul(fe_mul(fe_mul(fe_imul(4,Xi),Xi),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(6,Xi),Xi),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(4,Xi),xi),xi),xi)),fe_mul(fe_mul(fe_mul(xi,xi),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(12,Xr),Xr),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(6,Xr),Xr),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(12,Xr),xr),Xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(12,Xr),xr),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(6,xr),xr),Xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(12,xr),xr),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(6,xr),xr),xi),xi)),cr);
xin=fe_add(fe_add(fe_mul(fe_imul(4,fe_sub(fe_mul(Xr,Xr),fe_mul(Xi,Xi))),fe_diffabs(fe_mul(Xr,Xi),fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi)))),fe_mul(fe_imul(4,fe_abs(fe_add(fe_add(fe_add(fe_mul(Xr,Xi),fe_mul(Xr,xi)),fe_mul(xr,Xi)),fe_mul(xr,xi)))),fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,xr),Xr),fe_mul(xr,xr)),fe_mul(fe_imul(2,xi),Xi)),fe_mul(xi,xi)))),ci);
}

);

static const char *perturbation_opencl_floatexp_1_4_1 = STR(

{dxan=fe_add(fe_imul(4,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dya,fe_sgn(Xxi))))))))),fe_add(fe_imul(4,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr))))))))),fe_add(fe_imul(-12,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr))))))))),fe_add(fe_imul(-12,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxr))))))))),daa))));
dxbn=fe_add(fe_imul(4,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dyb,fe_sgn(Xxi))))))))),fe_add(fe_imul(4,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr))))))))),fe_add(fe_imul(-12,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr))))))))),fe_add(fe_imul(-12,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxr))))))))),dab))));
dyan=fe_add(fe_imul(4,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxr))))))))),fe_add(fe_imul(-4,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxa,fe_sgn(Xxr))))))))),fe_add(fe_imul(-12,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxr))))))))),fe_add(fe_imul(12,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr))))))))),dba))));
dybn=fe_add(fe_imul(4,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxr))))))))),fe_add(fe_imul(-4,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxb,fe_sgn(Xxr))))))))),fe_add(fe_imul(-12,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxr))))))))),fe_add(fe_imul(12,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr))))))))),dbb))));
}

{xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_mul(fe_imul(4,Xr),Xr),Xr),xr),fe_mul(fe_mul(fe_mul(fe_imul(6,Xr),Xr),xr),xr)),fe_mul(fe_mul(fe_mul(fe_imul(4,Xr),xr),xr),xr)),fe_mul(fe_mul(fe_mul(xr,xr),xr),xr)),fe_mul(fe_mul(fe_mul(fe_imul(4,Xi),Xi),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(6,Xi),Xi),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(4,Xi),xi),xi),xi)),fe_mul(fe_mul(fe_mul(xi,xi),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(12,Xr),Xr),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(6,Xr),Xr),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(12,Xr),xr),Xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(12,Xr),xr),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(6,xr),xr),Xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(12,xr),xr),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(6,xr),xr),xi),xi)),cr);
xin=fe_add(fe_add(fe_mul(fe_imul(4,fe_sub(fe_mul(Xr,Xr),fe_mul(Xi,Xi))),fe_diffabs(fe_mul(Xr,Xi),fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi)))),fe_mul(fe_imul(4,fe_abs(fe_add(fe_add(fe_add(fe_mul(Xr,Xi),fe_mul(Xr,xi)),fe_mul(xr,Xi)),fe_mul(xr,xi)))),fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,xr),Xr),fe_mul(xr,xr)),fe_mul(fe_imul(2,xi),Xi)),fe_mul(xi,xi)))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_1_4_0 = STR(

{xrn=sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_mul(sf_imul(4,Xr),Xr),Xr),xr),sf_mul(sf_mul(sf_mul(sf_imul(6,Xr),Xr),xr),xr)),sf_mul(sf_mul(sf_mul(sf_imul(4,Xr),xr),xr),xr)),sf_mul(sf_mul(sf_mul(xr,xr),xr),xr)),sf_mul(sf_mul(sf_mul(sf_imul(4,Xi),Xi),Xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(6,Xi),Xi),xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(4,Xi),xi),xi),xi)),sf_mul(sf_mul(sf_mul(xi,xi),xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(12,Xr),Xr),Xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(6,Xr),Xr),xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(12,Xr),xr),Xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(24,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(12,Xr),xr),xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(6,xr),xr),Xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(12,xr),xr),Xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(6,xr),xr),xi),xi)),cr);
xin=sf_add(sf_add(sf_mul(sf_imul(4,sf_sub(sf_mul(Xr,Xr),sf_mul(Xi,Xi))),sf_diffabs(sf_mul(Xr,Xi),sf_add(sf_add(sf_mul(Xr,xi),sf_mul(xr,Xi)),sf_mul(xr,xi)))),sf_mul(sf_imul(4,sf_abs(sf_add(sf_add(sf_add(sf_mul(Xr,Xi),sf_mul(Xr,xi)),sf_mul(xr,Xi)),sf_mul(xr,xi)))),sf_sub(sf_sub(sf_add(sf_mul(sf_imul(2,xr),Xr),sf_mul(xr,xr)),sf_mul(sf_imul(2,xi),Xi)),sf_mul(xi,xi)))),ci);
}

);
#endif


static const char *perturbation_opencl_double_1_5_0 = STR(

{xrn=d_add(d_add(d_mul(d_diffabs(Xr,xr),d_add(d_sub(d_mul(d_mul(d_mul(Xr,Xr),Xr),Xr),d_mul(d_mul(d_mul(d_imul(10,Xr),Xr),Xi),Xi)),d_mul(d_mul(d_mul(d_imul(5,Xi),Xi),Xi),Xi))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_mul(d_mul(d_mul(d_imul(4,Xr),Xr),Xr),xr),d_mul(d_mul(d_mul(d_imul(6,Xr),Xr),xr),xr)),d_mul(d_mul(d_mul(d_imul(4,Xr),xr),xr),xr)),d_mul(d_mul(d_mul(xr,xr),xr),xr)),d_mul(d_mul(d_mul(d_imul(20,Xr),Xr),Xi),xi)),d_mul(d_mul(d_mul(d_imul(10,Xr),Xr),xi),xi)),d_mul(d_mul(d_mul(d_imul(20,Xr),xr),Xi),Xi)),d_mul(d_mul(d_mul(d_imul(40,Xr),xr),Xi),xi)),d_mul(d_mul(d_mul(d_imul(20,Xr),xr),xi),xi)),d_mul(d_mul(d_mul(d_imul(10,xr),xr),Xi),Xi)),d_mul(d_mul(d_mul(d_imul(20,xr),xr),Xi),xi)),d_mul(d_mul(d_mul(d_imul(10,xr),xr),xi),xi)),d_mul(d_mul(d_mul(d_imul(20,Xi),Xi),Xi),xi)),d_mul(d_mul(d_mul(d_imul(30,Xi),Xi),xi),xi)),d_mul(d_mul(d_mul(d_imul(20,Xi),xi),xi),xi)),d_mul(d_mul(d_mul(d_imul(5,xi),xi),xi),xi)))),cr);
xin=d_add(d_add(d_mul(d_diffabs(Xi,xi),d_add(d_sub(d_mul(d_mul(d_mul(d_imul(5,Xr),Xr),Xr),Xr),d_mul(d_mul(d_mul(d_imul(10,Xr),Xr),Xi),Xi)),d_mul(d_mul(d_mul(Xi,Xi),Xi),Xi))),d_mul(d_abs(d_add(Xi,xi)),d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_mul(d_mul(d_mul(d_imul(20,Xr),Xr),Xr),xr),d_mul(d_mul(d_mul(d_imul(30,Xr),Xr),xr),xr)),d_mul(d_mul(d_mul(d_imul(20,Xr),xr),xr),xr)),d_mul(d_mul(d_mul(d_imul(5,xr),xr),xr),xr)),d_mul(d_mul(d_mul(d_imul(20,Xr),Xr),Xi),xi)),d_mul(d_mul(d_mul(d_imul(10,Xr),Xr),xi),xi)),d_mul(d_mul(d_mul(d_imul(20,Xr),xr),Xi),Xi)),d_mul(d_mul(d_mul(d_imul(40,Xr),xr),Xi),xi)),d_mul(d_mul(d_mul(d_imul(20,Xr),xr),xi),xi)),d_mul(d_mul(d_mul(d_imul(10,xr),xr),Xi),Xi)),d_mul(d_mul(d_mul(d_imul(20,xr),xr),Xi),xi)),d_mul(d_mul(d_mul(d_imul(10,xr),xr),xi),xi)),d_mul(d_mul(d_mul(d_imul(4,Xi),Xi),Xi),xi)),d_mul(d_mul(d_mul(d_imul(6,Xi),Xi),xi),xi)),d_mul(d_mul(d_mul(d_imul(4,Xi),xi),xi),xi)),d_mul(d_mul(d_mul(xi,xi),xi),xi)))),ci);
}

);

static const char *perturbation_opencl_double_1_5_1 = STR(

{dxan=d_add(d_imul(5,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxa,d_sgn(Xxr))))))))))),d_add(d_imul(5,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr))))))))))),d_add(d_imul(-20,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(Xxr))))))))))),d_add(d_imul(20,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_sgn(Xxr))))))))))),d_add(d_imul(-30,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr))))))))))),daa)))));
dxbn=d_add(d_imul(5,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxb,d_sgn(Xxr))))))))))),d_add(d_imul(5,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr))))))))))),d_add(d_imul(-20,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(Xxr))))))))))),d_add(d_imul(20,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_sgn(Xxr))))))))))),d_add(d_imul(-30,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr))))))))))),dab)))));
dyan=d_add(d_imul(5,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dya,d_sgn(Xxi))))))))))),d_add(d_imul(5,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(Xxr))))))))))),d_add(d_imul(20,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr))))))))))),d_add(d_imul(-20,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr))))))))))),d_add(d_imul(-30,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(Xxr))))))))))),dba)))));
dybn=d_add(d_imul(5,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dyb,d_sgn(Xxi))))))))))),d_add(d_imul(5,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(Xxr))))))))))),d_add(d_imul(20,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr))))))))))),d_add(d_imul(-20,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr))))))))))),d_add(d_imul(-30,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(Xxr))))))))))),dbb)))));
}

{xrn=d_add(d_add(d_mul(d_diffabs(Xr,xr),d_add(d_sub(d_mul(d_mul(d_mul(Xr,Xr),Xr),Xr),d_mul(d_mul(d_mul(d_imul(10,Xr),Xr),Xi),Xi)),d_mul(d_mul(d_mul(d_imul(5,Xi),Xi),Xi),Xi))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_mul(d_mul(d_mul(d_imul(4,Xr),Xr),Xr),xr),d_mul(d_mul(d_mul(d_imul(6,Xr),Xr),xr),xr)),d_mul(d_mul(d_mul(d_imul(4,Xr),xr),xr),xr)),d_mul(d_mul(d_mul(xr,xr),xr),xr)),d_mul(d_mul(d_mul(d_imul(20,Xr),Xr),Xi),xi)),d_mul(d_mul(d_mul(d_imul(10,Xr),Xr),xi),xi)),d_mul(d_mul(d_mul(d_imul(20,Xr),xr),Xi),Xi)),d_mul(d_mul(d_mul(d_imul(40,Xr),xr),Xi),xi)),d_mul(d_mul(d_mul(d_imul(20,Xr),xr),xi),xi)),d_mul(d_mul(d_mul(d_imul(10,xr),xr),Xi),Xi)),d_mul(d_mul(d_mul(d_imul(20,xr),xr),Xi),xi)),d_mul(d_mul(d_mul(d_imul(10,xr),xr),xi),xi)),d_mul(d_mul(d_mul(d_imul(20,Xi),Xi),Xi),xi)),d_mul(d_mul(d_mul(d_imul(30,Xi),Xi),xi),xi)),d_mul(d_mul(d_mul(d_imul(20,Xi),xi),xi),xi)),d_mul(d_mul(d_mul(d_imul(5,xi),xi),xi),xi)))),cr);
xin=d_add(d_add(d_mul(d_diffabs(Xi,xi),d_add(d_sub(d_mul(d_mul(d_mul(d_imul(5,Xr),Xr),Xr),Xr),d_mul(d_mul(d_mul(d_imul(10,Xr),Xr),Xi),Xi)),d_mul(d_mul(d_mul(Xi,Xi),Xi),Xi))),d_mul(d_abs(d_add(Xi,xi)),d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_mul(d_mul(d_mul(d_imul(20,Xr),Xr),Xr),xr),d_mul(d_mul(d_mul(d_imul(30,Xr),Xr),xr),xr)),d_mul(d_mul(d_mul(d_imul(20,Xr),xr),xr),xr)),d_mul(d_mul(d_mul(d_imul(5,xr),xr),xr),xr)),d_mul(d_mul(d_mul(d_imul(20,Xr),Xr),Xi),xi)),d_mul(d_mul(d_mul(d_imul(10,Xr),Xr),xi),xi)),d_mul(d_mul(d_mul(d_imul(20,Xr),xr),Xi),Xi)),d_mul(d_mul(d_mul(d_imul(40,Xr),xr),Xi),xi)),d_mul(d_mul(d_mul(d_imul(20,Xr),xr),xi),xi)),d_mul(d_mul(d_mul(d_imul(10,xr),xr),Xi),Xi)),d_mul(d_mul(d_mul(d_imul(20,xr),xr),Xi),xi)),d_mul(d_mul(d_mul(d_imul(10,xr),xr),xi),xi)),d_mul(d_mul(d_mul(d_imul(4,Xi),Xi),Xi),xi)),d_mul(d_mul(d_mul(d_imul(6,Xi),Xi),xi),xi)),d_mul(d_mul(d_mul(d_imul(4,Xi),xi),xi),xi)),d_mul(d_mul(d_mul(xi,xi),xi),xi)))),ci);
}

);

static const char *perturbation_opencl_floatexp_1_5_0 = STR(

{xrn=fe_add(fe_add(fe_mul(fe_diffabs(Xr,xr),fe_add(fe_sub(fe_mul(fe_mul(fe_mul(Xr,Xr),Xr),Xr),fe_mul(fe_mul(fe_mul(fe_imul(10,Xr),Xr),Xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(5,Xi),Xi),Xi),Xi))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_mul(fe_imul(4,Xr),Xr),Xr),xr),fe_mul(fe_mul(fe_mul(fe_imul(6,Xr),Xr),xr),xr)),fe_mul(fe_mul(fe_mul(fe_imul(4,Xr),xr),xr),xr)),fe_mul(fe_mul(fe_mul(xr,xr),xr),xr)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),Xr),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(10,Xr),Xr),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),xr),Xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(40,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),xr),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(10,xr),xr),Xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr),xr),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(10,xr),xr),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),Xi),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(30,Xi),Xi),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),xi),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(5,xi),xi),xi),xi)))),cr);
xin=fe_add(fe_add(fe_mul(fe_diffabs(Xi,xi),fe_add(fe_sub(fe_mul(fe_mul(fe_mul(fe_imul(5,Xr),Xr),Xr),Xr),fe_mul(fe_mul(fe_mul(fe_imul(10,Xr),Xr),Xi),Xi)),fe_mul(fe_mul(fe_mul(Xi,Xi),Xi),Xi))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),Xr),Xr),xr),fe_mul(fe_mul(fe_mul(fe_imul(30,Xr),Xr),xr),xr)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),xr),xr),xr)),fe_mul(fe_mul(fe_mul(fe_imul(5,xr),xr),xr),xr)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),Xr),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(10,Xr),Xr),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),xr),Xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(40,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),xr),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(10,xr),xr),Xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr),xr),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(10,xr),xr),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(4,Xi),Xi),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(6,Xi),Xi),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(4,Xi),xi),xi),xi)),fe_mul(fe_mul(fe_mul(xi,xi),xi),xi)))),ci);
}

);

static const char *perturbation_opencl_floatexp_1_5_1 = STR(

{dxan=fe_add(fe_imul(5,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxa,fe_sgn(Xxr))))))))))),fe_add(fe_imul(5,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr))))))))))),fe_add(fe_imul(-20,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxr))))))))))),fe_add(fe_imul(20,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxr))))))))))),fe_add(fe_imul(-30,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr))))))))))),daa)))));
dxbn=fe_add(fe_imul(5,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxb,fe_sgn(Xxr))))))))))),fe_add(fe_imul(5,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr))))))))))),fe_add(fe_imul(-20,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxr))))))))))),fe_add(fe_imul(20,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxr))))))))))),fe_add(fe_imul(-30,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr))))))))))),dab)))));
dyan=fe_add(fe_imul(5,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dya,fe_sgn(Xxi))))))))))),fe_add(fe_imul(5,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxr))))))))))),fe_add(fe_imul(20,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr))))))))))),fe_add(fe_imul(-20,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr))))))))))),fe_add(fe_imul(-30,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxr))))))))))),dba)))));
dybn=fe_add(fe_imul(5,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dyb,fe_sgn(Xxi))))))))))),fe_add(fe_imul(5,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxr))))))))))),fe_add(fe_imul(20,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr))))))))))),fe_add(fe_imul(-20,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr))))))))))),fe_add(fe_imul(-30,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxr))))))))))),dbb)))));
}

{xrn=fe_add(fe_add(fe_mul(fe_diffabs(Xr,xr),fe_add(fe_sub(fe_mul(fe_mul(fe_mul(Xr,Xr),Xr),Xr),fe_mul(fe_mul(fe_mul(fe_imul(10,Xr),Xr),Xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(5,Xi),Xi),Xi),Xi))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_mul(fe_imul(4,Xr),Xr),Xr),xr),fe_mul(fe_mul(fe_mul(fe_imul(6,Xr),Xr),xr),xr)),fe_mul(fe_mul(fe_mul(fe_imul(4,Xr),xr),xr),xr)),fe_mul(fe_mul(fe_mul(xr,xr),xr),xr)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),Xr),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(10,Xr),Xr),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),xr),Xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(40,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),xr),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(10,xr),xr),Xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr),xr),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(10,xr),xr),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),Xi),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(30,Xi),Xi),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),xi),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(5,xi),xi),xi),xi)))),cr);
xin=fe_add(fe_add(fe_mul(fe_diffabs(Xi,xi),fe_add(fe_sub(fe_mul(fe_mul(fe_mul(fe_imul(5,Xr),Xr),Xr),Xr),fe_mul(fe_mul(fe_mul(fe_imul(10,Xr),Xr),Xi),Xi)),fe_mul(fe_mul(fe_mul(Xi,Xi),Xi),Xi))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),Xr),Xr),xr),fe_mul(fe_mul(fe_mul(fe_imul(30,Xr),Xr),xr),xr)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),xr),xr),xr)),fe_mul(fe_mul(fe_mul(fe_imul(5,xr),xr),xr),xr)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),Xr),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(10,Xr),Xr),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),xr),Xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(40,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),xr),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(10,xr),xr),Xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr),xr),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(10,xr),xr),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(4,Xi),Xi),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(6,Xi),Xi),xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(4,Xi),xi),xi),xi)),fe_mul(fe_mul(fe_mul(xi,xi),xi),xi)))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_1_5_0 = STR(

{xrn=sf_add(sf_add(sf_mul(sf_diffabs(Xr,xr),sf_add(sf_sub(sf_mul(sf_mul(sf_mul(Xr,Xr),Xr),Xr),sf_mul(sf_mul(sf_mul(sf_imul(10,Xr),Xr),Xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(5,Xi),Xi),Xi),Xi))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_add(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_mul(sf_imul(4,Xr),Xr),Xr),xr),sf_mul(sf_mul(sf_mul(sf_imul(6,Xr),Xr),xr),xr)),sf_mul(sf_mul(sf_mul(sf_imul(4,Xr),xr),xr),xr)),sf_mul(sf_mul(sf_mul(xr,xr),xr),xr)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xr),Xr),Xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(10,Xr),Xr),xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xr),xr),Xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(40,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xr),xr),xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(10,xr),xr),Xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(20,xr),xr),Xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(10,xr),xr),xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xi),Xi),Xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(30,Xi),Xi),xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xi),xi),xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(5,xi),xi),xi),xi)))),cr);
xin=sf_add(sf_add(sf_mul(sf_diffabs(Xi,xi),sf_add(sf_sub(sf_mul(sf_mul(sf_mul(sf_imul(5,Xr),Xr),Xr),Xr),sf_mul(sf_mul(sf_mul(sf_imul(10,Xr),Xr),Xi),Xi)),sf_mul(sf_mul(sf_mul(Xi,Xi),Xi),Xi))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_add(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_mul(sf_imul(20,Xr),Xr),Xr),xr),sf_mul(sf_mul(sf_mul(sf_imul(30,Xr),Xr),xr),xr)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xr),xr),xr),xr)),sf_mul(sf_mul(sf_mul(sf_imul(5,xr),xr),xr),xr)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xr),Xr),Xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(10,Xr),Xr),xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xr),xr),Xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(40,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xr),xr),xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(10,xr),xr),Xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(20,xr),xr),Xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(10,xr),xr),xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(4,Xi),Xi),Xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(6,Xi),Xi),xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(4,Xi),xi),xi),xi)),sf_mul(sf_mul(sf_mul(xi,xi),xi),xi)))),ci);
}

);
#endif


static const char *perturbation_opencl_double_2_2_0 = STR(

{xrn=d_add(d_diffabs(d_sub(d_mul(Xr,Xr),d_mul(Xi,Xi)),d_sub(d_sub(d_add(d_mul(d_imul(2,Xr),xr),d_mul(xr,xr)),d_mul(d_imul(2,Xi),xi)),d_mul(xi,xi))),cr);
xin=d_add(d_imul(2,d_diffabs(d_mul(Xr,Xi),d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi)))),ci);
}

);

static const char *perturbation_opencl_double_2_2_1 = STR(

{dxan=d_add(d_imul(2,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))),d_add(d_imul(-2,d_mul(Xxi,d_mul(dya,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))),daa));
dxbn=d_add(d_imul(2,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))),d_add(d_imul(-2,d_mul(Xxi,d_mul(dyb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))),dab));
dyan=d_add(d_imul(2,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(dxa,d_sgn(Xxr))))),d_add(d_imul(2,d_mul(d_sgn(Xxi),d_mul(Xxr,d_mul(dya,d_sgn(Xxr))))),dba));
dybn=d_add(d_imul(2,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(dxb,d_sgn(Xxr))))),d_add(d_imul(2,d_mul(d_sgn(Xxi),d_mul(Xxr,d_mul(dyb,d_sgn(Xxr))))),dbb));
}

{xrn=d_add(d_diffabs(d_sub(d_mul(Xr,Xr),d_mul(Xi,Xi)),d_sub(d_sub(d_add(d_mul(d_imul(2,Xr),xr),d_mul(xr,xr)),d_mul(d_imul(2,Xi),xi)),d_mul(xi,xi))),cr);
xin=d_add(d_imul(2,d_diffabs(d_mul(Xr,Xi),d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi)))),ci);
}

);

static const char *perturbation_opencl_floatexp_2_2_0 = STR(

{xrn=fe_add(fe_diffabs(fe_sub(fe_mul(Xr,Xr),fe_mul(Xi,Xi)),fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),fe_mul(xr,xr)),fe_mul(fe_imul(2,Xi),xi)),fe_mul(xi,xi))),cr);
xin=fe_add(fe_imul(2,fe_diffabs(fe_mul(Xr,Xi),fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi)))),ci);
}

);

static const char *perturbation_opencl_floatexp_2_2_1 = STR(

{dxan=fe_add(fe_imul(2,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))),fe_add(fe_imul(-2,fe_mul(Xxi,fe_mul(dya,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))),daa));
dxbn=fe_add(fe_imul(2,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))),fe_add(fe_imul(-2,fe_mul(Xxi,fe_mul(dyb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))),dab));
dyan=fe_add(fe_imul(2,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(dxa,fe_sgn(Xxr))))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxi),fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxr))))),dba));
dybn=fe_add(fe_imul(2,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(dxb,fe_sgn(Xxr))))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxi),fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxr))))),dbb));
}

{xrn=fe_add(fe_diffabs(fe_sub(fe_mul(Xr,Xr),fe_mul(Xi,Xi)),fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),fe_mul(xr,xr)),fe_mul(fe_imul(2,Xi),xi)),fe_mul(xi,xi))),cr);
xin=fe_add(fe_imul(2,fe_diffabs(fe_mul(Xr,Xi),fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi)))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_2_2_0 = STR(

{xrn=sf_add(sf_diffabs(sf_sub(sf_mul(Xr,Xr),sf_mul(Xi,Xi)),sf_sub(sf_sub(sf_add(sf_mul(sf_imul(2,Xr),xr),sf_mul(xr,xr)),sf_mul(sf_imul(2,Xi),xi)),sf_mul(xi,xi))),cr);
xin=sf_add(sf_imul(2,sf_diffabs(sf_mul(Xr,Xi),sf_add(sf_add(sf_mul(Xr,xi),sf_mul(xr,Xi)),sf_mul(xr,xi)))),ci);
}

);
#endif


static const char *perturbation_opencl_double_2_3_0 = STR(

{xrn=d_add(d_diffabs(d_mul(Xr,d_sub(d_mul(Xr,Xr),d_mul(d_imul(3,Xi),Xi))),d_sub(d_add(d_mul(xr,d_add(d_mul(d_imul(3,Xr),Xr),d_mul(xr,xr))),d_mul(d_imul(3,Xr),d_sub(d_sub(d_mul(xr,xr),d_mul(d_imul(2,Xi),xi)),d_mul(xi,xi)))),d_mul(d_imul(3,xr),d_add(d_add(d_mul(Xi,Xi),d_mul(d_imul(2,Xi),xi)),d_mul(xi,xi))))),cr);
xin=d_add(d_diffabs(d_mul(Xi,d_sub(d_mul(d_imul(3,Xr),Xr),d_mul(Xi,Xi))),d_sub(d_add(d_mul(d_imul(3,Xi),d_sub(d_add(d_mul(d_imul(2,Xr),xr),d_mul(xr,xr)),d_mul(xi,xi))),d_mul(d_imul(3,xi),d_add(d_add(d_mul(Xr,Xr),d_mul(d_imul(2,Xr),xr)),d_mul(xr,xr)))),d_mul(xi,d_add(d_mul(d_imul(3,Xi),Xi),d_mul(xi,xi))))),ci);
}

);

static const char *perturbation_opencl_double_2_3_1 = STR(

{dxan=d_add(d_imul(3,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_imul(-3,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr)))))))),d_add(d_imul(-3,d_mul(Xxi,d_mul(Xxi,d_mul(dxa,d_sgn(d_add(d_imul(-3,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr)))))))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_imul(-3,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr)))))))),daa)));
dxbn=d_add(d_imul(3,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_imul(-3,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr)))))))),d_add(d_imul(-3,d_mul(Xxi,d_mul(Xxi,d_mul(dxb,d_sgn(d_add(d_imul(-3,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr)))))))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_imul(-3,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr)))))))),dab)));
dyan=d_add(d_imul(3,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxi))),d_imul(3,d_mul(Xxi,d_mul(Xxr,Xxr))))))))),d_add(d_imul(-3,d_mul(Xxi,d_mul(Xxi,d_mul(dya,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxi))),d_imul(3,d_mul(Xxi,d_mul(Xxr,Xxr))))))))),d_add(d_imul(6,d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxi))),d_imul(3,d_mul(Xxi,d_mul(Xxr,Xxr))))))))),dba)));
dybn=d_add(d_imul(3,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxi))),d_imul(3,d_mul(Xxi,d_mul(Xxr,Xxr))))))))),d_add(d_imul(-3,d_mul(Xxi,d_mul(Xxi,d_mul(dyb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxi))),d_imul(3,d_mul(Xxi,d_mul(Xxr,Xxr))))))))),d_add(d_imul(6,d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxi))),d_imul(3,d_mul(Xxi,d_mul(Xxr,Xxr))))))))),dbb)));
}

{xrn=d_add(d_diffabs(d_mul(Xr,d_sub(d_mul(Xr,Xr),d_mul(d_imul(3,Xi),Xi))),d_sub(d_add(d_mul(xr,d_add(d_mul(d_imul(3,Xr),Xr),d_mul(xr,xr))),d_mul(d_imul(3,Xr),d_sub(d_sub(d_mul(xr,xr),d_mul(d_imul(2,Xi),xi)),d_mul(xi,xi)))),d_mul(d_imul(3,xr),d_add(d_add(d_mul(Xi,Xi),d_mul(d_imul(2,Xi),xi)),d_mul(xi,xi))))),cr);
xin=d_add(d_diffabs(d_mul(Xi,d_sub(d_mul(d_imul(3,Xr),Xr),d_mul(Xi,Xi))),d_sub(d_add(d_mul(d_imul(3,Xi),d_sub(d_add(d_mul(d_imul(2,Xr),xr),d_mul(xr,xr)),d_mul(xi,xi))),d_mul(d_imul(3,xi),d_add(d_add(d_mul(Xr,Xr),d_mul(d_imul(2,Xr),xr)),d_mul(xr,xr)))),d_mul(xi,d_add(d_mul(d_imul(3,Xi),Xi),d_mul(xi,xi))))),ci);
}

);

static const char *perturbation_opencl_floatexp_2_3_0 = STR(

{xrn=fe_add(fe_diffabs(fe_mul(Xr,fe_sub(fe_mul(Xr,Xr),fe_mul(fe_imul(3,Xi),Xi))),fe_sub(fe_add(fe_mul(xr,fe_add(fe_mul(fe_imul(3,Xr),Xr),fe_mul(xr,xr))),fe_mul(fe_imul(3,Xr),fe_sub(fe_sub(fe_mul(xr,xr),fe_mul(fe_imul(2,Xi),xi)),fe_mul(xi,xi)))),fe_mul(fe_imul(3,xr),fe_add(fe_add(fe_mul(Xi,Xi),fe_mul(fe_imul(2,Xi),xi)),fe_mul(xi,xi))))),cr);
xin=fe_add(fe_diffabs(fe_mul(Xi,fe_sub(fe_mul(fe_imul(3,Xr),Xr),fe_mul(Xi,Xi))),fe_sub(fe_add(fe_mul(fe_imul(3,Xi),fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),fe_mul(xr,xr)),fe_mul(xi,xi))),fe_mul(fe_imul(3,xi),fe_add(fe_add(fe_mul(Xr,Xr),fe_mul(fe_imul(2,Xr),xr)),fe_mul(xr,xr)))),fe_mul(xi,fe_add(fe_mul(fe_imul(3,Xi),Xi),fe_mul(xi,xi))))),ci);
}

);

static const char *perturbation_opencl_floatexp_2_3_1 = STR(

{dxan=fe_add(fe_imul(3,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_imul(-3,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(-3,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxa,fe_sgn(fe_add(fe_imul(-3,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_imul(-3,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))),daa)));
dxbn=fe_add(fe_imul(3,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_imul(-3,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(-3,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxb,fe_sgn(fe_add(fe_imul(-3,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_imul(-3,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))),dab)));
dyan=fe_add(fe_imul(3,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_imul(3,fe_mul(Xxi,fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(-3,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dya,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_imul(3,fe_mul(Xxi,fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(6,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_imul(3,fe_mul(Xxi,fe_mul(Xxr,Xxr))))))))),dba)));
dybn=fe_add(fe_imul(3,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_imul(3,fe_mul(Xxi,fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(-3,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dyb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_imul(3,fe_mul(Xxi,fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(6,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_imul(3,fe_mul(Xxi,fe_mul(Xxr,Xxr))))))))),dbb)));
}

{xrn=fe_add(fe_diffabs(fe_mul(Xr,fe_sub(fe_mul(Xr,Xr),fe_mul(fe_imul(3,Xi),Xi))),fe_sub(fe_add(fe_mul(xr,fe_add(fe_mul(fe_imul(3,Xr),Xr),fe_mul(xr,xr))),fe_mul(fe_imul(3,Xr),fe_sub(fe_sub(fe_mul(xr,xr),fe_mul(fe_imul(2,Xi),xi)),fe_mul(xi,xi)))),fe_mul(fe_imul(3,xr),fe_add(fe_add(fe_mul(Xi,Xi),fe_mul(fe_imul(2,Xi),xi)),fe_mul(xi,xi))))),cr);
xin=fe_add(fe_diffabs(fe_mul(Xi,fe_sub(fe_mul(fe_imul(3,Xr),Xr),fe_mul(Xi,Xi))),fe_sub(fe_add(fe_mul(fe_imul(3,Xi),fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),fe_mul(xr,xr)),fe_mul(xi,xi))),fe_mul(fe_imul(3,xi),fe_add(fe_add(fe_mul(Xr,Xr),fe_mul(fe_imul(2,Xr),xr)),fe_mul(xr,xr)))),fe_mul(xi,fe_add(fe_mul(fe_imul(3,Xi),Xi),fe_mul(xi,xi))))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_2_3_0 = STR(

{xrn=sf_add(sf_diffabs(sf_mul(Xr,sf_sub(sf_mul(Xr,Xr),sf_mul(sf_imul(3,Xi),Xi))),sf_sub(sf_add(sf_mul(xr,sf_add(sf_mul(sf_imul(3,Xr),Xr),sf_mul(xr,xr))),sf_mul(sf_imul(3,Xr),sf_sub(sf_sub(sf_mul(xr,xr),sf_mul(sf_imul(2,Xi),xi)),sf_mul(xi,xi)))),sf_mul(sf_imul(3,xr),sf_add(sf_add(sf_mul(Xi,Xi),sf_mul(sf_imul(2,Xi),xi)),sf_mul(xi,xi))))),cr);
xin=sf_add(sf_diffabs(sf_mul(Xi,sf_sub(sf_mul(sf_imul(3,Xr),Xr),sf_mul(Xi,Xi))),sf_sub(sf_add(sf_mul(sf_imul(3,Xi),sf_sub(sf_add(sf_mul(sf_imul(2,Xr),xr),sf_mul(xr,xr)),sf_mul(xi,xi))),sf_mul(sf_imul(3,xi),sf_add(sf_add(sf_mul(Xr,Xr),sf_mul(sf_imul(2,Xr),xr)),sf_mul(xr,xr)))),sf_mul(xi,sf_add(sf_mul(sf_imul(3,Xi),Xi),sf_mul(xi,xi))))),ci);
}

);
#endif


static const char *perturbation_opencl_double_2_4_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_diffabs(d_sub(d_add(d_mul(Xr2,Xr2),d_mul(Xi2,Xi2)),d_mul(d_imul(6,Xr2),Xi2)),d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_mul(d_imul(12,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(24,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(12,Xr),xr),xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xr2),Xi),xi)),d_mul(d_imul(6,xr2),xi2))),cr);
xin=d_add(d_diffabs(d_sub(d_mul(d_mul(d_imul(4,Xr2),Xr),Xi),d_mul(d_mul(d_imul(4,Xr),Xi2),Xi)),d_add(d_sub(d_add(d_sub(d_add(d_add(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_mul(d_mul(d_imul(-4,xr),Xi2),Xi),d_mul(d_mul(d_imul(12,xi),Xr),Xi2)),d_mul(d_mul(d_imul(12,xr),xi),Xi2)),d_mul(d_mul(d_imul(12,xr),Xr2),Xi)),d_mul(d_mul(d_imul(12,xi2),Xr),Xi)),d_mul(d_mul(d_imul(12,xr2),Xr),Xi)),d_mul(d_mul(d_imul(12,xr),xi2),Xi)),d_mul(d_mul(d_imul(4,xr2),xr),Xi)),d_mul(d_mul(d_imul(4,xi),Xr2),Xr)),d_mul(d_mul(d_imul(12,xr),xi),Xr2)),d_mul(d_mul(d_imul(4,xi2),xi),Xr)),d_mul(d_mul(d_imul(12,xr2),xi),Xr)),d_mul(d_mul(d_imul(4,xr),xi2),xi)),d_mul(d_mul(d_imul(4,xr2),xr),xi))),ci);
}

);

static const char *perturbation_opencl_double_2_4_1 = STR(

{dxan=d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dya,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),daa))));
dxbn=d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dyb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),dab))));
dyan=d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_imul(-4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr)))),d_imul(4,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxa,d_sgn(d_add(d_imul(-4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr)))),d_imul(4,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_imul(-4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr)))),d_imul(4,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_imul(-4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr)))),d_imul(4,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),dba))));
dybn=d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_imul(-4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr)))),d_imul(4,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxb,d_sgn(d_add(d_imul(-4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr)))),d_imul(4,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_imul(-4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr)))),d_imul(4,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_imul(-4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr)))),d_imul(4,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),dbb))));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_diffabs(d_sub(d_add(d_mul(Xr2,Xr2),d_mul(Xi2,Xi2)),d_mul(d_imul(6,Xr2),Xi2)),d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_mul(d_imul(12,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(24,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(12,Xr),xr),xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xr2),Xi),xi)),d_mul(d_imul(6,xr2),xi2))),cr);
xin=d_add(d_diffabs(d_sub(d_mul(d_mul(d_imul(4,Xr2),Xr),Xi),d_mul(d_mul(d_imul(4,Xr),Xi2),Xi)),d_add(d_sub(d_add(d_sub(d_add(d_add(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_mul(d_mul(d_imul(-4,xr),Xi2),Xi),d_mul(d_mul(d_imul(12,xi),Xr),Xi2)),d_mul(d_mul(d_imul(12,xr),xi),Xi2)),d_mul(d_mul(d_imul(12,xr),Xr2),Xi)),d_mul(d_mul(d_imul(12,xi2),Xr),Xi)),d_mul(d_mul(d_imul(12,xr2),Xr),Xi)),d_mul(d_mul(d_imul(12,xr),xi2),Xi)),d_mul(d_mul(d_imul(4,xr2),xr),Xi)),d_mul(d_mul(d_imul(4,xi),Xr2),Xr)),d_mul(d_mul(d_imul(12,xr),xi),Xr2)),d_mul(d_mul(d_imul(4,xi2),xi),Xr)),d_mul(d_mul(d_imul(12,xr2),xi),Xr)),d_mul(d_mul(d_imul(4,xr),xi2),xi)),d_mul(d_mul(d_imul(4,xr2),xr),xi))),ci);
}

);

static const char *perturbation_opencl_floatexp_2_4_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_add(fe_mul(Xr2,Xr2),fe_mul(Xi2,Xi2)),fe_mul(fe_imul(6,Xr2),Xi2)),fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_mul(fe_imul(12,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(12,Xr),xr),xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xr2),Xi),xi)),fe_mul(fe_imul(6,xr2),xi2))),cr);
xin=fe_add(fe_diffabs(fe_sub(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),Xi),fe_mul(fe_mul(fe_imul(4,Xr),Xi2),Xi)),fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_mul(fe_mul(fe_imul(-4,xr),Xi2),Xi),fe_mul(fe_mul(fe_imul(12,xi),Xr),Xi2)),fe_mul(fe_mul(fe_imul(12,xr),xi),Xi2)),fe_mul(fe_mul(fe_imul(12,xr),Xr2),Xi)),fe_mul(fe_mul(fe_imul(12,xi2),Xr),Xi)),fe_mul(fe_mul(fe_imul(12,xr2),Xr),Xi)),fe_mul(fe_mul(fe_imul(12,xr),xi2),Xi)),fe_mul(fe_mul(fe_imul(4,xr2),xr),Xi)),fe_mul(fe_mul(fe_imul(4,xi),Xr2),Xr)),fe_mul(fe_mul(fe_imul(12,xr),xi),Xr2)),fe_mul(fe_mul(fe_imul(4,xi2),xi),Xr)),fe_mul(fe_mul(fe_imul(12,xr2),xi),Xr)),fe_mul(fe_mul(fe_imul(4,xr),xi2),xi)),fe_mul(fe_mul(fe_imul(4,xr2),xr),xi))),ci);
}

);

static const char *perturbation_opencl_floatexp_2_4_1 = STR(

{dxan=fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dya,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),daa))));
dxbn=fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dyb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),dab))));
dyan=fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr)))),fe_imul(4,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxa,fe_sgn(fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr)))),fe_imul(4,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr)))),fe_imul(4,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr)))),fe_imul(4,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),dba))));
dybn=fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr)))),fe_imul(4,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxb,fe_sgn(fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr)))),fe_imul(4,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr)))),fe_imul(4,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr)))),fe_imul(4,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),dbb))));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_add(fe_mul(Xr2,Xr2),fe_mul(Xi2,Xi2)),fe_mul(fe_imul(6,Xr2),Xi2)),fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_mul(fe_imul(12,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(12,Xr),xr),xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xr2),Xi),xi)),fe_mul(fe_imul(6,xr2),xi2))),cr);
xin=fe_add(fe_diffabs(fe_sub(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),Xi),fe_mul(fe_mul(fe_imul(4,Xr),Xi2),Xi)),fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_mul(fe_mul(fe_imul(-4,xr),Xi2),Xi),fe_mul(fe_mul(fe_imul(12,xi),Xr),Xi2)),fe_mul(fe_mul(fe_imul(12,xr),xi),Xi2)),fe_mul(fe_mul(fe_imul(12,xr),Xr2),Xi)),fe_mul(fe_mul(fe_imul(12,xi2),Xr),Xi)),fe_mul(fe_mul(fe_imul(12,xr2),Xr),Xi)),fe_mul(fe_mul(fe_imul(12,xr),xi2),Xi)),fe_mul(fe_mul(fe_imul(4,xr2),xr),Xi)),fe_mul(fe_mul(fe_imul(4,xi),Xr2),Xr)),fe_mul(fe_mul(fe_imul(12,xr),xi),Xr2)),fe_mul(fe_mul(fe_imul(4,xi2),xi),Xr)),fe_mul(fe_mul(fe_imul(12,xr2),xi),Xr)),fe_mul(fe_mul(fe_imul(4,xr),xi2),xi)),fe_mul(fe_mul(fe_imul(4,xr2),xr),xi))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_2_4_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_diffabs(sf_sub(sf_add(sf_mul(Xr2,Xr2),sf_mul(Xi2,Xi2)),sf_mul(sf_imul(6,Xr2),Xi2)),sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_mul(sf_imul(4,Xi),xi2),xi)),sf_mul(xi2,xi2)),sf_mul(sf_mul(sf_imul(12,Xr2),Xi),xi)),sf_mul(sf_imul(6,Xr2),xi2)),sf_mul(sf_mul(sf_imul(12,Xr),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(24,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_imul(12,Xr),xr),xi2)),sf_mul(sf_imul(6,xr2),Xi2)),sf_mul(sf_mul(sf_imul(12,xr2),Xi),xi)),sf_mul(sf_imul(6,xr2),xi2))),cr);
xin=sf_add(sf_diffabs(sf_sub(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),Xi),sf_mul(sf_mul(sf_imul(4,Xr),Xi2),Xi)),sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_mul(sf_mul(sf_imul(-4,xr),Xi2),Xi),sf_mul(sf_mul(sf_imul(12,xi),Xr),Xi2)),sf_mul(sf_mul(sf_imul(12,xr),xi),Xi2)),sf_mul(sf_mul(sf_imul(12,xr),Xr2),Xi)),sf_mul(sf_mul(sf_imul(12,xi2),Xr),Xi)),sf_mul(sf_mul(sf_imul(12,xr2),Xr),Xi)),sf_mul(sf_mul(sf_imul(12,xr),xi2),Xi)),sf_mul(sf_mul(sf_imul(4,xr2),xr),Xi)),sf_mul(sf_mul(sf_imul(4,xi),Xr2),Xr)),sf_mul(sf_mul(sf_imul(12,xr),xi),Xr2)),sf_mul(sf_mul(sf_imul(4,xi2),xi),Xr)),sf_mul(sf_mul(sf_imul(12,xr2),xi),Xr)),sf_mul(sf_mul(sf_imul(4,xr),xi2),xi)),sf_mul(sf_mul(sf_imul(4,xr2),xr),xi))),ci);
}

);
#endif


static const char *perturbation_opencl_double_2_5_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_diffabs(d_add(d_sub(d_mul(d_mul(d_imul(5,Xr),Xi2),Xi2),d_mul(d_mul(d_imul(10,Xr2),Xr),Xi2)),d_mul(d_mul(Xr2,Xr2),Xr)),d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_add(d_add(d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_mul(d_mul(d_mul(d_imul(20,Xr),xi),Xi2),Xi),d_mul(d_mul(d_imul(30,Xr2),xr),Xi2)),d_mul(d_mul(d_imul(30,Xr),xi2),Xi2)),d_mul(d_mul(d_imul(30,Xr),xr2),Xi2)),d_mul(d_mul(d_mul(d_imul(20,Xr2),Xr),xi),Xi)),d_mul(d_mul(d_mul(d_imul(60,Xr2),xr),xi),Xi)),d_mul(d_mul(d_mul(d_imul(20,Xr),xi2),xi),Xi)),d_mul(d_mul(d_mul(d_imul(60,Xr),xr2),xi),Xi)),d_mul(d_mul(d_imul(5,Xr2),Xr2),xr)),d_mul(d_mul(d_imul(10,Xr2),Xr),xi2)),d_mul(d_mul(d_imul(10,Xr2),Xr),xr2)),d_mul(d_mul(d_imul(30,Xr2),xr),xi2)),d_mul(d_mul(d_imul(10,Xr2),xr2),xr)),d_mul(d_mul(d_imul(5,Xr),xi2),xi2)),d_mul(d_mul(d_imul(30,Xr),xr2),xi2)),d_mul(d_mul(d_imul(5,Xr),xr2),xr2)),d_mul(d_mul(d_imul(5,xr),Xi2),Xi2)),d_mul(d_mul(d_mul(d_imul(20,xr),xi),Xi2),Xi)),d_mul(d_mul(d_imul(30,xr),xi2),Xi2)),d_mul(d_mul(d_imul(10,xr2),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(20,xr),xi2),xi),Xi)),d_mul(d_mul(d_mul(d_imul(20,xr2),xr),xi),Xi)),d_mul(d_mul(d_imul(5,xr),xi2),xi2)),d_mul(d_mul(d_imul(10,xr2),xr),xi2)),d_mul(d_mul(xr2,xr2),xr))),cr);
xin=d_add(d_diffabs(d_add(d_sub(d_mul(d_mul(Xi2,Xi2),Xi),d_mul(d_mul(d_imul(10,Xi2),Xi),Xr2)),d_mul(d_mul(d_imul(5,Xi),Xr2),Xr2)),d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_add(d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_mul(d_mul(d_imul(5,Xi2),Xi2),xi),d_mul(d_mul(d_mul(d_imul(20,Xi2),Xi),xr),Xr)),d_mul(d_mul(d_imul(10,Xi2),Xi),xi2)),d_mul(d_mul(d_imul(10,Xi2),Xi),xr2)),d_mul(d_mul(d_imul(30,Xi2),xi),Xr2)),d_mul(d_mul(d_mul(d_imul(60,Xi2),xr),xi),Xr)),d_mul(d_mul(d_imul(10,Xi2),xi2),xi)),d_mul(d_mul(d_imul(30,Xi2),xr2),xi)),d_mul(d_mul(d_mul(d_imul(20,Xi),xr),Xr2),Xr)),d_mul(d_mul(d_imul(30,Xi),xi2),Xr2)),d_mul(d_mul(d_imul(30,Xi),xr2),Xr2)),d_mul(d_mul(d_mul(d_imul(60,Xi),xr),xi2),Xr)),d_mul(d_mul(d_mul(d_imul(20,Xi),xr2),xr),Xr)),d_mul(d_mul(d_imul(5,Xi),xi2),xi2)),d_mul(d_mul(d_imul(30,Xi),xr2),xi2)),d_mul(d_mul(d_imul(5,Xi),xr2),xr2)),d_mul(d_mul(d_imul(5,xi),Xr2),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi),xr),Xr2),Xr)),d_mul(d_mul(d_imul(10,xi2),xi),Xr2)),d_mul(d_mul(d_imul(30,xi),xr2),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi2),xi),xr),Xr)),d_mul(d_mul(d_mul(d_imul(20,xi),xr2),xr),Xr)),d_mul(d_mul(xi2,xi2),xi)),d_mul(d_mul(d_imul(10,xi2),xi),xr2)),d_mul(d_mul(d_imul(5,xi),xr2),xr2))),ci);
}

);

static const char *perturbation_opencl_double_2_5_1 = STR(

{dxan=d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxa,d_sgn(d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr))))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_add(d_imul(5,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr))))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_add(d_imul(-20,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr))))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_add(d_imul(20,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr))))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_add(d_imul(-30,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr))))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),daa)))));
dxbn=d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxb,d_sgn(d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr))))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_add(d_imul(5,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr))))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_add(d_imul(-20,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr))))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_add(d_imul(20,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr))))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_add(d_imul(-30,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr))))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),dab)))));
dyan=d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dya,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi)))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr))))),d_imul(5,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr)))))))))))))),d_add(d_imul(5,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi)))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr))))),d_imul(5,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr)))))))))))))),d_add(d_imul(20,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi)))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr))))),d_imul(5,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr)))))))))))))),d_add(d_imul(-20,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi)))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr))))),d_imul(5,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr)))))))))))))),d_add(d_imul(-30,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi)))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr))))),d_imul(5,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr)))))))))))))),dba)))));
dybn=d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dyb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi)))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr))))),d_imul(5,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr)))))))))))))),d_add(d_imul(5,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi)))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr))))),d_imul(5,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr)))))))))))))),d_add(d_imul(20,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi)))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr))))),d_imul(5,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr)))))))))))))),d_add(d_imul(-20,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi)))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr))))),d_imul(5,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr)))))))))))))),d_add(d_imul(-30,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi)))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr))))),d_imul(5,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr)))))))))))))),dbb)))));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_diffabs(d_add(d_sub(d_mul(d_mul(d_imul(5,Xr),Xi2),Xi2),d_mul(d_mul(d_imul(10,Xr2),Xr),Xi2)),d_mul(d_mul(Xr2,Xr2),Xr)),d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_add(d_add(d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_mul(d_mul(d_mul(d_imul(20,Xr),xi),Xi2),Xi),d_mul(d_mul(d_imul(30,Xr2),xr),Xi2)),d_mul(d_mul(d_imul(30,Xr),xi2),Xi2)),d_mul(d_mul(d_imul(30,Xr),xr2),Xi2)),d_mul(d_mul(d_mul(d_imul(20,Xr2),Xr),xi),Xi)),d_mul(d_mul(d_mul(d_imul(60,Xr2),xr),xi),Xi)),d_mul(d_mul(d_mul(d_imul(20,Xr),xi2),xi),Xi)),d_mul(d_mul(d_mul(d_imul(60,Xr),xr2),xi),Xi)),d_mul(d_mul(d_imul(5,Xr2),Xr2),xr)),d_mul(d_mul(d_imul(10,Xr2),Xr),xi2)),d_mul(d_mul(d_imul(10,Xr2),Xr),xr2)),d_mul(d_mul(d_imul(30,Xr2),xr),xi2)),d_mul(d_mul(d_imul(10,Xr2),xr2),xr)),d_mul(d_mul(d_imul(5,Xr),xi2),xi2)),d_mul(d_mul(d_imul(30,Xr),xr2),xi2)),d_mul(d_mul(d_imul(5,Xr),xr2),xr2)),d_mul(d_mul(d_imul(5,xr),Xi2),Xi2)),d_mul(d_mul(d_mul(d_imul(20,xr),xi),Xi2),Xi)),d_mul(d_mul(d_imul(30,xr),xi2),Xi2)),d_mul(d_mul(d_imul(10,xr2),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(20,xr),xi2),xi),Xi)),d_mul(d_mul(d_mul(d_imul(20,xr2),xr),xi),Xi)),d_mul(d_mul(d_imul(5,xr),xi2),xi2)),d_mul(d_mul(d_imul(10,xr2),xr),xi2)),d_mul(d_mul(xr2,xr2),xr))),cr);
xin=d_add(d_diffabs(d_add(d_sub(d_mul(d_mul(Xi2,Xi2),Xi),d_mul(d_mul(d_imul(10,Xi2),Xi),Xr2)),d_mul(d_mul(d_imul(5,Xi),Xr2),Xr2)),d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_add(d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_mul(d_mul(d_imul(5,Xi2),Xi2),xi),d_mul(d_mul(d_mul(d_imul(20,Xi2),Xi),xr),Xr)),d_mul(d_mul(d_imul(10,Xi2),Xi),xi2)),d_mul(d_mul(d_imul(10,Xi2),Xi),xr2)),d_mul(d_mul(d_imul(30,Xi2),xi),Xr2)),d_mul(d_mul(d_mul(d_imul(60,Xi2),xr),xi),Xr)),d_mul(d_mul(d_imul(10,Xi2),xi2),xi)),d_mul(d_mul(d_imul(30,Xi2),xr2),xi)),d_mul(d_mul(d_mul(d_imul(20,Xi),xr),Xr2),Xr)),d_mul(d_mul(d_imul(30,Xi),xi2),Xr2)),d_mul(d_mul(d_imul(30,Xi),xr2),Xr2)),d_mul(d_mul(d_mul(d_imul(60,Xi),xr),xi2),Xr)),d_mul(d_mul(d_mul(d_imul(20,Xi),xr2),xr),Xr)),d_mul(d_mul(d_imul(5,Xi),xi2),xi2)),d_mul(d_mul(d_imul(30,Xi),xr2),xi2)),d_mul(d_mul(d_imul(5,Xi),xr2),xr2)),d_mul(d_mul(d_imul(5,xi),Xr2),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi),xr),Xr2),Xr)),d_mul(d_mul(d_imul(10,xi2),xi),Xr2)),d_mul(d_mul(d_imul(30,xi),xr2),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi2),xi),xr),Xr)),d_mul(d_mul(d_mul(d_imul(20,xi),xr2),xr),Xr)),d_mul(d_mul(xi2,xi2),xi)),d_mul(d_mul(d_imul(10,xi2),xi),xr2)),d_mul(d_mul(d_imul(5,xi),xr2),xr2))),ci);
}

);

static const char *perturbation_opencl_floatexp_2_5_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_add(fe_sub(fe_mul(fe_mul(fe_imul(5,Xr),Xi2),Xi2),fe_mul(fe_mul(fe_imul(10,Xr2),Xr),Xi2)),fe_mul(fe_mul(Xr2,Xr2),Xr)),fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),xi),Xi2),Xi),fe_mul(fe_mul(fe_imul(30,Xr2),xr),Xi2)),fe_mul(fe_mul(fe_imul(30,Xr),xi2),Xi2)),fe_mul(fe_mul(fe_imul(30,Xr),xr2),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr2),Xr),xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xr2),xr),xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),xi2),xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xr),xr2),xi),Xi)),fe_mul(fe_mul(fe_imul(5,Xr2),Xr2),xr)),fe_mul(fe_mul(fe_imul(10,Xr2),Xr),xi2)),fe_mul(fe_mul(fe_imul(10,Xr2),Xr),xr2)),fe_mul(fe_mul(fe_imul(30,Xr2),xr),xi2)),fe_mul(fe_mul(fe_imul(10,Xr2),xr2),xr)),fe_mul(fe_mul(fe_imul(5,Xr),xi2),xi2)),fe_mul(fe_mul(fe_imul(30,Xr),xr2),xi2)),fe_mul(fe_mul(fe_imul(5,Xr),xr2),xr2)),fe_mul(fe_mul(fe_imul(5,xr),Xi2),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr),xi),Xi2),Xi)),fe_mul(fe_mul(fe_imul(30,xr),xi2),Xi2)),fe_mul(fe_mul(fe_imul(10,xr2),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr),xi2),xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr2),xr),xi),Xi)),fe_mul(fe_mul(fe_imul(5,xr),xi2),xi2)),fe_mul(fe_mul(fe_imul(10,xr2),xr),xi2)),fe_mul(fe_mul(xr2,xr2),xr))),cr);
xin=fe_add(fe_diffabs(fe_add(fe_sub(fe_mul(fe_mul(Xi2,Xi2),Xi),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),Xr2)),fe_mul(fe_mul(fe_imul(5,Xi),Xr2),Xr2)),fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_mul(fe_mul(fe_imul(5,Xi2),Xi2),xi),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi2),Xi),xr),Xr)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xi2)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xr2)),fe_mul(fe_mul(fe_imul(30,Xi2),xi),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi2),xr),xi),Xr)),fe_mul(fe_mul(fe_imul(10,Xi2),xi2),xi)),fe_mul(fe_mul(fe_imul(30,Xi2),xr2),xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),xr),Xr2),Xr)),fe_mul(fe_mul(fe_imul(30,Xi),xi2),Xr2)),fe_mul(fe_mul(fe_imul(30,Xi),xr2),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi),xr),xi2),Xr)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),xr2),xr),Xr)),fe_mul(fe_mul(fe_imul(5,Xi),xi2),xi2)),fe_mul(fe_mul(fe_imul(30,Xi),xr2),xi2)),fe_mul(fe_mul(fe_imul(5,Xi),xr2),xr2)),fe_mul(fe_mul(fe_imul(5,xi),Xr2),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),xr),Xr2),Xr)),fe_mul(fe_mul(fe_imul(10,xi2),xi),Xr2)),fe_mul(fe_mul(fe_imul(30,xi),xr2),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi2),xi),xr),Xr)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),xr2),xr),Xr)),fe_mul(fe_mul(xi2,xi2),xi)),fe_mul(fe_mul(fe_imul(10,xi2),xi),xr2)),fe_mul(fe_mul(fe_imul(5,xi),xr2),xr2))),ci);
}

);

static const char *perturbation_opencl_floatexp_2_5_1 = STR(

{dxan=fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxa,fe_sgn(fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr))))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_add(fe_imul(5,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr))))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_add(fe_imul(-20,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr))))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_add(fe_imul(20,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr))))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_add(fe_imul(-30,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr))))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),daa)))));
dxbn=fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxb,fe_sgn(fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr))))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_add(fe_imul(5,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr))))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_add(fe_imul(-20,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr))))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_add(fe_imul(20,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr))))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_add(fe_imul(-30,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr))))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),dab)))));
dyan=fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dya,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr))))),fe_imul(5,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))))))))),fe_add(fe_imul(5,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr))))),fe_imul(5,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))))))))),fe_add(fe_imul(20,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr))))),fe_imul(5,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))))))))),fe_add(fe_imul(-20,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr))))),fe_imul(5,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))))))))),fe_add(fe_imul(-30,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr))))),fe_imul(5,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))))))))),dba)))));
dybn=fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dyb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr))))),fe_imul(5,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))))))))),fe_add(fe_imul(5,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr))))),fe_imul(5,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))))))))),fe_add(fe_imul(20,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr))))),fe_imul(5,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))))))))),fe_add(fe_imul(-20,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr))))),fe_imul(5,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))))))))),fe_add(fe_imul(-30,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr))))),fe_imul(5,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))))))))),dbb)))));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_add(fe_sub(fe_mul(fe_mul(fe_imul(5,Xr),Xi2),Xi2),fe_mul(fe_mul(fe_imul(10,Xr2),Xr),Xi2)),fe_mul(fe_mul(Xr2,Xr2),Xr)),fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),xi),Xi2),Xi),fe_mul(fe_mul(fe_imul(30,Xr2),xr),Xi2)),fe_mul(fe_mul(fe_imul(30,Xr),xi2),Xi2)),fe_mul(fe_mul(fe_imul(30,Xr),xr2),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr2),Xr),xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xr2),xr),xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),xi2),xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xr),xr2),xi),Xi)),fe_mul(fe_mul(fe_imul(5,Xr2),Xr2),xr)),fe_mul(fe_mul(fe_imul(10,Xr2),Xr),xi2)),fe_mul(fe_mul(fe_imul(10,Xr2),Xr),xr2)),fe_mul(fe_mul(fe_imul(30,Xr2),xr),xi2)),fe_mul(fe_mul(fe_imul(10,Xr2),xr2),xr)),fe_mul(fe_mul(fe_imul(5,Xr),xi2),xi2)),fe_mul(fe_mul(fe_imul(30,Xr),xr2),xi2)),fe_mul(fe_mul(fe_imul(5,Xr),xr2),xr2)),fe_mul(fe_mul(fe_imul(5,xr),Xi2),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr),xi),Xi2),Xi)),fe_mul(fe_mul(fe_imul(30,xr),xi2),Xi2)),fe_mul(fe_mul(fe_imul(10,xr2),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr),xi2),xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr2),xr),xi),Xi)),fe_mul(fe_mul(fe_imul(5,xr),xi2),xi2)),fe_mul(fe_mul(fe_imul(10,xr2),xr),xi2)),fe_mul(fe_mul(xr2,xr2),xr))),cr);
xin=fe_add(fe_diffabs(fe_add(fe_sub(fe_mul(fe_mul(Xi2,Xi2),Xi),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),Xr2)),fe_mul(fe_mul(fe_imul(5,Xi),Xr2),Xr2)),fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_mul(fe_mul(fe_imul(5,Xi2),Xi2),xi),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi2),Xi),xr),Xr)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xi2)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xr2)),fe_mul(fe_mul(fe_imul(30,Xi2),xi),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi2),xr),xi),Xr)),fe_mul(fe_mul(fe_imul(10,Xi2),xi2),xi)),fe_mul(fe_mul(fe_imul(30,Xi2),xr2),xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),xr),Xr2),Xr)),fe_mul(fe_mul(fe_imul(30,Xi),xi2),Xr2)),fe_mul(fe_mul(fe_imul(30,Xi),xr2),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi),xr),xi2),Xr)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),xr2),xr),Xr)),fe_mul(fe_mul(fe_imul(5,Xi),xi2),xi2)),fe_mul(fe_mul(fe_imul(30,Xi),xr2),xi2)),fe_mul(fe_mul(fe_imul(5,Xi),xr2),xr2)),fe_mul(fe_mul(fe_imul(5,xi),Xr2),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),xr),Xr2),Xr)),fe_mul(fe_mul(fe_imul(10,xi2),xi),Xr2)),fe_mul(fe_mul(fe_imul(30,xi),xr2),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi2),xi),xr),Xr)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),xr2),xr),Xr)),fe_mul(fe_mul(xi2,xi2),xi)),fe_mul(fe_mul(fe_imul(10,xi2),xi),xr2)),fe_mul(fe_mul(fe_imul(5,xi),xr2),xr2))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_2_5_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_diffabs(sf_add(sf_sub(sf_mul(sf_mul(sf_imul(5,Xr),Xi2),Xi2),sf_mul(sf_mul(sf_imul(10,Xr2),Xr),Xi2)),sf_mul(sf_mul(Xr2,Xr2),Xr)),sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_sub(sf_mul(sf_mul(sf_mul(sf_imul(20,Xr),xi),Xi2),Xi),sf_mul(sf_mul(sf_imul(30,Xr2),xr),Xi2)),sf_mul(sf_mul(sf_imul(30,Xr),xi2),Xi2)),sf_mul(sf_mul(sf_imul(30,Xr),xr2),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xr2),Xr),xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xr2),xr),xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xr),xi2),xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xr),xr2),xi),Xi)),sf_mul(sf_mul(sf_imul(5,Xr2),Xr2),xr)),sf_mul(sf_mul(sf_imul(10,Xr2),Xr),xi2)),sf_mul(sf_mul(sf_imul(10,Xr2),Xr),xr2)),sf_mul(sf_mul(sf_imul(30,Xr2),xr),xi2)),sf_mul(sf_mul(sf_imul(10,Xr2),xr2),xr)),sf_mul(sf_mul(sf_imul(5,Xr),xi2),xi2)),sf_mul(sf_mul(sf_imul(30,Xr),xr2),xi2)),sf_mul(sf_mul(sf_imul(5,Xr),xr2),xr2)),sf_mul(sf_mul(sf_imul(5,xr),Xi2),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xr),xi),Xi2),Xi)),sf_mul(sf_mul(sf_imul(30,xr),xi2),Xi2)),sf_mul(sf_mul(sf_imul(10,xr2),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xr),xi2),xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(20,xr2),xr),xi),Xi)),sf_mul(sf_mul(sf_imul(5,xr),xi2),xi2)),sf_mul(sf_mul(sf_imul(10,xr2),xr),xi2)),sf_mul(sf_mul(xr2,xr2),xr))),cr);
xin=sf_add(sf_diffabs(sf_add(sf_sub(sf_mul(sf_mul(Xi2,Xi2),Xi),sf_mul(sf_mul(sf_imul(10,Xi2),Xi),Xr2)),sf_mul(sf_mul(sf_imul(5,Xi),Xr2),Xr2)),sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_add(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_sub(sf_mul(sf_mul(sf_imul(5,Xi2),Xi2),xi),sf_mul(sf_mul(sf_mul(sf_imul(20,Xi2),Xi),xr),Xr)),sf_mul(sf_mul(sf_imul(10,Xi2),Xi),xi2)),sf_mul(sf_mul(sf_imul(10,Xi2),Xi),xr2)),sf_mul(sf_mul(sf_imul(30,Xi2),xi),Xr2)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xi2),xr),xi),Xr)),sf_mul(sf_mul(sf_imul(10,Xi2),xi2),xi)),sf_mul(sf_mul(sf_imul(30,Xi2),xr2),xi)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xi),xr),Xr2),Xr)),sf_mul(sf_mul(sf_imul(30,Xi),xi2),Xr2)),sf_mul(sf_mul(sf_imul(30,Xi),xr2),Xr2)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xi),xr),xi2),Xr)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xi),xr2),xr),Xr)),sf_mul(sf_mul(sf_imul(5,Xi),xi2),xi2)),sf_mul(sf_mul(sf_imul(30,Xi),xr2),xi2)),sf_mul(sf_mul(sf_imul(5,Xi),xr2),xr2)),sf_mul(sf_mul(sf_imul(5,xi),Xr2),Xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi),xr),Xr2),Xr)),sf_mul(sf_mul(sf_imul(10,xi2),xi),Xr2)),sf_mul(sf_mul(sf_imul(30,xi),xr2),Xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi2),xi),xr),Xr)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi),xr2),xr),Xr)),sf_mul(sf_mul(xi2,xi2),xi)),sf_mul(sf_mul(sf_imul(10,xi2),xi),xr2)),sf_mul(sf_mul(sf_imul(5,xi),xr2),xr2))),ci);
}

);
#endif


static const char *perturbation_opencl_double_3_2_0 = STR(

{xrn=d_add(d_diffabs(d_sub(d_mul(Xr,Xr),d_mul(Xi,Xi)),d_sub(d_mul(d_add(d_imul(2,Xr),xr),xr),d_mul(d_add(d_imul(2,Xi),xi),xi))),cr);
xin=d_add(d_add(d_mul(d_imul(2,Xr),xi),d_mul(d_imul(2,xr),d_add(Xi,xi))),ci);
}

);

static const char *perturbation_opencl_double_3_2_1 = STR(

{dxan=d_add(d_imul(2,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))),d_add(d_imul(-2,d_mul(Xxi,d_mul(dya,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))),daa));
dxbn=d_add(d_imul(2,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))),d_add(d_imul(-2,d_mul(Xxi,d_mul(dyb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))),dab));
dyan=d_add(d_imul(2,d_mul(Xxi,dxa)),d_add(d_imul(2,d_mul(Xxr,dya)),dba));
dybn=d_add(d_imul(2,d_mul(Xxi,dxb)),d_add(d_imul(2,d_mul(Xxr,dyb)),dbb));
}

{xrn=d_add(d_diffabs(d_sub(d_mul(Xr,Xr),d_mul(Xi,Xi)),d_sub(d_mul(d_add(d_imul(2,Xr),xr),xr),d_mul(d_add(d_imul(2,Xi),xi),xi))),cr);
xin=d_add(d_add(d_mul(d_imul(2,Xr),xi),d_mul(d_imul(2,xr),d_add(Xi,xi))),ci);
}

);

static const char *perturbation_opencl_floatexp_3_2_0 = STR(

{xrn=fe_add(fe_diffabs(fe_sub(fe_mul(Xr,Xr),fe_mul(Xi,Xi)),fe_sub(fe_mul(fe_add(fe_imul(2,Xr),xr),xr),fe_mul(fe_add(fe_imul(2,Xi),xi),xi))),cr);
xin=fe_add(fe_add(fe_mul(fe_imul(2,Xr),xi),fe_mul(fe_imul(2,xr),fe_add(Xi,xi))),ci);
}

);

static const char *perturbation_opencl_floatexp_3_2_1 = STR(

{dxan=fe_add(fe_imul(2,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))),fe_add(fe_imul(-2,fe_mul(Xxi,fe_mul(dya,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))),daa));
dxbn=fe_add(fe_imul(2,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))),fe_add(fe_imul(-2,fe_mul(Xxi,fe_mul(dyb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))),dab));
dyan=fe_add(fe_imul(2,fe_mul(Xxi,dxa)),fe_add(fe_imul(2,fe_mul(Xxr,dya)),dba));
dybn=fe_add(fe_imul(2,fe_mul(Xxi,dxb)),fe_add(fe_imul(2,fe_mul(Xxr,dyb)),dbb));
}

{xrn=fe_add(fe_diffabs(fe_sub(fe_mul(Xr,Xr),fe_mul(Xi,Xi)),fe_sub(fe_mul(fe_add(fe_imul(2,Xr),xr),xr),fe_mul(fe_add(fe_imul(2,Xi),xi),xi))),cr);
xin=fe_add(fe_add(fe_mul(fe_imul(2,Xr),xi),fe_mul(fe_imul(2,xr),fe_add(Xi,xi))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_3_2_0 = STR(

{xrn=sf_add(sf_diffabs(sf_sub(sf_mul(Xr,Xr),sf_mul(Xi,Xi)),sf_sub(sf_mul(sf_add(sf_imul(2,Xr),xr),xr),sf_mul(sf_add(sf_imul(2,Xi),xi),xi))),cr);
xin=sf_add(sf_add(sf_mul(sf_imul(2,Xr),xi),sf_mul(sf_imul(2,xr),sf_add(Xi,xi))),ci);
}

);
#endif


static const char *perturbation_opencl_double_3_3_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_diffabs(d_mul(Xr,d_sub(Xr2,d_imul(3,Xi2))),d_sub(d_add(d_mul(xr,d_add(d_imul(3,Xr2),xr2)),d_mul(d_imul(3,Xr),d_sub(d_sub(xr2,d_mul(d_imul(2,Xi),xi)),xi2))),d_mul(d_imul(3,xr),d_add(d_add(Xi2,d_mul(d_imul(2,Xi),xi)),xi2)))),cr);
xin=d_add(d_sub(d_add(d_mul(d_imul(3,Xi),d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),xi2)),d_mul(d_imul(3,xi),d_add(d_add(Xr2,d_mul(d_imul(2,Xr),xr)),xr2))),d_mul(xi,d_add(xi2,d_imul(3,Xi2)))),ci);
}

);

static const char *perturbation_opencl_double_3_3_1 = STR(

{dxan=d_add(d_imul(3,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_imul(-3,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr)))))))),d_add(d_imul(-3,d_mul(Xxi,d_mul(Xxi,d_mul(dxa,d_sgn(d_add(d_imul(-3,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr)))))))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_imul(-3,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr)))))))),daa)));
dxbn=d_add(d_imul(3,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_imul(-3,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr)))))))),d_add(d_imul(-3,d_mul(Xxi,d_mul(Xxi,d_mul(dxb,d_sgn(d_add(d_imul(-3,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr)))))))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_imul(-3,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr)))))))),dab)));
dyan=d_add(d_imul(3,d_mul(Xxr,d_mul(Xxr,dya))),d_add(d_imul(-3,d_mul(Xxi,d_mul(Xxi,dya))),d_add(d_imul(6,d_mul(Xxi,d_mul(Xxr,dxa))),dba)));
dybn=d_add(d_imul(3,d_mul(Xxr,d_mul(Xxr,dyb))),d_add(d_imul(-3,d_mul(Xxi,d_mul(Xxi,dyb))),d_add(d_imul(6,d_mul(Xxi,d_mul(Xxr,dxb))),dbb)));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_diffabs(d_mul(Xr,d_sub(Xr2,d_imul(3,Xi2))),d_sub(d_add(d_mul(xr,d_add(d_imul(3,Xr2),xr2)),d_mul(d_imul(3,Xr),d_sub(d_sub(xr2,d_mul(d_imul(2,Xi),xi)),xi2))),d_mul(d_imul(3,xr),d_add(d_add(Xi2,d_mul(d_imul(2,Xi),xi)),xi2)))),cr);
xin=d_add(d_sub(d_add(d_mul(d_imul(3,Xi),d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),xi2)),d_mul(d_imul(3,xi),d_add(d_add(Xr2,d_mul(d_imul(2,Xr),xr)),xr2))),d_mul(xi,d_add(xi2,d_imul(3,Xi2)))),ci);
}

);

static const char *perturbation_opencl_floatexp_3_3_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_mul(Xr,fe_sub(Xr2,fe_imul(3,Xi2))),fe_sub(fe_add(fe_mul(xr,fe_add(fe_imul(3,Xr2),xr2)),fe_mul(fe_imul(3,Xr),fe_sub(fe_sub(xr2,fe_mul(fe_imul(2,Xi),xi)),xi2))),fe_mul(fe_imul(3,xr),fe_add(fe_add(Xi2,fe_mul(fe_imul(2,Xi),xi)),xi2)))),cr);
xin=fe_add(fe_sub(fe_add(fe_mul(fe_imul(3,Xi),fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),xi2)),fe_mul(fe_imul(3,xi),fe_add(fe_add(Xr2,fe_mul(fe_imul(2,Xr),xr)),xr2))),fe_mul(xi,fe_add(xi2,fe_imul(3,Xi2)))),ci);
}

);

static const char *perturbation_opencl_floatexp_3_3_1 = STR(

{dxan=fe_add(fe_imul(3,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_imul(-3,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(-3,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxa,fe_sgn(fe_add(fe_imul(-3,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_imul(-3,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))),daa)));
dxbn=fe_add(fe_imul(3,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_imul(-3,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(-3,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxb,fe_sgn(fe_add(fe_imul(-3,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_imul(-3,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))),dab)));
dyan=fe_add(fe_imul(3,fe_mul(Xxr,fe_mul(Xxr,dya))),fe_add(fe_imul(-3,fe_mul(Xxi,fe_mul(Xxi,dya))),fe_add(fe_imul(6,fe_mul(Xxi,fe_mul(Xxr,dxa))),dba)));
dybn=fe_add(fe_imul(3,fe_mul(Xxr,fe_mul(Xxr,dyb))),fe_add(fe_imul(-3,fe_mul(Xxi,fe_mul(Xxi,dyb))),fe_add(fe_imul(6,fe_mul(Xxi,fe_mul(Xxr,dxb))),dbb)));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_mul(Xr,fe_sub(Xr2,fe_imul(3,Xi2))),fe_sub(fe_add(fe_mul(xr,fe_add(fe_imul(3,Xr2),xr2)),fe_mul(fe_imul(3,Xr),fe_sub(fe_sub(xr2,fe_mul(fe_imul(2,Xi),xi)),xi2))),fe_mul(fe_imul(3,xr),fe_add(fe_add(Xi2,fe_mul(fe_imul(2,Xi),xi)),xi2)))),cr);
xin=fe_add(fe_sub(fe_add(fe_mul(fe_imul(3,Xi),fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),xi2)),fe_mul(fe_imul(3,xi),fe_add(fe_add(Xr2,fe_mul(fe_imul(2,Xr),xr)),xr2))),fe_mul(xi,fe_add(xi2,fe_imul(3,Xi2)))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_3_3_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_diffabs(sf_mul(Xr,sf_sub(Xr2,sf_imul(3,Xi2))),sf_sub(sf_add(sf_mul(xr,sf_add(sf_imul(3,Xr2),xr2)),sf_mul(sf_imul(3,Xr),sf_sub(sf_sub(xr2,sf_mul(sf_imul(2,Xi),xi)),xi2))),sf_mul(sf_imul(3,xr),sf_add(sf_add(Xi2,sf_mul(sf_imul(2,Xi),xi)),xi2)))),cr);
xin=sf_add(sf_sub(sf_add(sf_mul(sf_imul(3,Xi),sf_sub(sf_add(sf_mul(sf_imul(2,Xr),xr),xr2),xi2)),sf_mul(sf_imul(3,xi),sf_add(sf_add(Xr2,sf_mul(sf_imul(2,Xr),xr)),xr2))),sf_mul(xi,sf_add(xi2,sf_imul(3,Xi2)))),ci);
}

);
#endif


static const char *perturbation_opencl_double_3_4_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_diffabs(d_sub(d_add(d_mul(Xr2,Xr2),d_mul(Xi2,Xi2)),d_mul(d_imul(6,Xr2),Xi2)),d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,xr),Xr),Xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xi),Xr2),Xi)),d_mul(d_mul(d_mul(d_imul(24,xr),xi),Xr),Xi)),d_mul(d_mul(d_imul(12,xr2),xi),Xi)),d_mul(d_imul(6,xi2),Xr2)),d_mul(d_mul(d_imul(12,xr),xi2),Xr)),d_mul(d_imul(6,xr2),xi2))),cr);
xin=d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_add(d_add(d_add(d_sub(d_sub(d_add(d_mul(d_mul(d_imul(12,Xr2),Xi),xr),d_mul(d_mul(d_imul(12,Xr),Xi),xr2)),d_mul(d_mul(d_imul(12,Xr),Xi2),xi)),d_mul(d_mul(d_imul(12,Xr),Xi),xi2)),d_mul(d_mul(d_imul(4,Xr2),Xr),xi)),d_mul(d_mul(d_imul(12,Xr2),xi),xr)),d_mul(d_mul(d_imul(12,Xr),xi),xr2)),d_mul(d_mul(d_imul(4,Xr),xi2),xi)),d_mul(d_mul(d_imul(4,xr2),xr),Xi)),d_mul(d_mul(d_imul(4,xr),Xi2),Xi)),d_mul(d_mul(d_imul(12,xr),Xi2),xi)),d_mul(d_mul(d_imul(12,xr),Xi),xi2)),d_mul(d_mul(d_imul(4,xr2),xr),xi)),d_mul(d_mul(d_imul(4,xr),xi2),xi)),ci);
}

);

static const char *perturbation_opencl_double_3_4_1 = STR(

{dxan=d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dya,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),daa))));
dxbn=d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dyb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),dab))));
dyan=d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dya)))),d_add(d_imul(-4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dxa)))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,dya)))),d_add(d_imul(12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,dxa)))),dba))));
dybn=d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dyb)))),d_add(d_imul(-4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dxb)))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,dyb)))),d_add(d_imul(12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,dxb)))),dbb))));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_diffabs(d_sub(d_add(d_mul(Xr2,Xr2),d_mul(Xi2,Xi2)),d_mul(d_imul(6,Xr2),Xi2)),d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,xr),Xr),Xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xi),Xr2),Xi)),d_mul(d_mul(d_mul(d_imul(24,xr),xi),Xr),Xi)),d_mul(d_mul(d_imul(12,xr2),xi),Xi)),d_mul(d_imul(6,xi2),Xr2)),d_mul(d_mul(d_imul(12,xr),xi2),Xr)),d_mul(d_imul(6,xr2),xi2))),cr);
xin=d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_add(d_add(d_add(d_sub(d_sub(d_add(d_mul(d_mul(d_imul(12,Xr2),Xi),xr),d_mul(d_mul(d_imul(12,Xr),Xi),xr2)),d_mul(d_mul(d_imul(12,Xr),Xi2),xi)),d_mul(d_mul(d_imul(12,Xr),Xi),xi2)),d_mul(d_mul(d_imul(4,Xr2),Xr),xi)),d_mul(d_mul(d_imul(12,Xr2),xi),xr)),d_mul(d_mul(d_imul(12,Xr),xi),xr2)),d_mul(d_mul(d_imul(4,Xr),xi2),xi)),d_mul(d_mul(d_imul(4,xr2),xr),Xi)),d_mul(d_mul(d_imul(4,xr),Xi2),Xi)),d_mul(d_mul(d_imul(12,xr),Xi2),xi)),d_mul(d_mul(d_imul(12,xr),Xi),xi2)),d_mul(d_mul(d_imul(4,xr2),xr),xi)),d_mul(d_mul(d_imul(4,xr),xi2),xi)),ci);
}

);

static const char *perturbation_opencl_floatexp_3_4_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_add(fe_mul(Xr2,Xr2),fe_mul(Xi2,Xi2)),fe_mul(fe_imul(6,Xr2),Xi2)),fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,xr),Xr),Xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xi),Xr2),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(24,xr),xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(12,xr2),xi),Xi)),fe_mul(fe_imul(6,xi2),Xr2)),fe_mul(fe_mul(fe_imul(12,xr),xi2),Xr)),fe_mul(fe_imul(6,xr2),xi2))),cr);
xin=fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_add(fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xr),fe_mul(fe_mul(fe_imul(12,Xr),Xi),xr2)),fe_mul(fe_mul(fe_imul(12,Xr),Xi2),xi)),fe_mul(fe_mul(fe_imul(12,Xr),Xi),xi2)),fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xi)),fe_mul(fe_mul(fe_imul(12,Xr2),xi),xr)),fe_mul(fe_mul(fe_imul(12,Xr),xi),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xi2),xi)),fe_mul(fe_mul(fe_imul(4,xr2),xr),Xi)),fe_mul(fe_mul(fe_imul(4,xr),Xi2),Xi)),fe_mul(fe_mul(fe_imul(12,xr),Xi2),xi)),fe_mul(fe_mul(fe_imul(12,xr),Xi),xi2)),fe_mul(fe_mul(fe_imul(4,xr2),xr),xi)),fe_mul(fe_mul(fe_imul(4,xr),xi2),xi)),ci);
}

);

static const char *perturbation_opencl_floatexp_3_4_1 = STR(

{dxan=fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dya,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),daa))));
dxbn=fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dyb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),dab))));
dyan=fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dya)))),fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dxa)))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,dya)))),fe_add(fe_imul(12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,dxa)))),dba))));
dybn=fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dyb)))),fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dxb)))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,dyb)))),fe_add(fe_imul(12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,dxb)))),dbb))));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_add(fe_mul(Xr2,Xr2),fe_mul(Xi2,Xi2)),fe_mul(fe_imul(6,Xr2),Xi2)),fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,xr),Xr),Xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xi),Xr2),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(24,xr),xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(12,xr2),xi),Xi)),fe_mul(fe_imul(6,xi2),Xr2)),fe_mul(fe_mul(fe_imul(12,xr),xi2),Xr)),fe_mul(fe_imul(6,xr2),xi2))),cr);
xin=fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_add(fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xr),fe_mul(fe_mul(fe_imul(12,Xr),Xi),xr2)),fe_mul(fe_mul(fe_imul(12,Xr),Xi2),xi)),fe_mul(fe_mul(fe_imul(12,Xr),Xi),xi2)),fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xi)),fe_mul(fe_mul(fe_imul(12,Xr2),xi),xr)),fe_mul(fe_mul(fe_imul(12,Xr),xi),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xi2),xi)),fe_mul(fe_mul(fe_imul(4,xr2),xr),Xi)),fe_mul(fe_mul(fe_imul(4,xr),Xi2),Xi)),fe_mul(fe_mul(fe_imul(12,xr),Xi2),xi)),fe_mul(fe_mul(fe_imul(12,xr),Xi),xi2)),fe_mul(fe_mul(fe_imul(4,xr2),xr),xi)),fe_mul(fe_mul(fe_imul(4,xr),xi2),xi)),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_3_4_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_diffabs(sf_sub(sf_add(sf_mul(Xr2,Xr2),sf_mul(Xi2,Xi2)),sf_mul(sf_imul(6,Xr2),Xi2)),sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_mul(sf_imul(4,Xi),xi2),xi)),sf_mul(xi2,xi2)),sf_mul(sf_mul(sf_imul(12,xr),Xr),Xi2)),sf_mul(sf_imul(6,xr2),Xi2)),sf_mul(sf_mul(sf_imul(12,xi),Xr2),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(24,xr),xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(12,xr2),xi),Xi)),sf_mul(sf_imul(6,xi2),Xr2)),sf_mul(sf_mul(sf_imul(12,xr),xi2),Xr)),sf_mul(sf_imul(6,xr2),xi2))),cr);
xin=sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_sub(sf_add(sf_add(sf_add(sf_sub(sf_sub(sf_add(sf_mul(sf_mul(sf_imul(12,Xr2),Xi),xr),sf_mul(sf_mul(sf_imul(12,Xr),Xi),xr2)),sf_mul(sf_mul(sf_imul(12,Xr),Xi2),xi)),sf_mul(sf_mul(sf_imul(12,Xr),Xi),xi2)),sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xi)),sf_mul(sf_mul(sf_imul(12,Xr2),xi),xr)),sf_mul(sf_mul(sf_imul(12,Xr),xi),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xi2),xi)),sf_mul(sf_mul(sf_imul(4,xr2),xr),Xi)),sf_mul(sf_mul(sf_imul(4,xr),Xi2),Xi)),sf_mul(sf_mul(sf_imul(12,xr),Xi2),xi)),sf_mul(sf_mul(sf_imul(12,xr),Xi),xi2)),sf_mul(sf_mul(sf_imul(4,xr2),xr),xi)),sf_mul(sf_mul(sf_imul(4,xr),xi2),xi)),ci);
}

);
#endif


static const char *perturbation_opencl_double_3_5_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_diffabs(d_add(d_sub(d_mul(d_mul(Xr2,Xr2),Xr),d_mul(d_mul(d_imul(10,Xr2),Xr),Xi2)),d_mul(d_mul(d_imul(5,Xr),Xi2),Xi2)),d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_add(d_add(d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_mul(d_mul(d_mul(d_imul(20,Xr),xi),Xi2),Xi),d_mul(d_mul(d_imul(30,Xr2),xr),Xi2)),d_mul(d_mul(d_imul(30,Xr),xi2),Xi2)),d_mul(d_mul(d_imul(30,Xr),xr2),Xi2)),d_mul(d_mul(d_mul(d_imul(20,Xr2),Xr),xi),Xi)),d_mul(d_mul(d_mul(d_imul(60,Xr2),xr),xi),Xi)),d_mul(d_mul(d_mul(d_imul(20,Xr),xi2),xi),Xi)),d_mul(d_mul(d_mul(d_imul(60,Xr),xr2),xi),Xi)),d_mul(d_mul(d_imul(5,Xr2),Xr2),xr)),d_mul(d_mul(d_imul(10,Xr2),Xr),xi2)),d_mul(d_mul(d_imul(10,Xr2),Xr),xr2)),d_mul(d_mul(d_imul(30,Xr2),xr),xi2)),d_mul(d_mul(d_imul(10,Xr2),xr2),xr)),d_mul(d_mul(d_imul(5,Xr),xi2),xi2)),d_mul(d_mul(d_imul(30,Xr),xr2),xi2)),d_mul(d_mul(d_imul(5,Xr),xr2),xr2)),d_mul(d_mul(d_imul(5,xr),Xi2),Xi2)),d_mul(d_mul(d_mul(d_imul(20,xr),xi),Xi2),Xi)),d_mul(d_mul(d_imul(30,xr),xi2),Xi2)),d_mul(d_mul(d_imul(10,xr2),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(20,xr),xi2),xi),Xi)),d_mul(d_mul(d_mul(d_imul(20,xr2),xr),xi),Xi)),d_mul(d_mul(d_imul(5,xr),xi2),xi2)),d_mul(d_mul(d_imul(10,xr2),xr),xi2)),d_mul(d_mul(xr2,xr2),xr))),cr);
xin=d_add(d_add(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_mul(d_mul(d_mul(d_imul(20,Xi),Xr2),Xr),xr),d_mul(d_mul(d_imul(30,Xi),Xr2),xr2)),d_mul(d_mul(d_mul(d_imul(20,Xi),Xr),xr2),xr)),d_mul(d_mul(d_imul(5,Xi),xr2),xr2)),d_mul(d_mul(d_imul(30,Xi2),Xr2),xi)),d_mul(d_mul(d_imul(30,Xi),Xr2),xi2)),d_mul(d_mul(d_mul(d_imul(20,Xi2),Xi),Xr),xr)),d_mul(d_mul(d_mul(d_imul(60,Xi2),Xr),xr),xi)),d_mul(d_mul(d_mul(d_imul(60,Xi),Xr),xr),xi2)),d_mul(d_mul(d_imul(10,Xi2),Xi),xr2)),d_mul(d_mul(d_imul(30,Xi2),xr2),xi)),d_mul(d_mul(d_imul(30,Xi),xr2),xi2)),d_mul(d_mul(d_imul(5,Xi2),Xi2),xi)),d_mul(d_mul(d_imul(10,Xi2),Xi),xi2)),d_mul(d_mul(d_imul(10,Xi2),xi2),xi)),d_mul(d_mul(d_imul(5,Xi),xi2),xi2)),d_mul(d_mul(d_imul(5,xi),Xr2),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi),Xr2),Xr),xr)),d_mul(d_mul(d_imul(30,xi),Xr2),xr2)),d_mul(d_mul(d_mul(d_imul(20,xi),Xr),xr2),xr)),d_mul(d_mul(d_imul(5,xi),xr2),xr2)),d_mul(d_mul(d_imul(10,xi2),xi),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi2),xi),Xr),xr)),d_mul(d_mul(d_imul(10,xi2),xi),xr2)),d_mul(d_mul(xi2,xi2),xi)),ci);
}

);

static const char *perturbation_opencl_double_3_5_1 = STR(

{dxan=d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxa,d_sgn(d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr))))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_add(d_imul(5,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr))))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_add(d_imul(-20,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr))))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_add(d_imul(20,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr))))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_add(d_imul(-30,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr))))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),daa)))));
dxbn=d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxb,d_sgn(d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr))))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_add(d_imul(5,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr))))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_add(d_imul(-20,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr))))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_add(d_imul(20,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr))))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_add(d_imul(-30,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr))))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),dab)))));
dyan=d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dya))))),d_add(d_imul(5,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dya))))),d_add(d_imul(20,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dxa))))),d_add(d_imul(-20,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,dxa))))),d_add(d_imul(-30,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,dya))))),dba)))));
dybn=d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dyb))))),d_add(d_imul(5,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dyb))))),d_add(d_imul(20,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dxb))))),d_add(d_imul(-20,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,dxb))))),d_add(d_imul(-30,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,dyb))))),dbb)))));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_diffabs(d_add(d_sub(d_mul(d_mul(Xr2,Xr2),Xr),d_mul(d_mul(d_imul(10,Xr2),Xr),Xi2)),d_mul(d_mul(d_imul(5,Xr),Xi2),Xi2)),d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_add(d_add(d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_mul(d_mul(d_mul(d_imul(20,Xr),xi),Xi2),Xi),d_mul(d_mul(d_imul(30,Xr2),xr),Xi2)),d_mul(d_mul(d_imul(30,Xr),xi2),Xi2)),d_mul(d_mul(d_imul(30,Xr),xr2),Xi2)),d_mul(d_mul(d_mul(d_imul(20,Xr2),Xr),xi),Xi)),d_mul(d_mul(d_mul(d_imul(60,Xr2),xr),xi),Xi)),d_mul(d_mul(d_mul(d_imul(20,Xr),xi2),xi),Xi)),d_mul(d_mul(d_mul(d_imul(60,Xr),xr2),xi),Xi)),d_mul(d_mul(d_imul(5,Xr2),Xr2),xr)),d_mul(d_mul(d_imul(10,Xr2),Xr),xi2)),d_mul(d_mul(d_imul(10,Xr2),Xr),xr2)),d_mul(d_mul(d_imul(30,Xr2),xr),xi2)),d_mul(d_mul(d_imul(10,Xr2),xr2),xr)),d_mul(d_mul(d_imul(5,Xr),xi2),xi2)),d_mul(d_mul(d_imul(30,Xr),xr2),xi2)),d_mul(d_mul(d_imul(5,Xr),xr2),xr2)),d_mul(d_mul(d_imul(5,xr),Xi2),Xi2)),d_mul(d_mul(d_mul(d_imul(20,xr),xi),Xi2),Xi)),d_mul(d_mul(d_imul(30,xr),xi2),Xi2)),d_mul(d_mul(d_imul(10,xr2),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(20,xr),xi2),xi),Xi)),d_mul(d_mul(d_mul(d_imul(20,xr2),xr),xi),Xi)),d_mul(d_mul(d_imul(5,xr),xi2),xi2)),d_mul(d_mul(d_imul(10,xr2),xr),xi2)),d_mul(d_mul(xr2,xr2),xr))),cr);
xin=d_add(d_add(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_mul(d_mul(d_mul(d_imul(20,Xi),Xr2),Xr),xr),d_mul(d_mul(d_imul(30,Xi),Xr2),xr2)),d_mul(d_mul(d_mul(d_imul(20,Xi),Xr),xr2),xr)),d_mul(d_mul(d_imul(5,Xi),xr2),xr2)),d_mul(d_mul(d_imul(30,Xi2),Xr2),xi)),d_mul(d_mul(d_imul(30,Xi),Xr2),xi2)),d_mul(d_mul(d_mul(d_imul(20,Xi2),Xi),Xr),xr)),d_mul(d_mul(d_mul(d_imul(60,Xi2),Xr),xr),xi)),d_mul(d_mul(d_mul(d_imul(60,Xi),Xr),xr),xi2)),d_mul(d_mul(d_imul(10,Xi2),Xi),xr2)),d_mul(d_mul(d_imul(30,Xi2),xr2),xi)),d_mul(d_mul(d_imul(30,Xi),xr2),xi2)),d_mul(d_mul(d_imul(5,Xi2),Xi2),xi)),d_mul(d_mul(d_imul(10,Xi2),Xi),xi2)),d_mul(d_mul(d_imul(10,Xi2),xi2),xi)),d_mul(d_mul(d_imul(5,Xi),xi2),xi2)),d_mul(d_mul(d_imul(5,xi),Xr2),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi),Xr2),Xr),xr)),d_mul(d_mul(d_imul(30,xi),Xr2),xr2)),d_mul(d_mul(d_mul(d_imul(20,xi),Xr),xr2),xr)),d_mul(d_mul(d_imul(5,xi),xr2),xr2)),d_mul(d_mul(d_imul(10,xi2),xi),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi2),xi),Xr),xr)),d_mul(d_mul(d_imul(10,xi2),xi),xr2)),d_mul(d_mul(xi2,xi2),xi)),ci);
}

);

static const char *perturbation_opencl_floatexp_3_5_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_add(fe_sub(fe_mul(fe_mul(Xr2,Xr2),Xr),fe_mul(fe_mul(fe_imul(10,Xr2),Xr),Xi2)),fe_mul(fe_mul(fe_imul(5,Xr),Xi2),Xi2)),fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),xi),Xi2),Xi),fe_mul(fe_mul(fe_imul(30,Xr2),xr),Xi2)),fe_mul(fe_mul(fe_imul(30,Xr),xi2),Xi2)),fe_mul(fe_mul(fe_imul(30,Xr),xr2),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr2),Xr),xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xr2),xr),xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),xi2),xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xr),xr2),xi),Xi)),fe_mul(fe_mul(fe_imul(5,Xr2),Xr2),xr)),fe_mul(fe_mul(fe_imul(10,Xr2),Xr),xi2)),fe_mul(fe_mul(fe_imul(10,Xr2),Xr),xr2)),fe_mul(fe_mul(fe_imul(30,Xr2),xr),xi2)),fe_mul(fe_mul(fe_imul(10,Xr2),xr2),xr)),fe_mul(fe_mul(fe_imul(5,Xr),xi2),xi2)),fe_mul(fe_mul(fe_imul(30,Xr),xr2),xi2)),fe_mul(fe_mul(fe_imul(5,Xr),xr2),xr2)),fe_mul(fe_mul(fe_imul(5,xr),Xi2),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr),xi),Xi2),Xi)),fe_mul(fe_mul(fe_imul(30,xr),xi2),Xi2)),fe_mul(fe_mul(fe_imul(10,xr2),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr),xi2),xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr2),xr),xi),Xi)),fe_mul(fe_mul(fe_imul(5,xr),xi2),xi2)),fe_mul(fe_mul(fe_imul(10,xr2),xr),xi2)),fe_mul(fe_mul(xr2,xr2),xr))),cr);
xin=fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),Xr2),Xr),xr),fe_mul(fe_mul(fe_imul(30,Xi),Xr2),xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),Xr),xr2),xr)),fe_mul(fe_mul(fe_imul(5,Xi),xr2),xr2)),fe_mul(fe_mul(fe_imul(30,Xi2),Xr2),xi)),fe_mul(fe_mul(fe_imul(30,Xi),Xr2),xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi2),Xi),Xr),xr)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi2),Xr),xr),xi)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi),Xr),xr),xi2)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xr2)),fe_mul(fe_mul(fe_imul(30,Xi2),xr2),xi)),fe_mul(fe_mul(fe_imul(30,Xi),xr2),xi2)),fe_mul(fe_mul(fe_imul(5,Xi2),Xi2),xi)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xi2)),fe_mul(fe_mul(fe_imul(10,Xi2),xi2),xi)),fe_mul(fe_mul(fe_imul(5,Xi),xi2),xi2)),fe_mul(fe_mul(fe_imul(5,xi),Xr2),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),Xr2),Xr),xr)),fe_mul(fe_mul(fe_imul(30,xi),Xr2),xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),Xr),xr2),xr)),fe_mul(fe_mul(fe_imul(5,xi),xr2),xr2)),fe_mul(fe_mul(fe_imul(10,xi2),xi),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi2),xi),Xr),xr)),fe_mul(fe_mul(fe_imul(10,xi2),xi),xr2)),fe_mul(fe_mul(xi2,xi2),xi)),ci);
}

);

static const char *perturbation_opencl_floatexp_3_5_1 = STR(

{dxan=fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxa,fe_sgn(fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr))))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_add(fe_imul(5,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr))))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_add(fe_imul(-20,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr))))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_add(fe_imul(20,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr))))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_add(fe_imul(-30,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr))))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),daa)))));
dxbn=fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxb,fe_sgn(fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr))))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_add(fe_imul(5,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr))))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_add(fe_imul(-20,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr))))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_add(fe_imul(20,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr))))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_add(fe_imul(-30,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr))))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),dab)))));
dyan=fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dya))))),fe_add(fe_imul(5,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dya))))),fe_add(fe_imul(20,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dxa))))),fe_add(fe_imul(-20,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,dxa))))),fe_add(fe_imul(-30,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,dya))))),dba)))));
dybn=fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dyb))))),fe_add(fe_imul(5,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dyb))))),fe_add(fe_imul(20,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dxb))))),fe_add(fe_imul(-20,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,dxb))))),fe_add(fe_imul(-30,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,dyb))))),dbb)))));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_add(fe_sub(fe_mul(fe_mul(Xr2,Xr2),Xr),fe_mul(fe_mul(fe_imul(10,Xr2),Xr),Xi2)),fe_mul(fe_mul(fe_imul(5,Xr),Xi2),Xi2)),fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),xi),Xi2),Xi),fe_mul(fe_mul(fe_imul(30,Xr2),xr),Xi2)),fe_mul(fe_mul(fe_imul(30,Xr),xi2),Xi2)),fe_mul(fe_mul(fe_imul(30,Xr),xr2),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr2),Xr),xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xr2),xr),xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),xi2),xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xr),xr2),xi),Xi)),fe_mul(fe_mul(fe_imul(5,Xr2),Xr2),xr)),fe_mul(fe_mul(fe_imul(10,Xr2),Xr),xi2)),fe_mul(fe_mul(fe_imul(10,Xr2),Xr),xr2)),fe_mul(fe_mul(fe_imul(30,Xr2),xr),xi2)),fe_mul(fe_mul(fe_imul(10,Xr2),xr2),xr)),fe_mul(fe_mul(fe_imul(5,Xr),xi2),xi2)),fe_mul(fe_mul(fe_imul(30,Xr),xr2),xi2)),fe_mul(fe_mul(fe_imul(5,Xr),xr2),xr2)),fe_mul(fe_mul(fe_imul(5,xr),Xi2),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr),xi),Xi2),Xi)),fe_mul(fe_mul(fe_imul(30,xr),xi2),Xi2)),fe_mul(fe_mul(fe_imul(10,xr2),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr),xi2),xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr2),xr),xi),Xi)),fe_mul(fe_mul(fe_imul(5,xr),xi2),xi2)),fe_mul(fe_mul(fe_imul(10,xr2),xr),xi2)),fe_mul(fe_mul(xr2,xr2),xr))),cr);
xin=fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),Xr2),Xr),xr),fe_mul(fe_mul(fe_imul(30,Xi),Xr2),xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),Xr),xr2),xr)),fe_mul(fe_mul(fe_imul(5,Xi),xr2),xr2)),fe_mul(fe_mul(fe_imul(30,Xi2),Xr2),xi)),fe_mul(fe_mul(fe_imul(30,Xi),Xr2),xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi2),Xi),Xr),xr)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi2),Xr),xr),xi)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi),Xr),xr),xi2)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xr2)),fe_mul(fe_mul(fe_imul(30,Xi2),xr2),xi)),fe_mul(fe_mul(fe_imul(30,Xi),xr2),xi2)),fe_mul(fe_mul(fe_imul(5,Xi2),Xi2),xi)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xi2)),fe_mul(fe_mul(fe_imul(10,Xi2),xi2),xi)),fe_mul(fe_mul(fe_imul(5,Xi),xi2),xi2)),fe_mul(fe_mul(fe_imul(5,xi),Xr2),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),Xr2),Xr),xr)),fe_mul(fe_mul(fe_imul(30,xi),Xr2),xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),Xr),xr2),xr)),fe_mul(fe_mul(fe_imul(5,xi),xr2),xr2)),fe_mul(fe_mul(fe_imul(10,xi2),xi),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi2),xi),Xr),xr)),fe_mul(fe_mul(fe_imul(10,xi2),xi),xr2)),fe_mul(fe_mul(xi2,xi2),xi)),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_3_5_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_diffabs(sf_add(sf_sub(sf_mul(sf_mul(Xr2,Xr2),Xr),sf_mul(sf_mul(sf_imul(10,Xr2),Xr),Xi2)),sf_mul(sf_mul(sf_imul(5,Xr),Xi2),Xi2)),sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_sub(sf_mul(sf_mul(sf_mul(sf_imul(20,Xr),xi),Xi2),Xi),sf_mul(sf_mul(sf_imul(30,Xr2),xr),Xi2)),sf_mul(sf_mul(sf_imul(30,Xr),xi2),Xi2)),sf_mul(sf_mul(sf_imul(30,Xr),xr2),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xr2),Xr),xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xr2),xr),xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xr),xi2),xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xr),xr2),xi),Xi)),sf_mul(sf_mul(sf_imul(5,Xr2),Xr2),xr)),sf_mul(sf_mul(sf_imul(10,Xr2),Xr),xi2)),sf_mul(sf_mul(sf_imul(10,Xr2),Xr),xr2)),sf_mul(sf_mul(sf_imul(30,Xr2),xr),xi2)),sf_mul(sf_mul(sf_imul(10,Xr2),xr2),xr)),sf_mul(sf_mul(sf_imul(5,Xr),xi2),xi2)),sf_mul(sf_mul(sf_imul(30,Xr),xr2),xi2)),sf_mul(sf_mul(sf_imul(5,Xr),xr2),xr2)),sf_mul(sf_mul(sf_imul(5,xr),Xi2),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xr),xi),Xi2),Xi)),sf_mul(sf_mul(sf_imul(30,xr),xi2),Xi2)),sf_mul(sf_mul(sf_imul(10,xr2),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xr),xi2),xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(20,xr2),xr),xi),Xi)),sf_mul(sf_mul(sf_imul(5,xr),xi2),xi2)),sf_mul(sf_mul(sf_imul(10,xr2),xr),xi2)),sf_mul(sf_mul(xr2,xr2),xr))),cr);
xin=sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_mul(sf_imul(20,Xi),Xr2),Xr),xr),sf_mul(sf_mul(sf_imul(30,Xi),Xr2),xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xi),Xr),xr2),xr)),sf_mul(sf_mul(sf_imul(5,Xi),xr2),xr2)),sf_mul(sf_mul(sf_imul(30,Xi2),Xr2),xi)),sf_mul(sf_mul(sf_imul(30,Xi),Xr2),xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xi2),Xi),Xr),xr)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xi2),Xr),xr),xi)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xi),Xr),xr),xi2)),sf_mul(sf_mul(sf_imul(10,Xi2),Xi),xr2)),sf_mul(sf_mul(sf_imul(30,Xi2),xr2),xi)),sf_mul(sf_mul(sf_imul(30,Xi),xr2),xi2)),sf_mul(sf_mul(sf_imul(5,Xi2),Xi2),xi)),sf_mul(sf_mul(sf_imul(10,Xi2),Xi),xi2)),sf_mul(sf_mul(sf_imul(10,Xi2),xi2),xi)),sf_mul(sf_mul(sf_imul(5,Xi),xi2),xi2)),sf_mul(sf_mul(sf_imul(5,xi),Xr2),Xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi),Xr2),Xr),xr)),sf_mul(sf_mul(sf_imul(30,xi),Xr2),xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi),Xr),xr2),xr)),sf_mul(sf_mul(sf_imul(5,xi),xr2),xr2)),sf_mul(sf_mul(sf_imul(10,xi2),xi),Xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi2),xi),Xr),xr)),sf_mul(sf_mul(sf_imul(10,xi2),xi),xr2)),sf_mul(sf_mul(xi2,xi2),xi)),ci);
}

);
#endif


static const char *perturbation_opencl_double_4_2_0 = STR(

{const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_sub(d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),xi2),d_mul(d_imul(2,xi),Xi)),cr);
xin=d_sub(ci,d_imul(2,d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi))));
}

);

static const char *perturbation_opencl_double_4_2_1 = STR(

{dxan=d_add(d_imul(-2,d_mul(Xxi,dya)),d_add(d_imul(2,d_mul(Xxr,dxa)),daa));
dxbn=d_add(d_imul(-2,d_mul(Xxi,dyb)),d_add(d_imul(2,d_mul(Xxr,dxb)),dab));
dyan=d_add(d_imul(-2,d_mul(Xxi,dxa)),d_add(d_imul(-2,d_mul(Xxr,dya)),dba));
dybn=d_add(d_imul(-2,d_mul(Xxi,dxb)),d_add(d_imul(-2,d_mul(Xxr,dyb)),dbb));
}

{const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_sub(d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),xi2),d_mul(d_imul(2,xi),Xi)),cr);
xin=d_sub(ci,d_imul(2,d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi))));
}

);

static const char *perturbation_opencl_floatexp_4_2_0 = STR(

{const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),xi2),fe_mul(fe_imul(2,xi),Xi)),cr);
xin=fe_sub(ci,fe_imul(2,fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi))));
}

);

static const char *perturbation_opencl_floatexp_4_2_1 = STR(

{dxan=fe_add(fe_imul(-2,fe_mul(Xxi,dya)),fe_add(fe_imul(2,fe_mul(Xxr,dxa)),daa));
dxbn=fe_add(fe_imul(-2,fe_mul(Xxi,dyb)),fe_add(fe_imul(2,fe_mul(Xxr,dxb)),dab));
dyan=fe_add(fe_imul(-2,fe_mul(Xxi,dxa)),fe_add(fe_imul(-2,fe_mul(Xxr,dya)),dba));
dybn=fe_add(fe_imul(-2,fe_mul(Xxi,dxb)),fe_add(fe_imul(-2,fe_mul(Xxr,dyb)),dbb));
}

{const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),xi2),fe_mul(fe_imul(2,xi),Xi)),cr);
xin=fe_sub(ci,fe_imul(2,fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi))));
}

);

#if 0
static const char *perturbation_opencl_softfloat_4_2_0 = STR(

{const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_sub(sf_sub(sf_add(sf_mul(sf_imul(2,Xr),xr),xr2),xi2),sf_mul(sf_imul(2,xi),Xi)),cr);
xin=sf_sub(ci,sf_imul(2,sf_add(sf_add(sf_mul(Xr,xi),sf_mul(xr,Xi)),sf_mul(xr,xi))));
}

);
#endif


static const char *perturbation_opencl_double_4_3_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_add(d_sub(cr,d_mul(xr,d_add(d_imul(3,Xr2),xr2))),d_mul(d_imul(3,Xr),d_sub(d_add(xi2,d_mul(d_imul(2,Xi),xi)),xr2))),d_mul(d_imul(3,xr),d_add(d_add(Xi2,d_mul(d_imul(2,Xi),xi)),xi2)));
xin=d_add(d_sub(d_add(d_add(d_add(d_sub(d_sub(d_add(d_mul(d_mul(d_imul(6,Xr),Xi),xr),d_mul(d_imul(3,Xi),xr2)),d_mul(d_imul(3,Xi2),xi)),d_mul(d_imul(3,Xi),xi2)),d_mul(d_imul(3,Xr2),xi)),d_mul(d_mul(d_imul(6,Xr),xr),xi)),d_mul(d_imul(3,xr2),xi)),d_mul(xi2,xi)),ci);
}

);

static const char *perturbation_opencl_double_4_3_1 = STR(

{dxan=d_add(d_imul(3,d_mul(Xxr,d_mul(Xxr,dxa))),d_add(d_imul(-3,d_mul(Xxi,d_mul(Xxi,dxa))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxr,dya))),daa)));
dxbn=d_add(d_imul(3,d_mul(Xxr,d_mul(Xxr,dxb))),d_add(d_imul(-3,d_mul(Xxi,d_mul(Xxi,dxb))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxr,dyb))),dab)));
dyan=d_add(d_imul(-3,d_mul(Xxr,d_mul(Xxr,dya))),d_add(d_imul(3,d_mul(Xxi,d_mul(Xxi,dya))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxr,dxa))),dba)));
dybn=d_add(d_imul(-3,d_mul(Xxr,d_mul(Xxr,dyb))),d_add(d_imul(3,d_mul(Xxi,d_mul(Xxi,dyb))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxr,dxb))),dbb)));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_add(d_sub(cr,d_mul(xr,d_add(d_imul(3,Xr2),xr2))),d_mul(d_imul(3,Xr),d_sub(d_add(xi2,d_mul(d_imul(2,Xi),xi)),xr2))),d_mul(d_imul(3,xr),d_add(d_add(Xi2,d_mul(d_imul(2,Xi),xi)),xi2)));
xin=d_add(d_sub(d_add(d_add(d_add(d_sub(d_sub(d_add(d_mul(d_mul(d_imul(6,Xr),Xi),xr),d_mul(d_imul(3,Xi),xr2)),d_mul(d_imul(3,Xi2),xi)),d_mul(d_imul(3,Xi),xi2)),d_mul(d_imul(3,Xr2),xi)),d_mul(d_mul(d_imul(6,Xr),xr),xi)),d_mul(d_imul(3,xr2),xi)),d_mul(xi2,xi)),ci);
}

);

static const char *perturbation_opencl_floatexp_4_3_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_sub(cr,fe_mul(xr,fe_add(fe_imul(3,Xr2),xr2))),fe_mul(fe_imul(3,Xr),fe_sub(fe_add(xi2,fe_mul(fe_imul(2,Xi),xi)),xr2))),fe_mul(fe_imul(3,xr),fe_add(fe_add(Xi2,fe_mul(fe_imul(2,Xi),xi)),xi2)));
xin=fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_add(fe_mul(fe_mul(fe_imul(6,Xr),Xi),xr),fe_mul(fe_imul(3,Xi),xr2)),fe_mul(fe_imul(3,Xi2),xi)),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(fe_imul(3,Xr2),xi)),fe_mul(fe_mul(fe_imul(6,Xr),xr),xi)),fe_mul(fe_imul(3,xr2),xi)),fe_mul(xi2,xi)),ci);
}

);

static const char *perturbation_opencl_floatexp_4_3_1 = STR(

{dxan=fe_add(fe_imul(3,fe_mul(Xxr,fe_mul(Xxr,dxa))),fe_add(fe_imul(-3,fe_mul(Xxi,fe_mul(Xxi,dxa))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxr,dya))),daa)));
dxbn=fe_add(fe_imul(3,fe_mul(Xxr,fe_mul(Xxr,dxb))),fe_add(fe_imul(-3,fe_mul(Xxi,fe_mul(Xxi,dxb))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxr,dyb))),dab)));
dyan=fe_add(fe_imul(-3,fe_mul(Xxr,fe_mul(Xxr,dya))),fe_add(fe_imul(3,fe_mul(Xxi,fe_mul(Xxi,dya))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxr,dxa))),dba)));
dybn=fe_add(fe_imul(-3,fe_mul(Xxr,fe_mul(Xxr,dyb))),fe_add(fe_imul(3,fe_mul(Xxi,fe_mul(Xxi,dyb))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxr,dxb))),dbb)));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_sub(cr,fe_mul(xr,fe_add(fe_imul(3,Xr2),xr2))),fe_mul(fe_imul(3,Xr),fe_sub(fe_add(xi2,fe_mul(fe_imul(2,Xi),xi)),xr2))),fe_mul(fe_imul(3,xr),fe_add(fe_add(Xi2,fe_mul(fe_imul(2,Xi),xi)),xi2)));
xin=fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_add(fe_mul(fe_mul(fe_imul(6,Xr),Xi),xr),fe_mul(fe_imul(3,Xi),xr2)),fe_mul(fe_imul(3,Xi2),xi)),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(fe_imul(3,Xr2),xi)),fe_mul(fe_mul(fe_imul(6,Xr),xr),xi)),fe_mul(fe_imul(3,xr2),xi)),fe_mul(xi2,xi)),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_4_3_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_add(sf_sub(cr,sf_mul(xr,sf_add(sf_imul(3,Xr2),xr2))),sf_mul(sf_imul(3,Xr),sf_sub(sf_add(xi2,sf_mul(sf_imul(2,Xi),xi)),xr2))),sf_mul(sf_imul(3,xr),sf_add(sf_add(Xi2,sf_mul(sf_imul(2,Xi),xi)),xi2)));
xin=sf_add(sf_sub(sf_add(sf_add(sf_add(sf_sub(sf_sub(sf_add(sf_mul(sf_mul(sf_imul(6,Xr),Xi),xr),sf_mul(sf_imul(3,Xi),xr2)),sf_mul(sf_imul(3,Xi2),xi)),sf_mul(sf_imul(3,Xi),xi2)),sf_mul(sf_imul(3,Xr2),xi)),sf_mul(sf_mul(sf_imul(6,Xr),xr),xi)),sf_mul(sf_imul(3,xr2),xi)),sf_mul(xi2,xi)),ci);
}

);
#endif


static const char *perturbation_opencl_double_4_4_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_mul(d_imul(12,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(24,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(12,Xr),xr),xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xr2),Xi),xi)),d_mul(d_imul(6,xr2),xi2)),cr);
xin=d_add(d_add(d_sub(d_add(d_add(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_add(d_sub(d_mul(d_mul(d_imul(-12,Xr2),Xi),xr),d_mul(d_mul(d_imul(12,Xr),Xi),xr2)),d_mul(d_mul(d_imul(12,Xr),Xi2),xi)),d_mul(d_mul(d_imul(12,Xr),Xi),xi2)),d_mul(d_mul(d_imul(4,Xr2),Xr),xi)),d_mul(d_mul(d_imul(12,Xr2),xi),xr)),d_mul(d_mul(d_imul(12,Xr),xi),xr2)),d_mul(d_mul(d_imul(4,Xr),xi2),xi)),d_mul(d_mul(d_imul(4,xr2),xr),Xi)),d_mul(d_mul(d_imul(4,xr),Xi2),Xi)),d_mul(d_mul(d_imul(12,xr),Xi2),xi)),d_mul(d_mul(d_imul(12,xr),Xi),xi2)),d_mul(d_mul(d_imul(4,xr2),xr),xi)),d_mul(d_mul(d_imul(4,xr),xi2),xi)),ci);
}

);

static const char *perturbation_opencl_double_4_4_1 = STR(

{dxan=d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dya)))),d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dxa)))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,dxa)))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,dya)))),daa))));
dxbn=d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dyb)))),d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dxb)))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,dxb)))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,dyb)))),dab))));
dyan=d_add(d_imul(-4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dya)))),d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dxa)))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,dxa)))),d_add(d_imul(12,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,dya)))),dba))));
dybn=d_add(d_imul(-4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dyb)))),d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dxb)))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,dxb)))),d_add(d_imul(12,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,dyb)))),dbb))));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_mul(d_imul(12,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(24,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(12,Xr),xr),xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xr2),Xi),xi)),d_mul(d_imul(6,xr2),xi2)),cr);
xin=d_add(d_add(d_sub(d_add(d_add(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_add(d_sub(d_mul(d_mul(d_imul(-12,Xr2),Xi),xr),d_mul(d_mul(d_imul(12,Xr),Xi),xr2)),d_mul(d_mul(d_imul(12,Xr),Xi2),xi)),d_mul(d_mul(d_imul(12,Xr),Xi),xi2)),d_mul(d_mul(d_imul(4,Xr2),Xr),xi)),d_mul(d_mul(d_imul(12,Xr2),xi),xr)),d_mul(d_mul(d_imul(12,Xr),xi),xr2)),d_mul(d_mul(d_imul(4,Xr),xi2),xi)),d_mul(d_mul(d_imul(4,xr2),xr),Xi)),d_mul(d_mul(d_imul(4,xr),Xi2),Xi)),d_mul(d_mul(d_imul(12,xr),Xi2),xi)),d_mul(d_mul(d_imul(12,xr),Xi),xi2)),d_mul(d_mul(d_imul(4,xr2),xr),xi)),d_mul(d_mul(d_imul(4,xr),xi2),xi)),ci);
}

);

static const char *perturbation_opencl_floatexp_4_4_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_mul(fe_imul(12,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(12,Xr),xr),xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xr2),Xi),xi)),fe_mul(fe_imul(6,xr2),xi2)),cr);
xin=fe_add(fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_sub(fe_mul(fe_mul(fe_imul(-12,Xr2),Xi),xr),fe_mul(fe_mul(fe_imul(12,Xr),Xi),xr2)),fe_mul(fe_mul(fe_imul(12,Xr),Xi2),xi)),fe_mul(fe_mul(fe_imul(12,Xr),Xi),xi2)),fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xi)),fe_mul(fe_mul(fe_imul(12,Xr2),xi),xr)),fe_mul(fe_mul(fe_imul(12,Xr),xi),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xi2),xi)),fe_mul(fe_mul(fe_imul(4,xr2),xr),Xi)),fe_mul(fe_mul(fe_imul(4,xr),Xi2),Xi)),fe_mul(fe_mul(fe_imul(12,xr),Xi2),xi)),fe_mul(fe_mul(fe_imul(12,xr),Xi),xi2)),fe_mul(fe_mul(fe_imul(4,xr2),xr),xi)),fe_mul(fe_mul(fe_imul(4,xr),xi2),xi)),ci);
}

);

static const char *perturbation_opencl_floatexp_4_4_1 = STR(

{dxan=fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dya)))),fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dxa)))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,dxa)))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,dya)))),daa))));
dxbn=fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dyb)))),fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dxb)))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,dxb)))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,dyb)))),dab))));
dyan=fe_add(fe_imul(-4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dya)))),fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dxa)))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,dxa)))),fe_add(fe_imul(12,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,dya)))),dba))));
dybn=fe_add(fe_imul(-4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dyb)))),fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dxb)))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,dxb)))),fe_add(fe_imul(12,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,dyb)))),dbb))));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_mul(fe_imul(12,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(12,Xr),xr),xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xr2),Xi),xi)),fe_mul(fe_imul(6,xr2),xi2)),cr);
xin=fe_add(fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_sub(fe_mul(fe_mul(fe_imul(-12,Xr2),Xi),xr),fe_mul(fe_mul(fe_imul(12,Xr),Xi),xr2)),fe_mul(fe_mul(fe_imul(12,Xr),Xi2),xi)),fe_mul(fe_mul(fe_imul(12,Xr),Xi),xi2)),fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xi)),fe_mul(fe_mul(fe_imul(12,Xr2),xi),xr)),fe_mul(fe_mul(fe_imul(12,Xr),xi),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xi2),xi)),fe_mul(fe_mul(fe_imul(4,xr2),xr),Xi)),fe_mul(fe_mul(fe_imul(4,xr),Xi2),Xi)),fe_mul(fe_mul(fe_imul(12,xr),Xi2),xi)),fe_mul(fe_mul(fe_imul(12,xr),Xi),xi2)),fe_mul(fe_mul(fe_imul(4,xr2),xr),xi)),fe_mul(fe_mul(fe_imul(4,xr),xi2),xi)),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_4_4_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_mul(sf_imul(4,Xi),xi2),xi)),sf_mul(xi2,xi2)),sf_mul(sf_mul(sf_imul(12,Xr2),Xi),xi)),sf_mul(sf_imul(6,Xr2),xi2)),sf_mul(sf_mul(sf_imul(12,Xr),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(24,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_imul(12,Xr),xr),xi2)),sf_mul(sf_imul(6,xr2),Xi2)),sf_mul(sf_mul(sf_imul(12,xr2),Xi),xi)),sf_mul(sf_imul(6,xr2),xi2)),cr);
xin=sf_add(sf_add(sf_sub(sf_add(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_sub(sf_mul(sf_mul(sf_imul(-12,Xr2),Xi),xr),sf_mul(sf_mul(sf_imul(12,Xr),Xi),xr2)),sf_mul(sf_mul(sf_imul(12,Xr),Xi2),xi)),sf_mul(sf_mul(sf_imul(12,Xr),Xi),xi2)),sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xi)),sf_mul(sf_mul(sf_imul(12,Xr2),xi),xr)),sf_mul(sf_mul(sf_imul(12,Xr),xi),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xi2),xi)),sf_mul(sf_mul(sf_imul(4,xr2),xr),Xi)),sf_mul(sf_mul(sf_imul(4,xr),Xi2),Xi)),sf_mul(sf_mul(sf_imul(12,xr),Xi2),xi)),sf_mul(sf_mul(sf_imul(12,xr),Xi),xi2)),sf_mul(sf_mul(sf_imul(4,xr2),xr),xi)),sf_mul(sf_mul(sf_imul(4,xr),xi2),xi)),ci);
}

);
#endif


static const char *perturbation_opencl_double_4_5_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_add(d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_mul(d_mul(d_imul(5,Xr2),Xr2),xr),d_mul(d_mul(d_imul(10,Xr2),Xr),xr2)),d_mul(d_mul(d_imul(10,Xr2),xr2),xr)),d_mul(d_mul(d_imul(5,Xr),xr2),xr2)),d_mul(d_mul(d_mul(d_imul(20,Xr2),Xr),Xi),xi)),d_mul(d_mul(d_imul(10,Xr2),Xr),xi2)),d_mul(d_mul(d_imul(30,Xr2),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(60,Xr2),xr),Xi),xi)),d_mul(d_mul(d_imul(30,Xr2),xr),xi2)),d_mul(d_mul(d_imul(30,Xr),xr2),Xi2)),d_mul(d_mul(d_mul(d_imul(60,Xr),xr2),Xi),xi)),d_mul(d_mul(d_imul(30,Xr),xr2),xi2)),d_mul(d_mul(d_mul(d_imul(20,Xr),Xi2),Xi),xi)),d_mul(d_mul(d_imul(30,Xr),Xi2),xi2)),d_mul(d_mul(d_mul(d_imul(20,Xr),Xi),xi2),xi)),d_mul(d_mul(d_imul(5,Xr),xi2),xi2)),d_mul(d_mul(xr2,xr2),xr)),d_mul(d_mul(d_imul(10,xr2),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(20,xr2),xr),Xi),xi)),d_mul(d_mul(d_imul(10,xr2),xr),xi2)),d_mul(d_mul(d_imul(5,xr),Xi2),Xi2)),d_mul(d_mul(d_mul(d_imul(20,xr),Xi2),Xi),xi)),d_mul(d_mul(d_imul(30,xr),Xi2),xi2)),d_mul(d_mul(d_mul(d_imul(20,xr),Xi),xi2),xi)),d_mul(d_mul(d_imul(5,xr),xi2),xi2)),cr);
xin=d_add(d_sub(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_mul(d_mul(d_mul(d_imul(-20,Xi),Xr2),Xr),xr),d_mul(d_mul(d_imul(30,Xi),Xr2),xr2)),d_mul(d_mul(d_mul(d_imul(20,Xi),Xr),xr2),xr)),d_mul(d_mul(d_imul(5,Xi),xr2),xr2)),d_mul(d_mul(d_imul(30,Xi2),Xr2),xi)),d_mul(d_mul(d_imul(30,Xi),Xr2),xi2)),d_mul(d_mul(d_mul(d_imul(20,Xi2),Xi),Xr),xr)),d_mul(d_mul(d_mul(d_imul(60,Xi2),Xr),xr),xi)),d_mul(d_mul(d_mul(d_imul(60,Xi),Xr),xr),xi2)),d_mul(d_mul(d_imul(10,Xi2),Xi),xr2)),d_mul(d_mul(d_imul(30,Xi2),xr2),xi)),d_mul(d_mul(d_imul(30,Xi),xr2),xi2)),d_mul(d_mul(d_imul(5,Xi2),Xi2),xi)),d_mul(d_mul(d_imul(10,Xi2),Xi),xi2)),d_mul(d_mul(d_imul(10,Xi2),xi2),xi)),d_mul(d_mul(d_imul(5,Xi),xi2),xi2)),d_mul(d_mul(d_imul(5,xi),Xr2),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi),Xr2),Xr),xr)),d_mul(d_mul(d_imul(30,xi),Xr2),xr2)),d_mul(d_mul(d_mul(d_imul(20,xi),Xr),xr2),xr)),d_mul(d_mul(d_imul(5,xi),xr2),xr2)),d_mul(d_mul(d_imul(10,xi2),xi),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi2),xi),Xr),xr)),d_mul(d_mul(d_imul(10,xi2),xi),xr2)),d_mul(d_mul(xi2,xi2),xi)),ci);
}

);

static const char *perturbation_opencl_double_4_5_1 = STR(

{dxan=d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dxa))))),d_add(d_imul(5,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dxa))))),d_add(d_imul(20,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,dya))))),d_add(d_imul(-20,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dya))))),d_add(d_imul(-30,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,dxa))))),daa)))));
dxbn=d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dxb))))),d_add(d_imul(5,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dxb))))),d_add(d_imul(20,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,dyb))))),d_add(d_imul(-20,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dyb))))),d_add(d_imul(-30,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,dxb))))),dab)))));
dyan=d_add(d_imul(-5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dya))))),d_add(d_imul(-5,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dya))))),d_add(d_imul(20,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,dxa))))),d_add(d_imul(-20,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dxa))))),d_add(d_imul(30,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,dya))))),dba)))));
dybn=d_add(d_imul(-5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dyb))))),d_add(d_imul(-5,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dyb))))),d_add(d_imul(20,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,dxb))))),d_add(d_imul(-20,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dxb))))),d_add(d_imul(30,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,dyb))))),dbb)))));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_add(d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_mul(d_mul(d_imul(5,Xr2),Xr2),xr),d_mul(d_mul(d_imul(10,Xr2),Xr),xr2)),d_mul(d_mul(d_imul(10,Xr2),xr2),xr)),d_mul(d_mul(d_imul(5,Xr),xr2),xr2)),d_mul(d_mul(d_mul(d_imul(20,Xr2),Xr),Xi),xi)),d_mul(d_mul(d_imul(10,Xr2),Xr),xi2)),d_mul(d_mul(d_imul(30,Xr2),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(60,Xr2),xr),Xi),xi)),d_mul(d_mul(d_imul(30,Xr2),xr),xi2)),d_mul(d_mul(d_imul(30,Xr),xr2),Xi2)),d_mul(d_mul(d_mul(d_imul(60,Xr),xr2),Xi),xi)),d_mul(d_mul(d_imul(30,Xr),xr2),xi2)),d_mul(d_mul(d_mul(d_imul(20,Xr),Xi2),Xi),xi)),d_mul(d_mul(d_imul(30,Xr),Xi2),xi2)),d_mul(d_mul(d_mul(d_imul(20,Xr),Xi),xi2),xi)),d_mul(d_mul(d_imul(5,Xr),xi2),xi2)),d_mul(d_mul(xr2,xr2),xr)),d_mul(d_mul(d_imul(10,xr2),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(20,xr2),xr),Xi),xi)),d_mul(d_mul(d_imul(10,xr2),xr),xi2)),d_mul(d_mul(d_imul(5,xr),Xi2),Xi2)),d_mul(d_mul(d_mul(d_imul(20,xr),Xi2),Xi),xi)),d_mul(d_mul(d_imul(30,xr),Xi2),xi2)),d_mul(d_mul(d_mul(d_imul(20,xr),Xi),xi2),xi)),d_mul(d_mul(d_imul(5,xr),xi2),xi2)),cr);
xin=d_add(d_sub(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_mul(d_mul(d_mul(d_imul(-20,Xi),Xr2),Xr),xr),d_mul(d_mul(d_imul(30,Xi),Xr2),xr2)),d_mul(d_mul(d_mul(d_imul(20,Xi),Xr),xr2),xr)),d_mul(d_mul(d_imul(5,Xi),xr2),xr2)),d_mul(d_mul(d_imul(30,Xi2),Xr2),xi)),d_mul(d_mul(d_imul(30,Xi),Xr2),xi2)),d_mul(d_mul(d_mul(d_imul(20,Xi2),Xi),Xr),xr)),d_mul(d_mul(d_mul(d_imul(60,Xi2),Xr),xr),xi)),d_mul(d_mul(d_mul(d_imul(60,Xi),Xr),xr),xi2)),d_mul(d_mul(d_imul(10,Xi2),Xi),xr2)),d_mul(d_mul(d_imul(30,Xi2),xr2),xi)),d_mul(d_mul(d_imul(30,Xi),xr2),xi2)),d_mul(d_mul(d_imul(5,Xi2),Xi2),xi)),d_mul(d_mul(d_imul(10,Xi2),Xi),xi2)),d_mul(d_mul(d_imul(10,Xi2),xi2),xi)),d_mul(d_mul(d_imul(5,Xi),xi2),xi2)),d_mul(d_mul(d_imul(5,xi),Xr2),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi),Xr2),Xr),xr)),d_mul(d_mul(d_imul(30,xi),Xr2),xr2)),d_mul(d_mul(d_mul(d_imul(20,xi),Xr),xr2),xr)),d_mul(d_mul(d_imul(5,xi),xr2),xr2)),d_mul(d_mul(d_imul(10,xi2),xi),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi2),xi),Xr),xr)),d_mul(d_mul(d_imul(10,xi2),xi),xr2)),d_mul(d_mul(xi2,xi2),xi)),ci);
}

);

static const char *perturbation_opencl_floatexp_4_5_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(5,Xr2),Xr2),xr),fe_mul(fe_mul(fe_imul(10,Xr2),Xr),xr2)),fe_mul(fe_mul(fe_imul(10,Xr2),xr2),xr)),fe_mul(fe_mul(fe_imul(5,Xr),xr2),xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr2),Xr),Xi),xi)),fe_mul(fe_mul(fe_imul(10,Xr2),Xr),xi2)),fe_mul(fe_mul(fe_imul(30,Xr2),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xr2),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(30,Xr2),xr),xi2)),fe_mul(fe_mul(fe_imul(30,Xr),xr2),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xr),xr2),Xi),xi)),fe_mul(fe_mul(fe_imul(30,Xr),xr2),xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),Xi2),Xi),xi)),fe_mul(fe_mul(fe_imul(30,Xr),Xi2),xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),Xi),xi2),xi)),fe_mul(fe_mul(fe_imul(5,Xr),xi2),xi2)),fe_mul(fe_mul(xr2,xr2),xr)),fe_mul(fe_mul(fe_imul(10,xr2),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr2),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(10,xr2),xr),xi2)),fe_mul(fe_mul(fe_imul(5,xr),Xi2),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr),Xi2),Xi),xi)),fe_mul(fe_mul(fe_imul(30,xr),Xi2),xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr),Xi),xi2),xi)),fe_mul(fe_mul(fe_imul(5,xr),xi2),xi2)),cr);
xin=fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_mul(fe_mul(fe_mul(fe_imul(-20,Xi),Xr2),Xr),xr),fe_mul(fe_mul(fe_imul(30,Xi),Xr2),xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),Xr),xr2),xr)),fe_mul(fe_mul(fe_imul(5,Xi),xr2),xr2)),fe_mul(fe_mul(fe_imul(30,Xi2),Xr2),xi)),fe_mul(fe_mul(fe_imul(30,Xi),Xr2),xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi2),Xi),Xr),xr)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi2),Xr),xr),xi)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi),Xr),xr),xi2)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xr2)),fe_mul(fe_mul(fe_imul(30,Xi2),xr2),xi)),fe_mul(fe_mul(fe_imul(30,Xi),xr2),xi2)),fe_mul(fe_mul(fe_imul(5,Xi2),Xi2),xi)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xi2)),fe_mul(fe_mul(fe_imul(10,Xi2),xi2),xi)),fe_mul(fe_mul(fe_imul(5,Xi),xi2),xi2)),fe_mul(fe_mul(fe_imul(5,xi),Xr2),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),Xr2),Xr),xr)),fe_mul(fe_mul(fe_imul(30,xi),Xr2),xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),Xr),xr2),xr)),fe_mul(fe_mul(fe_imul(5,xi),xr2),xr2)),fe_mul(fe_mul(fe_imul(10,xi2),xi),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi2),xi),Xr),xr)),fe_mul(fe_mul(fe_imul(10,xi2),xi),xr2)),fe_mul(fe_mul(xi2,xi2),xi)),ci);
}

);

static const char *perturbation_opencl_floatexp_4_5_1 = STR(

{dxan=fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dxa))))),fe_add(fe_imul(5,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dxa))))),fe_add(fe_imul(20,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,dya))))),fe_add(fe_imul(-20,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dya))))),fe_add(fe_imul(-30,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,dxa))))),daa)))));
dxbn=fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dxb))))),fe_add(fe_imul(5,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dxb))))),fe_add(fe_imul(20,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,dyb))))),fe_add(fe_imul(-20,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dyb))))),fe_add(fe_imul(-30,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,dxb))))),dab)))));
dyan=fe_add(fe_imul(-5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dya))))),fe_add(fe_imul(-5,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dya))))),fe_add(fe_imul(20,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,dxa))))),fe_add(fe_imul(-20,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dxa))))),fe_add(fe_imul(30,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,dya))))),dba)))));
dybn=fe_add(fe_imul(-5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dyb))))),fe_add(fe_imul(-5,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dyb))))),fe_add(fe_imul(20,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,dxb))))),fe_add(fe_imul(-20,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dxb))))),fe_add(fe_imul(30,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,dyb))))),dbb)))));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(5,Xr2),Xr2),xr),fe_mul(fe_mul(fe_imul(10,Xr2),Xr),xr2)),fe_mul(fe_mul(fe_imul(10,Xr2),xr2),xr)),fe_mul(fe_mul(fe_imul(5,Xr),xr2),xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr2),Xr),Xi),xi)),fe_mul(fe_mul(fe_imul(10,Xr2),Xr),xi2)),fe_mul(fe_mul(fe_imul(30,Xr2),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xr2),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(30,Xr2),xr),xi2)),fe_mul(fe_mul(fe_imul(30,Xr),xr2),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xr),xr2),Xi),xi)),fe_mul(fe_mul(fe_imul(30,Xr),xr2),xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),Xi2),Xi),xi)),fe_mul(fe_mul(fe_imul(30,Xr),Xi2),xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),Xi),xi2),xi)),fe_mul(fe_mul(fe_imul(5,Xr),xi2),xi2)),fe_mul(fe_mul(xr2,xr2),xr)),fe_mul(fe_mul(fe_imul(10,xr2),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr2),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(10,xr2),xr),xi2)),fe_mul(fe_mul(fe_imul(5,xr),Xi2),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr),Xi2),Xi),xi)),fe_mul(fe_mul(fe_imul(30,xr),Xi2),xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr),Xi),xi2),xi)),fe_mul(fe_mul(fe_imul(5,xr),xi2),xi2)),cr);
xin=fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_mul(fe_mul(fe_mul(fe_imul(-20,Xi),Xr2),Xr),xr),fe_mul(fe_mul(fe_imul(30,Xi),Xr2),xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),Xr),xr2),xr)),fe_mul(fe_mul(fe_imul(5,Xi),xr2),xr2)),fe_mul(fe_mul(fe_imul(30,Xi2),Xr2),xi)),fe_mul(fe_mul(fe_imul(30,Xi),Xr2),xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi2),Xi),Xr),xr)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi2),Xr),xr),xi)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi),Xr),xr),xi2)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xr2)),fe_mul(fe_mul(fe_imul(30,Xi2),xr2),xi)),fe_mul(fe_mul(fe_imul(30,Xi),xr2),xi2)),fe_mul(fe_mul(fe_imul(5,Xi2),Xi2),xi)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xi2)),fe_mul(fe_mul(fe_imul(10,Xi2),xi2),xi)),fe_mul(fe_mul(fe_imul(5,Xi),xi2),xi2)),fe_mul(fe_mul(fe_imul(5,xi),Xr2),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),Xr2),Xr),xr)),fe_mul(fe_mul(fe_imul(30,xi),Xr2),xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),Xr),xr2),xr)),fe_mul(fe_mul(fe_imul(5,xi),xr2),xr2)),fe_mul(fe_mul(fe_imul(10,xi2),xi),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi2),xi),Xr),xr)),fe_mul(fe_mul(fe_imul(10,xi2),xi),xr2)),fe_mul(fe_mul(xi2,xi2),xi)),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_4_5_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(5,Xr2),Xr2),xr),sf_mul(sf_mul(sf_imul(10,Xr2),Xr),xr2)),sf_mul(sf_mul(sf_imul(10,Xr2),xr2),xr)),sf_mul(sf_mul(sf_imul(5,Xr),xr2),xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xr2),Xr),Xi),xi)),sf_mul(sf_mul(sf_imul(10,Xr2),Xr),xi2)),sf_mul(sf_mul(sf_imul(30,Xr2),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xr2),xr),Xi),xi)),sf_mul(sf_mul(sf_imul(30,Xr2),xr),xi2)),sf_mul(sf_mul(sf_imul(30,Xr),xr2),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xr),xr2),Xi),xi)),sf_mul(sf_mul(sf_imul(30,Xr),xr2),xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xr),Xi2),Xi),xi)),sf_mul(sf_mul(sf_imul(30,Xr),Xi2),xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xr),Xi),xi2),xi)),sf_mul(sf_mul(sf_imul(5,Xr),xi2),xi2)),sf_mul(sf_mul(xr2,xr2),xr)),sf_mul(sf_mul(sf_imul(10,xr2),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xr2),xr),Xi),xi)),sf_mul(sf_mul(sf_imul(10,xr2),xr),xi2)),sf_mul(sf_mul(sf_imul(5,xr),Xi2),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xr),Xi2),Xi),xi)),sf_mul(sf_mul(sf_imul(30,xr),Xi2),xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xr),Xi),xi2),xi)),sf_mul(sf_mul(sf_imul(5,xr),xi2),xi2)),cr);
xin=sf_add(sf_sub(sf_add(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_mul(sf_mul(sf_mul(sf_imul(-20,Xi),Xr2),Xr),xr),sf_mul(sf_mul(sf_imul(30,Xi),Xr2),xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xi),Xr),xr2),xr)),sf_mul(sf_mul(sf_imul(5,Xi),xr2),xr2)),sf_mul(sf_mul(sf_imul(30,Xi2),Xr2),xi)),sf_mul(sf_mul(sf_imul(30,Xi),Xr2),xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xi2),Xi),Xr),xr)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xi2),Xr),xr),xi)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xi),Xr),xr),xi2)),sf_mul(sf_mul(sf_imul(10,Xi2),Xi),xr2)),sf_mul(sf_mul(sf_imul(30,Xi2),xr2),xi)),sf_mul(sf_mul(sf_imul(30,Xi),xr2),xi2)),sf_mul(sf_mul(sf_imul(5,Xi2),Xi2),xi)),sf_mul(sf_mul(sf_imul(10,Xi2),Xi),xi2)),sf_mul(sf_mul(sf_imul(10,Xi2),xi2),xi)),sf_mul(sf_mul(sf_imul(5,Xi),xi2),xi2)),sf_mul(sf_mul(sf_imul(5,xi),Xr2),Xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi),Xr2),Xr),xr)),sf_mul(sf_mul(sf_imul(30,xi),Xr2),xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi),Xr),xr2),xr)),sf_mul(sf_mul(sf_imul(5,xi),xr2),xr2)),sf_mul(sf_mul(sf_imul(10,xi2),xi),Xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi2),xi),Xr),xr)),sf_mul(sf_mul(sf_imul(10,xi2),xi),xr2)),sf_mul(sf_mul(xi2,xi2),xi)),ci);
}

);
#endif


static const char *perturbation_opencl_double_5_2_0 = STR(

{const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_diffabs(d_sub(d_mul(Xr,Xr),d_mul(Xi,Xi)),d_sub(d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),d_mul(d_imul(2,Xi),xi)),xi2)),cr);
xin=d_add(d_muli(d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi)),-2),ci);
}

);

static const char *perturbation_opencl_double_5_2_1 = STR(

{dxan=d_add(d_imul(2,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))),d_add(d_imul(-2,d_mul(Xxi,d_mul(dya,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))),daa));
dxbn=d_add(d_imul(2,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))),d_add(d_imul(-2,d_mul(Xxi,d_mul(dyb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))),dab));
dyan=d_add(d_imul(-2,d_mul(Xxi,dxa)),d_add(d_imul(-2,d_mul(Xxr,dya)),dba));
dybn=d_add(d_imul(-2,d_mul(Xxi,dxb)),d_add(d_imul(-2,d_mul(Xxr,dyb)),dbb));
}

{const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_diffabs(d_sub(d_mul(Xr,Xr),d_mul(Xi,Xi)),d_sub(d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),d_mul(d_imul(2,Xi),xi)),xi2)),cr);
xin=d_add(d_muli(d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi)),-2),ci);
}

);

static const char *perturbation_opencl_floatexp_5_2_0 = STR(

{const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_mul(Xr,Xr),fe_mul(Xi,Xi)),fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),fe_mul(fe_imul(2,Xi),xi)),xi2)),cr);
xin=fe_add(fe_muli(fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi)),-2),ci);
}

);

static const char *perturbation_opencl_floatexp_5_2_1 = STR(

{dxan=fe_add(fe_imul(2,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))),fe_add(fe_imul(-2,fe_mul(Xxi,fe_mul(dya,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))),daa));
dxbn=fe_add(fe_imul(2,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))),fe_add(fe_imul(-2,fe_mul(Xxi,fe_mul(dyb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))),dab));
dyan=fe_add(fe_imul(-2,fe_mul(Xxi,dxa)),fe_add(fe_imul(-2,fe_mul(Xxr,dya)),dba));
dybn=fe_add(fe_imul(-2,fe_mul(Xxi,dxb)),fe_add(fe_imul(-2,fe_mul(Xxr,dyb)),dbb));
}

{const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_mul(Xr,Xr),fe_mul(Xi,Xi)),fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),fe_mul(fe_imul(2,Xi),xi)),xi2)),cr);
xin=fe_add(fe_muli(fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi)),-2),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_5_2_0 = STR(

{const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_diffabs(sf_sub(sf_mul(Xr,Xr),sf_mul(Xi,Xi)),sf_sub(sf_sub(sf_add(sf_mul(sf_imul(2,Xr),xr),xr2),sf_mul(sf_imul(2,Xi),xi)),xi2)),cr);
xin=sf_add(sf_muli(sf_add(sf_add(sf_mul(Xr,xi),sf_mul(xr,Xi)),sf_mul(xr,xi)),-2),ci);
}

);
#endif


static const char *perturbation_opencl_double_6_2_0 = STR(

{const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_sub(d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),xi2),d_mul(d_imul(2,xi),Xi)),cr);
xin=d_add(d_add(d_muli(d_mul(d_abs(d_add(Xr,xr)),xi),-2),d_muli(d_mul(d_diffabs(Xr,xr),Xi),-2)),ci);
}

);

static const char *perturbation_opencl_double_6_2_1 = STR(

{dxan=d_add(d_imul(2,d_mul(Xxr,dxa)),d_add(d_imul(-2,d_mul(Xxi,dya)),daa));
dxbn=d_add(d_imul(2,d_mul(Xxr,dxb)),d_add(d_imul(-2,d_mul(Xxi,dyb)),dab));
dyan=d_add(dba,d_add(d_imul(-2,d_mul(Xxi,d_mul(dxa,d_sgn(Xxr)))),d_imul(-2,d_mul(d_abs(Xxr),dya))));
dybn=d_add(dbb,d_add(d_imul(-2,d_mul(Xxi,d_mul(dxb,d_sgn(Xxr)))),d_imul(-2,d_mul(d_abs(Xxr),dyb))));
}

{const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_sub(d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),xi2),d_mul(d_imul(2,xi),Xi)),cr);
xin=d_add(d_add(d_muli(d_mul(d_abs(d_add(Xr,xr)),xi),-2),d_muli(d_mul(d_diffabs(Xr,xr),Xi),-2)),ci);
}

);

static const char *perturbation_opencl_floatexp_6_2_0 = STR(

{const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),xi2),fe_mul(fe_imul(2,xi),Xi)),cr);
xin=fe_add(fe_add(fe_muli(fe_mul(fe_abs(fe_add(Xr,xr)),xi),-2),fe_muli(fe_mul(fe_diffabs(Xr,xr),Xi),-2)),ci);
}

);

static const char *perturbation_opencl_floatexp_6_2_1 = STR(

{dxan=fe_add(fe_imul(2,fe_mul(Xxr,dxa)),fe_add(fe_imul(-2,fe_mul(Xxi,dya)),daa));
dxbn=fe_add(fe_imul(2,fe_mul(Xxr,dxb)),fe_add(fe_imul(-2,fe_mul(Xxi,dyb)),dab));
dyan=fe_add(dba,fe_add(fe_imul(-2,fe_mul(Xxi,fe_mul(dxa,fe_sgn(Xxr)))),fe_imul(-2,fe_mul(fe_abs(Xxr),dya))));
dybn=fe_add(dbb,fe_add(fe_imul(-2,fe_mul(Xxi,fe_mul(dxb,fe_sgn(Xxr)))),fe_imul(-2,fe_mul(fe_abs(Xxr),dyb))));
}

{const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),xi2),fe_mul(fe_imul(2,xi),Xi)),cr);
xin=fe_add(fe_add(fe_muli(fe_mul(fe_abs(fe_add(Xr,xr)),xi),-2),fe_muli(fe_mul(fe_diffabs(Xr,xr),Xi),-2)),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_6_2_0 = STR(

{const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_sub(sf_sub(sf_add(sf_mul(sf_imul(2,Xr),xr),xr2),xi2),sf_mul(sf_imul(2,xi),Xi)),cr);
xin=sf_add(sf_add(sf_muli(sf_mul(sf_abs(sf_add(Xr,xr)),xi),-2),sf_muli(sf_mul(sf_diffabs(Xr,xr),Xi),-2)),ci);
}

);
#endif


static const char *perturbation_opencl_double_7_2_0 = STR(

{const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_sub(d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),xi2),d_mul(d_imul(2,xi),Xi)),cr);
xin=d_add(d_add(d_muli(d_mul(d_diffabs(Xi,xi),Xr),-2),d_muli(d_mul(xr,d_abs(d_add(Xi,xi))),-2)),ci);
}

);

static const char *perturbation_opencl_double_7_2_1 = STR(

{dxan=d_add(d_imul(2,d_mul(Xxr,dxa)),d_add(d_imul(-2,d_mul(Xxi,dya)),daa));
dxbn=d_add(d_imul(2,d_mul(Xxr,dxb)),d_add(d_imul(-2,d_mul(Xxi,dyb)),dab));
dyan=d_add(dba,d_add(d_imul(-2,d_mul(Xxr,d_mul(dya,d_sgn(Xxi)))),d_imul(-2,d_mul(d_abs(Xxi),dxa))));
dybn=d_add(dbb,d_add(d_imul(-2,d_mul(Xxr,d_mul(dyb,d_sgn(Xxi)))),d_imul(-2,d_mul(d_abs(Xxi),dxb))));
}

{const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_sub(d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),xi2),d_mul(d_imul(2,xi),Xi)),cr);
xin=d_add(d_add(d_muli(d_mul(d_diffabs(Xi,xi),Xr),-2),d_muli(d_mul(xr,d_abs(d_add(Xi,xi))),-2)),ci);
}

);

static const char *perturbation_opencl_floatexp_7_2_0 = STR(

{const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),xi2),fe_mul(fe_imul(2,xi),Xi)),cr);
xin=fe_add(fe_add(fe_muli(fe_mul(fe_diffabs(Xi,xi),Xr),-2),fe_muli(fe_mul(xr,fe_abs(fe_add(Xi,xi))),-2)),ci);
}

);

static const char *perturbation_opencl_floatexp_7_2_1 = STR(

{dxan=fe_add(fe_imul(2,fe_mul(Xxr,dxa)),fe_add(fe_imul(-2,fe_mul(Xxi,dya)),daa));
dxbn=fe_add(fe_imul(2,fe_mul(Xxr,dxb)),fe_add(fe_imul(-2,fe_mul(Xxi,dyb)),dab));
dyan=fe_add(dba,fe_add(fe_imul(-2,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxi)))),fe_imul(-2,fe_mul(fe_abs(Xxi),dxa))));
dybn=fe_add(dbb,fe_add(fe_imul(-2,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxi)))),fe_imul(-2,fe_mul(fe_abs(Xxi),dxb))));
}

{const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),xi2),fe_mul(fe_imul(2,xi),Xi)),cr);
xin=fe_add(fe_add(fe_muli(fe_mul(fe_diffabs(Xi,xi),Xr),-2),fe_muli(fe_mul(xr,fe_abs(fe_add(Xi,xi))),-2)),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_7_2_0 = STR(

{const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_sub(sf_sub(sf_add(sf_mul(sf_imul(2,Xr),xr),xr2),xi2),sf_mul(sf_imul(2,xi),Xi)),cr);
xin=sf_add(sf_add(sf_muli(sf_mul(sf_diffabs(Xi,xi),Xr),-2),sf_muli(sf_mul(xr,sf_abs(sf_add(Xi,xi))),-2)),ci);
}

);
#endif


static const char *perturbation_opencl_double_8_2_0 = STR(

{const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_diffabs(d_sub(d_mul(Xr,Xr),d_mul(Xi,Xi)),d_sub(d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),d_mul(d_imul(2,Xi),xi)),xi2)),cr);
xin=d_add(d_add(d_muli(d_mul(d_abs(d_add(Xr,xr)),xi),-2),d_muli(d_mul(d_diffabs(Xr,xr),Xi),-2)),ci);
}

);

static const char *perturbation_opencl_double_8_2_1 = STR(

{dxan=d_add(d_imul(2,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))),d_add(d_imul(-2,d_mul(Xxi,d_mul(dya,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))),daa));
dxbn=d_add(d_imul(2,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))),d_add(d_imul(-2,d_mul(Xxi,d_mul(dyb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))),dab));
dyan=d_add(dba,d_add(d_imul(-2,d_mul(Xxi,d_mul(dxa,d_sgn(Xxr)))),d_imul(-2,d_mul(d_abs(Xxr),dya))));
dybn=d_add(dbb,d_add(d_imul(-2,d_mul(Xxi,d_mul(dxb,d_sgn(Xxr)))),d_imul(-2,d_mul(d_abs(Xxr),dyb))));
}

{const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_diffabs(d_sub(d_mul(Xr,Xr),d_mul(Xi,Xi)),d_sub(d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),d_mul(d_imul(2,Xi),xi)),xi2)),cr);
xin=d_add(d_add(d_muli(d_mul(d_abs(d_add(Xr,xr)),xi),-2),d_muli(d_mul(d_diffabs(Xr,xr),Xi),-2)),ci);
}

);

static const char *perturbation_opencl_floatexp_8_2_0 = STR(

{const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_mul(Xr,Xr),fe_mul(Xi,Xi)),fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),fe_mul(fe_imul(2,Xi),xi)),xi2)),cr);
xin=fe_add(fe_add(fe_muli(fe_mul(fe_abs(fe_add(Xr,xr)),xi),-2),fe_muli(fe_mul(fe_diffabs(Xr,xr),Xi),-2)),ci);
}

);

static const char *perturbation_opencl_floatexp_8_2_1 = STR(

{dxan=fe_add(fe_imul(2,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))),fe_add(fe_imul(-2,fe_mul(Xxi,fe_mul(dya,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))),daa));
dxbn=fe_add(fe_imul(2,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))),fe_add(fe_imul(-2,fe_mul(Xxi,fe_mul(dyb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))),dab));
dyan=fe_add(dba,fe_add(fe_imul(-2,fe_mul(Xxi,fe_mul(dxa,fe_sgn(Xxr)))),fe_imul(-2,fe_mul(fe_abs(Xxr),dya))));
dybn=fe_add(dbb,fe_add(fe_imul(-2,fe_mul(Xxi,fe_mul(dxb,fe_sgn(Xxr)))),fe_imul(-2,fe_mul(fe_abs(Xxr),dyb))));
}

{const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_mul(Xr,Xr),fe_mul(Xi,Xi)),fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),fe_mul(fe_imul(2,Xi),xi)),xi2)),cr);
xin=fe_add(fe_add(fe_muli(fe_mul(fe_abs(fe_add(Xr,xr)),xi),-2),fe_muli(fe_mul(fe_diffabs(Xr,xr),Xi),-2)),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_8_2_0 = STR(

{const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_diffabs(sf_sub(sf_mul(Xr,Xr),sf_mul(Xi,Xi)),sf_sub(sf_sub(sf_add(sf_mul(sf_imul(2,Xr),xr),xr2),sf_mul(sf_imul(2,Xi),xi)),xi2)),cr);
xin=sf_add(sf_add(sf_muli(sf_mul(sf_abs(sf_add(Xr,xr)),xi),-2),sf_muli(sf_mul(sf_diffabs(Xr,xr),Xi),-2)),ci);
}

);
#endif


static const char *perturbation_opencl_double_9_2_0 = STR(

{const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_diffabs(d_sub(d_mul(Xr,Xr),d_mul(Xi,Xi)),d_sub(d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),d_mul(d_imul(2,Xi),xi)),xi2)),cr);
xin=d_add(d_add(d_muli(d_mul(d_diffabs(Xi,xi),Xr),-2),d_muli(d_mul(xr,d_abs(d_add(Xi,xi))),-2)),ci);
}

);

static const char *perturbation_opencl_double_9_2_1 = STR(

{dxan=d_add(d_imul(2,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))),d_add(d_imul(-2,d_mul(Xxi,d_mul(dya,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))),daa));
dxbn=d_add(d_imul(2,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))),d_add(d_imul(-2,d_mul(Xxi,d_mul(dyb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))),dab));
dyan=d_add(dba,d_add(d_imul(-2,d_mul(Xxr,d_mul(dya,d_sgn(Xxi)))),d_imul(-2,d_mul(d_abs(Xxi),dxa))));
dybn=d_add(dbb,d_add(d_imul(-2,d_mul(Xxr,d_mul(dyb,d_sgn(Xxi)))),d_imul(-2,d_mul(d_abs(Xxi),dxb))));
}

{const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_diffabs(d_sub(d_mul(Xr,Xr),d_mul(Xi,Xi)),d_sub(d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),d_mul(d_imul(2,Xi),xi)),xi2)),cr);
xin=d_add(d_add(d_muli(d_mul(d_diffabs(Xi,xi),Xr),-2),d_muli(d_mul(xr,d_abs(d_add(Xi,xi))),-2)),ci);
}

);

static const char *perturbation_opencl_floatexp_9_2_0 = STR(

{const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_mul(Xr,Xr),fe_mul(Xi,Xi)),fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),fe_mul(fe_imul(2,Xi),xi)),xi2)),cr);
xin=fe_add(fe_add(fe_muli(fe_mul(fe_diffabs(Xi,xi),Xr),-2),fe_muli(fe_mul(xr,fe_abs(fe_add(Xi,xi))),-2)),ci);
}

);

static const char *perturbation_opencl_floatexp_9_2_1 = STR(

{dxan=fe_add(fe_imul(2,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))),fe_add(fe_imul(-2,fe_mul(Xxi,fe_mul(dya,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))),daa));
dxbn=fe_add(fe_imul(2,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))),fe_add(fe_imul(-2,fe_mul(Xxi,fe_mul(dyb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))),dab));
dyan=fe_add(dba,fe_add(fe_imul(-2,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxi)))),fe_imul(-2,fe_mul(fe_abs(Xxi),dxa))));
dybn=fe_add(dbb,fe_add(fe_imul(-2,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxi)))),fe_imul(-2,fe_mul(fe_abs(Xxi),dxb))));
}

{const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_mul(Xr,Xr),fe_mul(Xi,Xi)),fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),fe_mul(fe_imul(2,Xi),xi)),xi2)),cr);
xin=fe_add(fe_add(fe_muli(fe_mul(fe_diffabs(Xi,xi),Xr),-2),fe_muli(fe_mul(xr,fe_abs(fe_add(Xi,xi))),-2)),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_9_2_0 = STR(

{const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_diffabs(sf_sub(sf_mul(Xr,Xr),sf_mul(Xi,Xi)),sf_sub(sf_sub(sf_add(sf_mul(sf_imul(2,Xr),xr),xr2),sf_mul(sf_imul(2,Xi),xi)),xi2)),cr);
xin=sf_add(sf_add(sf_muli(sf_mul(sf_diffabs(Xi,xi),Xr),-2),sf_muli(sf_mul(xr,sf_abs(sf_add(Xi,xi))),-2)),ci);
}

);
#endif


static const char *perturbation_opencl_double_10_3_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_add(d_mul(d_sub(Xr2,d_imul(3,Xi2)),d_diffabs(Xr,xr)),d_mul(d_sub(d_sub(d_add(d_mul(d_imul(2,xr),Xr),xr2),d_mul(d_imul(6,Xi),xi)),d_imul(3,xi2)),d_abs(d_add(Xr,xr)))),cr);
xin=d_sub(ci,d_diffabs(d_mul(Xi,d_sub(d_imul(3,Xr2),Xi2)),d_sub(d_add(d_mul(d_imul(3,Xi),d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),xi2)),d_mul(d_imul(3,xi),d_add(d_add(Xr2,d_mul(d_imul(2,Xr),xr)),xr2))),d_mul(xi,d_add(d_imul(3,Xi2),xi2)))));
}

);

static const char *perturbation_opencl_double_10_3_1 = STR(

{dxan=d_add(d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr)))),d_add(d_imul(2,d_mul(d_abs(Xxr),d_mul(Xxr,dxa))),d_add(d_imul(-3,d_mul(Xxi,d_mul(Xxi,d_mul(dxa,d_sgn(Xxr))))),d_add(d_imul(-6,d_mul(d_abs(Xxr),d_mul(Xxi,dya))),daa))));
dxbn=d_add(d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr)))),d_add(d_imul(2,d_mul(d_abs(Xxr),d_mul(Xxr,dxb))),d_add(d_imul(-3,d_mul(Xxi,d_mul(Xxi,d_mul(dxb,d_sgn(Xxr))))),d_add(d_imul(-6,d_mul(d_abs(Xxr),d_mul(Xxi,dyb))),dab))));
dyan=d_add(d_imul(-3,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxi))),d_imul(3,d_mul(Xxi,d_mul(Xxr,Xxr))))))))),d_add(d_imul(3,d_mul(Xxi,d_mul(Xxi,d_mul(dya,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxi))),d_imul(3,d_mul(Xxi,d_mul(Xxr,Xxr))))))))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxi))),d_imul(3,d_mul(Xxi,d_mul(Xxr,Xxr))))))))),dba)));
dybn=d_add(d_imul(-3,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxi))),d_imul(3,d_mul(Xxi,d_mul(Xxr,Xxr))))))))),d_add(d_imul(3,d_mul(Xxi,d_mul(Xxi,d_mul(dyb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxi))),d_imul(3,d_mul(Xxi,d_mul(Xxr,Xxr))))))))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxi))),d_imul(3,d_mul(Xxi,d_mul(Xxr,Xxr))))))))),dbb)));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_add(d_mul(d_sub(Xr2,d_imul(3,Xi2)),d_diffabs(Xr,xr)),d_mul(d_sub(d_sub(d_add(d_mul(d_imul(2,xr),Xr),xr2),d_mul(d_imul(6,Xi),xi)),d_imul(3,xi2)),d_abs(d_add(Xr,xr)))),cr);
xin=d_sub(ci,d_diffabs(d_mul(Xi,d_sub(d_imul(3,Xr2),Xi2)),d_sub(d_add(d_mul(d_imul(3,Xi),d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),xi2)),d_mul(d_imul(3,xi),d_add(d_add(Xr2,d_mul(d_imul(2,Xr),xr)),xr2))),d_mul(xi,d_add(d_imul(3,Xi2),xi2)))));
}

);

static const char *perturbation_opencl_floatexp_10_3_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_mul(fe_sub(Xr2,fe_imul(3,Xi2)),fe_diffabs(Xr,xr)),fe_mul(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,xr),Xr),xr2),fe_mul(fe_imul(6,Xi),xi)),fe_imul(3,xi2)),fe_abs(fe_add(Xr,xr)))),cr);
xin=fe_sub(ci,fe_diffabs(fe_mul(Xi,fe_sub(fe_imul(3,Xr2),Xi2)),fe_sub(fe_add(fe_mul(fe_imul(3,Xi),fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),xi2)),fe_mul(fe_imul(3,xi),fe_add(fe_add(Xr2,fe_mul(fe_imul(2,Xr),xr)),xr2))),fe_mul(xi,fe_add(fe_imul(3,Xi2),xi2)))));
}

);

static const char *perturbation_opencl_floatexp_10_3_1 = STR(

{dxan=fe_add(fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr)))),fe_add(fe_imul(2,fe_mul(fe_abs(Xxr),fe_mul(Xxr,dxa))),fe_add(fe_imul(-3,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxa,fe_sgn(Xxr))))),fe_add(fe_imul(-6,fe_mul(fe_abs(Xxr),fe_mul(Xxi,dya))),daa))));
dxbn=fe_add(fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr)))),fe_add(fe_imul(2,fe_mul(fe_abs(Xxr),fe_mul(Xxr,dxb))),fe_add(fe_imul(-3,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxb,fe_sgn(Xxr))))),fe_add(fe_imul(-6,fe_mul(fe_abs(Xxr),fe_mul(Xxi,dyb))),dab))));
dyan=fe_add(fe_imul(-3,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_imul(3,fe_mul(Xxi,fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(3,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dya,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_imul(3,fe_mul(Xxi,fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_imul(3,fe_mul(Xxi,fe_mul(Xxr,Xxr))))))))),dba)));
dybn=fe_add(fe_imul(-3,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_imul(3,fe_mul(Xxi,fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(3,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dyb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_imul(3,fe_mul(Xxi,fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_imul(3,fe_mul(Xxi,fe_mul(Xxr,Xxr))))))))),dbb)));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_mul(fe_sub(Xr2,fe_imul(3,Xi2)),fe_diffabs(Xr,xr)),fe_mul(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,xr),Xr),xr2),fe_mul(fe_imul(6,Xi),xi)),fe_imul(3,xi2)),fe_abs(fe_add(Xr,xr)))),cr);
xin=fe_sub(ci,fe_diffabs(fe_mul(Xi,fe_sub(fe_imul(3,Xr2),Xi2)),fe_sub(fe_add(fe_mul(fe_imul(3,Xi),fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),xi2)),fe_mul(fe_imul(3,xi),fe_add(fe_add(Xr2,fe_mul(fe_imul(2,Xr),xr)),xr2))),fe_mul(xi,fe_add(fe_imul(3,Xi2),xi2)))));
}

);

#if 0
static const char *perturbation_opencl_softfloat_10_3_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_add(sf_mul(sf_sub(Xr2,sf_imul(3,Xi2)),sf_diffabs(Xr,xr)),sf_mul(sf_sub(sf_sub(sf_add(sf_mul(sf_imul(2,xr),Xr),xr2),sf_mul(sf_imul(6,Xi),xi)),sf_imul(3,xi2)),sf_abs(sf_add(Xr,xr)))),cr);
xin=sf_sub(ci,sf_diffabs(sf_mul(Xi,sf_sub(sf_imul(3,Xr2),Xi2)),sf_sub(sf_add(sf_mul(sf_imul(3,Xi),sf_sub(sf_add(sf_mul(sf_imul(2,Xr),xr),xr2),xi2)),sf_mul(sf_imul(3,xi),sf_add(sf_add(Xr2,sf_mul(sf_imul(2,Xr),xr)),xr2))),sf_mul(xi,sf_add(sf_imul(3,Xi2),xi2)))));
}

);
#endif


static const char *perturbation_opencl_double_11_3_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_add(d_mul(d_sub(Xr2,d_imul(3,Xi2)),d_diffabs(Xr,xr)),d_mul(d_sub(d_sub(d_add(d_mul(d_imul(2,xr),Xr),xr2),d_mul(d_imul(6,Xi),xi)),d_imul(3,xi2)),d_abs(d_add(Xr,xr)))),cr);
xin=d_add(d_add(d_add(d_add(d_mul(d_imul(6,Xr),d_add(d_mul(Xi,xr),d_mul(xr,xi))),d_mul(d_imul(3,Xi),d_sub(xr2,xi2))),d_mul(d_imul(3,xi),d_sub(Xr2,Xi2))),d_mul(xi,d_sub(d_imul(3,xr2),xi2))),ci);
}

);

static const char *perturbation_opencl_double_11_3_1 = STR(

{dxan=d_add(d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr)))),d_add(d_imul(2,d_mul(d_abs(Xxr),d_mul(Xxr,dxa))),d_add(d_imul(-3,d_mul(Xxi,d_mul(Xxi,d_mul(dxa,d_sgn(Xxr))))),d_add(d_imul(-6,d_mul(d_abs(Xxr),d_mul(Xxi,dya))),daa))));
dxbn=d_add(d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr)))),d_add(d_imul(2,d_mul(d_abs(Xxr),d_mul(Xxr,dxb))),d_add(d_imul(-3,d_mul(Xxi,d_mul(Xxi,d_mul(dxb,d_sgn(Xxr))))),d_add(d_imul(-6,d_mul(d_abs(Xxr),d_mul(Xxi,dyb))),dab))));
dyan=d_add(d_imul(3,d_mul(Xxr,d_mul(Xxr,dya))),d_add(d_imul(-3,d_mul(Xxi,d_mul(Xxi,dya))),d_add(d_imul(6,d_mul(Xxi,d_mul(Xxr,dxa))),dba)));
dybn=d_add(d_imul(3,d_mul(Xxr,d_mul(Xxr,dyb))),d_add(d_imul(-3,d_mul(Xxi,d_mul(Xxi,dyb))),d_add(d_imul(6,d_mul(Xxi,d_mul(Xxr,dxb))),dbb)));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_add(d_mul(d_sub(Xr2,d_imul(3,Xi2)),d_diffabs(Xr,xr)),d_mul(d_sub(d_sub(d_add(d_mul(d_imul(2,xr),Xr),xr2),d_mul(d_imul(6,Xi),xi)),d_imul(3,xi2)),d_abs(d_add(Xr,xr)))),cr);
xin=d_add(d_add(d_add(d_add(d_mul(d_imul(6,Xr),d_add(d_mul(Xi,xr),d_mul(xr,xi))),d_mul(d_imul(3,Xi),d_sub(xr2,xi2))),d_mul(d_imul(3,xi),d_sub(Xr2,Xi2))),d_mul(xi,d_sub(d_imul(3,xr2),xi2))),ci);
}

);

static const char *perturbation_opencl_floatexp_11_3_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_mul(fe_sub(Xr2,fe_imul(3,Xi2)),fe_diffabs(Xr,xr)),fe_mul(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,xr),Xr),xr2),fe_mul(fe_imul(6,Xi),xi)),fe_imul(3,xi2)),fe_abs(fe_add(Xr,xr)))),cr);
xin=fe_add(fe_add(fe_add(fe_add(fe_mul(fe_imul(6,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xr,xi))),fe_mul(fe_imul(3,Xi),fe_sub(xr2,xi2))),fe_mul(fe_imul(3,xi),fe_sub(Xr2,Xi2))),fe_mul(xi,fe_sub(fe_imul(3,xr2),xi2))),ci);
}

);

static const char *perturbation_opencl_floatexp_11_3_1 = STR(

{dxan=fe_add(fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr)))),fe_add(fe_imul(2,fe_mul(fe_abs(Xxr),fe_mul(Xxr,dxa))),fe_add(fe_imul(-3,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxa,fe_sgn(Xxr))))),fe_add(fe_imul(-6,fe_mul(fe_abs(Xxr),fe_mul(Xxi,dya))),daa))));
dxbn=fe_add(fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr)))),fe_add(fe_imul(2,fe_mul(fe_abs(Xxr),fe_mul(Xxr,dxb))),fe_add(fe_imul(-3,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxb,fe_sgn(Xxr))))),fe_add(fe_imul(-6,fe_mul(fe_abs(Xxr),fe_mul(Xxi,dyb))),dab))));
dyan=fe_add(fe_imul(3,fe_mul(Xxr,fe_mul(Xxr,dya))),fe_add(fe_imul(-3,fe_mul(Xxi,fe_mul(Xxi,dya))),fe_add(fe_imul(6,fe_mul(Xxi,fe_mul(Xxr,dxa))),dba)));
dybn=fe_add(fe_imul(3,fe_mul(Xxr,fe_mul(Xxr,dyb))),fe_add(fe_imul(-3,fe_mul(Xxi,fe_mul(Xxi,dyb))),fe_add(fe_imul(6,fe_mul(Xxi,fe_mul(Xxr,dxb))),dbb)));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_mul(fe_sub(Xr2,fe_imul(3,Xi2)),fe_diffabs(Xr,xr)),fe_mul(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,xr),Xr),xr2),fe_mul(fe_imul(6,Xi),xi)),fe_imul(3,xi2)),fe_abs(fe_add(Xr,xr)))),cr);
xin=fe_add(fe_add(fe_add(fe_add(fe_mul(fe_imul(6,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xr,xi))),fe_mul(fe_imul(3,Xi),fe_sub(xr2,xi2))),fe_mul(fe_imul(3,xi),fe_sub(Xr2,Xi2))),fe_mul(xi,fe_sub(fe_imul(3,xr2),xi2))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_11_3_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_add(sf_mul(sf_sub(Xr2,sf_imul(3,Xi2)),sf_diffabs(Xr,xr)),sf_mul(sf_sub(sf_sub(sf_add(sf_mul(sf_imul(2,xr),Xr),xr2),sf_mul(sf_imul(6,Xi),xi)),sf_imul(3,xi2)),sf_abs(sf_add(Xr,xr)))),cr);
xin=sf_add(sf_add(sf_add(sf_add(sf_mul(sf_imul(6,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xr,xi))),sf_mul(sf_imul(3,Xi),sf_sub(xr2,xi2))),sf_mul(sf_imul(3,xi),sf_sub(Xr2,Xi2))),sf_mul(xi,sf_sub(sf_imul(3,xr2),xi2))),ci);
}

);
#endif


static const char *perturbation_opencl_double_12_3_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_sub(d_add(d_mul(d_imul(3,Xr2),xr),d_mul(d_imul(3,Xr),xr2)),d_mul(d_mul(d_imul(6,Xr),Xi),xi)),d_mul(d_imul(3,Xr),xi2)),d_mul(xr,xr2)),d_mul(d_imul(3,Xi2),xr)),d_mul(d_mul(d_imul(6,Xi),xr),xi)),d_mul(d_imul(3,xr),xi2)),cr);
xin=d_add(d_add(d_mul(d_sub(d_imul(3,Xr2),Xi2),d_diffabs(Xi,xi)),d_mul(d_sub(d_sub(d_add(d_mul(d_imul(6,xr),Xr),d_imul(3,xr2)),d_mul(d_imul(2,Xi),xi)),xi2),d_abs(d_add(Xi,xi)))),ci);
}

);

static const char *perturbation_opencl_double_12_3_1 = STR(

{dxan=d_add(d_imul(3,d_mul(Xxr,d_mul(Xxr,dxa))),d_add(d_imul(-3,d_mul(Xxi,d_mul(Xxi,dxa))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxr,dya))),daa)));
dxbn=d_add(d_imul(3,d_mul(Xxr,d_mul(Xxr,dxb))),d_add(d_imul(-3,d_mul(Xxi,d_mul(Xxi,dxb))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxr,dyb))),dab)));
dyan=d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,d_mul(dya,d_sgn(Xxi))))),d_add(d_imul(-2,d_mul(d_abs(Xxi),d_mul(Xxi,dya))),d_add(d_imul(3,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(Xxi))))),d_add(d_imul(6,d_mul(d_abs(Xxi),d_mul(Xxr,dxa))),dba))));
dybn=d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,d_mul(dyb,d_sgn(Xxi))))),d_add(d_imul(-2,d_mul(d_abs(Xxi),d_mul(Xxi,dyb))),d_add(d_imul(3,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(Xxi))))),d_add(d_imul(6,d_mul(d_abs(Xxi),d_mul(Xxr,dxb))),dbb))));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_sub(d_add(d_mul(d_imul(3,Xr2),xr),d_mul(d_imul(3,Xr),xr2)),d_mul(d_mul(d_imul(6,Xr),Xi),xi)),d_mul(d_imul(3,Xr),xi2)),d_mul(xr,xr2)),d_mul(d_imul(3,Xi2),xr)),d_mul(d_mul(d_imul(6,Xi),xr),xi)),d_mul(d_imul(3,xr),xi2)),cr);
xin=d_add(d_add(d_mul(d_sub(d_imul(3,Xr2),Xi2),d_diffabs(Xi,xi)),d_mul(d_sub(d_sub(d_add(d_mul(d_imul(6,xr),Xr),d_imul(3,xr2)),d_mul(d_imul(2,Xi),xi)),xi2),d_abs(d_add(Xi,xi)))),ci);
}

);

static const char *perturbation_opencl_floatexp_12_3_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(3,Xr2),xr),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(fe_mul(fe_imul(6,Xr),Xi),xi)),fe_mul(fe_imul(3,Xr),xi2)),fe_mul(xr,xr2)),fe_mul(fe_imul(3,Xi2),xr)),fe_mul(fe_mul(fe_imul(6,Xi),xr),xi)),fe_mul(fe_imul(3,xr),xi2)),cr);
xin=fe_add(fe_add(fe_mul(fe_sub(fe_imul(3,Xr2),Xi2),fe_diffabs(Xi,xi)),fe_mul(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(6,xr),Xr),fe_imul(3,xr2)),fe_mul(fe_imul(2,Xi),xi)),xi2),fe_abs(fe_add(Xi,xi)))),ci);
}

);

static const char *perturbation_opencl_floatexp_12_3_1 = STR(

{dxan=fe_add(fe_imul(3,fe_mul(Xxr,fe_mul(Xxr,dxa))),fe_add(fe_imul(-3,fe_mul(Xxi,fe_mul(Xxi,dxa))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxr,dya))),daa)));
dxbn=fe_add(fe_imul(3,fe_mul(Xxr,fe_mul(Xxr,dxb))),fe_add(fe_imul(-3,fe_mul(Xxi,fe_mul(Xxi,dxb))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxr,dyb))),dab)));
dyan=fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dya,fe_sgn(Xxi))))),fe_add(fe_imul(-2,fe_mul(fe_abs(Xxi),fe_mul(Xxi,dya))),fe_add(fe_imul(3,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxi))))),fe_add(fe_imul(6,fe_mul(fe_abs(Xxi),fe_mul(Xxr,dxa))),dba))));
dybn=fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dyb,fe_sgn(Xxi))))),fe_add(fe_imul(-2,fe_mul(fe_abs(Xxi),fe_mul(Xxi,dyb))),fe_add(fe_imul(3,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxi))))),fe_add(fe_imul(6,fe_mul(fe_abs(Xxi),fe_mul(Xxr,dxb))),dbb))));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(3,Xr2),xr),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(fe_mul(fe_imul(6,Xr),Xi),xi)),fe_mul(fe_imul(3,Xr),xi2)),fe_mul(xr,xr2)),fe_mul(fe_imul(3,Xi2),xr)),fe_mul(fe_mul(fe_imul(6,Xi),xr),xi)),fe_mul(fe_imul(3,xr),xi2)),cr);
xin=fe_add(fe_add(fe_mul(fe_sub(fe_imul(3,Xr2),Xi2),fe_diffabs(Xi,xi)),fe_mul(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(6,xr),Xr),fe_imul(3,xr2)),fe_mul(fe_imul(2,Xi),xi)),xi2),fe_abs(fe_add(Xi,xi)))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_12_3_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_sub(sf_sub(sf_add(sf_mul(sf_imul(3,Xr2),xr),sf_mul(sf_imul(3,Xr),xr2)),sf_mul(sf_mul(sf_imul(6,Xr),Xi),xi)),sf_mul(sf_imul(3,Xr),xi2)),sf_mul(xr,xr2)),sf_mul(sf_imul(3,Xi2),xr)),sf_mul(sf_mul(sf_imul(6,Xi),xr),xi)),sf_mul(sf_imul(3,xr),xi2)),cr);
xin=sf_add(sf_add(sf_mul(sf_sub(sf_imul(3,Xr2),Xi2),sf_diffabs(Xi,xi)),sf_mul(sf_sub(sf_sub(sf_add(sf_mul(sf_imul(6,xr),Xr),sf_imul(3,xr2)),sf_mul(sf_imul(2,Xi),xi)),xi2),sf_abs(sf_add(Xi,xi)))),ci);
}

);
#endif


static const char *perturbation_opencl_double_13_3_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_sub(d_add(d_mul(d_imul(3,Xr2),xr),d_mul(d_imul(3,Xr),xr2)),d_mul(d_mul(d_imul(6,Xr),Xi),xi)),d_mul(d_imul(3,Xr),xi2)),d_mul(xr,xr2)),d_mul(d_imul(3,Xi2),xr)),d_mul(d_mul(d_imul(6,Xi),xr),xi)),d_mul(d_imul(3,xr),xi2)),cr);
xin=d_add(d_diffabs(d_mul(Xi,d_sub(d_imul(3,Xr2),Xi2)),d_sub(d_add(d_mul(d_imul(3,Xi),d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),xi2)),d_mul(d_imul(3,xi),d_add(d_add(Xr2,d_mul(d_imul(2,Xr),xr)),xr2))),d_mul(xi,d_add(d_imul(3,Xi2),xi2)))),ci);
}

);

static const char *perturbation_opencl_double_13_3_1 = STR(

{dxan=d_add(d_imul(3,d_mul(Xxr,d_mul(Xxr,dxa))),d_add(d_imul(-3,d_mul(Xxi,d_mul(Xxi,dxa))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxr,dya))),daa)));
dxbn=d_add(d_imul(3,d_mul(Xxr,d_mul(Xxr,dxb))),d_add(d_imul(-3,d_mul(Xxi,d_mul(Xxi,dxb))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxr,dyb))),dab)));
dyan=d_add(d_imul(3,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxi))),d_imul(3,d_mul(Xxi,d_mul(Xxr,Xxr))))))))),d_add(d_imul(-3,d_mul(Xxi,d_mul(Xxi,d_mul(dya,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxi))),d_imul(3,d_mul(Xxi,d_mul(Xxr,Xxr))))))))),d_add(d_imul(6,d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxi))),d_imul(3,d_mul(Xxi,d_mul(Xxr,Xxr))))))))),dba)));
dybn=d_add(d_imul(3,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxi))),d_imul(3,d_mul(Xxi,d_mul(Xxr,Xxr))))))))),d_add(d_imul(-3,d_mul(Xxi,d_mul(Xxi,d_mul(dyb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxi))),d_imul(3,d_mul(Xxi,d_mul(Xxr,Xxr))))))))),d_add(d_imul(6,d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxi))),d_imul(3,d_mul(Xxi,d_mul(Xxr,Xxr))))))))),dbb)));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_sub(d_add(d_mul(d_imul(3,Xr2),xr),d_mul(d_imul(3,Xr),xr2)),d_mul(d_mul(d_imul(6,Xr),Xi),xi)),d_mul(d_imul(3,Xr),xi2)),d_mul(xr,xr2)),d_mul(d_imul(3,Xi2),xr)),d_mul(d_mul(d_imul(6,Xi),xr),xi)),d_mul(d_imul(3,xr),xi2)),cr);
xin=d_add(d_diffabs(d_mul(Xi,d_sub(d_imul(3,Xr2),Xi2)),d_sub(d_add(d_mul(d_imul(3,Xi),d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),xi2)),d_mul(d_imul(3,xi),d_add(d_add(Xr2,d_mul(d_imul(2,Xr),xr)),xr2))),d_mul(xi,d_add(d_imul(3,Xi2),xi2)))),ci);
}

);

static const char *perturbation_opencl_floatexp_13_3_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(3,Xr2),xr),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(fe_mul(fe_imul(6,Xr),Xi),xi)),fe_mul(fe_imul(3,Xr),xi2)),fe_mul(xr,xr2)),fe_mul(fe_imul(3,Xi2),xr)),fe_mul(fe_mul(fe_imul(6,Xi),xr),xi)),fe_mul(fe_imul(3,xr),xi2)),cr);
xin=fe_add(fe_diffabs(fe_mul(Xi,fe_sub(fe_imul(3,Xr2),Xi2)),fe_sub(fe_add(fe_mul(fe_imul(3,Xi),fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),xi2)),fe_mul(fe_imul(3,xi),fe_add(fe_add(Xr2,fe_mul(fe_imul(2,Xr),xr)),xr2))),fe_mul(xi,fe_add(fe_imul(3,Xi2),xi2)))),ci);
}

);

static const char *perturbation_opencl_floatexp_13_3_1 = STR(

{dxan=fe_add(fe_imul(3,fe_mul(Xxr,fe_mul(Xxr,dxa))),fe_add(fe_imul(-3,fe_mul(Xxi,fe_mul(Xxi,dxa))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxr,dya))),daa)));
dxbn=fe_add(fe_imul(3,fe_mul(Xxr,fe_mul(Xxr,dxb))),fe_add(fe_imul(-3,fe_mul(Xxi,fe_mul(Xxi,dxb))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxr,dyb))),dab)));
dyan=fe_add(fe_imul(3,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_imul(3,fe_mul(Xxi,fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(-3,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dya,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_imul(3,fe_mul(Xxi,fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(6,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_imul(3,fe_mul(Xxi,fe_mul(Xxr,Xxr))))))))),dba)));
dybn=fe_add(fe_imul(3,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_imul(3,fe_mul(Xxi,fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(-3,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dyb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_imul(3,fe_mul(Xxi,fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(6,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_imul(3,fe_mul(Xxi,fe_mul(Xxr,Xxr))))))))),dbb)));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(3,Xr2),xr),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(fe_mul(fe_imul(6,Xr),Xi),xi)),fe_mul(fe_imul(3,Xr),xi2)),fe_mul(xr,xr2)),fe_mul(fe_imul(3,Xi2),xr)),fe_mul(fe_mul(fe_imul(6,Xi),xr),xi)),fe_mul(fe_imul(3,xr),xi2)),cr);
xin=fe_add(fe_diffabs(fe_mul(Xi,fe_sub(fe_imul(3,Xr2),Xi2)),fe_sub(fe_add(fe_mul(fe_imul(3,Xi),fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),xi2)),fe_mul(fe_imul(3,xi),fe_add(fe_add(Xr2,fe_mul(fe_imul(2,Xr),xr)),xr2))),fe_mul(xi,fe_add(fe_imul(3,Xi2),xi2)))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_13_3_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_sub(sf_sub(sf_add(sf_mul(sf_imul(3,Xr2),xr),sf_mul(sf_imul(3,Xr),xr2)),sf_mul(sf_mul(sf_imul(6,Xr),Xi),xi)),sf_mul(sf_imul(3,Xr),xi2)),sf_mul(xr,xr2)),sf_mul(sf_imul(3,Xi2),xr)),sf_mul(sf_mul(sf_imul(6,Xi),xr),xi)),sf_mul(sf_imul(3,xr),xi2)),cr);
xin=sf_add(sf_diffabs(sf_mul(Xi,sf_sub(sf_imul(3,Xr2),Xi2)),sf_sub(sf_add(sf_mul(sf_imul(3,Xi),sf_sub(sf_add(sf_mul(sf_imul(2,Xr),xr),xr2),xi2)),sf_mul(sf_imul(3,xi),sf_add(sf_add(Xr2,sf_mul(sf_imul(2,Xr),xr)),xr2))),sf_mul(xi,sf_add(sf_imul(3,Xi2),xi2)))),ci);
}

);
#endif


static const char *perturbation_opencl_double_14_3_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_add(d_mul(d_sub(Xr2,d_imul(3,Xi2)),d_diffabs(Xr,xr)),d_mul(d_sub(d_sub(d_add(d_mul(d_imul(2,xr),Xr),xr2),d_mul(d_imul(6,Xi),xi)),d_imul(3,xi2)),d_abs(d_add(Xr,xr)))),cr);
xin=d_sub(d_sub(ci,d_mul(d_diffabs(d_sub(d_imul(3,Xr2),Xi2),d_sub(d_sub(d_add(d_mul(d_imul(6,Xr),xr),d_imul(3,xr2)),d_mul(d_imul(2,Xi),xi)),xi2)),Xi)),d_mul(d_abs(d_sub(d_sub(d_sub(d_add(d_add(d_imul(3,Xr2),d_mul(d_imul(6,Xr),xr)),d_imul(3,xr2)),Xi2),d_mul(d_imul(2,Xi),xi)),xi2)),xi));
}

);

static const char *perturbation_opencl_double_14_3_1 = STR(

{dxan=d_add(d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr)))),d_add(d_imul(2,d_mul(d_abs(Xxr),d_mul(Xxr,dxa))),d_add(d_imul(-3,d_mul(Xxi,d_mul(Xxi,d_mul(dxa,d_sgn(Xxr))))),d_add(d_imul(-6,d_mul(d_abs(Xxr),d_mul(Xxi,dya))),daa))));
dxbn=d_add(d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr)))),d_add(d_imul(2,d_mul(d_abs(Xxr),d_mul(Xxr,dxb))),d_add(d_imul(-3,d_mul(Xxi,d_mul(Xxi,d_mul(dxb,d_sgn(Xxr))))),d_add(d_imul(-6,d_mul(d_abs(Xxr),d_mul(Xxi,dyb))),dab))));
dyan=d_add(dba,d_add(d_imul(2,d_mul(Xxi,d_mul(Xxi,d_mul(dya,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_imul(3,d_mul(Xxr,Xxr)))))))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_imul(3,d_mul(Xxr,Xxr)))))))),d_imul(-1,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_imul(3,d_mul(Xxr,Xxr)))),dya)))));
dybn=d_add(dbb,d_add(d_imul(2,d_mul(Xxi,d_mul(Xxi,d_mul(dyb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_imul(3,d_mul(Xxr,Xxr)))))))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_imul(3,d_mul(Xxr,Xxr)))))))),d_imul(-1,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_imul(3,d_mul(Xxr,Xxr)))),dyb)))));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_add(d_mul(d_sub(Xr2,d_imul(3,Xi2)),d_diffabs(Xr,xr)),d_mul(d_sub(d_sub(d_add(d_mul(d_imul(2,xr),Xr),xr2),d_mul(d_imul(6,Xi),xi)),d_imul(3,xi2)),d_abs(d_add(Xr,xr)))),cr);
xin=d_sub(d_sub(ci,d_mul(d_diffabs(d_sub(d_imul(3,Xr2),Xi2),d_sub(d_sub(d_add(d_mul(d_imul(6,Xr),xr),d_imul(3,xr2)),d_mul(d_imul(2,Xi),xi)),xi2)),Xi)),d_mul(d_abs(d_sub(d_sub(d_sub(d_add(d_add(d_imul(3,Xr2),d_mul(d_imul(6,Xr),xr)),d_imul(3,xr2)),Xi2),d_mul(d_imul(2,Xi),xi)),xi2)),xi));
}

);

static const char *perturbation_opencl_floatexp_14_3_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_mul(fe_sub(Xr2,fe_imul(3,Xi2)),fe_diffabs(Xr,xr)),fe_mul(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,xr),Xr),xr2),fe_mul(fe_imul(6,Xi),xi)),fe_imul(3,xi2)),fe_abs(fe_add(Xr,xr)))),cr);
xin=fe_sub(fe_sub(ci,fe_mul(fe_diffabs(fe_sub(fe_imul(3,Xr2),Xi2),fe_sub(fe_sub(fe_add(fe_mul(fe_imul(6,Xr),xr),fe_imul(3,xr2)),fe_mul(fe_imul(2,Xi),xi)),xi2)),Xi)),fe_mul(fe_abs(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_imul(3,Xr2),fe_mul(fe_imul(6,Xr),xr)),fe_imul(3,xr2)),Xi2),fe_mul(fe_imul(2,Xi),xi)),xi2)),xi));
}

);

static const char *perturbation_opencl_floatexp_14_3_1 = STR(

{dxan=fe_add(fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr)))),fe_add(fe_imul(2,fe_mul(fe_abs(Xxr),fe_mul(Xxr,dxa))),fe_add(fe_imul(-3,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxa,fe_sgn(Xxr))))),fe_add(fe_imul(-6,fe_mul(fe_abs(Xxr),fe_mul(Xxi,dya))),daa))));
dxbn=fe_add(fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr)))),fe_add(fe_imul(2,fe_mul(fe_abs(Xxr),fe_mul(Xxr,dxb))),fe_add(fe_imul(-3,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxb,fe_sgn(Xxr))))),fe_add(fe_imul(-6,fe_mul(fe_abs(Xxr),fe_mul(Xxi,dyb))),dab))));
dyan=fe_add(dba,fe_add(fe_imul(2,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dya,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_imul(3,fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_imul(3,fe_mul(Xxr,Xxr)))))))),fe_imul(-1,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_imul(3,fe_mul(Xxr,Xxr)))),dya)))));
dybn=fe_add(dbb,fe_add(fe_imul(2,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dyb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_imul(3,fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_imul(3,fe_mul(Xxr,Xxr)))))))),fe_imul(-1,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_imul(3,fe_mul(Xxr,Xxr)))),dyb)))));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_mul(fe_sub(Xr2,fe_imul(3,Xi2)),fe_diffabs(Xr,xr)),fe_mul(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,xr),Xr),xr2),fe_mul(fe_imul(6,Xi),xi)),fe_imul(3,xi2)),fe_abs(fe_add(Xr,xr)))),cr);
xin=fe_sub(fe_sub(ci,fe_mul(fe_diffabs(fe_sub(fe_imul(3,Xr2),Xi2),fe_sub(fe_sub(fe_add(fe_mul(fe_imul(6,Xr),xr),fe_imul(3,xr2)),fe_mul(fe_imul(2,Xi),xi)),xi2)),Xi)),fe_mul(fe_abs(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_imul(3,Xr2),fe_mul(fe_imul(6,Xr),xr)),fe_imul(3,xr2)),Xi2),fe_mul(fe_imul(2,Xi),xi)),xi2)),xi));
}

);

#if 0
static const char *perturbation_opencl_softfloat_14_3_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_add(sf_mul(sf_sub(Xr2,sf_imul(3,Xi2)),sf_diffabs(Xr,xr)),sf_mul(sf_sub(sf_sub(sf_add(sf_mul(sf_imul(2,xr),Xr),xr2),sf_mul(sf_imul(6,Xi),xi)),sf_imul(3,xi2)),sf_abs(sf_add(Xr,xr)))),cr);
xin=sf_sub(sf_sub(ci,sf_mul(sf_diffabs(sf_sub(sf_imul(3,Xr2),Xi2),sf_sub(sf_sub(sf_add(sf_mul(sf_imul(6,Xr),xr),sf_imul(3,xr2)),sf_mul(sf_imul(2,Xi),xi)),xi2)),Xi)),sf_mul(sf_abs(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_imul(3,Xr2),sf_mul(sf_imul(6,Xr),xr)),sf_imul(3,xr2)),Xi2),sf_mul(sf_imul(2,Xi),xi)),xi2)),xi));
}

);
#endif


static const char *perturbation_opencl_double_15_4_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_mul(d_imul(12,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(24,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(12,Xr),xr),xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xr2),Xi),xi)),d_mul(d_imul(6,xr2),xi2)),cr);
xin=d_add(d_add(d_mul(d_abs(d_add(Xi,xi)),d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_mul(d_imul(12,Xr2),xr),d_mul(d_imul(12,Xr),xr2)),d_mul(d_imul(4,xr2),xr)),d_mul(d_imul(4,xr),Xi2)),d_mul(d_mul(d_imul(8,xi),Xr),Xi)),d_mul(d_mul(d_imul(8,xr),xi),Xi)),d_mul(d_imul(4,xi2),Xr)),d_mul(d_imul(4,xr),xi2))),d_mul(d_diffabs(Xi,xi),d_sub(d_mul(d_imul(4,Xr2),Xr),d_mul(d_imul(4,Xr),Xi2)))),ci);
}

);

static const char *perturbation_opencl_double_15_4_1 = STR(

{dxan=d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dxa)))),d_add(d_imul(4,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dya,d_sgn(Xxi))))))))),d_add(d_imul(-12,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxr,dxa))),d_add(d_imul(-12,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(Xxi))))))),daa))));
dxbn=d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dxb)))),d_add(d_imul(4,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dyb,d_sgn(Xxi))))))))),d_add(d_imul(-12,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxr,dxb))),d_add(d_imul(-12,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(Xxi))))))),dab))));
dyan=d_add(dba,d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(Xxi)))))),d_add(d_imul(12,d_mul(d_abs(Xxi),d_mul(Xxr,d_mul(Xxr,dxa)))),d_add(d_imul(-12,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_sgn(Xxi)))))))),d_imul(-4,d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))),dxa))))));
dybn=d_add(dbb,d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(Xxi)))))),d_add(d_imul(12,d_mul(d_abs(Xxi),d_mul(Xxr,d_mul(Xxr,dxb)))),d_add(d_imul(-12,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_sgn(Xxi)))))))),d_imul(-4,d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))),dxb))))));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_mul(d_imul(12,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(24,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(12,Xr),xr),xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xr2),Xi),xi)),d_mul(d_imul(6,xr2),xi2)),cr);
xin=d_add(d_add(d_mul(d_abs(d_add(Xi,xi)),d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_mul(d_imul(12,Xr2),xr),d_mul(d_imul(12,Xr),xr2)),d_mul(d_imul(4,xr2),xr)),d_mul(d_imul(4,xr),Xi2)),d_mul(d_mul(d_imul(8,xi),Xr),Xi)),d_mul(d_mul(d_imul(8,xr),xi),Xi)),d_mul(d_imul(4,xi2),Xr)),d_mul(d_imul(4,xr),xi2))),d_mul(d_diffabs(Xi,xi),d_sub(d_mul(d_imul(4,Xr2),Xr),d_mul(d_imul(4,Xr),Xi2)))),ci);
}

);

static const char *perturbation_opencl_floatexp_15_4_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_mul(fe_imul(12,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(12,Xr),xr),xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xr2),Xi),xi)),fe_mul(fe_imul(6,xr2),xi2)),cr);
xin=fe_add(fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_mul(fe_imul(12,Xr2),xr),fe_mul(fe_imul(12,Xr),xr2)),fe_mul(fe_imul(4,xr2),xr)),fe_mul(fe_imul(4,xr),Xi2)),fe_mul(fe_mul(fe_imul(8,xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(8,xr),xi),Xi)),fe_mul(fe_imul(4,xi2),Xr)),fe_mul(fe_imul(4,xr),xi2))),fe_mul(fe_diffabs(Xi,xi),fe_sub(fe_mul(fe_imul(4,Xr2),Xr),fe_mul(fe_imul(4,Xr),Xi2)))),ci);
}

);

static const char *perturbation_opencl_floatexp_15_4_1 = STR(

{dxan=fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dxa)))),fe_add(fe_imul(4,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dya,fe_sgn(Xxi))))))))),fe_add(fe_imul(-12,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxr,dxa))),fe_add(fe_imul(-12,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxi))))))),daa))));
dxbn=fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dxb)))),fe_add(fe_imul(4,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dyb,fe_sgn(Xxi))))))))),fe_add(fe_imul(-12,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxr,dxb))),fe_add(fe_imul(-12,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxi))))))),dab))));
dyan=fe_add(dba,fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxi)))))),fe_add(fe_imul(12,fe_mul(fe_abs(Xxi),fe_mul(Xxr,fe_mul(Xxr,dxa)))),fe_add(fe_imul(-12,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxi)))))))),fe_imul(-4,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))),dxa))))));
dybn=fe_add(dbb,fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxi)))))),fe_add(fe_imul(12,fe_mul(fe_abs(Xxi),fe_mul(Xxr,fe_mul(Xxr,dxb)))),fe_add(fe_imul(-12,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxi)))))))),fe_imul(-4,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))),dxb))))));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_mul(fe_imul(12,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(12,Xr),xr),xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xr2),Xi),xi)),fe_mul(fe_imul(6,xr2),xi2)),cr);
xin=fe_add(fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_mul(fe_imul(12,Xr2),xr),fe_mul(fe_imul(12,Xr),xr2)),fe_mul(fe_imul(4,xr2),xr)),fe_mul(fe_imul(4,xr),Xi2)),fe_mul(fe_mul(fe_imul(8,xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(8,xr),xi),Xi)),fe_mul(fe_imul(4,xi2),Xr)),fe_mul(fe_imul(4,xr),xi2))),fe_mul(fe_diffabs(Xi,xi),fe_sub(fe_mul(fe_imul(4,Xr2),Xr),fe_mul(fe_imul(4,Xr),Xi2)))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_15_4_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_mul(sf_imul(4,Xi),xi2),xi)),sf_mul(xi2,xi2)),sf_mul(sf_mul(sf_imul(12,Xr2),Xi),xi)),sf_mul(sf_imul(6,Xr2),xi2)),sf_mul(sf_mul(sf_imul(12,Xr),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(24,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_imul(12,Xr),xr),xi2)),sf_mul(sf_imul(6,xr2),Xi2)),sf_mul(sf_mul(sf_imul(12,xr2),Xi),xi)),sf_mul(sf_imul(6,xr2),xi2)),cr);
xin=sf_add(sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_mul(sf_imul(12,Xr2),xr),sf_mul(sf_imul(12,Xr),xr2)),sf_mul(sf_imul(4,xr2),xr)),sf_mul(sf_imul(4,xr),Xi2)),sf_mul(sf_mul(sf_imul(8,xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(8,xr),xi),Xi)),sf_mul(sf_imul(4,xi2),Xr)),sf_mul(sf_imul(4,xr),xi2))),sf_mul(sf_diffabs(Xi,xi),sf_sub(sf_mul(sf_imul(4,Xr2),Xr),sf_mul(sf_imul(4,Xr),Xi2)))),ci);
}

);
#endif


static const char *perturbation_opencl_double_16_4_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_mul(d_imul(12,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(24,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(12,Xr),xr),xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xr2),Xi),xi)),d_mul(d_imul(6,xr2),xi2)),cr);
xin=d_add(d_add(d_mul(d_abs(d_add(Xr,xr)),d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_mul(d_imul(4,Xr2),xi),d_mul(d_mul(d_imul(8,Xr),xr),Xi)),d_mul(d_mul(d_imul(8,Xr),xr),xi)),d_mul(d_imul(4,xr2),Xi)),d_mul(d_imul(4,xr2),xi)),d_mul(d_imul(12,xi),Xi2)),d_mul(d_imul(12,xi2),Xi)),d_mul(d_imul(4,xi2),xi))),d_mul(d_diffabs(Xr,xr),d_sub(d_mul(d_imul(4,Xr2),Xi),d_mul(d_imul(4,Xi2),Xi)))),ci);
}

);

static const char *perturbation_opencl_double_16_4_1 = STR(

{dxan=d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dya)))),d_add(d_imul(4,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr))))))))),d_add(d_imul(-12,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,dya))),d_add(d_imul(-12,d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr))))))),daa))));
dxbn=d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dyb)))),d_add(d_imul(4,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr))))))))),d_add(d_imul(-12,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,dyb))),d_add(d_imul(-12,d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr))))))),dab))));
dyan=d_add(dba,d_add(d_imul(-4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxa,d_sgn(Xxr)))))),d_add(d_imul(-12,d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(Xxi,dya)))),d_add(d_imul(12,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr)))))))),d_imul(4,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),dya))))));
dybn=d_add(dbb,d_add(d_imul(-4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxb,d_sgn(Xxr)))))),d_add(d_imul(-12,d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(Xxi,dyb)))),d_add(d_imul(12,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr)))))))),d_imul(4,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),dyb))))));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_mul(d_imul(12,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(24,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(12,Xr),xr),xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xr2),Xi),xi)),d_mul(d_imul(6,xr2),xi2)),cr);
xin=d_add(d_add(d_mul(d_abs(d_add(Xr,xr)),d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_mul(d_imul(4,Xr2),xi),d_mul(d_mul(d_imul(8,Xr),xr),Xi)),d_mul(d_mul(d_imul(8,Xr),xr),xi)),d_mul(d_imul(4,xr2),Xi)),d_mul(d_imul(4,xr2),xi)),d_mul(d_imul(12,xi),Xi2)),d_mul(d_imul(12,xi2),Xi)),d_mul(d_imul(4,xi2),xi))),d_mul(d_diffabs(Xr,xr),d_sub(d_mul(d_imul(4,Xr2),Xi),d_mul(d_imul(4,Xi2),Xi)))),ci);
}

);

static const char *perturbation_opencl_floatexp_16_4_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_mul(fe_imul(12,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(12,Xr),xr),xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xr2),Xi),xi)),fe_mul(fe_imul(6,xr2),xi2)),cr);
xin=fe_add(fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_imul(4,Xr2),xi),fe_mul(fe_mul(fe_imul(8,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(8,Xr),xr),xi)),fe_mul(fe_imul(4,xr2),Xi)),fe_mul(fe_imul(4,xr2),xi)),fe_mul(fe_imul(12,xi),Xi2)),fe_mul(fe_imul(12,xi2),Xi)),fe_mul(fe_imul(4,xi2),xi))),fe_mul(fe_diffabs(Xr,xr),fe_sub(fe_mul(fe_imul(4,Xr2),Xi),fe_mul(fe_imul(4,Xi2),Xi)))),ci);
}

);

static const char *perturbation_opencl_floatexp_16_4_1 = STR(

{dxan=fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dya)))),fe_add(fe_imul(4,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr))))))))),fe_add(fe_imul(-12,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,dya))),fe_add(fe_imul(-12,fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr))))))),daa))));
dxbn=fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dyb)))),fe_add(fe_imul(4,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr))))))))),fe_add(fe_imul(-12,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,dyb))),fe_add(fe_imul(-12,fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr))))))),dab))));
dyan=fe_add(dba,fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxa,fe_sgn(Xxr)))))),fe_add(fe_imul(-12,fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(Xxi,dya)))),fe_add(fe_imul(12,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr)))))))),fe_imul(4,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),dya))))));
dybn=fe_add(dbb,fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxb,fe_sgn(Xxr)))))),fe_add(fe_imul(-12,fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(Xxi,dyb)))),fe_add(fe_imul(12,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr)))))))),fe_imul(4,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),dyb))))));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_mul(fe_imul(12,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(12,Xr),xr),xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xr2),Xi),xi)),fe_mul(fe_imul(6,xr2),xi2)),cr);
xin=fe_add(fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_imul(4,Xr2),xi),fe_mul(fe_mul(fe_imul(8,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(8,Xr),xr),xi)),fe_mul(fe_imul(4,xr2),Xi)),fe_mul(fe_imul(4,xr2),xi)),fe_mul(fe_imul(12,xi),Xi2)),fe_mul(fe_imul(12,xi2),Xi)),fe_mul(fe_imul(4,xi2),xi))),fe_mul(fe_diffabs(Xr,xr),fe_sub(fe_mul(fe_imul(4,Xr2),Xi),fe_mul(fe_imul(4,Xi2),Xi)))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_16_4_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_mul(sf_imul(4,Xi),xi2),xi)),sf_mul(xi2,xi2)),sf_mul(sf_mul(sf_imul(12,Xr2),Xi),xi)),sf_mul(sf_imul(6,Xr2),xi2)),sf_mul(sf_mul(sf_imul(12,Xr),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(24,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_imul(12,Xr),xr),xi2)),sf_mul(sf_imul(6,xr2),Xi2)),sf_mul(sf_mul(sf_imul(12,xr2),Xi),xi)),sf_mul(sf_imul(6,xr2),xi2)),cr);
xin=sf_add(sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_imul(4,Xr2),xi),sf_mul(sf_mul(sf_imul(8,Xr),xr),Xi)),sf_mul(sf_mul(sf_imul(8,Xr),xr),xi)),sf_mul(sf_imul(4,xr2),Xi)),sf_mul(sf_imul(4,xr2),xi)),sf_mul(sf_imul(12,xi),Xi2)),sf_mul(sf_imul(12,xi2),Xi)),sf_mul(sf_imul(4,xi2),xi))),sf_mul(sf_diffabs(Xr,xr),sf_sub(sf_mul(sf_imul(4,Xr2),Xi),sf_mul(sf_imul(4,Xi2),Xi)))),ci);
}

);
#endif


static const char *perturbation_opencl_double_17_4_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_mul(d_imul(12,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(24,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(12,Xr),xr),xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xr2),Xi),xi)),d_mul(d_imul(6,xr2),xi2)),cr);
xin=d_add(d_add(d_mul(d_abs(d_add(Xr,xr)),d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_mul(d_imul(12,Xi2),xi),d_mul(d_imul(12,Xi),xi2)),d_mul(d_imul(4,xi2),xi)),d_mul(d_mul(d_imul(8,xr),Xr),Xi)),d_mul(d_imul(4,xr2),Xi)),d_mul(d_imul(4,xi),Xr2)),d_mul(d_mul(d_imul(8,xr),xi),Xr)),d_mul(d_imul(4,xr2),xi))),d_mul(d_diffabs(Xr,xr),d_sub(d_mul(d_imul(4,Xi2),Xi),d_mul(d_imul(4,Xr2),Xi)))),ci);
}

);

static const char *perturbation_opencl_double_17_4_1 = STR(

{dxan=d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dya)))),d_add(d_imul(4,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr))))))))),d_add(d_imul(-12,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,dya))),d_add(d_imul(-12,d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr))))))),daa))));
dxbn=d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dyb)))),d_add(d_imul(4,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr))))))))),d_add(d_imul(-12,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,dyb))),d_add(d_imul(-12,d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr))))))),dab))));
dyan=d_add(dba,d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxa,d_sgn(Xxr)))))),d_add(d_imul(12,d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(Xxi,dya)))),d_add(d_imul(-12,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr)))))))),d_imul(-4,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),dya))))));
dybn=d_add(dbb,d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxb,d_sgn(Xxr)))))),d_add(d_imul(12,d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(Xxi,dyb)))),d_add(d_imul(-12,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr)))))))),d_imul(-4,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),dyb))))));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_mul(d_imul(12,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(24,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(12,Xr),xr),xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xr2),Xi),xi)),d_mul(d_imul(6,xr2),xi2)),cr);
xin=d_add(d_add(d_mul(d_abs(d_add(Xr,xr)),d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_mul(d_imul(12,Xi2),xi),d_mul(d_imul(12,Xi),xi2)),d_mul(d_imul(4,xi2),xi)),d_mul(d_mul(d_imul(8,xr),Xr),Xi)),d_mul(d_imul(4,xr2),Xi)),d_mul(d_imul(4,xi),Xr2)),d_mul(d_mul(d_imul(8,xr),xi),Xr)),d_mul(d_imul(4,xr2),xi))),d_mul(d_diffabs(Xr,xr),d_sub(d_mul(d_imul(4,Xi2),Xi),d_mul(d_imul(4,Xr2),Xi)))),ci);
}

);

static const char *perturbation_opencl_floatexp_17_4_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_mul(fe_imul(12,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(12,Xr),xr),xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xr2),Xi),xi)),fe_mul(fe_imul(6,xr2),xi2)),cr);
xin=fe_add(fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_mul(fe_imul(12,Xi2),xi),fe_mul(fe_imul(12,Xi),xi2)),fe_mul(fe_imul(4,xi2),xi)),fe_mul(fe_mul(fe_imul(8,xr),Xr),Xi)),fe_mul(fe_imul(4,xr2),Xi)),fe_mul(fe_imul(4,xi),Xr2)),fe_mul(fe_mul(fe_imul(8,xr),xi),Xr)),fe_mul(fe_imul(4,xr2),xi))),fe_mul(fe_diffabs(Xr,xr),fe_sub(fe_mul(fe_imul(4,Xi2),Xi),fe_mul(fe_imul(4,Xr2),Xi)))),ci);
}

);

static const char *perturbation_opencl_floatexp_17_4_1 = STR(

{dxan=fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dya)))),fe_add(fe_imul(4,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr))))))))),fe_add(fe_imul(-12,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,dya))),fe_add(fe_imul(-12,fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr))))))),daa))));
dxbn=fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dyb)))),fe_add(fe_imul(4,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr))))))))),fe_add(fe_imul(-12,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,dyb))),fe_add(fe_imul(-12,fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr))))))),dab))));
dyan=fe_add(dba,fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxa,fe_sgn(Xxr)))))),fe_add(fe_imul(12,fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(Xxi,dya)))),fe_add(fe_imul(-12,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr)))))))),fe_imul(-4,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),dya))))));
dybn=fe_add(dbb,fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxb,fe_sgn(Xxr)))))),fe_add(fe_imul(12,fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(Xxi,dyb)))),fe_add(fe_imul(-12,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr)))))))),fe_imul(-4,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),dyb))))));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_mul(fe_imul(12,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(12,Xr),xr),xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xr2),Xi),xi)),fe_mul(fe_imul(6,xr2),xi2)),cr);
xin=fe_add(fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_mul(fe_imul(12,Xi2),xi),fe_mul(fe_imul(12,Xi),xi2)),fe_mul(fe_imul(4,xi2),xi)),fe_mul(fe_mul(fe_imul(8,xr),Xr),Xi)),fe_mul(fe_imul(4,xr2),Xi)),fe_mul(fe_imul(4,xi),Xr2)),fe_mul(fe_mul(fe_imul(8,xr),xi),Xr)),fe_mul(fe_imul(4,xr2),xi))),fe_mul(fe_diffabs(Xr,xr),fe_sub(fe_mul(fe_imul(4,Xi2),Xi),fe_mul(fe_imul(4,Xr2),Xi)))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_17_4_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_mul(sf_imul(4,Xi),xi2),xi)),sf_mul(xi2,xi2)),sf_mul(sf_mul(sf_imul(12,Xr2),Xi),xi)),sf_mul(sf_imul(6,Xr2),xi2)),sf_mul(sf_mul(sf_imul(12,Xr),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(24,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_imul(12,Xr),xr),xi2)),sf_mul(sf_imul(6,xr2),Xi2)),sf_mul(sf_mul(sf_imul(12,xr2),Xi),xi)),sf_mul(sf_imul(6,xr2),xi2)),cr);
xin=sf_add(sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_mul(sf_imul(12,Xi2),xi),sf_mul(sf_imul(12,Xi),xi2)),sf_mul(sf_imul(4,xi2),xi)),sf_mul(sf_mul(sf_imul(8,xr),Xr),Xi)),sf_mul(sf_imul(4,xr2),Xi)),sf_mul(sf_imul(4,xi),Xr2)),sf_mul(sf_mul(sf_imul(8,xr),xi),Xr)),sf_mul(sf_imul(4,xr2),xi))),sf_mul(sf_diffabs(Xr,xr),sf_sub(sf_mul(sf_imul(4,Xi2),Xi),sf_mul(sf_imul(4,Xr2),Xi)))),ci);
}

);
#endif


static const char *perturbation_opencl_double_18_4_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_diffabs(d_sub(d_add(d_mul(Xr2,Xr2),d_mul(Xi2,Xi2)),d_mul(d_imul(6,Xr2),Xi2)),d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,xr),Xr),Xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xi),Xr2),Xi)),d_mul(d_mul(d_mul(d_imul(24,xr),xi),Xr),Xi)),d_mul(d_mul(d_imul(12,xr2),xi),Xi)),d_mul(d_imul(6,xi2),Xr2)),d_mul(d_mul(d_imul(12,xr),xi2),Xr)),d_mul(d_imul(6,xr2),xi2))),cr);
xin=d_add(d_add(d_mul(d_abs(d_add(Xi,xi)),d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_mul(d_imul(12,Xr2),xr),d_mul(d_imul(12,Xr),xr2)),d_mul(d_imul(4,xr2),xr)),d_mul(d_imul(4,xr),Xi2)),d_mul(d_mul(d_imul(8,xi),Xr),Xi)),d_mul(d_mul(d_imul(8,xr),xi),Xi)),d_mul(d_imul(4,xi2),Xr)),d_mul(d_imul(4,xr),xi2))),d_mul(d_diffabs(Xi,xi),d_sub(d_mul(d_imul(4,Xr2),Xr),d_mul(d_imul(4,Xr),Xi2)))),ci);
}

);

static const char *perturbation_opencl_double_18_4_1 = STR(

{dxan=d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))),d_add(d_imul(-6,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr))),d_abs(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi)))))))))))),d_add(d_imul(4,d_mul(d_sgn(d_add(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))),d_add(d_imul(-6,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr))),d_abs(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))))))),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dya,d_sgn(Xxi)))))))))),d_add(d_imul(-12,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(d_sgn(d_add(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))),d_add(d_imul(-6,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr))),d_abs(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))))))),d_mul(Xxr,dxa)))),d_add(d_imul(-12,d_mul(d_sgn(d_add(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))),d_add(d_imul(-6,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr))),d_abs(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))))))),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(Xxi)))))))),daa))));
dxbn=d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))),d_add(d_imul(-6,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr))),d_abs(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi)))))))))))),d_add(d_imul(4,d_mul(d_sgn(d_add(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))),d_add(d_imul(-6,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr))),d_abs(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))))))),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dyb,d_sgn(Xxi)))))))))),d_add(d_imul(-12,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(d_sgn(d_add(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))),d_add(d_imul(-6,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr))),d_abs(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))))))),d_mul(Xxr,dxb)))),d_add(d_imul(-12,d_mul(d_sgn(d_add(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))),d_add(d_imul(-6,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr))),d_abs(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))))))),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(Xxi)))))))),dab))));
dyan=d_add(dba,d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(Xxi)))))),d_add(d_imul(12,d_mul(d_abs(Xxi),d_mul(Xxr,d_mul(Xxr,dxa)))),d_add(d_imul(-12,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_sgn(Xxi)))))))),d_imul(-4,d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))),dxa))))));
dybn=d_add(dbb,d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(Xxi)))))),d_add(d_imul(12,d_mul(d_abs(Xxi),d_mul(Xxr,d_mul(Xxr,dxb)))),d_add(d_imul(-12,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_sgn(Xxi)))))))),d_imul(-4,d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))),dxb))))));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_diffabs(d_sub(d_add(d_mul(Xr2,Xr2),d_mul(Xi2,Xi2)),d_mul(d_imul(6,Xr2),Xi2)),d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,xr),Xr),Xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xi),Xr2),Xi)),d_mul(d_mul(d_mul(d_imul(24,xr),xi),Xr),Xi)),d_mul(d_mul(d_imul(12,xr2),xi),Xi)),d_mul(d_imul(6,xi2),Xr2)),d_mul(d_mul(d_imul(12,xr),xi2),Xr)),d_mul(d_imul(6,xr2),xi2))),cr);
xin=d_add(d_add(d_mul(d_abs(d_add(Xi,xi)),d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_mul(d_imul(12,Xr2),xr),d_mul(d_imul(12,Xr),xr2)),d_mul(d_imul(4,xr2),xr)),d_mul(d_imul(4,xr),Xi2)),d_mul(d_mul(d_imul(8,xi),Xr),Xi)),d_mul(d_mul(d_imul(8,xr),xi),Xi)),d_mul(d_imul(4,xi2),Xr)),d_mul(d_imul(4,xr),xi2))),d_mul(d_diffabs(Xi,xi),d_sub(d_mul(d_imul(4,Xr2),Xr),d_mul(d_imul(4,Xr),Xi2)))),ci);
}

);

static const char *perturbation_opencl_floatexp_18_4_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_add(fe_mul(Xr2,Xr2),fe_mul(Xi2,Xi2)),fe_mul(fe_imul(6,Xr2),Xi2)),fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,xr),Xr),Xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xi),Xr2),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(24,xr),xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(12,xr2),xi),Xi)),fe_mul(fe_imul(6,xi2),Xr2)),fe_mul(fe_mul(fe_imul(12,xr),xi2),Xr)),fe_mul(fe_imul(6,xr2),xi2))),cr);
xin=fe_add(fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_mul(fe_imul(12,Xr2),xr),fe_mul(fe_imul(12,Xr),xr2)),fe_mul(fe_imul(4,xr2),xr)),fe_mul(fe_imul(4,xr),Xi2)),fe_mul(fe_mul(fe_imul(8,xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(8,xr),xi),Xi)),fe_mul(fe_imul(4,xi2),Xr)),fe_mul(fe_imul(4,xr),xi2))),fe_mul(fe_diffabs(Xi,xi),fe_sub(fe_mul(fe_imul(4,Xr2),Xr),fe_mul(fe_imul(4,Xr),Xi2)))),ci);
}

);

static const char *perturbation_opencl_floatexp_18_4_1 = STR(

{dxan=fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr))),fe_abs(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi)))))))))))),fe_add(fe_imul(4,fe_mul(fe_sgn(fe_add(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr))),fe_abs(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dya,fe_sgn(Xxi)))))))))),fe_add(fe_imul(-12,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(fe_sgn(fe_add(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr))),fe_abs(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))))))),fe_mul(Xxr,dxa)))),fe_add(fe_imul(-12,fe_mul(fe_sgn(fe_add(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr))),fe_abs(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))))))),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxi)))))))),daa))));
dxbn=fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr))),fe_abs(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi)))))))))))),fe_add(fe_imul(4,fe_mul(fe_sgn(fe_add(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr))),fe_abs(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dyb,fe_sgn(Xxi)))))))))),fe_add(fe_imul(-12,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(fe_sgn(fe_add(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr))),fe_abs(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))))))),fe_mul(Xxr,dxb)))),fe_add(fe_imul(-12,fe_mul(fe_sgn(fe_add(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr))),fe_abs(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))))))),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxi)))))))),dab))));
dyan=fe_add(dba,fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxi)))))),fe_add(fe_imul(12,fe_mul(fe_abs(Xxi),fe_mul(Xxr,fe_mul(Xxr,dxa)))),fe_add(fe_imul(-12,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxi)))))))),fe_imul(-4,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))),dxa))))));
dybn=fe_add(dbb,fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxi)))))),fe_add(fe_imul(12,fe_mul(fe_abs(Xxi),fe_mul(Xxr,fe_mul(Xxr,dxb)))),fe_add(fe_imul(-12,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxi)))))))),fe_imul(-4,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))),dxb))))));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_add(fe_mul(Xr2,Xr2),fe_mul(Xi2,Xi2)),fe_mul(fe_imul(6,Xr2),Xi2)),fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,xr),Xr),Xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xi),Xr2),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(24,xr),xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(12,xr2),xi),Xi)),fe_mul(fe_imul(6,xi2),Xr2)),fe_mul(fe_mul(fe_imul(12,xr),xi2),Xr)),fe_mul(fe_imul(6,xr2),xi2))),cr);
xin=fe_add(fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_mul(fe_imul(12,Xr2),xr),fe_mul(fe_imul(12,Xr),xr2)),fe_mul(fe_imul(4,xr2),xr)),fe_mul(fe_imul(4,xr),Xi2)),fe_mul(fe_mul(fe_imul(8,xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(8,xr),xi),Xi)),fe_mul(fe_imul(4,xi2),Xr)),fe_mul(fe_imul(4,xr),xi2))),fe_mul(fe_diffabs(Xi,xi),fe_sub(fe_mul(fe_imul(4,Xr2),Xr),fe_mul(fe_imul(4,Xr),Xi2)))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_18_4_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_diffabs(sf_sub(sf_add(sf_mul(Xr2,Xr2),sf_mul(Xi2,Xi2)),sf_mul(sf_imul(6,Xr2),Xi2)),sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_mul(sf_imul(4,Xi),xi2),xi)),sf_mul(xi2,xi2)),sf_mul(sf_mul(sf_imul(12,xr),Xr),Xi2)),sf_mul(sf_imul(6,xr2),Xi2)),sf_mul(sf_mul(sf_imul(12,xi),Xr2),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(24,xr),xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(12,xr2),xi),Xi)),sf_mul(sf_imul(6,xi2),Xr2)),sf_mul(sf_mul(sf_imul(12,xr),xi2),Xr)),sf_mul(sf_imul(6,xr2),xi2))),cr);
xin=sf_add(sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_mul(sf_imul(12,Xr2),xr),sf_mul(sf_imul(12,Xr),xr2)),sf_mul(sf_imul(4,xr2),xr)),sf_mul(sf_imul(4,xr),Xi2)),sf_mul(sf_mul(sf_imul(8,xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(8,xr),xi),Xi)),sf_mul(sf_imul(4,xi2),Xr)),sf_mul(sf_imul(4,xr),xi2))),sf_mul(sf_diffabs(Xi,xi),sf_sub(sf_mul(sf_imul(4,Xr2),Xr),sf_mul(sf_imul(4,Xr),Xi2)))),ci);
}

);
#endif


static const char *perturbation_opencl_double_19_4_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_diffabs(d_sub(d_add(d_mul(Xr2,Xr2),d_mul(Xi2,Xi2)),d_mul(d_imul(6,Xr2),Xi2)),d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,xr),Xr),Xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xi),Xr2),Xi)),d_mul(d_mul(d_mul(d_imul(24,xr),xi),Xr),Xi)),d_mul(d_mul(d_imul(12,xr2),xi),Xi)),d_mul(d_imul(6,xi2),Xr2)),d_mul(d_mul(d_imul(12,xr),xi2),Xr)),d_mul(d_imul(6,xr2),xi2))),cr);
xin=d_add(d_add(d_mul(d_abs(d_add(Xr,xr)),d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_mul(d_imul(4,Xr2),xi),d_mul(d_mul(d_imul(8,Xr),xr),Xi)),d_mul(d_mul(d_imul(8,Xr),xr),xi)),d_mul(d_imul(4,xr2),Xi)),d_mul(d_imul(4,xr2),xi)),d_mul(d_imul(12,xi),Xi2)),d_mul(d_imul(12,xi2),Xi)),d_mul(d_imul(4,xi2),xi))),d_mul(d_diffabs(Xr,xr),d_sub(d_mul(d_imul(4,Xr2),Xi),d_mul(d_imul(4,Xi2),Xi)))),ci);
}

);

static const char *perturbation_opencl_double_19_4_1 = STR(

{dxan=d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dya,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,Xxi))),d_abs(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr)))))))))))),d_add(d_imul(4,d_mul(d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,Xxi))),d_abs(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr)))))))))),d_add(d_imul(-12,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,Xxi))),d_abs(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))),d_mul(Xxi,dya)))),d_add(d_imul(-12,d_mul(d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,Xxi))),d_abs(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr)))))))),daa))));
dxbn=d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dyb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,Xxi))),d_abs(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr)))))))))))),d_add(d_imul(4,d_mul(d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,Xxi))),d_abs(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr)))))))))),d_add(d_imul(-12,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,Xxi))),d_abs(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))),d_mul(Xxi,dyb)))),d_add(d_imul(-12,d_mul(d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,Xxi))),d_abs(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr)))))))),dab))));
dyan=d_add(dba,d_add(d_imul(-4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxa,d_sgn(Xxr)))))),d_add(d_imul(-12,d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(Xxi,dya)))),d_add(d_imul(12,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr)))))))),d_imul(4,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),dya))))));
dybn=d_add(dbb,d_add(d_imul(-4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxb,d_sgn(Xxr)))))),d_add(d_imul(-12,d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(Xxi,dyb)))),d_add(d_imul(12,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr)))))))),d_imul(4,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),dyb))))));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_diffabs(d_sub(d_add(d_mul(Xr2,Xr2),d_mul(Xi2,Xi2)),d_mul(d_imul(6,Xr2),Xi2)),d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,xr),Xr),Xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xi),Xr2),Xi)),d_mul(d_mul(d_mul(d_imul(24,xr),xi),Xr),Xi)),d_mul(d_mul(d_imul(12,xr2),xi),Xi)),d_mul(d_imul(6,xi2),Xr2)),d_mul(d_mul(d_imul(12,xr),xi2),Xr)),d_mul(d_imul(6,xr2),xi2))),cr);
xin=d_add(d_add(d_mul(d_abs(d_add(Xr,xr)),d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_mul(d_imul(4,Xr2),xi),d_mul(d_mul(d_imul(8,Xr),xr),Xi)),d_mul(d_mul(d_imul(8,Xr),xr),xi)),d_mul(d_imul(4,xr2),Xi)),d_mul(d_imul(4,xr2),xi)),d_mul(d_imul(12,xi),Xi2)),d_mul(d_imul(12,xi2),Xi)),d_mul(d_imul(4,xi2),xi))),d_mul(d_diffabs(Xr,xr),d_sub(d_mul(d_imul(4,Xr2),Xi),d_mul(d_imul(4,Xi2),Xi)))),ci);
}

);

static const char *perturbation_opencl_floatexp_19_4_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_add(fe_mul(Xr2,Xr2),fe_mul(Xi2,Xi2)),fe_mul(fe_imul(6,Xr2),Xi2)),fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,xr),Xr),Xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xi),Xr2),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(24,xr),xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(12,xr2),xi),Xi)),fe_mul(fe_imul(6,xi2),Xr2)),fe_mul(fe_mul(fe_imul(12,xr),xi2),Xr)),fe_mul(fe_imul(6,xr2),xi2))),cr);
xin=fe_add(fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_imul(4,Xr2),xi),fe_mul(fe_mul(fe_imul(8,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(8,Xr),xr),xi)),fe_mul(fe_imul(4,xr2),Xi)),fe_mul(fe_imul(4,xr2),xi)),fe_mul(fe_imul(12,xi),Xi2)),fe_mul(fe_imul(12,xi2),Xi)),fe_mul(fe_imul(4,xi2),xi))),fe_mul(fe_diffabs(Xr,xr),fe_sub(fe_mul(fe_imul(4,Xr2),Xi),fe_mul(fe_imul(4,Xi2),Xi)))),ci);
}

);

static const char *perturbation_opencl_floatexp_19_4_1 = STR(

{dxan=fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dya,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,Xxi))),fe_abs(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))))))),fe_add(fe_imul(4,fe_mul(fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,Xxi))),fe_abs(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr)))))))))),fe_add(fe_imul(-12,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,Xxi))),fe_abs(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))),fe_mul(Xxi,dya)))),fe_add(fe_imul(-12,fe_mul(fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,Xxi))),fe_abs(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr)))))))),daa))));
dxbn=fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dyb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,Xxi))),fe_abs(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))))))),fe_add(fe_imul(4,fe_mul(fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,Xxi))),fe_abs(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr)))))))))),fe_add(fe_imul(-12,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,Xxi))),fe_abs(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))),fe_mul(Xxi,dyb)))),fe_add(fe_imul(-12,fe_mul(fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,Xxi))),fe_abs(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr)))))))),dab))));
dyan=fe_add(dba,fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxa,fe_sgn(Xxr)))))),fe_add(fe_imul(-12,fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(Xxi,dya)))),fe_add(fe_imul(12,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr)))))))),fe_imul(4,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),dya))))));
dybn=fe_add(dbb,fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxb,fe_sgn(Xxr)))))),fe_add(fe_imul(-12,fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(Xxi,dyb)))),fe_add(fe_imul(12,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr)))))))),fe_imul(4,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),dyb))))));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_add(fe_mul(Xr2,Xr2),fe_mul(Xi2,Xi2)),fe_mul(fe_imul(6,Xr2),Xi2)),fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,xr),Xr),Xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xi),Xr2),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(24,xr),xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(12,xr2),xi),Xi)),fe_mul(fe_imul(6,xi2),Xr2)),fe_mul(fe_mul(fe_imul(12,xr),xi2),Xr)),fe_mul(fe_imul(6,xr2),xi2))),cr);
xin=fe_add(fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_imul(4,Xr2),xi),fe_mul(fe_mul(fe_imul(8,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(8,Xr),xr),xi)),fe_mul(fe_imul(4,xr2),Xi)),fe_mul(fe_imul(4,xr2),xi)),fe_mul(fe_imul(12,xi),Xi2)),fe_mul(fe_imul(12,xi2),Xi)),fe_mul(fe_imul(4,xi2),xi))),fe_mul(fe_diffabs(Xr,xr),fe_sub(fe_mul(fe_imul(4,Xr2),Xi),fe_mul(fe_imul(4,Xi2),Xi)))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_19_4_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_diffabs(sf_sub(sf_add(sf_mul(Xr2,Xr2),sf_mul(Xi2,Xi2)),sf_mul(sf_imul(6,Xr2),Xi2)),sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_mul(sf_imul(4,Xi),xi2),xi)),sf_mul(xi2,xi2)),sf_mul(sf_mul(sf_imul(12,xr),Xr),Xi2)),sf_mul(sf_imul(6,xr2),Xi2)),sf_mul(sf_mul(sf_imul(12,xi),Xr2),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(24,xr),xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(12,xr2),xi),Xi)),sf_mul(sf_imul(6,xi2),Xr2)),sf_mul(sf_mul(sf_imul(12,xr),xi2),Xr)),sf_mul(sf_imul(6,xr2),xi2))),cr);
xin=sf_add(sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_imul(4,Xr2),xi),sf_mul(sf_mul(sf_imul(8,Xr),xr),Xi)),sf_mul(sf_mul(sf_imul(8,Xr),xr),xi)),sf_mul(sf_imul(4,xr2),Xi)),sf_mul(sf_imul(4,xr2),xi)),sf_mul(sf_imul(12,xi),Xi2)),sf_mul(sf_imul(12,xi2),Xi)),sf_mul(sf_imul(4,xi2),xi))),sf_mul(sf_diffabs(Xr,xr),sf_sub(sf_mul(sf_imul(4,Xr2),Xi),sf_mul(sf_imul(4,Xi2),Xi)))),ci);
}

);
#endif


static const char *perturbation_opencl_double_20_4_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_diffabs(d_sub(d_add(d_mul(Xr2,Xr2),d_mul(Xi2,Xi2)),d_mul(d_imul(6,Xr2),Xi2)),d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,xr),Xr),Xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xi),Xr2),Xi)),d_mul(d_mul(d_mul(d_imul(24,xr),xi),Xr),Xi)),d_mul(d_mul(d_imul(12,xr2),xi),Xi)),d_mul(d_imul(6,xi2),Xr2)),d_mul(d_mul(d_imul(12,xr),xi2),Xr)),d_mul(d_imul(6,xr2),xi2))),cr);
xin=d_add(d_add(d_mul(d_abs(d_add(Xr,xr)),d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_mul(d_imul(12,Xi2),xi),d_mul(d_imul(12,Xi),xi2)),d_mul(d_imul(4,xi2),xi)),d_mul(d_mul(d_imul(8,xr),Xr),Xi)),d_mul(d_imul(4,xr2),Xi)),d_mul(d_imul(4,xi),Xr2)),d_mul(d_mul(d_imul(8,xr),xi),Xr)),d_mul(d_imul(4,xr2),xi))),d_mul(d_diffabs(Xr,xr),d_sub(d_mul(d_imul(4,Xi2),Xi),d_mul(d_imul(4,Xr2),Xi)))),ci);
}

);

static const char *perturbation_opencl_double_20_4_1 = STR(

{dxan=d_add(d_imul(4,d_mul(d_sgn(d_add(d_abs(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi)))),d_add(d_muli(d_abs(d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),-6),d_abs(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dya,d_sgn(Xxi)))))))))),d_add(d_imul(4,d_mul(d_sgn(d_add(d_abs(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi)))),d_add(d_muli(d_abs(d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),-6),d_abs(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr)))))))))),d_add(d_imul(-12,d_mul(d_sgn(d_add(d_abs(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi)))),d_add(d_muli(d_abs(d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),-6),d_abs(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr)))))))))),d_add(d_imul(-12,d_mul(d_sgn(d_add(d_abs(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi)))),d_add(d_muli(d_abs(d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),-6),d_abs(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(Xxr)))))))))),daa))));
dxbn=d_add(d_imul(4,d_mul(d_sgn(d_add(d_abs(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi)))),d_add(d_muli(d_abs(d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),-6),d_abs(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dyb,d_sgn(Xxi)))))))))),d_add(d_imul(4,d_mul(d_sgn(d_add(d_abs(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi)))),d_add(d_muli(d_abs(d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),-6),d_abs(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr)))))))))),d_add(d_imul(-12,d_mul(d_sgn(d_add(d_abs(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi)))),d_add(d_muli(d_abs(d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),-6),d_abs(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr)))))))))),d_add(d_imul(-12,d_mul(d_sgn(d_add(d_abs(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi)))),d_add(d_muli(d_abs(d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),-6),d_abs(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(Xxr)))))))))),dab))));
dyan=d_add(d_imul(-4,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(Xxr))))))))),d_add(d_imul(4,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxa,d_sgn(Xxr))))))))),d_add(d_imul(12,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_sgn(Xxr))))))))),d_add(d_imul(-12,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr))))))))),dba))));
dybn=d_add(d_imul(-4,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(Xxr))))))))),d_add(d_imul(4,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxb,d_sgn(Xxr))))))))),d_add(d_imul(12,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_sgn(Xxr))))))))),d_add(d_imul(-12,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr))))))))),dbb))));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_diffabs(d_sub(d_add(d_mul(Xr2,Xr2),d_mul(Xi2,Xi2)),d_mul(d_imul(6,Xr2),Xi2)),d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,xr),Xr),Xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xi),Xr2),Xi)),d_mul(d_mul(d_mul(d_imul(24,xr),xi),Xr),Xi)),d_mul(d_mul(d_imul(12,xr2),xi),Xi)),d_mul(d_imul(6,xi2),Xr2)),d_mul(d_mul(d_imul(12,xr),xi2),Xr)),d_mul(d_imul(6,xr2),xi2))),cr);
xin=d_add(d_add(d_mul(d_abs(d_add(Xr,xr)),d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_mul(d_imul(12,Xi2),xi),d_mul(d_imul(12,Xi),xi2)),d_mul(d_imul(4,xi2),xi)),d_mul(d_mul(d_imul(8,xr),Xr),Xi)),d_mul(d_imul(4,xr2),Xi)),d_mul(d_imul(4,xi),Xr2)),d_mul(d_mul(d_imul(8,xr),xi),Xr)),d_mul(d_imul(4,xr2),xi))),d_mul(d_diffabs(Xr,xr),d_sub(d_mul(d_imul(4,Xi2),Xi),d_mul(d_imul(4,Xr2),Xi)))),ci);
}

);

static const char *perturbation_opencl_floatexp_20_4_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_add(fe_mul(Xr2,Xr2),fe_mul(Xi2,Xi2)),fe_mul(fe_imul(6,Xr2),Xi2)),fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,xr),Xr),Xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xi),Xr2),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(24,xr),xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(12,xr2),xi),Xi)),fe_mul(fe_imul(6,xi2),Xr2)),fe_mul(fe_mul(fe_imul(12,xr),xi2),Xr)),fe_mul(fe_imul(6,xr2),xi2))),cr);
xin=fe_add(fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_mul(fe_imul(12,Xi2),xi),fe_mul(fe_imul(12,Xi),xi2)),fe_mul(fe_imul(4,xi2),xi)),fe_mul(fe_mul(fe_imul(8,xr),Xr),Xi)),fe_mul(fe_imul(4,xr2),Xi)),fe_mul(fe_imul(4,xi),Xr2)),fe_mul(fe_mul(fe_imul(8,xr),xi),Xr)),fe_mul(fe_imul(4,xr2),xi))),fe_mul(fe_diffabs(Xr,xr),fe_sub(fe_mul(fe_imul(4,Xi2),Xi),fe_mul(fe_imul(4,Xr2),Xi)))),ci);
}

);

static const char *perturbation_opencl_floatexp_20_4_1 = STR(

{dxan=fe_add(fe_imul(4,fe_mul(fe_sgn(fe_add(fe_abs(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_add(fe_muli(fe_abs(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),-6),fe_abs(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dya,fe_sgn(Xxi)))))))))),fe_add(fe_imul(4,fe_mul(fe_sgn(fe_add(fe_abs(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_add(fe_muli(fe_abs(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),-6),fe_abs(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr)))))))))),fe_add(fe_imul(-12,fe_mul(fe_sgn(fe_add(fe_abs(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_add(fe_muli(fe_abs(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),-6),fe_abs(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr)))))))))),fe_add(fe_imul(-12,fe_mul(fe_sgn(fe_add(fe_abs(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_add(fe_muli(fe_abs(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),-6),fe_abs(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxr)))))))))),daa))));
dxbn=fe_add(fe_imul(4,fe_mul(fe_sgn(fe_add(fe_abs(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_add(fe_muli(fe_abs(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),-6),fe_abs(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dyb,fe_sgn(Xxi)))))))))),fe_add(fe_imul(4,fe_mul(fe_sgn(fe_add(fe_abs(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_add(fe_muli(fe_abs(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),-6),fe_abs(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr)))))))))),fe_add(fe_imul(-12,fe_mul(fe_sgn(fe_add(fe_abs(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_add(fe_muli(fe_abs(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),-6),fe_abs(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr)))))))))),fe_add(fe_imul(-12,fe_mul(fe_sgn(fe_add(fe_abs(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_add(fe_muli(fe_abs(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),-6),fe_abs(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxr)))))))))),dab))));
dyan=fe_add(fe_imul(-4,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxr))))))))),fe_add(fe_imul(4,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxa,fe_sgn(Xxr))))))))),fe_add(fe_imul(12,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxr))))))))),fe_add(fe_imul(-12,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr))))))))),dba))));
dybn=fe_add(fe_imul(-4,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxr))))))))),fe_add(fe_imul(4,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxb,fe_sgn(Xxr))))))))),fe_add(fe_imul(12,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxr))))))))),fe_add(fe_imul(-12,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr))))))))),dbb))));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_add(fe_mul(Xr2,Xr2),fe_mul(Xi2,Xi2)),fe_mul(fe_imul(6,Xr2),Xi2)),fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,xr),Xr),Xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xi),Xr2),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(24,xr),xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(12,xr2),xi),Xi)),fe_mul(fe_imul(6,xi2),Xr2)),fe_mul(fe_mul(fe_imul(12,xr),xi2),Xr)),fe_mul(fe_imul(6,xr2),xi2))),cr);
xin=fe_add(fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_mul(fe_imul(12,Xi2),xi),fe_mul(fe_imul(12,Xi),xi2)),fe_mul(fe_imul(4,xi2),xi)),fe_mul(fe_mul(fe_imul(8,xr),Xr),Xi)),fe_mul(fe_imul(4,xr2),Xi)),fe_mul(fe_imul(4,xi),Xr2)),fe_mul(fe_mul(fe_imul(8,xr),xi),Xr)),fe_mul(fe_imul(4,xr2),xi))),fe_mul(fe_diffabs(Xr,xr),fe_sub(fe_mul(fe_imul(4,Xi2),Xi),fe_mul(fe_imul(4,Xr2),Xi)))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_20_4_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_diffabs(sf_sub(sf_add(sf_mul(Xr2,Xr2),sf_mul(Xi2,Xi2)),sf_mul(sf_imul(6,Xr2),Xi2)),sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_mul(sf_imul(4,Xi),xi2),xi)),sf_mul(xi2,xi2)),sf_mul(sf_mul(sf_imul(12,xr),Xr),Xi2)),sf_mul(sf_imul(6,xr2),Xi2)),sf_mul(sf_mul(sf_imul(12,xi),Xr2),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(24,xr),xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(12,xr2),xi),Xi)),sf_mul(sf_imul(6,xi2),Xr2)),sf_mul(sf_mul(sf_imul(12,xr),xi2),Xr)),sf_mul(sf_imul(6,xr2),xi2))),cr);
xin=sf_add(sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_mul(sf_imul(12,Xi2),xi),sf_mul(sf_imul(12,Xi),xi2)),sf_mul(sf_imul(4,xi2),xi)),sf_mul(sf_mul(sf_imul(8,xr),Xr),Xi)),sf_mul(sf_imul(4,xr2),Xi)),sf_mul(sf_imul(4,xi),Xr2)),sf_mul(sf_mul(sf_imul(8,xr),xi),Xr)),sf_mul(sf_imul(4,xr2),xi))),sf_mul(sf_diffabs(Xr,xr),sf_sub(sf_mul(sf_imul(4,Xi2),Xi),sf_mul(sf_imul(4,Xr2),Xi)))),ci);
}

);
#endif


static const char *perturbation_opencl_double_21_4_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_mul(d_imul(12,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(24,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(12,Xr),xr),xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xr2),Xi),xi)),d_mul(d_imul(6,xr2),xi2)),cr);
xin=d_add(d_diffabs(d_sub(d_mul(d_mul(d_imul(4,Xr2),Xr),Xi),d_mul(d_mul(d_imul(4,Xr),Xi2),Xi)),d_add(d_sub(d_add(d_sub(d_add(d_add(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_mul(d_mul(d_imul(-4,xr),Xi2),Xi),d_mul(d_mul(d_imul(12,xi),Xr),Xi2)),d_mul(d_mul(d_imul(12,xr),xi),Xi2)),d_mul(d_mul(d_imul(12,xr),Xr2),Xi)),d_mul(d_mul(d_imul(12,xi2),Xr),Xi)),d_mul(d_mul(d_imul(12,xr2),Xr),Xi)),d_mul(d_mul(d_imul(12,xr),xi2),Xi)),d_mul(d_mul(d_imul(4,xr2),xr),Xi)),d_mul(d_mul(d_imul(4,xi),Xr2),Xr)),d_mul(d_mul(d_imul(12,xr),xi),Xr2)),d_mul(d_mul(d_imul(4,xi2),xi),Xr)),d_mul(d_mul(d_imul(12,xr2),xi),Xr)),d_mul(d_mul(d_imul(4,xr),xi2),xi)),d_mul(d_mul(d_imul(4,xr2),xr),xi))),ci);
}

);

static const char *perturbation_opencl_double_21_4_1 = STR(

{dxan=d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dya)))),d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dxa)))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,dxa)))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,dya)))),daa))));
dxbn=d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dyb)))),d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dxb)))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,dxb)))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,dyb)))),dab))));
dyan=d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_imul(-4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr)))),d_imul(4,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxa,d_sgn(d_add(d_imul(-4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr)))),d_imul(4,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_imul(-4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr)))),d_imul(4,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_imul(-4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr)))),d_imul(4,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),dba))));
dybn=d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_imul(-4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr)))),d_imul(4,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxb,d_sgn(d_add(d_imul(-4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr)))),d_imul(4,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_imul(-4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr)))),d_imul(4,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_imul(-4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr)))),d_imul(4,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),dbb))));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_mul(d_imul(12,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(24,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(12,Xr),xr),xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xr2),Xi),xi)),d_mul(d_imul(6,xr2),xi2)),cr);
xin=d_add(d_diffabs(d_sub(d_mul(d_mul(d_imul(4,Xr2),Xr),Xi),d_mul(d_mul(d_imul(4,Xr),Xi2),Xi)),d_add(d_sub(d_add(d_sub(d_add(d_add(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_mul(d_mul(d_imul(-4,xr),Xi2),Xi),d_mul(d_mul(d_imul(12,xi),Xr),Xi2)),d_mul(d_mul(d_imul(12,xr),xi),Xi2)),d_mul(d_mul(d_imul(12,xr),Xr2),Xi)),d_mul(d_mul(d_imul(12,xi2),Xr),Xi)),d_mul(d_mul(d_imul(12,xr2),Xr),Xi)),d_mul(d_mul(d_imul(12,xr),xi2),Xi)),d_mul(d_mul(d_imul(4,xr2),xr),Xi)),d_mul(d_mul(d_imul(4,xi),Xr2),Xr)),d_mul(d_mul(d_imul(12,xr),xi),Xr2)),d_mul(d_mul(d_imul(4,xi2),xi),Xr)),d_mul(d_mul(d_imul(12,xr2),xi),Xr)),d_mul(d_mul(d_imul(4,xr),xi2),xi)),d_mul(d_mul(d_imul(4,xr2),xr),xi))),ci);
}

);

static const char *perturbation_opencl_floatexp_21_4_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_mul(fe_imul(12,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(12,Xr),xr),xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xr2),Xi),xi)),fe_mul(fe_imul(6,xr2),xi2)),cr);
xin=fe_add(fe_diffabs(fe_sub(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),Xi),fe_mul(fe_mul(fe_imul(4,Xr),Xi2),Xi)),fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_mul(fe_mul(fe_imul(-4,xr),Xi2),Xi),fe_mul(fe_mul(fe_imul(12,xi),Xr),Xi2)),fe_mul(fe_mul(fe_imul(12,xr),xi),Xi2)),fe_mul(fe_mul(fe_imul(12,xr),Xr2),Xi)),fe_mul(fe_mul(fe_imul(12,xi2),Xr),Xi)),fe_mul(fe_mul(fe_imul(12,xr2),Xr),Xi)),fe_mul(fe_mul(fe_imul(12,xr),xi2),Xi)),fe_mul(fe_mul(fe_imul(4,xr2),xr),Xi)),fe_mul(fe_mul(fe_imul(4,xi),Xr2),Xr)),fe_mul(fe_mul(fe_imul(12,xr),xi),Xr2)),fe_mul(fe_mul(fe_imul(4,xi2),xi),Xr)),fe_mul(fe_mul(fe_imul(12,xr2),xi),Xr)),fe_mul(fe_mul(fe_imul(4,xr),xi2),xi)),fe_mul(fe_mul(fe_imul(4,xr2),xr),xi))),ci);
}

);

static const char *perturbation_opencl_floatexp_21_4_1 = STR(

{dxan=fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dya)))),fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dxa)))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,dxa)))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,dya)))),daa))));
dxbn=fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dyb)))),fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dxb)))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,dxb)))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,dyb)))),dab))));
dyan=fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr)))),fe_imul(4,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxa,fe_sgn(fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr)))),fe_imul(4,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr)))),fe_imul(4,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr)))),fe_imul(4,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),dba))));
dybn=fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr)))),fe_imul(4,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxb,fe_sgn(fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr)))),fe_imul(4,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr)))),fe_imul(4,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr)))),fe_imul(4,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),dbb))));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_mul(fe_imul(12,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(12,Xr),xr),xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xr2),Xi),xi)),fe_mul(fe_imul(6,xr2),xi2)),cr);
xin=fe_add(fe_diffabs(fe_sub(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),Xi),fe_mul(fe_mul(fe_imul(4,Xr),Xi2),Xi)),fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_mul(fe_mul(fe_imul(-4,xr),Xi2),Xi),fe_mul(fe_mul(fe_imul(12,xi),Xr),Xi2)),fe_mul(fe_mul(fe_imul(12,xr),xi),Xi2)),fe_mul(fe_mul(fe_imul(12,xr),Xr2),Xi)),fe_mul(fe_mul(fe_imul(12,xi2),Xr),Xi)),fe_mul(fe_mul(fe_imul(12,xr2),Xr),Xi)),fe_mul(fe_mul(fe_imul(12,xr),xi2),Xi)),fe_mul(fe_mul(fe_imul(4,xr2),xr),Xi)),fe_mul(fe_mul(fe_imul(4,xi),Xr2),Xr)),fe_mul(fe_mul(fe_imul(12,xr),xi),Xr2)),fe_mul(fe_mul(fe_imul(4,xi2),xi),Xr)),fe_mul(fe_mul(fe_imul(12,xr2),xi),Xr)),fe_mul(fe_mul(fe_imul(4,xr),xi2),xi)),fe_mul(fe_mul(fe_imul(4,xr2),xr),xi))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_21_4_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_mul(sf_imul(4,Xi),xi2),xi)),sf_mul(xi2,xi2)),sf_mul(sf_mul(sf_imul(12,Xr2),Xi),xi)),sf_mul(sf_imul(6,Xr2),xi2)),sf_mul(sf_mul(sf_imul(12,Xr),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(24,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_imul(12,Xr),xr),xi2)),sf_mul(sf_imul(6,xr2),Xi2)),sf_mul(sf_mul(sf_imul(12,xr2),Xi),xi)),sf_mul(sf_imul(6,xr2),xi2)),cr);
xin=sf_add(sf_diffabs(sf_sub(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),Xi),sf_mul(sf_mul(sf_imul(4,Xr),Xi2),Xi)),sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_mul(sf_mul(sf_imul(-4,xr),Xi2),Xi),sf_mul(sf_mul(sf_imul(12,xi),Xr),Xi2)),sf_mul(sf_mul(sf_imul(12,xr),xi),Xi2)),sf_mul(sf_mul(sf_imul(12,xr),Xr2),Xi)),sf_mul(sf_mul(sf_imul(12,xi2),Xr),Xi)),sf_mul(sf_mul(sf_imul(12,xr2),Xr),Xi)),sf_mul(sf_mul(sf_imul(12,xr),xi2),Xi)),sf_mul(sf_mul(sf_imul(4,xr2),xr),Xi)),sf_mul(sf_mul(sf_imul(4,xi),Xr2),Xr)),sf_mul(sf_mul(sf_imul(12,xr),xi),Xr2)),sf_mul(sf_mul(sf_imul(4,xi2),xi),Xr)),sf_mul(sf_mul(sf_imul(12,xr2),xi),Xr)),sf_mul(sf_mul(sf_imul(4,xr),xi2),xi)),sf_mul(sf_mul(sf_imul(4,xr2),xr),xi))),ci);
}

);
#endif


static const char *perturbation_opencl_double_22_4_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_diffabs(d_sub(d_add(d_mul(Xr2,Xr2),d_mul(Xi2,Xi2)),d_mul(d_imul(6,Xr2),Xi2)),d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,xr),Xr),Xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xi),Xr2),Xi)),d_mul(d_mul(d_mul(d_imul(24,xr),xi),Xr),Xi)),d_mul(d_mul(d_imul(12,xr2),xi),Xi)),d_mul(d_imul(6,xi2),Xr2)),d_mul(d_mul(d_imul(12,xr),xi2),Xr)),d_mul(d_imul(6,xr2),xi2))),cr);
xin=d_sub(ci,d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_add(d_add(d_add(d_sub(d_sub(d_add(d_mul(d_mul(d_imul(12,Xr2),Xi),xr),d_mul(d_mul(d_imul(12,Xr),Xi),xr2)),d_mul(d_mul(d_imul(12,Xr),Xi2),xi)),d_mul(d_mul(d_imul(12,Xr),Xi),xi2)),d_mul(d_mul(d_imul(4,Xr2),Xr),xi)),d_mul(d_mul(d_imul(12,Xr2),xi),xr)),d_mul(d_mul(d_imul(12,Xr),xi),xr2)),d_mul(d_mul(d_imul(4,Xr),xi2),xi)),d_mul(d_mul(d_imul(4,xr2),xr),Xi)),d_mul(d_mul(d_imul(4,xr),Xi2),Xi)),d_mul(d_mul(d_imul(12,xr),Xi2),xi)),d_mul(d_mul(d_imul(12,xr),Xi),xi2)),d_mul(d_mul(d_imul(4,xr2),xr),xi)),d_mul(d_mul(d_imul(4,xr),xi2),xi)));
}

);

static const char *perturbation_opencl_double_22_4_1 = STR(

{dxan=d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dya,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),daa))));
dxbn=d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dyb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),dab))));
dyan=d_add(d_imul(-4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dya)))),d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dxa)))),d_add(d_imul(12,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,dya)))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,dxa)))),dba))));
dybn=d_add(d_imul(-4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dyb)))),d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dxb)))),d_add(d_imul(12,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,dyb)))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,dxb)))),dbb))));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_diffabs(d_sub(d_add(d_mul(Xr2,Xr2),d_mul(Xi2,Xi2)),d_mul(d_imul(6,Xr2),Xi2)),d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,xr),Xr),Xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xi),Xr2),Xi)),d_mul(d_mul(d_mul(d_imul(24,xr),xi),Xr),Xi)),d_mul(d_mul(d_imul(12,xr2),xi),Xi)),d_mul(d_imul(6,xi2),Xr2)),d_mul(d_mul(d_imul(12,xr),xi2),Xr)),d_mul(d_imul(6,xr2),xi2))),cr);
xin=d_sub(ci,d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_add(d_add(d_add(d_sub(d_sub(d_add(d_mul(d_mul(d_imul(12,Xr2),Xi),xr),d_mul(d_mul(d_imul(12,Xr),Xi),xr2)),d_mul(d_mul(d_imul(12,Xr),Xi2),xi)),d_mul(d_mul(d_imul(12,Xr),Xi),xi2)),d_mul(d_mul(d_imul(4,Xr2),Xr),xi)),d_mul(d_mul(d_imul(12,Xr2),xi),xr)),d_mul(d_mul(d_imul(12,Xr),xi),xr2)),d_mul(d_mul(d_imul(4,Xr),xi2),xi)),d_mul(d_mul(d_imul(4,xr2),xr),Xi)),d_mul(d_mul(d_imul(4,xr),Xi2),Xi)),d_mul(d_mul(d_imul(12,xr),Xi2),xi)),d_mul(d_mul(d_imul(12,xr),Xi),xi2)),d_mul(d_mul(d_imul(4,xr2),xr),xi)),d_mul(d_mul(d_imul(4,xr),xi2),xi)));
}

);

static const char *perturbation_opencl_floatexp_22_4_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_add(fe_mul(Xr2,Xr2),fe_mul(Xi2,Xi2)),fe_mul(fe_imul(6,Xr2),Xi2)),fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,xr),Xr),Xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xi),Xr2),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(24,xr),xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(12,xr2),xi),Xi)),fe_mul(fe_imul(6,xi2),Xr2)),fe_mul(fe_mul(fe_imul(12,xr),xi2),Xr)),fe_mul(fe_imul(6,xr2),xi2))),cr);
xin=fe_sub(ci,fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_add(fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xr),fe_mul(fe_mul(fe_imul(12,Xr),Xi),xr2)),fe_mul(fe_mul(fe_imul(12,Xr),Xi2),xi)),fe_mul(fe_mul(fe_imul(12,Xr),Xi),xi2)),fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xi)),fe_mul(fe_mul(fe_imul(12,Xr2),xi),xr)),fe_mul(fe_mul(fe_imul(12,Xr),xi),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xi2),xi)),fe_mul(fe_mul(fe_imul(4,xr2),xr),Xi)),fe_mul(fe_mul(fe_imul(4,xr),Xi2),Xi)),fe_mul(fe_mul(fe_imul(12,xr),Xi2),xi)),fe_mul(fe_mul(fe_imul(12,xr),Xi),xi2)),fe_mul(fe_mul(fe_imul(4,xr2),xr),xi)),fe_mul(fe_mul(fe_imul(4,xr),xi2),xi)));
}

);

static const char *perturbation_opencl_floatexp_22_4_1 = STR(

{dxan=fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dya,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),daa))));
dxbn=fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dyb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),dab))));
dyan=fe_add(fe_imul(-4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dya)))),fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dxa)))),fe_add(fe_imul(12,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,dya)))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,dxa)))),dba))));
dybn=fe_add(fe_imul(-4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dyb)))),fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dxb)))),fe_add(fe_imul(12,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,dyb)))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,dxb)))),dbb))));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_add(fe_mul(Xr2,Xr2),fe_mul(Xi2,Xi2)),fe_mul(fe_imul(6,Xr2),Xi2)),fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,xr),Xr),Xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xi),Xr2),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(24,xr),xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(12,xr2),xi),Xi)),fe_mul(fe_imul(6,xi2),Xr2)),fe_mul(fe_mul(fe_imul(12,xr),xi2),Xr)),fe_mul(fe_imul(6,xr2),xi2))),cr);
xin=fe_sub(ci,fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_add(fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xr),fe_mul(fe_mul(fe_imul(12,Xr),Xi),xr2)),fe_mul(fe_mul(fe_imul(12,Xr),Xi2),xi)),fe_mul(fe_mul(fe_imul(12,Xr),Xi),xi2)),fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xi)),fe_mul(fe_mul(fe_imul(12,Xr2),xi),xr)),fe_mul(fe_mul(fe_imul(12,Xr),xi),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xi2),xi)),fe_mul(fe_mul(fe_imul(4,xr2),xr),Xi)),fe_mul(fe_mul(fe_imul(4,xr),Xi2),Xi)),fe_mul(fe_mul(fe_imul(12,xr),Xi2),xi)),fe_mul(fe_mul(fe_imul(12,xr),Xi),xi2)),fe_mul(fe_mul(fe_imul(4,xr2),xr),xi)),fe_mul(fe_mul(fe_imul(4,xr),xi2),xi)));
}

);

#if 0
static const char *perturbation_opencl_softfloat_22_4_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_diffabs(sf_sub(sf_add(sf_mul(Xr2,Xr2),sf_mul(Xi2,Xi2)),sf_mul(sf_imul(6,Xr2),Xi2)),sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_mul(sf_imul(4,Xi),xi2),xi)),sf_mul(xi2,xi2)),sf_mul(sf_mul(sf_imul(12,xr),Xr),Xi2)),sf_mul(sf_imul(6,xr2),Xi2)),sf_mul(sf_mul(sf_imul(12,xi),Xr2),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(24,xr),xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(12,xr2),xi),Xi)),sf_mul(sf_imul(6,xi2),Xr2)),sf_mul(sf_mul(sf_imul(12,xr),xi2),Xr)),sf_mul(sf_imul(6,xr2),xi2))),cr);
xin=sf_sub(ci,sf_sub(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_sub(sf_add(sf_add(sf_add(sf_sub(sf_sub(sf_add(sf_mul(sf_mul(sf_imul(12,Xr2),Xi),xr),sf_mul(sf_mul(sf_imul(12,Xr),Xi),xr2)),sf_mul(sf_mul(sf_imul(12,Xr),Xi2),xi)),sf_mul(sf_mul(sf_imul(12,Xr),Xi),xi2)),sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xi)),sf_mul(sf_mul(sf_imul(12,Xr2),xi),xr)),sf_mul(sf_mul(sf_imul(12,Xr),xi),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xi2),xi)),sf_mul(sf_mul(sf_imul(4,xr2),xr),Xi)),sf_mul(sf_mul(sf_imul(4,xr),Xi2),Xi)),sf_mul(sf_mul(sf_imul(12,xr),Xi2),xi)),sf_mul(sf_mul(sf_imul(12,xr),Xi),xi2)),sf_mul(sf_mul(sf_imul(4,xr2),xr),xi)),sf_mul(sf_mul(sf_imul(4,xr),xi2),xi)));
}

);
#endif


static const char *perturbation_opencl_double_23_4_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_mul(d_imul(12,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(24,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(12,Xr),xr),xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xr2),Xi),xi)),d_mul(d_imul(6,xr2),xi2)),cr);
xin=d_add(d_sub(d_mul(d_neg(d_mul(d_imul(4,Xr),Xi)),d_diffabs(d_sub(Xr2,Xi2),d_add(d_sub(d_add(d_mul(d_imul(-2,xi),Xi),d_mul(d_imul(2,xr),Xr)),xi2),xr2))),d_mul(d_add(d_add(d_mul(d_imul(4,Xr),xi),d_mul(d_imul(4,xr),Xi)),d_mul(d_imul(4,xr),xi)),d_abs(d_add(d_sub(d_add(d_add(d_sub(d_neg(Xi2),d_mul(d_imul(2,xi),Xi)),Xr2),d_mul(d_imul(2,xr),Xr)),xi2),xr2)))),ci);
}

);

static const char *perturbation_opencl_double_23_4_1 = STR(

{dxan=d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dya)))),d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dxa)))),d_add(d_imul(-12,d_mul(Xxr,d_mul(Xxr,dya))),d_add(d_imul(-24,d_mul(Xxi,d_mul(Xxr,dxa))),daa))));
dxbn=d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dyb)))),d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dxb)))),d_add(d_imul(-12,d_mul(Xxr,d_mul(Xxr,dyb))),d_add(d_imul(-24,d_mul(Xxi,d_mul(Xxr,dxb))),dab))));
dyan=d_add(d_imul(-4,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr))),d_mul(Xxi,dxa))),d_add(d_imul(-4,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr))),d_mul(Xxr,dya))),d_add(d_imul(-8,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))))),d_add(d_imul(8,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))))),dba))));
dybn=d_add(d_imul(-4,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr))),d_mul(Xxi,dxb))),d_add(d_imul(-4,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr))),d_mul(Xxr,dyb))),d_add(d_imul(-8,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))))),d_add(d_imul(8,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))))),dbb))));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_mul(d_imul(12,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(24,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(12,Xr),xr),xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xr2),Xi),xi)),d_mul(d_imul(6,xr2),xi2)),cr);
xin=d_add(d_sub(d_mul(d_neg(d_mul(d_imul(4,Xr),Xi)),d_diffabs(d_sub(Xr2,Xi2),d_add(d_sub(d_add(d_mul(d_imul(-2,xi),Xi),d_mul(d_imul(2,xr),Xr)),xi2),xr2))),d_mul(d_add(d_add(d_mul(d_imul(4,Xr),xi),d_mul(d_imul(4,xr),Xi)),d_mul(d_imul(4,xr),xi)),d_abs(d_add(d_sub(d_add(d_add(d_sub(d_neg(Xi2),d_mul(d_imul(2,xi),Xi)),Xr2),d_mul(d_imul(2,xr),Xr)),xi2),xr2)))),ci);
}

);

static const char *perturbation_opencl_floatexp_23_4_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_mul(fe_imul(12,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(12,Xr),xr),xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xr2),Xi),xi)),fe_mul(fe_imul(6,xr2),xi2)),cr);
xin=fe_add(fe_sub(fe_mul(fe_neg(fe_mul(fe_imul(4,Xr),Xi)),fe_diffabs(fe_sub(Xr2,Xi2),fe_add(fe_sub(fe_add(fe_mul(fe_imul(-2,xi),Xi),fe_mul(fe_imul(2,xr),Xr)),xi2),xr2))),fe_mul(fe_add(fe_add(fe_mul(fe_imul(4,Xr),xi),fe_mul(fe_imul(4,xr),Xi)),fe_mul(fe_imul(4,xr),xi)),fe_abs(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_neg(Xi2),fe_mul(fe_imul(2,xi),Xi)),Xr2),fe_mul(fe_imul(2,xr),Xr)),xi2),xr2)))),ci);
}

);

static const char *perturbation_opencl_floatexp_23_4_1 = STR(

{dxan=fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dya)))),fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dxa)))),fe_add(fe_imul(-12,fe_mul(Xxr,fe_mul(Xxr,dya))),fe_add(fe_imul(-24,fe_mul(Xxi,fe_mul(Xxr,dxa))),daa))));
dxbn=fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dyb)))),fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dxb)))),fe_add(fe_imul(-12,fe_mul(Xxr,fe_mul(Xxr,dyb))),fe_add(fe_imul(-24,fe_mul(Xxi,fe_mul(Xxr,dxb))),dab))));
dyan=fe_add(fe_imul(-4,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr))),fe_mul(Xxi,dxa))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr))),fe_mul(Xxr,dya))),fe_add(fe_imul(-8,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(8,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))))),dba))));
dybn=fe_add(fe_imul(-4,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr))),fe_mul(Xxi,dxb))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr))),fe_mul(Xxr,dyb))),fe_add(fe_imul(-8,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(8,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))))),dbb))));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_mul(fe_imul(12,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(12,Xr),xr),xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xr2),Xi),xi)),fe_mul(fe_imul(6,xr2),xi2)),cr);
xin=fe_add(fe_sub(fe_mul(fe_neg(fe_mul(fe_imul(4,Xr),Xi)),fe_diffabs(fe_sub(Xr2,Xi2),fe_add(fe_sub(fe_add(fe_mul(fe_imul(-2,xi),Xi),fe_mul(fe_imul(2,xr),Xr)),xi2),xr2))),fe_mul(fe_add(fe_add(fe_mul(fe_imul(4,Xr),xi),fe_mul(fe_imul(4,xr),Xi)),fe_mul(fe_imul(4,xr),xi)),fe_abs(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_neg(Xi2),fe_mul(fe_imul(2,xi),Xi)),Xr2),fe_mul(fe_imul(2,xr),Xr)),xi2),xr2)))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_23_4_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_mul(sf_imul(4,Xi),xi2),xi)),sf_mul(xi2,xi2)),sf_mul(sf_mul(sf_imul(12,Xr2),Xi),xi)),sf_mul(sf_imul(6,Xr2),xi2)),sf_mul(sf_mul(sf_imul(12,Xr),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(24,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_imul(12,Xr),xr),xi2)),sf_mul(sf_imul(6,xr2),Xi2)),sf_mul(sf_mul(sf_imul(12,xr2),Xi),xi)),sf_mul(sf_imul(6,xr2),xi2)),cr);
xin=sf_add(sf_sub(sf_mul(sf_neg(sf_mul(sf_imul(4,Xr),Xi)),sf_diffabs(sf_sub(Xr2,Xi2),sf_add(sf_sub(sf_add(sf_mul(sf_imul(-2,xi),Xi),sf_mul(sf_imul(2,xr),Xr)),xi2),xr2))),sf_mul(sf_add(sf_add(sf_mul(sf_imul(4,Xr),xi),sf_mul(sf_imul(4,xr),Xi)),sf_mul(sf_imul(4,xr),xi)),sf_abs(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_neg(Xi2),sf_mul(sf_imul(2,xi),Xi)),Xr2),sf_mul(sf_imul(2,xr),Xr)),xi2),xr2)))),ci);
}

);
#endif


static const char *perturbation_opencl_double_24_4_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_mul(d_imul(12,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(24,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(12,Xr),xr),xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xr2),Xi),xi)),d_mul(d_imul(6,xr2),xi2)),cr);
xin=d_add(d_add(d_mul(d_mul(d_imul(4,Xr),Xi),d_diffabs(d_sub(Xr2,Xi2),d_add(d_sub(d_add(d_mul(d_imul(-2,xi),Xi),d_mul(d_imul(2,xr),Xr)),xi2),xr2))),d_mul(d_add(d_add(d_mul(d_imul(4,Xr),xi),d_mul(d_imul(4,xr),Xi)),d_mul(d_imul(4,xr),xi)),d_abs(d_add(d_sub(d_add(d_add(d_sub(d_neg(Xi2),d_mul(d_imul(2,xi),Xi)),Xr2),d_mul(d_imul(2,xr),Xr)),xi2),xr2)))),ci);
}

);

static const char *perturbation_opencl_double_24_4_1 = STR(

{dxan=d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dya)))),d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dxa)))),d_add(d_imul(-12,d_mul(Xxr,d_mul(Xxr,dya))),d_add(d_imul(-24,d_mul(Xxi,d_mul(Xxr,dxa))),daa))));
dxbn=d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dyb)))),d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dxb)))),d_add(d_imul(-12,d_mul(Xxr,d_mul(Xxr,dyb))),d_add(d_imul(-24,d_mul(Xxi,d_mul(Xxr,dxb))),dab))));
dyan=d_add(d_imul(4,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr))),d_mul(Xxi,dxa))),d_add(d_imul(4,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr))),d_mul(Xxr,dya))),d_add(d_imul(8,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))))),d_add(d_imul(-8,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))))),dba))));
dybn=d_add(d_imul(4,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr))),d_mul(Xxi,dxb))),d_add(d_imul(4,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr))),d_mul(Xxr,dyb))),d_add(d_imul(8,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))))),d_add(d_imul(-8,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))))),dbb))));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_mul(d_imul(12,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(24,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(12,Xr),xr),xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xr2),Xi),xi)),d_mul(d_imul(6,xr2),xi2)),cr);
xin=d_add(d_add(d_mul(d_mul(d_imul(4,Xr),Xi),d_diffabs(d_sub(Xr2,Xi2),d_add(d_sub(d_add(d_mul(d_imul(-2,xi),Xi),d_mul(d_imul(2,xr),Xr)),xi2),xr2))),d_mul(d_add(d_add(d_mul(d_imul(4,Xr),xi),d_mul(d_imul(4,xr),Xi)),d_mul(d_imul(4,xr),xi)),d_abs(d_add(d_sub(d_add(d_add(d_sub(d_neg(Xi2),d_mul(d_imul(2,xi),Xi)),Xr2),d_mul(d_imul(2,xr),Xr)),xi2),xr2)))),ci);
}

);

static const char *perturbation_opencl_floatexp_24_4_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_mul(fe_imul(12,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(12,Xr),xr),xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xr2),Xi),xi)),fe_mul(fe_imul(6,xr2),xi2)),cr);
xin=fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr),Xi),fe_diffabs(fe_sub(Xr2,Xi2),fe_add(fe_sub(fe_add(fe_mul(fe_imul(-2,xi),Xi),fe_mul(fe_imul(2,xr),Xr)),xi2),xr2))),fe_mul(fe_add(fe_add(fe_mul(fe_imul(4,Xr),xi),fe_mul(fe_imul(4,xr),Xi)),fe_mul(fe_imul(4,xr),xi)),fe_abs(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_neg(Xi2),fe_mul(fe_imul(2,xi),Xi)),Xr2),fe_mul(fe_imul(2,xr),Xr)),xi2),xr2)))),ci);
}

);

static const char *perturbation_opencl_floatexp_24_4_1 = STR(

{dxan=fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dya)))),fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dxa)))),fe_add(fe_imul(-12,fe_mul(Xxr,fe_mul(Xxr,dya))),fe_add(fe_imul(-24,fe_mul(Xxi,fe_mul(Xxr,dxa))),daa))));
dxbn=fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dyb)))),fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dxb)))),fe_add(fe_imul(-12,fe_mul(Xxr,fe_mul(Xxr,dyb))),fe_add(fe_imul(-24,fe_mul(Xxi,fe_mul(Xxr,dxb))),dab))));
dyan=fe_add(fe_imul(4,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr))),fe_mul(Xxi,dxa))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr))),fe_mul(Xxr,dya))),fe_add(fe_imul(8,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(-8,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))))),dba))));
dybn=fe_add(fe_imul(4,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr))),fe_mul(Xxi,dxb))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr))),fe_mul(Xxr,dyb))),fe_add(fe_imul(8,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(-8,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))))),dbb))));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_mul(fe_imul(12,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(12,Xr),xr),xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xr2),Xi),xi)),fe_mul(fe_imul(6,xr2),xi2)),cr);
xin=fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr),Xi),fe_diffabs(fe_sub(Xr2,Xi2),fe_add(fe_sub(fe_add(fe_mul(fe_imul(-2,xi),Xi),fe_mul(fe_imul(2,xr),Xr)),xi2),xr2))),fe_mul(fe_add(fe_add(fe_mul(fe_imul(4,Xr),xi),fe_mul(fe_imul(4,xr),Xi)),fe_mul(fe_imul(4,xr),xi)),fe_abs(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_neg(Xi2),fe_mul(fe_imul(2,xi),Xi)),Xr2),fe_mul(fe_imul(2,xr),Xr)),xi2),xr2)))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_24_4_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_mul(sf_imul(4,Xi),xi2),xi)),sf_mul(xi2,xi2)),sf_mul(sf_mul(sf_imul(12,Xr2),Xi),xi)),sf_mul(sf_imul(6,Xr2),xi2)),sf_mul(sf_mul(sf_imul(12,Xr),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(24,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_imul(12,Xr),xr),xi2)),sf_mul(sf_imul(6,xr2),Xi2)),sf_mul(sf_mul(sf_imul(12,xr2),Xi),xi)),sf_mul(sf_imul(6,xr2),xi2)),cr);
xin=sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr),Xi),sf_diffabs(sf_sub(Xr2,Xi2),sf_add(sf_sub(sf_add(sf_mul(sf_imul(-2,xi),Xi),sf_mul(sf_imul(2,xr),Xr)),xi2),xr2))),sf_mul(sf_add(sf_add(sf_mul(sf_imul(4,Xr),xi),sf_mul(sf_imul(4,xr),Xi)),sf_mul(sf_imul(4,xr),xi)),sf_abs(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_neg(Xi2),sf_mul(sf_imul(2,xi),Xi)),Xr2),sf_mul(sf_imul(2,xr),Xr)),xi2),xr2)))),ci);
}

);
#endif


static const char *perturbation_opencl_double_25_4_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_diffabs(d_sub(d_add(d_mul(Xr2,Xr2),d_mul(Xi2,Xi2)),d_mul(d_imul(6,Xr2),Xi2)),d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,xr),Xr),Xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xi),Xr2),Xi)),d_mul(d_mul(d_mul(d_imul(24,xr),xi),Xr),Xi)),d_mul(d_mul(d_imul(12,xr2),xi),Xi)),d_mul(d_imul(6,xi2),Xr2)),d_mul(d_mul(d_imul(12,xr),xi2),Xr)),d_mul(d_imul(6,xr2),xi2))),cr);
xin=d_add(d_sub(d_mul(d_neg(d_mul(d_imul(4,Xr),Xi)),d_diffabs(d_sub(Xr2,Xi2),d_add(d_sub(d_add(d_mul(d_imul(-2,xi),Xi),d_mul(d_imul(2,xr),Xr)),xi2),xr2))),d_mul(d_add(d_add(d_mul(d_imul(4,Xr),xi),d_mul(d_imul(4,xr),Xi)),d_mul(d_imul(4,xr),xi)),d_abs(d_add(d_sub(d_add(d_add(d_sub(d_neg(Xi2),d_mul(d_imul(2,xi),Xi)),Xr2),d_mul(d_imul(2,xr),Xr)),xi2),xr2)))),ci);
}

);

static const char *perturbation_opencl_double_25_4_1 = STR(

{dxan=d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dya,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-12,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr)))))))))),d_add(d_imul(-24,d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr)))))))))),daa))));
dxbn=d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dyb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-12,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr)))))))))),d_add(d_imul(-24,d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr)))))))))),dab))));
dyan=d_add(d_imul(-4,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr))),d_mul(Xxi,dxa))),d_add(d_imul(-4,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr))),d_mul(Xxr,dya))),d_add(d_imul(-8,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))))),d_add(d_imul(8,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))))),dba))));
dybn=d_add(d_imul(-4,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr))),d_mul(Xxi,dxb))),d_add(d_imul(-4,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr))),d_mul(Xxr,dyb))),d_add(d_imul(-8,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))))),d_add(d_imul(8,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))))),dbb))));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_diffabs(d_sub(d_add(d_mul(Xr2,Xr2),d_mul(Xi2,Xi2)),d_mul(d_imul(6,Xr2),Xi2)),d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,xr),Xr),Xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xi),Xr2),Xi)),d_mul(d_mul(d_mul(d_imul(24,xr),xi),Xr),Xi)),d_mul(d_mul(d_imul(12,xr2),xi),Xi)),d_mul(d_imul(6,xi2),Xr2)),d_mul(d_mul(d_imul(12,xr),xi2),Xr)),d_mul(d_imul(6,xr2),xi2))),cr);
xin=d_add(d_sub(d_mul(d_neg(d_mul(d_imul(4,Xr),Xi)),d_diffabs(d_sub(Xr2,Xi2),d_add(d_sub(d_add(d_mul(d_imul(-2,xi),Xi),d_mul(d_imul(2,xr),Xr)),xi2),xr2))),d_mul(d_add(d_add(d_mul(d_imul(4,Xr),xi),d_mul(d_imul(4,xr),Xi)),d_mul(d_imul(4,xr),xi)),d_abs(d_add(d_sub(d_add(d_add(d_sub(d_neg(Xi2),d_mul(d_imul(2,xi),Xi)),Xr2),d_mul(d_imul(2,xr),Xr)),xi2),xr2)))),ci);
}

);

static const char *perturbation_opencl_floatexp_25_4_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_add(fe_mul(Xr2,Xr2),fe_mul(Xi2,Xi2)),fe_mul(fe_imul(6,Xr2),Xi2)),fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,xr),Xr),Xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xi),Xr2),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(24,xr),xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(12,xr2),xi),Xi)),fe_mul(fe_imul(6,xi2),Xr2)),fe_mul(fe_mul(fe_imul(12,xr),xi2),Xr)),fe_mul(fe_imul(6,xr2),xi2))),cr);
xin=fe_add(fe_sub(fe_mul(fe_neg(fe_mul(fe_imul(4,Xr),Xi)),fe_diffabs(fe_sub(Xr2,Xi2),fe_add(fe_sub(fe_add(fe_mul(fe_imul(-2,xi),Xi),fe_mul(fe_imul(2,xr),Xr)),xi2),xr2))),fe_mul(fe_add(fe_add(fe_mul(fe_imul(4,Xr),xi),fe_mul(fe_imul(4,xr),Xi)),fe_mul(fe_imul(4,xr),xi)),fe_abs(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_neg(Xi2),fe_mul(fe_imul(2,xi),Xi)),Xr2),fe_mul(fe_imul(2,xr),Xr)),xi2),xr2)))),ci);
}

);

static const char *perturbation_opencl_floatexp_25_4_1 = STR(

{dxan=fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dya,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-12,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))))),fe_add(fe_imul(-24,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))))),daa))));
dxbn=fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dyb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-12,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))))),fe_add(fe_imul(-24,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))))),dab))));
dyan=fe_add(fe_imul(-4,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr))),fe_mul(Xxi,dxa))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr))),fe_mul(Xxr,dya))),fe_add(fe_imul(-8,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(8,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))))),dba))));
dybn=fe_add(fe_imul(-4,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr))),fe_mul(Xxi,dxb))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr))),fe_mul(Xxr,dyb))),fe_add(fe_imul(-8,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(8,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))))),dbb))));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_add(fe_mul(Xr2,Xr2),fe_mul(Xi2,Xi2)),fe_mul(fe_imul(6,Xr2),Xi2)),fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,xr),Xr),Xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xi),Xr2),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(24,xr),xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(12,xr2),xi),Xi)),fe_mul(fe_imul(6,xi2),Xr2)),fe_mul(fe_mul(fe_imul(12,xr),xi2),Xr)),fe_mul(fe_imul(6,xr2),xi2))),cr);
xin=fe_add(fe_sub(fe_mul(fe_neg(fe_mul(fe_imul(4,Xr),Xi)),fe_diffabs(fe_sub(Xr2,Xi2),fe_add(fe_sub(fe_add(fe_mul(fe_imul(-2,xi),Xi),fe_mul(fe_imul(2,xr),Xr)),xi2),xr2))),fe_mul(fe_add(fe_add(fe_mul(fe_imul(4,Xr),xi),fe_mul(fe_imul(4,xr),Xi)),fe_mul(fe_imul(4,xr),xi)),fe_abs(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_neg(Xi2),fe_mul(fe_imul(2,xi),Xi)),Xr2),fe_mul(fe_imul(2,xr),Xr)),xi2),xr2)))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_25_4_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_diffabs(sf_sub(sf_add(sf_mul(Xr2,Xr2),sf_mul(Xi2,Xi2)),sf_mul(sf_imul(6,Xr2),Xi2)),sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_mul(sf_imul(4,Xi),xi2),xi)),sf_mul(xi2,xi2)),sf_mul(sf_mul(sf_imul(12,xr),Xr),Xi2)),sf_mul(sf_imul(6,xr2),Xi2)),sf_mul(sf_mul(sf_imul(12,xi),Xr2),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(24,xr),xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(12,xr2),xi),Xi)),sf_mul(sf_imul(6,xi2),Xr2)),sf_mul(sf_mul(sf_imul(12,xr),xi2),Xr)),sf_mul(sf_imul(6,xr2),xi2))),cr);
xin=sf_add(sf_sub(sf_mul(sf_neg(sf_mul(sf_imul(4,Xr),Xi)),sf_diffabs(sf_sub(Xr2,Xi2),sf_add(sf_sub(sf_add(sf_mul(sf_imul(-2,xi),Xi),sf_mul(sf_imul(2,xr),Xr)),xi2),xr2))),sf_mul(sf_add(sf_add(sf_mul(sf_imul(4,Xr),xi),sf_mul(sf_imul(4,xr),Xi)),sf_mul(sf_imul(4,xr),xi)),sf_abs(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_neg(Xi2),sf_mul(sf_imul(2,xi),Xi)),Xr2),sf_mul(sf_imul(2,xr),Xr)),xi2),xr2)))),ci);
}

);
#endif


static const char *perturbation_opencl_double_26_4_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_diffabs(d_sub(d_add(d_mul(Xr2,Xr2),d_mul(Xi2,Xi2)),d_mul(d_imul(6,Xr2),Xi2)),d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,xr),Xr),Xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xi),Xr2),Xi)),d_mul(d_mul(d_mul(d_imul(24,xr),xi),Xr),Xi)),d_mul(d_mul(d_imul(12,xr2),xi),Xi)),d_mul(d_imul(6,xi2),Xr2)),d_mul(d_mul(d_imul(12,xr),xi2),Xr)),d_mul(d_imul(6,xr2),xi2))),cr);
xin=d_add(d_add(d_mul(d_mul(d_imul(4,Xr),Xi),d_diffabs(d_sub(Xr2,Xi2),d_add(d_sub(d_add(d_mul(d_imul(-2,xi),Xi),d_mul(d_imul(2,xr),Xr)),xi2),xr2))),d_mul(d_add(d_add(d_mul(d_imul(4,Xr),xi),d_mul(d_imul(4,xr),Xi)),d_mul(d_imul(4,xr),xi)),d_abs(d_add(d_sub(d_add(d_add(d_sub(d_neg(Xi2),d_mul(d_imul(2,xi),Xi)),Xr2),d_mul(d_imul(2,xr),Xr)),xi2),xr2)))),ci);
}

);

static const char *perturbation_opencl_double_26_4_1 = STR(

{dxan=d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dya,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-12,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr)))))))))),d_add(d_imul(-24,d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr)))))))))),daa))));
dxbn=d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dyb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-12,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr)))))))))),d_add(d_imul(-24,d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr)))))))))),dab))));
dyan=d_add(d_imul(4,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr))),d_mul(Xxi,dxa))),d_add(d_imul(4,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr))),d_mul(Xxr,dya))),d_add(d_imul(8,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))))),d_add(d_imul(-8,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))))),dba))));
dybn=d_add(d_imul(4,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr))),d_mul(Xxi,dxb))),d_add(d_imul(4,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr))),d_mul(Xxr,dyb))),d_add(d_imul(8,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))))),d_add(d_imul(-8,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))))),dbb))));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_diffabs(d_sub(d_add(d_mul(Xr2,Xr2),d_mul(Xi2,Xi2)),d_mul(d_imul(6,Xr2),Xi2)),d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,xr),Xr),Xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xi),Xr2),Xi)),d_mul(d_mul(d_mul(d_imul(24,xr),xi),Xr),Xi)),d_mul(d_mul(d_imul(12,xr2),xi),Xi)),d_mul(d_imul(6,xi2),Xr2)),d_mul(d_mul(d_imul(12,xr),xi2),Xr)),d_mul(d_imul(6,xr2),xi2))),cr);
xin=d_add(d_add(d_mul(d_mul(d_imul(4,Xr),Xi),d_diffabs(d_sub(Xr2,Xi2),d_add(d_sub(d_add(d_mul(d_imul(-2,xi),Xi),d_mul(d_imul(2,xr),Xr)),xi2),xr2))),d_mul(d_add(d_add(d_mul(d_imul(4,Xr),xi),d_mul(d_imul(4,xr),Xi)),d_mul(d_imul(4,xr),xi)),d_abs(d_add(d_sub(d_add(d_add(d_sub(d_neg(Xi2),d_mul(d_imul(2,xi),Xi)),Xr2),d_mul(d_imul(2,xr),Xr)),xi2),xr2)))),ci);
}

);

static const char *perturbation_opencl_floatexp_26_4_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_add(fe_mul(Xr2,Xr2),fe_mul(Xi2,Xi2)),fe_mul(fe_imul(6,Xr2),Xi2)),fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,xr),Xr),Xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xi),Xr2),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(24,xr),xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(12,xr2),xi),Xi)),fe_mul(fe_imul(6,xi2),Xr2)),fe_mul(fe_mul(fe_imul(12,xr),xi2),Xr)),fe_mul(fe_imul(6,xr2),xi2))),cr);
xin=fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr),Xi),fe_diffabs(fe_sub(Xr2,Xi2),fe_add(fe_sub(fe_add(fe_mul(fe_imul(-2,xi),Xi),fe_mul(fe_imul(2,xr),Xr)),xi2),xr2))),fe_mul(fe_add(fe_add(fe_mul(fe_imul(4,Xr),xi),fe_mul(fe_imul(4,xr),Xi)),fe_mul(fe_imul(4,xr),xi)),fe_abs(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_neg(Xi2),fe_mul(fe_imul(2,xi),Xi)),Xr2),fe_mul(fe_imul(2,xr),Xr)),xi2),xr2)))),ci);
}

);

static const char *perturbation_opencl_floatexp_26_4_1 = STR(

{dxan=fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dya,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-12,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))))),fe_add(fe_imul(-24,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))))),daa))));
dxbn=fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dyb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-12,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))))),fe_add(fe_imul(-24,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))))),dab))));
dyan=fe_add(fe_imul(4,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr))),fe_mul(Xxi,dxa))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr))),fe_mul(Xxr,dya))),fe_add(fe_imul(8,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(-8,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))))),dba))));
dybn=fe_add(fe_imul(4,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr))),fe_mul(Xxi,dxb))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr))),fe_mul(Xxr,dyb))),fe_add(fe_imul(8,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(-8,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))))),dbb))));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_add(fe_mul(Xr2,Xr2),fe_mul(Xi2,Xi2)),fe_mul(fe_imul(6,Xr2),Xi2)),fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,xr),Xr),Xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xi),Xr2),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(24,xr),xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(12,xr2),xi),Xi)),fe_mul(fe_imul(6,xi2),Xr2)),fe_mul(fe_mul(fe_imul(12,xr),xi2),Xr)),fe_mul(fe_imul(6,xr2),xi2))),cr);
xin=fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr),Xi),fe_diffabs(fe_sub(Xr2,Xi2),fe_add(fe_sub(fe_add(fe_mul(fe_imul(-2,xi),Xi),fe_mul(fe_imul(2,xr),Xr)),xi2),xr2))),fe_mul(fe_add(fe_add(fe_mul(fe_imul(4,Xr),xi),fe_mul(fe_imul(4,xr),Xi)),fe_mul(fe_imul(4,xr),xi)),fe_abs(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_neg(Xi2),fe_mul(fe_imul(2,xi),Xi)),Xr2),fe_mul(fe_imul(2,xr),Xr)),xi2),xr2)))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_26_4_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_diffabs(sf_sub(sf_add(sf_mul(Xr2,Xr2),sf_mul(Xi2,Xi2)),sf_mul(sf_imul(6,Xr2),Xi2)),sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_mul(sf_imul(4,Xi),xi2),xi)),sf_mul(xi2,xi2)),sf_mul(sf_mul(sf_imul(12,xr),Xr),Xi2)),sf_mul(sf_imul(6,xr2),Xi2)),sf_mul(sf_mul(sf_imul(12,xi),Xr2),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(24,xr),xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(12,xr2),xi),Xi)),sf_mul(sf_imul(6,xi2),Xr2)),sf_mul(sf_mul(sf_imul(12,xr),xi2),Xr)),sf_mul(sf_imul(6,xr2),xi2))),cr);
xin=sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr),Xi),sf_diffabs(sf_sub(Xr2,Xi2),sf_add(sf_sub(sf_add(sf_mul(sf_imul(-2,xi),Xi),sf_mul(sf_imul(2,xr),Xr)),xi2),xr2))),sf_mul(sf_add(sf_add(sf_mul(sf_imul(4,Xr),xi),sf_mul(sf_imul(4,xr),Xi)),sf_mul(sf_imul(4,xr),xi)),sf_abs(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_neg(Xi2),sf_mul(sf_imul(2,xi),Xi)),Xr2),sf_mul(sf_imul(2,xr),Xr)),xi2),xr2)))),ci);
}

);
#endif


static const char *perturbation_opencl_double_27_5_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_add(d_mul(d_diffabs(Xr,xr),d_add(d_sub(d_mul(Xr2,Xr2),d_mul(d_imul(10,Xr2),Xi2)),d_mul(d_imul(5,Xi2),Xi2))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(20,Xr2),Xi),xi)),d_mul(d_imul(10,Xr2),xi2)),d_mul(d_mul(d_imul(20,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(40,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(20,Xr),xr),xi2)),d_mul(d_imul(10,xr2),Xi2)),d_mul(d_mul(d_imul(20,xr2),Xi),xi)),d_mul(d_imul(10,xr2),xi2)),d_mul(d_mul(d_imul(20,Xi2),Xi),xi)),d_mul(d_imul(30,Xi2),xi2)),d_mul(d_mul(d_imul(20,Xi),xi2),xi)),d_mul(d_imul(5,xi2),xi2)))),cr);
xin=d_add(d_add(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_mul(d_mul(d_mul(d_imul(20,Xi),Xr2),Xr),xr),d_mul(d_mul(d_imul(30,Xi),Xr2),xr2)),d_mul(d_mul(d_mul(d_imul(20,Xi),Xr),xr2),xr)),d_mul(d_mul(d_imul(5,Xi),xr2),xr2)),d_mul(d_mul(d_imul(30,Xi2),Xr2),xi)),d_mul(d_mul(d_imul(30,Xi),Xr2),xi2)),d_mul(d_mul(d_mul(d_imul(20,Xi2),Xi),Xr),xr)),d_mul(d_mul(d_mul(d_imul(60,Xi2),Xr),xr),xi)),d_mul(d_mul(d_mul(d_imul(60,Xi),Xr),xr),xi2)),d_mul(d_mul(d_imul(10,Xi2),Xi),xr2)),d_mul(d_mul(d_imul(30,Xi2),xr2),xi)),d_mul(d_mul(d_imul(30,Xi),xr2),xi2)),d_mul(d_mul(d_imul(5,Xi2),Xi2),xi)),d_mul(d_mul(d_imul(10,Xi2),Xi),xi2)),d_mul(d_mul(d_imul(10,Xi2),xi2),xi)),d_mul(d_mul(d_imul(5,Xi),xi2),xi2)),d_mul(d_mul(d_imul(5,xi),Xr2),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi),Xr2),Xr),xr)),d_mul(d_mul(d_imul(30,xi),Xr2),xr2)),d_mul(d_mul(d_mul(d_imul(20,xi),Xr),xr2),xr)),d_mul(d_mul(d_imul(5,xi),xr2),xr2)),d_mul(d_mul(d_imul(10,xi2),xi),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi2),xi),Xr),xr)),d_mul(d_mul(d_imul(10,xi2),xi),xr2)),d_mul(d_mul(xi2,xi2),xi)),ci);
}

);

static const char *perturbation_opencl_double_27_5_1 = STR(

{dxan=d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxa,d_sgn(Xxr))))))),d_add(d_imul(5,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr))))))))))),d_add(d_imul(20,d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dya))))),d_add(d_imul(-20,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(Xxi,dya))),d_add(d_imul(-30,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr))))))))),daa)))));
dxbn=d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxb,d_sgn(Xxr))))))),d_add(d_imul(5,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr))))))))))),d_add(d_imul(20,d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dyb))))),d_add(d_imul(-20,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(Xxi,dyb))),d_add(d_imul(-30,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr))))))))),dab)))));
dyan=d_add(dba,d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dya))))),d_add(d_imul(-20,d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr)))))))),d_add(d_imul(20,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr)))))))))),d_add(d_imul(-30,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,d_mul(Xxi,dya)))),d_imul(5,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr)))),dya)))))));
dybn=d_add(dbb,d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dyb))))),d_add(d_imul(-20,d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr)))))))),d_add(d_imul(20,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr)))))))))),d_add(d_imul(-30,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,d_mul(Xxi,dyb)))),d_imul(5,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr)))),dyb)))))));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_add(d_mul(d_diffabs(Xr,xr),d_add(d_sub(d_mul(Xr2,Xr2),d_mul(d_imul(10,Xr2),Xi2)),d_mul(d_imul(5,Xi2),Xi2))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(20,Xr2),Xi),xi)),d_mul(d_imul(10,Xr2),xi2)),d_mul(d_mul(d_imul(20,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(40,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(20,Xr),xr),xi2)),d_mul(d_imul(10,xr2),Xi2)),d_mul(d_mul(d_imul(20,xr2),Xi),xi)),d_mul(d_imul(10,xr2),xi2)),d_mul(d_mul(d_imul(20,Xi2),Xi),xi)),d_mul(d_imul(30,Xi2),xi2)),d_mul(d_mul(d_imul(20,Xi),xi2),xi)),d_mul(d_imul(5,xi2),xi2)))),cr);
xin=d_add(d_add(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_mul(d_mul(d_mul(d_imul(20,Xi),Xr2),Xr),xr),d_mul(d_mul(d_imul(30,Xi),Xr2),xr2)),d_mul(d_mul(d_mul(d_imul(20,Xi),Xr),xr2),xr)),d_mul(d_mul(d_imul(5,Xi),xr2),xr2)),d_mul(d_mul(d_imul(30,Xi2),Xr2),xi)),d_mul(d_mul(d_imul(30,Xi),Xr2),xi2)),d_mul(d_mul(d_mul(d_imul(20,Xi2),Xi),Xr),xr)),d_mul(d_mul(d_mul(d_imul(60,Xi2),Xr),xr),xi)),d_mul(d_mul(d_mul(d_imul(60,Xi),Xr),xr),xi2)),d_mul(d_mul(d_imul(10,Xi2),Xi),xr2)),d_mul(d_mul(d_imul(30,Xi2),xr2),xi)),d_mul(d_mul(d_imul(30,Xi),xr2),xi2)),d_mul(d_mul(d_imul(5,Xi2),Xi2),xi)),d_mul(d_mul(d_imul(10,Xi2),Xi),xi2)),d_mul(d_mul(d_imul(10,Xi2),xi2),xi)),d_mul(d_mul(d_imul(5,Xi),xi2),xi2)),d_mul(d_mul(d_imul(5,xi),Xr2),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi),Xr2),Xr),xr)),d_mul(d_mul(d_imul(30,xi),Xr2),xr2)),d_mul(d_mul(d_mul(d_imul(20,xi),Xr),xr2),xr)),d_mul(d_mul(d_imul(5,xi),xr2),xr2)),d_mul(d_mul(d_imul(10,xi2),xi),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi2),xi),Xr),xr)),d_mul(d_mul(d_imul(10,xi2),xi),xr2)),d_mul(d_mul(xi2,xi2),xi)),ci);
}

);

static const char *perturbation_opencl_floatexp_27_5_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_mul(fe_diffabs(Xr,xr),fe_add(fe_sub(fe_mul(Xr2,Xr2),fe_mul(fe_imul(10,Xr2),Xi2)),fe_mul(fe_imul(5,Xi2),Xi2))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(20,Xr2),Xi),xi)),fe_mul(fe_imul(10,Xr2),xi2)),fe_mul(fe_mul(fe_imul(20,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(40,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(20,Xr),xr),xi2)),fe_mul(fe_imul(10,xr2),Xi2)),fe_mul(fe_mul(fe_imul(20,xr2),Xi),xi)),fe_mul(fe_imul(10,xr2),xi2)),fe_mul(fe_mul(fe_imul(20,Xi2),Xi),xi)),fe_mul(fe_imul(30,Xi2),xi2)),fe_mul(fe_mul(fe_imul(20,Xi),xi2),xi)),fe_mul(fe_imul(5,xi2),xi2)))),cr);
xin=fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),Xr2),Xr),xr),fe_mul(fe_mul(fe_imul(30,Xi),Xr2),xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),Xr),xr2),xr)),fe_mul(fe_mul(fe_imul(5,Xi),xr2),xr2)),fe_mul(fe_mul(fe_imul(30,Xi2),Xr2),xi)),fe_mul(fe_mul(fe_imul(30,Xi),Xr2),xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi2),Xi),Xr),xr)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi2),Xr),xr),xi)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi),Xr),xr),xi2)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xr2)),fe_mul(fe_mul(fe_imul(30,Xi2),xr2),xi)),fe_mul(fe_mul(fe_imul(30,Xi),xr2),xi2)),fe_mul(fe_mul(fe_imul(5,Xi2),Xi2),xi)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xi2)),fe_mul(fe_mul(fe_imul(10,Xi2),xi2),xi)),fe_mul(fe_mul(fe_imul(5,Xi),xi2),xi2)),fe_mul(fe_mul(fe_imul(5,xi),Xr2),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),Xr2),Xr),xr)),fe_mul(fe_mul(fe_imul(30,xi),Xr2),xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),Xr),xr2),xr)),fe_mul(fe_mul(fe_imul(5,xi),xr2),xr2)),fe_mul(fe_mul(fe_imul(10,xi2),xi),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi2),xi),Xr),xr)),fe_mul(fe_mul(fe_imul(10,xi2),xi),xr2)),fe_mul(fe_mul(xi2,xi2),xi)),ci);
}

);

static const char *perturbation_opencl_floatexp_27_5_1 = STR(

{dxan=fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxa,fe_sgn(Xxr))))))),fe_add(fe_imul(5,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr))))))))))),fe_add(fe_imul(20,fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dya))))),fe_add(fe_imul(-20,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(Xxi,dya))),fe_add(fe_imul(-30,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr))))))))),daa)))));
dxbn=fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxb,fe_sgn(Xxr))))))),fe_add(fe_imul(5,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr))))))))))),fe_add(fe_imul(20,fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dyb))))),fe_add(fe_imul(-20,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(Xxi,dyb))),fe_add(fe_imul(-30,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr))))))))),dab)))));
dyan=fe_add(dba,fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dya))))),fe_add(fe_imul(-20,fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr)))))))),fe_add(fe_imul(20,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr)))))))))),fe_add(fe_imul(-30,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,fe_mul(Xxi,dya)))),fe_imul(5,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr)))),dya)))))));
dybn=fe_add(dbb,fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dyb))))),fe_add(fe_imul(-20,fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr)))))))),fe_add(fe_imul(20,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr)))))))))),fe_add(fe_imul(-30,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,fe_mul(Xxi,dyb)))),fe_imul(5,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr)))),dyb)))))));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_mul(fe_diffabs(Xr,xr),fe_add(fe_sub(fe_mul(Xr2,Xr2),fe_mul(fe_imul(10,Xr2),Xi2)),fe_mul(fe_imul(5,Xi2),Xi2))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(20,Xr2),Xi),xi)),fe_mul(fe_imul(10,Xr2),xi2)),fe_mul(fe_mul(fe_imul(20,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(40,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(20,Xr),xr),xi2)),fe_mul(fe_imul(10,xr2),Xi2)),fe_mul(fe_mul(fe_imul(20,xr2),Xi),xi)),fe_mul(fe_imul(10,xr2),xi2)),fe_mul(fe_mul(fe_imul(20,Xi2),Xi),xi)),fe_mul(fe_imul(30,Xi2),xi2)),fe_mul(fe_mul(fe_imul(20,Xi),xi2),xi)),fe_mul(fe_imul(5,xi2),xi2)))),cr);
xin=fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),Xr2),Xr),xr),fe_mul(fe_mul(fe_imul(30,Xi),Xr2),xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),Xr),xr2),xr)),fe_mul(fe_mul(fe_imul(5,Xi),xr2),xr2)),fe_mul(fe_mul(fe_imul(30,Xi2),Xr2),xi)),fe_mul(fe_mul(fe_imul(30,Xi),Xr2),xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi2),Xi),Xr),xr)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi2),Xr),xr),xi)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi),Xr),xr),xi2)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xr2)),fe_mul(fe_mul(fe_imul(30,Xi2),xr2),xi)),fe_mul(fe_mul(fe_imul(30,Xi),xr2),xi2)),fe_mul(fe_mul(fe_imul(5,Xi2),Xi2),xi)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xi2)),fe_mul(fe_mul(fe_imul(10,Xi2),xi2),xi)),fe_mul(fe_mul(fe_imul(5,Xi),xi2),xi2)),fe_mul(fe_mul(fe_imul(5,xi),Xr2),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),Xr2),Xr),xr)),fe_mul(fe_mul(fe_imul(30,xi),Xr2),xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),Xr),xr2),xr)),fe_mul(fe_mul(fe_imul(5,xi),xr2),xr2)),fe_mul(fe_mul(fe_imul(10,xi2),xi),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi2),xi),Xr),xr)),fe_mul(fe_mul(fe_imul(10,xi2),xi),xr2)),fe_mul(fe_mul(xi2,xi2),xi)),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_27_5_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_add(sf_mul(sf_diffabs(Xr,xr),sf_add(sf_sub(sf_mul(Xr2,Xr2),sf_mul(sf_imul(10,Xr2),Xi2)),sf_mul(sf_imul(5,Xi2),Xi2))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_add(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(20,Xr2),Xi),xi)),sf_mul(sf_imul(10,Xr2),xi2)),sf_mul(sf_mul(sf_imul(20,Xr),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(40,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_imul(20,Xr),xr),xi2)),sf_mul(sf_imul(10,xr2),Xi2)),sf_mul(sf_mul(sf_imul(20,xr2),Xi),xi)),sf_mul(sf_imul(10,xr2),xi2)),sf_mul(sf_mul(sf_imul(20,Xi2),Xi),xi)),sf_mul(sf_imul(30,Xi2),xi2)),sf_mul(sf_mul(sf_imul(20,Xi),xi2),xi)),sf_mul(sf_imul(5,xi2),xi2)))),cr);
xin=sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_mul(sf_imul(20,Xi),Xr2),Xr),xr),sf_mul(sf_mul(sf_imul(30,Xi),Xr2),xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xi),Xr),xr2),xr)),sf_mul(sf_mul(sf_imul(5,Xi),xr2),xr2)),sf_mul(sf_mul(sf_imul(30,Xi2),Xr2),xi)),sf_mul(sf_mul(sf_imul(30,Xi),Xr2),xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xi2),Xi),Xr),xr)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xi2),Xr),xr),xi)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xi),Xr),xr),xi2)),sf_mul(sf_mul(sf_imul(10,Xi2),Xi),xr2)),sf_mul(sf_mul(sf_imul(30,Xi2),xr2),xi)),sf_mul(sf_mul(sf_imul(30,Xi),xr2),xi2)),sf_mul(sf_mul(sf_imul(5,Xi2),Xi2),xi)),sf_mul(sf_mul(sf_imul(10,Xi2),Xi),xi2)),sf_mul(sf_mul(sf_imul(10,Xi2),xi2),xi)),sf_mul(sf_mul(sf_imul(5,Xi),xi2),xi2)),sf_mul(sf_mul(sf_imul(5,xi),Xr2),Xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi),Xr2),Xr),xr)),sf_mul(sf_mul(sf_imul(30,xi),Xr2),xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi),Xr),xr2),xr)),sf_mul(sf_mul(sf_imul(5,xi),xr2),xr2)),sf_mul(sf_mul(sf_imul(10,xi2),xi),Xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi2),xi),Xr),xr)),sf_mul(sf_mul(sf_imul(10,xi2),xi),xr2)),sf_mul(sf_mul(xi2,xi2),xi)),ci);
}

);
#endif


static const char *perturbation_opencl_double_28_5_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_add(d_mul(d_diffabs(Xr,xr),d_add(d_sub(d_mul(Xr2,Xr2),d_mul(d_imul(10,Xr2),Xi2)),d_mul(d_imul(5,Xi2),Xi2))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(20,Xr2),Xi),xi)),d_mul(d_imul(10,Xr2),xi2)),d_mul(d_mul(d_imul(20,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(40,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(20,Xr),xr),xi2)),d_mul(d_imul(10,xr2),Xi2)),d_mul(d_mul(d_imul(20,xr2),Xi),xi)),d_mul(d_imul(10,xr2),xi2)),d_mul(d_mul(d_imul(20,Xi2),Xi),xi)),d_mul(d_imul(30,Xi2),xi2)),d_mul(d_mul(d_imul(20,Xi),xi2),xi)),d_mul(d_imul(5,xi2),xi2)))),cr);
xin=d_sub(ci,d_add(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_mul(d_mul(d_mul(d_imul(20,Xi),Xr2),Xr),xr),d_mul(d_mul(d_imul(30,Xi),Xr2),xr2)),d_mul(d_mul(d_mul(d_imul(20,Xi),Xr),xr2),xr)),d_mul(d_mul(d_imul(5,Xi),xr2),xr2)),d_mul(d_mul(d_imul(30,Xi2),Xr2),xi)),d_mul(d_mul(d_imul(30,Xi),Xr2),xi2)),d_mul(d_mul(d_mul(d_imul(20,Xi2),Xi),Xr),xr)),d_mul(d_mul(d_mul(d_imul(60,Xi2),Xr),xr),xi)),d_mul(d_mul(d_mul(d_imul(60,Xi),Xr),xr),xi2)),d_mul(d_mul(d_imul(10,Xi2),Xi),xr2)),d_mul(d_mul(d_imul(30,Xi2),xr2),xi)),d_mul(d_mul(d_imul(30,Xi),xr2),xi2)),d_mul(d_mul(d_imul(5,Xi2),Xi2),xi)),d_mul(d_mul(d_imul(10,Xi2),Xi),xi2)),d_mul(d_mul(d_imul(10,Xi2),xi2),xi)),d_mul(d_mul(d_imul(5,Xi),xi2),xi2)),d_mul(d_mul(d_imul(5,xi),Xr2),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi),Xr2),Xr),xr)),d_mul(d_mul(d_imul(30,xi),Xr2),xr2)),d_mul(d_mul(d_mul(d_imul(20,xi),Xr),xr2),xr)),d_mul(d_mul(d_imul(5,xi),xr2),xr2)),d_mul(d_mul(d_imul(10,xi2),xi),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi2),xi),Xr),xr)),d_mul(d_mul(d_imul(10,xi2),xi),xr2)),d_mul(d_mul(xi2,xi2),xi)));
}

);

static const char *perturbation_opencl_double_28_5_1 = STR(

{dxan=d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxa,d_sgn(Xxr))))))),d_add(d_imul(5,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr))))))))))),d_add(d_imul(20,d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dya))))),d_add(d_imul(-20,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(Xxi,dya))),d_add(d_imul(-30,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr))))))))),daa)))));
dxbn=d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxb,d_sgn(Xxr))))))),d_add(d_imul(5,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr))))))))))),d_add(d_imul(20,d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dyb))))),d_add(d_imul(-20,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(Xxi,dyb))),d_add(d_imul(-30,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr))))))))),dab)))));
dyan=d_add(dba,d_add(d_imul(-5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dya))))),d_add(d_imul(20,d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr)))))))),d_add(d_imul(-20,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr)))))))))),d_add(d_imul(30,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,d_mul(Xxi,dya)))),d_imul(-5,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr)))),dya)))))));
dybn=d_add(dbb,d_add(d_imul(-5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dyb))))),d_add(d_imul(20,d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr)))))))),d_add(d_imul(-20,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr)))))))))),d_add(d_imul(30,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,d_mul(Xxi,dyb)))),d_imul(-5,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr)))),dyb)))))));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_add(d_mul(d_diffabs(Xr,xr),d_add(d_sub(d_mul(Xr2,Xr2),d_mul(d_imul(10,Xr2),Xi2)),d_mul(d_imul(5,Xi2),Xi2))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(20,Xr2),Xi),xi)),d_mul(d_imul(10,Xr2),xi2)),d_mul(d_mul(d_imul(20,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(40,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(20,Xr),xr),xi2)),d_mul(d_imul(10,xr2),Xi2)),d_mul(d_mul(d_imul(20,xr2),Xi),xi)),d_mul(d_imul(10,xr2),xi2)),d_mul(d_mul(d_imul(20,Xi2),Xi),xi)),d_mul(d_imul(30,Xi2),xi2)),d_mul(d_mul(d_imul(20,Xi),xi2),xi)),d_mul(d_imul(5,xi2),xi2)))),cr);
xin=d_sub(ci,d_add(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_mul(d_mul(d_mul(d_imul(20,Xi),Xr2),Xr),xr),d_mul(d_mul(d_imul(30,Xi),Xr2),xr2)),d_mul(d_mul(d_mul(d_imul(20,Xi),Xr),xr2),xr)),d_mul(d_mul(d_imul(5,Xi),xr2),xr2)),d_mul(d_mul(d_imul(30,Xi2),Xr2),xi)),d_mul(d_mul(d_imul(30,Xi),Xr2),xi2)),d_mul(d_mul(d_mul(d_imul(20,Xi2),Xi),Xr),xr)),d_mul(d_mul(d_mul(d_imul(60,Xi2),Xr),xr),xi)),d_mul(d_mul(d_mul(d_imul(60,Xi),Xr),xr),xi2)),d_mul(d_mul(d_imul(10,Xi2),Xi),xr2)),d_mul(d_mul(d_imul(30,Xi2),xr2),xi)),d_mul(d_mul(d_imul(30,Xi),xr2),xi2)),d_mul(d_mul(d_imul(5,Xi2),Xi2),xi)),d_mul(d_mul(d_imul(10,Xi2),Xi),xi2)),d_mul(d_mul(d_imul(10,Xi2),xi2),xi)),d_mul(d_mul(d_imul(5,Xi),xi2),xi2)),d_mul(d_mul(d_imul(5,xi),Xr2),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi),Xr2),Xr),xr)),d_mul(d_mul(d_imul(30,xi),Xr2),xr2)),d_mul(d_mul(d_mul(d_imul(20,xi),Xr),xr2),xr)),d_mul(d_mul(d_imul(5,xi),xr2),xr2)),d_mul(d_mul(d_imul(10,xi2),xi),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi2),xi),Xr),xr)),d_mul(d_mul(d_imul(10,xi2),xi),xr2)),d_mul(d_mul(xi2,xi2),xi)));
}

);

static const char *perturbation_opencl_floatexp_28_5_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_mul(fe_diffabs(Xr,xr),fe_add(fe_sub(fe_mul(Xr2,Xr2),fe_mul(fe_imul(10,Xr2),Xi2)),fe_mul(fe_imul(5,Xi2),Xi2))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(20,Xr2),Xi),xi)),fe_mul(fe_imul(10,Xr2),xi2)),fe_mul(fe_mul(fe_imul(20,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(40,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(20,Xr),xr),xi2)),fe_mul(fe_imul(10,xr2),Xi2)),fe_mul(fe_mul(fe_imul(20,xr2),Xi),xi)),fe_mul(fe_imul(10,xr2),xi2)),fe_mul(fe_mul(fe_imul(20,Xi2),Xi),xi)),fe_mul(fe_imul(30,Xi2),xi2)),fe_mul(fe_mul(fe_imul(20,Xi),xi2),xi)),fe_mul(fe_imul(5,xi2),xi2)))),cr);
xin=fe_sub(ci,fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),Xr2),Xr),xr),fe_mul(fe_mul(fe_imul(30,Xi),Xr2),xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),Xr),xr2),xr)),fe_mul(fe_mul(fe_imul(5,Xi),xr2),xr2)),fe_mul(fe_mul(fe_imul(30,Xi2),Xr2),xi)),fe_mul(fe_mul(fe_imul(30,Xi),Xr2),xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi2),Xi),Xr),xr)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi2),Xr),xr),xi)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi),Xr),xr),xi2)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xr2)),fe_mul(fe_mul(fe_imul(30,Xi2),xr2),xi)),fe_mul(fe_mul(fe_imul(30,Xi),xr2),xi2)),fe_mul(fe_mul(fe_imul(5,Xi2),Xi2),xi)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xi2)),fe_mul(fe_mul(fe_imul(10,Xi2),xi2),xi)),fe_mul(fe_mul(fe_imul(5,Xi),xi2),xi2)),fe_mul(fe_mul(fe_imul(5,xi),Xr2),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),Xr2),Xr),xr)),fe_mul(fe_mul(fe_imul(30,xi),Xr2),xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),Xr),xr2),xr)),fe_mul(fe_mul(fe_imul(5,xi),xr2),xr2)),fe_mul(fe_mul(fe_imul(10,xi2),xi),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi2),xi),Xr),xr)),fe_mul(fe_mul(fe_imul(10,xi2),xi),xr2)),fe_mul(fe_mul(xi2,xi2),xi)));
}

);

static const char *perturbation_opencl_floatexp_28_5_1 = STR(

{dxan=fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxa,fe_sgn(Xxr))))))),fe_add(fe_imul(5,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr))))))))))),fe_add(fe_imul(20,fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dya))))),fe_add(fe_imul(-20,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(Xxi,dya))),fe_add(fe_imul(-30,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr))))))))),daa)))));
dxbn=fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxb,fe_sgn(Xxr))))))),fe_add(fe_imul(5,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr))))))))))),fe_add(fe_imul(20,fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dyb))))),fe_add(fe_imul(-20,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(Xxi,dyb))),fe_add(fe_imul(-30,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr))))))))),dab)))));
dyan=fe_add(dba,fe_add(fe_imul(-5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dya))))),fe_add(fe_imul(20,fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr)))))))),fe_add(fe_imul(-20,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr)))))))))),fe_add(fe_imul(30,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,fe_mul(Xxi,dya)))),fe_imul(-5,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr)))),dya)))))));
dybn=fe_add(dbb,fe_add(fe_imul(-5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dyb))))),fe_add(fe_imul(20,fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr)))))))),fe_add(fe_imul(-20,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr)))))))))),fe_add(fe_imul(30,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,fe_mul(Xxi,dyb)))),fe_imul(-5,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr)))),dyb)))))));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_mul(fe_diffabs(Xr,xr),fe_add(fe_sub(fe_mul(Xr2,Xr2),fe_mul(fe_imul(10,Xr2),Xi2)),fe_mul(fe_imul(5,Xi2),Xi2))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(20,Xr2),Xi),xi)),fe_mul(fe_imul(10,Xr2),xi2)),fe_mul(fe_mul(fe_imul(20,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(40,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(20,Xr),xr),xi2)),fe_mul(fe_imul(10,xr2),Xi2)),fe_mul(fe_mul(fe_imul(20,xr2),Xi),xi)),fe_mul(fe_imul(10,xr2),xi2)),fe_mul(fe_mul(fe_imul(20,Xi2),Xi),xi)),fe_mul(fe_imul(30,Xi2),xi2)),fe_mul(fe_mul(fe_imul(20,Xi),xi2),xi)),fe_mul(fe_imul(5,xi2),xi2)))),cr);
xin=fe_sub(ci,fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),Xr2),Xr),xr),fe_mul(fe_mul(fe_imul(30,Xi),Xr2),xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),Xr),xr2),xr)),fe_mul(fe_mul(fe_imul(5,Xi),xr2),xr2)),fe_mul(fe_mul(fe_imul(30,Xi2),Xr2),xi)),fe_mul(fe_mul(fe_imul(30,Xi),Xr2),xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi2),Xi),Xr),xr)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi2),Xr),xr),xi)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi),Xr),xr),xi2)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xr2)),fe_mul(fe_mul(fe_imul(30,Xi2),xr2),xi)),fe_mul(fe_mul(fe_imul(30,Xi),xr2),xi2)),fe_mul(fe_mul(fe_imul(5,Xi2),Xi2),xi)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xi2)),fe_mul(fe_mul(fe_imul(10,Xi2),xi2),xi)),fe_mul(fe_mul(fe_imul(5,Xi),xi2),xi2)),fe_mul(fe_mul(fe_imul(5,xi),Xr2),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),Xr2),Xr),xr)),fe_mul(fe_mul(fe_imul(30,xi),Xr2),xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),Xr),xr2),xr)),fe_mul(fe_mul(fe_imul(5,xi),xr2),xr2)),fe_mul(fe_mul(fe_imul(10,xi2),xi),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi2),xi),Xr),xr)),fe_mul(fe_mul(fe_imul(10,xi2),xi),xr2)),fe_mul(fe_mul(xi2,xi2),xi)));
}

);

#if 0
static const char *perturbation_opencl_softfloat_28_5_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_add(sf_mul(sf_diffabs(Xr,xr),sf_add(sf_sub(sf_mul(Xr2,Xr2),sf_mul(sf_imul(10,Xr2),Xi2)),sf_mul(sf_imul(5,Xi2),Xi2))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_add(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(20,Xr2),Xi),xi)),sf_mul(sf_imul(10,Xr2),xi2)),sf_mul(sf_mul(sf_imul(20,Xr),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(40,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_imul(20,Xr),xr),xi2)),sf_mul(sf_imul(10,xr2),Xi2)),sf_mul(sf_mul(sf_imul(20,xr2),Xi),xi)),sf_mul(sf_imul(10,xr2),xi2)),sf_mul(sf_mul(sf_imul(20,Xi2),Xi),xi)),sf_mul(sf_imul(30,Xi2),xi2)),sf_mul(sf_mul(sf_imul(20,Xi),xi2),xi)),sf_mul(sf_imul(5,xi2),xi2)))),cr);
xin=sf_sub(ci,sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_mul(sf_imul(20,Xi),Xr2),Xr),xr),sf_mul(sf_mul(sf_imul(30,Xi),Xr2),xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xi),Xr),xr2),xr)),sf_mul(sf_mul(sf_imul(5,Xi),xr2),xr2)),sf_mul(sf_mul(sf_imul(30,Xi2),Xr2),xi)),sf_mul(sf_mul(sf_imul(30,Xi),Xr2),xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xi2),Xi),Xr),xr)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xi2),Xr),xr),xi)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xi),Xr),xr),xi2)),sf_mul(sf_mul(sf_imul(10,Xi2),Xi),xr2)),sf_mul(sf_mul(sf_imul(30,Xi2),xr2),xi)),sf_mul(sf_mul(sf_imul(30,Xi),xr2),xi2)),sf_mul(sf_mul(sf_imul(5,Xi2),Xi2),xi)),sf_mul(sf_mul(sf_imul(10,Xi2),Xi),xi2)),sf_mul(sf_mul(sf_imul(10,Xi2),xi2),xi)),sf_mul(sf_mul(sf_imul(5,Xi),xi2),xi2)),sf_mul(sf_mul(sf_imul(5,xi),Xr2),Xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi),Xr2),Xr),xr)),sf_mul(sf_mul(sf_imul(30,xi),Xr2),xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi),Xr),xr2),xr)),sf_mul(sf_mul(sf_imul(5,xi),xr2),xr2)),sf_mul(sf_mul(sf_imul(10,xi2),xi),Xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi2),xi),Xr),xr)),sf_mul(sf_mul(sf_imul(10,xi2),xi),xr2)),sf_mul(sf_mul(xi2,xi2),xi)));
}

);
#endif


static const char *perturbation_opencl_double_29_5_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_diffabs(d_add(d_sub(d_mul(d_mul(d_imul(5,Xr),Xi2),Xi2),d_mul(d_mul(d_imul(10,Xr2),Xr),Xi2)),d_mul(d_mul(Xr2,Xr2),Xr)),d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_add(d_add(d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_mul(d_mul(d_mul(d_imul(20,Xr),xi),Xi2),Xi),d_mul(d_mul(d_imul(30,Xr2),xr),Xi2)),d_mul(d_mul(d_imul(30,Xr),xi2),Xi2)),d_mul(d_mul(d_imul(30,Xr),xr2),Xi2)),d_mul(d_mul(d_mul(d_imul(20,Xr2),Xr),xi),Xi)),d_mul(d_mul(d_mul(d_imul(60,Xr2),xr),xi),Xi)),d_mul(d_mul(d_mul(d_imul(20,Xr),xi2),xi),Xi)),d_mul(d_mul(d_mul(d_imul(60,Xr),xr2),xi),Xi)),d_mul(d_mul(d_imul(5,Xr2),Xr2),xr)),d_mul(d_mul(d_imul(10,Xr2),Xr),xi2)),d_mul(d_mul(d_imul(10,Xr2),Xr),xr2)),d_mul(d_mul(d_imul(30,Xr2),xr),xi2)),d_mul(d_mul(d_imul(10,Xr2),xr2),xr)),d_mul(d_mul(d_imul(5,Xr),xi2),xi2)),d_mul(d_mul(d_imul(30,Xr),xr2),xi2)),d_mul(d_mul(d_imul(5,Xr),xr2),xr2)),d_mul(d_mul(d_imul(5,xr),Xi2),Xi2)),d_mul(d_mul(d_mul(d_imul(20,xr),xi),Xi2),Xi)),d_mul(d_mul(d_imul(30,xr),xi2),Xi2)),d_mul(d_mul(d_imul(10,xr2),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(20,xr),xi2),xi),Xi)),d_mul(d_mul(d_mul(d_imul(20,xr2),xr),xi),Xi)),d_mul(d_mul(d_imul(5,xr),xi2),xi2)),d_mul(d_mul(d_imul(10,xr2),xr),xi2)),d_mul(d_mul(xr2,xr2),xr))),cr);
xin=d_sub(ci,d_add(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_mul(d_mul(d_mul(d_imul(20,Xi),Xr2),Xr),xr),d_mul(d_mul(d_imul(30,Xi),Xr2),xr2)),d_mul(d_mul(d_mul(d_imul(20,Xi),Xr),xr2),xr)),d_mul(d_mul(d_imul(5,Xi),xr2),xr2)),d_mul(d_mul(d_imul(30,Xi2),Xr2),xi)),d_mul(d_mul(d_imul(30,Xi),Xr2),xi2)),d_mul(d_mul(d_mul(d_imul(20,Xi2),Xi),Xr),xr)),d_mul(d_mul(d_mul(d_imul(60,Xi2),Xr),xr),xi)),d_mul(d_mul(d_mul(d_imul(60,Xi),Xr),xr),xi2)),d_mul(d_mul(d_imul(10,Xi2),Xi),xr2)),d_mul(d_mul(d_imul(30,Xi2),xr2),xi)),d_mul(d_mul(d_imul(30,Xi),xr2),xi2)),d_mul(d_mul(d_imul(5,Xi2),Xi2),xi)),d_mul(d_mul(d_imul(10,Xi2),Xi),xi2)),d_mul(d_mul(d_imul(10,Xi2),xi2),xi)),d_mul(d_mul(d_imul(5,Xi),xi2),xi2)),d_mul(d_mul(d_imul(5,xi),Xr2),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi),Xr2),Xr),xr)),d_mul(d_mul(d_imul(30,xi),Xr2),xr2)),d_mul(d_mul(d_mul(d_imul(20,xi),Xr),xr2),xr)),d_mul(d_mul(d_imul(5,xi),xr2),xr2)),d_mul(d_mul(d_imul(10,xi2),xi),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi2),xi),Xr),xr)),d_mul(d_mul(d_imul(10,xi2),xi),xr2)),d_mul(d_mul(xi2,xi2),xi)));
}

);

static const char *perturbation_opencl_double_29_5_1 = STR(

{dxan=d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxa,d_sgn(d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr))))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_add(d_imul(5,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr))))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_add(d_imul(-20,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr))))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_add(d_imul(20,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr))))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_add(d_imul(-30,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr))))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),daa)))));
dxbn=d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxb,d_sgn(d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr))))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_add(d_imul(5,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr))))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_add(d_imul(-20,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr))))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_add(d_imul(20,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr))))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_add(d_imul(-30,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxr))))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr))))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),dab)))));
dyan=d_add(d_imul(-5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dya))))),d_add(d_imul(-5,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dya))))),d_add(d_imul(-20,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dxa))))),d_add(d_imul(20,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,dxa))))),d_add(d_imul(30,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,dya))))),dba)))));
dybn=d_add(d_imul(-5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dyb))))),d_add(d_imul(-5,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dyb))))),d_add(d_imul(-20,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dxb))))),d_add(d_imul(20,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,dxb))))),d_add(d_imul(30,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,dyb))))),dbb)))));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_diffabs(d_add(d_sub(d_mul(d_mul(d_imul(5,Xr),Xi2),Xi2),d_mul(d_mul(d_imul(10,Xr2),Xr),Xi2)),d_mul(d_mul(Xr2,Xr2),Xr)),d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_add(d_add(d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_mul(d_mul(d_mul(d_imul(20,Xr),xi),Xi2),Xi),d_mul(d_mul(d_imul(30,Xr2),xr),Xi2)),d_mul(d_mul(d_imul(30,Xr),xi2),Xi2)),d_mul(d_mul(d_imul(30,Xr),xr2),Xi2)),d_mul(d_mul(d_mul(d_imul(20,Xr2),Xr),xi),Xi)),d_mul(d_mul(d_mul(d_imul(60,Xr2),xr),xi),Xi)),d_mul(d_mul(d_mul(d_imul(20,Xr),xi2),xi),Xi)),d_mul(d_mul(d_mul(d_imul(60,Xr),xr2),xi),Xi)),d_mul(d_mul(d_imul(5,Xr2),Xr2),xr)),d_mul(d_mul(d_imul(10,Xr2),Xr),xi2)),d_mul(d_mul(d_imul(10,Xr2),Xr),xr2)),d_mul(d_mul(d_imul(30,Xr2),xr),xi2)),d_mul(d_mul(d_imul(10,Xr2),xr2),xr)),d_mul(d_mul(d_imul(5,Xr),xi2),xi2)),d_mul(d_mul(d_imul(30,Xr),xr2),xi2)),d_mul(d_mul(d_imul(5,Xr),xr2),xr2)),d_mul(d_mul(d_imul(5,xr),Xi2),Xi2)),d_mul(d_mul(d_mul(d_imul(20,xr),xi),Xi2),Xi)),d_mul(d_mul(d_imul(30,xr),xi2),Xi2)),d_mul(d_mul(d_imul(10,xr2),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(20,xr),xi2),xi),Xi)),d_mul(d_mul(d_mul(d_imul(20,xr2),xr),xi),Xi)),d_mul(d_mul(d_imul(5,xr),xi2),xi2)),d_mul(d_mul(d_imul(10,xr2),xr),xi2)),d_mul(d_mul(xr2,xr2),xr))),cr);
xin=d_sub(ci,d_add(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_mul(d_mul(d_mul(d_imul(20,Xi),Xr2),Xr),xr),d_mul(d_mul(d_imul(30,Xi),Xr2),xr2)),d_mul(d_mul(d_mul(d_imul(20,Xi),Xr),xr2),xr)),d_mul(d_mul(d_imul(5,Xi),xr2),xr2)),d_mul(d_mul(d_imul(30,Xi2),Xr2),xi)),d_mul(d_mul(d_imul(30,Xi),Xr2),xi2)),d_mul(d_mul(d_mul(d_imul(20,Xi2),Xi),Xr),xr)),d_mul(d_mul(d_mul(d_imul(60,Xi2),Xr),xr),xi)),d_mul(d_mul(d_mul(d_imul(60,Xi),Xr),xr),xi2)),d_mul(d_mul(d_imul(10,Xi2),Xi),xr2)),d_mul(d_mul(d_imul(30,Xi2),xr2),xi)),d_mul(d_mul(d_imul(30,Xi),xr2),xi2)),d_mul(d_mul(d_imul(5,Xi2),Xi2),xi)),d_mul(d_mul(d_imul(10,Xi2),Xi),xi2)),d_mul(d_mul(d_imul(10,Xi2),xi2),xi)),d_mul(d_mul(d_imul(5,Xi),xi2),xi2)),d_mul(d_mul(d_imul(5,xi),Xr2),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi),Xr2),Xr),xr)),d_mul(d_mul(d_imul(30,xi),Xr2),xr2)),d_mul(d_mul(d_mul(d_imul(20,xi),Xr),xr2),xr)),d_mul(d_mul(d_imul(5,xi),xr2),xr2)),d_mul(d_mul(d_imul(10,xi2),xi),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi2),xi),Xr),xr)),d_mul(d_mul(d_imul(10,xi2),xi),xr2)),d_mul(d_mul(xi2,xi2),xi)));
}

);

static const char *perturbation_opencl_floatexp_29_5_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_add(fe_sub(fe_mul(fe_mul(fe_imul(5,Xr),Xi2),Xi2),fe_mul(fe_mul(fe_imul(10,Xr2),Xr),Xi2)),fe_mul(fe_mul(Xr2,Xr2),Xr)),fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),xi),Xi2),Xi),fe_mul(fe_mul(fe_imul(30,Xr2),xr),Xi2)),fe_mul(fe_mul(fe_imul(30,Xr),xi2),Xi2)),fe_mul(fe_mul(fe_imul(30,Xr),xr2),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr2),Xr),xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xr2),xr),xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),xi2),xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xr),xr2),xi),Xi)),fe_mul(fe_mul(fe_imul(5,Xr2),Xr2),xr)),fe_mul(fe_mul(fe_imul(10,Xr2),Xr),xi2)),fe_mul(fe_mul(fe_imul(10,Xr2),Xr),xr2)),fe_mul(fe_mul(fe_imul(30,Xr2),xr),xi2)),fe_mul(fe_mul(fe_imul(10,Xr2),xr2),xr)),fe_mul(fe_mul(fe_imul(5,Xr),xi2),xi2)),fe_mul(fe_mul(fe_imul(30,Xr),xr2),xi2)),fe_mul(fe_mul(fe_imul(5,Xr),xr2),xr2)),fe_mul(fe_mul(fe_imul(5,xr),Xi2),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr),xi),Xi2),Xi)),fe_mul(fe_mul(fe_imul(30,xr),xi2),Xi2)),fe_mul(fe_mul(fe_imul(10,xr2),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr),xi2),xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr2),xr),xi),Xi)),fe_mul(fe_mul(fe_imul(5,xr),xi2),xi2)),fe_mul(fe_mul(fe_imul(10,xr2),xr),xi2)),fe_mul(fe_mul(xr2,xr2),xr))),cr);
xin=fe_sub(ci,fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),Xr2),Xr),xr),fe_mul(fe_mul(fe_imul(30,Xi),Xr2),xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),Xr),xr2),xr)),fe_mul(fe_mul(fe_imul(5,Xi),xr2),xr2)),fe_mul(fe_mul(fe_imul(30,Xi2),Xr2),xi)),fe_mul(fe_mul(fe_imul(30,Xi),Xr2),xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi2),Xi),Xr),xr)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi2),Xr),xr),xi)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi),Xr),xr),xi2)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xr2)),fe_mul(fe_mul(fe_imul(30,Xi2),xr2),xi)),fe_mul(fe_mul(fe_imul(30,Xi),xr2),xi2)),fe_mul(fe_mul(fe_imul(5,Xi2),Xi2),xi)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xi2)),fe_mul(fe_mul(fe_imul(10,Xi2),xi2),xi)),fe_mul(fe_mul(fe_imul(5,Xi),xi2),xi2)),fe_mul(fe_mul(fe_imul(5,xi),Xr2),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),Xr2),Xr),xr)),fe_mul(fe_mul(fe_imul(30,xi),Xr2),xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),Xr),xr2),xr)),fe_mul(fe_mul(fe_imul(5,xi),xr2),xr2)),fe_mul(fe_mul(fe_imul(10,xi2),xi),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi2),xi),Xr),xr)),fe_mul(fe_mul(fe_imul(10,xi2),xi),xr2)),fe_mul(fe_mul(xi2,xi2),xi)));
}

);

static const char *perturbation_opencl_floatexp_29_5_1 = STR(

{dxan=fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxa,fe_sgn(fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr))))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_add(fe_imul(5,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr))))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_add(fe_imul(-20,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr))))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_add(fe_imul(20,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr))))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_add(fe_imul(-30,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr))))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),daa)))));
dxbn=fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxb,fe_sgn(fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr))))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_add(fe_imul(5,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr))))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_add(fe_imul(-20,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr))))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_add(fe_imul(20,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr))))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_add(fe_imul(-30,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxr))))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr))))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),dab)))));
dyan=fe_add(fe_imul(-5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dya))))),fe_add(fe_imul(-5,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dya))))),fe_add(fe_imul(-20,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dxa))))),fe_add(fe_imul(20,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,dxa))))),fe_add(fe_imul(30,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,dya))))),dba)))));
dybn=fe_add(fe_imul(-5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dyb))))),fe_add(fe_imul(-5,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dyb))))),fe_add(fe_imul(-20,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dxb))))),fe_add(fe_imul(20,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,dxb))))),fe_add(fe_imul(30,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,dyb))))),dbb)))));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_add(fe_sub(fe_mul(fe_mul(fe_imul(5,Xr),Xi2),Xi2),fe_mul(fe_mul(fe_imul(10,Xr2),Xr),Xi2)),fe_mul(fe_mul(Xr2,Xr2),Xr)),fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),xi),Xi2),Xi),fe_mul(fe_mul(fe_imul(30,Xr2),xr),Xi2)),fe_mul(fe_mul(fe_imul(30,Xr),xi2),Xi2)),fe_mul(fe_mul(fe_imul(30,Xr),xr2),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr2),Xr),xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xr2),xr),xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xr),xi2),xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xr),xr2),xi),Xi)),fe_mul(fe_mul(fe_imul(5,Xr2),Xr2),xr)),fe_mul(fe_mul(fe_imul(10,Xr2),Xr),xi2)),fe_mul(fe_mul(fe_imul(10,Xr2),Xr),xr2)),fe_mul(fe_mul(fe_imul(30,Xr2),xr),xi2)),fe_mul(fe_mul(fe_imul(10,Xr2),xr2),xr)),fe_mul(fe_mul(fe_imul(5,Xr),xi2),xi2)),fe_mul(fe_mul(fe_imul(30,Xr),xr2),xi2)),fe_mul(fe_mul(fe_imul(5,Xr),xr2),xr2)),fe_mul(fe_mul(fe_imul(5,xr),Xi2),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr),xi),Xi2),Xi)),fe_mul(fe_mul(fe_imul(30,xr),xi2),Xi2)),fe_mul(fe_mul(fe_imul(10,xr2),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr),xi2),xi),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,xr2),xr),xi),Xi)),fe_mul(fe_mul(fe_imul(5,xr),xi2),xi2)),fe_mul(fe_mul(fe_imul(10,xr2),xr),xi2)),fe_mul(fe_mul(xr2,xr2),xr))),cr);
xin=fe_sub(ci,fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),Xr2),Xr),xr),fe_mul(fe_mul(fe_imul(30,Xi),Xr2),xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),Xr),xr2),xr)),fe_mul(fe_mul(fe_imul(5,Xi),xr2),xr2)),fe_mul(fe_mul(fe_imul(30,Xi2),Xr2),xi)),fe_mul(fe_mul(fe_imul(30,Xi),Xr2),xi2)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi2),Xi),Xr),xr)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi2),Xr),xr),xi)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi),Xr),xr),xi2)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xr2)),fe_mul(fe_mul(fe_imul(30,Xi2),xr2),xi)),fe_mul(fe_mul(fe_imul(30,Xi),xr2),xi2)),fe_mul(fe_mul(fe_imul(5,Xi2),Xi2),xi)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xi2)),fe_mul(fe_mul(fe_imul(10,Xi2),xi2),xi)),fe_mul(fe_mul(fe_imul(5,Xi),xi2),xi2)),fe_mul(fe_mul(fe_imul(5,xi),Xr2),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),Xr2),Xr),xr)),fe_mul(fe_mul(fe_imul(30,xi),Xr2),xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),Xr),xr2),xr)),fe_mul(fe_mul(fe_imul(5,xi),xr2),xr2)),fe_mul(fe_mul(fe_imul(10,xi2),xi),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi2),xi),Xr),xr)),fe_mul(fe_mul(fe_imul(10,xi2),xi),xr2)),fe_mul(fe_mul(xi2,xi2),xi)));
}

);

#if 0
static const char *perturbation_opencl_softfloat_29_5_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_diffabs(sf_add(sf_sub(sf_mul(sf_mul(sf_imul(5,Xr),Xi2),Xi2),sf_mul(sf_mul(sf_imul(10,Xr2),Xr),Xi2)),sf_mul(sf_mul(Xr2,Xr2),Xr)),sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_sub(sf_mul(sf_mul(sf_mul(sf_imul(20,Xr),xi),Xi2),Xi),sf_mul(sf_mul(sf_imul(30,Xr2),xr),Xi2)),sf_mul(sf_mul(sf_imul(30,Xr),xi2),Xi2)),sf_mul(sf_mul(sf_imul(30,Xr),xr2),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xr2),Xr),xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xr2),xr),xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xr),xi2),xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xr),xr2),xi),Xi)),sf_mul(sf_mul(sf_imul(5,Xr2),Xr2),xr)),sf_mul(sf_mul(sf_imul(10,Xr2),Xr),xi2)),sf_mul(sf_mul(sf_imul(10,Xr2),Xr),xr2)),sf_mul(sf_mul(sf_imul(30,Xr2),xr),xi2)),sf_mul(sf_mul(sf_imul(10,Xr2),xr2),xr)),sf_mul(sf_mul(sf_imul(5,Xr),xi2),xi2)),sf_mul(sf_mul(sf_imul(30,Xr),xr2),xi2)),sf_mul(sf_mul(sf_imul(5,Xr),xr2),xr2)),sf_mul(sf_mul(sf_imul(5,xr),Xi2),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xr),xi),Xi2),Xi)),sf_mul(sf_mul(sf_imul(30,xr),xi2),Xi2)),sf_mul(sf_mul(sf_imul(10,xr2),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xr),xi2),xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(20,xr2),xr),xi),Xi)),sf_mul(sf_mul(sf_imul(5,xr),xi2),xi2)),sf_mul(sf_mul(sf_imul(10,xr2),xr),xi2)),sf_mul(sf_mul(xr2,xr2),xr))),cr);
xin=sf_sub(ci,sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_mul(sf_imul(20,Xi),Xr2),Xr),xr),sf_mul(sf_mul(sf_imul(30,Xi),Xr2),xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xi),Xr),xr2),xr)),sf_mul(sf_mul(sf_imul(5,Xi),xr2),xr2)),sf_mul(sf_mul(sf_imul(30,Xi2),Xr2),xi)),sf_mul(sf_mul(sf_imul(30,Xi),Xr2),xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xi2),Xi),Xr),xr)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xi2),Xr),xr),xi)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xi),Xr),xr),xi2)),sf_mul(sf_mul(sf_imul(10,Xi2),Xi),xr2)),sf_mul(sf_mul(sf_imul(30,Xi2),xr2),xi)),sf_mul(sf_mul(sf_imul(30,Xi),xr2),xi2)),sf_mul(sf_mul(sf_imul(5,Xi2),Xi2),xi)),sf_mul(sf_mul(sf_imul(10,Xi2),Xi),xi2)),sf_mul(sf_mul(sf_imul(10,Xi2),xi2),xi)),sf_mul(sf_mul(sf_imul(5,Xi),xi2),xi2)),sf_mul(sf_mul(sf_imul(5,xi),Xr2),Xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi),Xr2),Xr),xr)),sf_mul(sf_mul(sf_imul(30,xi),Xr2),xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi),Xr),xr2),xr)),sf_mul(sf_mul(sf_imul(5,xi),xr2),xr2)),sf_mul(sf_mul(sf_imul(10,xi2),xi),Xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi2),xi),Xr),xr)),sf_mul(sf_mul(sf_imul(10,xi2),xi),xr2)),sf_mul(sf_mul(xi2,xi2),xi)));
}

);
#endif


static const char *perturbation_opencl_double_30_5_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_add(d_mul(d_diffabs(Xr,xr),d_add(d_sub(d_mul(Xr2,Xr2),d_mul(d_imul(10,Xr2),Xi2)),d_mul(d_imul(5,Xi2),Xi2))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(20,Xr2),Xi),xi)),d_mul(d_imul(10,Xr2),xi2)),d_mul(d_mul(d_imul(20,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(40,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(20,Xr),xr),xi2)),d_mul(d_imul(10,xr2),Xi2)),d_mul(d_mul(d_imul(20,xr2),Xi),xi)),d_mul(d_imul(10,xr2),xi2)),d_mul(d_mul(d_imul(20,Xi2),Xi),xi)),d_mul(d_imul(30,Xi2),xi2)),d_mul(d_mul(d_imul(20,Xi),xi2),xi)),d_mul(d_imul(5,xi2),xi2)))),cr);
xin=d_sub(ci,d_diffabs(d_add(d_sub(d_mul(d_mul(Xi2,Xi2),Xi),d_mul(d_mul(d_imul(10,Xi2),Xi),Xr2)),d_mul(d_mul(d_imul(5,Xi),Xr2),Xr2)),d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_add(d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_mul(d_mul(d_imul(5,Xi2),Xi2),xi),d_mul(d_mul(d_mul(d_imul(20,Xi2),Xi),xr),Xr)),d_mul(d_mul(d_imul(10,Xi2),Xi),xi2)),d_mul(d_mul(d_imul(10,Xi2),Xi),xr2)),d_mul(d_mul(d_imul(30,Xi2),xi),Xr2)),d_mul(d_mul(d_mul(d_imul(60,Xi2),xr),xi),Xr)),d_mul(d_mul(d_imul(10,Xi2),xi2),xi)),d_mul(d_mul(d_imul(30,Xi2),xr2),xi)),d_mul(d_mul(d_mul(d_imul(20,Xi),xr),Xr2),Xr)),d_mul(d_mul(d_imul(30,Xi),xi2),Xr2)),d_mul(d_mul(d_imul(30,Xi),xr2),Xr2)),d_mul(d_mul(d_mul(d_imul(60,Xi),xr),xi2),Xr)),d_mul(d_mul(d_mul(d_imul(20,Xi),xr2),xr),Xr)),d_mul(d_mul(d_imul(5,Xi),xi2),xi2)),d_mul(d_mul(d_imul(30,Xi),xr2),xi2)),d_mul(d_mul(d_imul(5,Xi),xr2),xr2)),d_mul(d_mul(d_imul(5,xi),Xr2),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi),xr),Xr2),Xr)),d_mul(d_mul(d_imul(10,xi2),xi),Xr2)),d_mul(d_mul(d_imul(30,xi),xr2),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi2),xi),xr),Xr)),d_mul(d_mul(d_mul(d_imul(20,xi),xr2),xr),Xr)),d_mul(d_mul(xi2,xi2),xi)),d_mul(d_mul(d_imul(10,xi2),xi),xr2)),d_mul(d_mul(d_imul(5,xi),xr2),xr2))));
}

);

static const char *perturbation_opencl_double_30_5_1 = STR(

{dxan=d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxa,d_sgn(Xxr))))))),d_add(d_imul(5,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr))))))))))),d_add(d_imul(20,d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dya))))),d_add(d_imul(-20,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(Xxi,dya))),d_add(d_imul(-30,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr))))))))),daa)))));
dxbn=d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxb,d_sgn(Xxr))))))),d_add(d_imul(5,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr))))))))))),d_add(d_imul(20,d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dyb))))),d_add(d_imul(-20,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(Xxi,dyb))),d_add(d_imul(-30,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr))))))))),dab)))));
dyan=d_add(dba,d_add(d_imul(-5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dya,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi)))),d_add(d_imul(-10,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,d_mul(Xxi,Xxi)))),d_imul(5,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr)))),Xxi))))))))))),d_add(d_imul(20,d_mul(d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi)))),d_add(d_imul(-10,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,d_mul(Xxi,Xxi)))),d_imul(5,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr)))),Xxi))))),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr))))))))),d_add(d_imul(-20,d_mul(d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi)))),d_add(d_imul(-10,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,d_mul(Xxi,Xxi)))),d_imul(5,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr)))),Xxi))))),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr))))))))))),d_add(d_imul(30,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi)))),d_add(d_imul(-10,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,d_mul(Xxi,Xxi)))),d_imul(5,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr)))),Xxi))))),d_mul(Xxi,d_mul(Xxi,dya))))),d_imul(-5,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr)))),d_mul(d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi)))),d_add(d_imul(-10,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,d_mul(Xxi,Xxi)))),d_imul(5,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr)))),Xxi))))),dya))))))));
dybn=d_add(dbb,d_add(d_imul(-5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dyb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi)))),d_add(d_imul(-10,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,d_mul(Xxi,Xxi)))),d_imul(5,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr)))),Xxi))))))))))),d_add(d_imul(20,d_mul(d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi)))),d_add(d_imul(-10,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,d_mul(Xxi,Xxi)))),d_imul(5,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr)))),Xxi))))),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr))))))))),d_add(d_imul(-20,d_mul(d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi)))),d_add(d_imul(-10,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,d_mul(Xxi,Xxi)))),d_imul(5,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr)))),Xxi))))),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr))))))))))),d_add(d_imul(30,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi)))),d_add(d_imul(-10,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,d_mul(Xxi,Xxi)))),d_imul(5,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr)))),Xxi))))),d_mul(Xxi,d_mul(Xxi,dyb))))),d_imul(-5,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr)))),d_mul(d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi)))),d_add(d_imul(-10,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,d_mul(Xxi,Xxi)))),d_imul(5,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr)))),Xxi))))),dyb))))))));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_add(d_mul(d_diffabs(Xr,xr),d_add(d_sub(d_mul(Xr2,Xr2),d_mul(d_imul(10,Xr2),Xi2)),d_mul(d_imul(5,Xi2),Xi2))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(20,Xr2),Xi),xi)),d_mul(d_imul(10,Xr2),xi2)),d_mul(d_mul(d_imul(20,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(40,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(20,Xr),xr),xi2)),d_mul(d_imul(10,xr2),Xi2)),d_mul(d_mul(d_imul(20,xr2),Xi),xi)),d_mul(d_imul(10,xr2),xi2)),d_mul(d_mul(d_imul(20,Xi2),Xi),xi)),d_mul(d_imul(30,Xi2),xi2)),d_mul(d_mul(d_imul(20,Xi),xi2),xi)),d_mul(d_imul(5,xi2),xi2)))),cr);
xin=d_sub(ci,d_diffabs(d_add(d_sub(d_mul(d_mul(Xi2,Xi2),Xi),d_mul(d_mul(d_imul(10,Xi2),Xi),Xr2)),d_mul(d_mul(d_imul(5,Xi),Xr2),Xr2)),d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_add(d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_mul(d_mul(d_imul(5,Xi2),Xi2),xi),d_mul(d_mul(d_mul(d_imul(20,Xi2),Xi),xr),Xr)),d_mul(d_mul(d_imul(10,Xi2),Xi),xi2)),d_mul(d_mul(d_imul(10,Xi2),Xi),xr2)),d_mul(d_mul(d_imul(30,Xi2),xi),Xr2)),d_mul(d_mul(d_mul(d_imul(60,Xi2),xr),xi),Xr)),d_mul(d_mul(d_imul(10,Xi2),xi2),xi)),d_mul(d_mul(d_imul(30,Xi2),xr2),xi)),d_mul(d_mul(d_mul(d_imul(20,Xi),xr),Xr2),Xr)),d_mul(d_mul(d_imul(30,Xi),xi2),Xr2)),d_mul(d_mul(d_imul(30,Xi),xr2),Xr2)),d_mul(d_mul(d_mul(d_imul(60,Xi),xr),xi2),Xr)),d_mul(d_mul(d_mul(d_imul(20,Xi),xr2),xr),Xr)),d_mul(d_mul(d_imul(5,Xi),xi2),xi2)),d_mul(d_mul(d_imul(30,Xi),xr2),xi2)),d_mul(d_mul(d_imul(5,Xi),xr2),xr2)),d_mul(d_mul(d_imul(5,xi),Xr2),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi),xr),Xr2),Xr)),d_mul(d_mul(d_imul(10,xi2),xi),Xr2)),d_mul(d_mul(d_imul(30,xi),xr2),Xr2)),d_mul(d_mul(d_mul(d_imul(20,xi2),xi),xr),Xr)),d_mul(d_mul(d_mul(d_imul(20,xi),xr2),xr),Xr)),d_mul(d_mul(xi2,xi2),xi)),d_mul(d_mul(d_imul(10,xi2),xi),xr2)),d_mul(d_mul(d_imul(5,xi),xr2),xr2))));
}

);

static const char *perturbation_opencl_floatexp_30_5_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_mul(fe_diffabs(Xr,xr),fe_add(fe_sub(fe_mul(Xr2,Xr2),fe_mul(fe_imul(10,Xr2),Xi2)),fe_mul(fe_imul(5,Xi2),Xi2))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(20,Xr2),Xi),xi)),fe_mul(fe_imul(10,Xr2),xi2)),fe_mul(fe_mul(fe_imul(20,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(40,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(20,Xr),xr),xi2)),fe_mul(fe_imul(10,xr2),Xi2)),fe_mul(fe_mul(fe_imul(20,xr2),Xi),xi)),fe_mul(fe_imul(10,xr2),xi2)),fe_mul(fe_mul(fe_imul(20,Xi2),Xi),xi)),fe_mul(fe_imul(30,Xi2),xi2)),fe_mul(fe_mul(fe_imul(20,Xi),xi2),xi)),fe_mul(fe_imul(5,xi2),xi2)))),cr);
xin=fe_sub(ci,fe_diffabs(fe_add(fe_sub(fe_mul(fe_mul(Xi2,Xi2),Xi),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),Xr2)),fe_mul(fe_mul(fe_imul(5,Xi),Xr2),Xr2)),fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_mul(fe_mul(fe_imul(5,Xi2),Xi2),xi),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi2),Xi),xr),Xr)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xi2)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xr2)),fe_mul(fe_mul(fe_imul(30,Xi2),xi),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi2),xr),xi),Xr)),fe_mul(fe_mul(fe_imul(10,Xi2),xi2),xi)),fe_mul(fe_mul(fe_imul(30,Xi2),xr2),xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),xr),Xr2),Xr)),fe_mul(fe_mul(fe_imul(30,Xi),xi2),Xr2)),fe_mul(fe_mul(fe_imul(30,Xi),xr2),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi),xr),xi2),Xr)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),xr2),xr),Xr)),fe_mul(fe_mul(fe_imul(5,Xi),xi2),xi2)),fe_mul(fe_mul(fe_imul(30,Xi),xr2),xi2)),fe_mul(fe_mul(fe_imul(5,Xi),xr2),xr2)),fe_mul(fe_mul(fe_imul(5,xi),Xr2),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),xr),Xr2),Xr)),fe_mul(fe_mul(fe_imul(10,xi2),xi),Xr2)),fe_mul(fe_mul(fe_imul(30,xi),xr2),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi2),xi),xr),Xr)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),xr2),xr),Xr)),fe_mul(fe_mul(xi2,xi2),xi)),fe_mul(fe_mul(fe_imul(10,xi2),xi),xr2)),fe_mul(fe_mul(fe_imul(5,xi),xr2),xr2))));
}

);

static const char *perturbation_opencl_floatexp_30_5_1 = STR(

{dxan=fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxa,fe_sgn(Xxr))))))),fe_add(fe_imul(5,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr))))))))))),fe_add(fe_imul(20,fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dya))))),fe_add(fe_imul(-20,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(Xxi,dya))),fe_add(fe_imul(-30,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr))))))))),daa)))));
dxbn=fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxb,fe_sgn(Xxr))))))),fe_add(fe_imul(5,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr))))))))))),fe_add(fe_imul(20,fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dyb))))),fe_add(fe_imul(-20,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(Xxi,dyb))),fe_add(fe_imul(-30,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr))))))))),dab)))));
dyan=fe_add(dba,fe_add(fe_imul(-5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dya,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_add(fe_imul(-10,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_imul(5,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr)))),Xxi))))))))))),fe_add(fe_imul(20,fe_mul(fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_add(fe_imul(-10,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_imul(5,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr)))),Xxi))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr))))))))),fe_add(fe_imul(-20,fe_mul(fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_add(fe_imul(-10,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_imul(5,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr)))),Xxi))))),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr))))))))))),fe_add(fe_imul(30,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_add(fe_imul(-10,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_imul(5,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr)))),Xxi))))),fe_mul(Xxi,fe_mul(Xxi,dya))))),fe_imul(-5,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr)))),fe_mul(fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_add(fe_imul(-10,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_imul(5,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr)))),Xxi))))),dya))))))));
dybn=fe_add(dbb,fe_add(fe_imul(-5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dyb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_add(fe_imul(-10,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_imul(5,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr)))),Xxi))))))))))),fe_add(fe_imul(20,fe_mul(fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_add(fe_imul(-10,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_imul(5,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr)))),Xxi))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr))))))))),fe_add(fe_imul(-20,fe_mul(fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_add(fe_imul(-10,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_imul(5,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr)))),Xxi))))),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr))))))))))),fe_add(fe_imul(30,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_add(fe_imul(-10,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_imul(5,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr)))),Xxi))))),fe_mul(Xxi,fe_mul(Xxi,dyb))))),fe_imul(-5,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr)))),fe_mul(fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_add(fe_imul(-10,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,fe_mul(Xxi,Xxi)))),fe_imul(5,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr)))),Xxi))))),dyb))))))));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_mul(fe_diffabs(Xr,xr),fe_add(fe_sub(fe_mul(Xr2,Xr2),fe_mul(fe_imul(10,Xr2),Xi2)),fe_mul(fe_imul(5,Xi2),Xi2))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(20,Xr2),Xi),xi)),fe_mul(fe_imul(10,Xr2),xi2)),fe_mul(fe_mul(fe_imul(20,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(40,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(20,Xr),xr),xi2)),fe_mul(fe_imul(10,xr2),Xi2)),fe_mul(fe_mul(fe_imul(20,xr2),Xi),xi)),fe_mul(fe_imul(10,xr2),xi2)),fe_mul(fe_mul(fe_imul(20,Xi2),Xi),xi)),fe_mul(fe_imul(30,Xi2),xi2)),fe_mul(fe_mul(fe_imul(20,Xi),xi2),xi)),fe_mul(fe_imul(5,xi2),xi2)))),cr);
xin=fe_sub(ci,fe_diffabs(fe_add(fe_sub(fe_mul(fe_mul(Xi2,Xi2),Xi),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),Xr2)),fe_mul(fe_mul(fe_imul(5,Xi),Xr2),Xr2)),fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_mul(fe_mul(fe_imul(5,Xi2),Xi2),xi),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi2),Xi),xr),Xr)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xi2)),fe_mul(fe_mul(fe_imul(10,Xi2),Xi),xr2)),fe_mul(fe_mul(fe_imul(30,Xi2),xi),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi2),xr),xi),Xr)),fe_mul(fe_mul(fe_imul(10,Xi2),xi2),xi)),fe_mul(fe_mul(fe_imul(30,Xi2),xr2),xi)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),xr),Xr2),Xr)),fe_mul(fe_mul(fe_imul(30,Xi),xi2),Xr2)),fe_mul(fe_mul(fe_imul(30,Xi),xr2),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(60,Xi),xr),xi2),Xr)),fe_mul(fe_mul(fe_mul(fe_imul(20,Xi),xr2),xr),Xr)),fe_mul(fe_mul(fe_imul(5,Xi),xi2),xi2)),fe_mul(fe_mul(fe_imul(30,Xi),xr2),xi2)),fe_mul(fe_mul(fe_imul(5,Xi),xr2),xr2)),fe_mul(fe_mul(fe_imul(5,xi),Xr2),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),xr),Xr2),Xr)),fe_mul(fe_mul(fe_imul(10,xi2),xi),Xr2)),fe_mul(fe_mul(fe_imul(30,xi),xr2),Xr2)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi2),xi),xr),Xr)),fe_mul(fe_mul(fe_mul(fe_imul(20,xi),xr2),xr),Xr)),fe_mul(fe_mul(xi2,xi2),xi)),fe_mul(fe_mul(fe_imul(10,xi2),xi),xr2)),fe_mul(fe_mul(fe_imul(5,xi),xr2),xr2))));
}

);

#if 0
static const char *perturbation_opencl_softfloat_30_5_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_add(sf_mul(sf_diffabs(Xr,xr),sf_add(sf_sub(sf_mul(Xr2,Xr2),sf_mul(sf_imul(10,Xr2),Xi2)),sf_mul(sf_imul(5,Xi2),Xi2))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_add(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(20,Xr2),Xi),xi)),sf_mul(sf_imul(10,Xr2),xi2)),sf_mul(sf_mul(sf_imul(20,Xr),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(40,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_imul(20,Xr),xr),xi2)),sf_mul(sf_imul(10,xr2),Xi2)),sf_mul(sf_mul(sf_imul(20,xr2),Xi),xi)),sf_mul(sf_imul(10,xr2),xi2)),sf_mul(sf_mul(sf_imul(20,Xi2),Xi),xi)),sf_mul(sf_imul(30,Xi2),xi2)),sf_mul(sf_mul(sf_imul(20,Xi),xi2),xi)),sf_mul(sf_imul(5,xi2),xi2)))),cr);
xin=sf_sub(ci,sf_diffabs(sf_add(sf_sub(sf_mul(sf_mul(Xi2,Xi2),Xi),sf_mul(sf_mul(sf_imul(10,Xi2),Xi),Xr2)),sf_mul(sf_mul(sf_imul(5,Xi),Xr2),Xr2)),sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_add(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_sub(sf_mul(sf_mul(sf_imul(5,Xi2),Xi2),xi),sf_mul(sf_mul(sf_mul(sf_imul(20,Xi2),Xi),xr),Xr)),sf_mul(sf_mul(sf_imul(10,Xi2),Xi),xi2)),sf_mul(sf_mul(sf_imul(10,Xi2),Xi),xr2)),sf_mul(sf_mul(sf_imul(30,Xi2),xi),Xr2)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xi2),xr),xi),Xr)),sf_mul(sf_mul(sf_imul(10,Xi2),xi2),xi)),sf_mul(sf_mul(sf_imul(30,Xi2),xr2),xi)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xi),xr),Xr2),Xr)),sf_mul(sf_mul(sf_imul(30,Xi),xi2),Xr2)),sf_mul(sf_mul(sf_imul(30,Xi),xr2),Xr2)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xi),xr),xi2),Xr)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xi),xr2),xr),Xr)),sf_mul(sf_mul(sf_imul(5,Xi),xi2),xi2)),sf_mul(sf_mul(sf_imul(30,Xi),xr2),xi2)),sf_mul(sf_mul(sf_imul(5,Xi),xr2),xr2)),sf_mul(sf_mul(sf_imul(5,xi),Xr2),Xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi),xr),Xr2),Xr)),sf_mul(sf_mul(sf_imul(10,xi2),xi),Xr2)),sf_mul(sf_mul(sf_imul(30,xi),xr2),Xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi2),xi),xr),Xr)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi),xr2),xr),Xr)),sf_mul(sf_mul(xi2,xi2),xi)),sf_mul(sf_mul(sf_imul(10,xi2),xi),xr2)),sf_mul(sf_mul(sf_imul(5,xi),xr2),xr2))));
}

);
#endif


static const char *perturbation_opencl_double_31_5_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_add(d_mul(d_diffabs(Xr,xr),d_add(d_sub(d_mul(Xr2,Xr2),d_mul(d_imul(10,Xr2),Xi2)),d_mul(d_imul(5,Xi2),Xi2))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(20,Xr2),Xi),xi)),d_mul(d_imul(10,Xr2),xi2)),d_mul(d_mul(d_imul(20,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(40,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(20,Xr),xr),xi2)),d_mul(d_imul(10,xr2),Xi2)),d_mul(d_mul(d_imul(20,xr2),Xi),xi)),d_mul(d_imul(10,xr2),xi2)),d_mul(d_mul(d_imul(20,Xi2),Xi),xi)),d_mul(d_imul(30,Xi2),xi2)),d_mul(d_mul(d_imul(20,Xi),xi2),xi)),d_mul(d_imul(5,xi2),xi2)))),cr);
xin=d_add(d_sub(d_mul(d_neg(Xi),d_diffabs(d_add(d_sub(d_mul(d_imul(5,Xr2),Xr2),d_mul(d_imul(10,Xr2),Xi2)),d_mul(Xi2,Xi2)),d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_mul(d_mul(d_imul(4,xi),Xi2),Xi),d_mul(d_mul(d_imul(20,xr),Xr),Xi2)),d_mul(d_imul(6,xi2),Xi2)),d_mul(d_imul(10,xr2),Xi2)),d_mul(d_mul(d_imul(20,xi),Xr2),Xi)),d_mul(d_mul(d_mul(d_imul(40,xr),xi),Xr),Xi)),d_mul(d_mul(d_imul(4,xi2),xi),Xi)),d_mul(d_mul(d_imul(20,xr2),xi),Xi)),d_mul(d_mul(d_imul(20,xr),Xr2),Xr)),d_mul(d_imul(10,xi2),Xr2)),d_mul(d_imul(30,xr2),Xr2)),d_mul(d_mul(d_imul(20,xr),xi2),Xr)),d_mul(d_mul(d_imul(20,xr2),xr),Xr)),d_mul(xi2,xi2)),d_mul(d_imul(10,xr2),xi2)),d_mul(d_imul(5,xr2),xr2)))),d_mul(xi,d_abs(d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_sub(d_add(d_mul(Xi2,Xi2),d_mul(d_mul(d_imul(4,xi),Xi2),Xi)),d_mul(d_imul(10,Xr2),Xi2)),d_mul(d_mul(d_imul(20,xr),Xr),Xi2)),d_mul(d_imul(6,xi2),Xi2)),d_mul(d_imul(10,xr2),Xi2)),d_mul(d_mul(d_imul(20,xi),Xr2),Xi)),d_mul(d_mul(d_mul(d_imul(40,xr),xi),Xr),Xi)),d_mul(d_mul(d_imul(4,xi2),xi),Xi)),d_mul(d_mul(d_imul(20,xr2),xi),Xi)),d_mul(d_imul(5,Xr2),Xr2)),d_mul(d_mul(d_imul(20,xr),Xr2),Xr)),d_mul(d_imul(10,xi2),Xr2)),d_mul(d_imul(30,xr2),Xr2)),d_mul(d_mul(d_imul(20,xr),xi2),Xr)),d_mul(d_mul(d_imul(20,xr2),xr),Xr)),d_mul(xi2,xi2)),d_mul(d_imul(10,xr2),xi2)),d_mul(d_imul(5,xr2),xr2))))),ci);
}

);

static const char *perturbation_opencl_double_31_5_1 = STR(

{dxan=d_add(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr)))))),d_add(d_imul(4,d_mul(d_abs(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dxa))))),d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxa,d_sgn(Xxr))))))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr))))))),d_add(d_imul(-20,d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,dxa))))),d_add(d_imul(-20,d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,dya))))),d_add(d_imul(20,d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dya))))),daa)))))));
dxbn=d_add(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr)))))),d_add(d_imul(4,d_mul(d_abs(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dxb))))),d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxb,d_sgn(Xxr))))))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr))))))),d_add(d_imul(-20,d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,dxb))))),d_add(d_imul(-20,d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,dyb))))),d_add(d_imul(20,d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dyb))))),dab)))))));
dyan=d_add(dba,d_add(d_imul(-4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dya,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_imul(5,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_add(d_imul(20,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_imul(5,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_add(d_imul(-20,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_imul(5,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_add(d_imul(20,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_imul(5,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_imul(-1,d_mul(d_abs(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_imul(5,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))),dya)))))));
dybn=d_add(dbb,d_add(d_imul(-4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dyb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_imul(5,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_add(d_imul(20,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_imul(5,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_add(d_imul(-20,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_imul(5,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_add(d_imul(20,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_imul(5,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_imul(-1,d_mul(d_abs(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_imul(5,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))),dyb)))))));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_add(d_mul(d_diffabs(Xr,xr),d_add(d_sub(d_mul(Xr2,Xr2),d_mul(d_imul(10,Xr2),Xi2)),d_mul(d_imul(5,Xi2),Xi2))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(20,Xr2),Xi),xi)),d_mul(d_imul(10,Xr2),xi2)),d_mul(d_mul(d_imul(20,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(40,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(20,Xr),xr),xi2)),d_mul(d_imul(10,xr2),Xi2)),d_mul(d_mul(d_imul(20,xr2),Xi),xi)),d_mul(d_imul(10,xr2),xi2)),d_mul(d_mul(d_imul(20,Xi2),Xi),xi)),d_mul(d_imul(30,Xi2),xi2)),d_mul(d_mul(d_imul(20,Xi),xi2),xi)),d_mul(d_imul(5,xi2),xi2)))),cr);
xin=d_add(d_sub(d_mul(d_neg(Xi),d_diffabs(d_add(d_sub(d_mul(d_imul(5,Xr2),Xr2),d_mul(d_imul(10,Xr2),Xi2)),d_mul(Xi2,Xi2)),d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_mul(d_mul(d_imul(4,xi),Xi2),Xi),d_mul(d_mul(d_imul(20,xr),Xr),Xi2)),d_mul(d_imul(6,xi2),Xi2)),d_mul(d_imul(10,xr2),Xi2)),d_mul(d_mul(d_imul(20,xi),Xr2),Xi)),d_mul(d_mul(d_mul(d_imul(40,xr),xi),Xr),Xi)),d_mul(d_mul(d_imul(4,xi2),xi),Xi)),d_mul(d_mul(d_imul(20,xr2),xi),Xi)),d_mul(d_mul(d_imul(20,xr),Xr2),Xr)),d_mul(d_imul(10,xi2),Xr2)),d_mul(d_imul(30,xr2),Xr2)),d_mul(d_mul(d_imul(20,xr),xi2),Xr)),d_mul(d_mul(d_imul(20,xr2),xr),Xr)),d_mul(xi2,xi2)),d_mul(d_imul(10,xr2),xi2)),d_mul(d_imul(5,xr2),xr2)))),d_mul(xi,d_abs(d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_sub(d_add(d_mul(Xi2,Xi2),d_mul(d_mul(d_imul(4,xi),Xi2),Xi)),d_mul(d_imul(10,Xr2),Xi2)),d_mul(d_mul(d_imul(20,xr),Xr),Xi2)),d_mul(d_imul(6,xi2),Xi2)),d_mul(d_imul(10,xr2),Xi2)),d_mul(d_mul(d_imul(20,xi),Xr2),Xi)),d_mul(d_mul(d_mul(d_imul(40,xr),xi),Xr),Xi)),d_mul(d_mul(d_imul(4,xi2),xi),Xi)),d_mul(d_mul(d_imul(20,xr2),xi),Xi)),d_mul(d_imul(5,Xr2),Xr2)),d_mul(d_mul(d_imul(20,xr),Xr2),Xr)),d_mul(d_imul(10,xi2),Xr2)),d_mul(d_imul(30,xr2),Xr2)),d_mul(d_mul(d_imul(20,xr),xi2),Xr)),d_mul(d_mul(d_imul(20,xr2),xr),Xr)),d_mul(xi2,xi2)),d_mul(d_imul(10,xr2),xi2)),d_mul(d_imul(5,xr2),xr2))))),ci);
}

);

static const char *perturbation_opencl_floatexp_31_5_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_mul(fe_diffabs(Xr,xr),fe_add(fe_sub(fe_mul(Xr2,Xr2),fe_mul(fe_imul(10,Xr2),Xi2)),fe_mul(fe_imul(5,Xi2),Xi2))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(20,Xr2),Xi),xi)),fe_mul(fe_imul(10,Xr2),xi2)),fe_mul(fe_mul(fe_imul(20,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(40,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(20,Xr),xr),xi2)),fe_mul(fe_imul(10,xr2),Xi2)),fe_mul(fe_mul(fe_imul(20,xr2),Xi),xi)),fe_mul(fe_imul(10,xr2),xi2)),fe_mul(fe_mul(fe_imul(20,Xi2),Xi),xi)),fe_mul(fe_imul(30,Xi2),xi2)),fe_mul(fe_mul(fe_imul(20,Xi),xi2),xi)),fe_mul(fe_imul(5,xi2),xi2)))),cr);
xin=fe_add(fe_sub(fe_mul(fe_neg(Xi),fe_diffabs(fe_add(fe_sub(fe_mul(fe_imul(5,Xr2),Xr2),fe_mul(fe_imul(10,Xr2),Xi2)),fe_mul(Xi2,Xi2)),fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_mul(fe_mul(fe_imul(4,xi),Xi2),Xi),fe_mul(fe_mul(fe_imul(20,xr),Xr),Xi2)),fe_mul(fe_imul(6,xi2),Xi2)),fe_mul(fe_imul(10,xr2),Xi2)),fe_mul(fe_mul(fe_imul(20,xi),Xr2),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(40,xr),xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(4,xi2),xi),Xi)),fe_mul(fe_mul(fe_imul(20,xr2),xi),Xi)),fe_mul(fe_mul(fe_imul(20,xr),Xr2),Xr)),fe_mul(fe_imul(10,xi2),Xr2)),fe_mul(fe_imul(30,xr2),Xr2)),fe_mul(fe_mul(fe_imul(20,xr),xi2),Xr)),fe_mul(fe_mul(fe_imul(20,xr2),xr),Xr)),fe_mul(xi2,xi2)),fe_mul(fe_imul(10,xr2),xi2)),fe_mul(fe_imul(5,xr2),xr2)))),fe_mul(xi,fe_abs(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_sub(fe_add(fe_mul(Xi2,Xi2),fe_mul(fe_mul(fe_imul(4,xi),Xi2),Xi)),fe_mul(fe_imul(10,Xr2),Xi2)),fe_mul(fe_mul(fe_imul(20,xr),Xr),Xi2)),fe_mul(fe_imul(6,xi2),Xi2)),fe_mul(fe_imul(10,xr2),Xi2)),fe_mul(fe_mul(fe_imul(20,xi),Xr2),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(40,xr),xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(4,xi2),xi),Xi)),fe_mul(fe_mul(fe_imul(20,xr2),xi),Xi)),fe_mul(fe_imul(5,Xr2),Xr2)),fe_mul(fe_mul(fe_imul(20,xr),Xr2),Xr)),fe_mul(fe_imul(10,xi2),Xr2)),fe_mul(fe_imul(30,xr2),Xr2)),fe_mul(fe_mul(fe_imul(20,xr),xi2),Xr)),fe_mul(fe_mul(fe_imul(20,xr2),xr),Xr)),fe_mul(xi2,xi2)),fe_mul(fe_imul(10,xr2),xi2)),fe_mul(fe_imul(5,xr2),xr2))))),ci);
}

);

static const char *perturbation_opencl_floatexp_31_5_1 = STR(

{dxan=fe_add(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr)))))),fe_add(fe_imul(4,fe_mul(fe_abs(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dxa))))),fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxa,fe_sgn(Xxr))))))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr))))))),fe_add(fe_imul(-20,fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,dxa))))),fe_add(fe_imul(-20,fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,dya))))),fe_add(fe_imul(20,fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dya))))),daa)))))));
dxbn=fe_add(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr)))))),fe_add(fe_imul(4,fe_mul(fe_abs(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dxb))))),fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxb,fe_sgn(Xxr))))))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr))))))),fe_add(fe_imul(-20,fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,dxb))))),fe_add(fe_imul(-20,fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,dyb))))),fe_add(fe_imul(20,fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dyb))))),dab)))))));
dyan=fe_add(dba,fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dya,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_imul(5,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_add(fe_imul(20,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_imul(5,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_add(fe_imul(-20,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_imul(5,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_add(fe_imul(20,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_imul(5,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_imul(-1,fe_mul(fe_abs(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_imul(5,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))),dya)))))));
dybn=fe_add(dbb,fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dyb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_imul(5,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_add(fe_imul(20,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_imul(5,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_add(fe_imul(-20,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_imul(5,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_add(fe_imul(20,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_imul(5,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_imul(-1,fe_mul(fe_abs(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_imul(5,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))),dyb)))))));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_mul(fe_diffabs(Xr,xr),fe_add(fe_sub(fe_mul(Xr2,Xr2),fe_mul(fe_imul(10,Xr2),Xi2)),fe_mul(fe_imul(5,Xi2),Xi2))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(20,Xr2),Xi),xi)),fe_mul(fe_imul(10,Xr2),xi2)),fe_mul(fe_mul(fe_imul(20,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(40,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(20,Xr),xr),xi2)),fe_mul(fe_imul(10,xr2),Xi2)),fe_mul(fe_mul(fe_imul(20,xr2),Xi),xi)),fe_mul(fe_imul(10,xr2),xi2)),fe_mul(fe_mul(fe_imul(20,Xi2),Xi),xi)),fe_mul(fe_imul(30,Xi2),xi2)),fe_mul(fe_mul(fe_imul(20,Xi),xi2),xi)),fe_mul(fe_imul(5,xi2),xi2)))),cr);
xin=fe_add(fe_sub(fe_mul(fe_neg(Xi),fe_diffabs(fe_add(fe_sub(fe_mul(fe_imul(5,Xr2),Xr2),fe_mul(fe_imul(10,Xr2),Xi2)),fe_mul(Xi2,Xi2)),fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_mul(fe_mul(fe_imul(4,xi),Xi2),Xi),fe_mul(fe_mul(fe_imul(20,xr),Xr),Xi2)),fe_mul(fe_imul(6,xi2),Xi2)),fe_mul(fe_imul(10,xr2),Xi2)),fe_mul(fe_mul(fe_imul(20,xi),Xr2),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(40,xr),xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(4,xi2),xi),Xi)),fe_mul(fe_mul(fe_imul(20,xr2),xi),Xi)),fe_mul(fe_mul(fe_imul(20,xr),Xr2),Xr)),fe_mul(fe_imul(10,xi2),Xr2)),fe_mul(fe_imul(30,xr2),Xr2)),fe_mul(fe_mul(fe_imul(20,xr),xi2),Xr)),fe_mul(fe_mul(fe_imul(20,xr2),xr),Xr)),fe_mul(xi2,xi2)),fe_mul(fe_imul(10,xr2),xi2)),fe_mul(fe_imul(5,xr2),xr2)))),fe_mul(xi,fe_abs(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_sub(fe_add(fe_mul(Xi2,Xi2),fe_mul(fe_mul(fe_imul(4,xi),Xi2),Xi)),fe_mul(fe_imul(10,Xr2),Xi2)),fe_mul(fe_mul(fe_imul(20,xr),Xr),Xi2)),fe_mul(fe_imul(6,xi2),Xi2)),fe_mul(fe_imul(10,xr2),Xi2)),fe_mul(fe_mul(fe_imul(20,xi),Xr2),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(40,xr),xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(4,xi2),xi),Xi)),fe_mul(fe_mul(fe_imul(20,xr2),xi),Xi)),fe_mul(fe_imul(5,Xr2),Xr2)),fe_mul(fe_mul(fe_imul(20,xr),Xr2),Xr)),fe_mul(fe_imul(10,xi2),Xr2)),fe_mul(fe_imul(30,xr2),Xr2)),fe_mul(fe_mul(fe_imul(20,xr),xi2),Xr)),fe_mul(fe_mul(fe_imul(20,xr2),xr),Xr)),fe_mul(xi2,xi2)),fe_mul(fe_imul(10,xr2),xi2)),fe_mul(fe_imul(5,xr2),xr2))))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_31_5_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_add(sf_mul(sf_diffabs(Xr,xr),sf_add(sf_sub(sf_mul(Xr2,Xr2),sf_mul(sf_imul(10,Xr2),Xi2)),sf_mul(sf_imul(5,Xi2),Xi2))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_add(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(20,Xr2),Xi),xi)),sf_mul(sf_imul(10,Xr2),xi2)),sf_mul(sf_mul(sf_imul(20,Xr),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(40,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_imul(20,Xr),xr),xi2)),sf_mul(sf_imul(10,xr2),Xi2)),sf_mul(sf_mul(sf_imul(20,xr2),Xi),xi)),sf_mul(sf_imul(10,xr2),xi2)),sf_mul(sf_mul(sf_imul(20,Xi2),Xi),xi)),sf_mul(sf_imul(30,Xi2),xi2)),sf_mul(sf_mul(sf_imul(20,Xi),xi2),xi)),sf_mul(sf_imul(5,xi2),xi2)))),cr);
xin=sf_add(sf_sub(sf_mul(sf_neg(Xi),sf_diffabs(sf_add(sf_sub(sf_mul(sf_imul(5,Xr2),Xr2),sf_mul(sf_imul(10,Xr2),Xi2)),sf_mul(Xi2,Xi2)),sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_sub(sf_mul(sf_mul(sf_imul(4,xi),Xi2),Xi),sf_mul(sf_mul(sf_imul(20,xr),Xr),Xi2)),sf_mul(sf_imul(6,xi2),Xi2)),sf_mul(sf_imul(10,xr2),Xi2)),sf_mul(sf_mul(sf_imul(20,xi),Xr2),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(40,xr),xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(4,xi2),xi),Xi)),sf_mul(sf_mul(sf_imul(20,xr2),xi),Xi)),sf_mul(sf_mul(sf_imul(20,xr),Xr2),Xr)),sf_mul(sf_imul(10,xi2),Xr2)),sf_mul(sf_imul(30,xr2),Xr2)),sf_mul(sf_mul(sf_imul(20,xr),xi2),Xr)),sf_mul(sf_mul(sf_imul(20,xr2),xr),Xr)),sf_mul(xi2,xi2)),sf_mul(sf_imul(10,xr2),xi2)),sf_mul(sf_imul(5,xr2),xr2)))),sf_mul(xi,sf_abs(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_sub(sf_sub(sf_add(sf_mul(Xi2,Xi2),sf_mul(sf_mul(sf_imul(4,xi),Xi2),Xi)),sf_mul(sf_imul(10,Xr2),Xi2)),sf_mul(sf_mul(sf_imul(20,xr),Xr),Xi2)),sf_mul(sf_imul(6,xi2),Xi2)),sf_mul(sf_imul(10,xr2),Xi2)),sf_mul(sf_mul(sf_imul(20,xi),Xr2),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(40,xr),xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(4,xi2),xi),Xi)),sf_mul(sf_mul(sf_imul(20,xr2),xi),Xi)),sf_mul(sf_imul(5,Xr2),Xr2)),sf_mul(sf_mul(sf_imul(20,xr),Xr2),Xr)),sf_mul(sf_imul(10,xi2),Xr2)),sf_mul(sf_imul(30,xr2),Xr2)),sf_mul(sf_mul(sf_imul(20,xr),xi2),Xr)),sf_mul(sf_mul(sf_imul(20,xr2),xr),Xr)),sf_mul(xi2,xi2)),sf_mul(sf_imul(10,xr2),xi2)),sf_mul(sf_imul(5,xr2),xr2))))),ci);
}

);
#endif


static const char *perturbation_opencl_double_32_5_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_add(d_mul(d_diffabs(Xr,xr),d_add(d_sub(d_mul(Xr2,Xr2),d_mul(d_imul(10,Xr2),Xi2)),d_mul(d_imul(5,Xi2),Xi2))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(20,Xr2),Xi),xi)),d_mul(d_imul(10,Xr2),xi2)),d_mul(d_mul(d_imul(20,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(40,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(20,Xr),xr),xi2)),d_mul(d_imul(10,xr2),Xi2)),d_mul(d_mul(d_imul(20,xr2),Xi),xi)),d_mul(d_imul(10,xr2),xi2)),d_mul(d_mul(d_imul(20,Xi2),Xi),xi)),d_mul(d_imul(30,Xi2),xi2)),d_mul(d_mul(d_imul(20,Xi),xi2),xi)),d_mul(d_imul(5,xi2),xi2)))),cr);
xin=d_add(d_add(d_mul(Xi,d_diffabs(d_add(d_sub(d_mul(d_imul(5,Xr2),Xr2),d_mul(d_imul(10,Xr2),Xi2)),d_mul(Xi2,Xi2)),d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_mul(d_mul(d_imul(4,xi),Xi2),Xi),d_mul(d_mul(d_imul(20,xr),Xr),Xi2)),d_mul(d_imul(6,xi2),Xi2)),d_mul(d_imul(10,xr2),Xi2)),d_mul(d_mul(d_imul(20,xi),Xr2),Xi)),d_mul(d_mul(d_mul(d_imul(40,xr),xi),Xr),Xi)),d_mul(d_mul(d_imul(4,xi2),xi),Xi)),d_mul(d_mul(d_imul(20,xr2),xi),Xi)),d_mul(d_mul(d_imul(20,xr),Xr2),Xr)),d_mul(d_imul(10,xi2),Xr2)),d_mul(d_imul(30,xr2),Xr2)),d_mul(d_mul(d_imul(20,xr),xi2),Xr)),d_mul(d_mul(d_imul(20,xr2),xr),Xr)),d_mul(xi2,xi2)),d_mul(d_imul(10,xr2),xi2)),d_mul(d_imul(5,xr2),xr2)))),d_mul(xi,d_abs(d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_sub(d_add(d_mul(Xi2,Xi2),d_mul(d_mul(d_imul(4,xi),Xi2),Xi)),d_mul(d_imul(10,Xr2),Xi2)),d_mul(d_mul(d_imul(20,xr),Xr),Xi2)),d_mul(d_imul(6,xi2),Xi2)),d_mul(d_imul(10,xr2),Xi2)),d_mul(d_mul(d_imul(20,xi),Xr2),Xi)),d_mul(d_mul(d_mul(d_imul(40,xr),xi),Xr),Xi)),d_mul(d_mul(d_imul(4,xi2),xi),Xi)),d_mul(d_mul(d_imul(20,xr2),xi),Xi)),d_mul(d_imul(5,Xr2),Xr2)),d_mul(d_mul(d_imul(20,xr),Xr2),Xr)),d_mul(d_imul(10,xi2),Xr2)),d_mul(d_imul(30,xr2),Xr2)),d_mul(d_mul(d_imul(20,xr),xi2),Xr)),d_mul(d_mul(d_imul(20,xr2),xr),Xr)),d_mul(xi2,xi2)),d_mul(d_imul(10,xr2),xi2)),d_mul(d_imul(5,xr2),xr2))))),ci);
}

);

static const char *perturbation_opencl_double_32_5_1 = STR(

{dxan=d_add(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr)))))),d_add(d_imul(4,d_mul(d_abs(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dxa))))),d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxa,d_sgn(Xxr))))))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr))))))),d_add(d_imul(-20,d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,dxa))))),d_add(d_imul(-20,d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,dya))))),d_add(d_imul(20,d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dya))))),daa)))))));
dxbn=d_add(d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr)))))),d_add(d_imul(4,d_mul(d_abs(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dxb))))),d_add(d_imul(5,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxb,d_sgn(Xxr))))))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr))))))),d_add(d_imul(-20,d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,dxb))))),d_add(d_imul(-20,d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,dyb))))),d_add(d_imul(20,d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dyb))))),dab)))))));
dyan=d_add(dba,d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dya,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_imul(5,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_add(d_imul(-20,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_imul(5,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_add(d_imul(20,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_imul(5,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_add(d_imul(-20,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_imul(5,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_mul(d_abs(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_imul(5,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))),dya))))));
dybn=d_add(dbb,d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dyb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_imul(5,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_add(d_imul(-20,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_imul(5,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_add(d_imul(20,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_imul(5,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_add(d_imul(-20,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_imul(5,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))))),d_mul(d_abs(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-10,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_imul(5,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))),dyb))))));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_add(d_mul(d_diffabs(Xr,xr),d_add(d_sub(d_mul(Xr2,Xr2),d_mul(d_imul(10,Xr2),Xi2)),d_mul(d_imul(5,Xi2),Xi2))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_add(d_add(d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(20,Xr2),Xi),xi)),d_mul(d_imul(10,Xr2),xi2)),d_mul(d_mul(d_imul(20,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(40,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(20,Xr),xr),xi2)),d_mul(d_imul(10,xr2),Xi2)),d_mul(d_mul(d_imul(20,xr2),Xi),xi)),d_mul(d_imul(10,xr2),xi2)),d_mul(d_mul(d_imul(20,Xi2),Xi),xi)),d_mul(d_imul(30,Xi2),xi2)),d_mul(d_mul(d_imul(20,Xi),xi2),xi)),d_mul(d_imul(5,xi2),xi2)))),cr);
xin=d_add(d_add(d_mul(Xi,d_diffabs(d_add(d_sub(d_mul(d_imul(5,Xr2),Xr2),d_mul(d_imul(10,Xr2),Xi2)),d_mul(Xi2,Xi2)),d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_mul(d_mul(d_imul(4,xi),Xi2),Xi),d_mul(d_mul(d_imul(20,xr),Xr),Xi2)),d_mul(d_imul(6,xi2),Xi2)),d_mul(d_imul(10,xr2),Xi2)),d_mul(d_mul(d_imul(20,xi),Xr2),Xi)),d_mul(d_mul(d_mul(d_imul(40,xr),xi),Xr),Xi)),d_mul(d_mul(d_imul(4,xi2),xi),Xi)),d_mul(d_mul(d_imul(20,xr2),xi),Xi)),d_mul(d_mul(d_imul(20,xr),Xr2),Xr)),d_mul(d_imul(10,xi2),Xr2)),d_mul(d_imul(30,xr2),Xr2)),d_mul(d_mul(d_imul(20,xr),xi2),Xr)),d_mul(d_mul(d_imul(20,xr2),xr),Xr)),d_mul(xi2,xi2)),d_mul(d_imul(10,xr2),xi2)),d_mul(d_imul(5,xr2),xr2)))),d_mul(xi,d_abs(d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_sub(d_add(d_mul(Xi2,Xi2),d_mul(d_mul(d_imul(4,xi),Xi2),Xi)),d_mul(d_imul(10,Xr2),Xi2)),d_mul(d_mul(d_imul(20,xr),Xr),Xi2)),d_mul(d_imul(6,xi2),Xi2)),d_mul(d_imul(10,xr2),Xi2)),d_mul(d_mul(d_imul(20,xi),Xr2),Xi)),d_mul(d_mul(d_mul(d_imul(40,xr),xi),Xr),Xi)),d_mul(d_mul(d_imul(4,xi2),xi),Xi)),d_mul(d_mul(d_imul(20,xr2),xi),Xi)),d_mul(d_imul(5,Xr2),Xr2)),d_mul(d_mul(d_imul(20,xr),Xr2),Xr)),d_mul(d_imul(10,xi2),Xr2)),d_mul(d_imul(30,xr2),Xr2)),d_mul(d_mul(d_imul(20,xr),xi2),Xr)),d_mul(d_mul(d_imul(20,xr2),xr),Xr)),d_mul(xi2,xi2)),d_mul(d_imul(10,xr2),xi2)),d_mul(d_imul(5,xr2),xr2))))),ci);
}

);

static const char *perturbation_opencl_floatexp_32_5_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_mul(fe_diffabs(Xr,xr),fe_add(fe_sub(fe_mul(Xr2,Xr2),fe_mul(fe_imul(10,Xr2),Xi2)),fe_mul(fe_imul(5,Xi2),Xi2))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(20,Xr2),Xi),xi)),fe_mul(fe_imul(10,Xr2),xi2)),fe_mul(fe_mul(fe_imul(20,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(40,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(20,Xr),xr),xi2)),fe_mul(fe_imul(10,xr2),Xi2)),fe_mul(fe_mul(fe_imul(20,xr2),Xi),xi)),fe_mul(fe_imul(10,xr2),xi2)),fe_mul(fe_mul(fe_imul(20,Xi2),Xi),xi)),fe_mul(fe_imul(30,Xi2),xi2)),fe_mul(fe_mul(fe_imul(20,Xi),xi2),xi)),fe_mul(fe_imul(5,xi2),xi2)))),cr);
xin=fe_add(fe_add(fe_mul(Xi,fe_diffabs(fe_add(fe_sub(fe_mul(fe_imul(5,Xr2),Xr2),fe_mul(fe_imul(10,Xr2),Xi2)),fe_mul(Xi2,Xi2)),fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_mul(fe_mul(fe_imul(4,xi),Xi2),Xi),fe_mul(fe_mul(fe_imul(20,xr),Xr),Xi2)),fe_mul(fe_imul(6,xi2),Xi2)),fe_mul(fe_imul(10,xr2),Xi2)),fe_mul(fe_mul(fe_imul(20,xi),Xr2),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(40,xr),xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(4,xi2),xi),Xi)),fe_mul(fe_mul(fe_imul(20,xr2),xi),Xi)),fe_mul(fe_mul(fe_imul(20,xr),Xr2),Xr)),fe_mul(fe_imul(10,xi2),Xr2)),fe_mul(fe_imul(30,xr2),Xr2)),fe_mul(fe_mul(fe_imul(20,xr),xi2),Xr)),fe_mul(fe_mul(fe_imul(20,xr2),xr),Xr)),fe_mul(xi2,xi2)),fe_mul(fe_imul(10,xr2),xi2)),fe_mul(fe_imul(5,xr2),xr2)))),fe_mul(xi,fe_abs(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_sub(fe_add(fe_mul(Xi2,Xi2),fe_mul(fe_mul(fe_imul(4,xi),Xi2),Xi)),fe_mul(fe_imul(10,Xr2),Xi2)),fe_mul(fe_mul(fe_imul(20,xr),Xr),Xi2)),fe_mul(fe_imul(6,xi2),Xi2)),fe_mul(fe_imul(10,xr2),Xi2)),fe_mul(fe_mul(fe_imul(20,xi),Xr2),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(40,xr),xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(4,xi2),xi),Xi)),fe_mul(fe_mul(fe_imul(20,xr2),xi),Xi)),fe_mul(fe_imul(5,Xr2),Xr2)),fe_mul(fe_mul(fe_imul(20,xr),Xr2),Xr)),fe_mul(fe_imul(10,xi2),Xr2)),fe_mul(fe_imul(30,xr2),Xr2)),fe_mul(fe_mul(fe_imul(20,xr),xi2),Xr)),fe_mul(fe_mul(fe_imul(20,xr2),xr),Xr)),fe_mul(xi2,xi2)),fe_mul(fe_imul(10,xr2),xi2)),fe_mul(fe_imul(5,xr2),xr2))))),ci);
}

);

static const char *perturbation_opencl_floatexp_32_5_1 = STR(

{dxan=fe_add(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr)))))),fe_add(fe_imul(4,fe_mul(fe_abs(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dxa))))),fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxa,fe_sgn(Xxr))))))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr))))))),fe_add(fe_imul(-20,fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,dxa))))),fe_add(fe_imul(-20,fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,dya))))),fe_add(fe_imul(20,fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dya))))),daa)))))));
dxbn=fe_add(fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr)))))),fe_add(fe_imul(4,fe_mul(fe_abs(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dxb))))),fe_add(fe_imul(5,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxb,fe_sgn(Xxr))))))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr))))))),fe_add(fe_imul(-20,fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,dxb))))),fe_add(fe_imul(-20,fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,dyb))))),fe_add(fe_imul(20,fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dyb))))),dab)))))));
dyan=fe_add(dba,fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dya,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_imul(5,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_add(fe_imul(-20,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_imul(5,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_add(fe_imul(20,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_imul(5,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_add(fe_imul(-20,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_imul(5,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_mul(fe_abs(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_imul(5,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))),dya))))));
dybn=fe_add(dbb,fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dyb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_imul(5,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_add(fe_imul(-20,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_imul(5,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_add(fe_imul(20,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_imul(5,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_add(fe_imul(-20,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_imul(5,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))))),fe_mul(fe_abs(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-10,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_imul(5,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))),dyb))))));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_mul(fe_diffabs(Xr,xr),fe_add(fe_sub(fe_mul(Xr2,Xr2),fe_mul(fe_imul(10,Xr2),Xi2)),fe_mul(fe_imul(5,Xi2),Xi2))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_add(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(20,Xr2),Xi),xi)),fe_mul(fe_imul(10,Xr2),xi2)),fe_mul(fe_mul(fe_imul(20,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(40,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(20,Xr),xr),xi2)),fe_mul(fe_imul(10,xr2),Xi2)),fe_mul(fe_mul(fe_imul(20,xr2),Xi),xi)),fe_mul(fe_imul(10,xr2),xi2)),fe_mul(fe_mul(fe_imul(20,Xi2),Xi),xi)),fe_mul(fe_imul(30,Xi2),xi2)),fe_mul(fe_mul(fe_imul(20,Xi),xi2),xi)),fe_mul(fe_imul(5,xi2),xi2)))),cr);
xin=fe_add(fe_add(fe_mul(Xi,fe_diffabs(fe_add(fe_sub(fe_mul(fe_imul(5,Xr2),Xr2),fe_mul(fe_imul(10,Xr2),Xi2)),fe_mul(Xi2,Xi2)),fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_mul(fe_mul(fe_imul(4,xi),Xi2),Xi),fe_mul(fe_mul(fe_imul(20,xr),Xr),Xi2)),fe_mul(fe_imul(6,xi2),Xi2)),fe_mul(fe_imul(10,xr2),Xi2)),fe_mul(fe_mul(fe_imul(20,xi),Xr2),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(40,xr),xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(4,xi2),xi),Xi)),fe_mul(fe_mul(fe_imul(20,xr2),xi),Xi)),fe_mul(fe_mul(fe_imul(20,xr),Xr2),Xr)),fe_mul(fe_imul(10,xi2),Xr2)),fe_mul(fe_imul(30,xr2),Xr2)),fe_mul(fe_mul(fe_imul(20,xr),xi2),Xr)),fe_mul(fe_mul(fe_imul(20,xr2),xr),Xr)),fe_mul(xi2,xi2)),fe_mul(fe_imul(10,xr2),xi2)),fe_mul(fe_imul(5,xr2),xr2)))),fe_mul(xi,fe_abs(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_sub(fe_add(fe_mul(Xi2,Xi2),fe_mul(fe_mul(fe_imul(4,xi),Xi2),Xi)),fe_mul(fe_imul(10,Xr2),Xi2)),fe_mul(fe_mul(fe_imul(20,xr),Xr),Xi2)),fe_mul(fe_imul(6,xi2),Xi2)),fe_mul(fe_imul(10,xr2),Xi2)),fe_mul(fe_mul(fe_imul(20,xi),Xr2),Xi)),fe_mul(fe_mul(fe_mul(fe_imul(40,xr),xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(4,xi2),xi),Xi)),fe_mul(fe_mul(fe_imul(20,xr2),xi),Xi)),fe_mul(fe_imul(5,Xr2),Xr2)),fe_mul(fe_mul(fe_imul(20,xr),Xr2),Xr)),fe_mul(fe_imul(10,xi2),Xr2)),fe_mul(fe_imul(30,xr2),Xr2)),fe_mul(fe_mul(fe_imul(20,xr),xi2),Xr)),fe_mul(fe_mul(fe_imul(20,xr2),xr),Xr)),fe_mul(xi2,xi2)),fe_mul(fe_imul(10,xr2),xi2)),fe_mul(fe_imul(5,xr2),xr2))))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_32_5_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_add(sf_mul(sf_diffabs(Xr,xr),sf_add(sf_sub(sf_mul(Xr2,Xr2),sf_mul(sf_imul(10,Xr2),Xi2)),sf_mul(sf_imul(5,Xi2),Xi2))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_add(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(20,Xr2),Xi),xi)),sf_mul(sf_imul(10,Xr2),xi2)),sf_mul(sf_mul(sf_imul(20,Xr),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(40,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_imul(20,Xr),xr),xi2)),sf_mul(sf_imul(10,xr2),Xi2)),sf_mul(sf_mul(sf_imul(20,xr2),Xi),xi)),sf_mul(sf_imul(10,xr2),xi2)),sf_mul(sf_mul(sf_imul(20,Xi2),Xi),xi)),sf_mul(sf_imul(30,Xi2),xi2)),sf_mul(sf_mul(sf_imul(20,Xi),xi2),xi)),sf_mul(sf_imul(5,xi2),xi2)))),cr);
xin=sf_add(sf_add(sf_mul(Xi,sf_diffabs(sf_add(sf_sub(sf_mul(sf_imul(5,Xr2),Xr2),sf_mul(sf_imul(10,Xr2),Xi2)),sf_mul(Xi2,Xi2)),sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_sub(sf_mul(sf_mul(sf_imul(4,xi),Xi2),Xi),sf_mul(sf_mul(sf_imul(20,xr),Xr),Xi2)),sf_mul(sf_imul(6,xi2),Xi2)),sf_mul(sf_imul(10,xr2),Xi2)),sf_mul(sf_mul(sf_imul(20,xi),Xr2),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(40,xr),xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(4,xi2),xi),Xi)),sf_mul(sf_mul(sf_imul(20,xr2),xi),Xi)),sf_mul(sf_mul(sf_imul(20,xr),Xr2),Xr)),sf_mul(sf_imul(10,xi2),Xr2)),sf_mul(sf_imul(30,xr2),Xr2)),sf_mul(sf_mul(sf_imul(20,xr),xi2),Xr)),sf_mul(sf_mul(sf_imul(20,xr2),xr),Xr)),sf_mul(xi2,xi2)),sf_mul(sf_imul(10,xr2),xi2)),sf_mul(sf_imul(5,xr2),xr2)))),sf_mul(xi,sf_abs(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_sub(sf_sub(sf_add(sf_mul(Xi2,Xi2),sf_mul(sf_mul(sf_imul(4,xi),Xi2),Xi)),sf_mul(sf_imul(10,Xr2),Xi2)),sf_mul(sf_mul(sf_imul(20,xr),Xr),Xi2)),sf_mul(sf_imul(6,xi2),Xi2)),sf_mul(sf_imul(10,xr2),Xi2)),sf_mul(sf_mul(sf_imul(20,xi),Xr2),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(40,xr),xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(4,xi2),xi),Xi)),sf_mul(sf_mul(sf_imul(20,xr2),xi),Xi)),sf_mul(sf_imul(5,Xr2),Xr2)),sf_mul(sf_mul(sf_imul(20,xr),Xr2),Xr)),sf_mul(sf_imul(10,xi2),Xr2)),sf_mul(sf_imul(30,xr2),Xr2)),sf_mul(sf_mul(sf_imul(20,xr),xi2),Xr)),sf_mul(sf_mul(sf_imul(20,xr2),xr),Xr)),sf_mul(xi2,xi2)),sf_mul(sf_imul(10,xr2),xi2)),sf_mul(sf_imul(5,xr2),xr2))))),ci);
}

);
#endif


static const char *perturbation_opencl_double_33_4_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_add(d_sub(d_sub(d_sub(d_add(d_add(d_sub(d_sub(d_sub(d_mul(Xi2,d_diffabs(Xi2,d_add(d_mul(d_imul(2,xi),Xi),xi2))),d_mul(d_mul(d_imul(4,Xi),Xr),d_diffabs(d_mul(Xr,Xi),d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi))))),d_mul(Xr2,d_diffabs(Xi2,d_add(d_mul(d_imul(2,xi),Xi),xi2)))),d_mul(Xi2,d_diffabs(Xr2,d_add(d_mul(d_imul(2,Xr),xr),xr2)))),d_mul(Xr2,d_diffabs(Xr2,d_add(d_mul(d_imul(2,Xr),xr),xr2)))),d_mul(d_add(d_mul(d_imul(2,xi),Xi),xi2),d_abs(d_add(d_add(Xi2,d_mul(d_imul(2,xi),Xi)),xi2)))),d_mul(d_imul(4,d_add(d_add(d_mul(Xi,xr),d_mul(xi,Xr)),d_mul(xi,xr))),d_abs(d_add(d_add(d_add(d_mul(Xr,Xi),d_mul(Xr,xi)),d_mul(xr,Xi)),d_mul(xr,xi))))),d_mul(d_add(d_mul(d_imul(2,Xr),xr),xr2),d_abs(d_add(d_add(Xi2,d_mul(d_imul(2,xi),Xi)),xi2)))),d_mul(d_add(d_mul(d_imul(2,xi),Xi),xi2),d_abs(d_add(d_add(Xr2,d_mul(d_imul(2,Xr),xr)),xr2)))),d_mul(d_add(d_mul(d_imul(2,Xr),xr),xr2),d_abs(d_add(d_add(Xr2,d_mul(d_imul(2,Xr),xr)),xr2)))),cr);
xin=d_add(d_sub(d_sub(d_add(d_add(d_sub(d_sub(d_add(d_mul(d_imul(2,Xr2),d_diffabs(d_mul(Xr,Xi),d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi)))),d_mul(d_mul(d_imul(2,Xr),Xi),d_diffabs(Xr2,d_add(d_mul(d_imul(2,Xr),xr),xr2)))),d_mul(d_mul(d_imul(2,Xr),Xi),d_diffabs(Xi2,d_add(d_mul(d_imul(2,xi),Xi),xi2)))),d_mul(d_imul(2,Xi2),d_diffabs(d_mul(Xr,Xi),d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi))))),d_mul(d_imul(2,d_add(d_mul(d_imul(2,Xr),xr),xr2)),d_abs(d_add(d_add(d_add(d_mul(Xr,Xi),d_mul(Xr,xi)),d_mul(xr,Xi)),d_mul(xr,xi))))),d_mul(d_imul(2,d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi))),d_abs(d_add(d_add(Xr2,d_mul(d_imul(2,Xr),xr)),xr2)))),d_mul(d_imul(2,d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi))),d_abs(d_add(d_add(Xi2,d_mul(d_imul(2,xi),Xi)),xi2)))),d_mul(d_imul(2,d_add(d_mul(d_imul(2,xi),Xi),xi2)),d_abs(d_add(d_add(d_add(d_mul(Xr,Xi),d_mul(Xr,xi)),d_mul(xr,Xi)),d_mul(xr,xi))))),ci);
}

);

static const char *perturbation_opencl_double_33_4_1 = STR(

{dxan=d_add(d_imul(2,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxr,dxa))),d_add(d_imul(-2,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxr,dxa))),d_add(d_imul(2,d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr))))))),d_add(d_imul(-2,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,dya))),d_add(d_imul(2,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxi,dya))),d_add(d_imul(-2,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(Xxi))))))),d_add(d_imul(-2,d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr))))))),d_add(d_imul(2,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dya,d_sgn(Xxi))))))),d_add(d_imul(-4,d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(Xxi,dxa))),d_add(d_imul(-4,d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(Xxr,dya))),d_add(d_imul(-4,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr))))))),d_add(d_imul(-4,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(Xxr))))))),daa))))))))))));
dxbn=d_add(d_imul(2,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxr,dxb))),d_add(d_imul(-2,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxr,dxb))),d_add(d_imul(2,d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr))))))),d_add(d_imul(-2,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,dyb))),d_add(d_imul(2,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxi,dyb))),d_add(d_imul(-2,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(Xxi))))))),d_add(d_imul(-2,d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr))))))),d_add(d_imul(2,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dyb,d_sgn(Xxi))))))),d_add(d_imul(-4,d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(Xxi,dxb))),d_add(d_imul(-4,d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(Xxr,dyb))),d_add(d_imul(-4,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr))))))),d_add(d_imul(-4,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(Xxr))))))),dab))))))))))));
dyan=d_add(d_imul(2,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxr,dya))),d_add(d_imul(-2,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxr,dya))),d_add(d_imul(2,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,dxa))),d_add(d_imul(2,d_mul(d_sgn(Xxi),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(Xxr))))))),d_add(d_imul(-2,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxi,dxa))),d_add(d_imul(-2,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxa,d_sgn(Xxr))))))),d_add(d_imul(-2,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_sgn(Xxr))))))),d_add(d_imul(2,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr))))))),d_add(d_imul(4,d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(Xxr,dxa))),d_add(d_imul(-4,d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(Xxi,dya))),d_add(d_imul(4,d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr))))))),d_add(d_imul(-4,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_sgn(Xxi))))))),dba))))))))))));
dybn=d_add(d_imul(2,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxr,dyb))),d_add(d_imul(-2,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxr,dyb))),d_add(d_imul(2,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,dxb))),d_add(d_imul(2,d_mul(d_sgn(Xxi),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(Xxr))))))),d_add(d_imul(-2,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxi,dxb))),d_add(d_imul(-2,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxb,d_sgn(Xxr))))))),d_add(d_imul(-2,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_sgn(Xxr))))))),d_add(d_imul(2,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr))))))),d_add(d_imul(4,d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(Xxr,dxb))),d_add(d_imul(-4,d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(Xxi,dyb))),d_add(d_imul(4,d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr))))))),d_add(d_imul(-4,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_sgn(Xxi))))))),dbb))))))))))));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_add(d_sub(d_sub(d_sub(d_add(d_add(d_sub(d_sub(d_sub(d_mul(Xi2,d_diffabs(Xi2,d_add(d_mul(d_imul(2,xi),Xi),xi2))),d_mul(d_mul(d_imul(4,Xi),Xr),d_diffabs(d_mul(Xr,Xi),d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi))))),d_mul(Xr2,d_diffabs(Xi2,d_add(d_mul(d_imul(2,xi),Xi),xi2)))),d_mul(Xi2,d_diffabs(Xr2,d_add(d_mul(d_imul(2,Xr),xr),xr2)))),d_mul(Xr2,d_diffabs(Xr2,d_add(d_mul(d_imul(2,Xr),xr),xr2)))),d_mul(d_add(d_mul(d_imul(2,xi),Xi),xi2),d_abs(d_add(d_add(Xi2,d_mul(d_imul(2,xi),Xi)),xi2)))),d_mul(d_imul(4,d_add(d_add(d_mul(Xi,xr),d_mul(xi,Xr)),d_mul(xi,xr))),d_abs(d_add(d_add(d_add(d_mul(Xr,Xi),d_mul(Xr,xi)),d_mul(xr,Xi)),d_mul(xr,xi))))),d_mul(d_add(d_mul(d_imul(2,Xr),xr),xr2),d_abs(d_add(d_add(Xi2,d_mul(d_imul(2,xi),Xi)),xi2)))),d_mul(d_add(d_mul(d_imul(2,xi),Xi),xi2),d_abs(d_add(d_add(Xr2,d_mul(d_imul(2,Xr),xr)),xr2)))),d_mul(d_add(d_mul(d_imul(2,Xr),xr),xr2),d_abs(d_add(d_add(Xr2,d_mul(d_imul(2,Xr),xr)),xr2)))),cr);
xin=d_add(d_sub(d_sub(d_add(d_add(d_sub(d_sub(d_add(d_mul(d_imul(2,Xr2),d_diffabs(d_mul(Xr,Xi),d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi)))),d_mul(d_mul(d_imul(2,Xr),Xi),d_diffabs(Xr2,d_add(d_mul(d_imul(2,Xr),xr),xr2)))),d_mul(d_mul(d_imul(2,Xr),Xi),d_diffabs(Xi2,d_add(d_mul(d_imul(2,xi),Xi),xi2)))),d_mul(d_imul(2,Xi2),d_diffabs(d_mul(Xr,Xi),d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi))))),d_mul(d_imul(2,d_add(d_mul(d_imul(2,Xr),xr),xr2)),d_abs(d_add(d_add(d_add(d_mul(Xr,Xi),d_mul(Xr,xi)),d_mul(xr,Xi)),d_mul(xr,xi))))),d_mul(d_imul(2,d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi))),d_abs(d_add(d_add(Xr2,d_mul(d_imul(2,Xr),xr)),xr2)))),d_mul(d_imul(2,d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi))),d_abs(d_add(d_add(Xi2,d_mul(d_imul(2,xi),Xi)),xi2)))),d_mul(d_imul(2,d_add(d_mul(d_imul(2,xi),Xi),xi2)),d_abs(d_add(d_add(d_add(d_mul(Xr,Xi),d_mul(Xr,xi)),d_mul(xr,Xi)),d_mul(xr,xi))))),ci);
}

);

static const char *perturbation_opencl_floatexp_33_4_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_mul(Xi2,fe_diffabs(Xi2,fe_add(fe_mul(fe_imul(2,xi),Xi),xi2))),fe_mul(fe_mul(fe_imul(4,Xi),Xr),fe_diffabs(fe_mul(Xr,Xi),fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi))))),fe_mul(Xr2,fe_diffabs(Xi2,fe_add(fe_mul(fe_imul(2,xi),Xi),xi2)))),fe_mul(Xi2,fe_diffabs(Xr2,fe_add(fe_mul(fe_imul(2,Xr),xr),xr2)))),fe_mul(Xr2,fe_diffabs(Xr2,fe_add(fe_mul(fe_imul(2,Xr),xr),xr2)))),fe_mul(fe_add(fe_mul(fe_imul(2,xi),Xi),xi2),fe_abs(fe_add(fe_add(Xi2,fe_mul(fe_imul(2,xi),Xi)),xi2)))),fe_mul(fe_imul(4,fe_add(fe_add(fe_mul(Xi,xr),fe_mul(xi,Xr)),fe_mul(xi,xr))),fe_abs(fe_add(fe_add(fe_add(fe_mul(Xr,Xi),fe_mul(Xr,xi)),fe_mul(xr,Xi)),fe_mul(xr,xi))))),fe_mul(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),fe_abs(fe_add(fe_add(Xi2,fe_mul(fe_imul(2,xi),Xi)),xi2)))),fe_mul(fe_add(fe_mul(fe_imul(2,xi),Xi),xi2),fe_abs(fe_add(fe_add(Xr2,fe_mul(fe_imul(2,Xr),xr)),xr2)))),fe_mul(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),fe_abs(fe_add(fe_add(Xr2,fe_mul(fe_imul(2,Xr),xr)),xr2)))),cr);
xin=fe_add(fe_sub(fe_sub(fe_add(fe_add(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr2),fe_diffabs(fe_mul(Xr,Xi),fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi)))),fe_mul(fe_mul(fe_imul(2,Xr),Xi),fe_diffabs(Xr2,fe_add(fe_mul(fe_imul(2,Xr),xr),xr2)))),fe_mul(fe_mul(fe_imul(2,Xr),Xi),fe_diffabs(Xi2,fe_add(fe_mul(fe_imul(2,xi),Xi),xi2)))),fe_mul(fe_imul(2,Xi2),fe_diffabs(fe_mul(Xr,Xi),fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi))))),fe_mul(fe_imul(2,fe_add(fe_mul(fe_imul(2,Xr),xr),xr2)),fe_abs(fe_add(fe_add(fe_add(fe_mul(Xr,Xi),fe_mul(Xr,xi)),fe_mul(xr,Xi)),fe_mul(xr,xi))))),fe_mul(fe_imul(2,fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi))),fe_abs(fe_add(fe_add(Xr2,fe_mul(fe_imul(2,Xr),xr)),xr2)))),fe_mul(fe_imul(2,fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi))),fe_abs(fe_add(fe_add(Xi2,fe_mul(fe_imul(2,xi),Xi)),xi2)))),fe_mul(fe_imul(2,fe_add(fe_mul(fe_imul(2,xi),Xi),xi2)),fe_abs(fe_add(fe_add(fe_add(fe_mul(Xr,Xi),fe_mul(Xr,xi)),fe_mul(xr,Xi)),fe_mul(xr,xi))))),ci);
}

);

static const char *perturbation_opencl_floatexp_33_4_1 = STR(

{dxan=fe_add(fe_imul(2,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxr,dxa))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxr,dxa))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr))))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,dya))),fe_add(fe_imul(2,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxi,dya))),fe_add(fe_imul(-2,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxi))))))),fe_add(fe_imul(-2,fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr))))))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dya,fe_sgn(Xxi))))))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(Xxi,dxa))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(Xxr,dya))),fe_add(fe_imul(-4,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr))))))),fe_add(fe_imul(-4,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxr))))))),daa))))))))))));
dxbn=fe_add(fe_imul(2,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxr,dxb))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxr,dxb))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr))))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,dyb))),fe_add(fe_imul(2,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxi,dyb))),fe_add(fe_imul(-2,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxi))))))),fe_add(fe_imul(-2,fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr))))))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dyb,fe_sgn(Xxi))))))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(Xxi,dxb))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(Xxr,dyb))),fe_add(fe_imul(-4,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr))))))),fe_add(fe_imul(-4,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxr))))))),dab))))))))))));
dyan=fe_add(fe_imul(2,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxr,dya))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxr,dya))),fe_add(fe_imul(2,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,dxa))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxi),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxr))))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxi,dxa))),fe_add(fe_imul(-2,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxa,fe_sgn(Xxr))))))),fe_add(fe_imul(-2,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxr))))))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr))))))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(Xxr,dxa))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(Xxi,dya))),fe_add(fe_imul(4,fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr))))))),fe_add(fe_imul(-4,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxi))))))),dba))))))))))));
dybn=fe_add(fe_imul(2,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxr,dyb))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxr,dyb))),fe_add(fe_imul(2,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,dxb))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxi),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxr))))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxi,dxb))),fe_add(fe_imul(-2,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxb,fe_sgn(Xxr))))))),fe_add(fe_imul(-2,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxr))))))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr))))))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(Xxr,dxb))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(Xxi,dyb))),fe_add(fe_imul(4,fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr))))))),fe_add(fe_imul(-4,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxi))))))),dbb))))))))))));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_mul(Xi2,fe_diffabs(Xi2,fe_add(fe_mul(fe_imul(2,xi),Xi),xi2))),fe_mul(fe_mul(fe_imul(4,Xi),Xr),fe_diffabs(fe_mul(Xr,Xi),fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi))))),fe_mul(Xr2,fe_diffabs(Xi2,fe_add(fe_mul(fe_imul(2,xi),Xi),xi2)))),fe_mul(Xi2,fe_diffabs(Xr2,fe_add(fe_mul(fe_imul(2,Xr),xr),xr2)))),fe_mul(Xr2,fe_diffabs(Xr2,fe_add(fe_mul(fe_imul(2,Xr),xr),xr2)))),fe_mul(fe_add(fe_mul(fe_imul(2,xi),Xi),xi2),fe_abs(fe_add(fe_add(Xi2,fe_mul(fe_imul(2,xi),Xi)),xi2)))),fe_mul(fe_imul(4,fe_add(fe_add(fe_mul(Xi,xr),fe_mul(xi,Xr)),fe_mul(xi,xr))),fe_abs(fe_add(fe_add(fe_add(fe_mul(Xr,Xi),fe_mul(Xr,xi)),fe_mul(xr,Xi)),fe_mul(xr,xi))))),fe_mul(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),fe_abs(fe_add(fe_add(Xi2,fe_mul(fe_imul(2,xi),Xi)),xi2)))),fe_mul(fe_add(fe_mul(fe_imul(2,xi),Xi),xi2),fe_abs(fe_add(fe_add(Xr2,fe_mul(fe_imul(2,Xr),xr)),xr2)))),fe_mul(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),fe_abs(fe_add(fe_add(Xr2,fe_mul(fe_imul(2,Xr),xr)),xr2)))),cr);
xin=fe_add(fe_sub(fe_sub(fe_add(fe_add(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr2),fe_diffabs(fe_mul(Xr,Xi),fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi)))),fe_mul(fe_mul(fe_imul(2,Xr),Xi),fe_diffabs(Xr2,fe_add(fe_mul(fe_imul(2,Xr),xr),xr2)))),fe_mul(fe_mul(fe_imul(2,Xr),Xi),fe_diffabs(Xi2,fe_add(fe_mul(fe_imul(2,xi),Xi),xi2)))),fe_mul(fe_imul(2,Xi2),fe_diffabs(fe_mul(Xr,Xi),fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi))))),fe_mul(fe_imul(2,fe_add(fe_mul(fe_imul(2,Xr),xr),xr2)),fe_abs(fe_add(fe_add(fe_add(fe_mul(Xr,Xi),fe_mul(Xr,xi)),fe_mul(xr,Xi)),fe_mul(xr,xi))))),fe_mul(fe_imul(2,fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi))),fe_abs(fe_add(fe_add(Xr2,fe_mul(fe_imul(2,Xr),xr)),xr2)))),fe_mul(fe_imul(2,fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi))),fe_abs(fe_add(fe_add(Xi2,fe_mul(fe_imul(2,xi),Xi)),xi2)))),fe_mul(fe_imul(2,fe_add(fe_mul(fe_imul(2,xi),Xi),xi2)),fe_abs(fe_add(fe_add(fe_add(fe_mul(Xr,Xi),fe_mul(Xr,xi)),fe_mul(xr,Xi)),fe_mul(xr,xi))))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_33_4_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_mul(Xi2,sf_diffabs(Xi2,sf_add(sf_mul(sf_imul(2,xi),Xi),xi2))),sf_mul(sf_mul(sf_imul(4,Xi),Xr),sf_diffabs(sf_mul(Xr,Xi),sf_add(sf_add(sf_mul(Xr,xi),sf_mul(xr,Xi)),sf_mul(xr,xi))))),sf_mul(Xr2,sf_diffabs(Xi2,sf_add(sf_mul(sf_imul(2,xi),Xi),xi2)))),sf_mul(Xi2,sf_diffabs(Xr2,sf_add(sf_mul(sf_imul(2,Xr),xr),xr2)))),sf_mul(Xr2,sf_diffabs(Xr2,sf_add(sf_mul(sf_imul(2,Xr),xr),xr2)))),sf_mul(sf_add(sf_mul(sf_imul(2,xi),Xi),xi2),sf_abs(sf_add(sf_add(Xi2,sf_mul(sf_imul(2,xi),Xi)),xi2)))),sf_mul(sf_imul(4,sf_add(sf_add(sf_mul(Xi,xr),sf_mul(xi,Xr)),sf_mul(xi,xr))),sf_abs(sf_add(sf_add(sf_add(sf_mul(Xr,Xi),sf_mul(Xr,xi)),sf_mul(xr,Xi)),sf_mul(xr,xi))))),sf_mul(sf_add(sf_mul(sf_imul(2,Xr),xr),xr2),sf_abs(sf_add(sf_add(Xi2,sf_mul(sf_imul(2,xi),Xi)),xi2)))),sf_mul(sf_add(sf_mul(sf_imul(2,xi),Xi),xi2),sf_abs(sf_add(sf_add(Xr2,sf_mul(sf_imul(2,Xr),xr)),xr2)))),sf_mul(sf_add(sf_mul(sf_imul(2,Xr),xr),xr2),sf_abs(sf_add(sf_add(Xr2,sf_mul(sf_imul(2,Xr),xr)),xr2)))),cr);
xin=sf_add(sf_sub(sf_sub(sf_add(sf_add(sf_sub(sf_sub(sf_add(sf_mul(sf_imul(2,Xr2),sf_diffabs(sf_mul(Xr,Xi),sf_add(sf_add(sf_mul(Xr,xi),sf_mul(xr,Xi)),sf_mul(xr,xi)))),sf_mul(sf_mul(sf_imul(2,Xr),Xi),sf_diffabs(Xr2,sf_add(sf_mul(sf_imul(2,Xr),xr),xr2)))),sf_mul(sf_mul(sf_imul(2,Xr),Xi),sf_diffabs(Xi2,sf_add(sf_mul(sf_imul(2,xi),Xi),xi2)))),sf_mul(sf_imul(2,Xi2),sf_diffabs(sf_mul(Xr,Xi),sf_add(sf_add(sf_mul(Xr,xi),sf_mul(xr,Xi)),sf_mul(xr,xi))))),sf_mul(sf_imul(2,sf_add(sf_mul(sf_imul(2,Xr),xr),xr2)),sf_abs(sf_add(sf_add(sf_add(sf_mul(Xr,Xi),sf_mul(Xr,xi)),sf_mul(xr,Xi)),sf_mul(xr,xi))))),sf_mul(sf_imul(2,sf_add(sf_add(sf_mul(Xr,xi),sf_mul(xr,Xi)),sf_mul(xr,xi))),sf_abs(sf_add(sf_add(Xr2,sf_mul(sf_imul(2,Xr),xr)),xr2)))),sf_mul(sf_imul(2,sf_add(sf_add(sf_mul(Xr,xi),sf_mul(xr,Xi)),sf_mul(xr,xi))),sf_abs(sf_add(sf_add(Xi2,sf_mul(sf_imul(2,xi),Xi)),xi2)))),sf_mul(sf_imul(2,sf_add(sf_mul(sf_imul(2,xi),Xi),xi2)),sf_abs(sf_add(sf_add(sf_add(sf_mul(Xr,Xi),sf_mul(Xr,xi)),sf_mul(xr,Xi)),sf_mul(xr,xi))))),ci);
}

);
#endif


static const char *perturbation_opencl_double_34_4_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_mul(d_imul(12,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(24,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(12,Xr),xr),xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xr2),Xi),xi)),d_mul(d_imul(6,xr2),xi2)),cr);
xin=d_add(d_add(d_mul(d_imul(4,xr),d_abs(d_add(d_sub(d_add(d_add(d_add(d_sub(d_add(d_add(d_sub(d_mul(d_neg(Xi2),Xi),d_mul(d_imul(3,xi),Xi2)),d_mul(Xr2,Xi)),d_mul(d_mul(d_imul(2,xr),Xr),Xi)),d_mul(d_imul(3,xi2),Xi)),d_mul(xr2,Xi)),d_mul(xi,Xr2)),d_mul(d_mul(d_imul(2,xr),xi),Xr)),d_mul(xi2,xi)),d_mul(xr2,xi)))),d_mul(d_imul(4,Xr),d_diffabs(d_add(d_mul(d_neg(Xi2),Xi),d_mul(Xr2,Xi)),d_add(d_sub(d_add(d_add(d_add(d_sub(d_add(d_mul(d_imul(-3,xi),Xi2),d_mul(d_mul(d_imul(2,xr),Xr),Xi)),d_mul(d_imul(3,xi2),Xi)),d_mul(xr2,Xi)),d_mul(xi,Xr2)),d_mul(d_mul(d_imul(2,xr),xi),Xr)),d_mul(xi2,xi)),d_mul(xr2,xi))))),ci);
}

);

static const char *perturbation_opencl_double_34_4_1 = STR(

{dxan=d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dya)))),d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dxa)))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,dxa)))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,dya)))),daa))));
dxbn=d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dyb)))),d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dxb)))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,dxb)))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,dyb)))),dab))));
dyan=d_add(dba,d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxi,d_mul(Xxr,Xxr))))))))),d_add(d_imul(8,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxi,d_mul(Xxr,Xxr))))))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxi,d_mul(Xxr,Xxr))))))))),d_imul(4,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxi,d_mul(Xxr,Xxr)))),dxa))))));
dybn=d_add(dbb,d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxi,d_mul(Xxr,Xxr))))))))),d_add(d_imul(8,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxi,d_mul(Xxr,Xxr))))))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxi,d_mul(Xxr,Xxr))))))))),d_imul(4,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxi,d_mul(Xxr,Xxr)))),dxb))))));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_mul(d_imul(12,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(24,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(12,Xr),xr),xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xr2),Xi),xi)),d_mul(d_imul(6,xr2),xi2)),cr);
xin=d_add(d_add(d_mul(d_imul(4,xr),d_abs(d_add(d_sub(d_add(d_add(d_add(d_sub(d_add(d_add(d_sub(d_mul(d_neg(Xi2),Xi),d_mul(d_imul(3,xi),Xi2)),d_mul(Xr2,Xi)),d_mul(d_mul(d_imul(2,xr),Xr),Xi)),d_mul(d_imul(3,xi2),Xi)),d_mul(xr2,Xi)),d_mul(xi,Xr2)),d_mul(d_mul(d_imul(2,xr),xi),Xr)),d_mul(xi2,xi)),d_mul(xr2,xi)))),d_mul(d_imul(4,Xr),d_diffabs(d_add(d_mul(d_neg(Xi2),Xi),d_mul(Xr2,Xi)),d_add(d_sub(d_add(d_add(d_add(d_sub(d_add(d_mul(d_imul(-3,xi),Xi2),d_mul(d_mul(d_imul(2,xr),Xr),Xi)),d_mul(d_imul(3,xi2),Xi)),d_mul(xr2,Xi)),d_mul(xi,Xr2)),d_mul(d_mul(d_imul(2,xr),xi),Xr)),d_mul(xi2,xi)),d_mul(xr2,xi))))),ci);
}

);

static const char *perturbation_opencl_floatexp_34_4_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_mul(fe_imul(12,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(12,Xr),xr),xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xr2),Xi),xi)),fe_mul(fe_imul(6,xr2),xi2)),cr);
xin=fe_add(fe_add(fe_mul(fe_imul(4,xr),fe_abs(fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_mul(fe_neg(Xi2),Xi),fe_mul(fe_imul(3,xi),Xi2)),fe_mul(Xr2,Xi)),fe_mul(fe_mul(fe_imul(2,xr),Xr),Xi)),fe_mul(fe_imul(3,xi2),Xi)),fe_mul(xr2,Xi)),fe_mul(xi,Xr2)),fe_mul(fe_mul(fe_imul(2,xr),xi),Xr)),fe_mul(xi2,xi)),fe_mul(xr2,xi)))),fe_mul(fe_imul(4,Xr),fe_diffabs(fe_add(fe_mul(fe_neg(Xi2),Xi),fe_mul(Xr2,Xi)),fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_add(fe_mul(fe_imul(-3,xi),Xi2),fe_mul(fe_mul(fe_imul(2,xr),Xr),Xi)),fe_mul(fe_imul(3,xi2),Xi)),fe_mul(xr2,Xi)),fe_mul(xi,Xr2)),fe_mul(fe_mul(fe_imul(2,xr),xi),Xr)),fe_mul(xi2,xi)),fe_mul(xr2,xi))))),ci);
}

);

static const char *perturbation_opencl_floatexp_34_4_1 = STR(

{dxan=fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dya)))),fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dxa)))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,dxa)))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,dya)))),daa))));
dxbn=fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dyb)))),fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dxb)))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,dxb)))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,dyb)))),dab))));
dyan=fe_add(dba,fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxi,fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(8,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxi,fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxi,fe_mul(Xxr,Xxr))))))))),fe_imul(4,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxi,fe_mul(Xxr,Xxr)))),dxa))))));
dybn=fe_add(dbb,fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxi,fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(8,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxi,fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxi,fe_mul(Xxr,Xxr))))))))),fe_imul(4,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxi,fe_mul(Xxr,Xxr)))),dxb))))));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_mul(fe_imul(12,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(12,Xr),xr),xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xr2),Xi),xi)),fe_mul(fe_imul(6,xr2),xi2)),cr);
xin=fe_add(fe_add(fe_mul(fe_imul(4,xr),fe_abs(fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_mul(fe_neg(Xi2),Xi),fe_mul(fe_imul(3,xi),Xi2)),fe_mul(Xr2,Xi)),fe_mul(fe_mul(fe_imul(2,xr),Xr),Xi)),fe_mul(fe_imul(3,xi2),Xi)),fe_mul(xr2,Xi)),fe_mul(xi,Xr2)),fe_mul(fe_mul(fe_imul(2,xr),xi),Xr)),fe_mul(xi2,xi)),fe_mul(xr2,xi)))),fe_mul(fe_imul(4,Xr),fe_diffabs(fe_add(fe_mul(fe_neg(Xi2),Xi),fe_mul(Xr2,Xi)),fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_add(fe_mul(fe_imul(-3,xi),Xi2),fe_mul(fe_mul(fe_imul(2,xr),Xr),Xi)),fe_mul(fe_imul(3,xi2),Xi)),fe_mul(xr2,Xi)),fe_mul(xi,Xr2)),fe_mul(fe_mul(fe_imul(2,xr),xi),Xr)),fe_mul(xi2,xi)),fe_mul(xr2,xi))))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_34_4_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_mul(sf_imul(4,Xi),xi2),xi)),sf_mul(xi2,xi2)),sf_mul(sf_mul(sf_imul(12,Xr2),Xi),xi)),sf_mul(sf_imul(6,Xr2),xi2)),sf_mul(sf_mul(sf_imul(12,Xr),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(24,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_imul(12,Xr),xr),xi2)),sf_mul(sf_imul(6,xr2),Xi2)),sf_mul(sf_mul(sf_imul(12,xr2),Xi),xi)),sf_mul(sf_imul(6,xr2),xi2)),cr);
xin=sf_add(sf_add(sf_mul(sf_imul(4,xr),sf_abs(sf_add(sf_sub(sf_add(sf_add(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_mul(sf_neg(Xi2),Xi),sf_mul(sf_imul(3,xi),Xi2)),sf_mul(Xr2,Xi)),sf_mul(sf_mul(sf_imul(2,xr),Xr),Xi)),sf_mul(sf_imul(3,xi2),Xi)),sf_mul(xr2,Xi)),sf_mul(xi,Xr2)),sf_mul(sf_mul(sf_imul(2,xr),xi),Xr)),sf_mul(xi2,xi)),sf_mul(xr2,xi)))),sf_mul(sf_imul(4,Xr),sf_diffabs(sf_add(sf_mul(sf_neg(Xi2),Xi),sf_mul(Xr2,Xi)),sf_add(sf_sub(sf_add(sf_add(sf_add(sf_sub(sf_add(sf_mul(sf_imul(-3,xi),Xi2),sf_mul(sf_mul(sf_imul(2,xr),Xr),Xi)),sf_mul(sf_imul(3,xi2),Xi)),sf_mul(xr2,Xi)),sf_mul(xi,Xr2)),sf_mul(sf_mul(sf_imul(2,xr),xi),Xr)),sf_mul(xi2,xi)),sf_mul(xr2,xi))))),ci);
}

);
#endif


static const char *perturbation_opencl_double_35_4_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_mul(d_imul(12,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(24,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(12,Xr),xr),xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xr2),Xi),xi)),d_mul(d_imul(6,xr2),xi2)),cr);
xin=d_add(d_sub(d_mul(d_imul(-4,Xi),d_diffabs(d_sub(d_mul(Xr2,Xr),d_mul(Xr,Xi2)),d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_mul(d_neg(xr),Xi2),d_mul(d_mul(d_imul(2,xi),Xr),Xi)),d_mul(d_mul(d_imul(2,xr),xi),Xi)),d_mul(d_imul(3,xr),Xr2)),d_mul(xi2,Xr)),d_mul(d_imul(3,xr2),Xr)),d_mul(xr,xi2)),d_mul(xr2,xr)))),d_mul(d_imul(4,xi),d_abs(d_add(d_sub(d_add(d_sub(d_add(d_add(d_sub(d_sub(d_sub(d_mul(d_neg(Xr),Xi2),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xi),Xr),Xi)),d_mul(d_mul(d_imul(2,xr),xi),Xi)),d_mul(Xr2,Xr)),d_mul(d_imul(3,xr),Xr2)),d_mul(xi2,Xr)),d_mul(d_imul(3,xr2),Xr)),d_mul(xr,xi2)),d_mul(xr2,xr))))),ci);
}

);

static const char *perturbation_opencl_double_35_4_1 = STR(

{dxan=d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dya)))),d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dxa)))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,dxa)))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,dya)))),daa))));
dxbn=d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dyb)))),d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dxb)))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,dxb)))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,dyb)))),dab))));
dyan=d_add(dba,d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxa,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr))))))))),d_add(d_imul(8,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr))))))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr))))))))),d_imul(-4,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr)))),dya))))));
dybn=d_add(dbb,d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr))))))))),d_add(d_imul(8,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr))))))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr))))))))),d_imul(-4,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr)))),dyb))))));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_mul(d_imul(12,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(24,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(12,Xr),xr),xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xr2),Xi),xi)),d_mul(d_imul(6,xr2),xi2)),cr);
xin=d_add(d_sub(d_mul(d_imul(-4,Xi),d_diffabs(d_sub(d_mul(Xr2,Xr),d_mul(Xr,Xi2)),d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_mul(d_neg(xr),Xi2),d_mul(d_mul(d_imul(2,xi),Xr),Xi)),d_mul(d_mul(d_imul(2,xr),xi),Xi)),d_mul(d_imul(3,xr),Xr2)),d_mul(xi2,Xr)),d_mul(d_imul(3,xr2),Xr)),d_mul(xr,xi2)),d_mul(xr2,xr)))),d_mul(d_imul(4,xi),d_abs(d_add(d_sub(d_add(d_sub(d_add(d_add(d_sub(d_sub(d_sub(d_mul(d_neg(Xr),Xi2),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xi),Xr),Xi)),d_mul(d_mul(d_imul(2,xr),xi),Xi)),d_mul(Xr2,Xr)),d_mul(d_imul(3,xr),Xr2)),d_mul(xi2,Xr)),d_mul(d_imul(3,xr2),Xr)),d_mul(xr,xi2)),d_mul(xr2,xr))))),ci);
}

);

static const char *perturbation_opencl_floatexp_35_4_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_mul(fe_imul(12,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(12,Xr),xr),xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xr2),Xi),xi)),fe_mul(fe_imul(6,xr2),xi2)),cr);
xin=fe_add(fe_sub(fe_mul(fe_imul(-4,Xi),fe_diffabs(fe_sub(fe_mul(Xr2,Xr),fe_mul(Xr,Xi2)),fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_mul(fe_neg(xr),Xi2),fe_mul(fe_mul(fe_imul(2,xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(2,xr),xi),Xi)),fe_mul(fe_imul(3,xr),Xr2)),fe_mul(xi2,Xr)),fe_mul(fe_imul(3,xr2),Xr)),fe_mul(xr,xi2)),fe_mul(xr2,xr)))),fe_mul(fe_imul(4,xi),fe_abs(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_mul(fe_neg(Xr),Xi2),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(2,xr),xi),Xi)),fe_mul(Xr2,Xr)),fe_mul(fe_imul(3,xr),Xr2)),fe_mul(xi2,Xr)),fe_mul(fe_imul(3,xr2),Xr)),fe_mul(xr,xi2)),fe_mul(xr2,xr))))),ci);
}

);

static const char *perturbation_opencl_floatexp_35_4_1 = STR(

{dxan=fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dya)))),fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dxa)))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,dxa)))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,dya)))),daa))));
dxbn=fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dyb)))),fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dxb)))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,dxb)))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,dyb)))),dab))));
dyan=fe_add(dba,fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxa,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(8,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))),fe_imul(-4,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr)))),dya))))));
dybn=fe_add(dbb,fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(8,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))),fe_imul(-4,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr)))),dyb))))));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_mul(fe_imul(12,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(12,Xr),xr),xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xr2),Xi),xi)),fe_mul(fe_imul(6,xr2),xi2)),cr);
xin=fe_add(fe_sub(fe_mul(fe_imul(-4,Xi),fe_diffabs(fe_sub(fe_mul(Xr2,Xr),fe_mul(Xr,Xi2)),fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_mul(fe_neg(xr),Xi2),fe_mul(fe_mul(fe_imul(2,xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(2,xr),xi),Xi)),fe_mul(fe_imul(3,xr),Xr2)),fe_mul(xi2,Xr)),fe_mul(fe_imul(3,xr2),Xr)),fe_mul(xr,xi2)),fe_mul(xr2,xr)))),fe_mul(fe_imul(4,xi),fe_abs(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_mul(fe_neg(Xr),Xi2),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(2,xr),xi),Xi)),fe_mul(Xr2,Xr)),fe_mul(fe_imul(3,xr),Xr2)),fe_mul(xi2,Xr)),fe_mul(fe_imul(3,xr2),Xr)),fe_mul(xr,xi2)),fe_mul(xr2,xr))))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_35_4_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_mul(sf_imul(4,Xi),xi2),xi)),sf_mul(xi2,xi2)),sf_mul(sf_mul(sf_imul(12,Xr2),Xi),xi)),sf_mul(sf_imul(6,Xr2),xi2)),sf_mul(sf_mul(sf_imul(12,Xr),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(24,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_imul(12,Xr),xr),xi2)),sf_mul(sf_imul(6,xr2),Xi2)),sf_mul(sf_mul(sf_imul(12,xr2),Xi),xi)),sf_mul(sf_imul(6,xr2),xi2)),cr);
xin=sf_add(sf_sub(sf_mul(sf_imul(-4,Xi),sf_diffabs(sf_sub(sf_mul(Xr2,Xr),sf_mul(Xr,Xi2)),sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_mul(sf_neg(xr),Xi2),sf_mul(sf_mul(sf_imul(2,xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(2,xr),xi),Xi)),sf_mul(sf_imul(3,xr),Xr2)),sf_mul(xi2,Xr)),sf_mul(sf_imul(3,xr2),Xr)),sf_mul(xr,xi2)),sf_mul(xr2,xr)))),sf_mul(sf_imul(4,xi),sf_abs(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_mul(sf_neg(Xr),Xi2),sf_mul(xr,Xi2)),sf_mul(sf_mul(sf_imul(2,xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(2,xr),xi),Xi)),sf_mul(Xr2,Xr)),sf_mul(sf_imul(3,xr),Xr2)),sf_mul(xi2,Xr)),sf_mul(sf_imul(3,xr2),Xr)),sf_mul(xr,xi2)),sf_mul(xr2,xr))))),ci);
}

);
#endif


static const char *perturbation_opencl_double_36_4_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_mul(d_imul(12,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(24,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(12,Xr),xr),xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xr2),Xi),xi)),d_mul(d_imul(6,xr2),xi2)),cr);
xin=d_add(d_add(d_mul(d_imul(4,Xi),d_diffabs(d_sub(d_mul(Xr2,Xr),d_mul(Xr,Xi2)),d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_mul(d_neg(xr),Xi2),d_mul(d_mul(d_imul(2,xi),Xr),Xi)),d_mul(d_mul(d_imul(2,xr),xi),Xi)),d_mul(d_imul(3,xr),Xr2)),d_mul(xi2,Xr)),d_mul(d_imul(3,xr2),Xr)),d_mul(xr,xi2)),d_mul(xr2,xr)))),d_mul(d_imul(4,xi),d_abs(d_add(d_sub(d_add(d_sub(d_add(d_add(d_sub(d_sub(d_sub(d_mul(d_neg(Xr),Xi2),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xi),Xr),Xi)),d_mul(d_mul(d_imul(2,xr),xi),Xi)),d_mul(Xr2,Xr)),d_mul(d_imul(3,xr),Xr2)),d_mul(xi2,Xr)),d_mul(d_imul(3,xr2),Xr)),d_mul(xr,xi2)),d_mul(xr2,xr))))),ci);
}

);

static const char *perturbation_opencl_double_36_4_1 = STR(

{dxan=d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dya)))),d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dxa)))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,dxa)))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,dya)))),daa))));
dxbn=d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,dyb)))),d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,dxb)))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,dxb)))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,dyb)))),dab))));
dyan=d_add(dba,d_add(d_imul(-4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxa,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr))))))))),d_add(d_imul(-8,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr))))))))),d_add(d_imul(12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr))))))))),d_imul(4,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr)))),dya))))));
dybn=d_add(dbb,d_add(d_imul(-4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr))))))))),d_add(d_imul(-8,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr))))))))),d_add(d_imul(12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr))))))))),d_imul(4,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr)))),dyb))))));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_sub(d_add(d_add(d_add(d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(4,Xr2),Xr),xr),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(4,Xr),xr2),xr)),d_mul(xr2,xr2)),d_mul(d_mul(d_imul(4,Xi2),Xi),xi)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_mul(d_imul(4,Xi),xi2),xi)),d_mul(xi2,xi2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_mul(d_imul(12,Xr),xr),Xi2)),d_mul(d_mul(d_mul(d_imul(24,Xr),xr),Xi),xi)),d_mul(d_mul(d_imul(12,Xr),xr),xi2)),d_mul(d_imul(6,xr2),Xi2)),d_mul(d_mul(d_imul(12,xr2),Xi),xi)),d_mul(d_imul(6,xr2),xi2)),cr);
xin=d_add(d_add(d_mul(d_imul(4,Xi),d_diffabs(d_sub(d_mul(Xr2,Xr),d_mul(Xr,Xi2)),d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_mul(d_neg(xr),Xi2),d_mul(d_mul(d_imul(2,xi),Xr),Xi)),d_mul(d_mul(d_imul(2,xr),xi),Xi)),d_mul(d_imul(3,xr),Xr2)),d_mul(xi2,Xr)),d_mul(d_imul(3,xr2),Xr)),d_mul(xr,xi2)),d_mul(xr2,xr)))),d_mul(d_imul(4,xi),d_abs(d_add(d_sub(d_add(d_sub(d_add(d_add(d_sub(d_sub(d_sub(d_mul(d_neg(Xr),Xi2),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xi),Xr),Xi)),d_mul(d_mul(d_imul(2,xr),xi),Xi)),d_mul(Xr2,Xr)),d_mul(d_imul(3,xr),Xr2)),d_mul(xi2,Xr)),d_mul(d_imul(3,xr2),Xr)),d_mul(xr,xi2)),d_mul(xr2,xr))))),ci);
}

);

static const char *perturbation_opencl_floatexp_36_4_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_mul(fe_imul(12,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(12,Xr),xr),xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xr2),Xi),xi)),fe_mul(fe_imul(6,xr2),xi2)),cr);
xin=fe_add(fe_add(fe_mul(fe_imul(4,Xi),fe_diffabs(fe_sub(fe_mul(Xr2,Xr),fe_mul(Xr,Xi2)),fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_mul(fe_neg(xr),Xi2),fe_mul(fe_mul(fe_imul(2,xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(2,xr),xi),Xi)),fe_mul(fe_imul(3,xr),Xr2)),fe_mul(xi2,Xr)),fe_mul(fe_imul(3,xr2),Xr)),fe_mul(xr,xi2)),fe_mul(xr2,xr)))),fe_mul(fe_imul(4,xi),fe_abs(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_mul(fe_neg(Xr),Xi2),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(2,xr),xi),Xi)),fe_mul(Xr2,Xr)),fe_mul(fe_imul(3,xr),Xr2)),fe_mul(xi2,Xr)),fe_mul(fe_imul(3,xr2),Xr)),fe_mul(xr,xi2)),fe_mul(xr2,xr))))),ci);
}

);

static const char *perturbation_opencl_floatexp_36_4_1 = STR(

{dxan=fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dya)))),fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dxa)))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,dxa)))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,dya)))),daa))));
dxbn=fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,dyb)))),fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,dxb)))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,dxb)))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,dyb)))),dab))));
dyan=fe_add(dba,fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxa,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(-8,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))),fe_imul(4,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr)))),dya))))));
dybn=fe_add(dbb,fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(-8,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))),fe_imul(4,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr)))),dyb))))));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(4,Xr),xr2),xr)),fe_mul(xr2,xr2)),fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_mul(fe_imul(4,Xi),xi2),xi)),fe_mul(xi2,xi2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_mul(fe_imul(12,Xr),xr),Xi2)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),xr),Xi),xi)),fe_mul(fe_mul(fe_imul(12,Xr),xr),xi2)),fe_mul(fe_imul(6,xr2),Xi2)),fe_mul(fe_mul(fe_imul(12,xr2),Xi),xi)),fe_mul(fe_imul(6,xr2),xi2)),cr);
xin=fe_add(fe_add(fe_mul(fe_imul(4,Xi),fe_diffabs(fe_sub(fe_mul(Xr2,Xr),fe_mul(Xr,Xi2)),fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_mul(fe_neg(xr),Xi2),fe_mul(fe_mul(fe_imul(2,xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(2,xr),xi),Xi)),fe_mul(fe_imul(3,xr),Xr2)),fe_mul(xi2,Xr)),fe_mul(fe_imul(3,xr2),Xr)),fe_mul(xr,xi2)),fe_mul(xr2,xr)))),fe_mul(fe_imul(4,xi),fe_abs(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_mul(fe_neg(Xr),Xi2),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(2,xr),xi),Xi)),fe_mul(Xr2,Xr)),fe_mul(fe_imul(3,xr),Xr2)),fe_mul(xi2,Xr)),fe_mul(fe_imul(3,xr2),Xr)),fe_mul(xr,xi2)),fe_mul(xr2,xr))))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_36_4_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_mul(sf_imul(4,Xi),xi2),xi)),sf_mul(xi2,xi2)),sf_mul(sf_mul(sf_imul(12,Xr2),Xi),xi)),sf_mul(sf_imul(6,Xr2),xi2)),sf_mul(sf_mul(sf_imul(12,Xr),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(24,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_imul(12,Xr),xr),xi2)),sf_mul(sf_imul(6,xr2),Xi2)),sf_mul(sf_mul(sf_imul(12,xr2),Xi),xi)),sf_mul(sf_imul(6,xr2),xi2)),cr);
xin=sf_add(sf_add(sf_mul(sf_imul(4,Xi),sf_diffabs(sf_sub(sf_mul(Xr2,Xr),sf_mul(Xr,Xi2)),sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_mul(sf_neg(xr),Xi2),sf_mul(sf_mul(sf_imul(2,xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(2,xr),xi),Xi)),sf_mul(sf_imul(3,xr),Xr2)),sf_mul(xi2,Xr)),sf_mul(sf_imul(3,xr2),Xr)),sf_mul(xr,xi2)),sf_mul(xr2,xr)))),sf_mul(sf_imul(4,xi),sf_abs(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_mul(sf_neg(Xr),Xi2),sf_mul(xr,Xi2)),sf_mul(sf_mul(sf_imul(2,xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(2,xr),xi),Xi)),sf_mul(Xr2,Xr)),sf_mul(sf_imul(3,xr),Xr2)),sf_mul(xi2,Xr)),sf_mul(sf_imul(3,xr2),Xr)),sf_mul(xr,xi2)),sf_mul(xr2,xr))))),ci);
}

);
#endif


static const char *perturbation_opencl_double_37_4_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_diffabs(d_sub(d_add(d_mul(Xr2,Xr2),d_mul(Xi2,Xi2)),d_mul(d_imul(6,Xr2),Xi2)),d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_mul(d_mul(d_imul(4,Xi2),Xi),xi),d_mul(d_mul(d_imul(12,Xi2),xr),Xr)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_imul(6,Xi2),xr2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_mul(d_mul(d_imul(24,Xr),Xi),xr),xi)),d_mul(d_mul(d_imul(4,xi2),xi),Xi)),d_mul(d_mul(d_imul(12,xi),Xi),xr2)),d_mul(d_mul(d_imul(4,Xr2),Xr),xr)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(12,xi2),Xr),xr)),d_mul(d_mul(d_imul(4,xr2),xr),Xr)),d_mul(xi2,xi2)),d_mul(d_imul(6,xi2),xr2)),d_mul(xr2,xr2))),cr);
xin=d_add(d_add(d_mul(d_imul(4,xr),d_abs(d_add(d_sub(d_add(d_add(d_add(d_sub(d_add(d_add(d_sub(d_mul(d_neg(Xi2),Xi),d_mul(d_imul(3,xi),Xi2)),d_mul(Xr2,Xi)),d_mul(d_mul(d_imul(2,xr),Xr),Xi)),d_mul(d_imul(3,xi2),Xi)),d_mul(xr2,Xi)),d_mul(xi,Xr2)),d_mul(d_mul(d_imul(2,xr),xi),Xr)),d_mul(xi2,xi)),d_mul(xr2,xi)))),d_mul(d_imul(4,Xr),d_diffabs(d_add(d_mul(d_neg(Xi2),Xi),d_mul(Xr2,Xi)),d_add(d_sub(d_add(d_add(d_add(d_sub(d_add(d_mul(d_imul(-3,xi),Xi2),d_mul(d_mul(d_imul(2,xr),Xr),Xi)),d_mul(d_imul(3,xi2),Xi)),d_mul(xr2,Xi)),d_mul(xi,Xr2)),d_mul(d_mul(d_imul(2,xr),xi),Xr)),d_mul(xi2,xi)),d_mul(xr2,xi))))),ci);
}

);

static const char *perturbation_opencl_double_37_4_1 = STR(

{dxan=d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dya,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),daa))));
dxbn=d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dyb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),dab))));
dyan=d_add(dba,d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxi,d_mul(Xxr,Xxr))))))))),d_add(d_imul(8,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxi,d_mul(Xxr,Xxr))))))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxi,d_mul(Xxr,Xxr))))))))),d_imul(4,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxi,d_mul(Xxr,Xxr)))),dxa))))));
dybn=d_add(dbb,d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxi,d_mul(Xxr,Xxr))))))))),d_add(d_imul(8,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxi,d_mul(Xxr,Xxr))))))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxi,d_mul(Xxr,Xxr))))))))),d_imul(4,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxi,d_mul(Xxr,Xxr)))),dxb))))));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_diffabs(d_sub(d_add(d_mul(Xr2,Xr2),d_mul(Xi2,Xi2)),d_mul(d_imul(6,Xr2),Xi2)),d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_mul(d_mul(d_imul(4,Xi2),Xi),xi),d_mul(d_mul(d_imul(12,Xi2),xr),Xr)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_imul(6,Xi2),xr2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_mul(d_mul(d_imul(24,Xr),Xi),xr),xi)),d_mul(d_mul(d_imul(4,xi2),xi),Xi)),d_mul(d_mul(d_imul(12,xi),Xi),xr2)),d_mul(d_mul(d_imul(4,Xr2),Xr),xr)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(12,xi2),Xr),xr)),d_mul(d_mul(d_imul(4,xr2),xr),Xr)),d_mul(xi2,xi2)),d_mul(d_imul(6,xi2),xr2)),d_mul(xr2,xr2))),cr);
xin=d_add(d_add(d_mul(d_imul(4,xr),d_abs(d_add(d_sub(d_add(d_add(d_add(d_sub(d_add(d_add(d_sub(d_mul(d_neg(Xi2),Xi),d_mul(d_imul(3,xi),Xi2)),d_mul(Xr2,Xi)),d_mul(d_mul(d_imul(2,xr),Xr),Xi)),d_mul(d_imul(3,xi2),Xi)),d_mul(xr2,Xi)),d_mul(xi,Xr2)),d_mul(d_mul(d_imul(2,xr),xi),Xr)),d_mul(xi2,xi)),d_mul(xr2,xi)))),d_mul(d_imul(4,Xr),d_diffabs(d_add(d_mul(d_neg(Xi2),Xi),d_mul(Xr2,Xi)),d_add(d_sub(d_add(d_add(d_add(d_sub(d_add(d_mul(d_imul(-3,xi),Xi2),d_mul(d_mul(d_imul(2,xr),Xr),Xi)),d_mul(d_imul(3,xi2),Xi)),d_mul(xr2,Xi)),d_mul(xi,Xr2)),d_mul(d_mul(d_imul(2,xr),xi),Xr)),d_mul(xi2,xi)),d_mul(xr2,xi))))),ci);
}

);

static const char *perturbation_opencl_floatexp_37_4_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_add(fe_mul(Xr2,Xr2),fe_mul(Xi2,Xi2)),fe_mul(fe_imul(6,Xr2),Xi2)),fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi),fe_mul(fe_mul(fe_imul(12,Xi2),xr),Xr)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_imul(6,Xi2),xr2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),Xi),xr),xi)),fe_mul(fe_mul(fe_imul(4,xi2),xi),Xi)),fe_mul(fe_mul(fe_imul(12,xi),Xi),xr2)),fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(12,xi2),Xr),xr)),fe_mul(fe_mul(fe_imul(4,xr2),xr),Xr)),fe_mul(xi2,xi2)),fe_mul(fe_imul(6,xi2),xr2)),fe_mul(xr2,xr2))),cr);
xin=fe_add(fe_add(fe_mul(fe_imul(4,xr),fe_abs(fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_mul(fe_neg(Xi2),Xi),fe_mul(fe_imul(3,xi),Xi2)),fe_mul(Xr2,Xi)),fe_mul(fe_mul(fe_imul(2,xr),Xr),Xi)),fe_mul(fe_imul(3,xi2),Xi)),fe_mul(xr2,Xi)),fe_mul(xi,Xr2)),fe_mul(fe_mul(fe_imul(2,xr),xi),Xr)),fe_mul(xi2,xi)),fe_mul(xr2,xi)))),fe_mul(fe_imul(4,Xr),fe_diffabs(fe_add(fe_mul(fe_neg(Xi2),Xi),fe_mul(Xr2,Xi)),fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_add(fe_mul(fe_imul(-3,xi),Xi2),fe_mul(fe_mul(fe_imul(2,xr),Xr),Xi)),fe_mul(fe_imul(3,xi2),Xi)),fe_mul(xr2,Xi)),fe_mul(xi,Xr2)),fe_mul(fe_mul(fe_imul(2,xr),xi),Xr)),fe_mul(xi2,xi)),fe_mul(xr2,xi))))),ci);
}

);

static const char *perturbation_opencl_floatexp_37_4_1 = STR(

{dxan=fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dya,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),daa))));
dxbn=fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dyb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),dab))));
dyan=fe_add(dba,fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxi,fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(8,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxi,fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxi,fe_mul(Xxr,Xxr))))))))),fe_imul(4,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxi,fe_mul(Xxr,Xxr)))),dxa))))));
dybn=fe_add(dbb,fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxi,fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(8,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxi,fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxi,fe_mul(Xxr,Xxr))))))))),fe_imul(4,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxi,fe_mul(Xxr,Xxr)))),dxb))))));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_add(fe_mul(Xr2,Xr2),fe_mul(Xi2,Xi2)),fe_mul(fe_imul(6,Xr2),Xi2)),fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi),fe_mul(fe_mul(fe_imul(12,Xi2),xr),Xr)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_imul(6,Xi2),xr2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),Xi),xr),xi)),fe_mul(fe_mul(fe_imul(4,xi2),xi),Xi)),fe_mul(fe_mul(fe_imul(12,xi),Xi),xr2)),fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(12,xi2),Xr),xr)),fe_mul(fe_mul(fe_imul(4,xr2),xr),Xr)),fe_mul(xi2,xi2)),fe_mul(fe_imul(6,xi2),xr2)),fe_mul(xr2,xr2))),cr);
xin=fe_add(fe_add(fe_mul(fe_imul(4,xr),fe_abs(fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_mul(fe_neg(Xi2),Xi),fe_mul(fe_imul(3,xi),Xi2)),fe_mul(Xr2,Xi)),fe_mul(fe_mul(fe_imul(2,xr),Xr),Xi)),fe_mul(fe_imul(3,xi2),Xi)),fe_mul(xr2,Xi)),fe_mul(xi,Xr2)),fe_mul(fe_mul(fe_imul(2,xr),xi),Xr)),fe_mul(xi2,xi)),fe_mul(xr2,xi)))),fe_mul(fe_imul(4,Xr),fe_diffabs(fe_add(fe_mul(fe_neg(Xi2),Xi),fe_mul(Xr2,Xi)),fe_add(fe_sub(fe_add(fe_add(fe_add(fe_sub(fe_add(fe_mul(fe_imul(-3,xi),Xi2),fe_mul(fe_mul(fe_imul(2,xr),Xr),Xi)),fe_mul(fe_imul(3,xi2),Xi)),fe_mul(xr2,Xi)),fe_mul(xi,Xr2)),fe_mul(fe_mul(fe_imul(2,xr),xi),Xr)),fe_mul(xi2,xi)),fe_mul(xr2,xi))))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_37_4_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_diffabs(sf_sub(sf_add(sf_mul(Xr2,Xr2),sf_mul(Xi2,Xi2)),sf_mul(sf_imul(6,Xr2),Xi2)),sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_sub(sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi),sf_mul(sf_mul(sf_imul(12,Xi2),xr),Xr)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_imul(6,Xi2),xr2)),sf_mul(sf_mul(sf_imul(12,Xr2),Xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(24,Xr),Xi),xr),xi)),sf_mul(sf_mul(sf_imul(4,xi2),xi),Xi)),sf_mul(sf_mul(sf_imul(12,xi),Xi),xr2)),sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr)),sf_mul(sf_imul(6,Xr2),xi2)),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(12,xi2),Xr),xr)),sf_mul(sf_mul(sf_imul(4,xr2),xr),Xr)),sf_mul(xi2,xi2)),sf_mul(sf_imul(6,xi2),xr2)),sf_mul(xr2,xr2))),cr);
xin=sf_add(sf_add(sf_mul(sf_imul(4,xr),sf_abs(sf_add(sf_sub(sf_add(sf_add(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_mul(sf_neg(Xi2),Xi),sf_mul(sf_imul(3,xi),Xi2)),sf_mul(Xr2,Xi)),sf_mul(sf_mul(sf_imul(2,xr),Xr),Xi)),sf_mul(sf_imul(3,xi2),Xi)),sf_mul(xr2,Xi)),sf_mul(xi,Xr2)),sf_mul(sf_mul(sf_imul(2,xr),xi),Xr)),sf_mul(xi2,xi)),sf_mul(xr2,xi)))),sf_mul(sf_imul(4,Xr),sf_diffabs(sf_add(sf_mul(sf_neg(Xi2),Xi),sf_mul(Xr2,Xi)),sf_add(sf_sub(sf_add(sf_add(sf_add(sf_sub(sf_add(sf_mul(sf_imul(-3,xi),Xi2),sf_mul(sf_mul(sf_imul(2,xr),Xr),Xi)),sf_mul(sf_imul(3,xi2),Xi)),sf_mul(xr2,Xi)),sf_mul(xi,Xr2)),sf_mul(sf_mul(sf_imul(2,xr),xi),Xr)),sf_mul(xi2,xi)),sf_mul(xr2,xi))))),ci);
}

);
#endif


static const char *perturbation_opencl_double_38_4_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_diffabs(d_sub(d_add(d_mul(Xr2,Xr2),d_mul(Xi2,Xi2)),d_mul(d_imul(6,Xr2),Xi2)),d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_mul(d_mul(d_imul(4,Xi2),Xi),xi),d_mul(d_mul(d_imul(12,Xi2),xr),Xr)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_imul(6,Xi2),xr2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_mul(d_mul(d_imul(24,Xr),Xi),xr),xi)),d_mul(d_mul(d_imul(4,xi2),xi),Xi)),d_mul(d_mul(d_imul(12,xi),Xi),xr2)),d_mul(d_mul(d_imul(4,Xr2),Xr),xr)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(12,xi2),Xr),xr)),d_mul(d_mul(d_imul(4,xr2),xr),Xr)),d_mul(xi2,xi2)),d_mul(d_imul(6,xi2),xr2)),d_mul(xr2,xr2))),cr);
xin=d_add(d_sub(d_mul(d_imul(-4,Xi),d_diffabs(d_sub(d_mul(Xr2,Xr),d_mul(Xr,Xi2)),d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_mul(d_neg(xr),Xi2),d_mul(d_mul(d_imul(2,xi),Xr),Xi)),d_mul(d_mul(d_imul(2,xr),xi),Xi)),d_mul(d_imul(3,xr),Xr2)),d_mul(xi2,Xr)),d_mul(d_imul(3,xr2),Xr)),d_mul(xr,xi2)),d_mul(xr2,xr)))),d_mul(d_imul(4,xi),d_abs(d_add(d_sub(d_add(d_sub(d_add(d_add(d_sub(d_sub(d_sub(d_mul(d_neg(Xr),Xi2),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xi),Xr),Xi)),d_mul(d_mul(d_imul(2,xr),xi),Xi)),d_mul(Xr2,Xr)),d_mul(d_imul(3,xr),Xr2)),d_mul(xi2,Xr)),d_mul(d_imul(3,xr2),Xr)),d_mul(xr,xi2)),d_mul(xr2,xr))))),ci);
}

);

static const char *perturbation_opencl_double_38_4_1 = STR(

{dxan=d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dya,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),daa))));
dxbn=d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dyb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),dab))));
dyan=d_add(dba,d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxa,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr))))))))),d_add(d_imul(8,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr))))))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr))))))))),d_imul(-4,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr)))),dya))))));
dybn=d_add(dbb,d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr))))))))),d_add(d_imul(8,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr))))))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr))))))))),d_imul(-4,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr)))),dyb))))));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_diffabs(d_sub(d_add(d_mul(Xr2,Xr2),d_mul(Xi2,Xi2)),d_mul(d_imul(6,Xr2),Xi2)),d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_mul(d_mul(d_imul(4,Xi2),Xi),xi),d_mul(d_mul(d_imul(12,Xi2),xr),Xr)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_imul(6,Xi2),xr2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_mul(d_mul(d_imul(24,Xr),Xi),xr),xi)),d_mul(d_mul(d_imul(4,xi2),xi),Xi)),d_mul(d_mul(d_imul(12,xi),Xi),xr2)),d_mul(d_mul(d_imul(4,Xr2),Xr),xr)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(12,xi2),Xr),xr)),d_mul(d_mul(d_imul(4,xr2),xr),Xr)),d_mul(xi2,xi2)),d_mul(d_imul(6,xi2),xr2)),d_mul(xr2,xr2))),cr);
xin=d_add(d_sub(d_mul(d_imul(-4,Xi),d_diffabs(d_sub(d_mul(Xr2,Xr),d_mul(Xr,Xi2)),d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_mul(d_neg(xr),Xi2),d_mul(d_mul(d_imul(2,xi),Xr),Xi)),d_mul(d_mul(d_imul(2,xr),xi),Xi)),d_mul(d_imul(3,xr),Xr2)),d_mul(xi2,Xr)),d_mul(d_imul(3,xr2),Xr)),d_mul(xr,xi2)),d_mul(xr2,xr)))),d_mul(d_imul(4,xi),d_abs(d_add(d_sub(d_add(d_sub(d_add(d_add(d_sub(d_sub(d_sub(d_mul(d_neg(Xr),Xi2),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xi),Xr),Xi)),d_mul(d_mul(d_imul(2,xr),xi),Xi)),d_mul(Xr2,Xr)),d_mul(d_imul(3,xr),Xr2)),d_mul(xi2,Xr)),d_mul(d_imul(3,xr2),Xr)),d_mul(xr,xi2)),d_mul(xr2,xr))))),ci);
}

);

static const char *perturbation_opencl_floatexp_38_4_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_add(fe_mul(Xr2,Xr2),fe_mul(Xi2,Xi2)),fe_mul(fe_imul(6,Xr2),Xi2)),fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi),fe_mul(fe_mul(fe_imul(12,Xi2),xr),Xr)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_imul(6,Xi2),xr2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),Xi),xr),xi)),fe_mul(fe_mul(fe_imul(4,xi2),xi),Xi)),fe_mul(fe_mul(fe_imul(12,xi),Xi),xr2)),fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(12,xi2),Xr),xr)),fe_mul(fe_mul(fe_imul(4,xr2),xr),Xr)),fe_mul(xi2,xi2)),fe_mul(fe_imul(6,xi2),xr2)),fe_mul(xr2,xr2))),cr);
xin=fe_add(fe_sub(fe_mul(fe_imul(-4,Xi),fe_diffabs(fe_sub(fe_mul(Xr2,Xr),fe_mul(Xr,Xi2)),fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_mul(fe_neg(xr),Xi2),fe_mul(fe_mul(fe_imul(2,xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(2,xr),xi),Xi)),fe_mul(fe_imul(3,xr),Xr2)),fe_mul(xi2,Xr)),fe_mul(fe_imul(3,xr2),Xr)),fe_mul(xr,xi2)),fe_mul(xr2,xr)))),fe_mul(fe_imul(4,xi),fe_abs(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_mul(fe_neg(Xr),Xi2),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(2,xr),xi),Xi)),fe_mul(Xr2,Xr)),fe_mul(fe_imul(3,xr),Xr2)),fe_mul(xi2,Xr)),fe_mul(fe_imul(3,xr2),Xr)),fe_mul(xr,xi2)),fe_mul(xr2,xr))))),ci);
}

);

static const char *perturbation_opencl_floatexp_38_4_1 = STR(

{dxan=fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dya,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),daa))));
dxbn=fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dyb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),dab))));
dyan=fe_add(dba,fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxa,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(8,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))),fe_imul(-4,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr)))),dya))))));
dybn=fe_add(dbb,fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(8,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))),fe_imul(-4,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr)))),dyb))))));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_add(fe_mul(Xr2,Xr2),fe_mul(Xi2,Xi2)),fe_mul(fe_imul(6,Xr2),Xi2)),fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi),fe_mul(fe_mul(fe_imul(12,Xi2),xr),Xr)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_imul(6,Xi2),xr2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),Xi),xr),xi)),fe_mul(fe_mul(fe_imul(4,xi2),xi),Xi)),fe_mul(fe_mul(fe_imul(12,xi),Xi),xr2)),fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(12,xi2),Xr),xr)),fe_mul(fe_mul(fe_imul(4,xr2),xr),Xr)),fe_mul(xi2,xi2)),fe_mul(fe_imul(6,xi2),xr2)),fe_mul(xr2,xr2))),cr);
xin=fe_add(fe_sub(fe_mul(fe_imul(-4,Xi),fe_diffabs(fe_sub(fe_mul(Xr2,Xr),fe_mul(Xr,Xi2)),fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_mul(fe_neg(xr),Xi2),fe_mul(fe_mul(fe_imul(2,xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(2,xr),xi),Xi)),fe_mul(fe_imul(3,xr),Xr2)),fe_mul(xi2,Xr)),fe_mul(fe_imul(3,xr2),Xr)),fe_mul(xr,xi2)),fe_mul(xr2,xr)))),fe_mul(fe_imul(4,xi),fe_abs(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_mul(fe_neg(Xr),Xi2),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(2,xr),xi),Xi)),fe_mul(Xr2,Xr)),fe_mul(fe_imul(3,xr),Xr2)),fe_mul(xi2,Xr)),fe_mul(fe_imul(3,xr2),Xr)),fe_mul(xr,xi2)),fe_mul(xr2,xr))))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_38_4_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_diffabs(sf_sub(sf_add(sf_mul(Xr2,Xr2),sf_mul(Xi2,Xi2)),sf_mul(sf_imul(6,Xr2),Xi2)),sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_sub(sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi),sf_mul(sf_mul(sf_imul(12,Xi2),xr),Xr)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_imul(6,Xi2),xr2)),sf_mul(sf_mul(sf_imul(12,Xr2),Xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(24,Xr),Xi),xr),xi)),sf_mul(sf_mul(sf_imul(4,xi2),xi),Xi)),sf_mul(sf_mul(sf_imul(12,xi),Xi),xr2)),sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr)),sf_mul(sf_imul(6,Xr2),xi2)),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(12,xi2),Xr),xr)),sf_mul(sf_mul(sf_imul(4,xr2),xr),Xr)),sf_mul(xi2,xi2)),sf_mul(sf_imul(6,xi2),xr2)),sf_mul(xr2,xr2))),cr);
xin=sf_add(sf_sub(sf_mul(sf_imul(-4,Xi),sf_diffabs(sf_sub(sf_mul(Xr2,Xr),sf_mul(Xr,Xi2)),sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_mul(sf_neg(xr),Xi2),sf_mul(sf_mul(sf_imul(2,xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(2,xr),xi),Xi)),sf_mul(sf_imul(3,xr),Xr2)),sf_mul(xi2,Xr)),sf_mul(sf_imul(3,xr2),Xr)),sf_mul(xr,xi2)),sf_mul(xr2,xr)))),sf_mul(sf_imul(4,xi),sf_abs(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_mul(sf_neg(Xr),Xi2),sf_mul(xr,Xi2)),sf_mul(sf_mul(sf_imul(2,xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(2,xr),xi),Xi)),sf_mul(Xr2,Xr)),sf_mul(sf_imul(3,xr),Xr2)),sf_mul(xi2,Xr)),sf_mul(sf_imul(3,xr2),Xr)),sf_mul(xr,xi2)),sf_mul(xr2,xr))))),ci);
}

);
#endif


static const char *perturbation_opencl_double_39_4_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_diffabs(d_sub(d_add(d_mul(Xr2,Xr2),d_mul(Xi2,Xi2)),d_mul(d_imul(6,Xr2),Xi2)),d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_mul(d_mul(d_imul(4,Xi2),Xi),xi),d_mul(d_mul(d_imul(12,Xi2),xr),Xr)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_imul(6,Xi2),xr2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_mul(d_mul(d_imul(24,Xr),Xi),xr),xi)),d_mul(d_mul(d_imul(4,xi2),xi),Xi)),d_mul(d_mul(d_imul(12,xi),Xi),xr2)),d_mul(d_mul(d_imul(4,Xr2),Xr),xr)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(12,xi2),Xr),xr)),d_mul(d_mul(d_imul(4,xr2),xr),Xr)),d_mul(xi2,xi2)),d_mul(d_imul(6,xi2),xr2)),d_mul(xr2,xr2))),cr);
xin=d_add(d_add(d_mul(d_imul(4,Xi),d_diffabs(d_sub(d_mul(Xr2,Xr),d_mul(Xr,Xi2)),d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_mul(d_neg(xr),Xi2),d_mul(d_mul(d_imul(2,xi),Xr),Xi)),d_mul(d_mul(d_imul(2,xr),xi),Xi)),d_mul(d_imul(3,xr),Xr2)),d_mul(xi2,Xr)),d_mul(d_imul(3,xr2),Xr)),d_mul(xr,xi2)),d_mul(xr2,xr)))),d_mul(d_imul(4,xi),d_abs(d_add(d_sub(d_add(d_sub(d_add(d_add(d_sub(d_sub(d_sub(d_mul(d_neg(Xr),Xi2),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xi),Xr),Xi)),d_mul(d_mul(d_imul(2,xr),xi),Xi)),d_mul(Xr2,Xr)),d_mul(d_imul(3,xr),Xr2)),d_mul(xi2,Xr)),d_mul(d_imul(3,xr2),Xr)),d_mul(xr,xi2)),d_mul(xr2,xr))))),ci);
}

);

static const char *perturbation_opencl_double_39_4_1 = STR(

{dxan=d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dya,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),daa))));
dxbn=d_add(d_imul(4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dyb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(4,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,Xxr)))),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),dab))));
dyan=d_add(dba,d_add(d_imul(-4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxa,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr))))))))),d_add(d_imul(-8,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr))))))))),d_add(d_imul(12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr))))))))),d_imul(4,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr)))),dya))))));
dybn=d_add(dbb,d_add(d_imul(-4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr))))))))),d_add(d_imul(-8,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr))))))))),d_add(d_imul(12,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr))))))))),d_imul(4,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,Xxr)))),dyb))))));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_diffabs(d_sub(d_add(d_mul(Xr2,Xr2),d_mul(Xi2,Xi2)),d_mul(d_imul(6,Xr2),Xi2)),d_add(d_sub(d_add(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_sub(d_add(d_sub(d_mul(d_mul(d_imul(4,Xi2),Xi),xi),d_mul(d_mul(d_imul(12,Xi2),xr),Xr)),d_mul(d_imul(6,Xi2),xi2)),d_mul(d_imul(6,Xi2),xr2)),d_mul(d_mul(d_imul(12,Xr2),Xi),xi)),d_mul(d_mul(d_mul(d_imul(24,Xr),Xi),xr),xi)),d_mul(d_mul(d_imul(4,xi2),xi),Xi)),d_mul(d_mul(d_imul(12,xi),Xi),xr2)),d_mul(d_mul(d_imul(4,Xr2),Xr),xr)),d_mul(d_imul(6,Xr2),xi2)),d_mul(d_imul(6,Xr2),xr2)),d_mul(d_mul(d_imul(12,xi2),Xr),xr)),d_mul(d_mul(d_imul(4,xr2),xr),Xr)),d_mul(xi2,xi2)),d_mul(d_imul(6,xi2),xr2)),d_mul(xr2,xr2))),cr);
xin=d_add(d_add(d_mul(d_imul(4,Xi),d_diffabs(d_sub(d_mul(Xr2,Xr),d_mul(Xr,Xi2)),d_add(d_sub(d_add(d_sub(d_add(d_sub(d_sub(d_mul(d_neg(xr),Xi2),d_mul(d_mul(d_imul(2,xi),Xr),Xi)),d_mul(d_mul(d_imul(2,xr),xi),Xi)),d_mul(d_imul(3,xr),Xr2)),d_mul(xi2,Xr)),d_mul(d_imul(3,xr2),Xr)),d_mul(xr,xi2)),d_mul(xr2,xr)))),d_mul(d_imul(4,xi),d_abs(d_add(d_sub(d_add(d_sub(d_add(d_add(d_sub(d_sub(d_sub(d_mul(d_neg(Xr),Xi2),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xi),Xr),Xi)),d_mul(d_mul(d_imul(2,xr),xi),Xi)),d_mul(Xr2,Xr)),d_mul(d_imul(3,xr),Xr2)),d_mul(xi2,Xr)),d_mul(d_imul(3,xr2),Xr)),d_mul(xr,xi2)),d_mul(xr2,xr))))),ci);
}

);

static const char *perturbation_opencl_floatexp_39_4_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_add(fe_mul(Xr2,Xr2),fe_mul(Xi2,Xi2)),fe_mul(fe_imul(6,Xr2),Xi2)),fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi),fe_mul(fe_mul(fe_imul(12,Xi2),xr),Xr)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_imul(6,Xi2),xr2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),Xi),xr),xi)),fe_mul(fe_mul(fe_imul(4,xi2),xi),Xi)),fe_mul(fe_mul(fe_imul(12,xi),Xi),xr2)),fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(12,xi2),Xr),xr)),fe_mul(fe_mul(fe_imul(4,xr2),xr),Xr)),fe_mul(xi2,xi2)),fe_mul(fe_imul(6,xi2),xr2)),fe_mul(xr2,xr2))),cr);
xin=fe_add(fe_add(fe_mul(fe_imul(4,Xi),fe_diffabs(fe_sub(fe_mul(Xr2,Xr),fe_mul(Xr,Xi2)),fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_mul(fe_neg(xr),Xi2),fe_mul(fe_mul(fe_imul(2,xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(2,xr),xi),Xi)),fe_mul(fe_imul(3,xr),Xr2)),fe_mul(xi2,Xr)),fe_mul(fe_imul(3,xr2),Xr)),fe_mul(xr,xi2)),fe_mul(xr2,xr)))),fe_mul(fe_imul(4,xi),fe_abs(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_mul(fe_neg(Xr),Xi2),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(2,xr),xi),Xi)),fe_mul(Xr2,Xr)),fe_mul(fe_imul(3,xr),Xr2)),fe_mul(xi2,Xr)),fe_mul(fe_imul(3,xr2),Xr)),fe_mul(xr,xi2)),fe_mul(xr2,xr))))),ci);
}

);

static const char *perturbation_opencl_floatexp_39_4_1 = STR(

{dxan=fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dya,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),daa))));
dxbn=fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dyb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,Xxr)))),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),dab))));
dyan=fe_add(dba,fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxa,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(-8,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))),fe_imul(4,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr)))),dya))))));
dybn=fe_add(dbb,fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(-8,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(12,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))),fe_imul(4,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,Xxr)))),dyb))))));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_diffabs(fe_sub(fe_add(fe_mul(Xr2,Xr2),fe_mul(Xi2,Xi2)),fe_mul(fe_imul(6,Xr2),Xi2)),fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_sub(fe_mul(fe_mul(fe_imul(4,Xi2),Xi),xi),fe_mul(fe_mul(fe_imul(12,Xi2),xr),Xr)),fe_mul(fe_imul(6,Xi2),xi2)),fe_mul(fe_imul(6,Xi2),xr2)),fe_mul(fe_mul(fe_imul(12,Xr2),Xi),xi)),fe_mul(fe_mul(fe_mul(fe_imul(24,Xr),Xi),xr),xi)),fe_mul(fe_mul(fe_imul(4,xi2),xi),Xi)),fe_mul(fe_mul(fe_imul(12,xi),Xi),xr2)),fe_mul(fe_mul(fe_imul(4,Xr2),Xr),xr)),fe_mul(fe_imul(6,Xr2),xi2)),fe_mul(fe_imul(6,Xr2),xr2)),fe_mul(fe_mul(fe_imul(12,xi2),Xr),xr)),fe_mul(fe_mul(fe_imul(4,xr2),xr),Xr)),fe_mul(xi2,xi2)),fe_mul(fe_imul(6,xi2),xr2)),fe_mul(xr2,xr2))),cr);
xin=fe_add(fe_add(fe_mul(fe_imul(4,Xi),fe_diffabs(fe_sub(fe_mul(Xr2,Xr),fe_mul(Xr,Xi2)),fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_sub(fe_mul(fe_neg(xr),Xi2),fe_mul(fe_mul(fe_imul(2,xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(2,xr),xi),Xi)),fe_mul(fe_imul(3,xr),Xr2)),fe_mul(xi2,Xr)),fe_mul(fe_imul(3,xr2),Xr)),fe_mul(xr,xi2)),fe_mul(xr2,xr)))),fe_mul(fe_imul(4,xi),fe_abs(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_mul(fe_neg(Xr),Xi2),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xi),Xr),Xi)),fe_mul(fe_mul(fe_imul(2,xr),xi),Xi)),fe_mul(Xr2,Xr)),fe_mul(fe_imul(3,xr),Xr2)),fe_mul(xi2,Xr)),fe_mul(fe_imul(3,xr2),Xr)),fe_mul(xr,xi2)),fe_mul(xr2,xr))))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_39_4_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_diffabs(sf_sub(sf_add(sf_mul(Xr2,Xr2),sf_mul(Xi2,Xi2)),sf_mul(sf_imul(6,Xr2),Xi2)),sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_sub(sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi),sf_mul(sf_mul(sf_imul(12,Xi2),xr),Xr)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_imul(6,Xi2),xr2)),sf_mul(sf_mul(sf_imul(12,Xr2),Xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(24,Xr),Xi),xr),xi)),sf_mul(sf_mul(sf_imul(4,xi2),xi),Xi)),sf_mul(sf_mul(sf_imul(12,xi),Xi),xr2)),sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr)),sf_mul(sf_imul(6,Xr2),xi2)),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(12,xi2),Xr),xr)),sf_mul(sf_mul(sf_imul(4,xr2),xr),Xr)),sf_mul(xi2,xi2)),sf_mul(sf_imul(6,xi2),xr2)),sf_mul(xr2,xr2))),cr);
xin=sf_add(sf_add(sf_mul(sf_imul(4,Xi),sf_diffabs(sf_sub(sf_mul(Xr2,Xr),sf_mul(Xr,Xi2)),sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_mul(sf_neg(xr),Xi2),sf_mul(sf_mul(sf_imul(2,xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(2,xr),xi),Xi)),sf_mul(sf_imul(3,xr),Xr2)),sf_mul(xi2,Xr)),sf_mul(sf_imul(3,xr2),Xr)),sf_mul(xr,xi2)),sf_mul(xr2,xr)))),sf_mul(sf_imul(4,xi),sf_abs(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_mul(sf_neg(Xr),Xi2),sf_mul(xr,Xi2)),sf_mul(sf_mul(sf_imul(2,xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(2,xr),xi),Xi)),sf_mul(Xr2,Xr)),sf_mul(sf_imul(3,xr),Xr2)),sf_mul(xi2,Xr)),sf_mul(sf_imul(3,xr2),Xr)),sf_mul(xr,xi2)),sf_mul(xr2,xr))))),ci);
}

);
#endif


static const char *perturbation_opencl_double_40_6_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_add(d_sub(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_add(d_sub(d_sub(d_add(d_sub(d_add(d_sub(d_mul(d_imul(3,d_diffabs(d_mul(Xr2,Xi),d_add(d_add(d_add(d_add(d_mul(Xr2,xi),d_mul(d_mul(d_imul(2,Xr),xr),Xi)),d_mul(d_mul(d_imul(2,Xr),xr),xi)),d_mul(xr2,Xi)),d_mul(xr2,xi)))),d_mul(Xi2,Xi)),d_mul(d_diffabs(d_mul(Xi2,Xi),d_add(d_add(d_mul(d_imul(3,Xi2),xi),d_mul(d_imul(3,Xi),xi2)),d_mul(xi2,xi))),d_mul(Xi2,Xi))),d_mul(d_imul(9,d_diffabs(d_mul(Xr,Xi2),d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(2,Xr),Xi),xi),d_mul(Xr,xi2)),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xr),Xi),xi)),d_mul(xr,xi2)))),d_mul(Xr,Xi2))),d_mul(d_imul(3,d_diffabs(d_mul(Xr2,Xr),d_add(d_add(d_mul(d_imul(3,Xr2),xr),d_mul(d_imul(3,Xr),xr2)),d_mul(xr2,xr)))),d_mul(Xr,Xi2))),d_mul(d_imul(3,d_diffabs(d_mul(Xi2,Xi),d_add(d_add(d_mul(d_imul(3,Xi2),xi),d_mul(d_imul(3,Xi),xi2)),d_mul(xi2,xi)))),d_mul(Xr2,Xi))),d_mul(d_imul(9,d_diffabs(d_mul(Xr2,Xi),d_add(d_add(d_add(d_add(d_mul(Xr2,xi),d_mul(d_mul(d_imul(2,Xr),xr),Xi)),d_mul(d_mul(d_imul(2,Xr),xr),xi)),d_mul(xr2,Xi)),d_mul(xr2,xi)))),d_mul(Xr2,Xi))),d_mul(d_imul(3,d_diffabs(d_mul(Xr,Xi2),d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(2,Xr),Xi),xi),d_mul(Xr,xi2)),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xr),Xi),xi)),d_mul(xr,xi2)))),d_mul(Xr2,Xr))),d_mul(d_diffabs(d_mul(Xr2,Xr),d_add(d_add(d_mul(d_imul(3,Xr2),xr),d_mul(d_imul(3,Xr),xr2)),d_mul(xr2,xr))),d_mul(Xr2,Xr))),d_mul(d_imul(3,d_abs(d_add(d_add(d_add(d_add(d_add(d_mul(Xr2,Xi),d_mul(Xr2,xi)),d_mul(d_mul(d_imul(2,Xr),xr),Xi)),d_mul(d_mul(d_imul(2,Xr),xr),xi)),d_mul(xr2,Xi)),d_mul(xr2,xi)))),d_add(d_add(d_mul(d_imul(3,Xi2),xi),d_mul(d_imul(3,Xi),xi2)),d_mul(xi2,xi)))),d_mul(d_abs(d_add(d_add(d_add(d_mul(Xi2,Xi),d_mul(d_imul(3,Xi2),xi)),d_mul(d_imul(3,Xi),xi2)),d_mul(xi2,xi))),d_add(d_add(d_mul(d_imul(3,Xi2),xi),d_mul(d_imul(3,Xi),xi2)),d_mul(xi2,xi)))),d_mul(d_imul(9,d_abs(d_add(d_add(d_add(d_add(d_add(d_mul(Xr,Xi2),d_mul(d_mul(d_imul(2,Xr),Xi),xi)),d_mul(Xr,xi2)),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xr),Xi),xi)),d_mul(xr,xi2)))),d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(2,Xr),Xi),xi),d_mul(Xr,xi2)),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xr),Xi),xi)),d_mul(xr,xi2)))),d_mul(d_imul(3,d_abs(d_add(d_add(d_add(d_mul(Xr2,Xr),d_mul(d_imul(3,Xr2),xr)),d_mul(d_imul(3,Xr),xr2)),d_mul(xr2,xr)))),d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(2,Xr),Xi),xi),d_mul(Xr,xi2)),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xr),Xi),xi)),d_mul(xr,xi2)))),d_mul(d_imul(3,d_abs(d_add(d_add(d_add(d_mul(Xi2,Xi),d_mul(d_imul(3,Xi2),xi)),d_mul(d_imul(3,Xi),xi2)),d_mul(xi2,xi)))),d_add(d_add(d_add(d_add(d_mul(Xr2,xi),d_mul(d_mul(d_imul(2,Xr),xr),Xi)),d_mul(d_mul(d_imul(2,Xr),xr),xi)),d_mul(xr2,Xi)),d_mul(xr2,xi)))),d_mul(d_imul(9,d_abs(d_add(d_add(d_add(d_add(d_add(d_mul(Xr2,Xi),d_mul(Xr2,xi)),d_mul(d_mul(d_imul(2,Xr),xr),Xi)),d_mul(d_mul(d_imul(2,Xr),xr),xi)),d_mul(xr2,Xi)),d_mul(xr2,xi)))),d_add(d_add(d_add(d_add(d_mul(Xr2,xi),d_mul(d_mul(d_imul(2,Xr),xr),Xi)),d_mul(d_mul(d_imul(2,Xr),xr),xi)),d_mul(xr2,Xi)),d_mul(xr2,xi)))),d_mul(d_imul(3,d_abs(d_add(d_add(d_add(d_add(d_add(d_mul(Xr,Xi2),d_mul(d_mul(d_imul(2,Xr),Xi),xi)),d_mul(Xr,xi2)),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xr),Xi),xi)),d_mul(xr,xi2)))),d_add(d_add(d_mul(d_imul(3,Xr2),xr),d_mul(d_imul(3,Xr),xr2)),d_mul(xr2,xr)))),d_mul(d_abs(d_add(d_add(d_add(d_mul(Xr2,Xr),d_mul(d_imul(3,Xr2),xr)),d_mul(d_imul(3,Xr),xr2)),d_mul(xr2,xr))),d_add(d_add(d_mul(d_imul(3,Xr2),xr),d_mul(d_imul(3,Xr),xr2)),d_mul(xr2,xr)))),cr);
xin=d_add(d_add(d_sub(d_add(d_add(d_sub(d_sub(d_sub(d_add(d_add(d_sub(d_add(d_add(d_sub(d_sub(d_sub(d_mul(d_imul(3,d_diffabs(d_mul(Xr,Xi2),d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(2,Xr),Xi),xi),d_mul(Xr,xi2)),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xr),Xi),xi)),d_mul(xr,xi2)))),d_mul(Xi2,Xi)),d_mul(d_diffabs(d_mul(Xr2,Xr),d_add(d_add(d_mul(d_imul(3,Xr2),xr),d_mul(d_imul(3,Xr),xr2)),d_mul(xr2,xr))),d_mul(Xi2,Xi))),d_mul(d_imul(9,d_diffabs(d_mul(Xr2,Xi),d_add(d_add(d_add(d_add(d_mul(Xr2,xi),d_mul(d_mul(d_imul(2,Xr),xr),Xi)),d_mul(d_mul(d_imul(2,Xr),xr),xi)),d_mul(xr2,Xi)),d_mul(xr2,xi)))),d_mul(Xr,Xi2))),d_mul(d_imul(9,d_diffabs(d_mul(Xr,Xi2),d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(2,Xr),Xi),xi),d_mul(Xr,xi2)),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xr),Xi),xi)),d_mul(xr,xi2)))),d_mul(Xr2,Xi))),d_mul(d_imul(3,d_diffabs(d_mul(Xr2,Xr),d_add(d_add(d_mul(d_imul(3,Xr2),xr),d_mul(d_imul(3,Xr),xr2)),d_mul(xr2,xr)))),d_mul(Xr2,Xi))),d_mul(d_imul(3,d_diffabs(d_mul(Xi2,Xi),d_add(d_add(d_mul(d_imul(3,Xi2),xi),d_mul(d_imul(3,Xi),xi2)),d_mul(xi2,xi)))),d_mul(Xr,Xi2))),d_mul(d_diffabs(d_mul(Xi2,Xi),d_add(d_add(d_mul(d_imul(3,Xi2),xi),d_mul(d_imul(3,Xi),xi2)),d_mul(xi2,xi))),d_mul(Xr2,Xr))),d_mul(d_imul(3,d_diffabs(d_mul(Xr2,Xi),d_add(d_add(d_add(d_add(d_mul(Xr2,xi),d_mul(d_mul(d_imul(2,Xr),xr),Xi)),d_mul(d_mul(d_imul(2,Xr),xr),xi)),d_mul(xr2,Xi)),d_mul(xr2,xi)))),d_mul(Xr2,Xr))),d_mul(d_imul(3,d_abs(d_add(d_add(d_add(d_add(d_add(d_mul(Xr,Xi2),d_mul(d_mul(d_imul(2,Xr),Xi),xi)),d_mul(Xr,xi2)),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xr),Xi),xi)),d_mul(xr,xi2)))),d_add(d_add(d_mul(d_imul(3,Xi2),xi),d_mul(d_imul(3,Xi),xi2)),d_mul(xi2,xi)))),d_mul(d_abs(d_add(d_add(d_add(d_mul(Xr2,Xr),d_mul(d_imul(3,Xr2),xr)),d_mul(d_imul(3,Xr),xr2)),d_mul(xr2,xr))),d_add(d_add(d_mul(d_imul(3,Xi2),xi),d_mul(d_imul(3,Xi),xi2)),d_mul(xi2,xi)))),d_mul(d_imul(9,d_abs(d_add(d_add(d_add(d_add(d_add(d_mul(Xr2,Xi),d_mul(Xr2,xi)),d_mul(d_mul(d_imul(2,Xr),xr),Xi)),d_mul(d_mul(d_imul(2,Xr),xr),xi)),d_mul(xr2,Xi)),d_mul(xr2,xi)))),d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(2,Xr),Xi),xi),d_mul(Xr,xi2)),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xr),Xi),xi)),d_mul(xr,xi2)))),d_mul(d_imul(9,d_abs(d_add(d_add(d_add(d_add(d_add(d_mul(Xr,Xi2),d_mul(d_mul(d_imul(2,Xr),Xi),xi)),d_mul(Xr,xi2)),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xr),Xi),xi)),d_mul(xr,xi2)))),d_add(d_add(d_add(d_add(d_mul(Xr2,xi),d_mul(d_mul(d_imul(2,Xr),xr),Xi)),d_mul(d_mul(d_imul(2,Xr),xr),xi)),d_mul(xr2,Xi)),d_mul(xr2,xi)))),d_mul(d_imul(3,d_abs(d_add(d_add(d_add(d_mul(Xr2,Xr),d_mul(d_imul(3,Xr2),xr)),d_mul(d_imul(3,Xr),xr2)),d_mul(xr2,xr)))),d_add(d_add(d_add(d_add(d_mul(Xr2,xi),d_mul(d_mul(d_imul(2,Xr),xr),Xi)),d_mul(d_mul(d_imul(2,Xr),xr),xi)),d_mul(xr2,Xi)),d_mul(xr2,xi)))),d_mul(d_imul(3,d_abs(d_add(d_add(d_add(d_mul(Xi2,Xi),d_mul(d_imul(3,Xi2),xi)),d_mul(d_imul(3,Xi),xi2)),d_mul(xi2,xi)))),d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(2,Xr),Xi),xi),d_mul(Xr,xi2)),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xr),Xi),xi)),d_mul(xr,xi2)))),d_mul(d_abs(d_add(d_add(d_add(d_mul(Xi2,Xi),d_mul(d_imul(3,Xi2),xi)),d_mul(d_imul(3,Xi),xi2)),d_mul(xi2,xi))),d_add(d_add(d_mul(d_imul(3,Xr2),xr),d_mul(d_imul(3,Xr),xr2)),d_mul(xr2,xr)))),d_mul(d_imul(3,d_abs(d_add(d_add(d_add(d_add(d_add(d_mul(Xr2,Xi),d_mul(Xr2,xi)),d_mul(d_mul(d_imul(2,Xr),xr),Xi)),d_mul(d_mul(d_imul(2,Xr),xr),xi)),d_mul(xr2,Xi)),d_mul(xr2,xi)))),d_add(d_add(d_mul(d_imul(3,Xr2),xr),d_mul(d_imul(3,Xr),xr2)),d_mul(xr2,xr)))),ci);
}

);

static const char *perturbation_opencl_double_40_6_1 = STR(

{dxan=d_add(d_imul(3,d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxr,d_mul(Xxr,dya)))),d_add(d_imul(3,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(Xxr,d_mul(Xxr,dxa)))),d_add(d_imul(3,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr)))))))))),d_add(d_imul(-3,d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxi,d_mul(Xxi,dya)))),d_add(d_imul(-3,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(Xxi,d_mul(Xxi,dxa)))),d_add(d_imul(-3,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr)))))))))),d_add(d_imul(3,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(Xxr)))))))))),d_add(d_imul(-3,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dya,d_sgn(Xxi)))))))))),d_add(d_imul(-6,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(Xxi,d_mul(Xxr,dya)))),d_add(d_imul(6,d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxi,d_mul(Xxr,dxa)))),d_add(d_imul(-6,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(Xxr)))))))))),d_add(d_imul(6,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr)))))))))),d_add(d_imul(-9,d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,dxa)))),d_add(d_imul(-9,d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxr,d_mul(Xxr,dya)))),d_add(d_imul(-9,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(Xxr)))))))))),d_add(d_imul(9,d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxi,d_mul(Xxi,dxa)))),d_add(d_imul(9,d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxi,d_mul(Xxi,dya)))),d_add(d_imul(-9,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr)))))))))),d_add(d_imul(9,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr)))))))))),d_add(d_imul(9,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(Xxi)))))))))),d_add(d_imul(18,d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxi,d_mul(Xxr,dya)))),d_add(d_imul(-18,d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxi,d_mul(Xxr,dxa)))),d_add(d_imul(-18,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr)))))))))),d_add(d_imul(18,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(Xxr)))))))))),daa))))))))))))))))))))))));
dxbn=d_add(d_imul(3,d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxr,d_mul(Xxr,dyb)))),d_add(d_imul(3,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(Xxr,d_mul(Xxr,dxb)))),d_add(d_imul(3,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr)))))))))),d_add(d_imul(-3,d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxi,d_mul(Xxi,dyb)))),d_add(d_imul(-3,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(Xxi,d_mul(Xxi,dxb)))),d_add(d_imul(-3,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr)))))))))),d_add(d_imul(3,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(Xxr)))))))))),d_add(d_imul(-3,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dyb,d_sgn(Xxi)))))))))),d_add(d_imul(-6,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(Xxi,d_mul(Xxr,dyb)))),d_add(d_imul(6,d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxi,d_mul(Xxr,dxb)))),d_add(d_imul(-6,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(Xxr)))))))))),d_add(d_imul(6,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr)))))))))),d_add(d_imul(-9,d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,dxb)))),d_add(d_imul(-9,d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxr,d_mul(Xxr,dyb)))),d_add(d_imul(-9,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(Xxr)))))))))),d_add(d_imul(9,d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxi,d_mul(Xxi,dxb)))),d_add(d_imul(9,d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxi,d_mul(Xxi,dyb)))),d_add(d_imul(-9,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr)))))))))),d_add(d_imul(9,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr)))))))))),d_add(d_imul(9,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(Xxi)))))))))),d_add(d_imul(18,d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxi,d_mul(Xxr,dyb)))),d_add(d_imul(-18,d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxi,d_mul(Xxr,dxb)))),d_add(d_imul(-18,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr)))))))))),d_add(d_imul(18,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(Xxr)))))))))),dab))))))))))))))))))))))));
dyan=d_add(d_imul(3,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(Xxr,d_mul(Xxr,dya)))),d_add(d_imul(-3,d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxr,d_mul(Xxr,dxa)))),d_add(d_imul(3,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(Xxr)))))))))),d_add(d_imul(-3,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(Xxi,d_mul(Xxi,dya)))),d_add(d_imul(3,d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxi,d_mul(Xxi,dxa)))),d_add(d_imul(-3,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(Xxi)))))))))),d_add(d_imul(-3,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr)))))))))),d_add(d_imul(3,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxa,d_sgn(Xxr)))))))))),d_add(d_imul(6,d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxi,d_mul(Xxr,dya)))),d_add(d_imul(6,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(Xxi,d_mul(Xxr,dxa)))),d_add(d_imul(6,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_sgn(Xxr)))))))))),d_add(d_imul(6,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr)))))))))),d_add(d_imul(-9,d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,dya)))),d_add(d_imul(9,d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxi,d_mul(Xxi,dya)))),d_add(d_imul(9,d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxr,d_mul(Xxr,dxa)))),d_add(d_imul(9,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr)))))))))),d_add(d_imul(-9,d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxi,d_mul(Xxi,dxa)))),d_add(d_imul(-9,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(Xxr)))))))))),d_add(d_imul(9,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_sgn(Xxi)))))))))),d_add(d_imul(-9,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr)))))))))),d_add(d_imul(-18,d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxi,d_mul(Xxr,dxa)))),d_add(d_imul(-18,d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxi,d_mul(Xxr,dya)))),d_add(d_imul(-18,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(Xxr)))))))))),d_add(d_imul(-18,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr)))))))))),dba))))))))))))))))))))))));
dybn=d_add(d_imul(3,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(Xxr,d_mul(Xxr,dyb)))),d_add(d_imul(-3,d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxr,d_mul(Xxr,dxb)))),d_add(d_imul(3,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(Xxr)))))))))),d_add(d_imul(-3,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(Xxi,d_mul(Xxi,dyb)))),d_add(d_imul(3,d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxi,d_mul(Xxi,dxb)))),d_add(d_imul(-3,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(Xxi)))))))))),d_add(d_imul(-3,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr)))))))))),d_add(d_imul(3,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxb,d_sgn(Xxr)))))))))),d_add(d_imul(6,d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxi,d_mul(Xxr,dyb)))),d_add(d_imul(6,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(Xxi,d_mul(Xxr,dxb)))),d_add(d_imul(6,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_sgn(Xxr)))))))))),d_add(d_imul(6,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr)))))))))),d_add(d_imul(-9,d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxr,d_mul(Xxr,dyb)))),d_add(d_imul(9,d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxi,d_mul(Xxi,dyb)))),d_add(d_imul(9,d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxr,d_mul(Xxr,dxb)))),d_add(d_imul(9,d_mul(d_sgn(Xxr),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr)))))))))),d_add(d_imul(-9,d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxi,d_mul(Xxi,dxb)))),d_add(d_imul(-9,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(Xxr)))))))))),d_add(d_imul(9,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_sgn(Xxi)))))))))),d_add(d_imul(-9,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr)))))))))),d_add(d_imul(-18,d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxr))),d_mul(Xxi,d_mul(Xxr,dxb)))),d_add(d_imul(-18,d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxi,d_mul(Xxr,dyb)))),d_add(d_imul(-18,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(Xxr)))))))))),d_add(d_imul(-18,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr)))))))))),dbb))))))))))))))))))))))));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_add(d_sub(d_sub(d_add(d_sub(d_add(d_sub(d_add(d_add(d_sub(d_sub(d_add(d_sub(d_add(d_sub(d_mul(d_imul(3,d_diffabs(d_mul(Xr2,Xi),d_add(d_add(d_add(d_add(d_mul(Xr2,xi),d_mul(d_mul(d_imul(2,Xr),xr),Xi)),d_mul(d_mul(d_imul(2,Xr),xr),xi)),d_mul(xr2,Xi)),d_mul(xr2,xi)))),d_mul(Xi2,Xi)),d_mul(d_diffabs(d_mul(Xi2,Xi),d_add(d_add(d_mul(d_imul(3,Xi2),xi),d_mul(d_imul(3,Xi),xi2)),d_mul(xi2,xi))),d_mul(Xi2,Xi))),d_mul(d_imul(9,d_diffabs(d_mul(Xr,Xi2),d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(2,Xr),Xi),xi),d_mul(Xr,xi2)),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xr),Xi),xi)),d_mul(xr,xi2)))),d_mul(Xr,Xi2))),d_mul(d_imul(3,d_diffabs(d_mul(Xr2,Xr),d_add(d_add(d_mul(d_imul(3,Xr2),xr),d_mul(d_imul(3,Xr),xr2)),d_mul(xr2,xr)))),d_mul(Xr,Xi2))),d_mul(d_imul(3,d_diffabs(d_mul(Xi2,Xi),d_add(d_add(d_mul(d_imul(3,Xi2),xi),d_mul(d_imul(3,Xi),xi2)),d_mul(xi2,xi)))),d_mul(Xr2,Xi))),d_mul(d_imul(9,d_diffabs(d_mul(Xr2,Xi),d_add(d_add(d_add(d_add(d_mul(Xr2,xi),d_mul(d_mul(d_imul(2,Xr),xr),Xi)),d_mul(d_mul(d_imul(2,Xr),xr),xi)),d_mul(xr2,Xi)),d_mul(xr2,xi)))),d_mul(Xr2,Xi))),d_mul(d_imul(3,d_diffabs(d_mul(Xr,Xi2),d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(2,Xr),Xi),xi),d_mul(Xr,xi2)),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xr),Xi),xi)),d_mul(xr,xi2)))),d_mul(Xr2,Xr))),d_mul(d_diffabs(d_mul(Xr2,Xr),d_add(d_add(d_mul(d_imul(3,Xr2),xr),d_mul(d_imul(3,Xr),xr2)),d_mul(xr2,xr))),d_mul(Xr2,Xr))),d_mul(d_imul(3,d_abs(d_add(d_add(d_add(d_add(d_add(d_mul(Xr2,Xi),d_mul(Xr2,xi)),d_mul(d_mul(d_imul(2,Xr),xr),Xi)),d_mul(d_mul(d_imul(2,Xr),xr),xi)),d_mul(xr2,Xi)),d_mul(xr2,xi)))),d_add(d_add(d_mul(d_imul(3,Xi2),xi),d_mul(d_imul(3,Xi),xi2)),d_mul(xi2,xi)))),d_mul(d_abs(d_add(d_add(d_add(d_mul(Xi2,Xi),d_mul(d_imul(3,Xi2),xi)),d_mul(d_imul(3,Xi),xi2)),d_mul(xi2,xi))),d_add(d_add(d_mul(d_imul(3,Xi2),xi),d_mul(d_imul(3,Xi),xi2)),d_mul(xi2,xi)))),d_mul(d_imul(9,d_abs(d_add(d_add(d_add(d_add(d_add(d_mul(Xr,Xi2),d_mul(d_mul(d_imul(2,Xr),Xi),xi)),d_mul(Xr,xi2)),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xr),Xi),xi)),d_mul(xr,xi2)))),d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(2,Xr),Xi),xi),d_mul(Xr,xi2)),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xr),Xi),xi)),d_mul(xr,xi2)))),d_mul(d_imul(3,d_abs(d_add(d_add(d_add(d_mul(Xr2,Xr),d_mul(d_imul(3,Xr2),xr)),d_mul(d_imul(3,Xr),xr2)),d_mul(xr2,xr)))),d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(2,Xr),Xi),xi),d_mul(Xr,xi2)),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xr),Xi),xi)),d_mul(xr,xi2)))),d_mul(d_imul(3,d_abs(d_add(d_add(d_add(d_mul(Xi2,Xi),d_mul(d_imul(3,Xi2),xi)),d_mul(d_imul(3,Xi),xi2)),d_mul(xi2,xi)))),d_add(d_add(d_add(d_add(d_mul(Xr2,xi),d_mul(d_mul(d_imul(2,Xr),xr),Xi)),d_mul(d_mul(d_imul(2,Xr),xr),xi)),d_mul(xr2,Xi)),d_mul(xr2,xi)))),d_mul(d_imul(9,d_abs(d_add(d_add(d_add(d_add(d_add(d_mul(Xr2,Xi),d_mul(Xr2,xi)),d_mul(d_mul(d_imul(2,Xr),xr),Xi)),d_mul(d_mul(d_imul(2,Xr),xr),xi)),d_mul(xr2,Xi)),d_mul(xr2,xi)))),d_add(d_add(d_add(d_add(d_mul(Xr2,xi),d_mul(d_mul(d_imul(2,Xr),xr),Xi)),d_mul(d_mul(d_imul(2,Xr),xr),xi)),d_mul(xr2,Xi)),d_mul(xr2,xi)))),d_mul(d_imul(3,d_abs(d_add(d_add(d_add(d_add(d_add(d_mul(Xr,Xi2),d_mul(d_mul(d_imul(2,Xr),Xi),xi)),d_mul(Xr,xi2)),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xr),Xi),xi)),d_mul(xr,xi2)))),d_add(d_add(d_mul(d_imul(3,Xr2),xr),d_mul(d_imul(3,Xr),xr2)),d_mul(xr2,xr)))),d_mul(d_abs(d_add(d_add(d_add(d_mul(Xr2,Xr),d_mul(d_imul(3,Xr2),xr)),d_mul(d_imul(3,Xr),xr2)),d_mul(xr2,xr))),d_add(d_add(d_mul(d_imul(3,Xr2),xr),d_mul(d_imul(3,Xr),xr2)),d_mul(xr2,xr)))),cr);
xin=d_add(d_add(d_sub(d_add(d_add(d_sub(d_sub(d_sub(d_add(d_add(d_sub(d_add(d_add(d_sub(d_sub(d_sub(d_mul(d_imul(3,d_diffabs(d_mul(Xr,Xi2),d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(2,Xr),Xi),xi),d_mul(Xr,xi2)),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xr),Xi),xi)),d_mul(xr,xi2)))),d_mul(Xi2,Xi)),d_mul(d_diffabs(d_mul(Xr2,Xr),d_add(d_add(d_mul(d_imul(3,Xr2),xr),d_mul(d_imul(3,Xr),xr2)),d_mul(xr2,xr))),d_mul(Xi2,Xi))),d_mul(d_imul(9,d_diffabs(d_mul(Xr2,Xi),d_add(d_add(d_add(d_add(d_mul(Xr2,xi),d_mul(d_mul(d_imul(2,Xr),xr),Xi)),d_mul(d_mul(d_imul(2,Xr),xr),xi)),d_mul(xr2,Xi)),d_mul(xr2,xi)))),d_mul(Xr,Xi2))),d_mul(d_imul(9,d_diffabs(d_mul(Xr,Xi2),d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(2,Xr),Xi),xi),d_mul(Xr,xi2)),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xr),Xi),xi)),d_mul(xr,xi2)))),d_mul(Xr2,Xi))),d_mul(d_imul(3,d_diffabs(d_mul(Xr2,Xr),d_add(d_add(d_mul(d_imul(3,Xr2),xr),d_mul(d_imul(3,Xr),xr2)),d_mul(xr2,xr)))),d_mul(Xr2,Xi))),d_mul(d_imul(3,d_diffabs(d_mul(Xi2,Xi),d_add(d_add(d_mul(d_imul(3,Xi2),xi),d_mul(d_imul(3,Xi),xi2)),d_mul(xi2,xi)))),d_mul(Xr,Xi2))),d_mul(d_diffabs(d_mul(Xi2,Xi),d_add(d_add(d_mul(d_imul(3,Xi2),xi),d_mul(d_imul(3,Xi),xi2)),d_mul(xi2,xi))),d_mul(Xr2,Xr))),d_mul(d_imul(3,d_diffabs(d_mul(Xr2,Xi),d_add(d_add(d_add(d_add(d_mul(Xr2,xi),d_mul(d_mul(d_imul(2,Xr),xr),Xi)),d_mul(d_mul(d_imul(2,Xr),xr),xi)),d_mul(xr2,Xi)),d_mul(xr2,xi)))),d_mul(Xr2,Xr))),d_mul(d_imul(3,d_abs(d_add(d_add(d_add(d_add(d_add(d_mul(Xr,Xi2),d_mul(d_mul(d_imul(2,Xr),Xi),xi)),d_mul(Xr,xi2)),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xr),Xi),xi)),d_mul(xr,xi2)))),d_add(d_add(d_mul(d_imul(3,Xi2),xi),d_mul(d_imul(3,Xi),xi2)),d_mul(xi2,xi)))),d_mul(d_abs(d_add(d_add(d_add(d_mul(Xr2,Xr),d_mul(d_imul(3,Xr2),xr)),d_mul(d_imul(3,Xr),xr2)),d_mul(xr2,xr))),d_add(d_add(d_mul(d_imul(3,Xi2),xi),d_mul(d_imul(3,Xi),xi2)),d_mul(xi2,xi)))),d_mul(d_imul(9,d_abs(d_add(d_add(d_add(d_add(d_add(d_mul(Xr2,Xi),d_mul(Xr2,xi)),d_mul(d_mul(d_imul(2,Xr),xr),Xi)),d_mul(d_mul(d_imul(2,Xr),xr),xi)),d_mul(xr2,Xi)),d_mul(xr2,xi)))),d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(2,Xr),Xi),xi),d_mul(Xr,xi2)),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xr),Xi),xi)),d_mul(xr,xi2)))),d_mul(d_imul(9,d_abs(d_add(d_add(d_add(d_add(d_add(d_mul(Xr,Xi2),d_mul(d_mul(d_imul(2,Xr),Xi),xi)),d_mul(Xr,xi2)),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xr),Xi),xi)),d_mul(xr,xi2)))),d_add(d_add(d_add(d_add(d_mul(Xr2,xi),d_mul(d_mul(d_imul(2,Xr),xr),Xi)),d_mul(d_mul(d_imul(2,Xr),xr),xi)),d_mul(xr2,Xi)),d_mul(xr2,xi)))),d_mul(d_imul(3,d_abs(d_add(d_add(d_add(d_mul(Xr2,Xr),d_mul(d_imul(3,Xr2),xr)),d_mul(d_imul(3,Xr),xr2)),d_mul(xr2,xr)))),d_add(d_add(d_add(d_add(d_mul(Xr2,xi),d_mul(d_mul(d_imul(2,Xr),xr),Xi)),d_mul(d_mul(d_imul(2,Xr),xr),xi)),d_mul(xr2,Xi)),d_mul(xr2,xi)))),d_mul(d_imul(3,d_abs(d_add(d_add(d_add(d_mul(Xi2,Xi),d_mul(d_imul(3,Xi2),xi)),d_mul(d_imul(3,Xi),xi2)),d_mul(xi2,xi)))),d_add(d_add(d_add(d_add(d_mul(d_mul(d_imul(2,Xr),Xi),xi),d_mul(Xr,xi2)),d_mul(xr,Xi2)),d_mul(d_mul(d_imul(2,xr),Xi),xi)),d_mul(xr,xi2)))),d_mul(d_abs(d_add(d_add(d_add(d_mul(Xi2,Xi),d_mul(d_imul(3,Xi2),xi)),d_mul(d_imul(3,Xi),xi2)),d_mul(xi2,xi))),d_add(d_add(d_mul(d_imul(3,Xr2),xr),d_mul(d_imul(3,Xr),xr2)),d_mul(xr2,xr)))),d_mul(d_imul(3,d_abs(d_add(d_add(d_add(d_add(d_add(d_mul(Xr2,Xi),d_mul(Xr2,xi)),d_mul(d_mul(d_imul(2,Xr),xr),Xi)),d_mul(d_mul(d_imul(2,Xr),xr),xi)),d_mul(xr2,Xi)),d_mul(xr2,xi)))),d_add(d_add(d_mul(d_imul(3,Xr2),xr),d_mul(d_imul(3,Xr),xr2)),d_mul(xr2,xr)))),ci);
}

);

static const char *perturbation_opencl_floatexp_40_6_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_sub(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_mul(fe_imul(3,fe_diffabs(fe_mul(Xr2,Xi),fe_add(fe_add(fe_add(fe_add(fe_mul(Xr2,xi),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),xi)),fe_mul(xr2,Xi)),fe_mul(xr2,xi)))),fe_mul(Xi2,Xi)),fe_mul(fe_diffabs(fe_mul(Xi2,Xi),fe_add(fe_add(fe_mul(fe_imul(3,Xi2),xi),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(xi2,xi))),fe_mul(Xi2,Xi))),fe_mul(fe_imul(9,fe_diffabs(fe_mul(Xr,Xi2),fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(2,Xr),Xi),xi),fe_mul(Xr,xi2)),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xr),Xi),xi)),fe_mul(xr,xi2)))),fe_mul(Xr,Xi2))),fe_mul(fe_imul(3,fe_diffabs(fe_mul(Xr2,Xr),fe_add(fe_add(fe_mul(fe_imul(3,Xr2),xr),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(xr2,xr)))),fe_mul(Xr,Xi2))),fe_mul(fe_imul(3,fe_diffabs(fe_mul(Xi2,Xi),fe_add(fe_add(fe_mul(fe_imul(3,Xi2),xi),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(xi2,xi)))),fe_mul(Xr2,Xi))),fe_mul(fe_imul(9,fe_diffabs(fe_mul(Xr2,Xi),fe_add(fe_add(fe_add(fe_add(fe_mul(Xr2,xi),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),xi)),fe_mul(xr2,Xi)),fe_mul(xr2,xi)))),fe_mul(Xr2,Xi))),fe_mul(fe_imul(3,fe_diffabs(fe_mul(Xr,Xi2),fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(2,Xr),Xi),xi),fe_mul(Xr,xi2)),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xr),Xi),xi)),fe_mul(xr,xi2)))),fe_mul(Xr2,Xr))),fe_mul(fe_diffabs(fe_mul(Xr2,Xr),fe_add(fe_add(fe_mul(fe_imul(3,Xr2),xr),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(xr2,xr))),fe_mul(Xr2,Xr))),fe_mul(fe_imul(3,fe_abs(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(Xr2,Xi),fe_mul(Xr2,xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),xi)),fe_mul(xr2,Xi)),fe_mul(xr2,xi)))),fe_add(fe_add(fe_mul(fe_imul(3,Xi2),xi),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(xi2,xi)))),fe_mul(fe_abs(fe_add(fe_add(fe_add(fe_mul(Xi2,Xi),fe_mul(fe_imul(3,Xi2),xi)),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(xi2,xi))),fe_add(fe_add(fe_mul(fe_imul(3,Xi2),xi),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(xi2,xi)))),fe_mul(fe_imul(9,fe_abs(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(Xr,Xi2),fe_mul(fe_mul(fe_imul(2,Xr),Xi),xi)),fe_mul(Xr,xi2)),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xr),Xi),xi)),fe_mul(xr,xi2)))),fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(2,Xr),Xi),xi),fe_mul(Xr,xi2)),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xr),Xi),xi)),fe_mul(xr,xi2)))),fe_mul(fe_imul(3,fe_abs(fe_add(fe_add(fe_add(fe_mul(Xr2,Xr),fe_mul(fe_imul(3,Xr2),xr)),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(xr2,xr)))),fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(2,Xr),Xi),xi),fe_mul(Xr,xi2)),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xr),Xi),xi)),fe_mul(xr,xi2)))),fe_mul(fe_imul(3,fe_abs(fe_add(fe_add(fe_add(fe_mul(Xi2,Xi),fe_mul(fe_imul(3,Xi2),xi)),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(xi2,xi)))),fe_add(fe_add(fe_add(fe_add(fe_mul(Xr2,xi),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),xi)),fe_mul(xr2,Xi)),fe_mul(xr2,xi)))),fe_mul(fe_imul(9,fe_abs(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(Xr2,Xi),fe_mul(Xr2,xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),xi)),fe_mul(xr2,Xi)),fe_mul(xr2,xi)))),fe_add(fe_add(fe_add(fe_add(fe_mul(Xr2,xi),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),xi)),fe_mul(xr2,Xi)),fe_mul(xr2,xi)))),fe_mul(fe_imul(3,fe_abs(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(Xr,Xi2),fe_mul(fe_mul(fe_imul(2,Xr),Xi),xi)),fe_mul(Xr,xi2)),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xr),Xi),xi)),fe_mul(xr,xi2)))),fe_add(fe_add(fe_mul(fe_imul(3,Xr2),xr),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(xr2,xr)))),fe_mul(fe_abs(fe_add(fe_add(fe_add(fe_mul(Xr2,Xr),fe_mul(fe_imul(3,Xr2),xr)),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(xr2,xr))),fe_add(fe_add(fe_mul(fe_imul(3,Xr2),xr),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(xr2,xr)))),cr);
xin=fe_add(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_mul(fe_imul(3,fe_diffabs(fe_mul(Xr,Xi2),fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(2,Xr),Xi),xi),fe_mul(Xr,xi2)),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xr),Xi),xi)),fe_mul(xr,xi2)))),fe_mul(Xi2,Xi)),fe_mul(fe_diffabs(fe_mul(Xr2,Xr),fe_add(fe_add(fe_mul(fe_imul(3,Xr2),xr),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(xr2,xr))),fe_mul(Xi2,Xi))),fe_mul(fe_imul(9,fe_diffabs(fe_mul(Xr2,Xi),fe_add(fe_add(fe_add(fe_add(fe_mul(Xr2,xi),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),xi)),fe_mul(xr2,Xi)),fe_mul(xr2,xi)))),fe_mul(Xr,Xi2))),fe_mul(fe_imul(9,fe_diffabs(fe_mul(Xr,Xi2),fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(2,Xr),Xi),xi),fe_mul(Xr,xi2)),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xr),Xi),xi)),fe_mul(xr,xi2)))),fe_mul(Xr2,Xi))),fe_mul(fe_imul(3,fe_diffabs(fe_mul(Xr2,Xr),fe_add(fe_add(fe_mul(fe_imul(3,Xr2),xr),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(xr2,xr)))),fe_mul(Xr2,Xi))),fe_mul(fe_imul(3,fe_diffabs(fe_mul(Xi2,Xi),fe_add(fe_add(fe_mul(fe_imul(3,Xi2),xi),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(xi2,xi)))),fe_mul(Xr,Xi2))),fe_mul(fe_diffabs(fe_mul(Xi2,Xi),fe_add(fe_add(fe_mul(fe_imul(3,Xi2),xi),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(xi2,xi))),fe_mul(Xr2,Xr))),fe_mul(fe_imul(3,fe_diffabs(fe_mul(Xr2,Xi),fe_add(fe_add(fe_add(fe_add(fe_mul(Xr2,xi),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),xi)),fe_mul(xr2,Xi)),fe_mul(xr2,xi)))),fe_mul(Xr2,Xr))),fe_mul(fe_imul(3,fe_abs(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(Xr,Xi2),fe_mul(fe_mul(fe_imul(2,Xr),Xi),xi)),fe_mul(Xr,xi2)),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xr),Xi),xi)),fe_mul(xr,xi2)))),fe_add(fe_add(fe_mul(fe_imul(3,Xi2),xi),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(xi2,xi)))),fe_mul(fe_abs(fe_add(fe_add(fe_add(fe_mul(Xr2,Xr),fe_mul(fe_imul(3,Xr2),xr)),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(xr2,xr))),fe_add(fe_add(fe_mul(fe_imul(3,Xi2),xi),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(xi2,xi)))),fe_mul(fe_imul(9,fe_abs(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(Xr2,Xi),fe_mul(Xr2,xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),xi)),fe_mul(xr2,Xi)),fe_mul(xr2,xi)))),fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(2,Xr),Xi),xi),fe_mul(Xr,xi2)),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xr),Xi),xi)),fe_mul(xr,xi2)))),fe_mul(fe_imul(9,fe_abs(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(Xr,Xi2),fe_mul(fe_mul(fe_imul(2,Xr),Xi),xi)),fe_mul(Xr,xi2)),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xr),Xi),xi)),fe_mul(xr,xi2)))),fe_add(fe_add(fe_add(fe_add(fe_mul(Xr2,xi),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),xi)),fe_mul(xr2,Xi)),fe_mul(xr2,xi)))),fe_mul(fe_imul(3,fe_abs(fe_add(fe_add(fe_add(fe_mul(Xr2,Xr),fe_mul(fe_imul(3,Xr2),xr)),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(xr2,xr)))),fe_add(fe_add(fe_add(fe_add(fe_mul(Xr2,xi),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),xi)),fe_mul(xr2,Xi)),fe_mul(xr2,xi)))),fe_mul(fe_imul(3,fe_abs(fe_add(fe_add(fe_add(fe_mul(Xi2,Xi),fe_mul(fe_imul(3,Xi2),xi)),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(xi2,xi)))),fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(2,Xr),Xi),xi),fe_mul(Xr,xi2)),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xr),Xi),xi)),fe_mul(xr,xi2)))),fe_mul(fe_abs(fe_add(fe_add(fe_add(fe_mul(Xi2,Xi),fe_mul(fe_imul(3,Xi2),xi)),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(xi2,xi))),fe_add(fe_add(fe_mul(fe_imul(3,Xr2),xr),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(xr2,xr)))),fe_mul(fe_imul(3,fe_abs(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(Xr2,Xi),fe_mul(Xr2,xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),xi)),fe_mul(xr2,Xi)),fe_mul(xr2,xi)))),fe_add(fe_add(fe_mul(fe_imul(3,Xr2),xr),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(xr2,xr)))),ci);
}

);

static const char *perturbation_opencl_floatexp_40_6_1 = STR(

{dxan=fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxr,fe_mul(Xxr,dya)))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_mul(Xxr,dxa)))),fe_add(fe_imul(3,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr)))))))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxi,fe_mul(Xxi,dya)))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(Xxi,fe_mul(Xxi,dxa)))),fe_add(fe_imul(-3,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr)))))))))),fe_add(fe_imul(3,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxr)))))))))),fe_add(fe_imul(-3,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dya,fe_sgn(Xxi)))))))))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(Xxi,fe_mul(Xxr,dya)))),fe_add(fe_imul(6,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxi,fe_mul(Xxr,dxa)))),fe_add(fe_imul(-6,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxr)))))))))),fe_add(fe_imul(6,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr)))))))))),fe_add(fe_imul(-9,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,dxa)))),fe_add(fe_imul(-9,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_mul(Xxr,dya)))),fe_add(fe_imul(-9,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxr)))))))))),fe_add(fe_imul(9,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxi,fe_mul(Xxi,dxa)))),fe_add(fe_imul(9,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxi,fe_mul(Xxi,dya)))),fe_add(fe_imul(-9,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr)))))))))),fe_add(fe_imul(9,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr)))))))))),fe_add(fe_imul(9,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxi)))))))))),fe_add(fe_imul(18,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxi,fe_mul(Xxr,dya)))),fe_add(fe_imul(-18,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxi,fe_mul(Xxr,dxa)))),fe_add(fe_imul(-18,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr)))))))))),fe_add(fe_imul(18,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxr)))))))))),daa))))))))))))))))))))))));
dxbn=fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxr,fe_mul(Xxr,dyb)))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_mul(Xxr,dxb)))),fe_add(fe_imul(3,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr)))))))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxi,fe_mul(Xxi,dyb)))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(Xxi,fe_mul(Xxi,dxb)))),fe_add(fe_imul(-3,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr)))))))))),fe_add(fe_imul(3,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxr)))))))))),fe_add(fe_imul(-3,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dyb,fe_sgn(Xxi)))))))))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(Xxi,fe_mul(Xxr,dyb)))),fe_add(fe_imul(6,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxi,fe_mul(Xxr,dxb)))),fe_add(fe_imul(-6,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxr)))))))))),fe_add(fe_imul(6,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr)))))))))),fe_add(fe_imul(-9,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,dxb)))),fe_add(fe_imul(-9,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_mul(Xxr,dyb)))),fe_add(fe_imul(-9,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxr)))))))))),fe_add(fe_imul(9,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxi,fe_mul(Xxi,dxb)))),fe_add(fe_imul(9,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxi,fe_mul(Xxi,dyb)))),fe_add(fe_imul(-9,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr)))))))))),fe_add(fe_imul(9,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr)))))))))),fe_add(fe_imul(9,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxi)))))))))),fe_add(fe_imul(18,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxi,fe_mul(Xxr,dyb)))),fe_add(fe_imul(-18,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxi,fe_mul(Xxr,dxb)))),fe_add(fe_imul(-18,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr)))))))))),fe_add(fe_imul(18,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxr)))))))))),dab))))))))))))))))))))))));
dyan=fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_mul(Xxr,dya)))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxr,fe_mul(Xxr,dxa)))),fe_add(fe_imul(3,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxr)))))))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(Xxi,fe_mul(Xxi,dya)))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxi,fe_mul(Xxi,dxa)))),fe_add(fe_imul(-3,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxi)))))))))),fe_add(fe_imul(-3,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr)))))))))),fe_add(fe_imul(3,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxa,fe_sgn(Xxr)))))))))),fe_add(fe_imul(6,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxi,fe_mul(Xxr,dya)))),fe_add(fe_imul(6,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(Xxi,fe_mul(Xxr,dxa)))),fe_add(fe_imul(6,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxr)))))))))),fe_add(fe_imul(6,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr)))))))))),fe_add(fe_imul(-9,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,dya)))),fe_add(fe_imul(9,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxi,fe_mul(Xxi,dya)))),fe_add(fe_imul(9,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_mul(Xxr,dxa)))),fe_add(fe_imul(9,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr)))))))))),fe_add(fe_imul(-9,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxi,fe_mul(Xxi,dxa)))),fe_add(fe_imul(-9,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxr)))))))))),fe_add(fe_imul(9,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxi)))))))))),fe_add(fe_imul(-9,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr)))))))))),fe_add(fe_imul(-18,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxi,fe_mul(Xxr,dxa)))),fe_add(fe_imul(-18,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxi,fe_mul(Xxr,dya)))),fe_add(fe_imul(-18,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxr)))))))))),fe_add(fe_imul(-18,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr)))))))))),dba))))))))))))))))))))))));
dybn=fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_mul(Xxr,dyb)))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxr,fe_mul(Xxr,dxb)))),fe_add(fe_imul(3,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxr)))))))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(Xxi,fe_mul(Xxi,dyb)))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxi,fe_mul(Xxi,dxb)))),fe_add(fe_imul(-3,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxi)))))))))),fe_add(fe_imul(-3,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr)))))))))),fe_add(fe_imul(3,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxb,fe_sgn(Xxr)))))))))),fe_add(fe_imul(6,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxi,fe_mul(Xxr,dyb)))),fe_add(fe_imul(6,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(Xxi,fe_mul(Xxr,dxb)))),fe_add(fe_imul(6,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxr)))))))))),fe_add(fe_imul(6,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr)))))))))),fe_add(fe_imul(-9,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxr,fe_mul(Xxr,dyb)))),fe_add(fe_imul(9,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxi,fe_mul(Xxi,dyb)))),fe_add(fe_imul(9,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_mul(Xxr,dxb)))),fe_add(fe_imul(9,fe_mul(fe_sgn(Xxr),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr)))))))))),fe_add(fe_imul(-9,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxi,fe_mul(Xxi,dxb)))),fe_add(fe_imul(-9,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxr)))))))))),fe_add(fe_imul(9,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxi)))))))))),fe_add(fe_imul(-9,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr)))))))))),fe_add(fe_imul(-18,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxr))),fe_mul(Xxi,fe_mul(Xxr,dxb)))),fe_add(fe_imul(-18,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxi,fe_mul(Xxr,dyb)))),fe_add(fe_imul(-18,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxr)))))))))),fe_add(fe_imul(-18,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr)))))))))),dbb))))))))))))))))))))))));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_add(fe_sub(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_sub(fe_add(fe_sub(fe_add(fe_sub(fe_mul(fe_imul(3,fe_diffabs(fe_mul(Xr2,Xi),fe_add(fe_add(fe_add(fe_add(fe_mul(Xr2,xi),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),xi)),fe_mul(xr2,Xi)),fe_mul(xr2,xi)))),fe_mul(Xi2,Xi)),fe_mul(fe_diffabs(fe_mul(Xi2,Xi),fe_add(fe_add(fe_mul(fe_imul(3,Xi2),xi),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(xi2,xi))),fe_mul(Xi2,Xi))),fe_mul(fe_imul(9,fe_diffabs(fe_mul(Xr,Xi2),fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(2,Xr),Xi),xi),fe_mul(Xr,xi2)),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xr),Xi),xi)),fe_mul(xr,xi2)))),fe_mul(Xr,Xi2))),fe_mul(fe_imul(3,fe_diffabs(fe_mul(Xr2,Xr),fe_add(fe_add(fe_mul(fe_imul(3,Xr2),xr),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(xr2,xr)))),fe_mul(Xr,Xi2))),fe_mul(fe_imul(3,fe_diffabs(fe_mul(Xi2,Xi),fe_add(fe_add(fe_mul(fe_imul(3,Xi2),xi),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(xi2,xi)))),fe_mul(Xr2,Xi))),fe_mul(fe_imul(9,fe_diffabs(fe_mul(Xr2,Xi),fe_add(fe_add(fe_add(fe_add(fe_mul(Xr2,xi),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),xi)),fe_mul(xr2,Xi)),fe_mul(xr2,xi)))),fe_mul(Xr2,Xi))),fe_mul(fe_imul(3,fe_diffabs(fe_mul(Xr,Xi2),fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(2,Xr),Xi),xi),fe_mul(Xr,xi2)),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xr),Xi),xi)),fe_mul(xr,xi2)))),fe_mul(Xr2,Xr))),fe_mul(fe_diffabs(fe_mul(Xr2,Xr),fe_add(fe_add(fe_mul(fe_imul(3,Xr2),xr),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(xr2,xr))),fe_mul(Xr2,Xr))),fe_mul(fe_imul(3,fe_abs(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(Xr2,Xi),fe_mul(Xr2,xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),xi)),fe_mul(xr2,Xi)),fe_mul(xr2,xi)))),fe_add(fe_add(fe_mul(fe_imul(3,Xi2),xi),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(xi2,xi)))),fe_mul(fe_abs(fe_add(fe_add(fe_add(fe_mul(Xi2,Xi),fe_mul(fe_imul(3,Xi2),xi)),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(xi2,xi))),fe_add(fe_add(fe_mul(fe_imul(3,Xi2),xi),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(xi2,xi)))),fe_mul(fe_imul(9,fe_abs(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(Xr,Xi2),fe_mul(fe_mul(fe_imul(2,Xr),Xi),xi)),fe_mul(Xr,xi2)),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xr),Xi),xi)),fe_mul(xr,xi2)))),fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(2,Xr),Xi),xi),fe_mul(Xr,xi2)),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xr),Xi),xi)),fe_mul(xr,xi2)))),fe_mul(fe_imul(3,fe_abs(fe_add(fe_add(fe_add(fe_mul(Xr2,Xr),fe_mul(fe_imul(3,Xr2),xr)),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(xr2,xr)))),fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(2,Xr),Xi),xi),fe_mul(Xr,xi2)),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xr),Xi),xi)),fe_mul(xr,xi2)))),fe_mul(fe_imul(3,fe_abs(fe_add(fe_add(fe_add(fe_mul(Xi2,Xi),fe_mul(fe_imul(3,Xi2),xi)),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(xi2,xi)))),fe_add(fe_add(fe_add(fe_add(fe_mul(Xr2,xi),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),xi)),fe_mul(xr2,Xi)),fe_mul(xr2,xi)))),fe_mul(fe_imul(9,fe_abs(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(Xr2,Xi),fe_mul(Xr2,xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),xi)),fe_mul(xr2,Xi)),fe_mul(xr2,xi)))),fe_add(fe_add(fe_add(fe_add(fe_mul(Xr2,xi),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),xi)),fe_mul(xr2,Xi)),fe_mul(xr2,xi)))),fe_mul(fe_imul(3,fe_abs(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(Xr,Xi2),fe_mul(fe_mul(fe_imul(2,Xr),Xi),xi)),fe_mul(Xr,xi2)),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xr),Xi),xi)),fe_mul(xr,xi2)))),fe_add(fe_add(fe_mul(fe_imul(3,Xr2),xr),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(xr2,xr)))),fe_mul(fe_abs(fe_add(fe_add(fe_add(fe_mul(Xr2,Xr),fe_mul(fe_imul(3,Xr2),xr)),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(xr2,xr))),fe_add(fe_add(fe_mul(fe_imul(3,Xr2),xr),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(xr2,xr)))),cr);
xin=fe_add(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_add(fe_add(fe_sub(fe_add(fe_add(fe_sub(fe_sub(fe_sub(fe_mul(fe_imul(3,fe_diffabs(fe_mul(Xr,Xi2),fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(2,Xr),Xi),xi),fe_mul(Xr,xi2)),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xr),Xi),xi)),fe_mul(xr,xi2)))),fe_mul(Xi2,Xi)),fe_mul(fe_diffabs(fe_mul(Xr2,Xr),fe_add(fe_add(fe_mul(fe_imul(3,Xr2),xr),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(xr2,xr))),fe_mul(Xi2,Xi))),fe_mul(fe_imul(9,fe_diffabs(fe_mul(Xr2,Xi),fe_add(fe_add(fe_add(fe_add(fe_mul(Xr2,xi),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),xi)),fe_mul(xr2,Xi)),fe_mul(xr2,xi)))),fe_mul(Xr,Xi2))),fe_mul(fe_imul(9,fe_diffabs(fe_mul(Xr,Xi2),fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(2,Xr),Xi),xi),fe_mul(Xr,xi2)),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xr),Xi),xi)),fe_mul(xr,xi2)))),fe_mul(Xr2,Xi))),fe_mul(fe_imul(3,fe_diffabs(fe_mul(Xr2,Xr),fe_add(fe_add(fe_mul(fe_imul(3,Xr2),xr),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(xr2,xr)))),fe_mul(Xr2,Xi))),fe_mul(fe_imul(3,fe_diffabs(fe_mul(Xi2,Xi),fe_add(fe_add(fe_mul(fe_imul(3,Xi2),xi),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(xi2,xi)))),fe_mul(Xr,Xi2))),fe_mul(fe_diffabs(fe_mul(Xi2,Xi),fe_add(fe_add(fe_mul(fe_imul(3,Xi2),xi),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(xi2,xi))),fe_mul(Xr2,Xr))),fe_mul(fe_imul(3,fe_diffabs(fe_mul(Xr2,Xi),fe_add(fe_add(fe_add(fe_add(fe_mul(Xr2,xi),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),xi)),fe_mul(xr2,Xi)),fe_mul(xr2,xi)))),fe_mul(Xr2,Xr))),fe_mul(fe_imul(3,fe_abs(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(Xr,Xi2),fe_mul(fe_mul(fe_imul(2,Xr),Xi),xi)),fe_mul(Xr,xi2)),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xr),Xi),xi)),fe_mul(xr,xi2)))),fe_add(fe_add(fe_mul(fe_imul(3,Xi2),xi),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(xi2,xi)))),fe_mul(fe_abs(fe_add(fe_add(fe_add(fe_mul(Xr2,Xr),fe_mul(fe_imul(3,Xr2),xr)),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(xr2,xr))),fe_add(fe_add(fe_mul(fe_imul(3,Xi2),xi),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(xi2,xi)))),fe_mul(fe_imul(9,fe_abs(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(Xr2,Xi),fe_mul(Xr2,xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),xi)),fe_mul(xr2,Xi)),fe_mul(xr2,xi)))),fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(2,Xr),Xi),xi),fe_mul(Xr,xi2)),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xr),Xi),xi)),fe_mul(xr,xi2)))),fe_mul(fe_imul(9,fe_abs(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(Xr,Xi2),fe_mul(fe_mul(fe_imul(2,Xr),Xi),xi)),fe_mul(Xr,xi2)),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xr),Xi),xi)),fe_mul(xr,xi2)))),fe_add(fe_add(fe_add(fe_add(fe_mul(Xr2,xi),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),xi)),fe_mul(xr2,Xi)),fe_mul(xr2,xi)))),fe_mul(fe_imul(3,fe_abs(fe_add(fe_add(fe_add(fe_mul(Xr2,Xr),fe_mul(fe_imul(3,Xr2),xr)),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(xr2,xr)))),fe_add(fe_add(fe_add(fe_add(fe_mul(Xr2,xi),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),xi)),fe_mul(xr2,Xi)),fe_mul(xr2,xi)))),fe_mul(fe_imul(3,fe_abs(fe_add(fe_add(fe_add(fe_mul(Xi2,Xi),fe_mul(fe_imul(3,Xi2),xi)),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(xi2,xi)))),fe_add(fe_add(fe_add(fe_add(fe_mul(fe_mul(fe_imul(2,Xr),Xi),xi),fe_mul(Xr,xi2)),fe_mul(xr,Xi2)),fe_mul(fe_mul(fe_imul(2,xr),Xi),xi)),fe_mul(xr,xi2)))),fe_mul(fe_abs(fe_add(fe_add(fe_add(fe_mul(Xi2,Xi),fe_mul(fe_imul(3,Xi2),xi)),fe_mul(fe_imul(3,Xi),xi2)),fe_mul(xi2,xi))),fe_add(fe_add(fe_mul(fe_imul(3,Xr2),xr),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(xr2,xr)))),fe_mul(fe_imul(3,fe_abs(fe_add(fe_add(fe_add(fe_add(fe_add(fe_mul(Xr2,Xi),fe_mul(Xr2,xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),Xi)),fe_mul(fe_mul(fe_imul(2,Xr),xr),xi)),fe_mul(xr2,Xi)),fe_mul(xr2,xi)))),fe_add(fe_add(fe_mul(fe_imul(3,Xr2),xr),fe_mul(fe_imul(3,Xr),xr2)),fe_mul(xr2,xr)))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_40_6_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_add(sf_sub(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_mul(sf_imul(3,sf_diffabs(sf_mul(Xr2,Xi),sf_add(sf_add(sf_add(sf_add(sf_mul(Xr2,xi),sf_mul(sf_mul(sf_imul(2,Xr),xr),Xi)),sf_mul(sf_mul(sf_imul(2,Xr),xr),xi)),sf_mul(xr2,Xi)),sf_mul(xr2,xi)))),sf_mul(Xi2,Xi)),sf_mul(sf_diffabs(sf_mul(Xi2,Xi),sf_add(sf_add(sf_mul(sf_imul(3,Xi2),xi),sf_mul(sf_imul(3,Xi),xi2)),sf_mul(xi2,xi))),sf_mul(Xi2,Xi))),sf_mul(sf_imul(9,sf_diffabs(sf_mul(Xr,Xi2),sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(2,Xr),Xi),xi),sf_mul(Xr,xi2)),sf_mul(xr,Xi2)),sf_mul(sf_mul(sf_imul(2,xr),Xi),xi)),sf_mul(xr,xi2)))),sf_mul(Xr,Xi2))),sf_mul(sf_imul(3,sf_diffabs(sf_mul(Xr2,Xr),sf_add(sf_add(sf_mul(sf_imul(3,Xr2),xr),sf_mul(sf_imul(3,Xr),xr2)),sf_mul(xr2,xr)))),sf_mul(Xr,Xi2))),sf_mul(sf_imul(3,sf_diffabs(sf_mul(Xi2,Xi),sf_add(sf_add(sf_mul(sf_imul(3,Xi2),xi),sf_mul(sf_imul(3,Xi),xi2)),sf_mul(xi2,xi)))),sf_mul(Xr2,Xi))),sf_mul(sf_imul(9,sf_diffabs(sf_mul(Xr2,Xi),sf_add(sf_add(sf_add(sf_add(sf_mul(Xr2,xi),sf_mul(sf_mul(sf_imul(2,Xr),xr),Xi)),sf_mul(sf_mul(sf_imul(2,Xr),xr),xi)),sf_mul(xr2,Xi)),sf_mul(xr2,xi)))),sf_mul(Xr2,Xi))),sf_mul(sf_imul(3,sf_diffabs(sf_mul(Xr,Xi2),sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(2,Xr),Xi),xi),sf_mul(Xr,xi2)),sf_mul(xr,Xi2)),sf_mul(sf_mul(sf_imul(2,xr),Xi),xi)),sf_mul(xr,xi2)))),sf_mul(Xr2,Xr))),sf_mul(sf_diffabs(sf_mul(Xr2,Xr),sf_add(sf_add(sf_mul(sf_imul(3,Xr2),xr),sf_mul(sf_imul(3,Xr),xr2)),sf_mul(xr2,xr))),sf_mul(Xr2,Xr))),sf_mul(sf_imul(3,sf_abs(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(Xr2,Xi),sf_mul(Xr2,xi)),sf_mul(sf_mul(sf_imul(2,Xr),xr),Xi)),sf_mul(sf_mul(sf_imul(2,Xr),xr),xi)),sf_mul(xr2,Xi)),sf_mul(xr2,xi)))),sf_add(sf_add(sf_mul(sf_imul(3,Xi2),xi),sf_mul(sf_imul(3,Xi),xi2)),sf_mul(xi2,xi)))),sf_mul(sf_abs(sf_add(sf_add(sf_add(sf_mul(Xi2,Xi),sf_mul(sf_imul(3,Xi2),xi)),sf_mul(sf_imul(3,Xi),xi2)),sf_mul(xi2,xi))),sf_add(sf_add(sf_mul(sf_imul(3,Xi2),xi),sf_mul(sf_imul(3,Xi),xi2)),sf_mul(xi2,xi)))),sf_mul(sf_imul(9,sf_abs(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(Xr,Xi2),sf_mul(sf_mul(sf_imul(2,Xr),Xi),xi)),sf_mul(Xr,xi2)),sf_mul(xr,Xi2)),sf_mul(sf_mul(sf_imul(2,xr),Xi),xi)),sf_mul(xr,xi2)))),sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(2,Xr),Xi),xi),sf_mul(Xr,xi2)),sf_mul(xr,Xi2)),sf_mul(sf_mul(sf_imul(2,xr),Xi),xi)),sf_mul(xr,xi2)))),sf_mul(sf_imul(3,sf_abs(sf_add(sf_add(sf_add(sf_mul(Xr2,Xr),sf_mul(sf_imul(3,Xr2),xr)),sf_mul(sf_imul(3,Xr),xr2)),sf_mul(xr2,xr)))),sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(2,Xr),Xi),xi),sf_mul(Xr,xi2)),sf_mul(xr,Xi2)),sf_mul(sf_mul(sf_imul(2,xr),Xi),xi)),sf_mul(xr,xi2)))),sf_mul(sf_imul(3,sf_abs(sf_add(sf_add(sf_add(sf_mul(Xi2,Xi),sf_mul(sf_imul(3,Xi2),xi)),sf_mul(sf_imul(3,Xi),xi2)),sf_mul(xi2,xi)))),sf_add(sf_add(sf_add(sf_add(sf_mul(Xr2,xi),sf_mul(sf_mul(sf_imul(2,Xr),xr),Xi)),sf_mul(sf_mul(sf_imul(2,Xr),xr),xi)),sf_mul(xr2,Xi)),sf_mul(xr2,xi)))),sf_mul(sf_imul(9,sf_abs(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(Xr2,Xi),sf_mul(Xr2,xi)),sf_mul(sf_mul(sf_imul(2,Xr),xr),Xi)),sf_mul(sf_mul(sf_imul(2,Xr),xr),xi)),sf_mul(xr2,Xi)),sf_mul(xr2,xi)))),sf_add(sf_add(sf_add(sf_add(sf_mul(Xr2,xi),sf_mul(sf_mul(sf_imul(2,Xr),xr),Xi)),sf_mul(sf_mul(sf_imul(2,Xr),xr),xi)),sf_mul(xr2,Xi)),sf_mul(xr2,xi)))),sf_mul(sf_imul(3,sf_abs(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(Xr,Xi2),sf_mul(sf_mul(sf_imul(2,Xr),Xi),xi)),sf_mul(Xr,xi2)),sf_mul(xr,Xi2)),sf_mul(sf_mul(sf_imul(2,xr),Xi),xi)),sf_mul(xr,xi2)))),sf_add(sf_add(sf_mul(sf_imul(3,Xr2),xr),sf_mul(sf_imul(3,Xr),xr2)),sf_mul(xr2,xr)))),sf_mul(sf_abs(sf_add(sf_add(sf_add(sf_mul(Xr2,Xr),sf_mul(sf_imul(3,Xr2),xr)),sf_mul(sf_imul(3,Xr),xr2)),sf_mul(xr2,xr))),sf_add(sf_add(sf_mul(sf_imul(3,Xr2),xr),sf_mul(sf_imul(3,Xr),xr2)),sf_mul(xr2,xr)))),cr);
xin=sf_add(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_mul(sf_imul(3,sf_diffabs(sf_mul(Xr,Xi2),sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(2,Xr),Xi),xi),sf_mul(Xr,xi2)),sf_mul(xr,Xi2)),sf_mul(sf_mul(sf_imul(2,xr),Xi),xi)),sf_mul(xr,xi2)))),sf_mul(Xi2,Xi)),sf_mul(sf_diffabs(sf_mul(Xr2,Xr),sf_add(sf_add(sf_mul(sf_imul(3,Xr2),xr),sf_mul(sf_imul(3,Xr),xr2)),sf_mul(xr2,xr))),sf_mul(Xi2,Xi))),sf_mul(sf_imul(9,sf_diffabs(sf_mul(Xr2,Xi),sf_add(sf_add(sf_add(sf_add(sf_mul(Xr2,xi),sf_mul(sf_mul(sf_imul(2,Xr),xr),Xi)),sf_mul(sf_mul(sf_imul(2,Xr),xr),xi)),sf_mul(xr2,Xi)),sf_mul(xr2,xi)))),sf_mul(Xr,Xi2))),sf_mul(sf_imul(9,sf_diffabs(sf_mul(Xr,Xi2),sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(2,Xr),Xi),xi),sf_mul(Xr,xi2)),sf_mul(xr,Xi2)),sf_mul(sf_mul(sf_imul(2,xr),Xi),xi)),sf_mul(xr,xi2)))),sf_mul(Xr2,Xi))),sf_mul(sf_imul(3,sf_diffabs(sf_mul(Xr2,Xr),sf_add(sf_add(sf_mul(sf_imul(3,Xr2),xr),sf_mul(sf_imul(3,Xr),xr2)),sf_mul(xr2,xr)))),sf_mul(Xr2,Xi))),sf_mul(sf_imul(3,sf_diffabs(sf_mul(Xi2,Xi),sf_add(sf_add(sf_mul(sf_imul(3,Xi2),xi),sf_mul(sf_imul(3,Xi),xi2)),sf_mul(xi2,xi)))),sf_mul(Xr,Xi2))),sf_mul(sf_diffabs(sf_mul(Xi2,Xi),sf_add(sf_add(sf_mul(sf_imul(3,Xi2),xi),sf_mul(sf_imul(3,Xi),xi2)),sf_mul(xi2,xi))),sf_mul(Xr2,Xr))),sf_mul(sf_imul(3,sf_diffabs(sf_mul(Xr2,Xi),sf_add(sf_add(sf_add(sf_add(sf_mul(Xr2,xi),sf_mul(sf_mul(sf_imul(2,Xr),xr),Xi)),sf_mul(sf_mul(sf_imul(2,Xr),xr),xi)),sf_mul(xr2,Xi)),sf_mul(xr2,xi)))),sf_mul(Xr2,Xr))),sf_mul(sf_imul(3,sf_abs(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(Xr,Xi2),sf_mul(sf_mul(sf_imul(2,Xr),Xi),xi)),sf_mul(Xr,xi2)),sf_mul(xr,Xi2)),sf_mul(sf_mul(sf_imul(2,xr),Xi),xi)),sf_mul(xr,xi2)))),sf_add(sf_add(sf_mul(sf_imul(3,Xi2),xi),sf_mul(sf_imul(3,Xi),xi2)),sf_mul(xi2,xi)))),sf_mul(sf_abs(sf_add(sf_add(sf_add(sf_mul(Xr2,Xr),sf_mul(sf_imul(3,Xr2),xr)),sf_mul(sf_imul(3,Xr),xr2)),sf_mul(xr2,xr))),sf_add(sf_add(sf_mul(sf_imul(3,Xi2),xi),sf_mul(sf_imul(3,Xi),xi2)),sf_mul(xi2,xi)))),sf_mul(sf_imul(9,sf_abs(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(Xr2,Xi),sf_mul(Xr2,xi)),sf_mul(sf_mul(sf_imul(2,Xr),xr),Xi)),sf_mul(sf_mul(sf_imul(2,Xr),xr),xi)),sf_mul(xr2,Xi)),sf_mul(xr2,xi)))),sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(2,Xr),Xi),xi),sf_mul(Xr,xi2)),sf_mul(xr,Xi2)),sf_mul(sf_mul(sf_imul(2,xr),Xi),xi)),sf_mul(xr,xi2)))),sf_mul(sf_imul(9,sf_abs(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(Xr,Xi2),sf_mul(sf_mul(sf_imul(2,Xr),Xi),xi)),sf_mul(Xr,xi2)),sf_mul(xr,Xi2)),sf_mul(sf_mul(sf_imul(2,xr),Xi),xi)),sf_mul(xr,xi2)))),sf_add(sf_add(sf_add(sf_add(sf_mul(Xr2,xi),sf_mul(sf_mul(sf_imul(2,Xr),xr),Xi)),sf_mul(sf_mul(sf_imul(2,Xr),xr),xi)),sf_mul(xr2,Xi)),sf_mul(xr2,xi)))),sf_mul(sf_imul(3,sf_abs(sf_add(sf_add(sf_add(sf_mul(Xr2,Xr),sf_mul(sf_imul(3,Xr2),xr)),sf_mul(sf_imul(3,Xr),xr2)),sf_mul(xr2,xr)))),sf_add(sf_add(sf_add(sf_add(sf_mul(Xr2,xi),sf_mul(sf_mul(sf_imul(2,Xr),xr),Xi)),sf_mul(sf_mul(sf_imul(2,Xr),xr),xi)),sf_mul(xr2,Xi)),sf_mul(xr2,xi)))),sf_mul(sf_imul(3,sf_abs(sf_add(sf_add(sf_add(sf_mul(Xi2,Xi),sf_mul(sf_imul(3,Xi2),xi)),sf_mul(sf_imul(3,Xi),xi2)),sf_mul(xi2,xi)))),sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(2,Xr),Xi),xi),sf_mul(Xr,xi2)),sf_mul(xr,Xi2)),sf_mul(sf_mul(sf_imul(2,xr),Xi),xi)),sf_mul(xr,xi2)))),sf_mul(sf_abs(sf_add(sf_add(sf_add(sf_mul(Xi2,Xi),sf_mul(sf_imul(3,Xi2),xi)),sf_mul(sf_imul(3,Xi),xi2)),sf_mul(xi2,xi))),sf_add(sf_add(sf_mul(sf_imul(3,Xr2),xr),sf_mul(sf_imul(3,Xr),xr2)),sf_mul(xr2,xr)))),sf_mul(sf_imul(3,sf_abs(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(Xr2,Xi),sf_mul(Xr2,xi)),sf_mul(sf_mul(sf_imul(2,Xr),xr),Xi)),sf_mul(sf_mul(sf_imul(2,Xr),xr),xi)),sf_mul(xr2,Xi)),sf_mul(xr2,xi)))),sf_add(sf_add(sf_mul(sf_imul(3,Xr2),xr),sf_mul(sf_imul(3,Xr),xr2)),sf_mul(xr2,xr)))),ci);
}

);
#endif


static const char *perturbation_opencl_double_41_2_0 = STR(

{xrn=d_add(d_sub(d_sub(d_mul(xr,d_add(d_imul(2,Xr),xr)),d_mul(xi,d_add(xi,d_imul(2,Xi)))),d_diffabs(Xr,xr)),cr);
xin=d_add(d_sub(d_muli(d_diffabs(d_mul(Xr,Xi),d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi))),2),d_diffabs(Xi,xi)),ci);
}

);

static const char *perturbation_opencl_double_41_2_1 = STR(

{dxan=d_add(daa,d_add(d_imul(2,d_mul(Xxr,dxa)),d_add(d_imul(-2,d_mul(Xxi,dya)),d_imul(-1,d_mul(dxa,d_sgn(Xxr))))));
dxbn=d_add(dab,d_add(d_imul(2,d_mul(Xxr,dxb)),d_add(d_imul(-2,d_mul(Xxi,dyb)),d_imul(-1,d_mul(dxb,d_sgn(Xxr))))));
dyan=d_add(dba,d_add(d_imul(2,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(dxa,d_sgn(Xxr))))),d_add(d_imul(2,d_mul(d_sgn(Xxi),d_mul(Xxr,d_mul(dya,d_sgn(Xxr))))),d_imul(-1,d_mul(dya,d_sgn(Xxi))))));
dybn=d_add(dbb,d_add(d_imul(2,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(dxb,d_sgn(Xxr))))),d_add(d_imul(2,d_mul(d_sgn(Xxi),d_mul(Xxr,d_mul(dyb,d_sgn(Xxr))))),d_imul(-1,d_mul(dyb,d_sgn(Xxi))))));
}

{xrn=d_add(d_sub(d_sub(d_mul(xr,d_add(d_imul(2,Xr),xr)),d_mul(xi,d_add(xi,d_imul(2,Xi)))),d_diffabs(Xr,xr)),cr);
xin=d_add(d_sub(d_muli(d_diffabs(d_mul(Xr,Xi),d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi))),2),d_diffabs(Xi,xi)),ci);
}

);

static const char *perturbation_opencl_floatexp_41_2_0 = STR(

{xrn=fe_add(fe_sub(fe_sub(fe_mul(xr,fe_add(fe_imul(2,Xr),xr)),fe_mul(xi,fe_add(xi,fe_imul(2,Xi)))),fe_diffabs(Xr,xr)),cr);
xin=fe_add(fe_sub(fe_muli(fe_diffabs(fe_mul(Xr,Xi),fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi))),2),fe_diffabs(Xi,xi)),ci);
}

);

static const char *perturbation_opencl_floatexp_41_2_1 = STR(

{dxan=fe_add(daa,fe_add(fe_imul(2,fe_mul(Xxr,dxa)),fe_add(fe_imul(-2,fe_mul(Xxi,dya)),fe_imul(-1,fe_mul(dxa,fe_sgn(Xxr))))));
dxbn=fe_add(dab,fe_add(fe_imul(2,fe_mul(Xxr,dxb)),fe_add(fe_imul(-2,fe_mul(Xxi,dyb)),fe_imul(-1,fe_mul(dxb,fe_sgn(Xxr))))));
dyan=fe_add(dba,fe_add(fe_imul(2,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(dxa,fe_sgn(Xxr))))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxi),fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxr))))),fe_imul(-1,fe_mul(dya,fe_sgn(Xxi))))));
dybn=fe_add(dbb,fe_add(fe_imul(2,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(dxb,fe_sgn(Xxr))))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxi),fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxr))))),fe_imul(-1,fe_mul(dyb,fe_sgn(Xxi))))));
}

{xrn=fe_add(fe_sub(fe_sub(fe_mul(xr,fe_add(fe_imul(2,Xr),xr)),fe_mul(xi,fe_add(xi,fe_imul(2,Xi)))),fe_diffabs(Xr,xr)),cr);
xin=fe_add(fe_sub(fe_muli(fe_diffabs(fe_mul(Xr,Xi),fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi))),2),fe_diffabs(Xi,xi)),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_41_2_0 = STR(

{xrn=sf_add(sf_sub(sf_sub(sf_mul(xr,sf_add(sf_imul(2,Xr),xr)),sf_mul(xi,sf_add(xi,sf_imul(2,Xi)))),sf_diffabs(Xr,xr)),cr);
xin=sf_add(sf_sub(sf_muli(sf_diffabs(sf_mul(Xr,Xi),sf_add(sf_add(sf_mul(Xr,xi),sf_mul(xr,Xi)),sf_mul(xr,xi))),2),sf_diffabs(Xi,xi)),ci);
}

);
#endif


static const char *perturbation_opencl_double_42_3_0 = STR(

{
  const dcomplex X = { Xr COMMA Xi } COMMA x = { xr COMMA xi } COMMA Xx = { Xxr COMMA Xxi } COMMA c = { cr COMMA ci };
  dcomplex xn;
{const dcomplex X2 = dc_sqr(X);
const dcomplex x2 = dc_sqr(x);
xn=dc_add(dc_add(dc_add(dc_add(dc_mul(A,dc_add(dc_mul(dc_imul(2,X),x),x2)),dc_mul(dc_imul(3,X2),x)),dc_mul(dc_imul(3,X),x2)),dc_mul(x2,x)),c);
}
  xrn = xn.re;
  xin = xn.im;
}

);

static const char *perturbation_opencl_double_42_3_1 = STR(

{const dcomplex X2 = dc_sqr(X);
dn=dc_add(dc_mul(dc_add(dc_mul(A,dc_imul(2,X)),dc_imul(3,X2)),d),d0);
}

{const dcomplex X2 = dc_sqr(X);
const dcomplex x2 = dc_sqr(x);
xn=dc_add(dc_add(dc_add(dc_add(dc_mul(A,dc_add(dc_mul(dc_imul(2,X),x),x2)),dc_mul(dc_imul(3,X2),x)),dc_mul(dc_imul(3,X),x2)),dc_mul(x2,x)),c);
}

);

static const char *perturbation_opencl_floatexp_42_3_0 = STR(

{
  const fecomplex X = { Xr COMMA Xi } COMMA x = { xr COMMA xi } COMMA Xx = { Xxr COMMA Xxi } COMMA c = { cr COMMA ci };
  fecomplex xn;
{const fecomplex X2 = fec_sqr(X);
const fecomplex x2 = fec_sqr(x);
xn=fec_add(fec_add(fec_add(fec_add(fec_mul(A,fec_add(fec_mul(fec_imul(2,X),x),x2)),fec_mul(fec_imul(3,X2),x)),fec_mul(fec_imul(3,X),x2)),fec_mul(x2,x)),c);
}
  xrn = xn.re;
  xin = xn.im;
}

);

static const char *perturbation_opencl_floatexp_42_3_1 = STR(

{const fecomplex X2 = fec_sqr(X);
dn=fec_add(fec_mul(fec_add(fec_mul(A,fec_imul(2,X)),fec_imul(3,X2)),d),d0);
}

{const fecomplex X2 = fec_sqr(X);
const fecomplex x2 = fec_sqr(x);
xn=fec_add(fec_add(fec_add(fec_add(fec_mul(A,fec_add(fec_mul(fec_imul(2,X),x),x2)),fec_mul(fec_imul(3,X2),x)),fec_mul(fec_imul(3,X),x2)),fec_mul(x2,x)),c);
}

);

#if 0
static const char *perturbation_opencl_softfloat_42_3_0 = STR(

{const sfcomplex X2 = sfc_sqr(X);
const sfcomplex x2 = sfc_sqr(x);
xn=sfc_add(sfc_add(sfc_add(sfc_add(sfc_mul(A,sfc_add(sfc_mul(sfc_imul(2,X),x),x2)),sfc_mul(sfc_imul(3,X2),x)),sfc_mul(sfc_imul(3,X),x2)),sfc_mul(x2,x)),c);
}

);
#endif


static const char *perturbation_opencl_double_43_3_0 = STR(

{
  const dcomplex X = { Xr COMMA Xi } COMMA x = { xr COMMA xi } COMMA Xx = { Xxr COMMA Xxi } COMMA c = { cr COMMA ci };
  dcomplex xn;
{const dcomplex X2 = dc_sqr(X);
const dcomplex x2 = dc_sqr(x);
xn=dc_add(dc_sub(dc_sub(dc_sub(dc_mul(A,dc_add(dc_mul(dc_imul(2,X),x),x2)),dc_mul(dc_imul(3,X2),x)),dc_mul(dc_imul(3,X),x2)),dc_mul(x2,x)),c);
}
  xrn = xn.re;
  xin = xn.im;
}

);

static const char *perturbation_opencl_double_43_3_1 = STR(

{const dcomplex X2 = dc_sqr(X);
dn=dc_add(dc_mul(dc_sub(dc_mul(A,dc_imul(2,X)),dc_imul(3,X2)),d),d0);
}

{const dcomplex X2 = dc_sqr(X);
const dcomplex x2 = dc_sqr(x);
xn=dc_add(dc_sub(dc_sub(dc_sub(dc_mul(A,dc_add(dc_mul(dc_imul(2,X),x),x2)),dc_mul(dc_imul(3,X2),x)),dc_mul(dc_imul(3,X),x2)),dc_mul(x2,x)),c);
}

);

static const char *perturbation_opencl_floatexp_43_3_0 = STR(

{
  const fecomplex X = { Xr COMMA Xi } COMMA x = { xr COMMA xi } COMMA Xx = { Xxr COMMA Xxi } COMMA c = { cr COMMA ci };
  fecomplex xn;
{const fecomplex X2 = fec_sqr(X);
const fecomplex x2 = fec_sqr(x);
xn=fec_add(fec_sub(fec_sub(fec_sub(fec_mul(A,fec_add(fec_mul(fec_imul(2,X),x),x2)),fec_mul(fec_imul(3,X2),x)),fec_mul(fec_imul(3,X),x2)),fec_mul(x2,x)),c);
}
  xrn = xn.re;
  xin = xn.im;
}

);

static const char *perturbation_opencl_floatexp_43_3_1 = STR(

{const fecomplex X2 = fec_sqr(X);
dn=fec_add(fec_mul(fec_sub(fec_mul(A,fec_imul(2,X)),fec_imul(3,X2)),d),d0);
}

{const fecomplex X2 = fec_sqr(X);
const fecomplex x2 = fec_sqr(x);
xn=fec_add(fec_sub(fec_sub(fec_sub(fec_mul(A,fec_add(fec_mul(fec_imul(2,X),x),x2)),fec_mul(fec_imul(3,X2),x)),fec_mul(fec_imul(3,X),x2)),fec_mul(x2,x)),c);
}

);

#if 0
static const char *perturbation_opencl_softfloat_43_3_0 = STR(

{const sfcomplex X2 = sfc_sqr(X);
const sfcomplex x2 = sfc_sqr(x);
xn=sfc_add(sfc_sub(sfc_sub(sfc_sub(sfc_mul(A,sfc_add(sfc_mul(sfc_imul(2,X),x),x2)),sfc_mul(sfc_imul(3,X2),x)),sfc_mul(sfc_imul(3,X),x2)),sfc_mul(x2,x)),c);
}

);
#endif


static const char *perturbation_opencl_double_44_3_0 = STR(

{
  const dcomplex X = { Xr COMMA Xi } COMMA x = { xr COMMA xi } COMMA Xx = { Xxr COMMA Xxi } COMMA c = { cr COMMA ci };
  dcomplex xn;
{const dcomplex X2 = dc_sqr(X);
const dcomplex x2 = dc_sqr(x);
xn=dc_add(dc_sub(dc_sub(dc_sub(dc_imul(2,dc_add(dc_mul(dc_imul(2,X),x),x2)),dc_mul(dc_imul(3,X2),x)),dc_mul(dc_imul(3,X),x2)),dc_mul(x2,x)),c);
}
  xrn = xn.re;
  xin = xn.im;
}

);

static const char *perturbation_opencl_double_44_3_1 = STR(

{const dcomplex X2 = dc_sqr(X);
dn=dc_add(dc_mul(dc_sub(dc_imul(4,X),dc_imul(3,X2)),d),d0);
}

{const dcomplex X2 = dc_sqr(X);
const dcomplex x2 = dc_sqr(x);
xn=dc_add(dc_sub(dc_sub(dc_sub(dc_imul(2,dc_add(dc_mul(dc_imul(2,X),x),x2)),dc_mul(dc_imul(3,X2),x)),dc_mul(dc_imul(3,X),x2)),dc_mul(x2,x)),c);
}

);

static const char *perturbation_opencl_floatexp_44_3_0 = STR(

{
  const fecomplex X = { Xr COMMA Xi } COMMA x = { xr COMMA xi } COMMA Xx = { Xxr COMMA Xxi } COMMA c = { cr COMMA ci };
  fecomplex xn;
{const fecomplex X2 = fec_sqr(X);
const fecomplex x2 = fec_sqr(x);
xn=fec_add(fec_sub(fec_sub(fec_sub(fec_imul(2,fec_add(fec_mul(fec_imul(2,X),x),x2)),fec_mul(fec_imul(3,X2),x)),fec_mul(fec_imul(3,X),x2)),fec_mul(x2,x)),c);
}
  xrn = xn.re;
  xin = xn.im;
}

);

static const char *perturbation_opencl_floatexp_44_3_1 = STR(

{const fecomplex X2 = fec_sqr(X);
dn=fec_add(fec_mul(fec_sub(fec_imul(4,X),fec_imul(3,X2)),d),d0);
}

{const fecomplex X2 = fec_sqr(X);
const fecomplex x2 = fec_sqr(x);
xn=fec_add(fec_sub(fec_sub(fec_sub(fec_imul(2,fec_add(fec_mul(fec_imul(2,X),x),x2)),fec_mul(fec_imul(3,X2),x)),fec_mul(fec_imul(3,X),x2)),fec_mul(x2,x)),c);
}

);

#if 0
static const char *perturbation_opencl_softfloat_44_3_0 = STR(

{const sfcomplex X2 = sfc_sqr(X);
const sfcomplex x2 = sfc_sqr(x);
xn=sfc_add(sfc_sub(sfc_sub(sfc_sub(sfc_imul(2,sfc_add(sfc_mul(sfc_imul(2,X),x),x2)),sfc_mul(sfc_imul(3,X2),x)),sfc_mul(sfc_imul(3,X),x2)),sfc_mul(x2,x)),c);
}

);
#endif


static const char *perturbation_opencl_double_45_4_0 = STR(

{
  const dcomplex X = { Xr COMMA Xi } COMMA x = { xr COMMA xi } COMMA Xx = { Xxr COMMA Xxi } COMMA c = { cr COMMA ci };
  dcomplex xn;
{const dcomplex x2 = dc_sqr(x);
xn=dc_add(dc_add(dc_add(dc_add(dc_add(dc_mul(A,dc_add(dc_mul(dc_imul(2,X),x),x2)),dc_mul(dc_imul(4,dc_powi(X,3)),x)),dc_mul(dc_imul(6,dc_powi(X,2)),x2)),dc_mul(dc_mul(dc_imul(4,X),x2),x)),dc_powi(x2,2)),c);
}
  xrn = xn.re;
  xin = xn.im;
}

);

static const char *perturbation_opencl_double_45_4_1 = STR(

{const dcomplex X2 = dc_sqr(X);
dn=dc_add(dc_mul(dc_mul(dc_add(dc_muli(A,2),dc_imul(4,X2)),X),d),d0);
}

{const dcomplex x2 = dc_sqr(x);
xn=dc_add(dc_add(dc_add(dc_add(dc_add(dc_mul(A,dc_add(dc_mul(dc_imul(2,X),x),x2)),dc_mul(dc_imul(4,dc_powi(X,3)),x)),dc_mul(dc_imul(6,dc_powi(X,2)),x2)),dc_mul(dc_mul(dc_imul(4,X),x2),x)),dc_powi(x2,2)),c);
}

);

static const char *perturbation_opencl_floatexp_45_4_0 = STR(

{
  const fecomplex X = { Xr COMMA Xi } COMMA x = { xr COMMA xi } COMMA Xx = { Xxr COMMA Xxi } COMMA c = { cr COMMA ci };
  fecomplex xn;
{const fecomplex x2 = fec_sqr(x);
xn=fec_add(fec_add(fec_add(fec_add(fec_add(fec_mul(A,fec_add(fec_mul(fec_imul(2,X),x),x2)),fec_mul(fec_imul(4,fec_powi(X,3)),x)),fec_mul(fec_imul(6,fec_powi(X,2)),x2)),fec_mul(fec_mul(fec_imul(4,X),x2),x)),fec_powi(x2,2)),c);
}
  xrn = xn.re;
  xin = xn.im;
}

);

static const char *perturbation_opencl_floatexp_45_4_1 = STR(

{const fecomplex X2 = fec_sqr(X);
dn=fec_add(fec_mul(fec_mul(fec_add(fec_muli(A,2),fec_imul(4,X2)),X),d),d0);
}

{const fecomplex x2 = fec_sqr(x);
xn=fec_add(fec_add(fec_add(fec_add(fec_add(fec_mul(A,fec_add(fec_mul(fec_imul(2,X),x),x2)),fec_mul(fec_imul(4,fec_powi(X,3)),x)),fec_mul(fec_imul(6,fec_powi(X,2)),x2)),fec_mul(fec_mul(fec_imul(4,X),x2),x)),fec_powi(x2,2)),c);
}

);

#if 0
static const char *perturbation_opencl_softfloat_45_4_0 = STR(

{const sfcomplex x2 = sfc_sqr(x);
xn=sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_mul(A,sfc_add(sfc_mul(sfc_imul(2,X),x),x2)),sfc_mul(sfc_imul(4,sfc_powi(X,3)),x)),sfc_mul(sfc_imul(6,sfc_powi(X,2)),x2)),sfc_mul(sfc_mul(sfc_imul(4,X),x2),x)),sfc_powi(x2,2)),c);
}

);
#endif


static const char *perturbation_opencl_double_46_4_0 = STR(

{
  const dcomplex X = { Xr COMMA Xi } COMMA x = { xr COMMA xi } COMMA Xx = { Xxr COMMA Xxi } COMMA c = { cr COMMA ci };
  dcomplex xn;
{const dcomplex x2 = dc_sqr(x);
xn=dc_add(dc_sub(dc_sub(dc_sub(dc_sub(dc_mul(A,dc_add(dc_mul(dc_imul(2,X),x),x2)),dc_mul(dc_imul(4,dc_powi(X,3)),x)),dc_mul(dc_imul(6,dc_powi(X,2)),x2)),dc_mul(dc_mul(dc_imul(4,X),x2),x)),dc_powi(x2,2)),c);
}
  xrn = xn.re;
  xin = xn.im;
}

);

static const char *perturbation_opencl_double_46_4_1 = STR(

{const dcomplex X2 = dc_sqr(X);
dn=dc_add(dc_mul(dc_mul(dc_sub(dc_muli(A,2),dc_imul(4,X2)),X),d),d0);
}

{const dcomplex x2 = dc_sqr(x);
xn=dc_add(dc_sub(dc_sub(dc_sub(dc_sub(dc_mul(A,dc_add(dc_mul(dc_imul(2,X),x),x2)),dc_mul(dc_imul(4,dc_powi(X,3)),x)),dc_mul(dc_imul(6,dc_powi(X,2)),x2)),dc_mul(dc_mul(dc_imul(4,X),x2),x)),dc_powi(x2,2)),c);
}

);

static const char *perturbation_opencl_floatexp_46_4_0 = STR(

{
  const fecomplex X = { Xr COMMA Xi } COMMA x = { xr COMMA xi } COMMA Xx = { Xxr COMMA Xxi } COMMA c = { cr COMMA ci };
  fecomplex xn;
{const fecomplex x2 = fec_sqr(x);
xn=fec_add(fec_sub(fec_sub(fec_sub(fec_sub(fec_mul(A,fec_add(fec_mul(fec_imul(2,X),x),x2)),fec_mul(fec_imul(4,fec_powi(X,3)),x)),fec_mul(fec_imul(6,fec_powi(X,2)),x2)),fec_mul(fec_mul(fec_imul(4,X),x2),x)),fec_powi(x2,2)),c);
}
  xrn = xn.re;
  xin = xn.im;
}

);

static const char *perturbation_opencl_floatexp_46_4_1 = STR(

{const fecomplex X2 = fec_sqr(X);
dn=fec_add(fec_mul(fec_mul(fec_sub(fec_muli(A,2),fec_imul(4,X2)),X),d),d0);
}

{const fecomplex x2 = fec_sqr(x);
xn=fec_add(fec_sub(fec_sub(fec_sub(fec_sub(fec_mul(A,fec_add(fec_mul(fec_imul(2,X),x),x2)),fec_mul(fec_imul(4,fec_powi(X,3)),x)),fec_mul(fec_imul(6,fec_powi(X,2)),x2)),fec_mul(fec_mul(fec_imul(4,X),x2),x)),fec_powi(x2,2)),c);
}

);

#if 0
static const char *perturbation_opencl_softfloat_46_4_0 = STR(

{const sfcomplex x2 = sfc_sqr(x);
xn=sfc_add(sfc_sub(sfc_sub(sfc_sub(sfc_sub(sfc_mul(A,sfc_add(sfc_mul(sfc_imul(2,X),x),x2)),sfc_mul(sfc_imul(4,sfc_powi(X,3)),x)),sfc_mul(sfc_imul(6,sfc_powi(X,2)),x2)),sfc_mul(sfc_mul(sfc_imul(4,X),x2),x)),sfc_powi(x2,2)),c);
}

);
#endif


static const char *perturbation_opencl_double_47_5_0 = STR(

{
  const dcomplex X = { Xr COMMA Xi } COMMA x = { xr COMMA xi } COMMA Xx = { Xxr COMMA Xxi } COMMA c = { cr COMMA ci };
  dcomplex xn;
{const dcomplex x2 = dc_sqr(x);
xn=dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_mul(A,dc_add(dc_mul(dc_imul(2,X),x),x2)),dc_mul(dc_imul(5,dc_powi(X,4)),x)),dc_mul(dc_imul(10,dc_powi(X,3)),x2)),dc_mul(dc_mul(dc_imul(10,dc_powi(X,2)),x2),x)),dc_mul(dc_imul(5,X),dc_powi(x2,2))),dc_mul(dc_mul(x2,x2),x)),c);
}
  xrn = xn.re;
  xin = xn.im;
}

);

static const char *perturbation_opencl_double_47_5_1 = STR(

{const dcomplex X2 = dc_sqr(X);
dn=dc_add(dc_mul(dc_mul(dc_add(dc_muli(A,2),dc_mul(dc_imul(5,X2),X)),X),d),d0);
}

{const dcomplex x2 = dc_sqr(x);
xn=dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_mul(A,dc_add(dc_mul(dc_imul(2,X),x),x2)),dc_mul(dc_imul(5,dc_powi(X,4)),x)),dc_mul(dc_imul(10,dc_powi(X,3)),x2)),dc_mul(dc_mul(dc_imul(10,dc_powi(X,2)),x2),x)),dc_mul(dc_imul(5,X),dc_powi(x2,2))),dc_mul(dc_mul(x2,x2),x)),c);
}

);

static const char *perturbation_opencl_floatexp_47_5_0 = STR(

{
  const fecomplex X = { Xr COMMA Xi } COMMA x = { xr COMMA xi } COMMA Xx = { Xxr COMMA Xxi } COMMA c = { cr COMMA ci };
  fecomplex xn;
{const fecomplex x2 = fec_sqr(x);
xn=fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_mul(A,fec_add(fec_mul(fec_imul(2,X),x),x2)),fec_mul(fec_imul(5,fec_powi(X,4)),x)),fec_mul(fec_imul(10,fec_powi(X,3)),x2)),fec_mul(fec_mul(fec_imul(10,fec_powi(X,2)),x2),x)),fec_mul(fec_imul(5,X),fec_powi(x2,2))),fec_mul(fec_mul(x2,x2),x)),c);
}
  xrn = xn.re;
  xin = xn.im;
}

);

static const char *perturbation_opencl_floatexp_47_5_1 = STR(

{const fecomplex X2 = fec_sqr(X);
dn=fec_add(fec_mul(fec_mul(fec_add(fec_muli(A,2),fec_mul(fec_imul(5,X2),X)),X),d),d0);
}

{const fecomplex x2 = fec_sqr(x);
xn=fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_mul(A,fec_add(fec_mul(fec_imul(2,X),x),x2)),fec_mul(fec_imul(5,fec_powi(X,4)),x)),fec_mul(fec_imul(10,fec_powi(X,3)),x2)),fec_mul(fec_mul(fec_imul(10,fec_powi(X,2)),x2),x)),fec_mul(fec_imul(5,X),fec_powi(x2,2))),fec_mul(fec_mul(x2,x2),x)),c);
}

);

#if 0
static const char *perturbation_opencl_softfloat_47_5_0 = STR(

{const sfcomplex x2 = sfc_sqr(x);
xn=sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_mul(A,sfc_add(sfc_mul(sfc_imul(2,X),x),x2)),sfc_mul(sfc_imul(5,sfc_powi(X,4)),x)),sfc_mul(sfc_imul(10,sfc_powi(X,3)),x2)),sfc_mul(sfc_mul(sfc_imul(10,sfc_powi(X,2)),x2),x)),sfc_mul(sfc_imul(5,X),sfc_powi(x2,2))),sfc_mul(sfc_mul(x2,x2),x)),c);
}

);
#endif


static const char *perturbation_opencl_double_48_5_0 = STR(

{
  const dcomplex X = { Xr COMMA Xi } COMMA x = { xr COMMA xi } COMMA Xx = { Xxr COMMA Xxi } COMMA c = { cr COMMA ci };
  dcomplex xn;
{const dcomplex x2 = dc_sqr(x);
xn=dc_add(dc_sub(dc_sub(dc_sub(dc_sub(dc_sub(dc_mul(A,dc_add(dc_mul(dc_imul(2,X),x),x2)),dc_mul(dc_imul(5,dc_powi(X,4)),x)),dc_mul(dc_imul(10,dc_powi(X,3)),x2)),dc_mul(dc_mul(dc_imul(10,dc_powi(X,2)),x2),x)),dc_mul(dc_imul(5,X),dc_powi(x2,2))),dc_mul(dc_mul(x2,x2),x)),c);
}
  xrn = xn.re;
  xin = xn.im;
}

);

static const char *perturbation_opencl_double_48_5_1 = STR(

{const dcomplex X2 = dc_sqr(X);
dn=dc_add(dc_mul(dc_mul(dc_sub(dc_muli(A,2),dc_mul(dc_imul(5,X2),X)),X),d),d0);
}

{const dcomplex x2 = dc_sqr(x);
xn=dc_add(dc_sub(dc_sub(dc_sub(dc_sub(dc_sub(dc_mul(A,dc_add(dc_mul(dc_imul(2,X),x),x2)),dc_mul(dc_imul(5,dc_powi(X,4)),x)),dc_mul(dc_imul(10,dc_powi(X,3)),x2)),dc_mul(dc_mul(dc_imul(10,dc_powi(X,2)),x2),x)),dc_mul(dc_imul(5,X),dc_powi(x2,2))),dc_mul(dc_mul(x2,x2),x)),c);
}

);

static const char *perturbation_opencl_floatexp_48_5_0 = STR(

{
  const fecomplex X = { Xr COMMA Xi } COMMA x = { xr COMMA xi } COMMA Xx = { Xxr COMMA Xxi } COMMA c = { cr COMMA ci };
  fecomplex xn;
{const fecomplex x2 = fec_sqr(x);
xn=fec_add(fec_sub(fec_sub(fec_sub(fec_sub(fec_sub(fec_mul(A,fec_add(fec_mul(fec_imul(2,X),x),x2)),fec_mul(fec_imul(5,fec_powi(X,4)),x)),fec_mul(fec_imul(10,fec_powi(X,3)),x2)),fec_mul(fec_mul(fec_imul(10,fec_powi(X,2)),x2),x)),fec_mul(fec_imul(5,X),fec_powi(x2,2))),fec_mul(fec_mul(x2,x2),x)),c);
}
  xrn = xn.re;
  xin = xn.im;
}

);

static const char *perturbation_opencl_floatexp_48_5_1 = STR(

{const fecomplex X2 = fec_sqr(X);
dn=fec_add(fec_mul(fec_mul(fec_sub(fec_muli(A,2),fec_mul(fec_imul(5,X2),X)),X),d),d0);
}

{const fecomplex x2 = fec_sqr(x);
xn=fec_add(fec_sub(fec_sub(fec_sub(fec_sub(fec_sub(fec_mul(A,fec_add(fec_mul(fec_imul(2,X),x),x2)),fec_mul(fec_imul(5,fec_powi(X,4)),x)),fec_mul(fec_imul(10,fec_powi(X,3)),x2)),fec_mul(fec_mul(fec_imul(10,fec_powi(X,2)),x2),x)),fec_mul(fec_imul(5,X),fec_powi(x2,2))),fec_mul(fec_mul(x2,x2),x)),c);
}

);

#if 0
static const char *perturbation_opencl_softfloat_48_5_0 = STR(

{const sfcomplex x2 = sfc_sqr(x);
xn=sfc_add(sfc_sub(sfc_sub(sfc_sub(sfc_sub(sfc_sub(sfc_mul(A,sfc_add(sfc_mul(sfc_imul(2,X),x),x2)),sfc_mul(sfc_imul(5,sfc_powi(X,4)),x)),sfc_mul(sfc_imul(10,sfc_powi(X,3)),x2)),sfc_mul(sfc_mul(sfc_imul(10,sfc_powi(X,2)),x2),x)),sfc_mul(sfc_imul(5,X),sfc_powi(x2,2))),sfc_mul(sfc_mul(x2,x2),x)),c);
}

);
#endif


static const char *perturbation_opencl_double_49_6_0 = STR(

{
  const dcomplex X = { Xr COMMA Xi } COMMA x = { xr COMMA xi } COMMA Xx = { Xxr COMMA Xxi } COMMA c = { cr COMMA ci };
  dcomplex xn;
{const dcomplex x2 = dc_sqr(x);
xn=dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_mul(A,dc_add(dc_mul(dc_imul(2,X),x),x2)),dc_mul(dc_imul(6,dc_powi(X,5)),x)),dc_mul(dc_imul(15,dc_powi(X,4)),x2)),dc_mul(dc_imul(20,dc_powi(X,3)),dc_mul(x2,x))),dc_mul(dc_imul(15,dc_powi(X,2)),dc_powi(x2,2))),dc_mul(dc_imul(6,X),dc_mul(dc_mul(x2,x2),x))),dc_powi(x2,3)),c);
}
  xrn = xn.re;
  xin = xn.im;
}

);

static const char *perturbation_opencl_double_49_6_1 = STR(

{const dcomplex X2 = dc_sqr(X);
dn=dc_add(dc_mul(dc_mul(dc_add(dc_muli(A,2),dc_mul(dc_imul(6,X2),X2)),X),d),d0);
}

{const dcomplex x2 = dc_sqr(x);
xn=dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_add(dc_mul(A,dc_add(dc_mul(dc_imul(2,X),x),x2)),dc_mul(dc_imul(6,dc_powi(X,5)),x)),dc_mul(dc_imul(15,dc_powi(X,4)),x2)),dc_mul(dc_imul(20,dc_powi(X,3)),dc_mul(x2,x))),dc_mul(dc_imul(15,dc_powi(X,2)),dc_powi(x2,2))),dc_mul(dc_imul(6,X),dc_mul(dc_mul(x2,x2),x))),dc_powi(x2,3)),c);
}

);

static const char *perturbation_opencl_floatexp_49_6_0 = STR(

{
  const fecomplex X = { Xr COMMA Xi } COMMA x = { xr COMMA xi } COMMA Xx = { Xxr COMMA Xxi } COMMA c = { cr COMMA ci };
  fecomplex xn;
{const fecomplex x2 = fec_sqr(x);
xn=fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_mul(A,fec_add(fec_mul(fec_imul(2,X),x),x2)),fec_mul(fec_imul(6,fec_powi(X,5)),x)),fec_mul(fec_imul(15,fec_powi(X,4)),x2)),fec_mul(fec_imul(20,fec_powi(X,3)),fec_mul(x2,x))),fec_mul(fec_imul(15,fec_powi(X,2)),fec_powi(x2,2))),fec_mul(fec_imul(6,X),fec_mul(fec_mul(x2,x2),x))),fec_powi(x2,3)),c);
}
  xrn = xn.re;
  xin = xn.im;
}

);

static const char *perturbation_opencl_floatexp_49_6_1 = STR(

{const fecomplex X2 = fec_sqr(X);
dn=fec_add(fec_mul(fec_mul(fec_add(fec_muli(A,2),fec_mul(fec_imul(6,X2),X2)),X),d),d0);
}

{const fecomplex x2 = fec_sqr(x);
xn=fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_add(fec_mul(A,fec_add(fec_mul(fec_imul(2,X),x),x2)),fec_mul(fec_imul(6,fec_powi(X,5)),x)),fec_mul(fec_imul(15,fec_powi(X,4)),x2)),fec_mul(fec_imul(20,fec_powi(X,3)),fec_mul(x2,x))),fec_mul(fec_imul(15,fec_powi(X,2)),fec_powi(x2,2))),fec_mul(fec_imul(6,X),fec_mul(fec_mul(x2,x2),x))),fec_powi(x2,3)),c);
}

);

#if 0
static const char *perturbation_opencl_softfloat_49_6_0 = STR(

{const sfcomplex x2 = sfc_sqr(x);
xn=sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_mul(A,sfc_add(sfc_mul(sfc_imul(2,X),x),x2)),sfc_mul(sfc_imul(6,sfc_powi(X,5)),x)),sfc_mul(sfc_imul(15,sfc_powi(X,4)),x2)),sfc_mul(sfc_imul(20,sfc_powi(X,3)),sfc_mul(x2,x))),sfc_mul(sfc_imul(15,sfc_powi(X,2)),sfc_powi(x2,2))),sfc_mul(sfc_imul(6,X),sfc_mul(sfc_mul(x2,x2),x))),sfc_powi(x2,3)),c);
}

);
#endif


static const char *perturbation_opencl_double_50_6_0 = STR(

{
  const dcomplex X = { Xr COMMA Xi } COMMA x = { xr COMMA xi } COMMA Xx = { Xxr COMMA Xxi } COMMA c = { cr COMMA ci };
  dcomplex xn;
{xn=dc_add(dc_sub(dc_sub(dc_sub(dc_sub(dc_sub(dc_sub(dc_mul(A,dc_add(dc_mul(dc_imul(2,X),x),dc_powi(x,2))),dc_mul(dc_imul(6,dc_powi(X,5)),x)),dc_mul(dc_imul(15,dc_powi(X,4)),dc_powi(x,2))),dc_mul(dc_imul(20,dc_powi(X,3)),dc_powi(x,3))),dc_mul(dc_imul(15,dc_powi(X,2)),dc_powi(x,4))),dc_mul(dc_imul(6,X),dc_powi(x,5))),dc_powi(x,6)),c);
}
  xrn = xn.re;
  xin = xn.im;
}

);

static const char *perturbation_opencl_double_50_6_1 = STR(

{const dcomplex X2 = dc_sqr(X);
dn=dc_add(dc_mul(dc_mul(dc_sub(dc_muli(A,2),dc_mul(dc_imul(6,X2),X2)),X),d),d0);
}

{xn=dc_add(dc_sub(dc_sub(dc_sub(dc_sub(dc_sub(dc_sub(dc_mul(A,dc_add(dc_mul(dc_imul(2,X),x),dc_powi(x,2))),dc_mul(dc_imul(6,dc_powi(X,5)),x)),dc_mul(dc_imul(15,dc_powi(X,4)),dc_powi(x,2))),dc_mul(dc_imul(20,dc_powi(X,3)),dc_powi(x,3))),dc_mul(dc_imul(15,dc_powi(X,2)),dc_powi(x,4))),dc_mul(dc_imul(6,X),dc_powi(x,5))),dc_powi(x,6)),c);
}

);

static const char *perturbation_opencl_floatexp_50_6_0 = STR(

{
  const fecomplex X = { Xr COMMA Xi } COMMA x = { xr COMMA xi } COMMA Xx = { Xxr COMMA Xxi } COMMA c = { cr COMMA ci };
  fecomplex xn;
{xn=fec_add(fec_sub(fec_sub(fec_sub(fec_sub(fec_sub(fec_sub(fec_mul(A,fec_add(fec_mul(fec_imul(2,X),x),fec_powi(x,2))),fec_mul(fec_imul(6,fec_powi(X,5)),x)),fec_mul(fec_imul(15,fec_powi(X,4)),fec_powi(x,2))),fec_mul(fec_imul(20,fec_powi(X,3)),fec_powi(x,3))),fec_mul(fec_imul(15,fec_powi(X,2)),fec_powi(x,4))),fec_mul(fec_imul(6,X),fec_powi(x,5))),fec_powi(x,6)),c);
}
  xrn = xn.re;
  xin = xn.im;
}

);

static const char *perturbation_opencl_floatexp_50_6_1 = STR(

{const fecomplex X2 = fec_sqr(X);
dn=fec_add(fec_mul(fec_mul(fec_sub(fec_muli(A,2),fec_mul(fec_imul(6,X2),X2)),X),d),d0);
}

{xn=fec_add(fec_sub(fec_sub(fec_sub(fec_sub(fec_sub(fec_sub(fec_mul(A,fec_add(fec_mul(fec_imul(2,X),x),fec_powi(x,2))),fec_mul(fec_imul(6,fec_powi(X,5)),x)),fec_mul(fec_imul(15,fec_powi(X,4)),fec_powi(x,2))),fec_mul(fec_imul(20,fec_powi(X,3)),fec_powi(x,3))),fec_mul(fec_imul(15,fec_powi(X,2)),fec_powi(x,4))),fec_mul(fec_imul(6,X),fec_powi(x,5))),fec_powi(x,6)),c);
}

);

#if 0
static const char *perturbation_opencl_softfloat_50_6_0 = STR(

{xn=sfc_add(sfc_sub(sfc_sub(sfc_sub(sfc_sub(sfc_sub(sfc_sub(sfc_mul(A,sfc_add(sfc_mul(sfc_imul(2,X),x),sfc_powi(x,2))),sfc_mul(sfc_imul(6,sfc_powi(X,5)),x)),sfc_mul(sfc_imul(15,sfc_powi(X,4)),sfc_powi(x,2))),sfc_mul(sfc_imul(20,sfc_powi(X,3)),sfc_powi(x,3))),sfc_mul(sfc_imul(15,sfc_powi(X,2)),sfc_powi(x,4))),sfc_mul(sfc_imul(6,X),sfc_powi(x,5))),sfc_powi(x,6)),c);
}

);
#endif


static const char *perturbation_opencl_double_51_4_0 = STR(

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_sub(d_sub(d_add(d_mul(d_sub(Xr2,Xi2),d_diffabs(d_sub(Xr2,Xi2),d_sub(d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),d_mul(d_imul(2,Xi),xi)),xi2))),d_mul(d_sub(d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),d_mul(d_imul(2,Xi),xi)),xi2),d_abs(d_sub(d_sub(d_sub(d_add(d_add(Xr2,d_mul(d_imul(2,Xr),xr)),xr2),Xi2),d_mul(d_imul(2,Xi),xi)),xi2)))),d_mul(d_mul(d_imul(2,Xr),Xi),d_diffabs(d_mul(d_imul(2,Xr),Xi),d_add(d_add(d_mul(d_imul(2,Xr),xi),d_mul(d_imul(2,xr),Xi)),d_mul(d_imul(2,xr),xi))))),d_mul(d_add(d_add(d_mul(d_imul(2,Xr),xi),d_mul(d_imul(2,xr),Xi)),d_mul(d_imul(2,xr),xi)),d_abs(d_add(d_add(d_add(d_mul(d_imul(2,Xr),Xi),d_mul(d_imul(2,Xr),xi)),d_mul(d_imul(2,xr),Xi)),d_mul(d_imul(2,xr),xi))))),cr);
xin=d_add(d_add(d_add(d_add(d_mul(d_sub(Xr2,Xi2),d_diffabs(d_mul(d_imul(2,Xr),Xi),d_add(d_add(d_mul(d_imul(2,Xr),xi),d_mul(d_imul(2,xr),Xi)),d_mul(d_imul(2,xr),xi)))),d_mul(d_sub(d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),d_mul(d_imul(2,Xi),xi)),xi2),d_abs(d_add(d_add(d_add(d_mul(d_imul(2,Xr),Xi),d_mul(d_imul(2,Xr),xi)),d_mul(d_imul(2,xr),Xi)),d_mul(d_imul(2,xr),xi))))),d_mul(d_mul(d_imul(2,Xr),Xi),d_diffabs(d_sub(Xr2,Xi2),d_sub(d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),d_mul(d_imul(2,Xi),xi)),xi2)))),d_mul(d_add(d_add(d_mul(d_imul(2,Xr),xi),d_mul(d_imul(2,xr),Xi)),d_mul(d_imul(2,xr),xi)),d_abs(d_sub(d_sub(d_add(d_add(d_sub(Xr2,Xi2),d_mul(d_imul(2,Xr),xr)),xr2),d_mul(d_imul(2,Xi),xi)),xi2)))),ci);
}

);

static const char *perturbation_opencl_double_51_4_1 = STR(

{dxan=d_add(d_imul(2,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))))),d_add(d_imul(2,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr))),d_mul(Xxr,dxa))),d_add(d_imul(-2,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))))),d_add(d_imul(-2,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))))),d_add(d_imul(-2,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr))),d_mul(Xxi,dya))),d_add(d_imul(2,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dya,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))))),d_add(d_imul(-4,d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(Xxi,dxa))),d_add(d_imul(-4,d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(Xxr,dya))),d_add(d_imul(-4,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr))))))),d_add(d_imul(-4,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(Xxr))))))),daa))))))))));
dxbn=d_add(d_imul(2,d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))))),d_add(d_imul(2,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr))),d_mul(Xxr,dxb))),d_add(d_imul(-2,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))))),d_add(d_imul(-2,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))))),d_add(d_imul(-2,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr))),d_mul(Xxi,dyb))),d_add(d_imul(2,d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dyb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))))),d_add(d_imul(-4,d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(Xxi,dxb))),d_add(d_imul(-4,d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(Xxr,dyb))),d_add(d_imul(-4,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr))))))),d_add(d_imul(-4,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(Xxr))))))),dab))))))))));
dyan=d_add(d_imul(2,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr))),d_mul(Xxi,dxa))),d_add(d_imul(2,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr))),d_mul(Xxr,dya))),d_add(d_imul(2,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(Xxr))))))),d_add(d_imul(2,d_mul(d_sgn(Xxi),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dya,d_sgn(Xxr))))))),d_add(d_imul(-2,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxa,d_sgn(Xxr))))))),d_add(d_imul(-2,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_sgn(Xxr))))))),d_add(d_imul(4,d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(Xxr,dxa))),d_add(d_imul(-4,d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(Xxi,dya))),d_add(d_imul(4,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxa,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))))),d_add(d_imul(-4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))))),dba))))))))));
dybn=d_add(d_imul(2,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr))),d_mul(Xxi,dxb))),d_add(d_imul(2,d_mul(d_abs(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr))),d_mul(Xxr,dyb))),d_add(d_imul(2,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(Xxr))))))),d_add(d_imul(2,d_mul(d_sgn(Xxi),d_mul(Xxr,d_mul(Xxr,d_mul(Xxr,d_mul(dyb,d_sgn(Xxr))))))),d_add(d_imul(-2,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxi,d_mul(dxb,d_sgn(Xxr))))))),d_add(d_imul(-2,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_sgn(Xxr))))))),d_add(d_imul(4,d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(Xxr,dxb))),d_add(d_imul(-4,d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(Xxi,dyb))),d_add(d_imul(4,d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,d_mul(dxb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))))),d_add(d_imul(-4,d_mul(Xxi,d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_sgn(d_add(d_imul(-1,d_mul(Xxi,Xxi)),d_mul(Xxr,Xxr)))))))),dbb))))))))));
}

{const double Xr2 = d_mul(Xr, Xr);
const double Xi2 = d_mul(Xi, Xi);
const double xr2 = d_mul(xr, xr);
const double xi2 = d_mul(xi, xi);
xrn=d_add(d_sub(d_sub(d_add(d_mul(d_sub(Xr2,Xi2),d_diffabs(d_sub(Xr2,Xi2),d_sub(d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),d_mul(d_imul(2,Xi),xi)),xi2))),d_mul(d_sub(d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),d_mul(d_imul(2,Xi),xi)),xi2),d_abs(d_sub(d_sub(d_sub(d_add(d_add(Xr2,d_mul(d_imul(2,Xr),xr)),xr2),Xi2),d_mul(d_imul(2,Xi),xi)),xi2)))),d_mul(d_mul(d_imul(2,Xr),Xi),d_diffabs(d_mul(d_imul(2,Xr),Xi),d_add(d_add(d_mul(d_imul(2,Xr),xi),d_mul(d_imul(2,xr),Xi)),d_mul(d_imul(2,xr),xi))))),d_mul(d_add(d_add(d_mul(d_imul(2,Xr),xi),d_mul(d_imul(2,xr),Xi)),d_mul(d_imul(2,xr),xi)),d_abs(d_add(d_add(d_add(d_mul(d_imul(2,Xr),Xi),d_mul(d_imul(2,Xr),xi)),d_mul(d_imul(2,xr),Xi)),d_mul(d_imul(2,xr),xi))))),cr);
xin=d_add(d_add(d_add(d_add(d_mul(d_sub(Xr2,Xi2),d_diffabs(d_mul(d_imul(2,Xr),Xi),d_add(d_add(d_mul(d_imul(2,Xr),xi),d_mul(d_imul(2,xr),Xi)),d_mul(d_imul(2,xr),xi)))),d_mul(d_sub(d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),d_mul(d_imul(2,Xi),xi)),xi2),d_abs(d_add(d_add(d_add(d_mul(d_imul(2,Xr),Xi),d_mul(d_imul(2,Xr),xi)),d_mul(d_imul(2,xr),Xi)),d_mul(d_imul(2,xr),xi))))),d_mul(d_mul(d_imul(2,Xr),Xi),d_diffabs(d_sub(Xr2,Xi2),d_sub(d_sub(d_add(d_mul(d_imul(2,Xr),xr),xr2),d_mul(d_imul(2,Xi),xi)),xi2)))),d_mul(d_add(d_add(d_mul(d_imul(2,Xr),xi),d_mul(d_imul(2,xr),Xi)),d_mul(d_imul(2,xr),xi)),d_abs(d_sub(d_sub(d_add(d_add(d_sub(Xr2,Xi2),d_mul(d_imul(2,Xr),xr)),xr2),d_mul(d_imul(2,Xi),xi)),xi2)))),ci);
}

);

static const char *perturbation_opencl_floatexp_51_4_0 = STR(

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_add(fe_mul(fe_sub(Xr2,Xi2),fe_diffabs(fe_sub(Xr2,Xi2),fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),fe_mul(fe_imul(2,Xi),xi)),xi2))),fe_mul(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),fe_mul(fe_imul(2,Xi),xi)),xi2),fe_abs(fe_sub(fe_sub(fe_sub(fe_add(fe_add(Xr2,fe_mul(fe_imul(2,Xr),xr)),xr2),Xi2),fe_mul(fe_imul(2,Xi),xi)),xi2)))),fe_mul(fe_mul(fe_imul(2,Xr),Xi),fe_diffabs(fe_mul(fe_imul(2,Xr),Xi),fe_add(fe_add(fe_mul(fe_imul(2,Xr),xi),fe_mul(fe_imul(2,xr),Xi)),fe_mul(fe_imul(2,xr),xi))))),fe_mul(fe_add(fe_add(fe_mul(fe_imul(2,Xr),xi),fe_mul(fe_imul(2,xr),Xi)),fe_mul(fe_imul(2,xr),xi)),fe_abs(fe_add(fe_add(fe_add(fe_mul(fe_imul(2,Xr),Xi),fe_mul(fe_imul(2,Xr),xi)),fe_mul(fe_imul(2,xr),Xi)),fe_mul(fe_imul(2,xr),xi))))),cr);
xin=fe_add(fe_add(fe_add(fe_add(fe_mul(fe_sub(Xr2,Xi2),fe_diffabs(fe_mul(fe_imul(2,Xr),Xi),fe_add(fe_add(fe_mul(fe_imul(2,Xr),xi),fe_mul(fe_imul(2,xr),Xi)),fe_mul(fe_imul(2,xr),xi)))),fe_mul(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),fe_mul(fe_imul(2,Xi),xi)),xi2),fe_abs(fe_add(fe_add(fe_add(fe_mul(fe_imul(2,Xr),Xi),fe_mul(fe_imul(2,Xr),xi)),fe_mul(fe_imul(2,xr),Xi)),fe_mul(fe_imul(2,xr),xi))))),fe_mul(fe_mul(fe_imul(2,Xr),Xi),fe_diffabs(fe_sub(Xr2,Xi2),fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),fe_mul(fe_imul(2,Xi),xi)),xi2)))),fe_mul(fe_add(fe_add(fe_mul(fe_imul(2,Xr),xi),fe_mul(fe_imul(2,xr),Xi)),fe_mul(fe_imul(2,xr),xi)),fe_abs(fe_sub(fe_sub(fe_add(fe_add(fe_sub(Xr2,Xi2),fe_mul(fe_imul(2,Xr),xr)),xr2),fe_mul(fe_imul(2,Xi),xi)),xi2)))),ci);
}

);

static const char *perturbation_opencl_floatexp_51_4_1 = STR(

{dxan=fe_add(fe_imul(2,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(2,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr))),fe_mul(Xxr,dxa))),fe_add(fe_imul(-2,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(-2,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr))),fe_mul(Xxi,dya))),fe_add(fe_imul(2,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dya,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(Xxi,dxa))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(Xxr,dya))),fe_add(fe_imul(-4,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr))))))),fe_add(fe_imul(-4,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxr))))))),daa))))))))));
dxbn=fe_add(fe_imul(2,fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(2,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr))),fe_mul(Xxr,dxb))),fe_add(fe_imul(-2,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(-2,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr))),fe_mul(Xxi,dyb))),fe_add(fe_imul(2,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dyb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(Xxi,dxb))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(Xxr,dyb))),fe_add(fe_imul(-4,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr))))))),fe_add(fe_imul(-4,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxr))))))),dab))))))))));
dyan=fe_add(fe_imul(2,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr))),fe_mul(Xxi,dxa))),fe_add(fe_imul(2,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr))),fe_mul(Xxr,dya))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr))))))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxi),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxr))))))),fe_add(fe_imul(-2,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxa,fe_sgn(Xxr))))))),fe_add(fe_imul(-2,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxr))))))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(Xxr,dxa))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(Xxi,dya))),fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxa,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))))),dba))))))))));
dybn=fe_add(fe_imul(2,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr))),fe_mul(Xxi,dxb))),fe_add(fe_imul(2,fe_mul(fe_abs(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr))),fe_mul(Xxr,dyb))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr))))))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxi),fe_mul(Xxr,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxr))))))),fe_add(fe_imul(-2,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxi,fe_mul(dxb,fe_sgn(Xxr))))))),fe_add(fe_imul(-2,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxr))))))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(Xxr,dxb))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(Xxi,dyb))),fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,fe_mul(dxb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_sgn(fe_add(fe_imul(-1,fe_mul(Xxi,Xxi)),fe_mul(Xxr,Xxr)))))))),dbb))))))))));
}

{const floatexp Xr2 = fe_mul(Xr, Xr);
const floatexp Xi2 = fe_mul(Xi, Xi);
const floatexp xr2 = fe_mul(xr, xr);
const floatexp xi2 = fe_mul(xi, xi);
xrn=fe_add(fe_sub(fe_sub(fe_add(fe_mul(fe_sub(Xr2,Xi2),fe_diffabs(fe_sub(Xr2,Xi2),fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),fe_mul(fe_imul(2,Xi),xi)),xi2))),fe_mul(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),fe_mul(fe_imul(2,Xi),xi)),xi2),fe_abs(fe_sub(fe_sub(fe_sub(fe_add(fe_add(Xr2,fe_mul(fe_imul(2,Xr),xr)),xr2),Xi2),fe_mul(fe_imul(2,Xi),xi)),xi2)))),fe_mul(fe_mul(fe_imul(2,Xr),Xi),fe_diffabs(fe_mul(fe_imul(2,Xr),Xi),fe_add(fe_add(fe_mul(fe_imul(2,Xr),xi),fe_mul(fe_imul(2,xr),Xi)),fe_mul(fe_imul(2,xr),xi))))),fe_mul(fe_add(fe_add(fe_mul(fe_imul(2,Xr),xi),fe_mul(fe_imul(2,xr),Xi)),fe_mul(fe_imul(2,xr),xi)),fe_abs(fe_add(fe_add(fe_add(fe_mul(fe_imul(2,Xr),Xi),fe_mul(fe_imul(2,Xr),xi)),fe_mul(fe_imul(2,xr),Xi)),fe_mul(fe_imul(2,xr),xi))))),cr);
xin=fe_add(fe_add(fe_add(fe_add(fe_mul(fe_sub(Xr2,Xi2),fe_diffabs(fe_mul(fe_imul(2,Xr),Xi),fe_add(fe_add(fe_mul(fe_imul(2,Xr),xi),fe_mul(fe_imul(2,xr),Xi)),fe_mul(fe_imul(2,xr),xi)))),fe_mul(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),fe_mul(fe_imul(2,Xi),xi)),xi2),fe_abs(fe_add(fe_add(fe_add(fe_mul(fe_imul(2,Xr),Xi),fe_mul(fe_imul(2,Xr),xi)),fe_mul(fe_imul(2,xr),Xi)),fe_mul(fe_imul(2,xr),xi))))),fe_mul(fe_mul(fe_imul(2,Xr),Xi),fe_diffabs(fe_sub(Xr2,Xi2),fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,Xr),xr),xr2),fe_mul(fe_imul(2,Xi),xi)),xi2)))),fe_mul(fe_add(fe_add(fe_mul(fe_imul(2,Xr),xi),fe_mul(fe_imul(2,xr),Xi)),fe_mul(fe_imul(2,xr),xi)),fe_abs(fe_sub(fe_sub(fe_add(fe_add(fe_sub(Xr2,Xi2),fe_mul(fe_imul(2,Xr),xr)),xr2),fe_mul(fe_imul(2,Xi),xi)),xi2)))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_51_4_0 = STR(

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_sub(sf_sub(sf_add(sf_mul(sf_sub(Xr2,Xi2),sf_diffabs(sf_sub(Xr2,Xi2),sf_sub(sf_sub(sf_add(sf_mul(sf_imul(2,Xr),xr),xr2),sf_mul(sf_imul(2,Xi),xi)),xi2))),sf_mul(sf_sub(sf_sub(sf_add(sf_mul(sf_imul(2,Xr),xr),xr2),sf_mul(sf_imul(2,Xi),xi)),xi2),sf_abs(sf_sub(sf_sub(sf_sub(sf_add(sf_add(Xr2,sf_mul(sf_imul(2,Xr),xr)),xr2),Xi2),sf_mul(sf_imul(2,Xi),xi)),xi2)))),sf_mul(sf_mul(sf_imul(2,Xr),Xi),sf_diffabs(sf_mul(sf_imul(2,Xr),Xi),sf_add(sf_add(sf_mul(sf_imul(2,Xr),xi),sf_mul(sf_imul(2,xr),Xi)),sf_mul(sf_imul(2,xr),xi))))),sf_mul(sf_add(sf_add(sf_mul(sf_imul(2,Xr),xi),sf_mul(sf_imul(2,xr),Xi)),sf_mul(sf_imul(2,xr),xi)),sf_abs(sf_add(sf_add(sf_add(sf_mul(sf_imul(2,Xr),Xi),sf_mul(sf_imul(2,Xr),xi)),sf_mul(sf_imul(2,xr),Xi)),sf_mul(sf_imul(2,xr),xi))))),cr);
xin=sf_add(sf_add(sf_add(sf_add(sf_mul(sf_sub(Xr2,Xi2),sf_diffabs(sf_mul(sf_imul(2,Xr),Xi),sf_add(sf_add(sf_mul(sf_imul(2,Xr),xi),sf_mul(sf_imul(2,xr),Xi)),sf_mul(sf_imul(2,xr),xi)))),sf_mul(sf_sub(sf_sub(sf_add(sf_mul(sf_imul(2,Xr),xr),xr2),sf_mul(sf_imul(2,Xi),xi)),xi2),sf_abs(sf_add(sf_add(sf_add(sf_mul(sf_imul(2,Xr),Xi),sf_mul(sf_imul(2,Xr),xi)),sf_mul(sf_imul(2,xr),Xi)),sf_mul(sf_imul(2,xr),xi))))),sf_mul(sf_mul(sf_imul(2,Xr),Xi),sf_diffabs(sf_sub(Xr2,Xi2),sf_sub(sf_sub(sf_add(sf_mul(sf_imul(2,Xr),xr),xr2),sf_mul(sf_imul(2,Xi),xi)),xi2)))),sf_mul(sf_add(sf_add(sf_mul(sf_imul(2,Xr),xi),sf_mul(sf_imul(2,xr),Xi)),sf_mul(sf_imul(2,xr),xi)),sf_abs(sf_sub(sf_sub(sf_add(sf_add(sf_sub(Xr2,Xi2),sf_mul(sf_imul(2,Xr),xr)),xr2),sf_mul(sf_imul(2,Xi),xi)),xi2)))),ci);
}

);
#endif


static const char *perturbation_opencl_double_52_2_0 = STR(

{xrn=d_add(d_sub(d_sub(d_add(d_mul(d_imul(2,xr),Xr),d_mul(xr,xr)),d_mul(d_imul(2,Xi),xi)),d_mul(xi,xi)),cr);
xin=d_add(d_add(d_mul(d_imul(2,Ar),d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi))),d_mul(Ai,d_add(d_mul(d_imul(2,xr),Xr),d_mul(xr,xr)))),ci);
}

);

static const char *perturbation_opencl_double_52_2_1 = STR(

{dxan=d_add(d_add(d_imul(-2,d_mul(Xxi,dya)),d_imul(2,d_mul(Xxr,dxa))),daa);
dxbn=d_add(d_add(d_imul(-2,d_mul(Xxi,dyb)),d_imul(2,d_mul(Xxr,dxb))),dab);
dyan=d_add(d_add(d_imul(2,d_mul(Xxi,d_mul(dxa,g_FactorAR))),d_add(d_imul(2,d_mul(Xxr,d_mul(dxa,g_FactorAI))),d_imul(2,d_mul(Xxr,d_mul(dya,g_FactorAR))))),dba);
dybn=d_add(d_add(d_imul(2,d_mul(Xxi,d_mul(dxb,g_FactorAR))),d_add(d_imul(2,d_mul(Xxr,d_mul(dxb,g_FactorAI))),d_imul(2,d_mul(Xxr,d_mul(dyb,g_FactorAR))))),dbb);
}

{xrn=d_add(d_sub(d_sub(d_add(d_mul(d_imul(2,xr),Xr),d_mul(xr,xr)),d_mul(d_imul(2,Xi),xi)),d_mul(xi,xi)),cr);
xin=d_add(d_add(d_mul(d_imul(2,Ar),d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi))),d_mul(Ai,d_add(d_mul(d_imul(2,xr),Xr),d_mul(xr,xr)))),ci);
}

);

static const char *perturbation_opencl_floatexp_52_2_0 = STR(

{xrn=fe_add(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,xr),Xr),fe_mul(xr,xr)),fe_mul(fe_imul(2,Xi),xi)),fe_mul(xi,xi)),cr);
xin=fe_add(fe_add(fe_mul(fe_imul(2,Ar),fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi))),fe_mul(Ai,fe_add(fe_mul(fe_imul(2,xr),Xr),fe_mul(xr,xr)))),ci);
}

);

static const char *perturbation_opencl_floatexp_52_2_1 = STR(

{dxan=fe_add(fe_add(fe_imul(-2,fe_mul(Xxi,dya)),fe_imul(2,fe_mul(Xxr,dxa))),daa);
dxbn=fe_add(fe_add(fe_imul(-2,fe_mul(Xxi,dyb)),fe_imul(2,fe_mul(Xxr,dxb))),dab);
dyan=fe_add(fe_add(fe_imul(2,fe_mul(Xxi,fe_mul(dxa,g_FactorAR))),fe_add(fe_imul(2,fe_mul(Xxr,fe_mul(dxa,g_FactorAI))),fe_imul(2,fe_mul(Xxr,fe_mul(dya,g_FactorAR))))),dba);
dybn=fe_add(fe_add(fe_imul(2,fe_mul(Xxi,fe_mul(dxb,g_FactorAR))),fe_add(fe_imul(2,fe_mul(Xxr,fe_mul(dxb,g_FactorAI))),fe_imul(2,fe_mul(Xxr,fe_mul(dyb,g_FactorAR))))),dbb);
}

{xrn=fe_add(fe_sub(fe_sub(fe_add(fe_mul(fe_imul(2,xr),Xr),fe_mul(xr,xr)),fe_mul(fe_imul(2,Xi),xi)),fe_mul(xi,xi)),cr);
xin=fe_add(fe_add(fe_mul(fe_imul(2,Ar),fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi))),fe_mul(Ai,fe_add(fe_mul(fe_imul(2,xr),Xr),fe_mul(xr,xr)))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_52_2_0 = STR(

{xrn=sf_add(sf_sub(sf_sub(sf_add(sf_mul(sf_imul(2,xr),Xr),sf_mul(xr,xr)),sf_mul(sf_imul(2,Xi),xi)),sf_mul(xi,xi)),cr);
xin=sf_add(sf_add(sf_mul(sf_imul(2,Ar),sf_add(sf_add(sf_mul(Xr,xi),sf_mul(xr,Xi)),sf_mul(xr,xi))),sf_mul(Ai,sf_add(sf_mul(sf_imul(2,xr),Xr),sf_mul(xr,xr)))),ci);
}

);
#endif


static const char *perturbation_opencl_double_53_2_0 = STR(

{xrn=d_add(d_add(d_add(d_add(d_mul(d_imul(2,xr),Xr),d_mul(xr,xr)),d_mul(d_imul(2,Xi),xi)),d_mul(xi,xi)),cr);
xin=d_add(d_add(d_mul(d_imul(2,Ar),d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi))),d_mul(Ai,d_add(d_mul(d_imul(2,xr),Xr),d_mul(xr,xr)))),ci);
}

);

static const char *perturbation_opencl_double_53_2_1 = STR(

{dxan=d_add(d_add(d_imul(2,d_mul(Xxi,dya)),d_imul(2,d_mul(Xxr,dxa))),daa);
dxbn=d_add(d_add(d_imul(2,d_mul(Xxi,dyb)),d_imul(2,d_mul(Xxr,dxb))),dab);
dyan=d_add(d_add(d_imul(2,d_mul(Xxi,d_mul(dxa,g_FactorAR))),d_add(d_imul(2,d_mul(Xxr,d_mul(dxa,g_FactorAI))),d_imul(2,d_mul(Xxr,d_mul(dya,g_FactorAR))))),dba);
dybn=d_add(d_add(d_imul(2,d_mul(Xxi,d_mul(dxb,g_FactorAR))),d_add(d_imul(2,d_mul(Xxr,d_mul(dxb,g_FactorAI))),d_imul(2,d_mul(Xxr,d_mul(dyb,g_FactorAR))))),dbb);
}

{xrn=d_add(d_add(d_add(d_add(d_mul(d_imul(2,xr),Xr),d_mul(xr,xr)),d_mul(d_imul(2,Xi),xi)),d_mul(xi,xi)),cr);
xin=d_add(d_add(d_mul(d_imul(2,Ar),d_add(d_add(d_mul(Xr,xi),d_mul(xr,Xi)),d_mul(xr,xi))),d_mul(Ai,d_add(d_mul(d_imul(2,xr),Xr),d_mul(xr,xr)))),ci);
}

);

static const char *perturbation_opencl_floatexp_53_2_0 = STR(

{xrn=fe_add(fe_add(fe_add(fe_add(fe_mul(fe_imul(2,xr),Xr),fe_mul(xr,xr)),fe_mul(fe_imul(2,Xi),xi)),fe_mul(xi,xi)),cr);
xin=fe_add(fe_add(fe_mul(fe_imul(2,Ar),fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi))),fe_mul(Ai,fe_add(fe_mul(fe_imul(2,xr),Xr),fe_mul(xr,xr)))),ci);
}

);

static const char *perturbation_opencl_floatexp_53_2_1 = STR(

{dxan=fe_add(fe_add(fe_imul(2,fe_mul(Xxi,dya)),fe_imul(2,fe_mul(Xxr,dxa))),daa);
dxbn=fe_add(fe_add(fe_imul(2,fe_mul(Xxi,dyb)),fe_imul(2,fe_mul(Xxr,dxb))),dab);
dyan=fe_add(fe_add(fe_imul(2,fe_mul(Xxi,fe_mul(dxa,g_FactorAR))),fe_add(fe_imul(2,fe_mul(Xxr,fe_mul(dxa,g_FactorAI))),fe_imul(2,fe_mul(Xxr,fe_mul(dya,g_FactorAR))))),dba);
dybn=fe_add(fe_add(fe_imul(2,fe_mul(Xxi,fe_mul(dxb,g_FactorAR))),fe_add(fe_imul(2,fe_mul(Xxr,fe_mul(dxb,g_FactorAI))),fe_imul(2,fe_mul(Xxr,fe_mul(dyb,g_FactorAR))))),dbb);
}

{xrn=fe_add(fe_add(fe_add(fe_add(fe_mul(fe_imul(2,xr),Xr),fe_mul(xr,xr)),fe_mul(fe_imul(2,Xi),xi)),fe_mul(xi,xi)),cr);
xin=fe_add(fe_add(fe_mul(fe_imul(2,Ar),fe_add(fe_add(fe_mul(Xr,xi),fe_mul(xr,Xi)),fe_mul(xr,xi))),fe_mul(Ai,fe_add(fe_mul(fe_imul(2,xr),Xr),fe_mul(xr,xr)))),ci);
}

);

#if 0
static const char *perturbation_opencl_softfloat_53_2_0 = STR(

{xrn=sf_add(sf_add(sf_add(sf_add(sf_mul(sf_imul(2,xr),Xr),sf_mul(xr,xr)),sf_mul(sf_imul(2,Xi),xi)),sf_mul(xi,xi)),cr);
xin=sf_add(sf_add(sf_mul(sf_imul(2,Ar),sf_add(sf_add(sf_mul(Xr,xi),sf_mul(xr,Xi)),sf_mul(xr,xi))),sf_mul(Ai,sf_add(sf_mul(sf_imul(2,xr),Xr),sf_mul(xr,xr)))),ci);
}

);
#endif


static const char *perturbation_opencl_double_54_2_0 = STR(

{xrn=d_add(cr,d_add(d_mul(Xr,d_diffabs(Xr,xr)),d_add(d_imul(-1,d_add(d_mul(Xi,d_diffabs(Xi,xi)),d_mul(xi,d_abs(d_add(Xi,xi))))),d_mul(xr,d_abs(d_add(Xr,xr))))));
xin=d_add(ci,d_add(d_mul(Xi,d_diffabs(Xr,xr)),d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi)))))));
}

);

static const char *perturbation_opencl_double_54_2_1 = STR(

{dxan=d_add(daa,d_add(d_mul(Xxr,d_mul(dxa,d_sgn(Xxr))),d_add(d_mul(dxa,d_abs(Xxr)),d_imul(-1,d_add(d_mul(Xxi,d_mul(dya,d_sgn(Xxi))),d_mul(dya,d_abs(Xxi)))))));
dxbn=d_add(dab,d_add(d_mul(Xxr,d_mul(dxb,d_sgn(Xxr))),d_add(d_mul(dxb,d_abs(Xxr)),d_imul(-1,d_add(d_mul(Xxi,d_mul(dyb,d_sgn(Xxi))),d_mul(dyb,d_abs(Xxi)))))));
dyan=d_add(dba,d_add(d_mul(Xxi,d_mul(dxa,d_sgn(Xxr))),d_add(d_mul(Xxr,d_mul(dya,d_sgn(Xxi))),d_add(d_mul(dxa,d_abs(Xxi)),d_mul(dya,d_abs(Xxr))))));
dybn=d_add(dbb,d_add(d_mul(Xxi,d_mul(dxb,d_sgn(Xxr))),d_add(d_mul(Xxr,d_mul(dyb,d_sgn(Xxi))),d_add(d_mul(dxb,d_abs(Xxi)),d_mul(dyb,d_abs(Xxr))))));
}

{xrn=d_add(cr,d_add(d_mul(Xr,d_diffabs(Xr,xr)),d_add(d_imul(-1,d_add(d_mul(Xi,d_diffabs(Xi,xi)),d_mul(xi,d_abs(d_add(Xi,xi))))),d_mul(xr,d_abs(d_add(Xr,xr))))));
xin=d_add(ci,d_add(d_mul(Xi,d_diffabs(Xr,xr)),d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi)))))));
}

);

static const char *perturbation_opencl_floatexp_54_2_0 = STR(

{xrn=fe_add(cr,fe_add(fe_mul(Xr,fe_diffabs(Xr,xr)),fe_add(fe_imul(-1,fe_add(fe_mul(Xi,fe_diffabs(Xi,xi)),fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_mul(xr,fe_abs(fe_add(Xr,xr))))));
xin=fe_add(ci,fe_add(fe_mul(Xi,fe_diffabs(Xr,xr)),fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))));
}

);

static const char *perturbation_opencl_floatexp_54_2_1 = STR(

{dxan=fe_add(daa,fe_add(fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr))),fe_add(fe_mul(dxa,fe_abs(Xxr)),fe_imul(-1,fe_add(fe_mul(Xxi,fe_mul(dya,fe_sgn(Xxi))),fe_mul(dya,fe_abs(Xxi)))))));
dxbn=fe_add(dab,fe_add(fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr))),fe_add(fe_mul(dxb,fe_abs(Xxr)),fe_imul(-1,fe_add(fe_mul(Xxi,fe_mul(dyb,fe_sgn(Xxi))),fe_mul(dyb,fe_abs(Xxi)))))));
dyan=fe_add(dba,fe_add(fe_mul(Xxi,fe_mul(dxa,fe_sgn(Xxr))),fe_add(fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxi))),fe_add(fe_mul(dxa,fe_abs(Xxi)),fe_mul(dya,fe_abs(Xxr))))));
dybn=fe_add(dbb,fe_add(fe_mul(Xxi,fe_mul(dxb,fe_sgn(Xxr))),fe_add(fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxi))),fe_add(fe_mul(dxb,fe_abs(Xxi)),fe_mul(dyb,fe_abs(Xxr))))));
}

{xrn=fe_add(cr,fe_add(fe_mul(Xr,fe_diffabs(Xr,xr)),fe_add(fe_imul(-1,fe_add(fe_mul(Xi,fe_diffabs(Xi,xi)),fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_mul(xr,fe_abs(fe_add(Xr,xr))))));
xin=fe_add(ci,fe_add(fe_mul(Xi,fe_diffabs(Xr,xr)),fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))));
}

);

#if 0
static const char *perturbation_opencl_softfloat_54_2_0 = STR(

{xrn=sf_add(cr,sf_add(sf_mul(Xr,sf_diffabs(Xr,xr)),sf_add(sf_imul(-1,sf_add(sf_mul(Xi,sf_diffabs(Xi,xi)),sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_mul(xr,sf_abs(sf_add(Xr,xr))))));
xin=sf_add(ci,sf_add(sf_mul(Xi,sf_diffabs(Xr,xr)),sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))));
}

);
#endif


static const char *perturbation_opencl_double_55_3_0 = STR(

{xrn=d_add(cr,d_add(d_mul(d_abs(Xr),d_add(d_mul(Xr,d_diffabs(Xr,xr)),d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_diffabs(Xr,xr))),d_add(d_imul(-1,d_add(d_mul(d_abs(Xi),d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(d_diffabs(Xi,xi),d_add(Xr,xr))))),d_add(d_imul(-2,d_add(d_mul(d_abs(Xi),d_add(d_mul(Xi,d_diffabs(Xr,xr)),d_mul(xi,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_diffabs(Xi,xi),d_add(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xr,d_diffabs(Xr,xr))))))));
xin=d_add(ci,d_add(d_mul(d_abs(Xr),d_add(d_mul(Xi,d_diffabs(Xr,xr)),d_mul(xi,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_add(Xr,xr)),d_mul(d_diffabs(Xr,xr),d_add(Xi,xi))),d_add(d_imul(-1,d_add(d_mul(d_abs(Xi),d_add(d_mul(Xi,d_diffabs(Xi,xi)),d_mul(xi,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(d_diffabs(Xi,xi),d_add(Xi,xi))))),d_imul(2,d_add(d_mul(d_abs(Xi),d_add(d_mul(Xr,d_diffabs(Xr,xr)),d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_diffabs(Xi,xi),d_add(Xr,xr)))))))));
}

);

static const char *perturbation_opencl_double_55_3_1 = STR(

{dxan=d_add(daa,d_add(d_mul(d_abs(Xxr),d_mul(dxa,d_abs(Xxr))),d_add(d_imul(-1,d_mul(d_abs(Xxi),d_mul(dxa,d_abs(Xxi)))),d_add(d_imul(-2,d_mul(d_sgn(Xxi),d_add(d_mul(Xxi,d_mul(dya,d_abs(Xxr))),d_mul(Xxr,d_mul(dya,d_abs(Xxi)))))),d_add(d_imul(2,d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(dxa,d_abs(Xxr))))),d_imul(-2,d_add(d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(dxa,d_abs(Xxi)))),d_mul(d_abs(Xxi),d_mul(dya,d_abs(Xxr))))))))));
dxbn=d_add(dab,d_add(d_mul(d_abs(Xxr),d_mul(dxb,d_abs(Xxr))),d_add(d_imul(-1,d_mul(d_abs(Xxi),d_mul(dxb,d_abs(Xxi)))),d_add(d_imul(-2,d_mul(d_sgn(Xxi),d_add(d_mul(Xxi,d_mul(dyb,d_abs(Xxr))),d_mul(Xxr,d_mul(dyb,d_abs(Xxi)))))),d_add(d_imul(2,d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(dxb,d_abs(Xxr))))),d_imul(-2,d_add(d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(dxb,d_abs(Xxi)))),d_mul(d_abs(Xxi),d_mul(dyb,d_abs(Xxr))))))))));
dyan=d_add(dba,d_add(d_imul(-1,d_mul(d_abs(Xxi),d_mul(dya,d_abs(Xxi)))),d_add(d_imul(2,d_add(d_mul(d_abs(Xxi),d_mul(dxa,d_abs(Xxr))),d_add(d_mul(d_sgn(Xxi),d_mul(Xxr,d_mul(dya,d_abs(Xxr)))),d_mul(d_sgn(Xxr),d_add(d_mul(Xxi,d_mul(dxa,d_abs(Xxr))),d_mul(Xxr,d_mul(dxa,d_abs(Xxi)))))))),d_add(d_imul(-2,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(dya,d_abs(Xxi))))),d_mul(d_abs(Xxr),d_mul(dya,d_abs(Xxr)))))));
dybn=d_add(dbb,d_add(d_imul(-1,d_mul(d_abs(Xxi),d_mul(dyb,d_abs(Xxi)))),d_add(d_imul(2,d_add(d_mul(d_abs(Xxi),d_mul(dxb,d_abs(Xxr))),d_add(d_mul(d_sgn(Xxi),d_mul(Xxr,d_mul(dyb,d_abs(Xxr)))),d_mul(d_sgn(Xxr),d_add(d_mul(Xxi,d_mul(dxb,d_abs(Xxr))),d_mul(Xxr,d_mul(dxb,d_abs(Xxi)))))))),d_add(d_imul(-2,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(dyb,d_abs(Xxi))))),d_mul(d_abs(Xxr),d_mul(dyb,d_abs(Xxr)))))));
}

{xrn=d_add(cr,d_add(d_mul(d_abs(Xr),d_add(d_mul(Xr,d_diffabs(Xr,xr)),d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_diffabs(Xr,xr))),d_add(d_imul(-1,d_add(d_mul(d_abs(Xi),d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(d_diffabs(Xi,xi),d_add(Xr,xr))))),d_add(d_imul(-2,d_add(d_mul(d_abs(Xi),d_add(d_mul(Xi,d_diffabs(Xr,xr)),d_mul(xi,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_diffabs(Xi,xi),d_add(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xr,d_diffabs(Xr,xr))))))));
xin=d_add(ci,d_add(d_mul(d_abs(Xr),d_add(d_mul(Xi,d_diffabs(Xr,xr)),d_mul(xi,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_add(Xr,xr)),d_mul(d_diffabs(Xr,xr),d_add(Xi,xi))),d_add(d_imul(-1,d_add(d_mul(d_abs(Xi),d_add(d_mul(Xi,d_diffabs(Xi,xi)),d_mul(xi,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(d_diffabs(Xi,xi),d_add(Xi,xi))))),d_imul(2,d_add(d_mul(d_abs(Xi),d_add(d_mul(Xr,d_diffabs(Xr,xr)),d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_diffabs(Xi,xi),d_add(Xr,xr)))))))));
}

);

static const char *perturbation_opencl_floatexp_55_3_0 = STR(

{xrn=fe_add(cr,fe_add(fe_mul(fe_abs(Xr),fe_add(fe_mul(Xr,fe_diffabs(Xr,xr)),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_diffabs(Xr,xr))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_diffabs(Xi,xi),fe_add(Xr,xr))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(Xi,fe_diffabs(Xr,xr)),fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_diffabs(Xi,xi),fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xr,fe_diffabs(Xr,xr))))))));
xin=fe_add(ci,fe_add(fe_mul(fe_abs(Xr),fe_add(fe_mul(Xi,fe_diffabs(Xr,xr)),fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_diffabs(Xr,xr),fe_add(Xi,xi))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(Xi,fe_diffabs(Xi,xi)),fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_diffabs(Xi,xi),fe_add(Xi,xi))))),fe_imul(2,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(Xr,fe_diffabs(Xr,xr)),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_diffabs(Xi,xi),fe_add(Xr,xr)))))))));
}

);

static const char *perturbation_opencl_floatexp_55_3_1 = STR(

{dxan=fe_add(daa,fe_add(fe_mul(fe_abs(Xxr),fe_mul(dxa,fe_abs(Xxr))),fe_add(fe_imul(-1,fe_mul(fe_abs(Xxi),fe_mul(dxa,fe_abs(Xxi)))),fe_add(fe_imul(-2,fe_mul(fe_sgn(Xxi),fe_add(fe_mul(Xxi,fe_mul(dya,fe_abs(Xxr))),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxi)))))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxr))))),fe_imul(-2,fe_add(fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(dxa,fe_abs(Xxi)))),fe_mul(fe_abs(Xxi),fe_mul(dya,fe_abs(Xxr))))))))));
dxbn=fe_add(dab,fe_add(fe_mul(fe_abs(Xxr),fe_mul(dxb,fe_abs(Xxr))),fe_add(fe_imul(-1,fe_mul(fe_abs(Xxi),fe_mul(dxb,fe_abs(Xxi)))),fe_add(fe_imul(-2,fe_mul(fe_sgn(Xxi),fe_add(fe_mul(Xxi,fe_mul(dyb,fe_abs(Xxr))),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxi)))))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxr))))),fe_imul(-2,fe_add(fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(dxb,fe_abs(Xxi)))),fe_mul(fe_abs(Xxi),fe_mul(dyb,fe_abs(Xxr))))))))));
dyan=fe_add(dba,fe_add(fe_imul(-1,fe_mul(fe_abs(Xxi),fe_mul(dya,fe_abs(Xxi)))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(Xxi),fe_mul(dxa,fe_abs(Xxr))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxr)))),fe_mul(fe_sgn(Xxr),fe_add(fe_mul(Xxi,fe_mul(dxa,fe_abs(Xxr))),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxi)))))))),fe_add(fe_imul(-2,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(dya,fe_abs(Xxi))))),fe_mul(fe_abs(Xxr),fe_mul(dya,fe_abs(Xxr)))))));
dybn=fe_add(dbb,fe_add(fe_imul(-1,fe_mul(fe_abs(Xxi),fe_mul(dyb,fe_abs(Xxi)))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(Xxi),fe_mul(dxb,fe_abs(Xxr))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxr)))),fe_mul(fe_sgn(Xxr),fe_add(fe_mul(Xxi,fe_mul(dxb,fe_abs(Xxr))),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxi)))))))),fe_add(fe_imul(-2,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(dyb,fe_abs(Xxi))))),fe_mul(fe_abs(Xxr),fe_mul(dyb,fe_abs(Xxr)))))));
}

{xrn=fe_add(cr,fe_add(fe_mul(fe_abs(Xr),fe_add(fe_mul(Xr,fe_diffabs(Xr,xr)),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_diffabs(Xr,xr))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_diffabs(Xi,xi),fe_add(Xr,xr))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(Xi,fe_diffabs(Xr,xr)),fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_diffabs(Xi,xi),fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xr,fe_diffabs(Xr,xr))))))));
xin=fe_add(ci,fe_add(fe_mul(fe_abs(Xr),fe_add(fe_mul(Xi,fe_diffabs(Xr,xr)),fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_diffabs(Xr,xr),fe_add(Xi,xi))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(Xi,fe_diffabs(Xi,xi)),fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_diffabs(Xi,xi),fe_add(Xi,xi))))),fe_imul(2,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(Xr,fe_diffabs(Xr,xr)),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_diffabs(Xi,xi),fe_add(Xr,xr)))))))));
}

);

#if 0
static const char *perturbation_opencl_softfloat_55_3_0 = STR(

{xrn=sf_add(cr,sf_add(sf_mul(sf_abs(Xr),sf_add(sf_mul(Xr,sf_diffabs(Xr,xr)),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_diffabs(Xr,xr))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_diffabs(Xi,xi),sf_add(Xr,xr))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(Xi,sf_diffabs(Xr,xr)),sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_diffabs(Xi,xi),sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xr,sf_diffabs(Xr,xr))))))));
xin=sf_add(ci,sf_add(sf_mul(sf_abs(Xr),sf_add(sf_mul(Xi,sf_diffabs(Xr,xr)),sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_diffabs(Xr,xr),sf_add(Xi,xi))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(Xi,sf_diffabs(Xi,xi)),sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_diffabs(Xi,xi),sf_add(Xi,xi))))),sf_imul(2,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(Xr,sf_diffabs(Xr,xr)),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_diffabs(Xi,xi),sf_add(Xr,xr)))))))));
}

);
#endif


static const char *perturbation_opencl_double_56_3_0 = STR(

{xrn=d_add(cr,d_add(d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr)),d_add(d_imul(-1,d_add(d_mul(d_mul(Xi,Xi),d_diffabs(Xr,xr)),d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_add(d_imul(-2,d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))),d_add(d_imul(2,d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_imul(-2,d_add(d_mul(Xi,d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi)))))),d_mul(Xr,d_mul(xi,d_abs(d_add(Xi,xi)))))),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))))));
xin=d_add(ci,d_add(d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi)),d_add(d_imul(-1,d_add(d_mul(d_mul(Xi,Xi),d_diffabs(Xi,xi)),d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))),d_add(d_imul(2,d_add(d_mul(Xi,d_add(d_mul(Xr,d_diffabs(Xr,xr)),d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(Xr,d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr))))))),d_add(d_imul(-2,d_mul(Xi,d_mul(xi,d_abs(d_add(Xi,xi))))),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))))));
}

);

static const char *perturbation_opencl_double_56_3_1 = STR(

{dxan=d_add(d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_sgn(Xxr))),d_add(d_imul(-1,d_mul(d_mul(Xxi,Xxi),d_mul(dxa,d_sgn(Xxr)))),d_add(d_imul(-2,d_mul(Xxr,d_mul(dya,d_abs(Xxi)))),d_add(d_imul(2,d_mul(Xxr,d_mul(dxa,d_abs(Xxr)))),d_add(d_imul(-2,d_mul(Xxi,d_add(d_mul(Xxr,d_mul(dya,d_sgn(Xxi))),d_add(d_mul(dxa,d_abs(Xxi)),d_mul(dya,d_abs(Xxr)))))),daa)))));
dxbn=d_add(d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_sgn(Xxr))),d_add(d_imul(-1,d_mul(d_mul(Xxi,Xxi),d_mul(dxb,d_sgn(Xxr)))),d_add(d_imul(-2,d_mul(Xxr,d_mul(dyb,d_abs(Xxi)))),d_add(d_imul(2,d_mul(Xxr,d_mul(dxb,d_abs(Xxr)))),d_add(d_imul(-2,d_mul(Xxi,d_add(d_mul(Xxr,d_mul(dyb,d_sgn(Xxi))),d_add(d_mul(dxb,d_abs(Xxi)),d_mul(dyb,d_abs(Xxr)))))),dab)))));
dyan=d_add(d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_sgn(Xxi))),d_add(d_imul(-1,d_mul(d_mul(Xxi,Xxi),d_mul(dya,d_sgn(Xxi)))),d_add(d_imul(2,d_mul(Xxr,d_add(d_mul(dxa,d_abs(Xxi)),d_mul(dya,d_abs(Xxr))))),d_add(d_imul(-2,d_mul(Xxi,d_mul(dya,d_abs(Xxi)))),d_add(d_imul(2,d_mul(Xxi,d_add(d_mul(Xxr,d_mul(dxa,d_sgn(Xxr))),d_mul(dxa,d_abs(Xxr))))),dba)))));
dybn=d_add(d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_sgn(Xxi))),d_add(d_imul(-1,d_mul(d_mul(Xxi,Xxi),d_mul(dyb,d_sgn(Xxi)))),d_add(d_imul(2,d_mul(Xxr,d_add(d_mul(dxb,d_abs(Xxi)),d_mul(dyb,d_abs(Xxr))))),d_add(d_imul(-2,d_mul(Xxi,d_mul(dyb,d_abs(Xxi)))),d_add(d_imul(2,d_mul(Xxi,d_add(d_mul(Xxr,d_mul(dxb,d_sgn(Xxr))),d_mul(dxb,d_abs(Xxr))))),dbb)))));
}

{xrn=d_add(cr,d_add(d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr)),d_add(d_imul(-1,d_add(d_mul(d_mul(Xi,Xi),d_diffabs(Xr,xr)),d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_add(d_imul(-2,d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))),d_add(d_imul(2,d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_imul(-2,d_add(d_mul(Xi,d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi)))))),d_mul(Xr,d_mul(xi,d_abs(d_add(Xi,xi)))))),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))))));
xin=d_add(ci,d_add(d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi)),d_add(d_imul(-1,d_add(d_mul(d_mul(Xi,Xi),d_diffabs(Xi,xi)),d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))),d_add(d_imul(2,d_add(d_mul(Xi,d_add(d_mul(Xr,d_diffabs(Xr,xr)),d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(Xr,d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr))))))),d_add(d_imul(-2,d_mul(Xi,d_mul(xi,d_abs(d_add(Xi,xi))))),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))))));
}

);

static const char *perturbation_opencl_floatexp_56_3_0 = STR(

{xrn=fe_add(cr,fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr)),fe_add(fe_imul(-1,fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xr,xr)),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_add(fe_imul(-2,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_add(fe_imul(2,fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_imul(-2,fe_add(fe_mul(Xi,fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))))));
xin=fe_add(ci,fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi)),fe_add(fe_imul(-1,fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xi,xi)),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_add(fe_mul(Xr,fe_diffabs(Xr,xr)),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(Xr,fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))))),fe_add(fe_imul(-2,fe_mul(Xi,fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))))));
}

);

static const char *perturbation_opencl_floatexp_56_3_1 = STR(

{dxan=fe_add(fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_sgn(Xxr))),fe_add(fe_imul(-1,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxa,fe_sgn(Xxr)))),fe_add(fe_imul(-2,fe_mul(Xxr,fe_mul(dya,fe_abs(Xxi)))),fe_add(fe_imul(2,fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxr)))),fe_add(fe_imul(-2,fe_mul(Xxi,fe_add(fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxi))),fe_add(fe_mul(dxa,fe_abs(Xxi)),fe_mul(dya,fe_abs(Xxr)))))),daa)))));
dxbn=fe_add(fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_sgn(Xxr))),fe_add(fe_imul(-1,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxb,fe_sgn(Xxr)))),fe_add(fe_imul(-2,fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxi)))),fe_add(fe_imul(2,fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxr)))),fe_add(fe_imul(-2,fe_mul(Xxi,fe_add(fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxi))),fe_add(fe_mul(dxb,fe_abs(Xxi)),fe_mul(dyb,fe_abs(Xxr)))))),dab)))));
dyan=fe_add(fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_sgn(Xxi))),fe_add(fe_imul(-1,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dya,fe_sgn(Xxi)))),fe_add(fe_imul(2,fe_mul(Xxr,fe_add(fe_mul(dxa,fe_abs(Xxi)),fe_mul(dya,fe_abs(Xxr))))),fe_add(fe_imul(-2,fe_mul(Xxi,fe_mul(dya,fe_abs(Xxi)))),fe_add(fe_imul(2,fe_mul(Xxi,fe_add(fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr))),fe_mul(dxa,fe_abs(Xxr))))),dba)))));
dybn=fe_add(fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_sgn(Xxi))),fe_add(fe_imul(-1,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dyb,fe_sgn(Xxi)))),fe_add(fe_imul(2,fe_mul(Xxr,fe_add(fe_mul(dxb,fe_abs(Xxi)),fe_mul(dyb,fe_abs(Xxr))))),fe_add(fe_imul(-2,fe_mul(Xxi,fe_mul(dyb,fe_abs(Xxi)))),fe_add(fe_imul(2,fe_mul(Xxi,fe_add(fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr))),fe_mul(dxb,fe_abs(Xxr))))),dbb)))));
}

{xrn=fe_add(cr,fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr)),fe_add(fe_imul(-1,fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xr,xr)),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_add(fe_imul(-2,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_add(fe_imul(2,fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_imul(-2,fe_add(fe_mul(Xi,fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))))));
xin=fe_add(ci,fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi)),fe_add(fe_imul(-1,fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xi,xi)),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_add(fe_mul(Xr,fe_diffabs(Xr,xr)),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(Xr,fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))))),fe_add(fe_imul(-2,fe_mul(Xi,fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))))));
}

);

#if 0
static const char *perturbation_opencl_softfloat_56_3_0 = STR(

{xrn=sf_add(cr,sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr)),sf_add(sf_imul(-1,sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xr,xr)),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_add(sf_imul(-2,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_add(sf_imul(2,sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_imul(-2,sf_add(sf_mul(Xi,sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))))));
xin=sf_add(ci,sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi)),sf_add(sf_imul(-1,sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xi,xi)),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_add(sf_mul(Xr,sf_diffabs(Xr,xr)),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(Xr,sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))))),sf_add(sf_imul(-2,sf_mul(Xi,sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))))));
}

);
#endif


static const char *perturbation_opencl_double_57_4_0 = STR(

{xrn=d_add(cr,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_add(d_mul(Xi,d_diffabs(Xi,xi)),d_mul(xi,d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xr,d_diffabs(Xr,xr))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))),d_add(Xi,xi))),d_add(d_mul(d_abs(d_add(Xr,xr)),d_mul(d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))),d_add(Xr,xr))),d_add(d_imul(-1,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_add(d_mul(Xr,d_diffabs(Xr,xr)),d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_add(d_mul(Xi,d_diffabs(Xi,xi)),d_mul(xi,d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))),d_add(Xi,xi))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))),d_add(Xr,xr))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_add(d_mul(Xi,d_diffabs(Xr,xr)),d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))),d_add(Xr,xr))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))),d_add(Xi,xi)))))),d_mul(d_abs(d_mul(Xr,Xr)),d_mul(xr,d_abs(d_add(Xr,xr)))))))))));
xin=d_add(ci,d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_add(d_mul(Xi,d_diffabs(Xr,xr)),d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_mul(xi,d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))),d_add(Xr,xr))),d_add(d_mul(d_abs(d_add(Xr,xr)),d_mul(d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))),d_add(Xi,xi))),d_add(d_imul(-1,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_add(d_mul(Xi,d_diffabs(Xr,xr)),d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))),d_add(Xr,xr))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))),d_add(Xi,xi)))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(xr,d_abs(d_add(Xr,xr)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(xi,d_abs(d_add(Xi,xi)))),d_mul(d_abs(d_add(Xi,xi)),d_mul(xi,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(Xr,d_diffabs(Xr,xr))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(Xi,d_diffabs(Xi,xi))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))),d_mul(d_abs(d_mul(Xr,Xr)),d_mul(xr,d_abs(d_add(Xi,xi)))))))))))));
}

);

static const char *perturbation_opencl_double_57_4_1 = STR(

{dxan=d_add(daa,d_add(d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(dya,d_abs(Xxi))),d_add(d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(dxa,d_abs(Xxr))),d_add(d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(dya,d_abs(d_mul(Xxi,Xxi))))),d_add(d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(dxa,d_abs(d_mul(Xxr,Xxr))))),d_add(d_imul(-1,d_add(d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(dxa,d_abs(Xxr))),d_add(d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(dya,d_abs(d_mul(Xxr,Xxr))))),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(dxa,d_abs(d_mul(Xxi,Xxi)))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xxi,Xxr)),d_add(d_mul(dxa,d_abs(Xxi)),d_mul(dya,d_abs(Xxr)))),d_mul(d_sgn(Xxi),d_add(d_mul(Xxr,d_mul(dya,d_abs(d_mul(Xxi,Xxr)))),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxi)))))))),d_add(d_imul(2,d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr))))),d_add(d_imul(-2,d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_abs(Xxr))))),d_add(d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_add(d_mul(d_mul(Xxi,Xxi),d_mul(dxa,d_abs(Xxr))),d_mul(Xxi,d_mul(Xxr,d_add(d_mul(dxa,d_abs(Xxi)),d_mul(dya,d_abs(Xxr)))))))),d_add(d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(dxa,d_abs(d_mul(Xxi,Xxr))))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_abs(Xxi))))))))),d_add(d_imul(2,d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_mul(Xxi,Xxi),d_mul(dya,d_abs(Xxi))))),d_imul(-1,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(dya,d_abs(Xxi))))))))))))));
dxbn=d_add(dab,d_add(d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(dyb,d_abs(Xxi))),d_add(d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(dxb,d_abs(Xxr))),d_add(d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(dyb,d_abs(d_mul(Xxi,Xxi))))),d_add(d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(dxb,d_abs(d_mul(Xxr,Xxr))))),d_add(d_imul(-1,d_add(d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(dxb,d_abs(Xxr))),d_add(d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(dyb,d_abs(d_mul(Xxr,Xxr))))),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(dxb,d_abs(d_mul(Xxi,Xxi)))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xxi,Xxr)),d_add(d_mul(dxb,d_abs(Xxi)),d_mul(dyb,d_abs(Xxr)))),d_mul(d_sgn(Xxi),d_add(d_mul(Xxr,d_mul(dyb,d_abs(d_mul(Xxi,Xxr)))),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxi)))))))),d_add(d_imul(2,d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr))))),d_add(d_imul(-2,d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_abs(Xxr))))),d_add(d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_add(d_mul(d_mul(Xxi,Xxi),d_mul(dxb,d_abs(Xxr))),d_mul(Xxi,d_mul(Xxr,d_add(d_mul(dxb,d_abs(Xxi)),d_mul(dyb,d_abs(Xxr)))))))),d_add(d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(dxb,d_abs(d_mul(Xxi,Xxr))))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_abs(Xxi))))))))),d_add(d_imul(2,d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_mul(Xxi,Xxi),d_mul(dyb,d_abs(Xxi))))),d_imul(-1,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(dyb,d_abs(Xxi))))))))))))));
dyan=d_add(dba,d_add(d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(dxa,d_abs(Xxi))),d_add(d_mul(d_sgn(Xxi),d_mul(Xxr,d_mul(dya,d_abs(d_mul(Xxr,Xxr))))),d_add(d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(dxa,d_abs(d_mul(Xxr,Xxr))))),d_add(d_imul(-1,d_add(d_mul(d_abs(d_mul(Xxi,Xxi)),d_add(d_mul(dxa,d_abs(Xxi)),d_mul(dya,d_abs(Xxr)))),d_add(d_mul(d_sgn(Xxi),d_mul(Xxr,d_mul(dya,d_abs(d_mul(Xxi,Xxi))))),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(dxa,d_abs(d_mul(Xxi,Xxi)))))))),d_add(d_imul(-2,d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(dya,d_abs(Xxi)))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(dxa,d_abs(Xxr))),d_add(d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxr))))),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(dxa,d_abs(d_mul(Xxi,Xxr)))))))),d_add(d_imul(-2,d_add(d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(dya,d_abs(d_mul(Xxi,Xxr))))),d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_abs(Xxi))))),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_abs(Xxi))))))))),d_add(d_imul(2,d_add(d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_abs(Xxr)))))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_add(d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_abs(Xxr)))),d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxi))))))),d_add(d_imul(-2,d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_mul(Xxi,Xxi),d_mul(dya,d_abs(Xxr)))),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(dxa,d_abs(Xxi))))))),d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(dya,d_abs(Xxr)))))))))))));
dybn=d_add(dbb,d_add(d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(dxb,d_abs(Xxi))),d_add(d_mul(d_sgn(Xxi),d_mul(Xxr,d_mul(dyb,d_abs(d_mul(Xxr,Xxr))))),d_add(d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(dxb,d_abs(d_mul(Xxr,Xxr))))),d_add(d_imul(-1,d_add(d_mul(d_abs(d_mul(Xxi,Xxi)),d_add(d_mul(dxb,d_abs(Xxi)),d_mul(dyb,d_abs(Xxr)))),d_add(d_mul(d_sgn(Xxi),d_mul(Xxr,d_mul(dyb,d_abs(d_mul(Xxi,Xxi))))),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(dxb,d_abs(d_mul(Xxi,Xxi)))))))),d_add(d_imul(-2,d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(dyb,d_abs(Xxi)))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(dxb,d_abs(Xxr))),d_add(d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxr))))),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(dxb,d_abs(d_mul(Xxi,Xxr)))))))),d_add(d_imul(-2,d_add(d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(dyb,d_abs(d_mul(Xxi,Xxr))))),d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_abs(Xxi))))),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_abs(Xxi))))))))),d_add(d_imul(2,d_add(d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_abs(Xxr)))))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_add(d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_abs(Xxr)))),d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxi))))))),d_add(d_imul(-2,d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_mul(Xxi,Xxi),d_mul(dyb,d_abs(Xxr)))),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(dxb,d_abs(Xxi))))))),d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(dyb,d_abs(Xxr)))))))))))));
}

{xrn=d_add(cr,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_add(d_mul(Xi,d_diffabs(Xi,xi)),d_mul(xi,d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xr,d_diffabs(Xr,xr))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))),d_add(Xi,xi))),d_add(d_mul(d_abs(d_add(Xr,xr)),d_mul(d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))),d_add(Xr,xr))),d_add(d_imul(-1,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_add(d_mul(Xr,d_diffabs(Xr,xr)),d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_add(d_mul(Xi,d_diffabs(Xi,xi)),d_mul(xi,d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))),d_add(Xi,xi))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))),d_add(Xr,xr))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_add(d_mul(Xi,d_diffabs(Xr,xr)),d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))),d_add(Xr,xr))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))),d_add(Xi,xi)))))),d_mul(d_abs(d_mul(Xr,Xr)),d_mul(xr,d_abs(d_add(Xr,xr)))))))))));
xin=d_add(ci,d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_add(d_mul(Xi,d_diffabs(Xr,xr)),d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_mul(xi,d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))),d_add(Xr,xr))),d_add(d_mul(d_abs(d_add(Xr,xr)),d_mul(d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))),d_add(Xi,xi))),d_add(d_imul(-1,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_add(d_mul(Xi,d_diffabs(Xr,xr)),d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))),d_add(Xr,xr))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))),d_add(Xi,xi)))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(xr,d_abs(d_add(Xr,xr)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(xi,d_abs(d_add(Xi,xi)))),d_mul(d_abs(d_add(Xi,xi)),d_mul(xi,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(Xr,d_diffabs(Xr,xr))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(Xi,d_diffabs(Xi,xi))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))),d_mul(d_abs(d_mul(Xr,Xr)),d_mul(xr,d_abs(d_add(Xi,xi)))))))))))));
}

);

static const char *perturbation_opencl_floatexp_57_4_0 = STR(

{xrn=fe_add(cr,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_add(fe_mul(Xi,fe_diffabs(Xi,xi)),fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xr,fe_diffabs(Xr,xr))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))),fe_add(Xi,xi))),fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))),fe_add(Xr,xr))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_add(fe_mul(Xr,fe_diffabs(Xr,xr)),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_diffabs(Xi,xi)),fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))),fe_add(Xi,xi))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))),fe_add(Xr,xr))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_add(fe_mul(Xi,fe_diffabs(Xr,xr)),fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))),fe_add(Xr,xr))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))),fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(xr,fe_abs(fe_add(Xr,xr)))))))))));
xin=fe_add(ci,fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_diffabs(Xr,xr)),fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_mul(xi,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))),fe_add(Xr,xr))),fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))),fe_add(Xi,xi))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_add(fe_mul(Xi,fe_diffabs(Xr,xr)),fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))),fe_add(Xr,xr))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))),fe_add(Xi,xi)))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(xi,fe_abs(fe_add(Xi,xi)))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xi,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(Xr,fe_diffabs(Xr,xr))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(Xi,fe_diffabs(Xi,xi))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))),fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))))))))));
}

);

static const char *perturbation_opencl_floatexp_57_4_1 = STR(

{dxan=fe_add(daa,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(dya,fe_abs(Xxi))),fe_add(fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(dxa,fe_abs(Xxr))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(dya,fe_abs(fe_mul(Xxi,Xxi))))),fe_add(fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(dxa,fe_abs(fe_mul(Xxr,Xxr))))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(dxa,fe_abs(Xxr))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(dya,fe_abs(fe_mul(Xxr,Xxr))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(dxa,fe_abs(fe_mul(Xxi,Xxi)))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_add(fe_mul(dxa,fe_abs(Xxi)),fe_mul(dya,fe_abs(Xxr)))),fe_mul(fe_sgn(Xxi),fe_add(fe_mul(Xxr,fe_mul(dya,fe_abs(fe_mul(Xxi,Xxr)))),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxi)))))))),fe_add(fe_imul(2,fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_abs(Xxr))))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxa,fe_abs(Xxr))),fe_mul(Xxi,fe_mul(Xxr,fe_add(fe_mul(dxa,fe_abs(Xxi)),fe_mul(dya,fe_abs(Xxr)))))))),fe_add(fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(dxa,fe_abs(fe_mul(Xxi,Xxr))))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxi))))))))),fe_add(fe_imul(2,fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dya,fe_abs(Xxi))))),fe_imul(-1,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(dya,fe_abs(Xxi))))))))))))));
dxbn=fe_add(dab,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(dyb,fe_abs(Xxi))),fe_add(fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(dxb,fe_abs(Xxr))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(dyb,fe_abs(fe_mul(Xxi,Xxi))))),fe_add(fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(dxb,fe_abs(fe_mul(Xxr,Xxr))))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(dxb,fe_abs(Xxr))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(dyb,fe_abs(fe_mul(Xxr,Xxr))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(dxb,fe_abs(fe_mul(Xxi,Xxi)))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_add(fe_mul(dxb,fe_abs(Xxi)),fe_mul(dyb,fe_abs(Xxr)))),fe_mul(fe_sgn(Xxi),fe_add(fe_mul(Xxr,fe_mul(dyb,fe_abs(fe_mul(Xxi,Xxr)))),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxi)))))))),fe_add(fe_imul(2,fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxr))))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxb,fe_abs(Xxr))),fe_mul(Xxi,fe_mul(Xxr,fe_add(fe_mul(dxb,fe_abs(Xxi)),fe_mul(dyb,fe_abs(Xxr)))))))),fe_add(fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(dxb,fe_abs(fe_mul(Xxi,Xxr))))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxi))))))))),fe_add(fe_imul(2,fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dyb,fe_abs(Xxi))))),fe_imul(-1,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(dyb,fe_abs(Xxi))))))))))))));
dyan=fe_add(dba,fe_add(fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(dxa,fe_abs(Xxi))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(fe_mul(Xxr,Xxr))))),fe_add(fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(dxa,fe_abs(fe_mul(Xxr,Xxr))))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_add(fe_mul(dxa,fe_abs(Xxi)),fe_mul(dya,fe_abs(Xxr)))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(fe_mul(Xxi,Xxi))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(dxa,fe_abs(fe_mul(Xxi,Xxi)))))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(dya,fe_abs(Xxi)))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(dxa,fe_abs(Xxr))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxr))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(dxa,fe_abs(fe_mul(Xxi,Xxr)))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(dya,fe_abs(fe_mul(Xxi,Xxr))))),fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_abs(Xxi))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_abs(Xxi))))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxr)))))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_add(fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxr)))),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxi))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dya,fe_abs(Xxr)))),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxa,fe_abs(Xxi))))))),fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(dya,fe_abs(Xxr)))))))))))));
dybn=fe_add(dbb,fe_add(fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(dxb,fe_abs(Xxi))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(fe_mul(Xxr,Xxr))))),fe_add(fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(dxb,fe_abs(fe_mul(Xxr,Xxr))))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_add(fe_mul(dxb,fe_abs(Xxi)),fe_mul(dyb,fe_abs(Xxr)))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(fe_mul(Xxi,Xxi))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(dxb,fe_abs(fe_mul(Xxi,Xxi)))))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(dyb,fe_abs(Xxi)))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(dxb,fe_abs(Xxr))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxr))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(dxb,fe_abs(fe_mul(Xxi,Xxr)))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(dyb,fe_abs(fe_mul(Xxi,Xxr))))),fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxi))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxi))))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxr)))))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_add(fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxr)))),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxi))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dyb,fe_abs(Xxr)))),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxb,fe_abs(Xxi))))))),fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(dyb,fe_abs(Xxr)))))))))))));
}

{xrn=fe_add(cr,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_add(fe_mul(Xi,fe_diffabs(Xi,xi)),fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xr,fe_diffabs(Xr,xr))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))),fe_add(Xi,xi))),fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))),fe_add(Xr,xr))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_add(fe_mul(Xr,fe_diffabs(Xr,xr)),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_diffabs(Xi,xi)),fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))),fe_add(Xi,xi))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))),fe_add(Xr,xr))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_add(fe_mul(Xi,fe_diffabs(Xr,xr)),fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))),fe_add(Xr,xr))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))),fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(xr,fe_abs(fe_add(Xr,xr)))))))))));
xin=fe_add(ci,fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_diffabs(Xr,xr)),fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_mul(xi,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))),fe_add(Xr,xr))),fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))),fe_add(Xi,xi))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_add(fe_mul(Xi,fe_diffabs(Xr,xr)),fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))),fe_add(Xr,xr))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))),fe_add(Xi,xi)))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(xi,fe_abs(fe_add(Xi,xi)))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xi,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(Xr,fe_diffabs(Xr,xr))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(Xi,fe_diffabs(Xi,xi))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))),fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))))))))));
}

);

#if 0
static const char *perturbation_opencl_softfloat_57_4_0 = STR(

{xrn=sf_add(cr,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_add(sf_mul(Xi,sf_diffabs(Xi,xi)),sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xr,sf_diffabs(Xr,xr))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))),sf_add(Xi,xi))),sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))),sf_add(Xr,xr))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_add(sf_mul(Xr,sf_diffabs(Xr,xr)),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_diffabs(Xi,xi)),sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))),sf_add(Xi,xi))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))),sf_add(Xr,xr))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_add(sf_mul(Xi,sf_diffabs(Xr,xr)),sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))),sf_add(Xr,xr))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))),sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(xr,sf_abs(sf_add(Xr,xr)))))))))));
xin=sf_add(ci,sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_diffabs(Xr,xr)),sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_mul(xi,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))),sf_add(Xr,xr))),sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))),sf_add(Xi,xi))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_add(sf_mul(Xi,sf_diffabs(Xr,xr)),sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))),sf_add(Xr,xr))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))),sf_add(Xi,xi)))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(xi,sf_abs(sf_add(Xi,xi)))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xi,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(Xr,sf_diffabs(Xr,xr))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(Xi,sf_diffabs(Xi,xi))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))),sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))))))))));
}

);
#endif


static const char *perturbation_opencl_double_58_4_0 = STR(

{xrn=d_add(cr,d_add(d_mul(d_abs(Xi),d_add(d_mul(d_mul(Xi,Xi),d_diffabs(Xi,xi)),d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(Xr),d_add(d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr)),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_diffabs(Xi,xi),d_add(d_mul(Xi,Xi),d_mul(xi,xi)))),d_add(d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr))),d_add(d_imul(-1,d_add(d_mul(d_abs(Xi),d_add(d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi)),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(Xr),d_add(d_mul(d_mul(Xi,Xi),d_diffabs(Xr,xr)),d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_diffabs(Xi,xi),d_add(d_mul(Xr,Xr),d_mul(xr,xr)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_diffabs(Xr,xr),d_add(d_mul(Xi,Xi),d_mul(xi,xi)))))))),d_add(d_imul(2,d_add(d_mul(d_abs(Xr),d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(xr,d_diffabs(Xr,xr)))))),d_add(d_imul(-2,d_add(d_mul(d_abs(Xi),d_mul(Xr,d_mul(xr,d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(xi,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(xr,d_diffabs(Xi,xi)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(xi,d_diffabs(Xr,xr)))))))),d_add(d_imul(2,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(xi,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(xi,d_diffabs(Xi,xi)))))),d_add(d_imul(-4,d_add(d_mul(d_abs(Xi),d_add(d_mul(Xi,d_add(d_mul(Xr,d_diffabs(Xr,xr)),d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(Xr,d_mul(xi,d_abs(d_add(Xr,xr)))),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr))))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_mul(d_diffabs(Xi,xi),d_add(Xr,xr))),d_add(d_mul(Xr,d_mul(xi,d_diffabs(Xi,xi))),d_mul(xi,d_mul(xr,d_diffabs(Xi,xi)))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(xr,xr),d_diffabs(Xr,xr)))))))))))));
xin=d_add(ci,d_add(d_imul(2,d_add(d_mul(d_abs(Xi),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))),d_add(d_mul(d_abs(Xr),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xi,d_mul(xr,d_diffabs(Xr,xr))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(Xi),d_add(d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))),d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(xi,d_mul(xr,d_diffabs(Xi,xi)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(xi,xi),d_diffabs(Xi,xi)))))),d_add(d_imul(2,d_add(d_mul(d_abs(Xr),d_mul(Xr,d_mul(xi,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(xi,d_diffabs(Xr,xr)))))),d_add(d_imul(-2,d_add(d_mul(d_abs(Xi),d_mul(Xr,d_mul(xi,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(xi,d_diffabs(Xi,xi)))))),d_add(d_imul(2,d_add(d_mul(d_abs(Xi),d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr))),d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_mul(xr,d_diffabs(Xr,xr))),d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi))))))),d_add(d_imul(-2,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(xr,d_diffabs(Xi,xi))))),d_add(d_imul(2,d_mul(d_mul(Xi,d_mul(Xr,d_diffabs(Xr,xr))),d_add(d_abs(Xr),d_abs(d_add(Xr,xr))))),d_add(d_imul(-2,d_add(d_mul(d_abs(Xi),d_add(d_mul(d_mul(Xi,Xi),d_diffabs(Xr,xr)),d_mul(Xi,d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(Xr,d_diffabs(Xi,xi)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_diffabs(Xi,xi)))))),d_add(d_imul(4,d_add(d_mul(d_abs(Xi),d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(xr,d_diffabs(Xi,xi)))))),d_add(d_imul(-4,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(xi,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(xi,d_diffabs(Xi,xi)))))),d_imul(2,d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(xr,xr),d_diffabs(Xi,xi)))))))))))))));
}

);

static const char *perturbation_opencl_double_58_4_1 = STR(

{dxan=d_add(d_imul(2,d_mul(d_abs(Xxr),d_mul(Xxr,d_mul(dxa,d_abs(Xxr))))),d_add(d_imul(-2,d_add(d_mul(d_abs(Xxi),d_mul(Xxr,d_mul(dxa,d_abs(Xxi)))),d_mul(d_sgn(Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxi)))))),d_add(d_imul(2,d_mul(d_sgn(Xxr),d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr))))),d_add(d_imul(-2,d_add(d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(dya,d_abs(Xxr)))),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(dxa,d_abs(Xxr)))))),d_add(d_imul(2,d_add(d_mul(d_abs(Xxi),d_mul(Xxi,d_mul(dya,d_abs(Xxi)))),d_mul(d_sgn(Xxi),d_mul(d_mul(Xxi,Xxi),d_mul(dya,d_abs(Xxi)))))),d_add(d_imul(-4,d_add(d_mul(d_abs(Xxi),d_add(d_mul(Xxi,d_mul(dxa,d_abs(Xxr))),d_mul(Xxr,d_mul(dya,d_abs(Xxr))))),d_add(d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_abs(Xxr))))),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_abs(Xxi)))))))),daa))))));
dxbn=d_add(d_imul(2,d_mul(d_abs(Xxr),d_mul(Xxr,d_mul(dxb,d_abs(Xxr))))),d_add(d_imul(-2,d_add(d_mul(d_abs(Xxi),d_mul(Xxr,d_mul(dxb,d_abs(Xxi)))),d_mul(d_sgn(Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxi)))))),d_add(d_imul(2,d_mul(d_sgn(Xxr),d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr))))),d_add(d_imul(-2,d_add(d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(dyb,d_abs(Xxr)))),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(dxb,d_abs(Xxr)))))),d_add(d_imul(2,d_add(d_mul(d_abs(Xxi),d_mul(Xxi,d_mul(dyb,d_abs(Xxi)))),d_mul(d_sgn(Xxi),d_mul(d_mul(Xxi,Xxi),d_mul(dyb,d_abs(Xxi)))))),d_add(d_imul(-4,d_add(d_mul(d_abs(Xxi),d_add(d_mul(Xxi,d_mul(dxb,d_abs(Xxr))),d_mul(Xxr,d_mul(dyb,d_abs(Xxr))))),d_add(d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_abs(Xxr))))),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_abs(Xxi)))))))),dab))))));
dyan=d_add(d_imul(2,d_mul(d_abs(Xxr),d_mul(Xxr,d_mul(dya,d_abs(Xxr))))),d_add(d_imul(-2,d_mul(d_abs(Xxi),d_mul(Xxr,d_mul(dya,d_abs(Xxi))))),d_add(d_imul(2,d_add(d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(dxa,d_abs(Xxr)))),d_mul(d_sgn(Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxr)))))),d_add(d_imul(-2,d_mul(d_abs(Xxi),d_mul(Xxi,d_mul(dxa,d_abs(Xxi))))),d_add(d_imul(2,d_mul(d_sgn(Xxr),d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxi))))),d_add(d_imul(-2,d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(Xxi,Xxi),d_mul(dya,d_abs(Xxr)))),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(dxa,d_abs(Xxi)))))),d_add(d_imul(4,d_mul(d_abs(Xxi),d_mul(Xxr,d_mul(dxa,d_abs(Xxr))))),d_add(d_imul(-4,d_add(d_mul(d_abs(Xxi),d_mul(Xxi,d_mul(dya,d_abs(Xxr)))),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_abs(Xxi))))))),d_add(d_imul(4,d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_abs(Xxr)))))),dba)))))))));
dybn=d_add(d_imul(2,d_mul(d_abs(Xxr),d_mul(Xxr,d_mul(dyb,d_abs(Xxr))))),d_add(d_imul(-2,d_mul(d_abs(Xxi),d_mul(Xxr,d_mul(dyb,d_abs(Xxi))))),d_add(d_imul(2,d_add(d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(dxb,d_abs(Xxr)))),d_mul(d_sgn(Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxr)))))),d_add(d_imul(-2,d_mul(d_abs(Xxi),d_mul(Xxi,d_mul(dxb,d_abs(Xxi))))),d_add(d_imul(2,d_mul(d_sgn(Xxr),d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxi))))),d_add(d_imul(-2,d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(Xxi,Xxi),d_mul(dyb,d_abs(Xxr)))),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(dxb,d_abs(Xxi)))))),d_add(d_imul(4,d_mul(d_abs(Xxi),d_mul(Xxr,d_mul(dxb,d_abs(Xxr))))),d_add(d_imul(-4,d_add(d_mul(d_abs(Xxi),d_mul(Xxi,d_mul(dyb,d_abs(Xxr)))),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_abs(Xxi))))))),d_add(d_imul(4,d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_abs(Xxr)))))),dbb)))))))));
}

{xrn=d_add(cr,d_add(d_mul(d_abs(Xi),d_add(d_mul(d_mul(Xi,Xi),d_diffabs(Xi,xi)),d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(Xr),d_add(d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr)),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_diffabs(Xi,xi),d_add(d_mul(Xi,Xi),d_mul(xi,xi)))),d_add(d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr))),d_add(d_imul(-1,d_add(d_mul(d_abs(Xi),d_add(d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi)),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(Xr),d_add(d_mul(d_mul(Xi,Xi),d_diffabs(Xr,xr)),d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_diffabs(Xi,xi),d_add(d_mul(Xr,Xr),d_mul(xr,xr)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_diffabs(Xr,xr),d_add(d_mul(Xi,Xi),d_mul(xi,xi)))))))),d_add(d_imul(2,d_add(d_mul(d_abs(Xr),d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(xr,d_diffabs(Xr,xr)))))),d_add(d_imul(-2,d_add(d_mul(d_abs(Xi),d_mul(Xr,d_mul(xr,d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(xi,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(xr,d_diffabs(Xi,xi)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(xi,d_diffabs(Xr,xr)))))))),d_add(d_imul(2,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(xi,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(xi,d_diffabs(Xi,xi)))))),d_add(d_imul(-4,d_add(d_mul(d_abs(Xi),d_add(d_mul(Xi,d_add(d_mul(Xr,d_diffabs(Xr,xr)),d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(Xr,d_mul(xi,d_abs(d_add(Xr,xr)))),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr))))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_mul(d_diffabs(Xi,xi),d_add(Xr,xr))),d_add(d_mul(Xr,d_mul(xi,d_diffabs(Xi,xi))),d_mul(xi,d_mul(xr,d_diffabs(Xi,xi)))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(xr,xr),d_diffabs(Xr,xr)))))))))))));
xin=d_add(ci,d_add(d_imul(2,d_add(d_mul(d_abs(Xi),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))),d_add(d_mul(d_abs(Xr),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xi,d_mul(xr,d_diffabs(Xr,xr))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(Xi),d_add(d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))),d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(xi,d_mul(xr,d_diffabs(Xi,xi)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(xi,xi),d_diffabs(Xi,xi)))))),d_add(d_imul(2,d_add(d_mul(d_abs(Xr),d_mul(Xr,d_mul(xi,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(xi,d_diffabs(Xr,xr)))))),d_add(d_imul(-2,d_add(d_mul(d_abs(Xi),d_mul(Xr,d_mul(xi,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(xi,d_diffabs(Xi,xi)))))),d_add(d_imul(2,d_add(d_mul(d_abs(Xi),d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr))),d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_mul(xr,d_diffabs(Xr,xr))),d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi))))))),d_add(d_imul(-2,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(xr,d_diffabs(Xi,xi))))),d_add(d_imul(2,d_mul(d_mul(Xi,d_mul(Xr,d_diffabs(Xr,xr))),d_add(d_abs(Xr),d_abs(d_add(Xr,xr))))),d_add(d_imul(-2,d_add(d_mul(d_abs(Xi),d_add(d_mul(d_mul(Xi,Xi),d_diffabs(Xr,xr)),d_mul(Xi,d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(Xr,d_diffabs(Xi,xi)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_diffabs(Xi,xi)))))),d_add(d_imul(4,d_add(d_mul(d_abs(Xi),d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(xr,d_diffabs(Xi,xi)))))),d_add(d_imul(-4,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(xi,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(xi,d_diffabs(Xi,xi)))))),d_imul(2,d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(xr,xr),d_diffabs(Xi,xi)))))))))))))));
}

);

static const char *perturbation_opencl_floatexp_58_4_0 = STR(

{xrn=fe_add(cr,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xi,xi)),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(Xr),fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr)),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_diffabs(Xi,xi),fe_add(fe_mul(Xi,Xi),fe_mul(xi,xi)))),fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi)),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(Xr),fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xr,xr)),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_diffabs(Xi,xi),fe_add(fe_mul(Xr,Xr),fe_mul(xr,xr)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_diffabs(Xr,xr),fe_add(fe_mul(Xi,Xi),fe_mul(xi,xi)))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(Xr),fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(xr,fe_diffabs(Xr,xr)))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(xr,fe_diffabs(Xi,xi)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(xi,fe_diffabs(Xr,xr)))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(xi,fe_diffabs(Xi,xi)))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(Xi,fe_add(fe_mul(Xr,fe_diffabs(Xr,xr)),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xr,xr)))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_mul(fe_diffabs(Xi,xi),fe_add(Xr,xr))),fe_add(fe_mul(Xr,fe_mul(xi,fe_diffabs(Xi,xi))),fe_mul(xi,fe_mul(xr,fe_diffabs(Xi,xi)))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(xr,xr),fe_diffabs(Xr,xr)))))))))))));
xin=fe_add(ci,fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))),fe_add(fe_mul(fe_abs(Xr),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xi,fe_mul(xr,fe_diffabs(Xr,xr))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xi,fe_mul(xr,fe_diffabs(Xi,xi)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(xi,xi),fe_diffabs(Xi,xi)))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(Xr),fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(xi,fe_diffabs(Xr,xr)))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(xi,fe_diffabs(Xi,xi)))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr))),fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_mul(xr,fe_diffabs(Xr,xr))),fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi))))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(xr,fe_diffabs(Xi,xi))))),fe_add(fe_imul(2,fe_mul(fe_mul(Xi,fe_mul(Xr,fe_diffabs(Xr,xr))),fe_add(fe_abs(Xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xr,xr)),fe_mul(Xi,fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(Xi,xi)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xi,xi)))))),fe_add(fe_imul(4,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(xr,fe_diffabs(Xi,xi)))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(xi,fe_diffabs(Xi,xi)))))),fe_imul(2,fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi)))))))))))))));
}

);

static const char *perturbation_opencl_floatexp_58_4_1 = STR(

{dxan=fe_add(fe_imul(2,fe_mul(fe_abs(Xxr),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxr))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(Xxi),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxi)))),fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxi)))))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(dya,fe_abs(Xxr)))),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxa,fe_abs(Xxr)))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(Xxi),fe_mul(Xxi,fe_mul(dya,fe_abs(Xxi)))),fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dya,fe_abs(Xxi)))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_abs(Xxi),fe_add(fe_mul(Xxi,fe_mul(dxa,fe_abs(Xxr))),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxr))))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_abs(Xxr))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxi)))))))),daa))))));
dxbn=fe_add(fe_imul(2,fe_mul(fe_abs(Xxr),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxr))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(Xxi),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxi)))),fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxi)))))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(dyb,fe_abs(Xxr)))),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxb,fe_abs(Xxr)))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(Xxi),fe_mul(Xxi,fe_mul(dyb,fe_abs(Xxi)))),fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dyb,fe_abs(Xxi)))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_abs(Xxi),fe_add(fe_mul(Xxi,fe_mul(dxb,fe_abs(Xxr))),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxr))))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxr))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxi)))))))),dab))))));
dyan=fe_add(fe_imul(2,fe_mul(fe_abs(Xxr),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxr))))),fe_add(fe_imul(-2,fe_mul(fe_abs(Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxi))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(dxa,fe_abs(Xxr)))),fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxr)))))),fe_add(fe_imul(-2,fe_mul(fe_abs(Xxi),fe_mul(Xxi,fe_mul(dxa,fe_abs(Xxi))))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxi))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dya,fe_abs(Xxr)))),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxa,fe_abs(Xxi)))))),fe_add(fe_imul(4,fe_mul(fe_abs(Xxi),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxr))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_abs(Xxi),fe_mul(Xxi,fe_mul(dya,fe_abs(Xxr)))),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_abs(Xxi))))))),fe_add(fe_imul(4,fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxr)))))),dba)))))))));
dybn=fe_add(fe_imul(2,fe_mul(fe_abs(Xxr),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxr))))),fe_add(fe_imul(-2,fe_mul(fe_abs(Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxi))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(dxb,fe_abs(Xxr)))),fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxr)))))),fe_add(fe_imul(-2,fe_mul(fe_abs(Xxi),fe_mul(Xxi,fe_mul(dxb,fe_abs(Xxi))))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxi))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dyb,fe_abs(Xxr)))),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxb,fe_abs(Xxi)))))),fe_add(fe_imul(4,fe_mul(fe_abs(Xxi),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxr))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_abs(Xxi),fe_mul(Xxi,fe_mul(dyb,fe_abs(Xxr)))),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxi))))))),fe_add(fe_imul(4,fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxr)))))),dbb)))))))));
}

{xrn=fe_add(cr,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xi,xi)),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(Xr),fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr)),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_diffabs(Xi,xi),fe_add(fe_mul(Xi,Xi),fe_mul(xi,xi)))),fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi)),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(Xr),fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xr,xr)),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_diffabs(Xi,xi),fe_add(fe_mul(Xr,Xr),fe_mul(xr,xr)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_diffabs(Xr,xr),fe_add(fe_mul(Xi,Xi),fe_mul(xi,xi)))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(Xr),fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(xr,fe_diffabs(Xr,xr)))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(xr,fe_diffabs(Xi,xi)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(xi,fe_diffabs(Xr,xr)))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(xi,fe_diffabs(Xi,xi)))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(Xi,fe_add(fe_mul(Xr,fe_diffabs(Xr,xr)),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xr,xr)))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_mul(fe_diffabs(Xi,xi),fe_add(Xr,xr))),fe_add(fe_mul(Xr,fe_mul(xi,fe_diffabs(Xi,xi))),fe_mul(xi,fe_mul(xr,fe_diffabs(Xi,xi)))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(xr,xr),fe_diffabs(Xr,xr)))))))))))));
xin=fe_add(ci,fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))),fe_add(fe_mul(fe_abs(Xr),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xi,fe_mul(xr,fe_diffabs(Xr,xr))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xi,fe_mul(xr,fe_diffabs(Xi,xi)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(xi,xi),fe_diffabs(Xi,xi)))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(Xr),fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(xi,fe_diffabs(Xr,xr)))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(xi,fe_diffabs(Xi,xi)))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr))),fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_mul(xr,fe_diffabs(Xr,xr))),fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi))))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(xr,fe_diffabs(Xi,xi))))),fe_add(fe_imul(2,fe_mul(fe_mul(Xi,fe_mul(Xr,fe_diffabs(Xr,xr))),fe_add(fe_abs(Xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xr,xr)),fe_mul(Xi,fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(Xi,xi)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xi,xi)))))),fe_add(fe_imul(4,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(xr,fe_diffabs(Xi,xi)))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(xi,fe_diffabs(Xi,xi)))))),fe_imul(2,fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi)))))))))))))));
}

);

#if 0
static const char *perturbation_opencl_softfloat_58_4_0 = STR(

{xrn=sf_add(cr,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xi,xi)),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(Xr),sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr)),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_diffabs(Xi,xi),sf_add(sf_mul(Xi,Xi),sf_mul(xi,xi)))),sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi)),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(Xr),sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xr,xr)),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_diffabs(Xi,xi),sf_add(sf_mul(Xr,Xr),sf_mul(xr,xr)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_diffabs(Xr,xr),sf_add(sf_mul(Xi,Xi),sf_mul(xi,xi)))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(Xr),sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(xr,sf_diffabs(Xr,xr)))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(xr,sf_diffabs(Xi,xi)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(xi,sf_diffabs(Xr,xr)))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(xi,sf_diffabs(Xi,xi)))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(Xi,sf_add(sf_mul(Xr,sf_diffabs(Xr,xr)),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xr,xr)))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_mul(sf_diffabs(Xi,xi),sf_add(Xr,xr))),sf_add(sf_mul(Xr,sf_mul(xi,sf_diffabs(Xi,xi))),sf_mul(xi,sf_mul(xr,sf_diffabs(Xi,xi)))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(xr,xr),sf_diffabs(Xr,xr)))))))))))));
xin=sf_add(ci,sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))),sf_add(sf_mul(sf_abs(Xr),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xi,sf_mul(xr,sf_diffabs(Xr,xr))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xi,sf_mul(xr,sf_diffabs(Xi,xi)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(xi,xi),sf_diffabs(Xi,xi)))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(Xr),sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(xi,sf_diffabs(Xr,xr)))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(xi,sf_diffabs(Xi,xi)))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr))),sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_mul(xr,sf_diffabs(Xr,xr))),sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi))))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(xr,sf_diffabs(Xi,xi))))),sf_add(sf_imul(2,sf_mul(sf_mul(Xi,sf_mul(Xr,sf_diffabs(Xr,xr))),sf_add(sf_abs(Xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xr,xr)),sf_mul(Xi,sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(Xi,xi)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xi,xi)))))),sf_add(sf_imul(4,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(xr,sf_diffabs(Xi,xi)))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(xi,sf_diffabs(Xi,xi)))))),sf_imul(2,sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi)))))))))))))));
}

);
#endif


static const char *perturbation_opencl_double_59_4_0 = STR(

{xrn=d_add(cr,d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(Xi,xi))),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr))),d_add(d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))),d_add(d_imul(-3,d_add(d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr)))),d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_imul(3,d_mul(Xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_add(d_imul(-3,d_mul(Xr,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_add(d_imul(3,d_mul(d_mul(Xr,Xr),d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_imul(-3,d_add(d_mul(Xi,d_add(d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi)),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))),d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xi,xi)))))),d_add(d_imul(3,d_mul(Xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))),d_add(d_imul(-3,d_mul(d_mul(Xi,Xi),d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_imul(3,d_mul(d_mul(Xi,Xi),d_mul(xi,d_abs(d_add(Xi,xi))))),d_add(d_imul(-3,d_mul(d_mul(Xi,Xi),d_mul(Xr,d_diffabs(Xr,xr)))),d_add(d_imul(-6,d_add(d_mul(Xi,d_add(d_mul(Xr,d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_mul(Xr,d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))))),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))))))))))))))));
xin=d_add(ci,d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi))),d_add(d_imul(-1,d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(Xr,xr))),d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))))),d_add(d_imul(3,d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_add(d_imul(-3,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xi,xi))))),d_add(d_imul(3,d_mul(Xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))),d_add(d_imul(-3,d_mul(Xr,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))),d_add(d_imul(3,d_add(d_mul(Xi,d_add(d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr)),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_mul(d_mul(Xr,Xr),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_imul(-3,d_add(d_mul(d_mul(Xi,Xi),d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi)))))),d_mul(Xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))))),d_add(d_imul(6,d_mul(Xr,d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_imul(-6,d_mul(Xi,d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi)))))),d_add(d_imul(6,d_mul(Xi,d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_imul(-6,d_mul(Xi,d_mul(Xr,d_mul(xi,d_abs(d_add(Xi,xi)))))),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))))))))))))));
}

);

static const char *perturbation_opencl_double_59_4_1 = STR(

{dxan=d_add(d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dya,d_sgn(Xxi)))),d_add(d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_sgn(Xxr)))),d_add(d_imul(-3,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxi)))),d_add(d_imul(3,d_add(d_mul(d_mul(Xxi,Xxi),d_mul(dya,d_abs(Xxi))),d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr))))),d_add(d_imul(-3,d_add(d_mul(d_mul(Xxi,Xxi),d_add(d_mul(Xxr,d_mul(dxa,d_sgn(Xxr))),d_mul(dxa,d_abs(Xxr)))),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_sgn(Xxi)))))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxr,d_add(d_mul(dxa,d_abs(Xxi)),d_mul(dya,d_abs(Xxr)))))),daa))))));
dxbn=d_add(d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dyb,d_sgn(Xxi)))),d_add(d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_sgn(Xxr)))),d_add(d_imul(-3,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxi)))),d_add(d_imul(3,d_add(d_mul(d_mul(Xxi,Xxi),d_mul(dyb,d_abs(Xxi))),d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr))))),d_add(d_imul(-3,d_add(d_mul(d_mul(Xxi,Xxi),d_add(d_mul(Xxr,d_mul(dxb,d_sgn(Xxr))),d_mul(dxb,d_abs(Xxr)))),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_sgn(Xxi)))))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxr,d_add(d_mul(dxb,d_abs(Xxi)),d_mul(dyb,d_abs(Xxr)))))),dab))))));
dyan=d_add(d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_sgn(Xxi)))),d_add(d_imul(-1,d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dxa,d_sgn(Xxr))))),d_add(d_imul(3,d_mul(d_mul(Xxr,Xxr),d_add(d_mul(dxa,d_abs(Xxi)),d_mul(dya,d_abs(Xxr))))),d_add(d_imul(-3,d_mul(d_mul(Xxi,Xxi),d_add(d_mul(dxa,d_abs(Xxi)),d_mul(dya,d_abs(Xxr))))),d_add(d_imul(3,d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_sgn(Xxr))))),d_add(d_imul(-3,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dya,d_sgn(Xxi))))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_abs(Xxi))))),d_add(d_imul(6,d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_abs(Xxr))))),dba))))))));
dybn=d_add(d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_sgn(Xxi)))),d_add(d_imul(-1,d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dxb,d_sgn(Xxr))))),d_add(d_imul(3,d_mul(d_mul(Xxr,Xxr),d_add(d_mul(dxb,d_abs(Xxi)),d_mul(dyb,d_abs(Xxr))))),d_add(d_imul(-3,d_mul(d_mul(Xxi,Xxi),d_add(d_mul(dxb,d_abs(Xxi)),d_mul(dyb,d_abs(Xxr))))),d_add(d_imul(3,d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_sgn(Xxr))))),d_add(d_imul(-3,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dyb,d_sgn(Xxi))))),d_add(d_imul(-6,d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_abs(Xxi))))),d_add(d_imul(6,d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_abs(Xxr))))),dbb))))))));
}

{xrn=d_add(cr,d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(Xi,xi))),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr))),d_add(d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))),d_add(d_imul(-3,d_add(d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr)))),d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_imul(3,d_mul(Xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_add(d_imul(-3,d_mul(Xr,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_add(d_imul(3,d_mul(d_mul(Xr,Xr),d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_imul(-3,d_add(d_mul(Xi,d_add(d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi)),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))),d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xi,xi)))))),d_add(d_imul(3,d_mul(Xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))),d_add(d_imul(-3,d_mul(d_mul(Xi,Xi),d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_imul(3,d_mul(d_mul(Xi,Xi),d_mul(xi,d_abs(d_add(Xi,xi))))),d_add(d_imul(-3,d_mul(d_mul(Xi,Xi),d_mul(Xr,d_diffabs(Xr,xr)))),d_add(d_imul(-6,d_add(d_mul(Xi,d_add(d_mul(Xr,d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_mul(Xr,d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))))),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))))))))))))))));
xin=d_add(ci,d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi))),d_add(d_imul(-1,d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(Xr,xr))),d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))))),d_add(d_imul(3,d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_add(d_imul(-3,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xi,xi))))),d_add(d_imul(3,d_mul(Xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))),d_add(d_imul(-3,d_mul(Xr,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))),d_add(d_imul(3,d_add(d_mul(Xi,d_add(d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr)),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_mul(d_mul(Xr,Xr),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_imul(-3,d_add(d_mul(d_mul(Xi,Xi),d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi)))))),d_mul(Xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))))),d_add(d_imul(6,d_mul(Xr,d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_imul(-6,d_mul(Xi,d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi)))))),d_add(d_imul(6,d_mul(Xi,d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_imul(-6,d_mul(Xi,d_mul(Xr,d_mul(xi,d_abs(d_add(Xi,xi)))))),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))))))))))))));
}

);

static const char *perturbation_opencl_floatexp_59_4_0 = STR(

{xrn=fe_add(cr,fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xi,xi))),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr))),fe_add(fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(3,fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_imul(-3,fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_add(fe_imul(3,fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_imul(-3,fe_add(fe_mul(Xi,fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi)),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(3,fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))),fe_add(fe_imul(-3,fe_mul(fe_mul(Xi,Xi),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_imul(3,fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_add(fe_imul(-3,fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_diffabs(Xr,xr)))),fe_add(fe_imul(-6,fe_add(fe_mul(Xi,fe_add(fe_mul(Xr,fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))))))))))))))));
xin=fe_add(ci,fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi))),fe_add(fe_imul(-1,fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xr,xr))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(3,fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_imul(-3,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_add(fe_imul(3,fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))),fe_add(fe_imul(-3,fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))),fe_add(fe_imul(3,fe_add(fe_mul(Xi,fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr)),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_mul(Xr,Xr),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(6,fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(-6,fe_mul(Xi,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(6,fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(-6,fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))))))))))))));
}

);

static const char *perturbation_opencl_floatexp_59_4_1 = STR(

{dxan=fe_add(fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dya,fe_sgn(Xxi)))),fe_add(fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_sgn(Xxr)))),fe_add(fe_imul(-3,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxi)))),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(dya,fe_abs(Xxi))),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_add(fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr))),fe_mul(dxa,fe_abs(Xxr)))),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_sgn(Xxi)))))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxr,fe_add(fe_mul(dxa,fe_abs(Xxi)),fe_mul(dya,fe_abs(Xxr)))))),daa))))));
dxbn=fe_add(fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dyb,fe_sgn(Xxi)))),fe_add(fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_sgn(Xxr)))),fe_add(fe_imul(-3,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxi)))),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(dyb,fe_abs(Xxi))),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_add(fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr))),fe_mul(dxb,fe_abs(Xxr)))),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_sgn(Xxi)))))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxr,fe_add(fe_mul(dxb,fe_abs(Xxi)),fe_mul(dyb,fe_abs(Xxr)))))),dab))))));
dyan=fe_add(fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_sgn(Xxi)))),fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxa,fe_sgn(Xxr))))),fe_add(fe_imul(3,fe_mul(fe_mul(Xxr,Xxr),fe_add(fe_mul(dxa,fe_abs(Xxi)),fe_mul(dya,fe_abs(Xxr))))),fe_add(fe_imul(-3,fe_mul(fe_mul(Xxi,Xxi),fe_add(fe_mul(dxa,fe_abs(Xxi)),fe_mul(dya,fe_abs(Xxr))))),fe_add(fe_imul(3,fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_sgn(Xxr))))),fe_add(fe_imul(-3,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxi))))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_abs(Xxi))))),fe_add(fe_imul(6,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxr))))),dba))))))));
dybn=fe_add(fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_sgn(Xxi)))),fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxb,fe_sgn(Xxr))))),fe_add(fe_imul(3,fe_mul(fe_mul(Xxr,Xxr),fe_add(fe_mul(dxb,fe_abs(Xxi)),fe_mul(dyb,fe_abs(Xxr))))),fe_add(fe_imul(-3,fe_mul(fe_mul(Xxi,Xxi),fe_add(fe_mul(dxb,fe_abs(Xxi)),fe_mul(dyb,fe_abs(Xxr))))),fe_add(fe_imul(3,fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_sgn(Xxr))))),fe_add(fe_imul(-3,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxi))))),fe_add(fe_imul(-6,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxi))))),fe_add(fe_imul(6,fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxr))))),dbb))))))));
}

{xrn=fe_add(cr,fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xi,xi))),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr))),fe_add(fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(3,fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_imul(-3,fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_add(fe_imul(3,fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_imul(-3,fe_add(fe_mul(Xi,fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi)),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(3,fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))),fe_add(fe_imul(-3,fe_mul(fe_mul(Xi,Xi),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_imul(3,fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_add(fe_imul(-3,fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_diffabs(Xr,xr)))),fe_add(fe_imul(-6,fe_add(fe_mul(Xi,fe_add(fe_mul(Xr,fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))))))))))))))));
xin=fe_add(ci,fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi))),fe_add(fe_imul(-1,fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xr,xr))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(3,fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_imul(-3,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_add(fe_imul(3,fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))),fe_add(fe_imul(-3,fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))),fe_add(fe_imul(3,fe_add(fe_mul(Xi,fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr)),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_mul(Xr,Xr),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(6,fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(-6,fe_mul(Xi,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(6,fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(-6,fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))))))))))))));
}

);

#if 0
static const char *perturbation_opencl_softfloat_59_4_0 = STR(

{xrn=sf_add(cr,sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xi,xi))),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr))),sf_add(sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(3,sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_imul(-3,sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_add(sf_imul(3,sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_imul(-3,sf_add(sf_mul(Xi,sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi)),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(3,sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))),sf_add(sf_imul(-3,sf_mul(sf_mul(Xi,Xi),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_imul(3,sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_add(sf_imul(-3,sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_diffabs(Xr,xr)))),sf_add(sf_imul(-6,sf_add(sf_mul(Xi,sf_add(sf_mul(Xr,sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))))))))))))))));
xin=sf_add(ci,sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi))),sf_add(sf_imul(-1,sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xr,xr))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(3,sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_imul(-3,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_add(sf_imul(3,sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))),sf_add(sf_imul(-3,sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))),sf_add(sf_imul(3,sf_add(sf_mul(Xi,sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr)),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_mul(Xr,Xr),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(6,sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(-6,sf_mul(Xi,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(6,sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(-6,sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))))))))))))));
}

);
#endif


static const char *perturbation_opencl_double_60_5_0 = STR(

{xrn=d_add(cr,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xi,Xi))),d_add(d_mul(Xi,d_diffabs(Xr,xr)),d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_mul(Xr,d_diffabs(Xr,xr))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi)))),d_add(Xr,xr))),d_add(d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi))))),d_add(d_mul(Xr,d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr))))),d_add(d_mul(xi,d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi))))),d_mul(xr,d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr))))))))),d_add(d_imul(-1,d_add(d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_add(d_mul(Xi,d_diffabs(Xi,xi)),d_mul(xi,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr)))),d_add(Xi,xi))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(xr,d_abs(d_add(Xr,xr)))),d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(xr,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr)))))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(xi,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr))))))),d_mul(xr,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr)))))))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(xi,d_abs(d_add(Xi,xi)))),d_mul(d_abs(d_add(Xi,xi)),d_mul(xi,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr))))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(Xr,d_diffabs(Xr,xr))),d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_add(d_mul(Xi,d_diffabs(Xr,xr)),d_mul(Xr,d_diffabs(Xi,xi)))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr)))))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr))))))),d_mul(Xr,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr)))))))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(Xi,d_diffabs(Xi,xi))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr))))))))),d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_mul(xr,d_abs(d_add(Xr,xr))))))))))))));
xin=d_add(ci,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xi,Xi))),d_add(d_mul(Xi,d_diffabs(Xi,xi)),d_mul(xi,d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_add(d_mul(Xi,d_diffabs(Xr,xr)),d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_mul(xi,d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(Xi,d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi))))),d_add(d_mul(Xr,d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr))))),d_add(d_mul(xi,d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi))))),d_mul(xr,d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr))))))))),d_add(d_mul(d_abs(d_add(Xr,xr)),d_mul(d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr)))),d_add(Xi,xi))),d_add(d_imul(-1,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xi,Xi))),d_add(d_mul(Xr,d_diffabs(Xr,xr)),d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi)))),d_add(Xr,xr))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(xr,d_abs(d_add(Xr,xr)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xr,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr)))))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(xi,d_abs(d_add(Xi,xi)))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(xi,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr))))))),d_mul(xr,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr)))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xi,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr))))))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(Xr,d_diffabs(Xr,xr))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr)))))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_add(d_mul(Xi,d_diffabs(Xr,xr)),d_mul(Xr,d_diffabs(Xi,xi)))),d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(Xi,d_diffabs(Xi,xi))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(Xi,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr))))))),d_mul(Xr,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr)))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr))))))))))),d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_mul(xr,d_abs(d_add(Xi,xi))))))))))))));
}

);

static const char *perturbation_opencl_double_60_5_1 = STR(

{dxan=d_add(daa,d_add(d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_mul(dxa,d_abs(Xxi)),d_mul(dya,d_abs(Xxr)))),d_add(d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(dxa,d_abs(Xxr))),d_add(d_mul(d_sgn(Xxi),d_mul(Xxr,d_mul(dya,d_abs(d_mul(Xxi,d_mul(Xxi,Xxi)))))),d_add(d_mul(d_sgn(Xxr),d_add(d_mul(Xxi,d_mul(dxa,d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))))),d_mul(Xxr,d_mul(dxa,d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))))))),d_add(d_imul(-1,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(dya,d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))))))),d_add(d_imul(-3,d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(dya,d_abs(Xxr)))),d_add(d_imul(3,d_mul(d_abs(d_mul(d_mul(Xxi,Xxi),Xxr)),d_mul(dya,d_abs(Xxi)))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(d_mul(Xxi,Xxi),Xxr)),d_mul(dxa,d_abs(Xxr))),d_add(d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(dxa,d_abs(Xxi))),d_add(d_mul(d_sgn(Xxi),d_add(d_mul(Xxr,d_mul(dya,d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxi))))))),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(dxa,d_abs(d_mul(d_mul(Xxi,Xxi),Xxr))))))))),d_add(d_imul(3,d_add(d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(dya,d_abs(d_mul(d_mul(Xxi,Xxi),Xxr))))),d_mul(d_sgn(Xxr),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr)))))))),d_add(d_imul(-3,d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxa,d_abs(Xxr)))))),d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxr)))))),d_mul(d_sgn(Xxr),d_add(d_mul(Xxi,d_mul(dxa,d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxi)))))))))),d_add(d_imul(3,d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_add(d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dya,d_abs(Xxr)))),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dya,d_abs(Xxi))))))),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dxa,d_abs(Xxi)))))))),d_add(d_imul(-6,d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxr)))))),d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxi)))))))),d_add(d_imul(6,d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dya,d_abs(Xxi))))))),d_add(d_imul(-6,d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxa,d_abs(Xxr))))))),d_imul(-1,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(dya,d_abs(Xxi)))))))))))))))))));
dxbn=d_add(dab,d_add(d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))),d_add(d_mul(dxb,d_abs(Xxi)),d_mul(dyb,d_abs(Xxr)))),d_add(d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(dxb,d_abs(Xxr))),d_add(d_mul(d_sgn(Xxi),d_mul(Xxr,d_mul(dyb,d_abs(d_mul(Xxi,d_mul(Xxi,Xxi)))))),d_add(d_mul(d_sgn(Xxr),d_add(d_mul(Xxi,d_mul(dxb,d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))))),d_mul(Xxr,d_mul(dxb,d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))))))),d_add(d_imul(-1,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(dyb,d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))))))),d_add(d_imul(-3,d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(dyb,d_abs(Xxr)))),d_add(d_imul(3,d_mul(d_abs(d_mul(d_mul(Xxi,Xxi),Xxr)),d_mul(dyb,d_abs(Xxi)))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(d_mul(Xxi,Xxi),Xxr)),d_mul(dxb,d_abs(Xxr))),d_add(d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(dxb,d_abs(Xxi))),d_add(d_mul(d_sgn(Xxi),d_add(d_mul(Xxr,d_mul(dyb,d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxi))))))),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(dxb,d_abs(d_mul(d_mul(Xxi,Xxi),Xxr))))))))),d_add(d_imul(3,d_add(d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(dyb,d_abs(d_mul(d_mul(Xxi,Xxi),Xxr))))),d_mul(d_sgn(Xxr),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr)))))))),d_add(d_imul(-3,d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxb,d_abs(Xxr)))))),d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxr)))))),d_mul(d_sgn(Xxr),d_add(d_mul(Xxi,d_mul(dxb,d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxi)))))))))),d_add(d_imul(3,d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_add(d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dyb,d_abs(Xxr)))),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dyb,d_abs(Xxi))))))),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dxb,d_abs(Xxi)))))))),d_add(d_imul(-6,d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxr)))))),d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxi)))))))),d_add(d_imul(6,d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dyb,d_abs(Xxi))))))),d_add(d_imul(-6,d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxb,d_abs(Xxr))))))),d_imul(-1,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(dyb,d_abs(Xxi)))))))))))))))))));
dyan=d_add(dba,d_add(d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(dya,d_abs(Xxi))),d_add(d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(dxa,d_abs(Xxi))),d_add(d_mul(d_sgn(Xxi),d_add(d_mul(Xxi,d_mul(dya,d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))))),d_mul(Xxr,d_mul(dya,d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))))))),d_add(d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(dxa,d_abs(d_mul(Xxr,d_mul(Xxr,Xxr)))))),d_add(d_imul(-1,d_add(d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(dxa,d_abs(Xxr))),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(dxa,d_abs(d_mul(Xxi,d_mul(Xxi,Xxi)))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(d_mul(Xxi,Xxi),Xxr)),d_mul(dya,d_abs(Xxr))),d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(dya,d_abs(Xxi))))),d_add(d_imul(3,d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(dxa,d_abs(Xxr)))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(d_mul(Xxi,Xxi),Xxr)),d_mul(dxa,d_abs(Xxi))),d_mul(d_sgn(Xxi),d_mul(Xxr,d_mul(dya,d_abs(d_mul(d_mul(Xxi,Xxi),Xxr))))))),d_add(d_imul(3,d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxr)))))),d_mul(d_sgn(Xxr),d_add(d_mul(Xxr,d_mul(dxa,d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxi))))))))),d_add(d_imul(-3,d_add(d_mul(d_sgn(Xxi),d_add(d_mul(Xxi,d_mul(dya,d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxi))))))),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(dxa,d_abs(d_mul(d_mul(Xxi,Xxi),Xxr))))))),d_add(d_imul(3,d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dya,d_abs(Xxi)))))),d_mul(d_sgn(Xxr),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr)))))))),d_add(d_imul(-3,d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dya,d_abs(Xxr)))))),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_add(d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dxa,d_abs(Xxr)))),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxa,d_abs(Xxi))))))))),d_add(d_imul(-6,d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxi))))))),d_add(d_imul(6,d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr))))))),d_add(d_imul(-6,d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dya,d_abs(Xxr)))))),d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxa,d_abs(Xxi)))))))),d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(dya,d_abs(Xxr)))))))))))))))))));
dybn=d_add(dbb,d_add(d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(dyb,d_abs(Xxi))),d_add(d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(dxb,d_abs(Xxi))),d_add(d_mul(d_sgn(Xxi),d_add(d_mul(Xxi,d_mul(dyb,d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))))),d_mul(Xxr,d_mul(dyb,d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))))))),d_add(d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(dxb,d_abs(d_mul(Xxr,d_mul(Xxr,Xxr)))))),d_add(d_imul(-1,d_add(d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(dxb,d_abs(Xxr))),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(dxb,d_abs(d_mul(Xxi,d_mul(Xxi,Xxi)))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(d_mul(Xxi,Xxi),Xxr)),d_mul(dyb,d_abs(Xxr))),d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(dyb,d_abs(Xxi))))),d_add(d_imul(3,d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(dxb,d_abs(Xxr)))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(d_mul(Xxi,Xxi),Xxr)),d_mul(dxb,d_abs(Xxi))),d_mul(d_sgn(Xxi),d_mul(Xxr,d_mul(dyb,d_abs(d_mul(d_mul(Xxi,Xxi),Xxr))))))),d_add(d_imul(3,d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxr)))))),d_mul(d_sgn(Xxr),d_add(d_mul(Xxr,d_mul(dxb,d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxi))))))))),d_add(d_imul(-3,d_add(d_mul(d_sgn(Xxi),d_add(d_mul(Xxi,d_mul(dyb,d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxi))))))),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(dxb,d_abs(d_mul(d_mul(Xxi,Xxi),Xxr))))))),d_add(d_imul(3,d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dyb,d_abs(Xxi)))))),d_mul(d_sgn(Xxr),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr)))))))),d_add(d_imul(-3,d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dyb,d_abs(Xxr)))))),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_add(d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dxb,d_abs(Xxr)))),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxb,d_abs(Xxi))))))))),d_add(d_imul(-6,d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxi))))))),d_add(d_imul(6,d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr))))))),d_add(d_imul(-6,d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dyb,d_abs(Xxr)))))),d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxb,d_abs(Xxi)))))))),d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(dyb,d_abs(Xxr)))))))))))))))))));
}

{xrn=d_add(cr,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xi,Xi))),d_add(d_mul(Xi,d_diffabs(Xr,xr)),d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_mul(Xr,d_diffabs(Xr,xr))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi)))),d_add(Xr,xr))),d_add(d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi))))),d_add(d_mul(Xr,d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr))))),d_add(d_mul(xi,d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi))))),d_mul(xr,d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr))))))))),d_add(d_imul(-1,d_add(d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_add(d_mul(Xi,d_diffabs(Xi,xi)),d_mul(xi,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr)))),d_add(Xi,xi))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(xr,d_abs(d_add(Xr,xr)))),d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(xr,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr)))))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(xi,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr))))))),d_mul(xr,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr)))))))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(xi,d_abs(d_add(Xi,xi)))),d_mul(d_abs(d_add(Xi,xi)),d_mul(xi,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr))))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(Xr,d_diffabs(Xr,xr))),d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_add(d_mul(Xi,d_diffabs(Xr,xr)),d_mul(Xr,d_diffabs(Xi,xi)))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr)))))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr))))))),d_mul(Xr,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr)))))))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(Xi,d_diffabs(Xi,xi))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr))))))))),d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_mul(xr,d_abs(d_add(Xr,xr))))))))))))));
xin=d_add(ci,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xi,Xi))),d_add(d_mul(Xi,d_diffabs(Xi,xi)),d_mul(xi,d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_add(d_mul(Xi,d_diffabs(Xr,xr)),d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_mul(xi,d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(Xi,d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi))))),d_add(d_mul(Xr,d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr))))),d_add(d_mul(xi,d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi))))),d_mul(xr,d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr))))))))),d_add(d_mul(d_abs(d_add(Xr,xr)),d_mul(d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr)))),d_add(Xi,xi))),d_add(d_imul(-1,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xi,Xi))),d_add(d_mul(Xr,d_diffabs(Xr,xr)),d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi)))),d_add(Xr,xr))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(xr,d_abs(d_add(Xr,xr)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xr,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr)))))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(xi,d_abs(d_add(Xi,xi)))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(xi,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr))))))),d_mul(xr,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr)))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xi,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr))))))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(Xr,d_diffabs(Xr,xr))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr)))))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_add(d_mul(Xi,d_diffabs(Xr,xr)),d_mul(Xr,d_diffabs(Xi,xi)))),d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(Xi,d_diffabs(Xi,xi))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(Xi,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr))))))),d_mul(Xr,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr)))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr))))))))))),d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_mul(xr,d_abs(d_add(Xi,xi))))))))))))));
}

);

static const char *perturbation_opencl_floatexp_60_5_0 = STR(

{xrn=fe_add(cr,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xi,Xi))),fe_add(fe_mul(Xi,fe_diffabs(Xr,xr)),fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_mul(Xr,fe_diffabs(Xr,xr))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi)))),fe_add(Xr,xr))),fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi))))),fe_add(fe_mul(Xr,fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr))))),fe_add(fe_mul(xi,fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi))))),fe_mul(xr,fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr))))))))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_add(fe_mul(Xi,fe_diffabs(Xi,xi)),fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr)))),fe_add(Xi,xi))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xr,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr)))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(xi,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr))))))),fe_mul(xr,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr)))))))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(xi,fe_abs(fe_add(Xi,xi)))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xi,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr))))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(Xr,fe_diffabs(Xr,xr))),fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_add(fe_mul(Xi,fe_diffabs(Xr,xr)),fe_mul(Xr,fe_diffabs(Xi,xi)))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr)))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr))))))),fe_mul(Xr,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr)))))))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(Xi,fe_diffabs(Xi,xi))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr))))))))),fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_mul(xr,fe_abs(fe_add(Xr,xr))))))))))))));
xin=fe_add(ci,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xi,Xi))),fe_add(fe_mul(Xi,fe_diffabs(Xi,xi)),fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_add(fe_mul(Xi,fe_diffabs(Xr,xr)),fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_mul(xi,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(Xi,fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi))))),fe_add(fe_mul(Xr,fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr))))),fe_add(fe_mul(xi,fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi))))),fe_mul(xr,fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr))))))))),fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr)))),fe_add(Xi,xi))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xi,Xi))),fe_add(fe_mul(Xr,fe_diffabs(Xr,xr)),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi)))),fe_add(Xr,xr))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xr,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr)))))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(xi,fe_abs(fe_add(Xi,xi)))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(xi,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr))))))),fe_mul(xr,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr)))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xi,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr))))))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(Xr,fe_diffabs(Xr,xr))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr)))))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_add(fe_mul(Xi,fe_diffabs(Xr,xr)),fe_mul(Xr,fe_diffabs(Xi,xi)))),fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(Xi,fe_diffabs(Xi,xi))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(Xi,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr))))))),fe_mul(Xr,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr)))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr))))))))))),fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))))))))));
}

);

static const char *perturbation_opencl_floatexp_60_5_1 = STR(

{dxan=fe_add(daa,fe_add(fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_mul(dxa,fe_abs(Xxi)),fe_mul(dya,fe_abs(Xxr)))),fe_add(fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(dxa,fe_abs(Xxr))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi)))))),fe_add(fe_mul(fe_sgn(Xxr),fe_add(fe_mul(Xxi,fe_mul(dxa,fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))))),fe_mul(Xxr,fe_mul(dxa,fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))))))),fe_add(fe_imul(-1,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(dya,fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(dya,fe_abs(Xxr)))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr)),fe_mul(dya,fe_abs(Xxi)))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr)),fe_mul(dxa,fe_abs(Xxr))),fe_add(fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(dxa,fe_abs(Xxi))),fe_add(fe_mul(fe_sgn(Xxi),fe_add(fe_mul(Xxr,fe_mul(dya,fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxi))))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(dxa,fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr))))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(dya,fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr))))),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr)))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxr)))))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxr)))))),fe_mul(fe_sgn(Xxr),fe_add(fe_mul(Xxi,fe_mul(dxa,fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxi)))))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_add(fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dya,fe_abs(Xxr)))),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxi))))))),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxa,fe_abs(Xxi)))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxr)))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxi)))))))),fe_add(fe_imul(6,fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxi))))))),fe_add(fe_imul(-6,fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxr))))))),fe_imul(-1,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(dya,fe_abs(Xxi)))))))))))))))))));
dxbn=fe_add(dab,fe_add(fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_add(fe_mul(dxb,fe_abs(Xxi)),fe_mul(dyb,fe_abs(Xxr)))),fe_add(fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(dxb,fe_abs(Xxr))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi)))))),fe_add(fe_mul(fe_sgn(Xxr),fe_add(fe_mul(Xxi,fe_mul(dxb,fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))))),fe_mul(Xxr,fe_mul(dxb,fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))))))),fe_add(fe_imul(-1,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(dyb,fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(dyb,fe_abs(Xxr)))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr)),fe_mul(dyb,fe_abs(Xxi)))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr)),fe_mul(dxb,fe_abs(Xxr))),fe_add(fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(dxb,fe_abs(Xxi))),fe_add(fe_mul(fe_sgn(Xxi),fe_add(fe_mul(Xxr,fe_mul(dyb,fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxi))))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(dxb,fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr))))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(dyb,fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr))))),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr)))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxr)))))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxr)))))),fe_mul(fe_sgn(Xxr),fe_add(fe_mul(Xxi,fe_mul(dxb,fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxi)))))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_add(fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dyb,fe_abs(Xxr)))),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxi))))))),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxb,fe_abs(Xxi)))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxr)))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxi)))))))),fe_add(fe_imul(6,fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxi))))))),fe_add(fe_imul(-6,fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxr))))))),fe_imul(-1,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(dyb,fe_abs(Xxi)))))))))))))))))));
dyan=fe_add(dba,fe_add(fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(dya,fe_abs(Xxi))),fe_add(fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(dxa,fe_abs(Xxi))),fe_add(fe_mul(fe_sgn(Xxi),fe_add(fe_mul(Xxi,fe_mul(dya,fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))))),fe_mul(Xxr,fe_mul(dya,fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))))))),fe_add(fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(dxa,fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr)))))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(dxa,fe_abs(Xxr))),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(dxa,fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi)))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr)),fe_mul(dya,fe_abs(Xxr))),fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(dya,fe_abs(Xxi))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(dxa,fe_abs(Xxr)))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr)),fe_mul(dxa,fe_abs(Xxi))),fe_mul(fe_sgn(Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxr)))))),fe_mul(fe_sgn(Xxr),fe_add(fe_mul(Xxr,fe_mul(dxa,fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxi))))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_sgn(Xxi),fe_add(fe_mul(Xxi,fe_mul(dya,fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxi))))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(dxa,fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dya,fe_abs(Xxi)))))),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr)))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxr)))))),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_add(fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxa,fe_abs(Xxr)))),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxi))))))))),fe_add(fe_imul(-6,fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxi))))))),fe_add(fe_imul(6,fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxr)))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxi)))))))),fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(dya,fe_abs(Xxr)))))))))))))))))));
dybn=fe_add(dbb,fe_add(fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(dyb,fe_abs(Xxi))),fe_add(fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(dxb,fe_abs(Xxi))),fe_add(fe_mul(fe_sgn(Xxi),fe_add(fe_mul(Xxi,fe_mul(dyb,fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))))),fe_mul(Xxr,fe_mul(dyb,fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))))))),fe_add(fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(dxb,fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr)))))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(dxb,fe_abs(Xxr))),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(dxb,fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi)))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr)),fe_mul(dyb,fe_abs(Xxr))),fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(dyb,fe_abs(Xxi))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(dxb,fe_abs(Xxr)))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr)),fe_mul(dxb,fe_abs(Xxi))),fe_mul(fe_sgn(Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxr)))))),fe_mul(fe_sgn(Xxr),fe_add(fe_mul(Xxr,fe_mul(dxb,fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxi))))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_sgn(Xxi),fe_add(fe_mul(Xxi,fe_mul(dyb,fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxi))))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(dxb,fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dyb,fe_abs(Xxi)))))),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr)))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxr)))))),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_add(fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxb,fe_abs(Xxr)))),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxi))))))))),fe_add(fe_imul(-6,fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxi))))))),fe_add(fe_imul(6,fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxr)))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxi)))))))),fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(dyb,fe_abs(Xxr)))))))))))))))))));
}

{xrn=fe_add(cr,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xi,Xi))),fe_add(fe_mul(Xi,fe_diffabs(Xr,xr)),fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_mul(Xr,fe_diffabs(Xr,xr))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi)))),fe_add(Xr,xr))),fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi))))),fe_add(fe_mul(Xr,fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr))))),fe_add(fe_mul(xi,fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi))))),fe_mul(xr,fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr))))))))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_add(fe_mul(Xi,fe_diffabs(Xi,xi)),fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr)))),fe_add(Xi,xi))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xr,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr)))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(xi,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr))))))),fe_mul(xr,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr)))))))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(xi,fe_abs(fe_add(Xi,xi)))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xi,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr))))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(Xr,fe_diffabs(Xr,xr))),fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_add(fe_mul(Xi,fe_diffabs(Xr,xr)),fe_mul(Xr,fe_diffabs(Xi,xi)))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr)))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr))))))),fe_mul(Xr,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr)))))))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(Xi,fe_diffabs(Xi,xi))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr))))))))),fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_mul(xr,fe_abs(fe_add(Xr,xr))))))))))))));
xin=fe_add(ci,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xi,Xi))),fe_add(fe_mul(Xi,fe_diffabs(Xi,xi)),fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_add(fe_mul(Xi,fe_diffabs(Xr,xr)),fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_mul(xi,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(Xi,fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi))))),fe_add(fe_mul(Xr,fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr))))),fe_add(fe_mul(xi,fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi))))),fe_mul(xr,fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr))))))))),fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr)))),fe_add(Xi,xi))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xi,Xi))),fe_add(fe_mul(Xr,fe_diffabs(Xr,xr)),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi)))),fe_add(Xr,xr))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xr,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr)))))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(xi,fe_abs(fe_add(Xi,xi)))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(xi,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr))))))),fe_mul(xr,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr)))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xi,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr))))))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(Xr,fe_diffabs(Xr,xr))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr)))))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_add(fe_mul(Xi,fe_diffabs(Xr,xr)),fe_mul(Xr,fe_diffabs(Xi,xi)))),fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(Xi,fe_diffabs(Xi,xi))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(Xi,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr))))))),fe_mul(Xr,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr)))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr))))))))))),fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))))))))));
}

);

#if 0
static const char *perturbation_opencl_softfloat_60_5_0 = STR(

{xrn=sf_add(cr,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xi,Xi))),sf_add(sf_mul(Xi,sf_diffabs(Xr,xr)),sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_mul(Xr,sf_diffabs(Xr,xr))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi)))),sf_add(Xr,xr))),sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi))))),sf_add(sf_mul(Xr,sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr))))),sf_add(sf_mul(xi,sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi))))),sf_mul(xr,sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr))))))))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_add(sf_mul(Xi,sf_diffabs(Xi,xi)),sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr)))),sf_add(Xi,xi))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xr,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr)))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(xi,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr))))))),sf_mul(xr,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr)))))))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(xi,sf_abs(sf_add(Xi,xi)))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xi,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr))))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(Xr,sf_diffabs(Xr,xr))),sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_add(sf_mul(Xi,sf_diffabs(Xr,xr)),sf_mul(Xr,sf_diffabs(Xi,xi)))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr)))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr))))))),sf_mul(Xr,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr)))))))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(Xi,sf_diffabs(Xi,xi))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr))))))))),sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_mul(xr,sf_abs(sf_add(Xr,xr))))))))))))));
xin=sf_add(ci,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xi,Xi))),sf_add(sf_mul(Xi,sf_diffabs(Xi,xi)),sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_add(sf_mul(Xi,sf_diffabs(Xr,xr)),sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_mul(xi,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(Xi,sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi))))),sf_add(sf_mul(Xr,sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr))))),sf_add(sf_mul(xi,sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi))))),sf_mul(xr,sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr))))))))),sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr)))),sf_add(Xi,xi))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xi,Xi))),sf_add(sf_mul(Xr,sf_diffabs(Xr,xr)),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi)))),sf_add(Xr,xr))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xr,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr)))))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(xi,sf_abs(sf_add(Xi,xi)))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(xi,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr))))))),sf_mul(xr,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr)))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xi,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr))))))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(Xr,sf_diffabs(Xr,xr))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr)))))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_add(sf_mul(Xi,sf_diffabs(Xr,xr)),sf_mul(Xr,sf_diffabs(Xi,xi)))),sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(Xi,sf_diffabs(Xi,xi))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(Xi,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr))))))),sf_mul(Xr,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr)))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr))))))))))),sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))))))))));
}

);
#endif


static const char *perturbation_opencl_double_61_5_0 = STR(

{xrn=d_add(cr,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_add(d_mul(d_mul(Xi,Xi),d_diffabs(Xr,xr)),d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr))),d_add(d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(d_mul(Xi,Xi),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))),d_add(d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))),d_add(d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))),d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))))))),d_add(d_imul(-1,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_add(d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr)),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_add(d_mul(d_mul(Xi,Xi),d_diffabs(Xr,xr)),d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(d_mul(Xi,Xi),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))),d_add(d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))),d_add(d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))),d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))),d_add(d_imul(2,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi)))))),d_add(d_imul(-2,d_mul(d_abs(d_add(Xi,xi)),d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))),d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xr,d_mul(xi,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))))),d_add(d_imul(2,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xr,d_mul(xi,d_abs(d_add(Xi,xi)))))),d_add(d_imul(-2,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(xi,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(2,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(xi,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xi,d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))),d_add(d_imul(2,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xi,d_mul(xr,d_abs(d_add(Xi,xi)))))),d_add(d_imul(-2,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(2,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xi,d_mul(xi,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(xi,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xi,d_mul(xi,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(xi,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))),d_add(d_imul(-2,d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xi,d_mul(Xr,d_diffabs(Xi,xi))))),d_add(d_imul(2,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xi,d_mul(Xr,d_diffabs(Xi,xi))))),d_add(d_imul(-2,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(Xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(d_mul(Xi,Xi),d_diffabs(Xi,xi))),d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(d_mul(Xi,Xi),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))),d_mul(Xi,d_mul(Xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))))),d_add(d_imul(-4,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_add(d_mul(Xi,d_mul(xr,d_abs(d_add(Xr,xr)))),d_add(d_mul(Xr,d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr))))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_mul(xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))),d_add(d_mul(Xr,d_mul(xi,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))),d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))))))),d_add(d_imul(4,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(Xi,d_mul(xi,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(xi,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))),d_add(d_imul(-4,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(Xi,d_mul(Xr,d_diffabs(Xr,xr)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(Xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))),d_mul(d_abs(d_mul(Xr,Xr)),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))))))))))))))))))))))))))));
xin=d_add(ci,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_add(d_mul(d_mul(Xi,Xi),d_diffabs(Xi,xi)),d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(d_mul(Xi,Xi),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))),d_add(d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))),d_add(d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))),d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))))))),d_add(d_imul(-1,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_add(d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi)),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_add(d_mul(d_mul(Xi,Xi),d_diffabs(Xi,xi)),d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(d_mul(Xi,Xi),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))),d_add(d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))),d_add(d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))),d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))),d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))),d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))))),d_add(d_imul(2,d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xr,d_mul(xr,d_abs(d_add(Xi,xi)))))),d_add(d_imul(-2,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xr,d_mul(xr,d_abs(d_add(Xi,xi)))))),d_add(d_imul(2,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(-2,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xr,d_mul(xi,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(xi,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xr,d_mul(xi,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(xi,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xi,d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_mul(xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))),d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xi,d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xi,d_mul(xi,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))))),d_add(d_imul(2,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xi,d_mul(xi,d_abs(d_add(Xi,xi)))))),d_add(d_imul(-2,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(xi,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xi,d_mul(Xr,d_diffabs(Xr,xr)))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(xi,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(Xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xi,d_mul(Xr,d_diffabs(Xr,xr)))),d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(d_mul(Xi,Xi),d_diffabs(Xr,xr))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(d_mul(Xi,Xi),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))),d_mul(Xi,d_mul(Xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))))),d_add(d_imul(-4,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))),d_add(d_imul(4,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))),d_add(d_imul(-4,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_add(d_mul(Xi,d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi)))))),d_mul(Xr,d_mul(xi,d_abs(d_add(Xi,xi)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(Xi,d_mul(d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))),d_add(Xr,xr))),d_mul(Xr,d_mul(xi,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(xi,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))))),d_mul(d_abs(d_mul(Xr,Xr)),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))))))))))))))))))))))));
}

);

static const char *perturbation_opencl_double_61_5_1 = STR(

{dxan=d_add(d_mul(d_sgn(Xxr),d_add(d_mul(d_mul(Xxi,Xxi),d_mul(dxa,d_abs(d_mul(Xxi,Xxi)))),d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(d_mul(Xxr,Xxr)))))),d_add(d_imul(-1,d_mul(d_sgn(Xxr),d_add(d_mul(d_mul(Xxi,Xxi),d_mul(dxa,d_abs(d_mul(Xxr,Xxr)))),d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(d_mul(Xxi,Xxi))))))),d_add(d_imul(-2,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxr,d_mul(dya,d_abs(Xxi))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxr,d_mul(dya,d_abs(Xxi)))),d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxr,d_mul(dxa,d_abs(Xxr)))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxr,d_mul(dxa,d_abs(Xxr)))),d_mul(d_sgn(Xxi),d_add(d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(d_mul(Xxi,Xxr)))),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxi))))))))),d_add(d_imul(2,d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr)))))),d_add(d_imul(-2,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,d_mul(dya,d_abs(Xxr))))),d_add(d_imul(2,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxi,d_mul(dya,d_abs(Xxr))))),d_add(d_imul(-2,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,d_mul(dxa,d_abs(Xxi))))),d_add(d_imul(2,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxi,d_mul(dxa,d_abs(Xxi))))),d_add(d_imul(-2,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_abs(d_mul(Xxr,Xxr))))))),d_add(d_imul(2,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_abs(d_mul(Xxi,Xxi))))))),d_add(d_imul(-2,d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxr))))),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxi)))))))),d_add(d_imul(2,d_mul(d_sgn(Xxi),d_add(d_mul(d_mul(Xxi,Xxi),d_mul(dya,d_abs(d_mul(Xxi,Xxr)))),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dya,d_abs(Xxi)))))))),d_add(d_imul(-2,d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxa,d_abs(Xxr)))))),d_add(d_imul(2,d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dya,d_abs(Xxr))))),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dxa,d_abs(Xxi)))))))),d_add(d_imul(-4,d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(Xxr,d_add(d_mul(dxa,d_abs(Xxi)),d_mul(dya,d_abs(Xxr)))))),d_add(d_imul(4,d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(Xxi,d_mul(dya,d_abs(Xxi))))),d_add(d_imul(-4,d_add(d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(Xxi,d_mul(dxa,d_abs(Xxr)))),d_add(d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxr)))))),d_add(d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_abs(d_mul(Xxi,Xxr)))))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxi))))))))),d_add(d_imul(4,d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dya,d_abs(Xxi)))))),d_add(d_imul(-4,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxa,d_abs(Xxr))))))),daa)))))))))))))))))))));
dxbn=d_add(d_mul(d_sgn(Xxr),d_add(d_mul(d_mul(Xxi,Xxi),d_mul(dxb,d_abs(d_mul(Xxi,Xxi)))),d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(d_mul(Xxr,Xxr)))))),d_add(d_imul(-1,d_mul(d_sgn(Xxr),d_add(d_mul(d_mul(Xxi,Xxi),d_mul(dxb,d_abs(d_mul(Xxr,Xxr)))),d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(d_mul(Xxi,Xxi))))))),d_add(d_imul(-2,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxr,d_mul(dyb,d_abs(Xxi))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxr,d_mul(dyb,d_abs(Xxi)))),d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxr,d_mul(dxb,d_abs(Xxr)))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxr,d_mul(dxb,d_abs(Xxr)))),d_mul(d_sgn(Xxi),d_add(d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(d_mul(Xxi,Xxr)))),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxi))))))))),d_add(d_imul(2,d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr)))))),d_add(d_imul(-2,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,d_mul(dyb,d_abs(Xxr))))),d_add(d_imul(2,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxi,d_mul(dyb,d_abs(Xxr))))),d_add(d_imul(-2,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,d_mul(dxb,d_abs(Xxi))))),d_add(d_imul(2,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxi,d_mul(dxb,d_abs(Xxi))))),d_add(d_imul(-2,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_abs(d_mul(Xxr,Xxr))))))),d_add(d_imul(2,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_abs(d_mul(Xxi,Xxi))))))),d_add(d_imul(-2,d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxr))))),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxi)))))))),d_add(d_imul(2,d_mul(d_sgn(Xxi),d_add(d_mul(d_mul(Xxi,Xxi),d_mul(dyb,d_abs(d_mul(Xxi,Xxr)))),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dyb,d_abs(Xxi)))))))),d_add(d_imul(-2,d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxb,d_abs(Xxr)))))),d_add(d_imul(2,d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dyb,d_abs(Xxr))))),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dxb,d_abs(Xxi)))))))),d_add(d_imul(-4,d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(Xxr,d_add(d_mul(dxb,d_abs(Xxi)),d_mul(dyb,d_abs(Xxr)))))),d_add(d_imul(4,d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(Xxi,d_mul(dyb,d_abs(Xxi))))),d_add(d_imul(-4,d_add(d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(Xxi,d_mul(dxb,d_abs(Xxr)))),d_add(d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxr)))))),d_add(d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_abs(d_mul(Xxi,Xxr)))))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxi))))))))),d_add(d_imul(4,d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dyb,d_abs(Xxi)))))),d_add(d_imul(-4,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxb,d_abs(Xxr))))))),dab)))))))))))))))))))));
dyan=d_add(d_mul(d_sgn(Xxi),d_add(d_mul(d_mul(Xxi,Xxi),d_mul(dya,d_abs(d_mul(Xxi,Xxi)))),d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(d_mul(Xxr,Xxr)))))),d_add(d_imul(-1,d_mul(d_sgn(Xxi),d_add(d_mul(d_mul(Xxi,Xxi),d_mul(dya,d_abs(d_mul(Xxr,Xxr)))),d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(d_mul(Xxi,Xxi))))))),d_add(d_imul(2,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxr,d_mul(dya,d_abs(Xxr))))),d_add(d_imul(-2,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxr,d_mul(dya,d_abs(Xxr))))),d_add(d_imul(2,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxr,d_mul(dxa,d_abs(Xxi))))),d_add(d_imul(-2,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxr,d_mul(dxa,d_abs(Xxi))))),d_add(d_imul(2,d_add(d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxr)))))),d_add(d_mul(d_sgn(Xxr),d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(d_mul(Xxi,Xxr))))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxi)))))))),d_add(d_imul(-2,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,d_mul(dya,d_abs(Xxi))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxi,d_mul(dya,d_abs(Xxi)))),d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,d_mul(dxa,d_abs(Xxr)))))),d_add(d_imul(-2,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxi,d_mul(dxa,d_abs(Xxr))))),d_add(d_imul(2,d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_abs(d_mul(Xxr,Xxr))))))),d_add(d_imul(-2,d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxi))))),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_abs(d_mul(Xxi,Xxi)))))))),d_add(d_imul(2,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr))))))),d_add(d_imul(-2,d_add(d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dya,d_abs(Xxr)))))),d_add(d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(dxa,d_abs(d_mul(Xxi,Xxr))))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxa,d_abs(Xxi)))))))),d_add(d_imul(2,d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dya,d_abs(Xxi)))))),d_add(d_imul(-2,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dxa,d_abs(Xxr))))))),d_add(d_imul(-4,d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(Xxr,d_mul(dya,d_abs(Xxi))))),d_add(d_imul(4,d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(Xxr,d_mul(dxa,d_abs(Xxr))))),d_add(d_imul(-4,d_add(d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(Xxi,d_add(d_mul(dxa,d_abs(Xxi)),d_mul(dya,d_abs(Xxr))))),d_mul(d_sgn(Xxi),d_add(d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_abs(d_mul(Xxi,Xxr))))),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxi))))))))),d_add(d_imul(4,d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr)))))),d_add(d_imul(-4,d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dya,d_abs(Xxr))))),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxa,d_abs(Xxi)))))))),dba)))))))))))))))))))));
dybn=d_add(d_mul(d_sgn(Xxi),d_add(d_mul(d_mul(Xxi,Xxi),d_mul(dyb,d_abs(d_mul(Xxi,Xxi)))),d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(d_mul(Xxr,Xxr)))))),d_add(d_imul(-1,d_mul(d_sgn(Xxi),d_add(d_mul(d_mul(Xxi,Xxi),d_mul(dyb,d_abs(d_mul(Xxr,Xxr)))),d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(d_mul(Xxi,Xxi))))))),d_add(d_imul(2,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxr,d_mul(dyb,d_abs(Xxr))))),d_add(d_imul(-2,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxr,d_mul(dyb,d_abs(Xxr))))),d_add(d_imul(2,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxr,d_mul(dxb,d_abs(Xxi))))),d_add(d_imul(-2,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxr,d_mul(dxb,d_abs(Xxi))))),d_add(d_imul(2,d_add(d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxr)))))),d_add(d_mul(d_sgn(Xxr),d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(d_mul(Xxi,Xxr))))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxi)))))))),d_add(d_imul(-2,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,d_mul(dyb,d_abs(Xxi))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxi,d_mul(dyb,d_abs(Xxi)))),d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,d_mul(dxb,d_abs(Xxr)))))),d_add(d_imul(-2,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxi,d_mul(dxb,d_abs(Xxr))))),d_add(d_imul(2,d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_abs(d_mul(Xxr,Xxr))))))),d_add(d_imul(-2,d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxi))))),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_abs(d_mul(Xxi,Xxi)))))))),d_add(d_imul(2,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr))))))),d_add(d_imul(-2,d_add(d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dyb,d_abs(Xxr)))))),d_add(d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(dxb,d_abs(d_mul(Xxi,Xxr))))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxb,d_abs(Xxi)))))))),d_add(d_imul(2,d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dyb,d_abs(Xxi)))))),d_add(d_imul(-2,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dxb,d_abs(Xxr))))))),d_add(d_imul(-4,d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(Xxr,d_mul(dyb,d_abs(Xxi))))),d_add(d_imul(4,d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(Xxr,d_mul(dxb,d_abs(Xxr))))),d_add(d_imul(-4,d_add(d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(Xxi,d_add(d_mul(dxb,d_abs(Xxi)),d_mul(dyb,d_abs(Xxr))))),d_mul(d_sgn(Xxi),d_add(d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_abs(d_mul(Xxi,Xxr))))),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxi))))))))),d_add(d_imul(4,d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr)))))),d_add(d_imul(-4,d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dyb,d_abs(Xxr))))),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxb,d_abs(Xxi)))))))),dbb)))))))))))))))))))));
}

{xrn=d_add(cr,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_add(d_mul(d_mul(Xi,Xi),d_diffabs(Xr,xr)),d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr))),d_add(d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(d_mul(Xi,Xi),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))),d_add(d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))),d_add(d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))),d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))))))),d_add(d_imul(-1,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_add(d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr)),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_add(d_mul(d_mul(Xi,Xi),d_diffabs(Xr,xr)),d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(d_mul(Xi,Xi),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))),d_add(d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))),d_add(d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))),d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))),d_add(d_imul(2,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi)))))),d_add(d_imul(-2,d_mul(d_abs(d_add(Xi,xi)),d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))),d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xr,d_mul(xi,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))))),d_add(d_imul(2,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xr,d_mul(xi,d_abs(d_add(Xi,xi)))))),d_add(d_imul(-2,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(xi,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(2,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(xi,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xi,d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))),d_add(d_imul(2,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xi,d_mul(xr,d_abs(d_add(Xi,xi)))))),d_add(d_imul(-2,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(2,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xi,d_mul(xi,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(xi,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xi,d_mul(xi,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(xi,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))),d_add(d_imul(-2,d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xi,d_mul(Xr,d_diffabs(Xi,xi))))),d_add(d_imul(2,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xi,d_mul(Xr,d_diffabs(Xi,xi))))),d_add(d_imul(-2,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(Xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(d_mul(Xi,Xi),d_diffabs(Xi,xi))),d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(d_mul(Xi,Xi),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))),d_mul(Xi,d_mul(Xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))))),d_add(d_imul(-4,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_add(d_mul(Xi,d_mul(xr,d_abs(d_add(Xr,xr)))),d_add(d_mul(Xr,d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr))))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_mul(xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))),d_add(d_mul(Xr,d_mul(xi,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))),d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))))))),d_add(d_imul(4,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(Xi,d_mul(xi,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(xi,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))),d_add(d_imul(-4,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(Xi,d_mul(Xr,d_diffabs(Xr,xr)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(Xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))),d_mul(d_abs(d_mul(Xr,Xr)),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))))))))))))))))))))))))))));
xin=d_add(ci,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_add(d_mul(d_mul(Xi,Xi),d_diffabs(Xi,xi)),d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(d_mul(Xi,Xi),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))),d_add(d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))),d_add(d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))),d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))))))),d_add(d_imul(-1,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_add(d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi)),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_add(d_mul(d_mul(Xi,Xi),d_diffabs(Xi,xi)),d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(d_mul(Xi,Xi),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))),d_add(d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))),d_add(d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))),d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))),d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))),d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))))),d_add(d_imul(2,d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xr,d_mul(xr,d_abs(d_add(Xi,xi)))))),d_add(d_imul(-2,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xr,d_mul(xr,d_abs(d_add(Xi,xi)))))),d_add(d_imul(2,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(-2,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xr,d_mul(xi,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(xi,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xr,d_mul(xi,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(xi,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xi,d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_mul(xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))),d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xi,d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xi,d_mul(xi,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))))),d_add(d_imul(2,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xi,d_mul(xi,d_abs(d_add(Xi,xi)))))),d_add(d_imul(-2,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(xi,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xi,d_mul(Xr,d_diffabs(Xr,xr)))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(xi,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(Xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xi,d_mul(Xr,d_diffabs(Xr,xr)))),d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(d_mul(Xi,Xi),d_diffabs(Xr,xr))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(d_mul(Xi,Xi),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))),d_mul(Xi,d_mul(Xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))))),d_add(d_imul(-4,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))),d_add(d_imul(4,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))),d_add(d_imul(-4,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_add(d_mul(Xi,d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi)))))),d_mul(Xr,d_mul(xi,d_abs(d_add(Xi,xi)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(Xi,d_mul(d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))),d_add(Xr,xr))),d_mul(Xr,d_mul(xi,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(xi,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))))),d_mul(d_abs(d_mul(Xr,Xr)),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))))))))))))))))))))))));
}

);

static const char *perturbation_opencl_floatexp_61_5_0 = STR(

{xrn=fe_add(cr,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xr,xr)),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr))),fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))),fe_add(fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))),fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))))))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr)),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xr,xr)),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))),fe_add(fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))),fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))),fe_add(fe_imul(2,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))),fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))))),fe_add(fe_imul(2,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(xi,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(2,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(xi,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))),fe_add(fe_imul(2,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xi,fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(2,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xi,fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(xi,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xi,fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(xi,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(Xi,xi))))),fe_add(fe_imul(2,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(Xi,xi))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xi,xi))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))),fe_mul(Xi,fe_mul(Xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_add(fe_mul(Xr,fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))),fe_add(fe_mul(Xr,fe_mul(xi,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))),fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))))))),fe_add(fe_imul(4,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(Xi,fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(xi,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(Xr,xr)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))),fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))))))))))))))))))))))))))));
xin=fe_add(ci,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xi,xi)),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))),fe_add(fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))),fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))))))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi)),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xi,xi)),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))),fe_add(fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))),fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))),fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))),fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))))),fe_add(fe_imul(2,fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(2,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(xi,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(xi,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_mul(xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))),fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xi,fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))))),fe_add(fe_imul(2,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xi,fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(xi,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(Xr,xr)))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(xi,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(Xr,xr)))),fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xr,xr))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))),fe_mul(Xi,fe_mul(Xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))),fe_add(fe_imul(4,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_add(fe_mul(Xi,fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(Xi,fe_mul(fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))),fe_add(Xr,xr))),fe_mul(Xr,fe_mul(xi,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(xi,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))))),fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))))))))))))))))))))))));
}

);

static const char *perturbation_opencl_floatexp_61_5_1 = STR(

{dxan=fe_add(fe_mul(fe_sgn(Xxr),fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxa,fe_abs(fe_mul(Xxi,Xxi)))),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(fe_mul(Xxr,Xxr)))))),fe_add(fe_imul(-1,fe_mul(fe_sgn(Xxr),fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxa,fe_abs(fe_mul(Xxr,Xxr)))),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(fe_mul(Xxi,Xxi))))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxi))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxi)))),fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxr)))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxr)))),fe_mul(fe_sgn(Xxi),fe_add(fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(fe_mul(Xxi,Xxr)))),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxi))))))))),fe_add(fe_imul(2,fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr)))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,fe_mul(dya,fe_abs(Xxr))))),fe_add(fe_imul(2,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxi,fe_mul(dya,fe_abs(Xxr))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,fe_mul(dxa,fe_abs(Xxi))))),fe_add(fe_imul(2,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxi,fe_mul(dxa,fe_abs(Xxi))))),fe_add(fe_imul(-2,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_abs(fe_mul(Xxr,Xxr))))))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_abs(fe_mul(Xxi,Xxi))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxr))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxi)))))))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxi),fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(dya,fe_abs(fe_mul(Xxi,Xxr)))),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxi)))))))),fe_add(fe_imul(-2,fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxr)))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dya,fe_abs(Xxr))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxa,fe_abs(Xxi)))))))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(Xxr,fe_add(fe_mul(dxa,fe_abs(Xxi)),fe_mul(dya,fe_abs(Xxr)))))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(Xxi,fe_mul(dya,fe_abs(Xxi))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(Xxi,fe_mul(dxa,fe_abs(Xxr)))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxr)))))),fe_add(fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_abs(fe_mul(Xxi,Xxr)))))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxi))))))))),fe_add(fe_imul(4,fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxi)))))),fe_add(fe_imul(-4,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxr))))))),daa)))))))))))))))))))));
dxbn=fe_add(fe_mul(fe_sgn(Xxr),fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxb,fe_abs(fe_mul(Xxi,Xxi)))),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(fe_mul(Xxr,Xxr)))))),fe_add(fe_imul(-1,fe_mul(fe_sgn(Xxr),fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxb,fe_abs(fe_mul(Xxr,Xxr)))),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(fe_mul(Xxi,Xxi))))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxi))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxi)))),fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxr)))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxr)))),fe_mul(fe_sgn(Xxi),fe_add(fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(fe_mul(Xxi,Xxr)))),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxi))))))))),fe_add(fe_imul(2,fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr)))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,fe_mul(dyb,fe_abs(Xxr))))),fe_add(fe_imul(2,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxi,fe_mul(dyb,fe_abs(Xxr))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,fe_mul(dxb,fe_abs(Xxi))))),fe_add(fe_imul(2,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxi,fe_mul(dxb,fe_abs(Xxi))))),fe_add(fe_imul(-2,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_abs(fe_mul(Xxr,Xxr))))))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_abs(fe_mul(Xxi,Xxi))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxr))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxi)))))))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxi),fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(dyb,fe_abs(fe_mul(Xxi,Xxr)))),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxi)))))))),fe_add(fe_imul(-2,fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxr)))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dyb,fe_abs(Xxr))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxb,fe_abs(Xxi)))))))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(Xxr,fe_add(fe_mul(dxb,fe_abs(Xxi)),fe_mul(dyb,fe_abs(Xxr)))))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(Xxi,fe_mul(dyb,fe_abs(Xxi))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(Xxi,fe_mul(dxb,fe_abs(Xxr)))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxr)))))),fe_add(fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_abs(fe_mul(Xxi,Xxr)))))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxi))))))))),fe_add(fe_imul(4,fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxi)))))),fe_add(fe_imul(-4,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxr))))))),dab)))))))))))))))))))));
dyan=fe_add(fe_mul(fe_sgn(Xxi),fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(dya,fe_abs(fe_mul(Xxi,Xxi)))),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(fe_mul(Xxr,Xxr)))))),fe_add(fe_imul(-1,fe_mul(fe_sgn(Xxi),fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(dya,fe_abs(fe_mul(Xxr,Xxr)))),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(fe_mul(Xxi,Xxi))))))),fe_add(fe_imul(2,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxr))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxr))))),fe_add(fe_imul(2,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxi))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxi))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxr)))))),fe_add(fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(fe_mul(Xxi,Xxr))))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxi)))))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,fe_mul(dya,fe_abs(Xxi))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxi,fe_mul(dya,fe_abs(Xxi)))),fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,fe_mul(dxa,fe_abs(Xxr)))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxi,fe_mul(dxa,fe_abs(Xxr))))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_abs(fe_mul(Xxr,Xxr))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxi))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_abs(fe_mul(Xxi,Xxi)))))))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxr)))))),fe_add(fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxa,fe_abs(fe_mul(Xxi,Xxr))))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxi)))))))),fe_add(fe_imul(2,fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dya,fe_abs(Xxi)))))),fe_add(fe_imul(-2,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxa,fe_abs(Xxr))))))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxi))))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxr))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(Xxi,fe_add(fe_mul(dxa,fe_abs(Xxi)),fe_mul(dya,fe_abs(Xxr))))),fe_mul(fe_sgn(Xxi),fe_add(fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_abs(fe_mul(Xxi,Xxr))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxi))))))))),fe_add(fe_imul(4,fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr)))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxr))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxi)))))))),dba)))))))))))))))))))));
dybn=fe_add(fe_mul(fe_sgn(Xxi),fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(dyb,fe_abs(fe_mul(Xxi,Xxi)))),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(fe_mul(Xxr,Xxr)))))),fe_add(fe_imul(-1,fe_mul(fe_sgn(Xxi),fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(dyb,fe_abs(fe_mul(Xxr,Xxr)))),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(fe_mul(Xxi,Xxi))))))),fe_add(fe_imul(2,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxr))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxr))))),fe_add(fe_imul(2,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxi))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxi))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxr)))))),fe_add(fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(fe_mul(Xxi,Xxr))))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxi)))))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,fe_mul(dyb,fe_abs(Xxi))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxi,fe_mul(dyb,fe_abs(Xxi)))),fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,fe_mul(dxb,fe_abs(Xxr)))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxi,fe_mul(dxb,fe_abs(Xxr))))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_abs(fe_mul(Xxr,Xxr))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxi))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_abs(fe_mul(Xxi,Xxi)))))))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxr)))))),fe_add(fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxb,fe_abs(fe_mul(Xxi,Xxr))))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxi)))))))),fe_add(fe_imul(2,fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dyb,fe_abs(Xxi)))))),fe_add(fe_imul(-2,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxb,fe_abs(Xxr))))))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxi))))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxr))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(Xxi,fe_add(fe_mul(dxb,fe_abs(Xxi)),fe_mul(dyb,fe_abs(Xxr))))),fe_mul(fe_sgn(Xxi),fe_add(fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_abs(fe_mul(Xxi,Xxr))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxi))))))))),fe_add(fe_imul(4,fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr)))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxr))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxi)))))))),dbb)))))))))))))))))))));
}

{xrn=fe_add(cr,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xr,xr)),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr))),fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))),fe_add(fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))),fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))))))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr)),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xr,xr)),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))),fe_add(fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))),fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))),fe_add(fe_imul(2,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))),fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))))),fe_add(fe_imul(2,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(xi,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(2,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(xi,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))),fe_add(fe_imul(2,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xi,fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(2,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xi,fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(xi,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xi,fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(xi,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(Xi,xi))))),fe_add(fe_imul(2,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(Xi,xi))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xi,xi))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))),fe_mul(Xi,fe_mul(Xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_add(fe_mul(Xr,fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))),fe_add(fe_mul(Xr,fe_mul(xi,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))),fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))))))),fe_add(fe_imul(4,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(Xi,fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(xi,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(Xr,xr)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))),fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))))))))))))))))))))))))))));
xin=fe_add(ci,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xi,xi)),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))),fe_add(fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))),fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))))))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi)),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xi,xi)),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))),fe_add(fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))),fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))),fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))),fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))))),fe_add(fe_imul(2,fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(2,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(xi,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(xi,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_mul(xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))),fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xi,fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))))),fe_add(fe_imul(2,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xi,fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(xi,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(Xr,xr)))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(xi,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(Xr,xr)))),fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xr,xr))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))),fe_mul(Xi,fe_mul(Xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))),fe_add(fe_imul(4,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_add(fe_mul(Xi,fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(Xi,fe_mul(fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))),fe_add(Xr,xr))),fe_mul(Xr,fe_mul(xi,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(xi,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))))),fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))))))))))))))))))))))));
}

);

#if 0
static const char *perturbation_opencl_softfloat_61_5_0 = STR(

{xrn=sf_add(cr,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xr,xr)),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr))),sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))),sf_add(sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))),sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))))))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr)),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xr,xr)),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))),sf_add(sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))),sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))),sf_add(sf_imul(2,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))),sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))))),sf_add(sf_imul(2,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(xi,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(2,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(xi,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))),sf_add(sf_imul(2,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xi,sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(2,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xi,sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(xi,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xi,sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(xi,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(Xi,xi))))),sf_add(sf_imul(2,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(Xi,xi))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xi,xi))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))),sf_mul(Xi,sf_mul(Xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_add(sf_mul(Xr,sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))),sf_add(sf_mul(Xr,sf_mul(xi,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))),sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))))))),sf_add(sf_imul(4,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(Xi,sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(xi,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(Xr,xr)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))),sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))))))))))))))))))))))))))));
xin=sf_add(ci,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xi,xi)),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))),sf_add(sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))),sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))))))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi)),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xi,xi)),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))),sf_add(sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))),sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))),sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))),sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))))),sf_add(sf_imul(2,sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(2,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(xi,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(xi,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_mul(xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))),sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xi,sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))))),sf_add(sf_imul(2,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xi,sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(xi,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(Xr,xr)))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(xi,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(Xr,xr)))),sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xr,xr))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))),sf_mul(Xi,sf_mul(Xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))),sf_add(sf_imul(4,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_add(sf_mul(Xi,sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(Xi,sf_mul(sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))),sf_add(Xr,xr))),sf_mul(Xr,sf_mul(xi,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(xi,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))))),sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))))))))))))))))))))))));
}

);
#endif


static const char *perturbation_opencl_double_62_5_0 = STR(

{xrn=d_add(cr,d_add(d_mul(d_abs(Xr),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr))),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr)))),d_add(d_imul(-1,d_add(d_mul(d_abs(Xi),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi))),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi))),d_mul(xr,d_mul(d_mul(xr,xr),d_diffabs(Xi,xi))))))),d_add(d_imul(2,d_add(d_mul(d_abs(Xi),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(Xr,xr))),d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(Xi,xi))),d_mul(xi,d_mul(d_mul(xi,xi),d_diffabs(Xi,xi))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(Xr),d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(xi,xi),d_mul(xr,d_diffabs(Xr,xr)))))),d_add(d_imul(3,d_add(d_mul(d_abs(Xi),d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(Xr),d_mul(Xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(xi,xi),d_mul(xr,d_diffabs(Xi,xi)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(d_mul(xr,xr),d_diffabs(Xr,xr)))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(Xi),d_mul(Xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(Xr),d_mul(Xr,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(d_mul(xr,xr),d_diffabs(Xi,xi)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(d_mul(xi,xi),d_diffabs(Xr,xr)))))))),d_add(d_imul(3,d_add(d_mul(d_abs(Xi),d_mul(Xr,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(Xr),d_mul(d_mul(Xr,Xr),d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(d_mul(xi,xi),d_diffabs(Xi,xi)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xr,Xr),d_mul(xr,d_diffabs(Xr,xr)))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(Xi),d_mul(d_mul(Xr,Xr),d_mul(xr,d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(Xr),d_mul(d_mul(Xi,Xi),d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xr,Xr),d_mul(xr,d_diffabs(Xi,xi)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(xr,d_diffabs(Xr,xr)))))))),d_add(d_imul(3,d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xi,Xi),d_mul(xr,d_diffabs(Xi,xi))))),d_add(d_imul(-3,d_mul(d_mul(d_mul(Xi,Xi),d_mul(Xr,d_diffabs(Xr,xr))),d_add(d_abs(Xr),d_abs(d_add(Xr,xr))))),d_add(d_imul(3,d_add(d_mul(d_abs(Xi),d_mul(d_mul(Xi,Xi),d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_mul(xr,d_abs(d_add(Xi,xi)))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_diffabs(Xi,xi)))))),d_add(d_imul(-6,d_add(d_mul(d_abs(Xi),d_add(d_mul(Xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xr,xr)))),d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))))),d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_add(d_mul(xi,d_mul(xr,d_diffabs(Xr,xr))),d_mul(d_mul(xr,xr),d_diffabs(Xi,xi)))),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,d_diffabs(Xi,xi))),d_mul(xi,d_mul(d_mul(xr,xr),d_diffabs(Xi,xi))))))))),d_add(d_imul(6,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_add(d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))),d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(xi,d_mul(xr,d_diffabs(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(d_mul(xi,xi),d_diffabs(Xi,xi))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(Xr,d_mul(xi,d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(Xr,d_mul(xi,d_diffabs(Xr,xr))))))),d_add(d_imul(6,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(Xr,d_mul(xi,d_abs(d_add(Xi,xi)))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(Xr,d_mul(xi,d_diffabs(Xi,xi))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi)))))),d_add(d_imul(6,d_add(d_mul(d_abs(Xi),d_mul(d_mul(Xi,Xi),d_mul(xi,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(xi,d_diffabs(Xi,xi)))))),d_add(d_imul(-12,d_add(d_mul(d_abs(Xi),d_add(d_mul(Xi,d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(Xr,d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr))))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_mul(Xr,d_mul(xr,d_diffabs(Xi,xi)))),d_mul(Xr,d_mul(xi,d_mul(xr,d_diffabs(Xi,xi)))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xr,d_mul(d_mul(xr,xr),d_diffabs(Xr,xr))))))))))))))))))))))));
xin=d_add(ci,d_add(d_mul(d_abs(Xi),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(Xi,xi))),d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(Xi,xi))),d_mul(xi,d_mul(d_mul(xi,xi),d_diffabs(Xi,xi))))),d_add(d_imul(-1,d_add(d_mul(d_abs(Xr),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(Xr,xr))),d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(Xr,xr))),d_mul(xi,d_mul(d_mul(xi,xi),d_diffabs(Xr,xr))))))),d_add(d_imul(2,d_add(d_mul(d_abs(Xi),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr))),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi)))))),d_add(d_imul(3,d_add(d_mul(d_abs(Xr),d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xi,d_mul(d_mul(xr,xr),d_diffabs(Xr,xr)))))),d_add(d_imul(-3,d_add(d_mul(d_abs(Xi),d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(xi,d_mul(d_mul(xr,xr),d_diffabs(Xi,xi)))))),d_add(d_imul(3,d_add(d_mul(d_abs(Xr),d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xr,Xr),d_mul(xi,d_diffabs(Xr,xr)))))),d_add(d_imul(-3,d_add(d_mul(d_abs(Xi),d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xr,Xr),d_mul(xi,d_diffabs(Xi,xi)))))),d_add(d_imul(3,d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(d_mul(xr,xr),d_diffabs(Xr,xr)))))),d_add(d_imul(-3,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(d_mul(xr,xr),d_diffabs(Xi,xi)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(d_mul(xi,xi),d_diffabs(Xr,xr)))))))),d_add(d_imul(3,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr)))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(d_mul(xi,xi),d_diffabs(Xi,xi)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr)))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi)))),d_add(d_mul(d_abs(Xr),d_mul(d_mul(Xi,Xi),d_mul(xi,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(xi,d_diffabs(Xr,xr)))))))),d_add(d_imul(3,d_add(d_mul(d_abs(Xi),d_mul(d_mul(Xi,Xi),d_mul(xi,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xi,Xi),d_mul(xi,d_diffabs(Xi,xi)))))),d_add(d_imul(-6,d_add(d_mul(d_abs(Xi),d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(xi,xi),d_mul(xr,d_diffabs(Xi,xi)))))),d_add(d_imul(6,d_add(d_mul(d_abs(Xi),d_mul(Xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(Xr),d_mul(Xr,d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_add(d_mul(xi,d_mul(xr,d_diffabs(Xr,xr))),d_mul(d_mul(xr,xr),d_diffabs(Xi,xi)))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(Xi),d_mul(Xr,d_add(d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))),d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(xi,d_mul(xr,d_diffabs(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(d_mul(xi,xi),d_diffabs(Xi,xi))))))),d_add(d_imul(6,d_add(d_mul(d_abs(Xi),d_mul(d_mul(Xr,Xr),d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_mul(Xr,d_mul(xr,d_diffabs(Xr,xr)))),d_mul(d_mul(Xr,Xr),d_mul(xr,d_diffabs(Xi,xi)))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(Xi),d_add(d_mul(d_mul(Xi,Xi),d_add(d_mul(Xr,d_diffabs(Xr,xr)),d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(Xi,d_mul(Xr,d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(Xr,d_mul(xr,d_diffabs(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(d_diffabs(Xi,xi),d_add(Xr,xr))))))),d_add(d_imul(-12,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_add(d_mul(Xr,d_mul(xi,d_abs(d_add(Xr,xr)))),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_add(d_mul(Xr,d_mul(xi,d_diffabs(Xi,xi))),d_mul(xi,d_mul(xr,d_diffabs(Xi,xi)))))))),d_imul(2,d_mul(d_abs(d_add(Xr,xr)),d_mul(xr,d_mul(d_mul(xr,xr),d_diffabs(Xi,xi)))))))))))))))))))))))));
}

);

static const char *perturbation_opencl_double_62_5_1 = STR(

{dxan=d_add(d_imul(-2,d_mul(d_sgn(Xxi),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxi)))))),d_add(d_imul(2,d_add(d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dya,d_abs(Xxr))))),d_mul(d_sgn(Xxr),d_add(d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dxa,d_abs(Xxi)))),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr)))))))),d_add(d_imul(3,d_mul(d_abs(Xxr),d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr))))),d_add(d_imul(-3,d_add(d_mul(d_abs(Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxi)))),d_mul(d_abs(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(dxa,d_abs(Xxr)))))),d_add(d_imul(3,d_mul(d_abs(Xxi),d_mul(d_mul(Xxi,Xxi),d_mul(dxa,d_abs(Xxi))))),d_add(d_imul(-6,d_add(d_mul(d_abs(Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxr)))),d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_abs(Xxr))))))),d_add(d_imul(6,d_mul(d_abs(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_abs(Xxi)))))),d_add(d_imul(-6,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxr)))))),d_add(d_imul(6,d_add(d_mul(d_abs(Xxi),d_mul(d_mul(Xxi,Xxi),d_mul(dya,d_abs(Xxr)))),d_mul(d_sgn(Xxi),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dya,d_abs(Xxi))))))),d_add(d_imul(-6,d_mul(d_sgn(Xxr),d_add(d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxa,d_abs(Xxr)))),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxi))))))),d_add(d_imul(-12,d_mul(d_abs(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_abs(Xxr)))))),daa)))))))))));
dxbn=d_add(d_imul(-2,d_mul(d_sgn(Xxi),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxi)))))),d_add(d_imul(2,d_add(d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dyb,d_abs(Xxr))))),d_mul(d_sgn(Xxr),d_add(d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dxb,d_abs(Xxi)))),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr)))))))),d_add(d_imul(3,d_mul(d_abs(Xxr),d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr))))),d_add(d_imul(-3,d_add(d_mul(d_abs(Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxi)))),d_mul(d_abs(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(dxb,d_abs(Xxr)))))),d_add(d_imul(3,d_mul(d_abs(Xxi),d_mul(d_mul(Xxi,Xxi),d_mul(dxb,d_abs(Xxi))))),d_add(d_imul(-6,d_add(d_mul(d_abs(Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxr)))),d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_abs(Xxr))))))),d_add(d_imul(6,d_mul(d_abs(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_abs(Xxi)))))),d_add(d_imul(-6,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxr)))))),d_add(d_imul(6,d_add(d_mul(d_abs(Xxi),d_mul(d_mul(Xxi,Xxi),d_mul(dyb,d_abs(Xxr)))),d_mul(d_sgn(Xxi),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dyb,d_abs(Xxi))))))),d_add(d_imul(-6,d_mul(d_sgn(Xxr),d_add(d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxb,d_abs(Xxr)))),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxi))))))),d_add(d_imul(-12,d_mul(d_abs(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_abs(Xxr)))))),dab)))))))))));
dyan=d_add(d_imul(2,d_add(d_mul(d_sgn(Xxi),d_add(d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dya,d_abs(Xxi)))),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxr)))))),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxi))))))),d_add(d_imul(-2,d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dxa,d_abs(Xxr)))))),d_add(d_imul(3,d_mul(d_abs(Xxr),d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxr))))),d_add(d_imul(-3,d_add(d_mul(d_abs(Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxi)))),d_mul(d_abs(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(dya,d_abs(Xxr)))))),d_add(d_imul(3,d_mul(d_abs(Xxi),d_mul(d_mul(Xxi,Xxi),d_mul(dya,d_abs(Xxi))))),d_add(d_imul(6,d_add(d_mul(d_abs(Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr)))),d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_abs(Xxr))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_abs(Xxi))))),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxi))))))),d_add(d_imul(6,d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr)))))),d_add(d_imul(-6,d_add(d_mul(d_abs(Xxi),d_mul(d_mul(Xxi,Xxi),d_mul(dxa,d_abs(Xxr)))),d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dya,d_abs(Xxr))))),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxa,d_abs(Xxi)))))))),d_add(d_imul(-12,d_mul(d_abs(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_abs(Xxr)))))),dba))))))))));
dybn=d_add(d_imul(2,d_add(d_mul(d_sgn(Xxi),d_add(d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dyb,d_abs(Xxi)))),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxr)))))),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxi))))))),d_add(d_imul(-2,d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dxb,d_abs(Xxr)))))),d_add(d_imul(3,d_mul(d_abs(Xxr),d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxr))))),d_add(d_imul(-3,d_add(d_mul(d_abs(Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxi)))),d_mul(d_abs(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(dyb,d_abs(Xxr)))))),d_add(d_imul(3,d_mul(d_abs(Xxi),d_mul(d_mul(Xxi,Xxi),d_mul(dyb,d_abs(Xxi))))),d_add(d_imul(6,d_add(d_mul(d_abs(Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr)))),d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_abs(Xxr))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_abs(Xxi))))),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxi))))))),d_add(d_imul(6,d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr)))))),d_add(d_imul(-6,d_add(d_mul(d_abs(Xxi),d_mul(d_mul(Xxi,Xxi),d_mul(dxb,d_abs(Xxr)))),d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dyb,d_abs(Xxr))))),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxb,d_abs(Xxi)))))))),d_add(d_imul(-12,d_mul(d_abs(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_abs(Xxr)))))),dbb))))))))));
}

{xrn=d_add(cr,d_add(d_mul(d_abs(Xr),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr))),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr)))),d_add(d_imul(-1,d_add(d_mul(d_abs(Xi),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi))),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi))),d_mul(xr,d_mul(d_mul(xr,xr),d_diffabs(Xi,xi))))))),d_add(d_imul(2,d_add(d_mul(d_abs(Xi),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(Xr,xr))),d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(Xi,xi))),d_mul(xi,d_mul(d_mul(xi,xi),d_diffabs(Xi,xi))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(Xr),d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(xi,xi),d_mul(xr,d_diffabs(Xr,xr)))))),d_add(d_imul(3,d_add(d_mul(d_abs(Xi),d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(Xr),d_mul(Xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(xi,xi),d_mul(xr,d_diffabs(Xi,xi)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(d_mul(xr,xr),d_diffabs(Xr,xr)))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(Xi),d_mul(Xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(Xr),d_mul(Xr,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(d_mul(xr,xr),d_diffabs(Xi,xi)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(d_mul(xi,xi),d_diffabs(Xr,xr)))))))),d_add(d_imul(3,d_add(d_mul(d_abs(Xi),d_mul(Xr,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(Xr),d_mul(d_mul(Xr,Xr),d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(d_mul(xi,xi),d_diffabs(Xi,xi)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xr,Xr),d_mul(xr,d_diffabs(Xr,xr)))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(Xi),d_mul(d_mul(Xr,Xr),d_mul(xr,d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(Xr),d_mul(d_mul(Xi,Xi),d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xr,Xr),d_mul(xr,d_diffabs(Xi,xi)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(xr,d_diffabs(Xr,xr)))))))),d_add(d_imul(3,d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xi,Xi),d_mul(xr,d_diffabs(Xi,xi))))),d_add(d_imul(-3,d_mul(d_mul(d_mul(Xi,Xi),d_mul(Xr,d_diffabs(Xr,xr))),d_add(d_abs(Xr),d_abs(d_add(Xr,xr))))),d_add(d_imul(3,d_add(d_mul(d_abs(Xi),d_mul(d_mul(Xi,Xi),d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_mul(xr,d_abs(d_add(Xi,xi)))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_diffabs(Xi,xi)))))),d_add(d_imul(-6,d_add(d_mul(d_abs(Xi),d_add(d_mul(Xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xr,xr)))),d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))))),d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_add(d_mul(xi,d_mul(xr,d_diffabs(Xr,xr))),d_mul(d_mul(xr,xr),d_diffabs(Xi,xi)))),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,d_diffabs(Xi,xi))),d_mul(xi,d_mul(d_mul(xr,xr),d_diffabs(Xi,xi))))))))),d_add(d_imul(6,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_add(d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))),d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(xi,d_mul(xr,d_diffabs(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(d_mul(xi,xi),d_diffabs(Xi,xi))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(Xr,d_mul(xi,d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(Xr,d_mul(xi,d_diffabs(Xr,xr))))))),d_add(d_imul(6,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(Xr,d_mul(xi,d_abs(d_add(Xi,xi)))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(Xr,d_mul(xi,d_diffabs(Xi,xi))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi)))))),d_add(d_imul(6,d_add(d_mul(d_abs(Xi),d_mul(d_mul(Xi,Xi),d_mul(xi,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(xi,d_diffabs(Xi,xi)))))),d_add(d_imul(-12,d_add(d_mul(d_abs(Xi),d_add(d_mul(Xi,d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(Xr,d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr))))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_mul(Xr,d_mul(xr,d_diffabs(Xi,xi)))),d_mul(Xr,d_mul(xi,d_mul(xr,d_diffabs(Xi,xi)))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xr,d_mul(d_mul(xr,xr),d_diffabs(Xr,xr))))))))))))))))))))))));
xin=d_add(ci,d_add(d_mul(d_abs(Xi),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(Xi,xi))),d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(Xi,xi))),d_mul(xi,d_mul(d_mul(xi,xi),d_diffabs(Xi,xi))))),d_add(d_imul(-1,d_add(d_mul(d_abs(Xr),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(Xr,xr))),d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(Xr,xr))),d_mul(xi,d_mul(d_mul(xi,xi),d_diffabs(Xr,xr))))))),d_add(d_imul(2,d_add(d_mul(d_abs(Xi),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr))),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi)))))),d_add(d_imul(3,d_add(d_mul(d_abs(Xr),d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xi,d_mul(d_mul(xr,xr),d_diffabs(Xr,xr)))))),d_add(d_imul(-3,d_add(d_mul(d_abs(Xi),d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(xi,d_mul(d_mul(xr,xr),d_diffabs(Xi,xi)))))),d_add(d_imul(3,d_add(d_mul(d_abs(Xr),d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xr,Xr),d_mul(xi,d_diffabs(Xr,xr)))))),d_add(d_imul(-3,d_add(d_mul(d_abs(Xi),d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xr,Xr),d_mul(xi,d_diffabs(Xi,xi)))))),d_add(d_imul(3,d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(d_mul(xr,xr),d_diffabs(Xr,xr)))))),d_add(d_imul(-3,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(d_mul(xr,xr),d_diffabs(Xi,xi)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(d_mul(xi,xi),d_diffabs(Xr,xr)))))))),d_add(d_imul(3,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr)))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(d_mul(xi,xi),d_diffabs(Xi,xi)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr)))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi)))),d_add(d_mul(d_abs(Xr),d_mul(d_mul(Xi,Xi),d_mul(xi,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(xi,d_diffabs(Xr,xr)))))))),d_add(d_imul(3,d_add(d_mul(d_abs(Xi),d_mul(d_mul(Xi,Xi),d_mul(xi,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xi,Xi),d_mul(xi,d_diffabs(Xi,xi)))))),d_add(d_imul(-6,d_add(d_mul(d_abs(Xi),d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(xi,xi),d_mul(xr,d_diffabs(Xi,xi)))))),d_add(d_imul(6,d_add(d_mul(d_abs(Xi),d_mul(Xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(Xr),d_mul(Xr,d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_add(d_mul(xi,d_mul(xr,d_diffabs(Xr,xr))),d_mul(d_mul(xr,xr),d_diffabs(Xi,xi)))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(Xi),d_mul(Xr,d_add(d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))),d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(xi,d_mul(xr,d_diffabs(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(d_mul(xi,xi),d_diffabs(Xi,xi))))))),d_add(d_imul(6,d_add(d_mul(d_abs(Xi),d_mul(d_mul(Xr,Xr),d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_mul(Xr,d_mul(xr,d_diffabs(Xr,xr)))),d_mul(d_mul(Xr,Xr),d_mul(xr,d_diffabs(Xi,xi)))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(Xi),d_add(d_mul(d_mul(Xi,Xi),d_add(d_mul(Xr,d_diffabs(Xr,xr)),d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(Xi,d_mul(Xr,d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(Xr,d_mul(xr,d_diffabs(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(d_diffabs(Xi,xi),d_add(Xr,xr))))))),d_add(d_imul(-12,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_add(d_mul(Xr,d_mul(xi,d_abs(d_add(Xr,xr)))),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_add(d_mul(Xr,d_mul(xi,d_diffabs(Xi,xi))),d_mul(xi,d_mul(xr,d_diffabs(Xi,xi)))))))),d_imul(2,d_mul(d_abs(d_add(Xr,xr)),d_mul(xr,d_mul(d_mul(xr,xr),d_diffabs(Xi,xi)))))))))))))))))))))))));
}

);

static const char *perturbation_opencl_floatexp_62_5_0 = STR(

{xrn=fe_add(cr,fe_add(fe_mul(fe_abs(Xr),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr)))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xr,xr))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xi,xi))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_diffabs(Xi,xi))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(Xr),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_diffabs(Xr,xr)))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_diffabs(Xi,xi)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_diffabs(Xr,xr)))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_diffabs(Xr,xr)))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_diffabs(Xi,xi)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_diffabs(Xr,xr)))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(fe_mul(Xi,Xi),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_diffabs(Xi,xi)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(xr,fe_diffabs(Xr,xr)))))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(xr,fe_diffabs(Xi,xi))))),fe_add(fe_imul(-3,fe_mul(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_diffabs(Xr,xr))),fe_add(fe_abs(Xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_diffabs(Xi,xi)))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(Xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xr,xr)))),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_add(fe_mul(xi,fe_mul(xr,fe_diffabs(Xr,xr))),fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi)))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_diffabs(Xi,xi))),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_add(fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(xi,fe_mul(xr,fe_diffabs(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_diffabs(Xi,xi))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_diffabs(Xr,xr))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_diffabs(Xi,xi))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi)))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_diffabs(Xi,xi)))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_diffabs(Xi,xi)))),fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_diffabs(Xi,xi)))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_diffabs(Xr,xr))))))))))))))))))))))));
xin=fe_add(ci,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xi,xi))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xi,xi))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_diffabs(Xi,xi))))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(Xr),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xr,xr))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xr,xr))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_diffabs(Xr,xr))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi)))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(Xr),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_diffabs(Xr,xr)))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(Xi),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi)))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(Xr),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_diffabs(Xr,xr)))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_diffabs(Xi,xi)))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(fe_mul(xr,xr),fe_diffabs(Xr,xr)))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_diffabs(Xr,xr)))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr)))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_diffabs(Xi,xi)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr)))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi)))),fe_add(fe_mul(fe_abs(Xr),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_diffabs(Xr,xr)))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_diffabs(Xi,xi)))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_diffabs(Xi,xi)))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_add(fe_mul(xi,fe_mul(xr,fe_diffabs(Xr,xr))),fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi)))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xr,fe_add(fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_diffabs(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_diffabs(Xi,xi))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_diffabs(Xr,xr)))),fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_diffabs(Xi,xi)))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(Xr,fe_diffabs(Xr,xr)),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_diffabs(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(fe_diffabs(Xi,xi),fe_add(Xr,xr))))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_add(fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xr,xr)))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_add(fe_mul(Xr,fe_mul(xi,fe_diffabs(Xi,xi))),fe_mul(xi,fe_mul(xr,fe_diffabs(Xi,xi)))))))),fe_imul(2,fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi)))))))))))))))))))))))));
}

);

static const char *perturbation_opencl_floatexp_62_5_1 = STR(

{dxan=fe_add(fe_imul(-2,fe_mul(fe_sgn(Xxi),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxi)))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dya,fe_abs(Xxr))))),fe_mul(fe_sgn(Xxr),fe_add(fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxa,fe_abs(Xxi)))),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr)))))))),fe_add(fe_imul(3,fe_mul(fe_abs(Xxr),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxi)))),fe_mul(fe_abs(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxa,fe_abs(Xxr)))))),fe_add(fe_imul(3,fe_mul(fe_abs(Xxi),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxa,fe_abs(Xxi))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxr)))),fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_abs(Xxr))))))),fe_add(fe_imul(6,fe_mul(fe_abs(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_abs(Xxi)))))),fe_add(fe_imul(-6,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxr)))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(Xxi),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dya,fe_abs(Xxr)))),fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxi))))))),fe_add(fe_imul(-6,fe_mul(fe_sgn(Xxr),fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxr)))),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxi))))))),fe_add(fe_imul(-12,fe_mul(fe_abs(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxr)))))),daa)))))))))));
dxbn=fe_add(fe_imul(-2,fe_mul(fe_sgn(Xxi),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxi)))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dyb,fe_abs(Xxr))))),fe_mul(fe_sgn(Xxr),fe_add(fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxb,fe_abs(Xxi)))),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr)))))))),fe_add(fe_imul(3,fe_mul(fe_abs(Xxr),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxi)))),fe_mul(fe_abs(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxb,fe_abs(Xxr)))))),fe_add(fe_imul(3,fe_mul(fe_abs(Xxi),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxb,fe_abs(Xxi))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxr)))),fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxr))))))),fe_add(fe_imul(6,fe_mul(fe_abs(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxi)))))),fe_add(fe_imul(-6,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxr)))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(Xxi),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dyb,fe_abs(Xxr)))),fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxi))))))),fe_add(fe_imul(-6,fe_mul(fe_sgn(Xxr),fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxr)))),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxi))))))),fe_add(fe_imul(-12,fe_mul(fe_abs(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxr)))))),dab)))))))))));
dyan=fe_add(fe_imul(2,fe_add(fe_mul(fe_sgn(Xxi),fe_add(fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dya,fe_abs(Xxi)))),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxr)))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxi))))))),fe_add(fe_imul(-2,fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxa,fe_abs(Xxr)))))),fe_add(fe_imul(3,fe_mul(fe_abs(Xxr),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxr))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxi)))),fe_mul(fe_abs(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dya,fe_abs(Xxr)))))),fe_add(fe_imul(3,fe_mul(fe_abs(Xxi),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dya,fe_abs(Xxi))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr)))),fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxr))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxi))))),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxi))))))),fe_add(fe_imul(6,fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr)))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(Xxi),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxa,fe_abs(Xxr)))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxr))))),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxi)))))))),fe_add(fe_imul(-12,fe_mul(fe_abs(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_abs(Xxr)))))),dba))))))))));
dybn=fe_add(fe_imul(2,fe_add(fe_mul(fe_sgn(Xxi),fe_add(fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dyb,fe_abs(Xxi)))),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxr)))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxi))))))),fe_add(fe_imul(-2,fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxb,fe_abs(Xxr)))))),fe_add(fe_imul(3,fe_mul(fe_abs(Xxr),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxr))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxi)))),fe_mul(fe_abs(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dyb,fe_abs(Xxr)))))),fe_add(fe_imul(3,fe_mul(fe_abs(Xxi),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dyb,fe_abs(Xxi))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr)))),fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxr))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxi))))),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxi))))))),fe_add(fe_imul(6,fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr)))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(Xxi),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxb,fe_abs(Xxr)))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxr))))),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxi)))))))),fe_add(fe_imul(-12,fe_mul(fe_abs(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxr)))))),dbb))))))))));
}

{xrn=fe_add(cr,fe_add(fe_mul(fe_abs(Xr),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr)))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xr,xr))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xi,xi))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_diffabs(Xi,xi))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(Xr),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_diffabs(Xr,xr)))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_diffabs(Xi,xi)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_diffabs(Xr,xr)))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_diffabs(Xr,xr)))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_diffabs(Xi,xi)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_diffabs(Xr,xr)))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(fe_mul(Xi,Xi),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_diffabs(Xi,xi)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(xr,fe_diffabs(Xr,xr)))))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(xr,fe_diffabs(Xi,xi))))),fe_add(fe_imul(-3,fe_mul(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_diffabs(Xr,xr))),fe_add(fe_abs(Xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_diffabs(Xi,xi)))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(Xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xr,xr)))),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_add(fe_mul(xi,fe_mul(xr,fe_diffabs(Xr,xr))),fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi)))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_diffabs(Xi,xi))),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_add(fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(xi,fe_mul(xr,fe_diffabs(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_diffabs(Xi,xi))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_diffabs(Xr,xr))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_diffabs(Xi,xi))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi)))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_diffabs(Xi,xi)))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_diffabs(Xi,xi)))),fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_diffabs(Xi,xi)))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_diffabs(Xr,xr))))))))))))))))))))))));
xin=fe_add(ci,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xi,xi))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xi,xi))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_diffabs(Xi,xi))))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(Xr),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xr,xr))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xr,xr))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_diffabs(Xr,xr))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi)))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(Xr),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_diffabs(Xr,xr)))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(Xi),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi)))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(Xr),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_diffabs(Xr,xr)))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_diffabs(Xi,xi)))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(fe_mul(xr,xr),fe_diffabs(Xr,xr)))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_diffabs(Xr,xr)))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr)))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_diffabs(Xi,xi)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr)))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi)))),fe_add(fe_mul(fe_abs(Xr),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_diffabs(Xr,xr)))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_diffabs(Xi,xi)))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_diffabs(Xi,xi)))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_add(fe_mul(xi,fe_mul(xr,fe_diffabs(Xr,xr))),fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi)))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xr,fe_add(fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_diffabs(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_diffabs(Xi,xi))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_diffabs(Xr,xr)))),fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_diffabs(Xi,xi)))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(Xr,fe_diffabs(Xr,xr)),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_diffabs(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(fe_diffabs(Xi,xi),fe_add(Xr,xr))))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_add(fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xr,xr)))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_add(fe_mul(Xr,fe_mul(xi,fe_diffabs(Xi,xi))),fe_mul(xi,fe_mul(xr,fe_diffabs(Xi,xi)))))))),fe_imul(2,fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi)))))))))))))))))))))))));
}

);

#if 0
static const char *perturbation_opencl_softfloat_62_5_0 = STR(

{xrn=sf_add(cr,sf_add(sf_mul(sf_abs(Xr),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr)))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xr,xr))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xi,xi))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_diffabs(Xi,xi))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(Xr),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_diffabs(Xr,xr)))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_diffabs(Xi,xi)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_diffabs(Xr,xr)))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_diffabs(Xr,xr)))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_diffabs(Xi,xi)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_diffabs(Xr,xr)))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(sf_mul(Xi,Xi),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_diffabs(Xi,xi)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(xr,sf_diffabs(Xr,xr)))))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(xr,sf_diffabs(Xi,xi))))),sf_add(sf_imul(-3,sf_mul(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_diffabs(Xr,xr))),sf_add(sf_abs(Xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_diffabs(Xi,xi)))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(Xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xr,xr)))),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_add(sf_mul(xi,sf_mul(xr,sf_diffabs(Xr,xr))),sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi)))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_diffabs(Xi,xi))),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_add(sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(xi,sf_mul(xr,sf_diffabs(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_diffabs(Xi,xi))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_diffabs(Xr,xr))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_diffabs(Xi,xi))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi)))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_diffabs(Xi,xi)))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_diffabs(Xi,xi)))),sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_diffabs(Xi,xi)))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_diffabs(Xr,xr))))))))))))))))))))))));
xin=sf_add(ci,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xi,xi))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xi,xi))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_diffabs(Xi,xi))))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(Xr),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xr,xr))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xr,xr))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_diffabs(Xr,xr))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi)))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(Xr),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_diffabs(Xr,xr)))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(Xi),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi)))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(Xr),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_diffabs(Xr,xr)))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_diffabs(Xi,xi)))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(sf_mul(xr,xr),sf_diffabs(Xr,xr)))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_diffabs(Xr,xr)))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr)))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_diffabs(Xi,xi)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr)))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi)))),sf_add(sf_mul(sf_abs(Xr),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_diffabs(Xr,xr)))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_diffabs(Xi,xi)))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_diffabs(Xi,xi)))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_add(sf_mul(xi,sf_mul(xr,sf_diffabs(Xr,xr))),sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi)))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xr,sf_add(sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_diffabs(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_diffabs(Xi,xi))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_diffabs(Xr,xr)))),sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_diffabs(Xi,xi)))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(Xr,sf_diffabs(Xr,xr)),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_diffabs(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(sf_diffabs(Xi,xi),sf_add(Xr,xr))))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_add(sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xr,xr)))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_add(sf_mul(Xr,sf_mul(xi,sf_diffabs(Xi,xi))),sf_mul(xi,sf_mul(xr,sf_diffabs(Xi,xi)))))))),sf_imul(2,sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi)))))))))))))))))))))))));
}

);
#endif


static const char *perturbation_opencl_double_63_5_0 = STR(

{xrn=d_add(cr,d_add(d_mul(d_diffabs(Xr,xr),d_add(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi)),d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr)))),d_add(d_mul(d_mul(d_mul(xi,xi),d_mul(xi,xi)),d_abs(d_add(Xr,xr))),d_add(d_imul(-4,d_mul(xi,d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_imul(4,d_add(d_mul(Xr,d_add(d_mul(d_mul(Xr,Xr),d_mul(xr,d_abs(d_add(Xr,xr)))),d_add(d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))))),d_mul(xi,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_imul(-4,d_add(d_mul(Xi,d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xi,xi))))))),d_add(d_imul(4,d_mul(Xi,d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))))),d_add(d_imul(-4,d_mul(Xi,d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi))))),d_add(d_imul(4,d_mul(Xi,d_mul(d_mul(Xi,Xi),d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi)))))))),d_add(d_imul(-6,d_mul(d_mul(xi,xi),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_add(d_imul(6,d_mul(d_mul(Xr,Xr),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_add(d_imul(-6,d_add(d_mul(d_mul(Xi,Xi),d_add(d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr)),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_mul(d_mul(Xr,Xr),d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))))),d_add(d_imul(6,d_mul(d_mul(Xi,Xi),d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_add(d_imul(-12,d_add(d_mul(Xi,d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(Xr,d_add(d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr)))),d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))))))),d_add(d_imul(12,d_mul(Xi,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xi,xi)))))),d_add(d_imul(-12,d_mul(Xi,d_mul(Xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_imul(12,d_mul(Xi,d_mul(Xr,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))))),d_add(d_imul(-12,d_mul(Xi,d_mul(d_mul(Xr,Xr),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_imul(12,d_mul(d_mul(Xi,Xi),d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi)))))),d_add(d_imul(-12,d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_imul(12,d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(xi,d_abs(d_add(Xi,xi)))))),d_add(d_imul(-24,d_mul(Xi,d_mul(Xr,d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr))))))),d_mul(d_mul(d_mul(xr,xr),d_mul(xr,xr)),d_abs(d_add(Xr,xr)))))))))))))))))))))))));
xin=d_add(ci,d_add(d_mul(d_diffabs(Xi,xi),d_add(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi)),d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr)))),d_add(d_mul(d_mul(d_mul(xi,xi),d_mul(xi,xi)),d_abs(d_add(Xi,xi))),d_add(d_imul(4,d_mul(xi,d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_add(d_imul(-4,d_mul(xi,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_imul(4,d_mul(Xr,d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_imul(-4,d_mul(Xr,d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))))),d_add(d_imul(4,d_add(d_mul(Xi,d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr))),d_add(d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))))),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi)))))))),d_add(d_imul(-4,d_mul(Xi,d_mul(d_mul(Xi,Xi),d_add(d_mul(Xr,d_diffabs(Xr,xr)),d_mul(xr,d_abs(d_add(Xr,xr))))))),d_add(d_imul(4,d_mul(Xi,d_mul(d_mul(Xi,Xi),d_mul(xi,d_abs(d_add(Xi,xi)))))),d_add(d_imul(-6,d_mul(d_mul(xi,xi),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))),d_add(d_imul(6,d_mul(d_mul(Xr,Xr),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))),d_add(d_imul(-6,d_add(d_mul(d_mul(Xi,Xi),d_add(d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi)),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))),d_mul(d_mul(Xr,Xr),d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))))),d_add(d_imul(6,d_mul(d_mul(Xi,Xi),d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))),d_add(d_imul(12,d_mul(Xr,d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_add(d_imul(-12,d_mul(Xr,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xi,xi)))))),d_add(d_imul(12,d_mul(d_mul(Xr,Xr),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_imul(-12,d_mul(Xi,d_add(d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr)))),d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))))),d_add(d_imul(12,d_mul(Xi,d_mul(Xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_add(d_imul(-12,d_mul(Xi,d_mul(Xr,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))))),d_add(d_imul(12,d_mul(Xi,d_mul(d_mul(Xr,Xr),d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_imul(-12,d_add(d_mul(d_mul(Xi,Xi),d_add(d_mul(Xr,d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xi,xi))))))),d_add(d_imul(-24,d_mul(Xi,d_mul(Xr,d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))))),d_mul(d_mul(d_mul(xr,xr),d_mul(xr,xr)),d_abs(d_add(Xi,xi))))))))))))))))))))))))));
}

);

static const char *perturbation_opencl_double_63_5_1 = STR(

{dxan=d_add(d_mul(d_mul(dxa,d_sgn(Xxr)),d_add(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)))),d_add(d_imul(-4,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxi))))),d_add(d_imul(4,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr))))),d_add(d_imul(-4,d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_sgn(Xxi)))))),d_add(d_imul(4,d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_add(d_mul(Xxr,d_mul(dya,d_sgn(Xxi))),d_add(d_mul(dxa,d_abs(Xxi)),d_mul(dya,d_abs(Xxr))))))),d_add(d_imul(-6,d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_sgn(Xxr))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_add(d_mul(dxa,d_abs(Xxi)),d_mul(dya,d_abs(Xxr)))))),d_add(d_imul(12,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dya,d_abs(Xxi))))),d_add(d_imul(-12,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxa,d_abs(Xxr))))),daa)))))))));
dxbn=d_add(d_mul(d_mul(dxb,d_sgn(Xxr)),d_add(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)))),d_add(d_imul(-4,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxi))))),d_add(d_imul(4,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr))))),d_add(d_imul(-4,d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_sgn(Xxi)))))),d_add(d_imul(4,d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_add(d_mul(Xxr,d_mul(dyb,d_sgn(Xxi))),d_add(d_mul(dxb,d_abs(Xxi)),d_mul(dyb,d_abs(Xxr))))))),d_add(d_imul(-6,d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_sgn(Xxr))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_add(d_mul(dxb,d_abs(Xxi)),d_mul(dyb,d_abs(Xxr)))))),d_add(d_imul(12,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dyb,d_abs(Xxi))))),d_add(d_imul(-12,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxb,d_abs(Xxr))))),dab)))))))));
dyan=d_add(d_mul(d_mul(dya,d_sgn(Xxi)),d_add(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)))),d_add(d_imul(4,d_add(d_mul(Xxi,d_add(d_mul(d_mul(Xxi,Xxi),d_mul(dya,d_abs(Xxi))),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_sgn(Xxr)))))),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_add(d_mul(dxa,d_abs(Xxi)),d_mul(dya,d_abs(Xxr))))))),d_add(d_imul(-4,d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_add(d_mul(Xxr,d_mul(dxa,d_sgn(Xxr))),d_mul(dxa,d_abs(Xxr)))))),d_add(d_imul(-6,d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_sgn(Xxi))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxi))))),d_add(d_imul(12,d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr))))),d_add(d_imul(-12,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_add(d_mul(dxa,d_abs(Xxi)),d_mul(dya,d_abs(Xxr)))))),dba)))))));
dybn=d_add(d_mul(d_mul(dyb,d_sgn(Xxi)),d_add(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)))),d_add(d_imul(4,d_add(d_mul(Xxi,d_add(d_mul(d_mul(Xxi,Xxi),d_mul(dyb,d_abs(Xxi))),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_sgn(Xxr)))))),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_add(d_mul(dxb,d_abs(Xxi)),d_mul(dyb,d_abs(Xxr))))))),d_add(d_imul(-4,d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_add(d_mul(Xxr,d_mul(dxb,d_sgn(Xxr))),d_mul(dxb,d_abs(Xxr)))))),d_add(d_imul(-6,d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_sgn(Xxi))))),d_add(d_imul(-12,d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxi))))),d_add(d_imul(12,d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr))))),d_add(d_imul(-12,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_add(d_mul(dxb,d_abs(Xxi)),d_mul(dyb,d_abs(Xxr)))))),dbb)))))));
}

{xrn=d_add(cr,d_add(d_mul(d_diffabs(Xr,xr),d_add(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi)),d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr)))),d_add(d_mul(d_mul(d_mul(xi,xi),d_mul(xi,xi)),d_abs(d_add(Xr,xr))),d_add(d_imul(-4,d_mul(xi,d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_imul(4,d_add(d_mul(Xr,d_add(d_mul(d_mul(Xr,Xr),d_mul(xr,d_abs(d_add(Xr,xr)))),d_add(d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))))),d_mul(xi,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_imul(-4,d_add(d_mul(Xi,d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xi,xi))))))),d_add(d_imul(4,d_mul(Xi,d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))))),d_add(d_imul(-4,d_mul(Xi,d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi))))),d_add(d_imul(4,d_mul(Xi,d_mul(d_mul(Xi,Xi),d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi)))))))),d_add(d_imul(-6,d_mul(d_mul(xi,xi),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_add(d_imul(6,d_mul(d_mul(Xr,Xr),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_add(d_imul(-6,d_add(d_mul(d_mul(Xi,Xi),d_add(d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr)),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_mul(d_mul(Xr,Xr),d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))))),d_add(d_imul(6,d_mul(d_mul(Xi,Xi),d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_add(d_imul(-12,d_add(d_mul(Xi,d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(Xr,d_add(d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr)))),d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))))))),d_add(d_imul(12,d_mul(Xi,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xi,xi)))))),d_add(d_imul(-12,d_mul(Xi,d_mul(Xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_imul(12,d_mul(Xi,d_mul(Xr,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))))),d_add(d_imul(-12,d_mul(Xi,d_mul(d_mul(Xr,Xr),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_imul(12,d_mul(d_mul(Xi,Xi),d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi)))))),d_add(d_imul(-12,d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_imul(12,d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(xi,d_abs(d_add(Xi,xi)))))),d_add(d_imul(-24,d_mul(Xi,d_mul(Xr,d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr))))))),d_mul(d_mul(d_mul(xr,xr),d_mul(xr,xr)),d_abs(d_add(Xr,xr)))))))))))))))))))))))));
xin=d_add(ci,d_add(d_mul(d_diffabs(Xi,xi),d_add(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi)),d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr)))),d_add(d_mul(d_mul(d_mul(xi,xi),d_mul(xi,xi)),d_abs(d_add(Xi,xi))),d_add(d_imul(4,d_mul(xi,d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_add(d_imul(-4,d_mul(xi,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_imul(4,d_mul(Xr,d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_imul(-4,d_mul(Xr,d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))))),d_add(d_imul(4,d_add(d_mul(Xi,d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr))),d_add(d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))))),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi)))))))),d_add(d_imul(-4,d_mul(Xi,d_mul(d_mul(Xi,Xi),d_add(d_mul(Xr,d_diffabs(Xr,xr)),d_mul(xr,d_abs(d_add(Xr,xr))))))),d_add(d_imul(4,d_mul(Xi,d_mul(d_mul(Xi,Xi),d_mul(xi,d_abs(d_add(Xi,xi)))))),d_add(d_imul(-6,d_mul(d_mul(xi,xi),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))),d_add(d_imul(6,d_mul(d_mul(Xr,Xr),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))),d_add(d_imul(-6,d_add(d_mul(d_mul(Xi,Xi),d_add(d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi)),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))),d_mul(d_mul(Xr,Xr),d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))))),d_add(d_imul(6,d_mul(d_mul(Xi,Xi),d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))),d_add(d_imul(12,d_mul(Xr,d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_add(d_imul(-12,d_mul(Xr,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xi,xi)))))),d_add(d_imul(12,d_mul(d_mul(Xr,Xr),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_imul(-12,d_mul(Xi,d_add(d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr)))),d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))))),d_add(d_imul(12,d_mul(Xi,d_mul(Xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_add(d_imul(-12,d_mul(Xi,d_mul(Xr,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))))),d_add(d_imul(12,d_mul(Xi,d_mul(d_mul(Xr,Xr),d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_imul(-12,d_add(d_mul(d_mul(Xi,Xi),d_add(d_mul(Xr,d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xi,xi))))))),d_add(d_imul(-24,d_mul(Xi,d_mul(Xr,d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))))),d_mul(d_mul(d_mul(xr,xr),d_mul(xr,xr)),d_abs(d_add(Xi,xi))))))))))))))))))))))))));
}

);

static const char *perturbation_opencl_floatexp_63_5_0 = STR(

{xrn=fe_add(cr,fe_add(fe_mul(fe_diffabs(Xr,xr),fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi)),fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr)))),fe_add(fe_mul(fe_mul(fe_mul(xi,xi),fe_mul(xi,xi)),fe_abs(fe_add(Xr,xr))),fe_add(fe_imul(-4,fe_mul(xi,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(4,fe_add(fe_mul(Xr,fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_add(fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(-4,fe_add(fe_mul(Xi,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(4,fe_mul(Xi,fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(-4,fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi))))),fe_add(fe_imul(4,fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))))),fe_add(fe_imul(-6,fe_mul(fe_mul(xi,xi),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_imul(6,fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr)),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(6,fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_add(fe_imul(-12,fe_add(fe_mul(Xi,fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(Xr,fe_add(fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))))))),fe_add(fe_imul(12,fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-12,fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(12,fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-12,fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(12,fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-12,fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(12,fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-24,fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))))),fe_mul(fe_mul(fe_mul(xr,xr),fe_mul(xr,xr)),fe_abs(fe_add(Xr,xr)))))))))))))))))))))))));
xin=fe_add(ci,fe_add(fe_mul(fe_diffabs(Xi,xi),fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi)),fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr)))),fe_add(fe_mul(fe_mul(fe_mul(xi,xi),fe_mul(xi,xi)),fe_abs(fe_add(Xi,xi))),fe_add(fe_imul(4,fe_mul(xi,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(-4,fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(4,fe_mul(Xr,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-4,fe_mul(Xr,fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(4,fe_add(fe_mul(Xi,fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr))),fe_add(fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))))),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))))),fe_add(fe_imul(-4,fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(Xr,fe_diffabs(Xr,xr)),fe_mul(xr,fe_abs(fe_add(Xr,xr))))))),fe_add(fe_imul(4,fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-6,fe_mul(fe_mul(xi,xi),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))),fe_add(fe_imul(6,fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi)),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))),fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(6,fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))),fe_add(fe_imul(12,fe_mul(Xr,fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(-12,fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(12,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(-12,fe_mul(Xi,fe_add(fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(12,fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(-12,fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(12,fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(Xr,fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(-24,fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_mul(fe_mul(fe_mul(xr,xr),fe_mul(xr,xr)),fe_abs(fe_add(Xi,xi))))))))))))))))))))))))));
}

);

static const char *perturbation_opencl_floatexp_63_5_1 = STR(

{dxan=fe_add(fe_mul(fe_mul(dxa,fe_sgn(Xxr)),fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)))),fe_add(fe_imul(-4,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxi))))),fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr))))),fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_sgn(Xxi)))))),fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_add(fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxi))),fe_add(fe_mul(dxa,fe_abs(Xxi)),fe_mul(dya,fe_abs(Xxr))))))),fe_add(fe_imul(-6,fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_sgn(Xxr))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_add(fe_mul(dxa,fe_abs(Xxi)),fe_mul(dya,fe_abs(Xxr)))))),fe_add(fe_imul(12,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxi))))),fe_add(fe_imul(-12,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxr))))),daa)))))))));
dxbn=fe_add(fe_mul(fe_mul(dxb,fe_sgn(Xxr)),fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)))),fe_add(fe_imul(-4,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxi))))),fe_add(fe_imul(4,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr))))),fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_sgn(Xxi)))))),fe_add(fe_imul(4,fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_add(fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxi))),fe_add(fe_mul(dxb,fe_abs(Xxi)),fe_mul(dyb,fe_abs(Xxr))))))),fe_add(fe_imul(-6,fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_sgn(Xxr))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_add(fe_mul(dxb,fe_abs(Xxi)),fe_mul(dyb,fe_abs(Xxr)))))),fe_add(fe_imul(12,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxi))))),fe_add(fe_imul(-12,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxr))))),dab)))))))));
dyan=fe_add(fe_mul(fe_mul(dya,fe_sgn(Xxi)),fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)))),fe_add(fe_imul(4,fe_add(fe_mul(Xxi,fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(dya,fe_abs(Xxi))),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_sgn(Xxr)))))),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_add(fe_mul(dxa,fe_abs(Xxi)),fe_mul(dya,fe_abs(Xxr))))))),fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_add(fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr))),fe_mul(dxa,fe_abs(Xxr)))))),fe_add(fe_imul(-6,fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_sgn(Xxi))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxi))))),fe_add(fe_imul(12,fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr))))),fe_add(fe_imul(-12,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_add(fe_mul(dxa,fe_abs(Xxi)),fe_mul(dya,fe_abs(Xxr)))))),dba)))))));
dybn=fe_add(fe_mul(fe_mul(dyb,fe_sgn(Xxi)),fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)))),fe_add(fe_imul(4,fe_add(fe_mul(Xxi,fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(dyb,fe_abs(Xxi))),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_sgn(Xxr)))))),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_add(fe_mul(dxb,fe_abs(Xxi)),fe_mul(dyb,fe_abs(Xxr))))))),fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_add(fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr))),fe_mul(dxb,fe_abs(Xxr)))))),fe_add(fe_imul(-6,fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_sgn(Xxi))))),fe_add(fe_imul(-12,fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxi))))),fe_add(fe_imul(12,fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr))))),fe_add(fe_imul(-12,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_add(fe_mul(dxb,fe_abs(Xxi)),fe_mul(dyb,fe_abs(Xxr)))))),dbb)))))));
}

{xrn=fe_add(cr,fe_add(fe_mul(fe_diffabs(Xr,xr),fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi)),fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr)))),fe_add(fe_mul(fe_mul(fe_mul(xi,xi),fe_mul(xi,xi)),fe_abs(fe_add(Xr,xr))),fe_add(fe_imul(-4,fe_mul(xi,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(4,fe_add(fe_mul(Xr,fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_add(fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(-4,fe_add(fe_mul(Xi,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(4,fe_mul(Xi,fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(-4,fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi))))),fe_add(fe_imul(4,fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))))),fe_add(fe_imul(-6,fe_mul(fe_mul(xi,xi),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_imul(6,fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr)),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(6,fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_add(fe_imul(-12,fe_add(fe_mul(Xi,fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(Xr,fe_add(fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))))))),fe_add(fe_imul(12,fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-12,fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(12,fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-12,fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(12,fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-12,fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(12,fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-24,fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))))),fe_mul(fe_mul(fe_mul(xr,xr),fe_mul(xr,xr)),fe_abs(fe_add(Xr,xr)))))))))))))))))))))))));
xin=fe_add(ci,fe_add(fe_mul(fe_diffabs(Xi,xi),fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi)),fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr)))),fe_add(fe_mul(fe_mul(fe_mul(xi,xi),fe_mul(xi,xi)),fe_abs(fe_add(Xi,xi))),fe_add(fe_imul(4,fe_mul(xi,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(-4,fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(4,fe_mul(Xr,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-4,fe_mul(Xr,fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(4,fe_add(fe_mul(Xi,fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr))),fe_add(fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))))),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))))),fe_add(fe_imul(-4,fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(Xr,fe_diffabs(Xr,xr)),fe_mul(xr,fe_abs(fe_add(Xr,xr))))))),fe_add(fe_imul(4,fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-6,fe_mul(fe_mul(xi,xi),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))),fe_add(fe_imul(6,fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi)),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))),fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(6,fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))),fe_add(fe_imul(12,fe_mul(Xr,fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(-12,fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(12,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(-12,fe_mul(Xi,fe_add(fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(12,fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(-12,fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(12,fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(Xr,fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(-24,fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_mul(fe_mul(fe_mul(xr,xr),fe_mul(xr,xr)),fe_abs(fe_add(Xi,xi))))))))))))))))))))))))));
}

);

#if 0
static const char *perturbation_opencl_softfloat_63_5_0 = STR(

{xrn=sf_add(cr,sf_add(sf_mul(sf_diffabs(Xr,xr),sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi)),sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr)))),sf_add(sf_mul(sf_mul(sf_mul(xi,xi),sf_mul(xi,xi)),sf_abs(sf_add(Xr,xr))),sf_add(sf_imul(-4,sf_mul(xi,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(4,sf_add(sf_mul(Xr,sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_add(sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(-4,sf_add(sf_mul(Xi,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(4,sf_mul(Xi,sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(-4,sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi))))),sf_add(sf_imul(4,sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))))),sf_add(sf_imul(-6,sf_mul(sf_mul(xi,xi),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_imul(6,sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr)),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(6,sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_add(sf_imul(-12,sf_add(sf_mul(Xi,sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(Xr,sf_add(sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))))))),sf_add(sf_imul(12,sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-12,sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(12,sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-12,sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(12,sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-12,sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(12,sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-24,sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))))),sf_mul(sf_mul(sf_mul(xr,xr),sf_mul(xr,xr)),sf_abs(sf_add(Xr,xr)))))))))))))))))))))))));
xin=sf_add(ci,sf_add(sf_mul(sf_diffabs(Xi,xi),sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi)),sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr)))),sf_add(sf_mul(sf_mul(sf_mul(xi,xi),sf_mul(xi,xi)),sf_abs(sf_add(Xi,xi))),sf_add(sf_imul(4,sf_mul(xi,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(-4,sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(4,sf_mul(Xr,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-4,sf_mul(Xr,sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(4,sf_add(sf_mul(Xi,sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr))),sf_add(sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))))),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))))),sf_add(sf_imul(-4,sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(Xr,sf_diffabs(Xr,xr)),sf_mul(xr,sf_abs(sf_add(Xr,xr))))))),sf_add(sf_imul(4,sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-6,sf_mul(sf_mul(xi,xi),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))),sf_add(sf_imul(6,sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi)),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))),sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(6,sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))),sf_add(sf_imul(12,sf_mul(Xr,sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(-12,sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(12,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(-12,sf_mul(Xi,sf_add(sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(12,sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(-12,sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(12,sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(Xr,sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(-24,sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_mul(sf_mul(sf_mul(xr,xr),sf_mul(xr,xr)),sf_abs(sf_add(Xi,xi))))))))))))))))))))))))));
}

);
#endif


static const char *perturbation_opencl_double_64_6_0 = STR(

{xrn=d_add(cr,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi))),d_add(d_mul(Xr,d_diffabs(Xr,xr)),d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr))),d_mul(Xr,d_diffabs(Xr,xr))),d_add(d_mul(d_abs(d_add(Xr,xr)),d_mul(d_add(d_diffabs(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi)),d_add(d_imul(4,d_mul(Xi,d_mul(xi,d_add(d_mul(Xi,Xi),d_mul(xi,xi))))),d_add(d_imul(6,d_mul(d_mul(Xi,Xi),d_mul(xi,xi))),d_mul(d_mul(xi,xi),d_mul(xi,xi))))),d_diffabs(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr)),d_add(d_imul(4,d_mul(Xr,d_mul(xr,d_add(d_mul(Xr,Xr),d_mul(xr,xr))))),d_add(d_imul(6,d_mul(d_mul(Xr,Xr),d_mul(xr,xr))),d_mul(d_mul(xr,xr),d_mul(xr,xr)))))),d_add(Xr,xr))),d_add(d_imul(-1,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_add(d_diffabs(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi)),d_add(d_imul(4,d_mul(Xi,d_mul(xi,d_add(d_mul(Xi,Xi),d_mul(xi,xi))))),d_add(d_imul(6,d_mul(d_mul(Xi,Xi),d_mul(xi,xi))),d_mul(d_mul(xi,xi),d_mul(xi,xi))))),d_diffabs(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr)),d_add(d_imul(4,d_mul(Xr,d_mul(xr,d_add(d_mul(Xr,Xr),d_mul(xr,xr))))),d_add(d_imul(6,d_mul(d_mul(Xr,Xr),d_mul(xr,xr))),d_mul(d_mul(xr,xr),d_mul(xr,xr)))))))),d_mul(d_add(d_mul(Xi,d_diffabs(Xi,xi)),d_mul(xi,d_abs(d_add(Xi,xi)))),d_add(d_abs(d_add(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi)),d_add(d_imul(4,d_mul(Xi,d_mul(xi,d_add(d_mul(Xi,Xi),d_mul(xi,xi))))),d_add(d_imul(6,d_mul(d_mul(Xi,Xi),d_mul(xi,xi))),d_mul(d_mul(xi,xi),d_mul(xi,xi)))))),d_abs(d_add(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr)),d_add(d_imul(4,d_mul(Xr,d_mul(xr,d_add(d_mul(Xr,Xr),d_mul(xr,xr))))),d_add(d_imul(6,d_mul(d_mul(Xr,Xr),d_mul(xr,xr))),d_mul(d_mul(xr,xr),d_mul(xr,xr)))))))))),d_add(d_imul(-4,d_mul(d_abs(d_mul(Xi,d_mul(Xr,d_mul(Xr,Xr)))),d_mul(xr,d_abs(d_add(Xi,xi))))),d_add(d_imul(4,d_mul(d_abs(d_mul(Xi,d_mul(d_mul(Xi,Xi),Xr))),d_mul(xr,d_abs(d_add(Xi,xi))))),d_add(d_imul(-4,d_mul(d_abs(d_add(Xi,xi)),d_mul(xr,d_diffabs(d_mul(Xi,d_mul(Xr,d_mul(Xr,Xr))),d_add(d_mul(Xi,d_mul(xr,d_mul(xr,xr))),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),xi)),d_add(d_imul(3,d_add(d_mul(Xi,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,xr)),d_mul(Xr,d_mul(xi,d_mul(xr,xr)))))),d_mul(xi,d_mul(xr,d_mul(xr,xr)))))))))),d_add(d_imul(4,d_mul(d_abs(d_add(Xi,xi)),d_mul(xr,d_diffabs(d_mul(Xi,d_mul(d_mul(Xi,Xi),Xr)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),xr)),d_add(d_mul(Xr,d_mul(xi,d_mul(xi,xi))),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),d_mul(xi,d_add(Xr,xr))),d_mul(Xi,d_mul(d_mul(xi,xi),d_add(Xr,xr))))),d_mul(xi,d_mul(d_mul(xi,xi),xr))))))))),d_add(d_imul(-4,d_mul(d_abs(d_add(Xr,xr)),d_mul(xi,d_diffabs(d_mul(Xi,d_mul(Xr,d_mul(Xr,Xr))),d_add(d_mul(Xi,d_mul(xr,d_mul(xr,xr))),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),xi)),d_add(d_imul(3,d_add(d_mul(Xi,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,xr)),d_mul(Xr,d_mul(xi,d_mul(xr,xr)))))),d_mul(xi,d_mul(xr,d_mul(xr,xr)))))))))),d_add(d_imul(4,d_mul(d_abs(d_add(Xr,xr)),d_mul(xi,d_diffabs(d_mul(Xi,d_mul(d_mul(Xi,Xi),Xr)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),xr)),d_add(d_mul(Xr,d_mul(xi,d_mul(xi,xi))),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),d_mul(xi,d_add(Xr,xr))),d_mul(Xi,d_mul(d_mul(xi,xi),d_add(Xr,xr))))),d_mul(xi,d_mul(d_mul(xi,xi),xr))))))))),d_add(d_imul(-4,d_mul(d_abs(d_mul(Xi,d_mul(Xr,d_mul(Xr,Xr)))),d_mul(xi,d_abs(d_add(Xr,xr))))),d_add(d_imul(4,d_mul(d_abs(d_mul(Xi,d_mul(d_mul(Xi,Xi),Xr))),d_mul(xi,d_abs(d_add(Xr,xr))))),d_add(d_imul(-4,d_mul(d_abs(d_mul(Xi,d_mul(Xr,d_mul(Xr,Xr)))),d_mul(Xr,d_diffabs(Xi,xi)))),d_add(d_imul(4,d_mul(d_abs(d_mul(Xi,d_mul(d_mul(Xi,Xi),Xr))),d_mul(Xr,d_diffabs(Xi,xi)))),d_add(d_imul(-4,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_diffabs(d_mul(Xi,d_mul(Xr,d_mul(Xr,Xr))),d_add(d_mul(Xi,d_mul(xr,d_mul(xr,xr))),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),xi)),d_add(d_imul(3,d_add(d_mul(Xi,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,xr)),d_mul(Xr,d_mul(xi,d_mul(xr,xr)))))),d_mul(xi,d_mul(xr,d_mul(xr,xr)))))))))),d_add(d_imul(4,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_diffabs(d_mul(Xi,d_mul(d_mul(Xi,Xi),Xr)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),xr)),d_add(d_mul(Xr,d_mul(xi,d_mul(xi,xi))),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),d_mul(xi,d_add(Xr,xr))),d_mul(Xi,d_mul(d_mul(xi,xi),d_add(Xr,xr))))),d_mul(xi,d_mul(d_mul(xi,xi),xr))))))))),d_add(d_imul(-4,d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_diffabs(d_mul(Xi,d_mul(Xr,d_mul(Xr,Xr))),d_add(d_mul(Xi,d_mul(xr,d_mul(xr,xr))),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),xi)),d_add(d_imul(3,d_add(d_mul(Xi,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,xr)),d_mul(Xr,d_mul(xi,d_mul(xr,xr)))))),d_mul(xi,d_mul(xr,d_mul(xr,xr)))))))))),d_add(d_imul(4,d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_diffabs(d_mul(Xi,d_mul(d_mul(Xi,Xi),Xr)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),xr)),d_add(d_mul(Xr,d_mul(xi,d_mul(xi,xi))),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),d_mul(xi,d_add(Xr,xr))),d_mul(Xi,d_mul(d_mul(xi,xi),d_add(Xr,xr))))),d_mul(xi,d_mul(d_mul(xi,xi),xr))))))))),d_add(d_imul(-4,d_mul(d_abs(d_mul(Xi,d_mul(Xr,d_mul(Xr,Xr)))),d_mul(Xi,d_diffabs(Xr,xr)))),d_add(d_imul(4,d_mul(d_abs(d_mul(Xi,d_mul(d_mul(Xi,Xi),Xr))),d_mul(Xi,d_diffabs(Xr,xr)))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),d_mul(Xr,Xr))),d_mul(xr,d_abs(d_add(Xr,xr)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xr,d_diffabs(d_mul(d_mul(Xi,Xi),d_mul(Xr,Xr)),d_add(d_mul(d_mul(Xi,Xi),d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,xi)),d_add(d_imul(2,d_add(d_mul(d_mul(Xi,Xi),d_mul(Xr,xr)),d_add(d_mul(Xi,d_mul(xi,d_add(d_mul(Xr,Xr),d_mul(xr,xr)))),d_mul(Xr,d_mul(d_mul(xi,xi),xr))))),d_add(d_imul(4,d_mul(Xi,d_mul(Xr,d_mul(xi,xr)))),d_mul(d_mul(xi,xi),d_mul(xr,xr))))))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),d_mul(Xr,Xr))),d_mul(xi,d_abs(d_add(Xi,xi)))),d_mul(d_abs(d_add(Xi,xi)),d_mul(xi,d_diffabs(d_mul(d_mul(Xi,Xi),d_mul(Xr,Xr)),d_add(d_mul(d_mul(Xi,Xi),d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,xi)),d_add(d_imul(2,d_add(d_mul(d_mul(Xi,Xi),d_mul(Xr,xr)),d_add(d_mul(Xi,d_mul(xi,d_add(d_mul(Xr,Xr),d_mul(xr,xr)))),d_mul(Xr,d_mul(d_mul(xi,xi),xr))))),d_add(d_imul(4,d_mul(Xi,d_mul(Xr,d_mul(xi,xr)))),d_mul(d_mul(xi,xi),d_mul(xr,xr))))))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),d_mul(Xr,Xr))),d_mul(Xr,d_diffabs(Xr,xr))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_diffabs(d_mul(d_mul(Xi,Xi),d_mul(Xr,Xr)),d_add(d_mul(d_mul(Xi,Xi),d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,xi)),d_add(d_imul(2,d_add(d_mul(d_mul(Xi,Xi),d_mul(Xr,xr)),d_add(d_mul(Xi,d_mul(xi,d_add(d_mul(Xr,Xr),d_mul(xr,xr)))),d_mul(Xr,d_mul(d_mul(xi,xi),xr))))),d_add(d_imul(4,d_mul(Xi,d_mul(Xr,d_mul(xi,xr)))),d_mul(d_mul(xi,xi),d_mul(xr,xr))))))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),d_mul(Xr,Xr))),d_mul(Xi,d_diffabs(Xi,xi))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_diffabs(d_mul(d_mul(Xi,Xi),d_mul(Xr,Xr)),d_add(d_mul(d_mul(Xi,Xi),d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,xi)),d_add(d_imul(2,d_add(d_mul(d_mul(Xi,Xi),d_mul(Xr,xr)),d_add(d_mul(Xi,d_mul(xi,d_add(d_mul(Xr,Xr),d_mul(xr,xr)))),d_mul(Xr,d_mul(d_mul(xi,xi),xr))))),d_add(d_imul(4,d_mul(Xi,d_mul(Xr,d_mul(xi,xr)))),d_mul(d_mul(xi,xi),d_mul(xr,xr))))))))))),d_mul(d_abs(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr))),d_mul(xr,d_abs(d_add(Xr,xr)))))))))))))))))))))))))))));
xin=d_add(ci,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi))),d_add(d_mul(Xi,d_diffabs(Xr,xr)),d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_mul(d_abs(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr))),d_add(d_mul(Xi,d_diffabs(Xr,xr)),d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_mul(xi,d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_add(d_diffabs(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi)),d_add(d_imul(4,d_mul(Xi,d_mul(xi,d_add(d_mul(Xi,Xi),d_mul(xi,xi))))),d_add(d_imul(6,d_mul(d_mul(Xi,Xi),d_mul(xi,xi))),d_mul(d_mul(xi,xi),d_mul(xi,xi))))),d_diffabs(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr)),d_add(d_imul(4,d_mul(Xr,d_mul(xr,d_add(d_mul(Xr,Xr),d_mul(xr,xr))))),d_add(d_imul(6,d_mul(d_mul(Xr,Xr),d_mul(xr,xr))),d_mul(d_mul(xr,xr),d_mul(xr,xr)))))),d_add(Xr,xr))),d_add(d_mul(d_abs(d_add(Xr,xr)),d_mul(d_add(d_diffabs(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi)),d_add(d_imul(4,d_mul(Xi,d_mul(xi,d_add(d_mul(Xi,Xi),d_mul(xi,xi))))),d_add(d_imul(6,d_mul(d_mul(Xi,Xi),d_mul(xi,xi))),d_mul(d_mul(xi,xi),d_mul(xi,xi))))),d_diffabs(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr)),d_add(d_imul(4,d_mul(Xr,d_mul(xr,d_add(d_mul(Xr,Xr),d_mul(xr,xr))))),d_add(d_imul(6,d_mul(d_mul(Xr,Xr),d_mul(xr,xr))),d_mul(d_mul(xr,xr),d_mul(xr,xr)))))),d_add(Xi,xi))),d_add(d_imul(4,d_mul(d_abs(d_add(Xr,xr)),d_mul(xr,d_diffabs(d_mul(Xi,d_mul(Xr,d_mul(Xr,Xr))),d_add(d_mul(Xi,d_mul(xr,d_mul(xr,xr))),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),xi)),d_add(d_imul(3,d_add(d_mul(Xi,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,xr)),d_mul(Xr,d_mul(xi,d_mul(xr,xr)))))),d_mul(xi,d_mul(xr,d_mul(xr,xr)))))))))),d_add(d_imul(-4,d_mul(d_abs(d_add(Xr,xr)),d_mul(xr,d_diffabs(d_mul(Xi,d_mul(d_mul(Xi,Xi),Xr)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),xr)),d_add(d_mul(Xr,d_mul(xi,d_mul(xi,xi))),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),d_mul(xi,d_add(Xr,xr))),d_mul(Xi,d_mul(d_mul(xi,xi),d_add(Xr,xr))))),d_mul(xi,d_mul(d_mul(xi,xi),xr))))))))),d_add(d_imul(4,d_mul(d_abs(d_mul(Xi,d_mul(Xr,d_mul(Xr,Xr)))),d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_imul(-4,d_add(d_mul(d_abs(d_mul(Xi,d_mul(d_mul(Xi,Xi),Xr))),d_mul(xr,d_abs(d_add(Xr,xr)))),d_mul(d_abs(d_mul(Xi,d_mul(Xr,d_mul(Xr,Xr)))),d_mul(xi,d_abs(d_add(Xi,xi)))))),d_add(d_imul(4,d_mul(d_abs(d_mul(Xi,d_mul(d_mul(Xi,Xi),Xr))),d_mul(xi,d_abs(d_add(Xi,xi))))),d_add(d_imul(-4,d_mul(d_abs(d_add(Xi,xi)),d_mul(xi,d_diffabs(d_mul(Xi,d_mul(Xr,d_mul(Xr,Xr))),d_add(d_mul(Xi,d_mul(xr,d_mul(xr,xr))),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),xi)),d_add(d_imul(3,d_add(d_mul(Xi,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,xr)),d_mul(Xr,d_mul(xi,d_mul(xr,xr)))))),d_mul(xi,d_mul(xr,d_mul(xr,xr)))))))))),d_add(d_imul(4,d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(xi,d_diffabs(d_mul(Xi,d_mul(d_mul(Xi,Xi),Xr)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),xr)),d_add(d_mul(Xr,d_mul(xi,d_mul(xi,xi))),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),d_mul(xi,d_add(Xr,xr))),d_mul(Xi,d_mul(d_mul(xi,xi),d_add(Xr,xr))))),d_mul(xi,d_mul(d_mul(xi,xi),xr)))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_diffabs(d_mul(Xi,d_mul(Xr,d_mul(Xr,Xr))),d_add(d_mul(Xi,d_mul(xr,d_mul(xr,xr))),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),xi)),d_add(d_imul(3,d_add(d_mul(Xi,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,xr)),d_mul(Xr,d_mul(xi,d_mul(xr,xr)))))),d_mul(xi,d_mul(xr,d_mul(xr,xr))))))))))),d_add(d_imul(-4,d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_diffabs(d_mul(Xi,d_mul(d_mul(Xi,Xi),Xr)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),xr)),d_add(d_mul(Xr,d_mul(xi,d_mul(xi,xi))),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),d_mul(xi,d_add(Xr,xr))),d_mul(Xi,d_mul(d_mul(xi,xi),d_add(Xr,xr))))),d_mul(xi,d_mul(d_mul(xi,xi),xr))))))))),d_add(d_imul(4,d_mul(d_abs(d_mul(Xi,d_mul(Xr,d_mul(Xr,Xr)))),d_mul(Xr,d_diffabs(Xr,xr)))),d_add(d_imul(-4,d_add(d_mul(d_abs(d_mul(Xi,d_mul(d_mul(Xi,Xi),Xr))),d_mul(Xr,d_diffabs(Xr,xr))),d_mul(d_abs(d_mul(Xi,d_mul(Xr,d_mul(Xr,Xr)))),d_mul(Xi,d_diffabs(Xi,xi))))),d_add(d_imul(4,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_diffabs(d_mul(Xi,d_mul(d_mul(Xi,Xi),Xr)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),xr)),d_add(d_mul(Xr,d_mul(xi,d_mul(xi,xi))),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),d_mul(xi,d_add(Xr,xr))),d_mul(Xi,d_mul(d_mul(xi,xi),d_add(Xr,xr))))),d_mul(xi,d_mul(d_mul(xi,xi),xr))))))))),d_add(d_imul(-4,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_diffabs(d_mul(Xi,d_mul(Xr,d_mul(Xr,Xr))),d_add(d_mul(Xi,d_mul(xr,d_mul(xr,xr))),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),xi)),d_add(d_imul(3,d_add(d_mul(Xi,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,xr)),d_mul(Xr,d_mul(xi,d_mul(xr,xr)))))),d_mul(xi,d_mul(xr,d_mul(xr,xr)))))))))),d_add(d_imul(4,d_mul(d_abs(d_mul(Xi,d_mul(d_mul(Xi,Xi),Xr))),d_mul(Xi,d_diffabs(Xi,xi)))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),d_mul(Xr,Xr))),d_add(d_mul(Xi,d_diffabs(Xr,xr)),d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_diffabs(d_mul(d_mul(Xi,Xi),d_mul(Xr,Xr)),d_add(d_mul(d_mul(Xi,Xi),d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,xi)),d_add(d_imul(2,d_add(d_mul(d_mul(Xi,Xi),d_mul(Xr,xr)),d_add(d_mul(Xi,d_mul(xi,d_add(d_mul(Xr,Xr),d_mul(xr,xr)))),d_mul(Xr,d_mul(d_mul(xi,xi),xr))))),d_add(d_imul(4,d_mul(Xi,d_mul(Xr,d_mul(xi,xr)))),d_mul(d_mul(xi,xi),d_mul(xr,xr))))))),d_add(Xr,xr))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_diffabs(d_mul(d_mul(Xi,Xi),d_mul(Xr,Xr)),d_add(d_mul(d_mul(Xi,Xi),d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,xi)),d_add(d_imul(2,d_add(d_mul(d_mul(Xi,Xi),d_mul(Xr,xr)),d_add(d_mul(Xi,d_mul(xi,d_add(d_mul(Xr,Xr),d_mul(xr,xr)))),d_mul(Xr,d_mul(d_mul(xi,xi),xr))))),d_add(d_imul(4,d_mul(Xi,d_mul(Xr,d_mul(xi,xr)))),d_mul(d_mul(xi,xi),d_mul(xr,xr))))))),d_add(Xi,xi)))))),d_mul(d_abs(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr))),d_mul(xr,d_abs(d_add(Xi,xi)))))))))))))))))))))));
}

);

static const char *perturbation_opencl_double_64_6_1 = STR(

{dxan=d_add(daa,d_add(d_mul(d_mul(dxa,d_abs(Xxr)),d_add(d_abs(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi))),d_abs(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr))))),d_add(d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(dxa,d_add(d_abs(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi))),d_abs(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr))))))),d_add(d_imul(-1,d_add(d_mul(d_abs(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi))),d_mul(dya,d_abs(Xxi))),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(dya,d_add(d_abs(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi))),d_abs(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr))))))))),d_add(d_imul(-4,d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr)))),d_mul(dya,d_abs(Xxr)))),d_add(d_imul(4,d_mul(d_abs(d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),Xxr))),d_mul(dya,d_abs(Xxr)))),d_add(d_imul(-4,d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr)))),d_mul(dxa,d_abs(Xxi)))),d_add(d_imul(4,d_mul(d_abs(d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),Xxr))),d_mul(dxa,d_abs(Xxi)))),d_add(d_imul(-4,d_mul(d_sgn(Xxi),d_mul(Xxr,d_mul(dya,d_abs(d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr)))))))),d_add(d_imul(4,d_mul(d_sgn(Xxi),d_mul(Xxr,d_mul(dya,d_abs(d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),Xxr))))))),d_add(d_imul(-4,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dya,d_abs(Xxi))))))),d_add(d_imul(4,d_mul(d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_sgn(Xxr),d_sgn(Xxr))),d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dxa,d_abs(Xxr))))),d_add(d_imul(-4,d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(dxa,d_abs(d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr)))))))),d_add(d_imul(4,d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(dxa,d_abs(d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),Xxr))))))),d_add(d_imul(-4,d_add(d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxr)))))))),d_mul(d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_sgn(Xxr),d_sgn(Xxr))),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxi)))))))),d_add(d_imul(4,d_add(d_mul(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxi),d_sgn(Xxi))),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dya,d_abs(Xxr)))))),d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_add(d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(dxa,d_abs(Xxr))),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxa,d_abs(Xxi))))))))))),d_add(d_imul(-4,d_mul(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxi),d_sgn(Xxi))),d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(dya,d_abs(Xxi))))),d_add(d_imul(6,d_mul(d_abs(d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,Xxr))),d_mul(dya,d_abs(Xxi)))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,Xxr))),d_mul(dxa,d_abs(Xxr))),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(dxa,d_abs(d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,Xxr)))))))),d_add(d_imul(6,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(dya,d_abs(d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,Xxr))))))),d_add(d_imul(-12,d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxr))))))),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxi)))))))))),d_add(d_imul(12,d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxi))))))),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxi)))))))),d_add(d_imul(-12,d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr)))))),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr))))))))),d_add(d_imul(12,d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dya,d_abs(Xxr)))))))),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxa,d_abs(Xxi))))))))),d_imul(-1,d_mul(d_abs(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr))),d_mul(dya,d_abs(Xxi))))))))))))))))))))))))))));
dxbn=d_add(dab,d_add(d_mul(d_mul(dxb,d_abs(Xxr)),d_add(d_abs(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi))),d_abs(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr))))),d_add(d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(dxb,d_add(d_abs(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi))),d_abs(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr))))))),d_add(d_imul(-1,d_add(d_mul(d_abs(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi))),d_mul(dyb,d_abs(Xxi))),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(dyb,d_add(d_abs(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi))),d_abs(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr))))))))),d_add(d_imul(-4,d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr)))),d_mul(dyb,d_abs(Xxr)))),d_add(d_imul(4,d_mul(d_abs(d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),Xxr))),d_mul(dyb,d_abs(Xxr)))),d_add(d_imul(-4,d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr)))),d_mul(dxb,d_abs(Xxi)))),d_add(d_imul(4,d_mul(d_abs(d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),Xxr))),d_mul(dxb,d_abs(Xxi)))),d_add(d_imul(-4,d_mul(d_sgn(Xxi),d_mul(Xxr,d_mul(dyb,d_abs(d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr)))))))),d_add(d_imul(4,d_mul(d_sgn(Xxi),d_mul(Xxr,d_mul(dyb,d_abs(d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),Xxr))))))),d_add(d_imul(-4,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dyb,d_abs(Xxi))))))),d_add(d_imul(4,d_mul(d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_sgn(Xxr),d_sgn(Xxr))),d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dxb,d_abs(Xxr))))),d_add(d_imul(-4,d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(dxb,d_abs(d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr)))))))),d_add(d_imul(4,d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(dxb,d_abs(d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),Xxr))))))),d_add(d_imul(-4,d_add(d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxr)))))))),d_mul(d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_sgn(Xxr),d_sgn(Xxr))),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxi)))))))),d_add(d_imul(4,d_add(d_mul(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxi),d_sgn(Xxi))),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dyb,d_abs(Xxr)))))),d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_add(d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(dxb,d_abs(Xxr))),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxb,d_abs(Xxi))))))))))),d_add(d_imul(-4,d_mul(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxi),d_sgn(Xxi))),d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(dyb,d_abs(Xxi))))),d_add(d_imul(6,d_mul(d_abs(d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,Xxr))),d_mul(dyb,d_abs(Xxi)))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,Xxr))),d_mul(dxb,d_abs(Xxr))),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(dxb,d_abs(d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,Xxr)))))))),d_add(d_imul(6,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(dyb,d_abs(d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,Xxr))))))),d_add(d_imul(-12,d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxr))))))),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxi)))))))))),d_add(d_imul(12,d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxi))))))),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxi)))))))),d_add(d_imul(-12,d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr)))))),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr))))))))),d_add(d_imul(12,d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dyb,d_abs(Xxr)))))))),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxb,d_abs(Xxi))))))))),d_imul(-1,d_mul(d_abs(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr))),d_mul(dyb,d_abs(Xxi))))))))))))))))))))))))))));
dyan=d_add(dba,d_add(d_mul(d_abs(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi))),d_add(d_mul(dxa,d_abs(Xxi)),d_mul(dya,d_abs(Xxr)))),d_add(d_mul(d_abs(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr))),d_mul(dxa,d_abs(Xxi))),d_add(d_mul(d_sgn(Xxi),d_mul(Xxr,d_mul(dya,d_add(d_abs(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi))),d_abs(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr))))))),d_add(d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(dxa,d_add(d_abs(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi))),d_abs(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr))))))),d_add(d_imul(-4,d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr)))),d_mul(dya,d_abs(Xxi)))),d_add(d_imul(4,d_add(d_mul(d_abs(d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),Xxr))),d_mul(dya,d_abs(Xxi))),d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr)))),d_mul(dxa,d_abs(Xxr))))),d_add(d_imul(-4,d_mul(d_abs(d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),Xxr))),d_mul(dxa,d_abs(Xxr)))),d_add(d_imul(4,d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(dxa,d_abs(d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr)))))))),d_add(d_imul(-4,d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(dxa,d_abs(d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),Xxr))))))),d_add(d_imul(4,d_add(d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dya,d_abs(Xxr)))))),d_mul(d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_sgn(Xxr),d_sgn(Xxr))),d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dxa,d_abs(Xxi)))))),d_add(d_imul(-4,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(dya,d_abs(d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr)))))))),d_add(d_imul(4,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(dya,d_abs(d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),Xxr))))))),d_add(d_imul(-4,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxi))))))))),d_add(d_imul(4,d_add(d_mul(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxi),d_sgn(Xxi))),d_add(d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(dya,d_abs(Xxr))),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dya,d_abs(Xxi))))))),d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(dxa,d_abs(Xxi)))))),d_mul(d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_sgn(Xxr),d_sgn(Xxr))),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr))))))))),d_add(d_imul(-4,d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxa,d_abs(Xxr))))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,Xxr))),d_add(d_mul(dxa,d_abs(Xxi)),d_mul(dya,d_abs(Xxr)))),d_add(d_mul(d_sgn(Xxi),d_mul(Xxr,d_mul(dya,d_abs(d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,Xxr)))))),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(dxa,d_abs(d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,Xxr))))))))),d_add(d_imul(-12,d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxi)))))))),d_add(d_imul(12,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr))))))))),d_add(d_imul(-12,d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxr))))))),d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_add(d_mul(dxa,d_abs(Xxi)),d_mul(dya,d_abs(Xxr))))))),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxi)))))))))),d_add(d_imul(12,d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dya,d_abs(Xxi))))))))),d_add(d_imul(-12,d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxa,d_abs(Xxr)))))))),d_mul(d_abs(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr))),d_mul(dya,d_abs(Xxr)))))))))))))))))))))))));
dybn=d_add(dbb,d_add(d_mul(d_abs(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi))),d_add(d_mul(dxb,d_abs(Xxi)),d_mul(dyb,d_abs(Xxr)))),d_add(d_mul(d_abs(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr))),d_mul(dxb,d_abs(Xxi))),d_add(d_mul(d_sgn(Xxi),d_mul(Xxr,d_mul(dyb,d_add(d_abs(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi))),d_abs(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr))))))),d_add(d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(dxb,d_add(d_abs(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi))),d_abs(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr))))))),d_add(d_imul(-4,d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr)))),d_mul(dyb,d_abs(Xxi)))),d_add(d_imul(4,d_add(d_mul(d_abs(d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),Xxr))),d_mul(dyb,d_abs(Xxi))),d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr)))),d_mul(dxb,d_abs(Xxr))))),d_add(d_imul(-4,d_mul(d_abs(d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),Xxr))),d_mul(dxb,d_abs(Xxr)))),d_add(d_imul(4,d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(dxb,d_abs(d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr)))))))),d_add(d_imul(-4,d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(dxb,d_abs(d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),Xxr))))))),d_add(d_imul(4,d_add(d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dyb,d_abs(Xxr)))))),d_mul(d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_sgn(Xxr),d_sgn(Xxr))),d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dxb,d_abs(Xxi)))))),d_add(d_imul(-4,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(dyb,d_abs(d_mul(Xxi,d_mul(Xxr,d_mul(Xxr,Xxr)))))))),d_add(d_imul(4,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(dyb,d_abs(d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),Xxr))))))),d_add(d_imul(-4,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxi))))))))),d_add(d_imul(4,d_add(d_mul(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxi),d_sgn(Xxi))),d_add(d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(dyb,d_abs(Xxr))),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dyb,d_abs(Xxi))))))),d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(dxb,d_abs(Xxi)))))),d_mul(d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_sgn(Xxr),d_sgn(Xxr))),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr))))))))),d_add(d_imul(-4,d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxb,d_abs(Xxr))))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,Xxr))),d_add(d_mul(dxb,d_abs(Xxi)),d_mul(dyb,d_abs(Xxr)))),d_add(d_mul(d_sgn(Xxi),d_mul(Xxr,d_mul(dyb,d_abs(d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,Xxr)))))),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(dxb,d_abs(d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,Xxr))))))))),d_add(d_imul(-12,d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxi)))))))),d_add(d_imul(12,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr))))))))),d_add(d_imul(-12,d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxr))))))),d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_add(d_mul(dxb,d_abs(Xxi)),d_mul(dyb,d_abs(Xxr))))))),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxi)))))))))),d_add(d_imul(12,d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dyb,d_abs(Xxi))))))))),d_add(d_imul(-12,d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxb,d_abs(Xxr)))))))),d_mul(d_abs(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr))),d_mul(dyb,d_abs(Xxr)))))))))))))))))))))))));
}

{xrn=d_add(cr,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi))),d_add(d_mul(Xr,d_diffabs(Xr,xr)),d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr))),d_mul(Xr,d_diffabs(Xr,xr))),d_add(d_mul(d_abs(d_add(Xr,xr)),d_mul(d_add(d_diffabs(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi)),d_add(d_imul(4,d_mul(Xi,d_mul(xi,d_add(d_mul(Xi,Xi),d_mul(xi,xi))))),d_add(d_imul(6,d_mul(d_mul(Xi,Xi),d_mul(xi,xi))),d_mul(d_mul(xi,xi),d_mul(xi,xi))))),d_diffabs(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr)),d_add(d_imul(4,d_mul(Xr,d_mul(xr,d_add(d_mul(Xr,Xr),d_mul(xr,xr))))),d_add(d_imul(6,d_mul(d_mul(Xr,Xr),d_mul(xr,xr))),d_mul(d_mul(xr,xr),d_mul(xr,xr)))))),d_add(Xr,xr))),d_add(d_imul(-1,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_add(d_diffabs(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi)),d_add(d_imul(4,d_mul(Xi,d_mul(xi,d_add(d_mul(Xi,Xi),d_mul(xi,xi))))),d_add(d_imul(6,d_mul(d_mul(Xi,Xi),d_mul(xi,xi))),d_mul(d_mul(xi,xi),d_mul(xi,xi))))),d_diffabs(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr)),d_add(d_imul(4,d_mul(Xr,d_mul(xr,d_add(d_mul(Xr,Xr),d_mul(xr,xr))))),d_add(d_imul(6,d_mul(d_mul(Xr,Xr),d_mul(xr,xr))),d_mul(d_mul(xr,xr),d_mul(xr,xr)))))))),d_mul(d_add(d_mul(Xi,d_diffabs(Xi,xi)),d_mul(xi,d_abs(d_add(Xi,xi)))),d_add(d_abs(d_add(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi)),d_add(d_imul(4,d_mul(Xi,d_mul(xi,d_add(d_mul(Xi,Xi),d_mul(xi,xi))))),d_add(d_imul(6,d_mul(d_mul(Xi,Xi),d_mul(xi,xi))),d_mul(d_mul(xi,xi),d_mul(xi,xi)))))),d_abs(d_add(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr)),d_add(d_imul(4,d_mul(Xr,d_mul(xr,d_add(d_mul(Xr,Xr),d_mul(xr,xr))))),d_add(d_imul(6,d_mul(d_mul(Xr,Xr),d_mul(xr,xr))),d_mul(d_mul(xr,xr),d_mul(xr,xr)))))))))),d_add(d_imul(-4,d_mul(d_abs(d_mul(Xi,d_mul(Xr,d_mul(Xr,Xr)))),d_mul(xr,d_abs(d_add(Xi,xi))))),d_add(d_imul(4,d_mul(d_abs(d_mul(Xi,d_mul(d_mul(Xi,Xi),Xr))),d_mul(xr,d_abs(d_add(Xi,xi))))),d_add(d_imul(-4,d_mul(d_abs(d_add(Xi,xi)),d_mul(xr,d_diffabs(d_mul(Xi,d_mul(Xr,d_mul(Xr,Xr))),d_add(d_mul(Xi,d_mul(xr,d_mul(xr,xr))),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),xi)),d_add(d_imul(3,d_add(d_mul(Xi,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,xr)),d_mul(Xr,d_mul(xi,d_mul(xr,xr)))))),d_mul(xi,d_mul(xr,d_mul(xr,xr)))))))))),d_add(d_imul(4,d_mul(d_abs(d_add(Xi,xi)),d_mul(xr,d_diffabs(d_mul(Xi,d_mul(d_mul(Xi,Xi),Xr)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),xr)),d_add(d_mul(Xr,d_mul(xi,d_mul(xi,xi))),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),d_mul(xi,d_add(Xr,xr))),d_mul(Xi,d_mul(d_mul(xi,xi),d_add(Xr,xr))))),d_mul(xi,d_mul(d_mul(xi,xi),xr))))))))),d_add(d_imul(-4,d_mul(d_abs(d_add(Xr,xr)),d_mul(xi,d_diffabs(d_mul(Xi,d_mul(Xr,d_mul(Xr,Xr))),d_add(d_mul(Xi,d_mul(xr,d_mul(xr,xr))),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),xi)),d_add(d_imul(3,d_add(d_mul(Xi,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,xr)),d_mul(Xr,d_mul(xi,d_mul(xr,xr)))))),d_mul(xi,d_mul(xr,d_mul(xr,xr)))))))))),d_add(d_imul(4,d_mul(d_abs(d_add(Xr,xr)),d_mul(xi,d_diffabs(d_mul(Xi,d_mul(d_mul(Xi,Xi),Xr)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),xr)),d_add(d_mul(Xr,d_mul(xi,d_mul(xi,xi))),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),d_mul(xi,d_add(Xr,xr))),d_mul(Xi,d_mul(d_mul(xi,xi),d_add(Xr,xr))))),d_mul(xi,d_mul(d_mul(xi,xi),xr))))))))),d_add(d_imul(-4,d_mul(d_abs(d_mul(Xi,d_mul(Xr,d_mul(Xr,Xr)))),d_mul(xi,d_abs(d_add(Xr,xr))))),d_add(d_imul(4,d_mul(d_abs(d_mul(Xi,d_mul(d_mul(Xi,Xi),Xr))),d_mul(xi,d_abs(d_add(Xr,xr))))),d_add(d_imul(-4,d_mul(d_abs(d_mul(Xi,d_mul(Xr,d_mul(Xr,Xr)))),d_mul(Xr,d_diffabs(Xi,xi)))),d_add(d_imul(4,d_mul(d_abs(d_mul(Xi,d_mul(d_mul(Xi,Xi),Xr))),d_mul(Xr,d_diffabs(Xi,xi)))),d_add(d_imul(-4,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_diffabs(d_mul(Xi,d_mul(Xr,d_mul(Xr,Xr))),d_add(d_mul(Xi,d_mul(xr,d_mul(xr,xr))),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),xi)),d_add(d_imul(3,d_add(d_mul(Xi,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,xr)),d_mul(Xr,d_mul(xi,d_mul(xr,xr)))))),d_mul(xi,d_mul(xr,d_mul(xr,xr)))))))))),d_add(d_imul(4,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_diffabs(d_mul(Xi,d_mul(d_mul(Xi,Xi),Xr)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),xr)),d_add(d_mul(Xr,d_mul(xi,d_mul(xi,xi))),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),d_mul(xi,d_add(Xr,xr))),d_mul(Xi,d_mul(d_mul(xi,xi),d_add(Xr,xr))))),d_mul(xi,d_mul(d_mul(xi,xi),xr))))))))),d_add(d_imul(-4,d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_diffabs(d_mul(Xi,d_mul(Xr,d_mul(Xr,Xr))),d_add(d_mul(Xi,d_mul(xr,d_mul(xr,xr))),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),xi)),d_add(d_imul(3,d_add(d_mul(Xi,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,xr)),d_mul(Xr,d_mul(xi,d_mul(xr,xr)))))),d_mul(xi,d_mul(xr,d_mul(xr,xr)))))))))),d_add(d_imul(4,d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_diffabs(d_mul(Xi,d_mul(d_mul(Xi,Xi),Xr)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),xr)),d_add(d_mul(Xr,d_mul(xi,d_mul(xi,xi))),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),d_mul(xi,d_add(Xr,xr))),d_mul(Xi,d_mul(d_mul(xi,xi),d_add(Xr,xr))))),d_mul(xi,d_mul(d_mul(xi,xi),xr))))))))),d_add(d_imul(-4,d_mul(d_abs(d_mul(Xi,d_mul(Xr,d_mul(Xr,Xr)))),d_mul(Xi,d_diffabs(Xr,xr)))),d_add(d_imul(4,d_mul(d_abs(d_mul(Xi,d_mul(d_mul(Xi,Xi),Xr))),d_mul(Xi,d_diffabs(Xr,xr)))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),d_mul(Xr,Xr))),d_mul(xr,d_abs(d_add(Xr,xr)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xr,d_diffabs(d_mul(d_mul(Xi,Xi),d_mul(Xr,Xr)),d_add(d_mul(d_mul(Xi,Xi),d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,xi)),d_add(d_imul(2,d_add(d_mul(d_mul(Xi,Xi),d_mul(Xr,xr)),d_add(d_mul(Xi,d_mul(xi,d_add(d_mul(Xr,Xr),d_mul(xr,xr)))),d_mul(Xr,d_mul(d_mul(xi,xi),xr))))),d_add(d_imul(4,d_mul(Xi,d_mul(Xr,d_mul(xi,xr)))),d_mul(d_mul(xi,xi),d_mul(xr,xr))))))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),d_mul(Xr,Xr))),d_mul(xi,d_abs(d_add(Xi,xi)))),d_mul(d_abs(d_add(Xi,xi)),d_mul(xi,d_diffabs(d_mul(d_mul(Xi,Xi),d_mul(Xr,Xr)),d_add(d_mul(d_mul(Xi,Xi),d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,xi)),d_add(d_imul(2,d_add(d_mul(d_mul(Xi,Xi),d_mul(Xr,xr)),d_add(d_mul(Xi,d_mul(xi,d_add(d_mul(Xr,Xr),d_mul(xr,xr)))),d_mul(Xr,d_mul(d_mul(xi,xi),xr))))),d_add(d_imul(4,d_mul(Xi,d_mul(Xr,d_mul(xi,xr)))),d_mul(d_mul(xi,xi),d_mul(xr,xr))))))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),d_mul(Xr,Xr))),d_mul(Xr,d_diffabs(Xr,xr))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_diffabs(d_mul(d_mul(Xi,Xi),d_mul(Xr,Xr)),d_add(d_mul(d_mul(Xi,Xi),d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,xi)),d_add(d_imul(2,d_add(d_mul(d_mul(Xi,Xi),d_mul(Xr,xr)),d_add(d_mul(Xi,d_mul(xi,d_add(d_mul(Xr,Xr),d_mul(xr,xr)))),d_mul(Xr,d_mul(d_mul(xi,xi),xr))))),d_add(d_imul(4,d_mul(Xi,d_mul(Xr,d_mul(xi,xr)))),d_mul(d_mul(xi,xi),d_mul(xr,xr))))))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),d_mul(Xr,Xr))),d_mul(Xi,d_diffabs(Xi,xi))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_diffabs(d_mul(d_mul(Xi,Xi),d_mul(Xr,Xr)),d_add(d_mul(d_mul(Xi,Xi),d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,xi)),d_add(d_imul(2,d_add(d_mul(d_mul(Xi,Xi),d_mul(Xr,xr)),d_add(d_mul(Xi,d_mul(xi,d_add(d_mul(Xr,Xr),d_mul(xr,xr)))),d_mul(Xr,d_mul(d_mul(xi,xi),xr))))),d_add(d_imul(4,d_mul(Xi,d_mul(Xr,d_mul(xi,xr)))),d_mul(d_mul(xi,xi),d_mul(xr,xr))))))))))),d_mul(d_abs(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr))),d_mul(xr,d_abs(d_add(Xr,xr)))))))))))))))))))))))))))));
xin=d_add(ci,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi))),d_add(d_mul(Xi,d_diffabs(Xr,xr)),d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_mul(d_abs(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr))),d_add(d_mul(Xi,d_diffabs(Xr,xr)),d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_mul(xi,d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_add(d_diffabs(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi)),d_add(d_imul(4,d_mul(Xi,d_mul(xi,d_add(d_mul(Xi,Xi),d_mul(xi,xi))))),d_add(d_imul(6,d_mul(d_mul(Xi,Xi),d_mul(xi,xi))),d_mul(d_mul(xi,xi),d_mul(xi,xi))))),d_diffabs(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr)),d_add(d_imul(4,d_mul(Xr,d_mul(xr,d_add(d_mul(Xr,Xr),d_mul(xr,xr))))),d_add(d_imul(6,d_mul(d_mul(Xr,Xr),d_mul(xr,xr))),d_mul(d_mul(xr,xr),d_mul(xr,xr)))))),d_add(Xr,xr))),d_add(d_mul(d_abs(d_add(Xr,xr)),d_mul(d_add(d_diffabs(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi)),d_add(d_imul(4,d_mul(Xi,d_mul(xi,d_add(d_mul(Xi,Xi),d_mul(xi,xi))))),d_add(d_imul(6,d_mul(d_mul(Xi,Xi),d_mul(xi,xi))),d_mul(d_mul(xi,xi),d_mul(xi,xi))))),d_diffabs(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr)),d_add(d_imul(4,d_mul(Xr,d_mul(xr,d_add(d_mul(Xr,Xr),d_mul(xr,xr))))),d_add(d_imul(6,d_mul(d_mul(Xr,Xr),d_mul(xr,xr))),d_mul(d_mul(xr,xr),d_mul(xr,xr)))))),d_add(Xi,xi))),d_add(d_imul(4,d_mul(d_abs(d_add(Xr,xr)),d_mul(xr,d_diffabs(d_mul(Xi,d_mul(Xr,d_mul(Xr,Xr))),d_add(d_mul(Xi,d_mul(xr,d_mul(xr,xr))),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),xi)),d_add(d_imul(3,d_add(d_mul(Xi,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,xr)),d_mul(Xr,d_mul(xi,d_mul(xr,xr)))))),d_mul(xi,d_mul(xr,d_mul(xr,xr)))))))))),d_add(d_imul(-4,d_mul(d_abs(d_add(Xr,xr)),d_mul(xr,d_diffabs(d_mul(Xi,d_mul(d_mul(Xi,Xi),Xr)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),xr)),d_add(d_mul(Xr,d_mul(xi,d_mul(xi,xi))),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),d_mul(xi,d_add(Xr,xr))),d_mul(Xi,d_mul(d_mul(xi,xi),d_add(Xr,xr))))),d_mul(xi,d_mul(d_mul(xi,xi),xr))))))))),d_add(d_imul(4,d_mul(d_abs(d_mul(Xi,d_mul(Xr,d_mul(Xr,Xr)))),d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_imul(-4,d_add(d_mul(d_abs(d_mul(Xi,d_mul(d_mul(Xi,Xi),Xr))),d_mul(xr,d_abs(d_add(Xr,xr)))),d_mul(d_abs(d_mul(Xi,d_mul(Xr,d_mul(Xr,Xr)))),d_mul(xi,d_abs(d_add(Xi,xi)))))),d_add(d_imul(4,d_mul(d_abs(d_mul(Xi,d_mul(d_mul(Xi,Xi),Xr))),d_mul(xi,d_abs(d_add(Xi,xi))))),d_add(d_imul(-4,d_mul(d_abs(d_add(Xi,xi)),d_mul(xi,d_diffabs(d_mul(Xi,d_mul(Xr,d_mul(Xr,Xr))),d_add(d_mul(Xi,d_mul(xr,d_mul(xr,xr))),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),xi)),d_add(d_imul(3,d_add(d_mul(Xi,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,xr)),d_mul(Xr,d_mul(xi,d_mul(xr,xr)))))),d_mul(xi,d_mul(xr,d_mul(xr,xr)))))))))),d_add(d_imul(4,d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(xi,d_diffabs(d_mul(Xi,d_mul(d_mul(Xi,Xi),Xr)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),xr)),d_add(d_mul(Xr,d_mul(xi,d_mul(xi,xi))),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),d_mul(xi,d_add(Xr,xr))),d_mul(Xi,d_mul(d_mul(xi,xi),d_add(Xr,xr))))),d_mul(xi,d_mul(d_mul(xi,xi),xr)))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_diffabs(d_mul(Xi,d_mul(Xr,d_mul(Xr,Xr))),d_add(d_mul(Xi,d_mul(xr,d_mul(xr,xr))),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),xi)),d_add(d_imul(3,d_add(d_mul(Xi,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,xr)),d_mul(Xr,d_mul(xi,d_mul(xr,xr)))))),d_mul(xi,d_mul(xr,d_mul(xr,xr))))))))))),d_add(d_imul(-4,d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_diffabs(d_mul(Xi,d_mul(d_mul(Xi,Xi),Xr)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),xr)),d_add(d_mul(Xr,d_mul(xi,d_mul(xi,xi))),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),d_mul(xi,d_add(Xr,xr))),d_mul(Xi,d_mul(d_mul(xi,xi),d_add(Xr,xr))))),d_mul(xi,d_mul(d_mul(xi,xi),xr))))))))),d_add(d_imul(4,d_mul(d_abs(d_mul(Xi,d_mul(Xr,d_mul(Xr,Xr)))),d_mul(Xr,d_diffabs(Xr,xr)))),d_add(d_imul(-4,d_add(d_mul(d_abs(d_mul(Xi,d_mul(d_mul(Xi,Xi),Xr))),d_mul(Xr,d_diffabs(Xr,xr))),d_mul(d_abs(d_mul(Xi,d_mul(Xr,d_mul(Xr,Xr)))),d_mul(Xi,d_diffabs(Xi,xi))))),d_add(d_imul(4,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_diffabs(d_mul(Xi,d_mul(d_mul(Xi,Xi),Xr)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),xr)),d_add(d_mul(Xr,d_mul(xi,d_mul(xi,xi))),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),d_mul(xi,d_add(Xr,xr))),d_mul(Xi,d_mul(d_mul(xi,xi),d_add(Xr,xr))))),d_mul(xi,d_mul(d_mul(xi,xi),xr))))))))),d_add(d_imul(-4,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_diffabs(d_mul(Xi,d_mul(Xr,d_mul(Xr,Xr))),d_add(d_mul(Xi,d_mul(xr,d_mul(xr,xr))),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),xi)),d_add(d_imul(3,d_add(d_mul(Xi,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,xr)),d_mul(Xr,d_mul(xi,d_mul(xr,xr)))))),d_mul(xi,d_mul(xr,d_mul(xr,xr)))))))))),d_add(d_imul(4,d_mul(d_abs(d_mul(Xi,d_mul(d_mul(Xi,Xi),Xr))),d_mul(Xi,d_diffabs(Xi,xi)))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),d_mul(Xr,Xr))),d_add(d_mul(Xi,d_diffabs(Xr,xr)),d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_diffabs(d_mul(d_mul(Xi,Xi),d_mul(Xr,Xr)),d_add(d_mul(d_mul(Xi,Xi),d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,xi)),d_add(d_imul(2,d_add(d_mul(d_mul(Xi,Xi),d_mul(Xr,xr)),d_add(d_mul(Xi,d_mul(xi,d_add(d_mul(Xr,Xr),d_mul(xr,xr)))),d_mul(Xr,d_mul(d_mul(xi,xi),xr))))),d_add(d_imul(4,d_mul(Xi,d_mul(Xr,d_mul(xi,xr)))),d_mul(d_mul(xi,xi),d_mul(xr,xr))))))),d_add(Xr,xr))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_diffabs(d_mul(d_mul(Xi,Xi),d_mul(Xr,Xr)),d_add(d_mul(d_mul(Xi,Xi),d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,xi)),d_add(d_imul(2,d_add(d_mul(d_mul(Xi,Xi),d_mul(Xr,xr)),d_add(d_mul(Xi,d_mul(xi,d_add(d_mul(Xr,Xr),d_mul(xr,xr)))),d_mul(Xr,d_mul(d_mul(xi,xi),xr))))),d_add(d_imul(4,d_mul(Xi,d_mul(Xr,d_mul(xi,xr)))),d_mul(d_mul(xi,xi),d_mul(xr,xr))))))),d_add(Xi,xi)))))),d_mul(d_abs(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr))),d_mul(xr,d_abs(d_add(Xi,xi)))))))))))))))))))))));
}

);

static const char *perturbation_opencl_floatexp_64_6_0 = STR(

{xrn=fe_add(cr,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi))),fe_add(fe_mul(Xr,fe_diffabs(Xr,xr)),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr))),fe_mul(Xr,fe_diffabs(Xr,xr))),fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_add(fe_diffabs(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi)),fe_add(fe_imul(4,fe_mul(Xi,fe_mul(xi,fe_add(fe_mul(Xi,Xi),fe_mul(xi,xi))))),fe_add(fe_imul(6,fe_mul(fe_mul(Xi,Xi),fe_mul(xi,xi))),fe_mul(fe_mul(xi,xi),fe_mul(xi,xi))))),fe_diffabs(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr)),fe_add(fe_imul(4,fe_mul(Xr,fe_mul(xr,fe_add(fe_mul(Xr,Xr),fe_mul(xr,xr))))),fe_add(fe_imul(6,fe_mul(fe_mul(Xr,Xr),fe_mul(xr,xr))),fe_mul(fe_mul(xr,xr),fe_mul(xr,xr)))))),fe_add(Xr,xr))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_add(fe_diffabs(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi)),fe_add(fe_imul(4,fe_mul(Xi,fe_mul(xi,fe_add(fe_mul(Xi,Xi),fe_mul(xi,xi))))),fe_add(fe_imul(6,fe_mul(fe_mul(Xi,Xi),fe_mul(xi,xi))),fe_mul(fe_mul(xi,xi),fe_mul(xi,xi))))),fe_diffabs(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr)),fe_add(fe_imul(4,fe_mul(Xr,fe_mul(xr,fe_add(fe_mul(Xr,Xr),fe_mul(xr,xr))))),fe_add(fe_imul(6,fe_mul(fe_mul(Xr,Xr),fe_mul(xr,xr))),fe_mul(fe_mul(xr,xr),fe_mul(xr,xr)))))))),fe_mul(fe_add(fe_mul(Xi,fe_diffabs(Xi,xi)),fe_mul(xi,fe_abs(fe_add(Xi,xi)))),fe_add(fe_abs(fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi)),fe_add(fe_imul(4,fe_mul(Xi,fe_mul(xi,fe_add(fe_mul(Xi,Xi),fe_mul(xi,xi))))),fe_add(fe_imul(6,fe_mul(fe_mul(Xi,Xi),fe_mul(xi,xi))),fe_mul(fe_mul(xi,xi),fe_mul(xi,xi)))))),fe_abs(fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr)),fe_add(fe_imul(4,fe_mul(Xr,fe_mul(xr,fe_add(fe_mul(Xr,Xr),fe_mul(xr,xr))))),fe_add(fe_imul(6,fe_mul(fe_mul(Xr,Xr),fe_mul(xr,xr))),fe_mul(fe_mul(xr,xr),fe_mul(xr,xr)))))))))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,fe_mul(Xr,Xr)))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),Xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xr,fe_diffabs(fe_mul(Xi,fe_mul(Xr,fe_mul(Xr,Xr))),fe_add(fe_mul(Xi,fe_mul(xr,fe_mul(xr,xr))),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),xi)),fe_add(fe_imul(3,fe_add(fe_mul(Xi,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,xr)),fe_mul(Xr,fe_mul(xi,fe_mul(xr,xr)))))),fe_mul(xi,fe_mul(xr,fe_mul(xr,xr)))))))))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xr,fe_diffabs(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),Xr)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),xr)),fe_add(fe_mul(Xr,fe_mul(xi,fe_mul(xi,xi))),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_add(Xr,xr))),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_add(Xr,xr))))),fe_mul(xi,fe_mul(fe_mul(xi,xi),xr))))))))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xi,fe_diffabs(fe_mul(Xi,fe_mul(Xr,fe_mul(Xr,Xr))),fe_add(fe_mul(Xi,fe_mul(xr,fe_mul(xr,xr))),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),xi)),fe_add(fe_imul(3,fe_add(fe_mul(Xi,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,xr)),fe_mul(Xr,fe_mul(xi,fe_mul(xr,xr)))))),fe_mul(xi,fe_mul(xr,fe_mul(xr,xr)))))))))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xi,fe_diffabs(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),Xr)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),xr)),fe_add(fe_mul(Xr,fe_mul(xi,fe_mul(xi,xi))),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_add(Xr,xr))),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_add(Xr,xr))))),fe_mul(xi,fe_mul(fe_mul(xi,xi),xr))))))))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,fe_mul(Xr,Xr)))),fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),Xr))),fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,fe_mul(Xr,Xr)))),fe_mul(Xr,fe_diffabs(Xi,xi)))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),Xr))),fe_mul(Xr,fe_diffabs(Xi,xi)))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_diffabs(fe_mul(Xi,fe_mul(Xr,fe_mul(Xr,Xr))),fe_add(fe_mul(Xi,fe_mul(xr,fe_mul(xr,xr))),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),xi)),fe_add(fe_imul(3,fe_add(fe_mul(Xi,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,xr)),fe_mul(Xr,fe_mul(xi,fe_mul(xr,xr)))))),fe_mul(xi,fe_mul(xr,fe_mul(xr,xr)))))))))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_diffabs(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),Xr)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),xr)),fe_add(fe_mul(Xr,fe_mul(xi,fe_mul(xi,xi))),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_add(Xr,xr))),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_add(Xr,xr))))),fe_mul(xi,fe_mul(fe_mul(xi,xi),xr))))))))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_diffabs(fe_mul(Xi,fe_mul(Xr,fe_mul(Xr,Xr))),fe_add(fe_mul(Xi,fe_mul(xr,fe_mul(xr,xr))),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),xi)),fe_add(fe_imul(3,fe_add(fe_mul(Xi,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,xr)),fe_mul(Xr,fe_mul(xi,fe_mul(xr,xr)))))),fe_mul(xi,fe_mul(xr,fe_mul(xr,xr)))))))))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_diffabs(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),Xr)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),xr)),fe_add(fe_mul(Xr,fe_mul(xi,fe_mul(xi,xi))),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_add(Xr,xr))),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_add(Xr,xr))))),fe_mul(xi,fe_mul(fe_mul(xi,xi),xr))))))))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,fe_mul(Xr,Xr)))),fe_mul(Xi,fe_diffabs(Xr,xr)))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),Xr))),fe_mul(Xi,fe_diffabs(Xr,xr)))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,Xr))),fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xr,fe_diffabs(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,Xr)),fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,xi)),fe_add(fe_imul(2,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,xr)),fe_add(fe_mul(Xi,fe_mul(xi,fe_add(fe_mul(Xr,Xr),fe_mul(xr,xr)))),fe_mul(Xr,fe_mul(fe_mul(xi,xi),xr))))),fe_add(fe_imul(4,fe_mul(Xi,fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(fe_mul(xi,xi),fe_mul(xr,xr))))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,Xr))),fe_mul(xi,fe_abs(fe_add(Xi,xi)))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xi,fe_diffabs(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,Xr)),fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,xi)),fe_add(fe_imul(2,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,xr)),fe_add(fe_mul(Xi,fe_mul(xi,fe_add(fe_mul(Xr,Xr),fe_mul(xr,xr)))),fe_mul(Xr,fe_mul(fe_mul(xi,xi),xr))))),fe_add(fe_imul(4,fe_mul(Xi,fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(fe_mul(xi,xi),fe_mul(xr,xr))))))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,Xr))),fe_mul(Xr,fe_diffabs(Xr,xr))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_diffabs(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,Xr)),fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,xi)),fe_add(fe_imul(2,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,xr)),fe_add(fe_mul(Xi,fe_mul(xi,fe_add(fe_mul(Xr,Xr),fe_mul(xr,xr)))),fe_mul(Xr,fe_mul(fe_mul(xi,xi),xr))))),fe_add(fe_imul(4,fe_mul(Xi,fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(fe_mul(xi,xi),fe_mul(xr,xr))))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,Xr))),fe_mul(Xi,fe_diffabs(Xi,xi))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_diffabs(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,Xr)),fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,xi)),fe_add(fe_imul(2,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,xr)),fe_add(fe_mul(Xi,fe_mul(xi,fe_add(fe_mul(Xr,Xr),fe_mul(xr,xr)))),fe_mul(Xr,fe_mul(fe_mul(xi,xi),xr))))),fe_add(fe_imul(4,fe_mul(Xi,fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(fe_mul(xi,xi),fe_mul(xr,xr))))))))))),fe_mul(fe_abs(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr))),fe_mul(xr,fe_abs(fe_add(Xr,xr)))))))))))))))))))))))))))));
xin=fe_add(ci,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi))),fe_add(fe_mul(Xi,fe_diffabs(Xr,xr)),fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr))),fe_add(fe_mul(Xi,fe_diffabs(Xr,xr)),fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_mul(xi,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_add(fe_diffabs(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi)),fe_add(fe_imul(4,fe_mul(Xi,fe_mul(xi,fe_add(fe_mul(Xi,Xi),fe_mul(xi,xi))))),fe_add(fe_imul(6,fe_mul(fe_mul(Xi,Xi),fe_mul(xi,xi))),fe_mul(fe_mul(xi,xi),fe_mul(xi,xi))))),fe_diffabs(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr)),fe_add(fe_imul(4,fe_mul(Xr,fe_mul(xr,fe_add(fe_mul(Xr,Xr),fe_mul(xr,xr))))),fe_add(fe_imul(6,fe_mul(fe_mul(Xr,Xr),fe_mul(xr,xr))),fe_mul(fe_mul(xr,xr),fe_mul(xr,xr)))))),fe_add(Xr,xr))),fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_add(fe_diffabs(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi)),fe_add(fe_imul(4,fe_mul(Xi,fe_mul(xi,fe_add(fe_mul(Xi,Xi),fe_mul(xi,xi))))),fe_add(fe_imul(6,fe_mul(fe_mul(Xi,Xi),fe_mul(xi,xi))),fe_mul(fe_mul(xi,xi),fe_mul(xi,xi))))),fe_diffabs(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr)),fe_add(fe_imul(4,fe_mul(Xr,fe_mul(xr,fe_add(fe_mul(Xr,Xr),fe_mul(xr,xr))))),fe_add(fe_imul(6,fe_mul(fe_mul(Xr,Xr),fe_mul(xr,xr))),fe_mul(fe_mul(xr,xr),fe_mul(xr,xr)))))),fe_add(Xi,xi))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xr,fe_diffabs(fe_mul(Xi,fe_mul(Xr,fe_mul(Xr,Xr))),fe_add(fe_mul(Xi,fe_mul(xr,fe_mul(xr,xr))),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),xi)),fe_add(fe_imul(3,fe_add(fe_mul(Xi,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,xr)),fe_mul(Xr,fe_mul(xi,fe_mul(xr,xr)))))),fe_mul(xi,fe_mul(xr,fe_mul(xr,xr)))))))))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xr,fe_diffabs(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),Xr)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),xr)),fe_add(fe_mul(Xr,fe_mul(xi,fe_mul(xi,xi))),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_add(Xr,xr))),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_add(Xr,xr))))),fe_mul(xi,fe_mul(fe_mul(xi,xi),xr))))))))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,fe_mul(Xr,Xr)))),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),Xr))),fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,fe_mul(Xr,Xr)))),fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),Xr))),fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xi,fe_diffabs(fe_mul(Xi,fe_mul(Xr,fe_mul(Xr,Xr))),fe_add(fe_mul(Xi,fe_mul(xr,fe_mul(xr,xr))),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),xi)),fe_add(fe_imul(3,fe_add(fe_mul(Xi,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,xr)),fe_mul(Xr,fe_mul(xi,fe_mul(xr,xr)))))),fe_mul(xi,fe_mul(xr,fe_mul(xr,xr)))))))))),fe_add(fe_imul(4,fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xi,fe_diffabs(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),Xr)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),xr)),fe_add(fe_mul(Xr,fe_mul(xi,fe_mul(xi,xi))),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_add(Xr,xr))),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_add(Xr,xr))))),fe_mul(xi,fe_mul(fe_mul(xi,xi),xr)))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_diffabs(fe_mul(Xi,fe_mul(Xr,fe_mul(Xr,Xr))),fe_add(fe_mul(Xi,fe_mul(xr,fe_mul(xr,xr))),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),xi)),fe_add(fe_imul(3,fe_add(fe_mul(Xi,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,xr)),fe_mul(Xr,fe_mul(xi,fe_mul(xr,xr)))))),fe_mul(xi,fe_mul(xr,fe_mul(xr,xr))))))))))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_diffabs(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),Xr)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),xr)),fe_add(fe_mul(Xr,fe_mul(xi,fe_mul(xi,xi))),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_add(Xr,xr))),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_add(Xr,xr))))),fe_mul(xi,fe_mul(fe_mul(xi,xi),xr))))))))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,fe_mul(Xr,Xr)))),fe_mul(Xr,fe_diffabs(Xr,xr)))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),Xr))),fe_mul(Xr,fe_diffabs(Xr,xr))),fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,fe_mul(Xr,Xr)))),fe_mul(Xi,fe_diffabs(Xi,xi))))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_diffabs(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),Xr)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),xr)),fe_add(fe_mul(Xr,fe_mul(xi,fe_mul(xi,xi))),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_add(Xr,xr))),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_add(Xr,xr))))),fe_mul(xi,fe_mul(fe_mul(xi,xi),xr))))))))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_diffabs(fe_mul(Xi,fe_mul(Xr,fe_mul(Xr,Xr))),fe_add(fe_mul(Xi,fe_mul(xr,fe_mul(xr,xr))),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),xi)),fe_add(fe_imul(3,fe_add(fe_mul(Xi,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,xr)),fe_mul(Xr,fe_mul(xi,fe_mul(xr,xr)))))),fe_mul(xi,fe_mul(xr,fe_mul(xr,xr)))))))))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),Xr))),fe_mul(Xi,fe_diffabs(Xi,xi)))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,Xr))),fe_add(fe_mul(Xi,fe_diffabs(Xr,xr)),fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_diffabs(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,Xr)),fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,xi)),fe_add(fe_imul(2,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,xr)),fe_add(fe_mul(Xi,fe_mul(xi,fe_add(fe_mul(Xr,Xr),fe_mul(xr,xr)))),fe_mul(Xr,fe_mul(fe_mul(xi,xi),xr))))),fe_add(fe_imul(4,fe_mul(Xi,fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(fe_mul(xi,xi),fe_mul(xr,xr))))))),fe_add(Xr,xr))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_diffabs(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,Xr)),fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,xi)),fe_add(fe_imul(2,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,xr)),fe_add(fe_mul(Xi,fe_mul(xi,fe_add(fe_mul(Xr,Xr),fe_mul(xr,xr)))),fe_mul(Xr,fe_mul(fe_mul(xi,xi),xr))))),fe_add(fe_imul(4,fe_mul(Xi,fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(fe_mul(xi,xi),fe_mul(xr,xr))))))),fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))))))))))))))))))));
}

);

static const char *perturbation_opencl_floatexp_64_6_1 = STR(

{dxan=fe_add(daa,fe_add(fe_mul(fe_mul(dxa,fe_abs(Xxr)),fe_add(fe_abs(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi))),fe_abs(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr))))),fe_add(fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(dxa,fe_add(fe_abs(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi))),fe_abs(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr))))))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi))),fe_mul(dya,fe_abs(Xxi))),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(dya,fe_add(fe_abs(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi))),fe_abs(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr)))),fe_mul(dya,fe_abs(Xxr)))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),Xxr))),fe_mul(dya,fe_abs(Xxr)))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr)))),fe_mul(dxa,fe_abs(Xxi)))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),Xxr))),fe_mul(dxa,fe_abs(Xxi)))),fe_add(fe_imul(-4,fe_mul(fe_sgn(Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(4,fe_mul(fe_sgn(Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),Xxr))))))),fe_add(fe_imul(-4,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dya,fe_abs(Xxi))))))),fe_add(fe_imul(4,fe_mul(fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_sgn(Xxr),fe_sgn(Xxr))),fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dxa,fe_abs(Xxr))))),fe_add(fe_imul(-4,fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(dxa,fe_abs(fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(4,fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(dxa,fe_abs(fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),Xxr))))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxr)))))))),fe_mul(fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_sgn(Xxr),fe_sgn(Xxr))),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxi)))))))),fe_add(fe_imul(4,fe_add(fe_mul(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxi),fe_sgn(Xxi))),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxr)))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_add(fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(dxa,fe_abs(Xxr))),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxi))))))))))),fe_add(fe_imul(-4,fe_mul(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxi),fe_sgn(Xxi))),fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(dya,fe_abs(Xxi))))),fe_add(fe_imul(6,fe_mul(fe_abs(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,Xxr))),fe_mul(dya,fe_abs(Xxi)))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,Xxr))),fe_mul(dxa,fe_abs(Xxr))),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(dxa,fe_abs(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(6,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(dya,fe_abs(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,Xxr))))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxr))))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxi)))))))))),fe_add(fe_imul(12,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxi))))))),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxi)))))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr)))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr))))))))),fe_add(fe_imul(12,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxr)))))))),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxi))))))))),fe_imul(-1,fe_mul(fe_abs(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr))),fe_mul(dya,fe_abs(Xxi))))))))))))))))))))))))))));
dxbn=fe_add(dab,fe_add(fe_mul(fe_mul(dxb,fe_abs(Xxr)),fe_add(fe_abs(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi))),fe_abs(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr))))),fe_add(fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(dxb,fe_add(fe_abs(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi))),fe_abs(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr))))))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi))),fe_mul(dyb,fe_abs(Xxi))),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(dyb,fe_add(fe_abs(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi))),fe_abs(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr)))),fe_mul(dyb,fe_abs(Xxr)))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),Xxr))),fe_mul(dyb,fe_abs(Xxr)))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr)))),fe_mul(dxb,fe_abs(Xxi)))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),Xxr))),fe_mul(dxb,fe_abs(Xxi)))),fe_add(fe_imul(-4,fe_mul(fe_sgn(Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(4,fe_mul(fe_sgn(Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),Xxr))))))),fe_add(fe_imul(-4,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dyb,fe_abs(Xxi))))))),fe_add(fe_imul(4,fe_mul(fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_sgn(Xxr),fe_sgn(Xxr))),fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dxb,fe_abs(Xxr))))),fe_add(fe_imul(-4,fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(dxb,fe_abs(fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(4,fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(dxb,fe_abs(fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),Xxr))))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxr)))))))),fe_mul(fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_sgn(Xxr),fe_sgn(Xxr))),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxi)))))))),fe_add(fe_imul(4,fe_add(fe_mul(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxi),fe_sgn(Xxi))),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxr)))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_add(fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(dxb,fe_abs(Xxr))),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxi))))))))))),fe_add(fe_imul(-4,fe_mul(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxi),fe_sgn(Xxi))),fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(dyb,fe_abs(Xxi))))),fe_add(fe_imul(6,fe_mul(fe_abs(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,Xxr))),fe_mul(dyb,fe_abs(Xxi)))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,Xxr))),fe_mul(dxb,fe_abs(Xxr))),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(dxb,fe_abs(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(6,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(dyb,fe_abs(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,Xxr))))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxr))))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxi)))))))))),fe_add(fe_imul(12,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxi))))))),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxi)))))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr)))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr))))))))),fe_add(fe_imul(12,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxr)))))))),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxi))))))))),fe_imul(-1,fe_mul(fe_abs(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr))),fe_mul(dyb,fe_abs(Xxi))))))))))))))))))))))))))));
dyan=fe_add(dba,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi))),fe_add(fe_mul(dxa,fe_abs(Xxi)),fe_mul(dya,fe_abs(Xxr)))),fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr))),fe_mul(dxa,fe_abs(Xxi))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxr,fe_mul(dya,fe_add(fe_abs(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi))),fe_abs(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr))))))),fe_add(fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(dxa,fe_add(fe_abs(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi))),fe_abs(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr))))))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr)))),fe_mul(dya,fe_abs(Xxi)))),fe_add(fe_imul(4,fe_add(fe_mul(fe_abs(fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),Xxr))),fe_mul(dya,fe_abs(Xxi))),fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr)))),fe_mul(dxa,fe_abs(Xxr))))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),Xxr))),fe_mul(dxa,fe_abs(Xxr)))),fe_add(fe_imul(4,fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(dxa,fe_abs(fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(-4,fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(dxa,fe_abs(fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),Xxr))))))),fe_add(fe_imul(4,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dya,fe_abs(Xxr)))))),fe_mul(fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_sgn(Xxr),fe_sgn(Xxr))),fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dxa,fe_abs(Xxi)))))),fe_add(fe_imul(-4,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(dya,fe_abs(fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(4,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(dya,fe_abs(fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),Xxr))))))),fe_add(fe_imul(-4,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxi))))))))),fe_add(fe_imul(4,fe_add(fe_mul(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxi),fe_sgn(Xxi))),fe_add(fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(dya,fe_abs(Xxr))),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxi))))))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(dxa,fe_abs(Xxi)))))),fe_mul(fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_sgn(Xxr),fe_sgn(Xxr))),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr))))))))),fe_add(fe_imul(-4,fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxr))))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,Xxr))),fe_add(fe_mul(dxa,fe_abs(Xxi)),fe_mul(dya,fe_abs(Xxr)))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,Xxr)))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(dxa,fe_abs(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(-12,fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxi)))))))),fe_add(fe_imul(12,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr))))))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxr))))))),fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_add(fe_mul(dxa,fe_abs(Xxi)),fe_mul(dya,fe_abs(Xxr))))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxi)))))))))),fe_add(fe_imul(12,fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxi))))))))),fe_add(fe_imul(-12,fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxr)))))))),fe_mul(fe_abs(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr))),fe_mul(dya,fe_abs(Xxr)))))))))))))))))))))))));
dybn=fe_add(dbb,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi))),fe_add(fe_mul(dxb,fe_abs(Xxi)),fe_mul(dyb,fe_abs(Xxr)))),fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr))),fe_mul(dxb,fe_abs(Xxi))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxr,fe_mul(dyb,fe_add(fe_abs(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi))),fe_abs(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr))))))),fe_add(fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(dxb,fe_add(fe_abs(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi))),fe_abs(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr))))))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr)))),fe_mul(dyb,fe_abs(Xxi)))),fe_add(fe_imul(4,fe_add(fe_mul(fe_abs(fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),Xxr))),fe_mul(dyb,fe_abs(Xxi))),fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr)))),fe_mul(dxb,fe_abs(Xxr))))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),Xxr))),fe_mul(dxb,fe_abs(Xxr)))),fe_add(fe_imul(4,fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(dxb,fe_abs(fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(-4,fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(dxb,fe_abs(fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),Xxr))))))),fe_add(fe_imul(4,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dyb,fe_abs(Xxr)))))),fe_mul(fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_sgn(Xxr),fe_sgn(Xxr))),fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dxb,fe_abs(Xxi)))))),fe_add(fe_imul(-4,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(dyb,fe_abs(fe_mul(Xxi,fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(4,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(dyb,fe_abs(fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),Xxr))))))),fe_add(fe_imul(-4,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxi))))))))),fe_add(fe_imul(4,fe_add(fe_mul(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxi),fe_sgn(Xxi))),fe_add(fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(dyb,fe_abs(Xxr))),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxi))))))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(dxb,fe_abs(Xxi)))))),fe_mul(fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_sgn(Xxr),fe_sgn(Xxr))),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr))))))))),fe_add(fe_imul(-4,fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxr))))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,Xxr))),fe_add(fe_mul(dxb,fe_abs(Xxi)),fe_mul(dyb,fe_abs(Xxr)))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,Xxr)))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(dxb,fe_abs(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,Xxr))))))))),fe_add(fe_imul(-12,fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxi)))))))),fe_add(fe_imul(12,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr))))))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxr))))))),fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_add(fe_mul(dxb,fe_abs(Xxi)),fe_mul(dyb,fe_abs(Xxr))))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxi)))))))))),fe_add(fe_imul(12,fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxi))))))))),fe_add(fe_imul(-12,fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxr)))))))),fe_mul(fe_abs(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr))),fe_mul(dyb,fe_abs(Xxr)))))))))))))))))))))))));
}

{xrn=fe_add(cr,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi))),fe_add(fe_mul(Xr,fe_diffabs(Xr,xr)),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr))),fe_mul(Xr,fe_diffabs(Xr,xr))),fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_add(fe_diffabs(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi)),fe_add(fe_imul(4,fe_mul(Xi,fe_mul(xi,fe_add(fe_mul(Xi,Xi),fe_mul(xi,xi))))),fe_add(fe_imul(6,fe_mul(fe_mul(Xi,Xi),fe_mul(xi,xi))),fe_mul(fe_mul(xi,xi),fe_mul(xi,xi))))),fe_diffabs(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr)),fe_add(fe_imul(4,fe_mul(Xr,fe_mul(xr,fe_add(fe_mul(Xr,Xr),fe_mul(xr,xr))))),fe_add(fe_imul(6,fe_mul(fe_mul(Xr,Xr),fe_mul(xr,xr))),fe_mul(fe_mul(xr,xr),fe_mul(xr,xr)))))),fe_add(Xr,xr))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_add(fe_diffabs(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi)),fe_add(fe_imul(4,fe_mul(Xi,fe_mul(xi,fe_add(fe_mul(Xi,Xi),fe_mul(xi,xi))))),fe_add(fe_imul(6,fe_mul(fe_mul(Xi,Xi),fe_mul(xi,xi))),fe_mul(fe_mul(xi,xi),fe_mul(xi,xi))))),fe_diffabs(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr)),fe_add(fe_imul(4,fe_mul(Xr,fe_mul(xr,fe_add(fe_mul(Xr,Xr),fe_mul(xr,xr))))),fe_add(fe_imul(6,fe_mul(fe_mul(Xr,Xr),fe_mul(xr,xr))),fe_mul(fe_mul(xr,xr),fe_mul(xr,xr)))))))),fe_mul(fe_add(fe_mul(Xi,fe_diffabs(Xi,xi)),fe_mul(xi,fe_abs(fe_add(Xi,xi)))),fe_add(fe_abs(fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi)),fe_add(fe_imul(4,fe_mul(Xi,fe_mul(xi,fe_add(fe_mul(Xi,Xi),fe_mul(xi,xi))))),fe_add(fe_imul(6,fe_mul(fe_mul(Xi,Xi),fe_mul(xi,xi))),fe_mul(fe_mul(xi,xi),fe_mul(xi,xi)))))),fe_abs(fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr)),fe_add(fe_imul(4,fe_mul(Xr,fe_mul(xr,fe_add(fe_mul(Xr,Xr),fe_mul(xr,xr))))),fe_add(fe_imul(6,fe_mul(fe_mul(Xr,Xr),fe_mul(xr,xr))),fe_mul(fe_mul(xr,xr),fe_mul(xr,xr)))))))))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,fe_mul(Xr,Xr)))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),Xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xr,fe_diffabs(fe_mul(Xi,fe_mul(Xr,fe_mul(Xr,Xr))),fe_add(fe_mul(Xi,fe_mul(xr,fe_mul(xr,xr))),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),xi)),fe_add(fe_imul(3,fe_add(fe_mul(Xi,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,xr)),fe_mul(Xr,fe_mul(xi,fe_mul(xr,xr)))))),fe_mul(xi,fe_mul(xr,fe_mul(xr,xr)))))))))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xr,fe_diffabs(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),Xr)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),xr)),fe_add(fe_mul(Xr,fe_mul(xi,fe_mul(xi,xi))),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_add(Xr,xr))),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_add(Xr,xr))))),fe_mul(xi,fe_mul(fe_mul(xi,xi),xr))))))))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xi,fe_diffabs(fe_mul(Xi,fe_mul(Xr,fe_mul(Xr,Xr))),fe_add(fe_mul(Xi,fe_mul(xr,fe_mul(xr,xr))),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),xi)),fe_add(fe_imul(3,fe_add(fe_mul(Xi,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,xr)),fe_mul(Xr,fe_mul(xi,fe_mul(xr,xr)))))),fe_mul(xi,fe_mul(xr,fe_mul(xr,xr)))))))))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xi,fe_diffabs(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),Xr)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),xr)),fe_add(fe_mul(Xr,fe_mul(xi,fe_mul(xi,xi))),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_add(Xr,xr))),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_add(Xr,xr))))),fe_mul(xi,fe_mul(fe_mul(xi,xi),xr))))))))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,fe_mul(Xr,Xr)))),fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),Xr))),fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,fe_mul(Xr,Xr)))),fe_mul(Xr,fe_diffabs(Xi,xi)))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),Xr))),fe_mul(Xr,fe_diffabs(Xi,xi)))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_diffabs(fe_mul(Xi,fe_mul(Xr,fe_mul(Xr,Xr))),fe_add(fe_mul(Xi,fe_mul(xr,fe_mul(xr,xr))),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),xi)),fe_add(fe_imul(3,fe_add(fe_mul(Xi,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,xr)),fe_mul(Xr,fe_mul(xi,fe_mul(xr,xr)))))),fe_mul(xi,fe_mul(xr,fe_mul(xr,xr)))))))))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_diffabs(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),Xr)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),xr)),fe_add(fe_mul(Xr,fe_mul(xi,fe_mul(xi,xi))),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_add(Xr,xr))),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_add(Xr,xr))))),fe_mul(xi,fe_mul(fe_mul(xi,xi),xr))))))))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_diffabs(fe_mul(Xi,fe_mul(Xr,fe_mul(Xr,Xr))),fe_add(fe_mul(Xi,fe_mul(xr,fe_mul(xr,xr))),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),xi)),fe_add(fe_imul(3,fe_add(fe_mul(Xi,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,xr)),fe_mul(Xr,fe_mul(xi,fe_mul(xr,xr)))))),fe_mul(xi,fe_mul(xr,fe_mul(xr,xr)))))))))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_diffabs(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),Xr)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),xr)),fe_add(fe_mul(Xr,fe_mul(xi,fe_mul(xi,xi))),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_add(Xr,xr))),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_add(Xr,xr))))),fe_mul(xi,fe_mul(fe_mul(xi,xi),xr))))))))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,fe_mul(Xr,Xr)))),fe_mul(Xi,fe_diffabs(Xr,xr)))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),Xr))),fe_mul(Xi,fe_diffabs(Xr,xr)))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,Xr))),fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xr,fe_diffabs(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,Xr)),fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,xi)),fe_add(fe_imul(2,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,xr)),fe_add(fe_mul(Xi,fe_mul(xi,fe_add(fe_mul(Xr,Xr),fe_mul(xr,xr)))),fe_mul(Xr,fe_mul(fe_mul(xi,xi),xr))))),fe_add(fe_imul(4,fe_mul(Xi,fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(fe_mul(xi,xi),fe_mul(xr,xr))))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,Xr))),fe_mul(xi,fe_abs(fe_add(Xi,xi)))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xi,fe_diffabs(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,Xr)),fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,xi)),fe_add(fe_imul(2,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,xr)),fe_add(fe_mul(Xi,fe_mul(xi,fe_add(fe_mul(Xr,Xr),fe_mul(xr,xr)))),fe_mul(Xr,fe_mul(fe_mul(xi,xi),xr))))),fe_add(fe_imul(4,fe_mul(Xi,fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(fe_mul(xi,xi),fe_mul(xr,xr))))))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,Xr))),fe_mul(Xr,fe_diffabs(Xr,xr))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_diffabs(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,Xr)),fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,xi)),fe_add(fe_imul(2,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,xr)),fe_add(fe_mul(Xi,fe_mul(xi,fe_add(fe_mul(Xr,Xr),fe_mul(xr,xr)))),fe_mul(Xr,fe_mul(fe_mul(xi,xi),xr))))),fe_add(fe_imul(4,fe_mul(Xi,fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(fe_mul(xi,xi),fe_mul(xr,xr))))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,Xr))),fe_mul(Xi,fe_diffabs(Xi,xi))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_diffabs(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,Xr)),fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,xi)),fe_add(fe_imul(2,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,xr)),fe_add(fe_mul(Xi,fe_mul(xi,fe_add(fe_mul(Xr,Xr),fe_mul(xr,xr)))),fe_mul(Xr,fe_mul(fe_mul(xi,xi),xr))))),fe_add(fe_imul(4,fe_mul(Xi,fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(fe_mul(xi,xi),fe_mul(xr,xr))))))))))),fe_mul(fe_abs(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr))),fe_mul(xr,fe_abs(fe_add(Xr,xr)))))))))))))))))))))))))))));
xin=fe_add(ci,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi))),fe_add(fe_mul(Xi,fe_diffabs(Xr,xr)),fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr))),fe_add(fe_mul(Xi,fe_diffabs(Xr,xr)),fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_mul(xi,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_add(fe_diffabs(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi)),fe_add(fe_imul(4,fe_mul(Xi,fe_mul(xi,fe_add(fe_mul(Xi,Xi),fe_mul(xi,xi))))),fe_add(fe_imul(6,fe_mul(fe_mul(Xi,Xi),fe_mul(xi,xi))),fe_mul(fe_mul(xi,xi),fe_mul(xi,xi))))),fe_diffabs(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr)),fe_add(fe_imul(4,fe_mul(Xr,fe_mul(xr,fe_add(fe_mul(Xr,Xr),fe_mul(xr,xr))))),fe_add(fe_imul(6,fe_mul(fe_mul(Xr,Xr),fe_mul(xr,xr))),fe_mul(fe_mul(xr,xr),fe_mul(xr,xr)))))),fe_add(Xr,xr))),fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_add(fe_diffabs(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi)),fe_add(fe_imul(4,fe_mul(Xi,fe_mul(xi,fe_add(fe_mul(Xi,Xi),fe_mul(xi,xi))))),fe_add(fe_imul(6,fe_mul(fe_mul(Xi,Xi),fe_mul(xi,xi))),fe_mul(fe_mul(xi,xi),fe_mul(xi,xi))))),fe_diffabs(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr)),fe_add(fe_imul(4,fe_mul(Xr,fe_mul(xr,fe_add(fe_mul(Xr,Xr),fe_mul(xr,xr))))),fe_add(fe_imul(6,fe_mul(fe_mul(Xr,Xr),fe_mul(xr,xr))),fe_mul(fe_mul(xr,xr),fe_mul(xr,xr)))))),fe_add(Xi,xi))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xr,fe_diffabs(fe_mul(Xi,fe_mul(Xr,fe_mul(Xr,Xr))),fe_add(fe_mul(Xi,fe_mul(xr,fe_mul(xr,xr))),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),xi)),fe_add(fe_imul(3,fe_add(fe_mul(Xi,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,xr)),fe_mul(Xr,fe_mul(xi,fe_mul(xr,xr)))))),fe_mul(xi,fe_mul(xr,fe_mul(xr,xr)))))))))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xr,fe_diffabs(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),Xr)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),xr)),fe_add(fe_mul(Xr,fe_mul(xi,fe_mul(xi,xi))),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_add(Xr,xr))),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_add(Xr,xr))))),fe_mul(xi,fe_mul(fe_mul(xi,xi),xr))))))))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,fe_mul(Xr,Xr)))),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),Xr))),fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,fe_mul(Xr,Xr)))),fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),Xr))),fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xi,fe_diffabs(fe_mul(Xi,fe_mul(Xr,fe_mul(Xr,Xr))),fe_add(fe_mul(Xi,fe_mul(xr,fe_mul(xr,xr))),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),xi)),fe_add(fe_imul(3,fe_add(fe_mul(Xi,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,xr)),fe_mul(Xr,fe_mul(xi,fe_mul(xr,xr)))))),fe_mul(xi,fe_mul(xr,fe_mul(xr,xr)))))))))),fe_add(fe_imul(4,fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xi,fe_diffabs(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),Xr)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),xr)),fe_add(fe_mul(Xr,fe_mul(xi,fe_mul(xi,xi))),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_add(Xr,xr))),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_add(Xr,xr))))),fe_mul(xi,fe_mul(fe_mul(xi,xi),xr)))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_diffabs(fe_mul(Xi,fe_mul(Xr,fe_mul(Xr,Xr))),fe_add(fe_mul(Xi,fe_mul(xr,fe_mul(xr,xr))),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),xi)),fe_add(fe_imul(3,fe_add(fe_mul(Xi,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,xr)),fe_mul(Xr,fe_mul(xi,fe_mul(xr,xr)))))),fe_mul(xi,fe_mul(xr,fe_mul(xr,xr))))))))))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_diffabs(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),Xr)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),xr)),fe_add(fe_mul(Xr,fe_mul(xi,fe_mul(xi,xi))),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_add(Xr,xr))),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_add(Xr,xr))))),fe_mul(xi,fe_mul(fe_mul(xi,xi),xr))))))))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,fe_mul(Xr,Xr)))),fe_mul(Xr,fe_diffabs(Xr,xr)))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),Xr))),fe_mul(Xr,fe_diffabs(Xr,xr))),fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,fe_mul(Xr,Xr)))),fe_mul(Xi,fe_diffabs(Xi,xi))))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_diffabs(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),Xr)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),xr)),fe_add(fe_mul(Xr,fe_mul(xi,fe_mul(xi,xi))),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_add(Xr,xr))),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_add(Xr,xr))))),fe_mul(xi,fe_mul(fe_mul(xi,xi),xr))))))))),fe_add(fe_imul(-4,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_diffabs(fe_mul(Xi,fe_mul(Xr,fe_mul(Xr,Xr))),fe_add(fe_mul(Xi,fe_mul(xr,fe_mul(xr,xr))),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),xi)),fe_add(fe_imul(3,fe_add(fe_mul(Xi,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,xr)),fe_mul(Xr,fe_mul(xi,fe_mul(xr,xr)))))),fe_mul(xi,fe_mul(xr,fe_mul(xr,xr)))))))))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),Xr))),fe_mul(Xi,fe_diffabs(Xi,xi)))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,Xr))),fe_add(fe_mul(Xi,fe_diffabs(Xr,xr)),fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_diffabs(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,Xr)),fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,xi)),fe_add(fe_imul(2,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,xr)),fe_add(fe_mul(Xi,fe_mul(xi,fe_add(fe_mul(Xr,Xr),fe_mul(xr,xr)))),fe_mul(Xr,fe_mul(fe_mul(xi,xi),xr))))),fe_add(fe_imul(4,fe_mul(Xi,fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(fe_mul(xi,xi),fe_mul(xr,xr))))))),fe_add(Xr,xr))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_diffabs(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,Xr)),fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,xi)),fe_add(fe_imul(2,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,xr)),fe_add(fe_mul(Xi,fe_mul(xi,fe_add(fe_mul(Xr,Xr),fe_mul(xr,xr)))),fe_mul(Xr,fe_mul(fe_mul(xi,xi),xr))))),fe_add(fe_imul(4,fe_mul(Xi,fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(fe_mul(xi,xi),fe_mul(xr,xr))))))),fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))))))))))))))))))));
}

);

#if 0
static const char *perturbation_opencl_softfloat_64_6_0 = STR(

{xrn=sf_add(cr,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi))),sf_add(sf_mul(Xr,sf_diffabs(Xr,xr)),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr))),sf_mul(Xr,sf_diffabs(Xr,xr))),sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_add(sf_diffabs(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi)),sf_add(sf_imul(4,sf_mul(Xi,sf_mul(xi,sf_add(sf_mul(Xi,Xi),sf_mul(xi,xi))))),sf_add(sf_imul(6,sf_mul(sf_mul(Xi,Xi),sf_mul(xi,xi))),sf_mul(sf_mul(xi,xi),sf_mul(xi,xi))))),sf_diffabs(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr)),sf_add(sf_imul(4,sf_mul(Xr,sf_mul(xr,sf_add(sf_mul(Xr,Xr),sf_mul(xr,xr))))),sf_add(sf_imul(6,sf_mul(sf_mul(Xr,Xr),sf_mul(xr,xr))),sf_mul(sf_mul(xr,xr),sf_mul(xr,xr)))))),sf_add(Xr,xr))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_add(sf_diffabs(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi)),sf_add(sf_imul(4,sf_mul(Xi,sf_mul(xi,sf_add(sf_mul(Xi,Xi),sf_mul(xi,xi))))),sf_add(sf_imul(6,sf_mul(sf_mul(Xi,Xi),sf_mul(xi,xi))),sf_mul(sf_mul(xi,xi),sf_mul(xi,xi))))),sf_diffabs(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr)),sf_add(sf_imul(4,sf_mul(Xr,sf_mul(xr,sf_add(sf_mul(Xr,Xr),sf_mul(xr,xr))))),sf_add(sf_imul(6,sf_mul(sf_mul(Xr,Xr),sf_mul(xr,xr))),sf_mul(sf_mul(xr,xr),sf_mul(xr,xr)))))))),sf_mul(sf_add(sf_mul(Xi,sf_diffabs(Xi,xi)),sf_mul(xi,sf_abs(sf_add(Xi,xi)))),sf_add(sf_abs(sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi)),sf_add(sf_imul(4,sf_mul(Xi,sf_mul(xi,sf_add(sf_mul(Xi,Xi),sf_mul(xi,xi))))),sf_add(sf_imul(6,sf_mul(sf_mul(Xi,Xi),sf_mul(xi,xi))),sf_mul(sf_mul(xi,xi),sf_mul(xi,xi)))))),sf_abs(sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr)),sf_add(sf_imul(4,sf_mul(Xr,sf_mul(xr,sf_add(sf_mul(Xr,Xr),sf_mul(xr,xr))))),sf_add(sf_imul(6,sf_mul(sf_mul(Xr,Xr),sf_mul(xr,xr))),sf_mul(sf_mul(xr,xr),sf_mul(xr,xr)))))))))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,sf_mul(Xr,Xr)))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),Xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xr,sf_diffabs(sf_mul(Xi,sf_mul(Xr,sf_mul(Xr,Xr))),sf_add(sf_mul(Xi,sf_mul(xr,sf_mul(xr,xr))),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),xi)),sf_add(sf_imul(3,sf_add(sf_mul(Xi,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,xr)),sf_mul(Xr,sf_mul(xi,sf_mul(xr,xr)))))),sf_mul(xi,sf_mul(xr,sf_mul(xr,xr)))))))))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xr,sf_diffabs(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),Xr)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),xr)),sf_add(sf_mul(Xr,sf_mul(xi,sf_mul(xi,xi))),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_add(Xr,xr))),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_add(Xr,xr))))),sf_mul(xi,sf_mul(sf_mul(xi,xi),xr))))))))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xi,sf_diffabs(sf_mul(Xi,sf_mul(Xr,sf_mul(Xr,Xr))),sf_add(sf_mul(Xi,sf_mul(xr,sf_mul(xr,xr))),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),xi)),sf_add(sf_imul(3,sf_add(sf_mul(Xi,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,xr)),sf_mul(Xr,sf_mul(xi,sf_mul(xr,xr)))))),sf_mul(xi,sf_mul(xr,sf_mul(xr,xr)))))))))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xi,sf_diffabs(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),Xr)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),xr)),sf_add(sf_mul(Xr,sf_mul(xi,sf_mul(xi,xi))),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_add(Xr,xr))),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_add(Xr,xr))))),sf_mul(xi,sf_mul(sf_mul(xi,xi),xr))))))))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,sf_mul(Xr,Xr)))),sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),Xr))),sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,sf_mul(Xr,Xr)))),sf_mul(Xr,sf_diffabs(Xi,xi)))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),Xr))),sf_mul(Xr,sf_diffabs(Xi,xi)))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_diffabs(sf_mul(Xi,sf_mul(Xr,sf_mul(Xr,Xr))),sf_add(sf_mul(Xi,sf_mul(xr,sf_mul(xr,xr))),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),xi)),sf_add(sf_imul(3,sf_add(sf_mul(Xi,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,xr)),sf_mul(Xr,sf_mul(xi,sf_mul(xr,xr)))))),sf_mul(xi,sf_mul(xr,sf_mul(xr,xr)))))))))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_diffabs(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),Xr)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),xr)),sf_add(sf_mul(Xr,sf_mul(xi,sf_mul(xi,xi))),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_add(Xr,xr))),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_add(Xr,xr))))),sf_mul(xi,sf_mul(sf_mul(xi,xi),xr))))))))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_diffabs(sf_mul(Xi,sf_mul(Xr,sf_mul(Xr,Xr))),sf_add(sf_mul(Xi,sf_mul(xr,sf_mul(xr,xr))),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),xi)),sf_add(sf_imul(3,sf_add(sf_mul(Xi,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,xr)),sf_mul(Xr,sf_mul(xi,sf_mul(xr,xr)))))),sf_mul(xi,sf_mul(xr,sf_mul(xr,xr)))))))))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_diffabs(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),Xr)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),xr)),sf_add(sf_mul(Xr,sf_mul(xi,sf_mul(xi,xi))),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_add(Xr,xr))),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_add(Xr,xr))))),sf_mul(xi,sf_mul(sf_mul(xi,xi),xr))))))))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,sf_mul(Xr,Xr)))),sf_mul(Xi,sf_diffabs(Xr,xr)))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),Xr))),sf_mul(Xi,sf_diffabs(Xr,xr)))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,Xr))),sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xr,sf_diffabs(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,Xr)),sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,xi)),sf_add(sf_imul(2,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,xr)),sf_add(sf_mul(Xi,sf_mul(xi,sf_add(sf_mul(Xr,Xr),sf_mul(xr,xr)))),sf_mul(Xr,sf_mul(sf_mul(xi,xi),xr))))),sf_add(sf_imul(4,sf_mul(Xi,sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(sf_mul(xi,xi),sf_mul(xr,xr))))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,Xr))),sf_mul(xi,sf_abs(sf_add(Xi,xi)))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xi,sf_diffabs(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,Xr)),sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,xi)),sf_add(sf_imul(2,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,xr)),sf_add(sf_mul(Xi,sf_mul(xi,sf_add(sf_mul(Xr,Xr),sf_mul(xr,xr)))),sf_mul(Xr,sf_mul(sf_mul(xi,xi),xr))))),sf_add(sf_imul(4,sf_mul(Xi,sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(sf_mul(xi,xi),sf_mul(xr,xr))))))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,Xr))),sf_mul(Xr,sf_diffabs(Xr,xr))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_diffabs(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,Xr)),sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,xi)),sf_add(sf_imul(2,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,xr)),sf_add(sf_mul(Xi,sf_mul(xi,sf_add(sf_mul(Xr,Xr),sf_mul(xr,xr)))),sf_mul(Xr,sf_mul(sf_mul(xi,xi),xr))))),sf_add(sf_imul(4,sf_mul(Xi,sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(sf_mul(xi,xi),sf_mul(xr,xr))))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,Xr))),sf_mul(Xi,sf_diffabs(Xi,xi))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_diffabs(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,Xr)),sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,xi)),sf_add(sf_imul(2,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,xr)),sf_add(sf_mul(Xi,sf_mul(xi,sf_add(sf_mul(Xr,Xr),sf_mul(xr,xr)))),sf_mul(Xr,sf_mul(sf_mul(xi,xi),xr))))),sf_add(sf_imul(4,sf_mul(Xi,sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(sf_mul(xi,xi),sf_mul(xr,xr))))))))))),sf_mul(sf_abs(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr))),sf_mul(xr,sf_abs(sf_add(Xr,xr)))))))))))))))))))))))))))));
xin=sf_add(ci,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi))),sf_add(sf_mul(Xi,sf_diffabs(Xr,xr)),sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr))),sf_add(sf_mul(Xi,sf_diffabs(Xr,xr)),sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_mul(xi,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_add(sf_diffabs(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi)),sf_add(sf_imul(4,sf_mul(Xi,sf_mul(xi,sf_add(sf_mul(Xi,Xi),sf_mul(xi,xi))))),sf_add(sf_imul(6,sf_mul(sf_mul(Xi,Xi),sf_mul(xi,xi))),sf_mul(sf_mul(xi,xi),sf_mul(xi,xi))))),sf_diffabs(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr)),sf_add(sf_imul(4,sf_mul(Xr,sf_mul(xr,sf_add(sf_mul(Xr,Xr),sf_mul(xr,xr))))),sf_add(sf_imul(6,sf_mul(sf_mul(Xr,Xr),sf_mul(xr,xr))),sf_mul(sf_mul(xr,xr),sf_mul(xr,xr)))))),sf_add(Xr,xr))),sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_add(sf_diffabs(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi)),sf_add(sf_imul(4,sf_mul(Xi,sf_mul(xi,sf_add(sf_mul(Xi,Xi),sf_mul(xi,xi))))),sf_add(sf_imul(6,sf_mul(sf_mul(Xi,Xi),sf_mul(xi,xi))),sf_mul(sf_mul(xi,xi),sf_mul(xi,xi))))),sf_diffabs(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr)),sf_add(sf_imul(4,sf_mul(Xr,sf_mul(xr,sf_add(sf_mul(Xr,Xr),sf_mul(xr,xr))))),sf_add(sf_imul(6,sf_mul(sf_mul(Xr,Xr),sf_mul(xr,xr))),sf_mul(sf_mul(xr,xr),sf_mul(xr,xr)))))),sf_add(Xi,xi))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xr,sf_diffabs(sf_mul(Xi,sf_mul(Xr,sf_mul(Xr,Xr))),sf_add(sf_mul(Xi,sf_mul(xr,sf_mul(xr,xr))),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),xi)),sf_add(sf_imul(3,sf_add(sf_mul(Xi,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,xr)),sf_mul(Xr,sf_mul(xi,sf_mul(xr,xr)))))),sf_mul(xi,sf_mul(xr,sf_mul(xr,xr)))))))))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xr,sf_diffabs(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),Xr)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),xr)),sf_add(sf_mul(Xr,sf_mul(xi,sf_mul(xi,xi))),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_add(Xr,xr))),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_add(Xr,xr))))),sf_mul(xi,sf_mul(sf_mul(xi,xi),xr))))))))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,sf_mul(Xr,Xr)))),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),Xr))),sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,sf_mul(Xr,Xr)))),sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),Xr))),sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xi,sf_diffabs(sf_mul(Xi,sf_mul(Xr,sf_mul(Xr,Xr))),sf_add(sf_mul(Xi,sf_mul(xr,sf_mul(xr,xr))),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),xi)),sf_add(sf_imul(3,sf_add(sf_mul(Xi,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,xr)),sf_mul(Xr,sf_mul(xi,sf_mul(xr,xr)))))),sf_mul(xi,sf_mul(xr,sf_mul(xr,xr)))))))))),sf_add(sf_imul(4,sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xi,sf_diffabs(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),Xr)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),xr)),sf_add(sf_mul(Xr,sf_mul(xi,sf_mul(xi,xi))),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_add(Xr,xr))),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_add(Xr,xr))))),sf_mul(xi,sf_mul(sf_mul(xi,xi),xr)))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_diffabs(sf_mul(Xi,sf_mul(Xr,sf_mul(Xr,Xr))),sf_add(sf_mul(Xi,sf_mul(xr,sf_mul(xr,xr))),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),xi)),sf_add(sf_imul(3,sf_add(sf_mul(Xi,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,xr)),sf_mul(Xr,sf_mul(xi,sf_mul(xr,xr)))))),sf_mul(xi,sf_mul(xr,sf_mul(xr,xr))))))))))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_diffabs(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),Xr)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),xr)),sf_add(sf_mul(Xr,sf_mul(xi,sf_mul(xi,xi))),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_add(Xr,xr))),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_add(Xr,xr))))),sf_mul(xi,sf_mul(sf_mul(xi,xi),xr))))))))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,sf_mul(Xr,Xr)))),sf_mul(Xr,sf_diffabs(Xr,xr)))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),Xr))),sf_mul(Xr,sf_diffabs(Xr,xr))),sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,sf_mul(Xr,Xr)))),sf_mul(Xi,sf_diffabs(Xi,xi))))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_diffabs(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),Xr)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),xr)),sf_add(sf_mul(Xr,sf_mul(xi,sf_mul(xi,xi))),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_add(Xr,xr))),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_add(Xr,xr))))),sf_mul(xi,sf_mul(sf_mul(xi,xi),xr))))))))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_diffabs(sf_mul(Xi,sf_mul(Xr,sf_mul(Xr,Xr))),sf_add(sf_mul(Xi,sf_mul(xr,sf_mul(xr,xr))),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),xi)),sf_add(sf_imul(3,sf_add(sf_mul(Xi,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,xr)),sf_mul(Xr,sf_mul(xi,sf_mul(xr,xr)))))),sf_mul(xi,sf_mul(xr,sf_mul(xr,xr)))))))))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),Xr))),sf_mul(Xi,sf_diffabs(Xi,xi)))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,Xr))),sf_add(sf_mul(Xi,sf_diffabs(Xr,xr)),sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_diffabs(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,Xr)),sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,xi)),sf_add(sf_imul(2,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,xr)),sf_add(sf_mul(Xi,sf_mul(xi,sf_add(sf_mul(Xr,Xr),sf_mul(xr,xr)))),sf_mul(Xr,sf_mul(sf_mul(xi,xi),xr))))),sf_add(sf_imul(4,sf_mul(Xi,sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(sf_mul(xi,xi),sf_mul(xr,xr))))))),sf_add(Xr,xr))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_diffabs(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,Xr)),sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,xi)),sf_add(sf_imul(2,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,xr)),sf_add(sf_mul(Xi,sf_mul(xi,sf_add(sf_mul(Xr,Xr),sf_mul(xr,xr)))),sf_mul(Xr,sf_mul(sf_mul(xi,xi),xr))))),sf_add(sf_imul(4,sf_mul(Xi,sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(sf_mul(xi,xi),sf_mul(xr,xr))))))),sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))))))))))))))))))));
}

);
#endif


static const char *perturbation_opencl_double_65_6_0 = STR(

{xrn=d_add(cr,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xi,Xi))),d_add(d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi)),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi)))),d_add(d_mul(Xr,Xr),d_mul(xr,xr)))),d_add(d_mul(d_abs(d_add(Xr,xr)),d_mul(d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr)))),d_add(d_mul(Xr,Xr),d_mul(xr,xr)))),d_add(d_imul(-1,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xi,Xi))),d_add(d_mul(d_mul(Xi,Xi),d_diffabs(Xi,xi)),d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_add(d_mul(d_mul(Xi,Xi),d_diffabs(Xr,xr)),d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi)))),d_add(d_mul(Xi,Xi),d_mul(xi,xi)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr)))),d_add(d_mul(Xi,Xi),d_mul(xi,xi)))))))),d_add(d_imul(-2,d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi)))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xi,Xi))),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi))))))))),d_add(d_imul(-2,d_mul(d_abs(d_add(Xi,xi)),d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr)))))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xi,Xi))),d_mul(Xr,d_mul(xr,d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(xr,d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(xr,d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr))))))))))),d_add(d_imul(-2,d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_mul(Xr,d_mul(xi,d_abs(d_add(Xi,xi)))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xi,Xi))),d_mul(Xr,d_mul(xi,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(xi,d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi))))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_mul(Xi,d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(xi,d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr))))))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xi,Xi))),d_mul(Xi,d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(xr,d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi))))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xi,Xi))),d_mul(Xi,d_mul(xi,d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_mul(Xi,d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_mul(xi,d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_add(d_mul(xi,d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi))))),d_mul(xr,d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr)))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(xi,d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr))))))))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xi,Xi))),d_mul(Xi,d_mul(Xr,d_diffabs(Xr,xr)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(Xr,d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi))))))))),d_add(d_imul(-2,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(Xr,d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr)))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))),d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr)))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(xr,xr),d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr))))))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))),d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr)))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(xi,xi),d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr))))))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr))),d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr)))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr))))))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(d_mul(Xi,Xi),d_diffabs(Xr,xr))),d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(d_mul(Xi,Xi),d_diffabs(Xi,xi))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xi,Xi),d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr)))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr))))))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr))))))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(xi,d_mul(xr,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr)))))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(Xr,d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(xr,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr))))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_add(d_mul(xi,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr))))))),d_mul(xr,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr))))))))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(Xr,d_mul(xi,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(xi,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr)))))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(Xi,d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(xr,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr))))))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(Xi,d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi)))))),d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(Xi,d_mul(xi,d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_add(d_mul(xi,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr))))))),d_mul(xr,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr))))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(xi,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr)))))))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(Xi,d_mul(Xr,d_diffabs(Xr,xr)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(Xr,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr))))))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(Xi,d_mul(Xr,d_diffabs(Xi,xi)))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(Xr,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr)))))))))),d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))))))))))))))))))))))))))))));
xin=d_add(ci,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xi,Xi))),d_add(d_mul(d_mul(Xi,Xi),d_diffabs(Xr,xr)),d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr)))),d_add(d_mul(Xr,Xr),d_mul(xr,xr)))),d_add(d_mul(d_abs(d_add(Xr,xr)),d_mul(d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi)))),d_add(d_mul(Xi,Xi),d_mul(xi,xi)))),d_add(d_imul(-1,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xi,Xi))),d_add(d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr)),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_add(d_mul(d_mul(Xi,Xi),d_diffabs(Xi,xi)),d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr)))),d_add(d_mul(Xi,Xi),d_mul(xi,xi)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi)))),d_add(d_mul(Xr,Xr),d_mul(xr,xr)))))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xi,Xi))),d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_add(d_mul(Xr,d_mul(xr,d_abs(d_add(Xi,xi)))),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr))))))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xi,Xi))),d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(xr,d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi))))))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xi,Xi))),d_add(d_mul(Xi,d_mul(xr,d_abs(d_add(Xi,xi)))),d_mul(Xr,d_mul(xi,d_abs(d_add(Xi,xi)))))),d_add(d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_add(d_mul(Xi,d_mul(xr,d_abs(d_add(Xr,xr)))),d_mul(Xr,d_mul(xi,d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(Xi,d_mul(xr,d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi)))))),d_mul(Xr,d_add(d_mul(xi,d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi))))),d_mul(xr,d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr))))))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_mul(xr,d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr)))))),d_mul(Xr,d_mul(xi,d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr)))))))))))),d_add(d_imul(-2,d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_mul(Xi,d_mul(xi,d_abs(d_add(Xi,xi)))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xi,Xi))),d_mul(Xi,d_mul(xi,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(xi,d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi))))))))),d_add(d_imul(-2,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(xi,d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr)))))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xi,Xi))),d_mul(Xi,d_mul(Xr,d_diffabs(Xi,xi)))),d_add(d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_mul(Xi,d_mul(Xr,d_diffabs(Xr,xr)))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(Xr,d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(Xr,d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr))))))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr)))))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))),d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(xr,xr),d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr)))))))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))),d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(xi,xi),d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr)))))))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi))),d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(d_mul(Xi,Xi),d_diffabs(Xr,xr))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr)))))))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(d_mul(Xi,Xi),d_diffabs(Xi,xi))),d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xi,Xi),d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr))))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr))))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xi,d_mul(xr,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr)))))))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(xr,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr))))))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_add(d_mul(Xi,d_mul(xr,d_abs(d_add(Xr,xr)))),d_mul(Xr,d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_add(d_mul(Xi,d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(Xr,d_mul(xi,d_abs(d_add(Xi,xi)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(Xi,d_mul(xr,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr)))))))),d_mul(Xr,d_add(d_mul(xi,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr))))))),d_mul(xr,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr)))))))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_add(d_mul(xi,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr))))))),d_mul(xr,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr)))))))),d_mul(Xr,d_mul(xi,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr))))))))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(Xi,d_mul(xi,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(xi,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr)))))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(Xi,d_mul(Xr,d_diffabs(Xr,xr)))),d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(Xi,d_mul(Xr,d_diffabs(Xi,xi)))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(Xr,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr))))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(Xr,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr)))))))))))),d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))))))))))))))))))))))));
}

);

static const char *perturbation_opencl_double_65_6_1 = STR(

{dxan=d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(d_mul(Xxi,d_mul(Xxi,Xxi)))))),d_add(d_mul(d_sgn(Xxr),d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(d_mul(Xxr,d_mul(Xxr,Xxr)))))),d_add(d_imul(-1,d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(Xxi,Xxi),d_mul(dya,d_abs(d_mul(Xxi,d_mul(Xxi,Xxi)))))),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(dxa,d_abs(d_mul(Xxr,d_mul(Xxr,Xxr)))))))),d_add(d_imul(-2,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(Xxr,d_mul(dya,d_abs(Xxi))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxr,d_add(d_mul(dxa,d_abs(Xxi)),d_mul(dya,d_abs(Xxr))))),d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(Xxr,d_mul(dxa,d_abs(Xxr)))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxi,d_mul(dya,d_abs(Xxi)))),d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(Xxi,d_add(d_mul(dxa,d_abs(Xxi)),d_mul(dya,d_abs(Xxr))))))),d_add(d_imul(2,d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxi,d_mul(dxa,d_abs(Xxr))))),d_add(d_imul(-2,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_abs(d_mul(Xxr,d_mul(Xxr,Xxr)))))))),d_add(d_imul(2,d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_abs(d_mul(Xxi,d_mul(Xxi,Xxi)))))))),d_add(d_imul(-3,d_add(d_mul(d_sgn(Xxi),d_add(d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dya,d_abs(Xxi)))))),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(d_mul(d_mul(Xxi,Xxi),Xxr))))))),d_add(d_imul(3,d_add(d_mul(d_sgn(Xxi),d_add(d_mul(d_mul(Xxi,Xxi),d_mul(dya,d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))))),d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxi)))),d_add(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_sgn(Xxr)))))),d_mul(d_sgn(Xxr),d_add(d_mul(d_mul(Xxi,Xxi),d_mul(dxa,d_abs(d_mul(d_mul(Xxi,Xxi),Xxr)))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dxa,d_abs(Xxr)))))))),d_add(d_imul(-3,d_mul(d_sgn(Xxr),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr))))))),d_add(d_imul(3,d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(dxa,d_abs(Xxr)))))),d_add(d_imul(-3,d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(dya,d_abs(Xxi))))),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr)))))))),d_add(d_imul(-6,d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxr,d_mul(dya,d_abs(Xxr))))),d_add(d_imul(6,d_mul(d_abs(d_mul(d_mul(Xxi,Xxi),Xxr)),d_mul(Xxr,d_mul(dya,d_abs(Xxi))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(d_mul(Xxi,Xxi),Xxr)),d_mul(Xxr,d_mul(dxa,d_abs(Xxr)))),d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxr,d_mul(dxa,d_abs(Xxi)))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(d_mul(Xxi,Xxi),Xxr)),d_mul(Xxi,d_mul(dya,d_abs(Xxr)))),d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxi,d_mul(dya,d_abs(Xxi)))))),d_add(d_imul(-6,d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxi,d_mul(dxa,d_abs(Xxr))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(d_mul(Xxi,Xxi),Xxr)),d_mul(Xxi,d_mul(dxa,d_abs(Xxi)))),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_abs(d_mul(d_mul(Xxi,Xxi),Xxr)))))))),d_add(d_imul(-6,d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxr))))))),d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_add(d_mul(dxa,d_abs(Xxi)),d_mul(dya,d_abs(Xxr)))))))),d_mul(d_sgn(Xxr),d_add(d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_abs(d_mul(Xxi,d_mul(Xxr,Xxr)))))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxi))))))))))),d_add(d_imul(6,d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dya,d_abs(Xxr))))))),d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_add(d_mul(dxa,d_abs(Xxi)),d_mul(dya,d_abs(Xxr)))))))),d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxa,d_abs(Xxi)))))))))),d_add(d_imul(12,d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxi))))))),d_add(d_imul(-12,d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr))))))),daa))))))))))))))))))))))));
dxbn=d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(d_mul(Xxi,d_mul(Xxi,Xxi)))))),d_add(d_mul(d_sgn(Xxr),d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(d_mul(Xxr,d_mul(Xxr,Xxr)))))),d_add(d_imul(-1,d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(Xxi,Xxi),d_mul(dyb,d_abs(d_mul(Xxi,d_mul(Xxi,Xxi)))))),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(dxb,d_abs(d_mul(Xxr,d_mul(Xxr,Xxr)))))))),d_add(d_imul(-2,d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(Xxr,d_mul(dyb,d_abs(Xxi))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxr,d_add(d_mul(dxb,d_abs(Xxi)),d_mul(dyb,d_abs(Xxr))))),d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(Xxr,d_mul(dxb,d_abs(Xxr)))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxi,d_mul(dyb,d_abs(Xxi)))),d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(Xxi,d_add(d_mul(dxb,d_abs(Xxi)),d_mul(dyb,d_abs(Xxr))))))),d_add(d_imul(2,d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxi,d_mul(dxb,d_abs(Xxr))))),d_add(d_imul(-2,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_abs(d_mul(Xxr,d_mul(Xxr,Xxr)))))))),d_add(d_imul(2,d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_abs(d_mul(Xxi,d_mul(Xxi,Xxi)))))))),d_add(d_imul(-3,d_add(d_mul(d_sgn(Xxi),d_add(d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dyb,d_abs(Xxi)))))),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(d_mul(d_mul(Xxi,Xxi),Xxr))))))),d_add(d_imul(3,d_add(d_mul(d_sgn(Xxi),d_add(d_mul(d_mul(Xxi,Xxi),d_mul(dyb,d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))))),d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxi)))),d_add(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_sgn(Xxr)))))),d_mul(d_sgn(Xxr),d_add(d_mul(d_mul(Xxi,Xxi),d_mul(dxb,d_abs(d_mul(d_mul(Xxi,Xxi),Xxr)))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dxb,d_abs(Xxr)))))))),d_add(d_imul(-3,d_mul(d_sgn(Xxr),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr))))))),d_add(d_imul(3,d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(dxb,d_abs(Xxr)))))),d_add(d_imul(-3,d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(dyb,d_abs(Xxi))))),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr)))))))),d_add(d_imul(-6,d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxr,d_mul(dyb,d_abs(Xxr))))),d_add(d_imul(6,d_mul(d_abs(d_mul(d_mul(Xxi,Xxi),Xxr)),d_mul(Xxr,d_mul(dyb,d_abs(Xxi))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(d_mul(Xxi,Xxi),Xxr)),d_mul(Xxr,d_mul(dxb,d_abs(Xxr)))),d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxr,d_mul(dxb,d_abs(Xxi)))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(d_mul(Xxi,Xxi),Xxr)),d_mul(Xxi,d_mul(dyb,d_abs(Xxr)))),d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxi,d_mul(dyb,d_abs(Xxi)))))),d_add(d_imul(-6,d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxi,d_mul(dxb,d_abs(Xxr))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(d_mul(Xxi,Xxi),Xxr)),d_mul(Xxi,d_mul(dxb,d_abs(Xxi)))),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_abs(d_mul(d_mul(Xxi,Xxi),Xxr)))))))),d_add(d_imul(-6,d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxr))))))),d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_add(d_mul(dxb,d_abs(Xxi)),d_mul(dyb,d_abs(Xxr)))))))),d_mul(d_sgn(Xxr),d_add(d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_abs(d_mul(Xxi,d_mul(Xxr,Xxr)))))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxi))))))))))),d_add(d_imul(6,d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dyb,d_abs(Xxr))))))),d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_add(d_mul(dxb,d_abs(Xxi)),d_mul(dyb,d_abs(Xxr)))))))),d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxb,d_abs(Xxi)))))))))),d_add(d_imul(12,d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxi))))))),d_add(d_imul(-12,d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr))))))),dab))))))))))))))))))))))));
dyan=d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(d_mul(Xxr,d_mul(Xxr,Xxr)))))),d_add(d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(dxa,d_abs(d_mul(Xxi,d_mul(Xxi,Xxi)))))),d_add(d_imul(-1,d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(Xxi,Xxi),d_mul(dya,d_abs(d_mul(Xxr,d_mul(Xxr,Xxr)))))),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(d_mul(Xxi,d_mul(Xxi,Xxi)))))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxr,d_mul(dya,d_abs(Xxi)))),d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(Xxr,d_add(d_mul(dxa,d_abs(Xxi)),d_mul(dya,d_abs(Xxr))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxr,d_mul(dxa,d_abs(Xxr)))),d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(Xxi,d_mul(dya,d_abs(Xxi)))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxi,d_add(d_mul(dxa,d_abs(Xxi)),d_mul(dya,d_abs(Xxr))))),d_add(d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(Xxi,d_mul(dxa,d_abs(Xxr)))),d_add(d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))))))),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-3,d_mul(d_sgn(Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(d_mul(d_mul(Xxi,Xxi),Xxr)))))),d_add(d_imul(3,d_add(d_mul(d_sgn(Xxi),d_add(d_mul(d_mul(Xxi,Xxi),d_mul(dya,d_abs(d_mul(d_mul(Xxi,Xxi),Xxr)))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dya,d_abs(Xxr)))))),d_mul(d_sgn(Xxr),d_add(d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dxa,d_abs(Xxi)))))))),d_add(d_imul(-3,d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxr)))),d_add(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_sgn(Xxr))))),d_mul(d_sgn(Xxr),d_add(d_mul(d_mul(Xxi,Xxi),d_mul(dxa,d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxi))))))))),d_add(d_imul(3,d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(dya,d_abs(Xxr)))))),d_add(d_imul(-3,d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxi))))))),d_add(d_imul(3,d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(dxa,d_abs(Xxi)))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(d_mul(Xxi,Xxi),Xxr)),d_mul(Xxr,d_mul(dya,d_abs(Xxr)))),d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxr,d_mul(dya,d_abs(Xxi)))))),d_add(d_imul(6,d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxr,d_mul(dxa,d_abs(Xxr))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(d_mul(Xxi,Xxi),Xxr)),d_mul(Xxr,d_mul(dxa,d_abs(Xxi)))),d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxi,d_mul(dya,d_abs(Xxr)))))),d_add(d_imul(6,d_mul(d_abs(d_mul(d_mul(Xxi,Xxi),Xxr)),d_mul(Xxi,d_mul(dya,d_abs(Xxi))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(d_mul(Xxi,Xxi),Xxr)),d_mul(Xxi,d_mul(dxa,d_abs(Xxr)))),d_add(d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxi,d_mul(dxa,d_abs(Xxi)))),d_add(d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))))))),d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxi))))))),d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxi))))))),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_abs(d_mul(d_mul(Xxi,Xxi),Xxr)))))))))))),d_add(d_imul(6,d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dya,d_abs(Xxi))))))),d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dya,d_abs(Xxi))))))),d_mul(d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr)))))),d_add(d_sgn(Xxi),d_sgn(Xxr)))))),d_add(d_imul(-6,d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxa,d_abs(Xxr))))))),d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxa,d_abs(Xxr))))))))),d_add(d_imul(-12,d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxr)))))),d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxi)))))))),dba))))))))))))))))))));
dybn=d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(d_mul(Xxr,d_mul(Xxr,Xxr)))))),d_add(d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(dxb,d_abs(d_mul(Xxi,d_mul(Xxi,Xxi)))))),d_add(d_imul(-1,d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(Xxi,Xxi),d_mul(dyb,d_abs(d_mul(Xxr,d_mul(Xxr,Xxr)))))),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(d_mul(Xxi,d_mul(Xxi,Xxi)))))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxr,d_mul(dyb,d_abs(Xxi)))),d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(Xxr,d_add(d_mul(dxb,d_abs(Xxi)),d_mul(dyb,d_abs(Xxr))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxr,d_mul(dxb,d_abs(Xxr)))),d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(Xxi,d_mul(dyb,d_abs(Xxi)))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))),d_mul(Xxi,d_add(d_mul(dxb,d_abs(Xxi)),d_mul(dyb,d_abs(Xxr))))),d_add(d_mul(d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))),d_mul(Xxi,d_mul(dxb,d_abs(Xxr)))),d_add(d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_abs(d_mul(Xxi,d_mul(Xxi,Xxi))))))),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_abs(d_mul(Xxr,d_mul(Xxr,Xxr))))))))))),d_add(d_imul(-3,d_mul(d_sgn(Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(d_mul(d_mul(Xxi,Xxi),Xxr)))))),d_add(d_imul(3,d_add(d_mul(d_sgn(Xxi),d_add(d_mul(d_mul(Xxi,Xxi),d_mul(dyb,d_abs(d_mul(d_mul(Xxi,Xxi),Xxr)))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dyb,d_abs(Xxr)))))),d_mul(d_sgn(Xxr),d_add(d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dxb,d_abs(Xxi)))))))),d_add(d_imul(-3,d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxr)))),d_add(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_sgn(Xxr))))),d_mul(d_sgn(Xxr),d_add(d_mul(d_mul(Xxi,Xxi),d_mul(dxb,d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxi))))))))),d_add(d_imul(3,d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(dyb,d_abs(Xxr)))))),d_add(d_imul(-3,d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxi))))))),d_add(d_imul(3,d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(dxb,d_abs(Xxi)))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(d_mul(Xxi,Xxi),Xxr)),d_mul(Xxr,d_mul(dyb,d_abs(Xxr)))),d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxr,d_mul(dyb,d_abs(Xxi)))))),d_add(d_imul(6,d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxr,d_mul(dxb,d_abs(Xxr))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(d_mul(Xxi,Xxi),Xxr)),d_mul(Xxr,d_mul(dxb,d_abs(Xxi)))),d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxi,d_mul(dyb,d_abs(Xxr)))))),d_add(d_imul(6,d_mul(d_abs(d_mul(d_mul(Xxi,Xxi),Xxr)),d_mul(Xxi,d_mul(dyb,d_abs(Xxi))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(d_mul(Xxi,Xxi),Xxr)),d_mul(Xxi,d_mul(dxb,d_abs(Xxr)))),d_add(d_mul(d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))),d_mul(Xxi,d_mul(dxb,d_abs(Xxi)))),d_add(d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_abs(d_mul(Xxi,d_mul(Xxr,Xxr))))))),d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxi))))))),d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxi))))))),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_abs(d_mul(d_mul(Xxi,Xxi),Xxr)))))))))))),d_add(d_imul(6,d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dyb,d_abs(Xxi))))))),d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dyb,d_abs(Xxi))))))),d_mul(d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr)))))),d_add(d_sgn(Xxi),d_sgn(Xxr)))))),d_add(d_imul(-6,d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxb,d_abs(Xxr))))))),d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxb,d_abs(Xxr))))))))),d_add(d_imul(-12,d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxr)))))),d_mul(d_sgn(Xxi),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxi)))))))),dbb))))))))))))))))))));
}

{xrn=d_add(cr,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xi,Xi))),d_add(d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi)),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi)))),d_add(d_mul(Xr,Xr),d_mul(xr,xr)))),d_add(d_mul(d_abs(d_add(Xr,xr)),d_mul(d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr)))),d_add(d_mul(Xr,Xr),d_mul(xr,xr)))),d_add(d_imul(-1,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xi,Xi))),d_add(d_mul(d_mul(Xi,Xi),d_diffabs(Xi,xi)),d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_add(d_mul(d_mul(Xi,Xi),d_diffabs(Xr,xr)),d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi)))),d_add(d_mul(Xi,Xi),d_mul(xi,xi)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr)))),d_add(d_mul(Xi,Xi),d_mul(xi,xi)))))))),d_add(d_imul(-2,d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi)))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xi,Xi))),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi))))))))),d_add(d_imul(-2,d_mul(d_abs(d_add(Xi,xi)),d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr)))))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xi,Xi))),d_mul(Xr,d_mul(xr,d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(xr,d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(xr,d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr))))))))))),d_add(d_imul(-2,d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_mul(Xr,d_mul(xi,d_abs(d_add(Xi,xi)))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xi,Xi))),d_mul(Xr,d_mul(xi,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(xi,d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi))))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_mul(Xi,d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(xi,d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr))))))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xi,Xi))),d_mul(Xi,d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(xr,d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi))))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xi,Xi))),d_mul(Xi,d_mul(xi,d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_mul(Xi,d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_mul(xi,d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_add(d_mul(xi,d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi))))),d_mul(xr,d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr)))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(xi,d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr))))))))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xi,Xi))),d_mul(Xi,d_mul(Xr,d_diffabs(Xr,xr)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(Xr,d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi))))))))),d_add(d_imul(-2,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(Xr,d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr)))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))),d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr)))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(xr,xr),d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr))))))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))),d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr)))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(xi,xi),d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr))))))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr))),d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr)))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr))))))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(d_mul(Xi,Xi),d_diffabs(Xr,xr))),d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(d_mul(Xi,Xi),d_diffabs(Xi,xi))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xi,Xi),d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr)))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr))))))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr))))))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(xi,d_mul(xr,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr)))))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(Xr,d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(xr,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr))))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_add(d_mul(xi,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr))))))),d_mul(xr,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr))))))))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(Xr,d_mul(xi,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(xi,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr)))))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(Xi,d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(xr,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr))))))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(Xi,d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi)))))),d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(Xi,d_mul(xi,d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_add(d_mul(xi,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr))))))),d_mul(xr,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr))))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(xi,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr)))))))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(Xi,d_mul(Xr,d_diffabs(Xr,xr)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(Xr,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr))))))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(Xi,d_mul(Xr,d_diffabs(Xi,xi)))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(Xr,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr)))))))))),d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))))))))))))))))))))))))))))));
xin=d_add(ci,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xi,Xi))),d_add(d_mul(d_mul(Xi,Xi),d_diffabs(Xr,xr)),d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr)))),d_add(d_mul(Xr,Xr),d_mul(xr,xr)))),d_add(d_mul(d_abs(d_add(Xr,xr)),d_mul(d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi)))),d_add(d_mul(Xi,Xi),d_mul(xi,xi)))),d_add(d_imul(-1,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xi,Xi))),d_add(d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr)),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_add(d_mul(d_mul(Xi,Xi),d_diffabs(Xi,xi)),d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr)))),d_add(d_mul(Xi,Xi),d_mul(xi,xi)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi)))),d_add(d_mul(Xr,Xr),d_mul(xr,xr)))))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xi,Xi))),d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_add(d_mul(Xr,d_mul(xr,d_abs(d_add(Xi,xi)))),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr))))))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xi,Xi))),d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(xr,d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi))))))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xi,Xi))),d_add(d_mul(Xi,d_mul(xr,d_abs(d_add(Xi,xi)))),d_mul(Xr,d_mul(xi,d_abs(d_add(Xi,xi)))))),d_add(d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_add(d_mul(Xi,d_mul(xr,d_abs(d_add(Xr,xr)))),d_mul(Xr,d_mul(xi,d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(Xi,d_mul(xr,d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi)))))),d_mul(Xr,d_add(d_mul(xi,d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi))))),d_mul(xr,d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr))))))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_mul(xr,d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr)))))),d_mul(Xr,d_mul(xi,d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr)))))))))))),d_add(d_imul(-2,d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_mul(Xi,d_mul(xi,d_abs(d_add(Xi,xi)))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xi,Xi))),d_mul(Xi,d_mul(xi,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(xi,d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi))))))))),d_add(d_imul(-2,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(xi,d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr)))))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xi,Xi))),d_mul(Xi,d_mul(Xr,d_diffabs(Xi,xi)))),d_add(d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_mul(Xi,d_mul(Xr,d_diffabs(Xr,xr)))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(Xr,d_diffabs(d_mul(Xi,d_mul(Xi,Xi)),d_add(d_imul(3,d_add(d_mul(d_mul(Xi,Xi),xi),d_mul(Xi,d_mul(xi,xi)))),d_mul(xi,d_mul(xi,xi))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(Xr,d_diffabs(d_mul(Xr,d_mul(Xr,Xr)),d_add(d_imul(3,d_add(d_mul(d_mul(Xr,Xr),xr),d_mul(Xr,d_mul(xr,xr)))),d_mul(xr,d_mul(xr,xr))))))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr)))))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))),d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(xr,xr),d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr)))))))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))),d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(xi,xi),d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr)))))))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi))),d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(d_mul(Xi,Xi),d_diffabs(Xr,xr))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr)))))))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(d_mul(Xi,Xi),d_diffabs(Xi,xi))),d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xi,Xi),d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr))))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr))))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xi,d_mul(xr,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr)))))))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(xr,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr))))))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_add(d_mul(Xi,d_mul(xr,d_abs(d_add(Xr,xr)))),d_mul(Xr,d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_add(d_mul(Xi,d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(Xr,d_mul(xi,d_abs(d_add(Xi,xi)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(Xi,d_mul(xr,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr)))))))),d_mul(Xr,d_add(d_mul(xi,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr))))))),d_mul(xr,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr)))))))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_add(d_mul(xi,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr))))))),d_mul(xr,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr)))))))),d_mul(Xr,d_mul(xi,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr))))))))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(Xi,d_mul(xi,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(xi,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr)))))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(d_mul(Xi,Xi),Xr)),d_mul(Xi,d_mul(Xr,d_diffabs(Xr,xr)))),d_add(d_mul(d_abs(d_mul(Xi,d_mul(Xr,Xr))),d_mul(Xi,d_mul(Xr,d_diffabs(Xi,xi)))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(Xr,d_diffabs(d_mul(Xi,d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(xr,xr)),d_add(d_mul(d_mul(Xr,Xr),xi),d_add(d_imul(2,d_add(d_mul(Xi,d_mul(Xr,xr)),d_mul(Xr,d_mul(xi,xr)))),d_mul(xi,d_mul(xr,xr))))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(Xr,d_diffabs(d_mul(d_mul(Xi,Xi),Xr),d_add(d_mul(d_mul(Xi,Xi),xr),d_add(d_mul(Xr,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xi,d_mul(xi,d_add(Xr,xr)))),d_mul(d_mul(xi,xi),xr)))))))))))),d_mul(d_abs(d_mul(Xr,d_mul(Xr,Xr))),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))))))))))))))))))))))));
}

);

static const char *perturbation_opencl_floatexp_65_6_0 = STR(

{xrn=fe_add(cr,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xi,Xi))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi)),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi)))),fe_add(fe_mul(Xr,Xr),fe_mul(xr,xr)))),fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr)))),fe_add(fe_mul(Xr,Xr),fe_mul(xr,xr)))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xi,Xi))),fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xi,xi)),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xr,xr)),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi)))),fe_add(fe_mul(Xi,Xi),fe_mul(xi,xi)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr)))),fe_add(fe_mul(Xi,Xi),fe_mul(xi,xi)))))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xi,Xi))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi))))))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr)))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xi,Xi))),fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(xr,fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(xr,fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr))))))))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xi,Xi))),fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(xi,fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi))))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_mul(Xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(xi,fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr))))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xi,Xi))),fe_mul(Xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi))))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xi,Xi))),fe_mul(Xi,fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_mul(Xi,fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_mul(xi,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_add(fe_mul(xi,fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi))))),fe_mul(xr,fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr)))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(xi,fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr))))))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xi,Xi))),fe_mul(Xi,fe_mul(Xr,fe_diffabs(Xr,xr)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi))))))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr)))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))),fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr)))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr))))))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))),fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr)))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr))))))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr))),fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr)))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr))))))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xr,xr))),fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xi,xi))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xi,Xi),fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr)))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr))))))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr))))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr)))))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(Xr,fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(xr,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr))))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_add(fe_mul(xi,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr))))))),fe_mul(xr,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr))))))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(xi,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr)))))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(Xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr))))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(Xi,fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(Xi,fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_add(fe_mul(xi,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr))))))),fe_mul(xr,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr))))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(xi,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr)))))))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(Xi,fe_mul(Xr,fe_diffabs(Xr,xr)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr))))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(Xi,xi)))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr)))))))))),fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))))))))))))))))))))))))))))));
xin=fe_add(ci,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xi,Xi))),fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xr,xr)),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr)))),fe_add(fe_mul(Xr,Xr),fe_mul(xr,xr)))),fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi)))),fe_add(fe_mul(Xi,Xi),fe_mul(xi,xi)))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xi,Xi))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr)),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xi,xi)),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr)))),fe_add(fe_mul(Xi,Xi),fe_mul(xi,xi)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi)))),fe_add(fe_mul(Xr,Xr),fe_mul(xr,xr)))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xi,Xi))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_add(fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xi,xi)))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr))))))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xi,Xi))),fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(xr,fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi))))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xi,Xi))),fe_add(fe_mul(Xi,fe_mul(xr,fe_abs(fe_add(Xi,xi)))),fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_add(fe_mul(Xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(Xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi)))))),fe_mul(Xr,fe_add(fe_mul(xi,fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi))))),fe_mul(xr,fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr))))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_mul(xr,fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr)))))),fe_mul(Xr,fe_mul(xi,fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr)))))))))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_mul(Xi,fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xi,Xi))),fe_mul(Xi,fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(xi,fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi))))))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(xi,fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr)))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xi,Xi))),fe_mul(Xi,fe_mul(Xr,fe_diffabs(Xi,xi)))),fe_add(fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_mul(Xi,fe_mul(Xr,fe_diffabs(Xr,xr)))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr))))))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr)))))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))),fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr)))))))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))),fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr)))))))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi))),fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xr,xr))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr)))))))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xi,xi))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xi,Xi),fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr))))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr))))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr)))))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(xr,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr))))))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_add(fe_mul(Xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_mul(Xr,fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_add(fe_mul(Xi,fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(Xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr)))))))),fe_mul(Xr,fe_add(fe_mul(xi,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr))))))),fe_mul(xr,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr)))))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_add(fe_mul(xi,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr))))))),fe_mul(xr,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr)))))))),fe_mul(Xr,fe_mul(xi,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr))))))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(Xi,fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(xi,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr)))))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(Xr,xr)))),fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(Xi,fe_mul(Xr,fe_diffabs(Xi,xi)))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr))))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr)))))))))))),fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))))))))))))))))))))))));
}

);

static const char *perturbation_opencl_floatexp_65_6_1 = STR(

{dxan=fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi)))))),fe_add(fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr)))))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dya,fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi)))))),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxa,fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxi))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxr,fe_add(fe_mul(dxa,fe_abs(Xxi)),fe_mul(dya,fe_abs(Xxr))))),fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxr)))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxi,fe_mul(dya,fe_abs(Xxi)))),fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(Xxi,fe_add(fe_mul(dxa,fe_abs(Xxi)),fe_mul(dya,fe_abs(Xxr))))))),fe_add(fe_imul(2,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxi,fe_mul(dxa,fe_abs(Xxr))))),fe_add(fe_imul(-2,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi)))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_sgn(Xxi),fe_add(fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dya,fe_abs(Xxi)))))),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_sgn(Xxi),fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(dya,fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))))),fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxi)))),fe_add(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)))))),fe_mul(fe_sgn(Xxr),fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxa,fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr)))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dxa,fe_abs(Xxr)))))))),fe_add(fe_imul(-3,fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr))))))),fe_add(fe_imul(3,fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(dxa,fe_abs(Xxr)))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(dya,fe_abs(Xxi))))),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr)))))))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxr))))),fe_add(fe_imul(6,fe_mul(fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr)),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxi))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr)),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxr)))),fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxi)))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr)),fe_mul(Xxi,fe_mul(dya,fe_abs(Xxr)))),fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxi,fe_mul(dya,fe_abs(Xxi)))))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxi,fe_mul(dxa,fe_abs(Xxr))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr)),fe_mul(Xxi,fe_mul(dxa,fe_abs(Xxi)))),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr)))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxr))))))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_add(fe_mul(dxa,fe_abs(Xxi)),fe_mul(dya,fe_abs(Xxr)))))))),fe_mul(fe_sgn(Xxr),fe_add(fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr)))))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxi))))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxr))))))),fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_add(fe_mul(dxa,fe_abs(Xxi)),fe_mul(dya,fe_abs(Xxr)))))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxi)))))))))),fe_add(fe_imul(12,fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxi))))))),fe_add(fe_imul(-12,fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr))))))),daa))))))))))))))))))))))));
dxbn=fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi)))))),fe_add(fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr)))))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dyb,fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi)))))),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxb,fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxi))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxr,fe_add(fe_mul(dxb,fe_abs(Xxi)),fe_mul(dyb,fe_abs(Xxr))))),fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxr)))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxi,fe_mul(dyb,fe_abs(Xxi)))),fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(Xxi,fe_add(fe_mul(dxb,fe_abs(Xxi)),fe_mul(dyb,fe_abs(Xxr))))))),fe_add(fe_imul(2,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxi,fe_mul(dxb,fe_abs(Xxr))))),fe_add(fe_imul(-2,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi)))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_sgn(Xxi),fe_add(fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dyb,fe_abs(Xxi)))))),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_sgn(Xxi),fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(dyb,fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))))),fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxi)))),fe_add(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)))))),fe_mul(fe_sgn(Xxr),fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxb,fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr)))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dxb,fe_abs(Xxr)))))))),fe_add(fe_imul(-3,fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr))))))),fe_add(fe_imul(3,fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(dxb,fe_abs(Xxr)))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(dyb,fe_abs(Xxi))))),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr)))))))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxr))))),fe_add(fe_imul(6,fe_mul(fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr)),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxi))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr)),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxr)))),fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxi)))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr)),fe_mul(Xxi,fe_mul(dyb,fe_abs(Xxr)))),fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxi,fe_mul(dyb,fe_abs(Xxi)))))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxi,fe_mul(dxb,fe_abs(Xxr))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr)),fe_mul(Xxi,fe_mul(dxb,fe_abs(Xxi)))),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr)))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxr))))))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_add(fe_mul(dxb,fe_abs(Xxi)),fe_mul(dyb,fe_abs(Xxr)))))))),fe_mul(fe_sgn(Xxr),fe_add(fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr)))))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxi))))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxr))))))),fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_add(fe_mul(dxb,fe_abs(Xxi)),fe_mul(dyb,fe_abs(Xxr)))))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxi)))))))))),fe_add(fe_imul(12,fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxi))))))),fe_add(fe_imul(-12,fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr))))))),dab))))))))))))))))))))))));
dyan=fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr)))))),fe_add(fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxa,fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi)))))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dya,fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr)))))),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi)))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxi)))),fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_add(fe_mul(dxa,fe_abs(Xxi)),fe_mul(dya,fe_abs(Xxr))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxr)))),fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(Xxi,fe_mul(dya,fe_abs(Xxi)))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxi,fe_add(fe_mul(dxa,fe_abs(Xxi)),fe_mul(dya,fe_abs(Xxr))))),fe_add(fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(Xxi,fe_mul(dxa,fe_abs(Xxr)))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-3,fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr)))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_sgn(Xxi),fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(dya,fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr)))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dya,fe_abs(Xxr)))))),fe_mul(fe_sgn(Xxr),fe_add(fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dxa,fe_abs(Xxi)))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxr)))),fe_add(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_sgn(Xxr))))),fe_mul(fe_sgn(Xxr),fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxa,fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxi))))))))),fe_add(fe_imul(3,fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(dya,fe_abs(Xxr)))))),fe_add(fe_imul(-3,fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxi))))))),fe_add(fe_imul(3,fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(dxa,fe_abs(Xxi)))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr)),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxr)))),fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxi)))))),fe_add(fe_imul(6,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxr))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr)),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxi)))),fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxi,fe_mul(dya,fe_abs(Xxr)))))),fe_add(fe_imul(6,fe_mul(fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr)),fe_mul(Xxi,fe_mul(dya,fe_abs(Xxi))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr)),fe_mul(Xxi,fe_mul(dxa,fe_abs(Xxr)))),fe_add(fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxi,fe_mul(dxa,fe_abs(Xxi)))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))))))),fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxi))))))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxi))))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr)))))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxi))))))),fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxi))))))),fe_mul(fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr)))))),fe_add(fe_sgn(Xxi),fe_sgn(Xxr)))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxr))))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxr))))))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxr)))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxi)))))))),dba))))))))))))))))))));
dybn=fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr)))))),fe_add(fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxb,fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi)))))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dyb,fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr)))))),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi)))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxi)))),fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_add(fe_mul(dxb,fe_abs(Xxi)),fe_mul(dyb,fe_abs(Xxr))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxr)))),fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(Xxi,fe_mul(dyb,fe_abs(Xxi)))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))),fe_mul(Xxi,fe_add(fe_mul(dxb,fe_abs(Xxi)),fe_mul(dyb,fe_abs(Xxr))))),fe_add(fe_mul(fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))),fe_mul(Xxi,fe_mul(dxb,fe_abs(Xxr)))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_abs(fe_mul(Xxi,fe_mul(Xxi,Xxi))))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_abs(fe_mul(Xxr,fe_mul(Xxr,Xxr))))))))))),fe_add(fe_imul(-3,fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr)))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_sgn(Xxi),fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(dyb,fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr)))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dyb,fe_abs(Xxr)))))),fe_mul(fe_sgn(Xxr),fe_add(fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dxb,fe_abs(Xxi)))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxr)))),fe_add(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_sgn(Xxr))))),fe_mul(fe_sgn(Xxr),fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxb,fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxi))))))))),fe_add(fe_imul(3,fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(dyb,fe_abs(Xxr)))))),fe_add(fe_imul(-3,fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxi))))))),fe_add(fe_imul(3,fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(dxb,fe_abs(Xxi)))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr)),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxr)))),fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxi)))))),fe_add(fe_imul(6,fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxr))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr)),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxi)))),fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxi,fe_mul(dyb,fe_abs(Xxr)))))),fe_add(fe_imul(6,fe_mul(fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr)),fe_mul(Xxi,fe_mul(dyb,fe_abs(Xxi))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr)),fe_mul(Xxi,fe_mul(dxb,fe_abs(Xxr)))),fe_add(fe_mul(fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))),fe_mul(Xxi,fe_mul(dxb,fe_abs(Xxi)))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_abs(fe_mul(Xxi,fe_mul(Xxr,Xxr))))))),fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxi))))))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxi))))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_abs(fe_mul(fe_mul(Xxi,Xxi),Xxr)))))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxi))))))),fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxi))))))),fe_mul(fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr)))))),fe_add(fe_sgn(Xxi),fe_sgn(Xxr)))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxr))))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxr))))))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxr)))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxi)))))))),dbb))))))))))))))))))));
}

{xrn=fe_add(cr,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xi,Xi))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi)),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi)))),fe_add(fe_mul(Xr,Xr),fe_mul(xr,xr)))),fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr)))),fe_add(fe_mul(Xr,Xr),fe_mul(xr,xr)))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xi,Xi))),fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xi,xi)),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xr,xr)),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi)))),fe_add(fe_mul(Xi,Xi),fe_mul(xi,xi)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr)))),fe_add(fe_mul(Xi,Xi),fe_mul(xi,xi)))))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xi,Xi))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi))))))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr)))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xi,Xi))),fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(xr,fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(xr,fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr))))))))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xi,Xi))),fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(xi,fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi))))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_mul(Xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(xi,fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr))))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xi,Xi))),fe_mul(Xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi))))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xi,Xi))),fe_mul(Xi,fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_mul(Xi,fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_mul(xi,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_add(fe_mul(xi,fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi))))),fe_mul(xr,fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr)))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(xi,fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr))))))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xi,Xi))),fe_mul(Xi,fe_mul(Xr,fe_diffabs(Xr,xr)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi))))))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr)))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))),fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr)))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr))))))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))),fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr)))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr))))))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr))),fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr)))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr))))))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xr,xr))),fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xi,xi))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xi,Xi),fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr)))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr))))))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr))))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr)))))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(Xr,fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(xr,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr))))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_add(fe_mul(xi,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr))))))),fe_mul(xr,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr))))))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(xi,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr)))))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(Xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr))))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(Xi,fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(Xi,fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_add(fe_mul(xi,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr))))))),fe_mul(xr,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr))))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(xi,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr)))))))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(Xi,fe_mul(Xr,fe_diffabs(Xr,xr)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr))))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(Xi,xi)))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr)))))))))),fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))))))))))))))))))))))))))))));
xin=fe_add(ci,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xi,Xi))),fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xr,xr)),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr)))),fe_add(fe_mul(Xr,Xr),fe_mul(xr,xr)))),fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi)))),fe_add(fe_mul(Xi,Xi),fe_mul(xi,xi)))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xi,Xi))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr)),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_add(fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xi,xi)),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr)))),fe_add(fe_mul(Xi,Xi),fe_mul(xi,xi)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi)))),fe_add(fe_mul(Xr,Xr),fe_mul(xr,xr)))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xi,Xi))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_add(fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xi,xi)))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr))))))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xi,Xi))),fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(xr,fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi))))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xi,Xi))),fe_add(fe_mul(Xi,fe_mul(xr,fe_abs(fe_add(Xi,xi)))),fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_add(fe_mul(Xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(Xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi)))))),fe_mul(Xr,fe_add(fe_mul(xi,fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi))))),fe_mul(xr,fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr))))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_mul(xr,fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr)))))),fe_mul(Xr,fe_mul(xi,fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr)))))))))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_mul(Xi,fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xi,Xi))),fe_mul(Xi,fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(xi,fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi))))))))),fe_add(fe_imul(-2,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(xi,fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr)))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xi,Xi))),fe_mul(Xi,fe_mul(Xr,fe_diffabs(Xi,xi)))),fe_add(fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_mul(Xi,fe_mul(Xr,fe_diffabs(Xr,xr)))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(fe_mul(Xi,fe_mul(Xi,Xi)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xi,Xi),xi),fe_mul(Xi,fe_mul(xi,xi)))),fe_mul(xi,fe_mul(xi,xi))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(fe_mul(Xr,fe_mul(Xr,Xr)),fe_add(fe_imul(3,fe_add(fe_mul(fe_mul(Xr,Xr),xr),fe_mul(Xr,fe_mul(xr,xr)))),fe_mul(xr,fe_mul(xr,xr))))))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr)))))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))),fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr)))))))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))),fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr)))))))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi))),fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xr,xr))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr)))))))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xi,xi))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xi,Xi),fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr))))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr))))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr)))))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(xr,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr))))))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_add(fe_mul(Xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_mul(Xr,fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_add(fe_mul(Xi,fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(Xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr)))))))),fe_mul(Xr,fe_add(fe_mul(xi,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr))))))),fe_mul(xr,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr)))))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_add(fe_mul(xi,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr))))))),fe_mul(xr,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr)))))))),fe_mul(Xr,fe_mul(xi,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr))))))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(Xi,fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(xi,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr)))))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(fe_mul(Xi,Xi),Xr)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(Xr,xr)))),fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_mul(Xr,Xr))),fe_mul(Xi,fe_mul(Xr,fe_diffabs(Xi,xi)))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(fe_mul(Xi,fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,fe_mul(Xr,xr)),fe_mul(Xr,fe_mul(xi,xr)))),fe_mul(xi,fe_mul(xr,xr))))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(Xr,fe_diffabs(fe_mul(fe_mul(Xi,Xi),Xr),fe_add(fe_mul(fe_mul(Xi,Xi),xr),fe_add(fe_mul(Xr,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xi,fe_mul(xi,fe_add(Xr,xr)))),fe_mul(fe_mul(xi,xi),xr)))))))))))),fe_mul(fe_abs(fe_mul(Xr,fe_mul(Xr,Xr))),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))))))))))))))))))))))));
}

);

#if 0
static const char *perturbation_opencl_softfloat_65_6_0 = STR(

{xrn=sf_add(cr,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xi,Xi))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi)),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi)))),sf_add(sf_mul(Xr,Xr),sf_mul(xr,xr)))),sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr)))),sf_add(sf_mul(Xr,Xr),sf_mul(xr,xr)))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xi,Xi))),sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xi,xi)),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xr,xr)),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi)))),sf_add(sf_mul(Xi,Xi),sf_mul(xi,xi)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr)))),sf_add(sf_mul(Xi,Xi),sf_mul(xi,xi)))))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xi,Xi))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi))))))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr)))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xi,Xi))),sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(xr,sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(xr,sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr))))))))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xi,Xi))),sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(xi,sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi))))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_mul(Xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(xi,sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr))))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xi,Xi))),sf_mul(Xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi))))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xi,Xi))),sf_mul(Xi,sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_mul(Xi,sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_mul(xi,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_add(sf_mul(xi,sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi))))),sf_mul(xr,sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr)))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(xi,sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr))))))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xi,Xi))),sf_mul(Xi,sf_mul(Xr,sf_diffabs(Xr,xr)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi))))))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr)))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))),sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr)))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr))))))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))),sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr)))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr))))))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr))),sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr)))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr))))))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xr,xr))),sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xi,xi))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xi,Xi),sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr)))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr))))))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr))))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr)))))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(Xr,sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(xr,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr))))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_add(sf_mul(xi,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr))))))),sf_mul(xr,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr))))))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(xi,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr)))))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(Xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr))))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(Xi,sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(Xi,sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_add(sf_mul(xi,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr))))))),sf_mul(xr,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr))))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(xi,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr)))))))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(Xi,sf_mul(Xr,sf_diffabs(Xr,xr)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr))))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(Xi,xi)))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr)))))))))),sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))))))))))))))))))))))))))))));
xin=sf_add(ci,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xi,Xi))),sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xr,xr)),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr)))),sf_add(sf_mul(Xr,Xr),sf_mul(xr,xr)))),sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi)))),sf_add(sf_mul(Xi,Xi),sf_mul(xi,xi)))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xi,Xi))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr)),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xi,xi)),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr)))),sf_add(sf_mul(Xi,Xi),sf_mul(xi,xi)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi)))),sf_add(sf_mul(Xr,Xr),sf_mul(xr,xr)))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xi,Xi))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_add(sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xi,xi)))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr))))))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xi,Xi))),sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(xr,sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi))))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xi,Xi))),sf_add(sf_mul(Xi,sf_mul(xr,sf_abs(sf_add(Xi,xi)))),sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_add(sf_mul(Xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(Xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi)))))),sf_mul(Xr,sf_add(sf_mul(xi,sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi))))),sf_mul(xr,sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr))))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_mul(xr,sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr)))))),sf_mul(Xr,sf_mul(xi,sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr)))))))))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_mul(Xi,sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xi,Xi))),sf_mul(Xi,sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(xi,sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi))))))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(xi,sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr)))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xi,Xi))),sf_mul(Xi,sf_mul(Xr,sf_diffabs(Xi,xi)))),sf_add(sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_mul(Xi,sf_mul(Xr,sf_diffabs(Xr,xr)))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr))))))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr)))))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))),sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr)))))))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))),sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr)))))))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi))),sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xr,xr))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr)))))))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xi,xi))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xi,Xi),sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr))))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr))))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr)))))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(xr,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr))))))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_add(sf_mul(Xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_mul(Xr,sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_add(sf_mul(Xi,sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(Xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr)))))))),sf_mul(Xr,sf_add(sf_mul(xi,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr))))))),sf_mul(xr,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr)))))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_add(sf_mul(xi,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr))))))),sf_mul(xr,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr)))))))),sf_mul(Xr,sf_mul(xi,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr))))))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(Xi,sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(xi,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr)))))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(Xr,xr)))),sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(Xi,sf_mul(Xr,sf_diffabs(Xi,xi)))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr))))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr)))))))))))),sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))))))))))))))))))))))));
}

);
#endif


static const char *perturbation_opencl_double_66_6_0 = STR(

{xrn=d_add(cr,d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(Xi,xi))),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr))),d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))),d_mul(xi,d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))),d_mul(xr,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(-1,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(Xi,xi))),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr))),d_add(d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))),d_mul(xi,d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))),d_mul(xr,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(xr,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xi,d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi)))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(Xr,xr)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))),d_add(d_imul(-3,d_mul(d_abs(d_mul(Xr,Xr)),d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_imul(3,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_imul(-3,d_mul(d_abs(d_add(Xi,xi)),d_mul(xi,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(3,d_mul(d_abs(d_add(Xi,xi)),d_mul(xi,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(xi,xi),d_mul(xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xr,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))),d_mul(d_mul(xi,xi),d_mul(xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xr,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_add(d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))),d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xr,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(d_mul(Xr,Xr),d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(d_mul(Xr,Xr),d_mul(xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))),d_mul(Xr,d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(d_mul(Xr,Xr),d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xr,Xr),d_mul(xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))))),d_add(d_imul(3,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xi,xi)))))),d_add(d_imul(-3,d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xr,Xr),d_mul(xi,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(3,d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xr,Xr),d_mul(xi,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))),d_add(d_imul(-3,d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_imul(3,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_imul(-3,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))),d_add(d_imul(-3,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))))),d_add(d_imul(3,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi)))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))),d_add(d_imul(3,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi))))),d_add(d_imul(-3,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(3,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(d_mul(Xi,Xi),d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(d_mul(Xi,Xi),d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(d_mul(Xi,Xi),d_mul(xi,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))))),d_add(d_imul(-3,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(d_mul(Xi,Xi),d_mul(xi,d_abs(d_add(Xi,xi)))))),d_add(d_imul(3,d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xi,Xi),d_mul(xi,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_diffabs(Xr,xr)))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xi,Xi),d_mul(xi,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_diffabs(Xr,xr)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xi,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(xi,xi),d_mul(xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(Xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xr,d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi)))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))))),d_add(d_imul(6,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xr,d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_imul(-6,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(Xr,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_add(d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))),d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_add(d_mul(Xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))),d_mul(d_mul(Xr,Xr),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xi,d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xr,Xr),d_mul(xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_add(d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))),d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))),d_mul(d_mul(Xr,Xr),d_mul(xi,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xi,d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(Xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_add(d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))),d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))))))),d_add(d_imul(-6,d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xi,d_mul(Xr,d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_imul(6,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xi,d_mul(Xr,d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_imul(-6,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(Xr,d_mul(xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))))))),d_add(d_imul(6,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(Xr,d_mul(xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xi,d_mul(Xr,d_mul(xi,d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(Xr,d_mul(xi,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xi,d_mul(Xr,d_mul(xi,d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(Xr,d_mul(xi,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(d_mul(Xi,Xi),d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xi,Xi),d_mul(d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))),d_add(Xr,xr)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(xi,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))))),d_add(d_imul(-12,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(Xr,d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))))),d_add(d_imul(12,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(Xi,d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi)))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))))),d_add(d_imul(-12,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(Xi,d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(Xr,d_mul(xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))))),d_add(d_imul(12,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(Xi,d_mul(Xr,d_mul(xi,d_abs(d_add(Xi,xi)))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(Xr,d_mul(xi,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))))),d_mul(d_abs(d_mul(Xr,Xr)),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))));
xin=d_add(ci,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(Xr,xr))),d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi)))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))),d_mul(xr,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))),d_mul(xi,d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))),d_add(d_imul(-1,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi))),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(Xr,xr))),d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))),d_mul(xr,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))),d_mul(xi,d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(Xi,xi))),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr))),d_add(d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))),d_mul(xi,d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))),d_mul(xr,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xi,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xi,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))))),d_add(d_imul(3,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xi,xi)))))),d_add(d_imul(-3,d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(xi,xi),d_mul(xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(xi,xi),d_mul(xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))),d_add(d_imul(-3,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_imul(3,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xr,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))),d_add(d_imul(3,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xr,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))))),d_add(d_imul(-3,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(d_mul(Xr,Xr),d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))),d_add(d_imul(-3,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(d_mul(Xr,Xr),d_mul(xr,d_abs(d_add(Xi,xi)))))),d_add(d_imul(3,d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xr,Xr),d_mul(xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(-3,d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xr,Xr),d_mul(xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xr,Xr),d_mul(xi,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xr,Xr),d_mul(xi,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_add(d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))),d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_add(d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))),d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr)))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(d_mul(Xi,Xi),d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))))),d_add(d_imul(3,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(d_mul(Xi,Xi),d_mul(xr,d_abs(d_add(Xi,xi)))))),d_add(d_imul(-3,d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xi,Xi),d_mul(xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(3,d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xi,Xi),d_mul(xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(d_mul(Xi,Xi),d_mul(xi,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(xi,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(d_mul(Xi,Xi),d_mul(xi,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(xi,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))),d_add(d_imul(-3,d_mul(d_abs(d_mul(Xr,Xr)),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_diffabs(Xi,xi))))),d_add(d_imul(3,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_diffabs(Xi,xi))))),d_add(d_imul(-3,d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(3,d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_add(d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr)))),d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(xi,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(xi,xi),d_mul(xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(Xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xr,d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_add(d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))),d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xr,d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(Xr,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_add(d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))),d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(d_mul(Xr,Xr),d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xr,Xr),d_mul(xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_add(d_mul(Xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))),d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xi,xi)))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xi,d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi)))))),d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(Xi,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))),d_mul(d_mul(Xr,Xr),d_mul(xi,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))))),d_add(d_imul(6,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xi,d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_imul(-6,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(Xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xi,d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_add(d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))),d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(Xr,d_mul(xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xi,d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xi,d_mul(Xr,d_mul(xi,d_abs(d_add(Xi,xi)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(Xr,d_mul(xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))))),d_add(d_imul(6,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xi,d_mul(Xr,d_mul(xi,d_abs(d_add(Xi,xi))))))),d_add(d_imul(-6,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(Xr,d_mul(xi,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))))))),d_add(d_imul(6,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(Xr,d_mul(xi,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_add(d_mul(d_mul(Xi,Xi),d_mul(xr,d_abs(d_add(Xr,xr)))),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(d_mul(Xi,Xi),d_mul(xi,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xi,Xi),d_mul(xi,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_diffabs(Xr,xr)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))),d_add(d_imul(-12,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_add(d_mul(Xi,d_add(d_mul(Xr,d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_mul(Xr,d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(Xi,d_mul(Xr,d_mul(xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))),d_mul(Xr,d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_add(d_mul(Xr,d_mul(xi,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))),d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))))))),d_mul(d_abs(d_mul(Xr,Xr)),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))))))))))))))))))))))))))))))))))))))))))))))))))))));
}

);

static const char *perturbation_opencl_double_66_6_1 = STR(

{dxan=d_add(d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dya,d_abs(d_mul(Xxr,Xxr)))))),d_add(d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(d_mul(Xxr,Xxr)))))),d_add(d_imul(-1,d_add(d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dya,d_abs(d_mul(Xxi,Xxi)))))),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(d_mul(Xxi,Xxi)))))))),d_add(d_imul(-2,d_mul(d_sgn(Xxi),d_add(d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(d_mul(Xxi,Xxr))))),d_mul(d_sgn(Xxr),d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dya,d_abs(Xxi))))))),d_add(d_imul(2,d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dxa,d_abs(Xxr))))),d_add(d_imul(-2,d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxr)))))),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxi))))))))),d_add(d_imul(2,d_add(d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_add(d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(dxa,d_abs(Xxr))),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dya,d_abs(Xxr)))))))),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dxa,d_abs(d_mul(Xxi,Xxr)))))))),d_add(d_imul(-2,d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(dya,d_abs(Xxi))))),d_add(d_imul(2,d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxa,d_abs(Xxi))))))),d_add(d_imul(-3,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxi))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxi)))),d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr)))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr)))),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(d_mul(Xxr,Xxr)))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(dya,d_abs(Xxi)))),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(d_mul(Xxi,Xxi)))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(d_mul(Xxi,Xxi),d_mul(dya,d_abs(Xxi)))),d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(dxa,d_abs(Xxr)))))),d_add(d_imul(3,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(d_mul(Xxi,Xxi),d_mul(dxa,d_abs(Xxr))))),d_add(d_imul(-3,d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxa,d_abs(d_mul(Xxr,Xxr))))))),d_add(d_imul(3,d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxa,d_abs(d_mul(Xxi,Xxi))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(d_mul(Xxr,Xxr),d_add(d_mul(dxa,d_abs(Xxi)),d_mul(dya,d_abs(Xxr))))),d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_abs(Xxr))))))),d_add(d_imul(6,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_abs(Xxr)))))),d_add(d_imul(-6,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_abs(Xxi)))))),d_add(d_imul(6,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_abs(Xxi)))))),d_add(d_imul(-6,d_add(d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxr))))))),d_add(d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(d_mul(Xxi,Xxr)))))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxi))))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(d_mul(Xxi,Xxi),d_add(d_mul(dxa,d_abs(Xxi)),d_mul(dya,d_abs(Xxr))))),d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dya,d_abs(d_mul(Xxi,Xxr)))))),d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxi))))),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxi)))))))))),d_add(d_imul(-6,d_add(d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr)))))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr))))))),d_add(d_imul(6,d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dya,d_abs(Xxr)))))),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxa,d_abs(Xxi))))))))),d_add(d_imul(12,d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_abs(Xxi)))))),d_add(d_imul(-12,d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_abs(Xxr)))))),daa)))))))))))))))))))))))))));
dxbn=d_add(d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dyb,d_abs(d_mul(Xxr,Xxr)))))),d_add(d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(d_mul(Xxr,Xxr)))))),d_add(d_imul(-1,d_add(d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dyb,d_abs(d_mul(Xxi,Xxi)))))),d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(d_mul(Xxi,Xxi)))))))),d_add(d_imul(-2,d_mul(d_sgn(Xxi),d_add(d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(d_mul(Xxi,Xxr))))),d_mul(d_sgn(Xxr),d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dyb,d_abs(Xxi))))))),d_add(d_imul(2,d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dxb,d_abs(Xxr))))),d_add(d_imul(-2,d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxr)))))),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxi))))))))),d_add(d_imul(2,d_add(d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_add(d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(dxb,d_abs(Xxr))),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dyb,d_abs(Xxr)))))))),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dxb,d_abs(d_mul(Xxi,Xxr)))))))),d_add(d_imul(-2,d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(dyb,d_abs(Xxi))))),d_add(d_imul(2,d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxb,d_abs(Xxi))))))),d_add(d_imul(-3,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxi))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxi)))),d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr)))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr)))),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(d_mul(Xxr,Xxr)))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(dyb,d_abs(Xxi)))),d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(d_mul(Xxi,Xxi)))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(d_mul(Xxi,Xxi),d_mul(dyb,d_abs(Xxi)))),d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(dxb,d_abs(Xxr)))))),d_add(d_imul(3,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(d_mul(Xxi,Xxi),d_mul(dxb,d_abs(Xxr))))),d_add(d_imul(-3,d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxb,d_abs(d_mul(Xxr,Xxr))))))),d_add(d_imul(3,d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxb,d_abs(d_mul(Xxi,Xxi))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(d_mul(Xxr,Xxr),d_add(d_mul(dxb,d_abs(Xxi)),d_mul(dyb,d_abs(Xxr))))),d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_abs(Xxr))))))),d_add(d_imul(6,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_abs(Xxr)))))),d_add(d_imul(-6,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_abs(Xxi)))))),d_add(d_imul(6,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_abs(Xxi)))))),d_add(d_imul(-6,d_add(d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxr))))))),d_add(d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(d_mul(Xxi,Xxr)))))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxi))))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(d_mul(Xxi,Xxi),d_add(d_mul(dxb,d_abs(Xxi)),d_mul(dyb,d_abs(Xxr))))),d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dyb,d_abs(d_mul(Xxi,Xxr)))))),d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxi))))),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxi)))))))))),d_add(d_imul(-6,d_add(d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr)))))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr))))))),d_add(d_imul(6,d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dyb,d_abs(Xxr)))))),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxb,d_abs(Xxi))))))))),d_add(d_imul(12,d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_abs(Xxi)))))),d_add(d_imul(-12,d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_abs(Xxr)))))),dab)))))))))))))))))))))))))));
dyan=d_add(d_mul(d_sgn(Xxi),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(d_mul(Xxr,Xxr)))))),d_add(d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dxa,d_abs(d_mul(Xxi,Xxi)))))),d_add(d_imul(-1,d_add(d_mul(d_sgn(Xxi),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(d_mul(Xxi,Xxi)))))),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dxa,d_abs(d_mul(Xxr,Xxr)))))))),d_add(d_imul(2,d_add(d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dya,d_abs(Xxr))))),d_add(d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(d_mul(Xxi,Xxr)))))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dxa,d_abs(Xxi))))))),d_add(d_imul(-2,d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxi))))))),d_add(d_imul(2,d_add(d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dya,d_abs(d_mul(Xxi,Xxr)))))),d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(dya,d_abs(Xxr)))),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_add(d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(dxa,d_abs(Xxi))),d_mul(Xxi,d_add(d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dya,d_abs(Xxi)))),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr)))))))))))),d_add(d_imul(-2,d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxa,d_abs(Xxr))))))),d_add(d_imul(3,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxr))))),d_add(d_imul(-3,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxr))))),d_add(d_imul(3,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxi))))),d_add(d_imul(-3,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxi))))),d_add(d_imul(3,d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(d_mul(Xxr,Xxr))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(dya,d_abs(Xxr)))),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(d_mul(Xxi,Xxi)))))))),d_add(d_imul(3,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(d_mul(Xxi,Xxi),d_mul(dya,d_abs(Xxr))))),d_add(d_imul(-3,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(dxa,d_abs(Xxi))))),d_add(d_imul(3,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(d_mul(Xxi,Xxi),d_mul(dxa,d_abs(Xxi))))),d_add(d_imul(-3,d_mul(d_sgn(Xxi),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dya,d_abs(d_mul(Xxr,Xxr))))))),d_add(d_imul(3,d_mul(d_sgn(Xxi),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dya,d_abs(d_mul(Xxi,Xxi))))))),d_add(d_imul(-6,d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxi))))),d_add(d_imul(6,d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr))))),d_add(d_imul(-6,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_abs(Xxi)))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxi,d_mul(Xxr,d_mul(dya,d_abs(Xxi))))),d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_abs(Xxr))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxi,d_mul(Xxr,d_mul(dxa,d_abs(Xxr))))),d_mul(d_sgn(Xxi),d_add(d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(d_mul(Xxi,Xxr))))),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxi)))))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(dya,d_abs(Xxi)))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr)))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(dxa,d_abs(Xxr)))),d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxr))))),d_add(d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_add(d_mul(dxa,d_abs(Xxi)),d_mul(dya,d_abs(Xxr))))))),d_add(d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxa,d_abs(d_mul(Xxi,Xxr)))))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxi)))))))))),d_add(d_imul(6,d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dya,d_abs(Xxi))))))),d_add(d_imul(-6,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxa,d_abs(Xxr)))))))),d_add(d_imul(-12,d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(Xxi,d_mul(Xxr,d_add(d_mul(dxa,d_abs(Xxi)),d_mul(dya,d_abs(Xxr))))))),dba))))))))))))))))))))))))))));
dybn=d_add(d_mul(d_sgn(Xxi),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(d_mul(Xxr,Xxr)))))),d_add(d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dxb,d_abs(d_mul(Xxi,Xxi)))))),d_add(d_imul(-1,d_add(d_mul(d_sgn(Xxi),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(d_mul(Xxi,Xxi)))))),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dxb,d_abs(d_mul(Xxr,Xxr)))))))),d_add(d_imul(2,d_add(d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dyb,d_abs(Xxr))))),d_add(d_mul(d_sgn(Xxr),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(d_mul(Xxi,Xxr)))))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dxb,d_abs(Xxi))))))),d_add(d_imul(-2,d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxi))))))),d_add(d_imul(2,d_add(d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dyb,d_abs(d_mul(Xxi,Xxr)))))),d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(dyb,d_abs(Xxr)))),d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_add(d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(dxb,d_abs(Xxi))),d_mul(Xxi,d_add(d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dyb,d_abs(Xxi)))),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr)))))))))))),d_add(d_imul(-2,d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxb,d_abs(Xxr))))))),d_add(d_imul(3,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxr))))),d_add(d_imul(-3,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxr))))),d_add(d_imul(3,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxi))))),d_add(d_imul(-3,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxi))))),d_add(d_imul(3,d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(d_mul(Xxr,Xxr))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(dyb,d_abs(Xxr)))),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(d_mul(Xxi,Xxi)))))))),d_add(d_imul(3,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(d_mul(Xxi,Xxi),d_mul(dyb,d_abs(Xxr))))),d_add(d_imul(-3,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(dxb,d_abs(Xxi))))),d_add(d_imul(3,d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(d_mul(Xxi,Xxi),d_mul(dxb,d_abs(Xxi))))),d_add(d_imul(-3,d_mul(d_sgn(Xxi),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dyb,d_abs(d_mul(Xxr,Xxr))))))),d_add(d_imul(3,d_mul(d_sgn(Xxi),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dyb,d_abs(d_mul(Xxi,Xxi))))))),d_add(d_imul(-6,d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxi))))),d_add(d_imul(6,d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr))))),d_add(d_imul(-6,d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_abs(Xxi)))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxi,d_mul(Xxr,d_mul(dyb,d_abs(Xxi))))),d_mul(d_abs(d_mul(Xxr,Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_abs(Xxr))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(Xxi,Xxi)),d_mul(Xxi,d_mul(Xxr,d_mul(dxb,d_abs(Xxr))))),d_mul(d_sgn(Xxi),d_add(d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(d_mul(Xxi,Xxr))))),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxi)))))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(dyb,d_abs(Xxi)))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr)))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(dxb,d_abs(Xxr)))),d_add(d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxr))))),d_add(d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_add(d_mul(dxb,d_abs(Xxi)),d_mul(dyb,d_abs(Xxr))))))),d_add(d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxb,d_abs(d_mul(Xxi,Xxr)))))),d_mul(d_mul(d_sgn(Xxr),d_sgn(Xxr)),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxi)))))))))),d_add(d_imul(6,d_mul(d_mul(d_sgn(Xxi),d_sgn(Xxi)),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dyb,d_abs(Xxi))))))),d_add(d_imul(-6,d_mul(d_sgn(Xxi),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxb,d_abs(Xxr)))))))),d_add(d_imul(-12,d_mul(d_abs(d_mul(Xxi,Xxr)),d_mul(Xxi,d_mul(Xxr,d_add(d_mul(dxb,d_abs(Xxi)),d_mul(dyb,d_abs(Xxr))))))),dbb))))))))))))))))))))))))))));
}

{xrn=d_add(cr,d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(Xi,xi))),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr))),d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))),d_mul(xi,d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))),d_mul(xr,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(-1,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(Xi,xi))),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr))),d_add(d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))),d_mul(xi,d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))),d_mul(xr,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(xr,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xi,d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))),d_add(d_imul(-2,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi)))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(Xr,xr)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))),d_add(d_imul(-3,d_mul(d_abs(d_mul(Xr,Xr)),d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_imul(3,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_imul(-3,d_mul(d_abs(d_add(Xi,xi)),d_mul(xi,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(3,d_mul(d_abs(d_add(Xi,xi)),d_mul(xi,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(xi,xi),d_mul(xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xr,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))),d_mul(d_mul(xi,xi),d_mul(xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xr,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_add(d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))),d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xr,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(d_mul(Xr,Xr),d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(d_mul(Xr,Xr),d_mul(xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))),d_mul(Xr,d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(d_mul(Xr,Xr),d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xr,Xr),d_mul(xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))))),d_add(d_imul(3,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xi,xi)))))),d_add(d_imul(-3,d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xr,Xr),d_mul(xi,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(3,d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xr,Xr),d_mul(xi,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))),d_add(d_imul(-3,d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_imul(3,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_imul(-3,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))),d_add(d_imul(-3,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))))),d_add(d_imul(3,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi)))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))),d_add(d_imul(3,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi))))),d_add(d_imul(-3,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(3,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(d_mul(Xi,Xi),d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(d_mul(Xi,Xi),d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(d_mul(Xi,Xi),d_mul(xi,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))))),d_add(d_imul(-3,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(d_mul(Xi,Xi),d_mul(xi,d_abs(d_add(Xi,xi)))))),d_add(d_imul(3,d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xi,Xi),d_mul(xi,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_diffabs(Xr,xr)))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xi,Xi),d_mul(xi,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_diffabs(Xr,xr)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xi,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(xi,xi),d_mul(xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(Xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xr,d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi)))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))))),d_add(d_imul(6,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xr,d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_imul(-6,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(Xr,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_add(d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))),d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_add(d_mul(Xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))),d_mul(d_mul(Xr,Xr),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xi,d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xr,Xr),d_mul(xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_add(d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))),d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))),d_mul(d_mul(Xr,Xr),d_mul(xi,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xi,d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(Xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_add(d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))),d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))))))),d_add(d_imul(-6,d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xi,d_mul(Xr,d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_imul(6,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xi,d_mul(Xr,d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_imul(-6,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(Xr,d_mul(xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))))))),d_add(d_imul(6,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(Xr,d_mul(xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xi,d_mul(Xr,d_mul(xi,d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(Xr,d_mul(xi,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xi,d_mul(Xr,d_mul(xi,d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(Xr,d_mul(xi,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(d_mul(Xi,Xi),d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xi,Xi),d_mul(d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))),d_add(Xr,xr)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(xi,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))))),d_add(d_imul(-12,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(Xr,d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))))),d_add(d_imul(12,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(Xi,d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi)))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))))),d_add(d_imul(-12,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(Xi,d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(Xr,d_mul(xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))))),d_add(d_imul(12,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(Xi,d_mul(Xr,d_mul(xi,d_abs(d_add(Xi,xi)))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(Xr,d_mul(xi,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))))),d_mul(d_abs(d_mul(Xr,Xr)),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))));
xin=d_add(ci,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(Xr,xr))),d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi)))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))),d_mul(xr,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))),d_mul(xi,d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))),d_add(d_imul(-1,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi))),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(Xr,xr))),d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))),d_mul(xr,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))),d_mul(xi,d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))))))),d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(Xi,xi))),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr))),d_add(d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))),d_mul(xi,d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))),d_mul(xr,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xi,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xi,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))))),d_add(d_imul(3,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xi,xi)))))),d_add(d_imul(-3,d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(xi,xi),d_mul(xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(xi,xi),d_mul(xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))),d_add(d_imul(-3,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_imul(3,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xr,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))),d_add(d_imul(3,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xr,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))))),d_add(d_imul(-3,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(d_mul(Xr,Xr),d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))),d_add(d_imul(-3,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(d_mul(Xr,Xr),d_mul(xr,d_abs(d_add(Xi,xi)))))),d_add(d_imul(3,d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xr,Xr),d_mul(xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(-3,d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xr,Xr),d_mul(xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xr,Xr),d_mul(xi,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xr,Xr),d_mul(xi,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_add(d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))),d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_add(d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))),d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr)))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(d_mul(Xi,Xi),d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))))),d_add(d_imul(3,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(d_mul(Xi,Xi),d_mul(xr,d_abs(d_add(Xi,xi)))))),d_add(d_imul(-3,d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xi,Xi),d_mul(xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(3,d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xi,Xi),d_mul(xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))),d_add(d_imul(-3,d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(d_mul(Xi,Xi),d_mul(xi,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(xi,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))))))),d_add(d_imul(3,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(d_mul(Xi,Xi),d_mul(xi,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(xi,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))),d_add(d_imul(-3,d_mul(d_abs(d_mul(Xr,Xr)),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_diffabs(Xi,xi))))),d_add(d_imul(3,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_diffabs(Xi,xi))))),d_add(d_imul(-3,d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))),d_add(d_imul(3,d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_add(d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr)))),d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(xi,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(xi,xi),d_mul(xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(Xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xr,d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_add(d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))),d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xr,d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(Xr,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_add(d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))),d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi))))))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(d_mul(Xr,Xr),d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xr,Xr),d_mul(xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_add(d_mul(Xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))),d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xi,xi)))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xi,d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi)))))),d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(Xi,d_mul(d_mul(xr,xr),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))),d_mul(d_mul(Xr,Xr),d_mul(xi,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))))),d_add(d_imul(6,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xi,d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_imul(-6,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(Xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xi,d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_add(d_mul(d_mul(xi,xi),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))),d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(Xr,d_mul(xr,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr))))))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xi,d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_mul(Xr,Xr)),d_mul(Xi,d_mul(Xr,d_mul(xi,d_abs(d_add(Xi,xi)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(Xr,d_mul(xr,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))))),d_add(d_imul(6,d_mul(d_abs(d_mul(Xi,Xi)),d_mul(Xi,d_mul(Xr,d_mul(xi,d_abs(d_add(Xi,xi))))))),d_add(d_imul(-6,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(Xr,d_mul(xi,d_diffabs(d_mul(Xr,Xr),d_add(d_imul(2,d_mul(Xr,xr)),d_mul(xr,xr)))))))),d_add(d_imul(6,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(Xr,d_mul(xi,d_diffabs(d_mul(Xi,Xi),d_add(d_imul(2,d_mul(Xi,xi)),d_mul(xi,xi)))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_add(d_mul(d_mul(Xi,Xi),d_mul(xr,d_abs(d_add(Xr,xr)))),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))))),d_add(d_imul(6,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(d_mul(Xi,Xi),d_mul(xi,d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xi,Xi),d_mul(xi,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_diffabs(Xr,xr)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))),d_add(d_imul(-12,d_add(d_mul(d_abs(d_mul(Xi,Xr)),d_add(d_mul(Xi,d_add(d_mul(Xr,d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_mul(Xr,d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(Xi,d_mul(Xr,d_mul(xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))),d_mul(Xr,d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_add(d_mul(Xr,d_mul(xi,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))),d_mul(xi,d_mul(xr,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr)))))))))))),d_mul(d_abs(d_mul(Xr,Xr)),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))))))))))))))))))))))))))))))))))))))))))))))))))))));
}

);

static const char *perturbation_opencl_floatexp_66_6_0 = STR(

{xrn=fe_add(cr,fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xi,xi))),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xi,xi))),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr))),fe_add(fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi)))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xr,xr)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_add(fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))),fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi)))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_diffabs(Xr,xr)))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_diffabs(Xr,xr)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))))),fe_add(fe_imul(6,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_add(fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))),fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_add(fe_mul(Xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))),fe_mul(fe_mul(Xr,Xr),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xi,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_add(fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))),fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xi,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_add(fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))),fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))))))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(6,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))))))),fe_add(fe_imul(6,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))),fe_add(Xr,xr)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))))),fe_add(fe_imul(12,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(Xi,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))))),fe_add(fe_imul(12,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))))),fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))));
xin=fe_add(ci,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xr,xr))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi)))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xr,xr))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xi,xi))),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr))),fe_add(fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_add(fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))),fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))),fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr)))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_diffabs(Xi,xi))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_diffabs(Xi,xi))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_add(fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_add(fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))),fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_add(fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))),fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_add(fe_mul(Xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xi,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(Xi,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))))),fe_add(fe_imul(6,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xi,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_add(fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))),fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))))),fe_add(fe_imul(6,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))))))),fe_add(fe_imul(6,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_diffabs(Xr,xr)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_add(fe_mul(Xi,fe_add(fe_mul(Xr,fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))),fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_add(fe_mul(Xr,fe_mul(xi,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))),fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))))))),fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))))))))))))))))))))))))))))))))))))))))))))))))))))));
}

);

static const char *perturbation_opencl_floatexp_66_6_1 = STR(

{dxan=fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dya,fe_abs(fe_mul(Xxr,Xxr)))))),fe_add(fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(fe_mul(Xxr,Xxr)))))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dya,fe_abs(fe_mul(Xxi,Xxi)))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(fe_mul(Xxi,Xxi)))))))),fe_add(fe_imul(-2,fe_mul(fe_sgn(Xxi),fe_add(fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(fe_mul(Xxi,Xxr))))),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dya,fe_abs(Xxi))))))),fe_add(fe_imul(2,fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dxa,fe_abs(Xxr))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxr)))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxi))))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_add(fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(dxa,fe_abs(Xxr))),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxr)))))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxa,fe_abs(fe_mul(Xxi,Xxr)))))))),fe_add(fe_imul(-2,fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(dya,fe_abs(Xxi))))),fe_add(fe_imul(2,fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxi))))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxi))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxi)))),fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr)))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr)))),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dya,fe_abs(Xxi)))),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(fe_mul(Xxi,Xxi)))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dya,fe_abs(Xxi)))),fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxa,fe_abs(Xxr)))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxa,fe_abs(Xxr))))),fe_add(fe_imul(-3,fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxa,fe_abs(fe_mul(Xxr,Xxr))))))),fe_add(fe_imul(3,fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxa,fe_abs(fe_mul(Xxi,Xxi))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(fe_mul(Xxr,Xxr),fe_add(fe_mul(dxa,fe_abs(Xxi)),fe_mul(dya,fe_abs(Xxr))))),fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_abs(Xxr))))))),fe_add(fe_imul(6,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_abs(Xxr)))))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxi)))))),fe_add(fe_imul(6,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxi)))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxr))))))),fe_add(fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(fe_mul(Xxi,Xxr)))))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxi))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_add(fe_mul(dxa,fe_abs(Xxi)),fe_mul(dya,fe_abs(Xxr))))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(fe_mul(Xxi,Xxr)))))),fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxi))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxi)))))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr)))))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxr)))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxi))))))))),fe_add(fe_imul(12,fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_abs(Xxi)))))),fe_add(fe_imul(-12,fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxr)))))),daa)))))))))))))))))))))))))));
dxbn=fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dyb,fe_abs(fe_mul(Xxr,Xxr)))))),fe_add(fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(fe_mul(Xxr,Xxr)))))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dyb,fe_abs(fe_mul(Xxi,Xxi)))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(fe_mul(Xxi,Xxi)))))))),fe_add(fe_imul(-2,fe_mul(fe_sgn(Xxi),fe_add(fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(fe_mul(Xxi,Xxr))))),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dyb,fe_abs(Xxi))))))),fe_add(fe_imul(2,fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dxb,fe_abs(Xxr))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxr)))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxi))))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_add(fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(dxb,fe_abs(Xxr))),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxr)))))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxb,fe_abs(fe_mul(Xxi,Xxr)))))))),fe_add(fe_imul(-2,fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(dyb,fe_abs(Xxi))))),fe_add(fe_imul(2,fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxi))))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxi))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxi)))),fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr)))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr)))),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dyb,fe_abs(Xxi)))),fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(fe_mul(Xxi,Xxi)))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dyb,fe_abs(Xxi)))),fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxb,fe_abs(Xxr)))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxb,fe_abs(Xxr))))),fe_add(fe_imul(-3,fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxb,fe_abs(fe_mul(Xxr,Xxr))))))),fe_add(fe_imul(3,fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxb,fe_abs(fe_mul(Xxi,Xxi))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(fe_mul(Xxr,Xxr),fe_add(fe_mul(dxb,fe_abs(Xxi)),fe_mul(dyb,fe_abs(Xxr))))),fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxr))))))),fe_add(fe_imul(6,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxr)))))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxi)))))),fe_add(fe_imul(6,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxi)))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxr))))))),fe_add(fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(fe_mul(Xxi,Xxr)))))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxi))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_add(fe_mul(dxb,fe_abs(Xxi)),fe_mul(dyb,fe_abs(Xxr))))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(fe_mul(Xxi,Xxr)))))),fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxi))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxi)))))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr)))))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxr)))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxi))))))))),fe_add(fe_imul(12,fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxi)))))),fe_add(fe_imul(-12,fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxr)))))),dab)))))))))))))))))))))))))));
dyan=fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(fe_mul(Xxr,Xxr)))))),fe_add(fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxa,fe_abs(fe_mul(Xxi,Xxi)))))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(fe_mul(Xxi,Xxi)))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxa,fe_abs(fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dya,fe_abs(Xxr))))),fe_add(fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(fe_mul(Xxi,Xxr)))))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dxa,fe_abs(Xxi))))))),fe_add(fe_imul(-2,fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxi))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dya,fe_abs(fe_mul(Xxi,Xxr)))))),fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(dya,fe_abs(Xxr)))),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_add(fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(dxa,fe_abs(Xxi))),fe_mul(Xxi,fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxi)))),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr)))))))))))),fe_add(fe_imul(-2,fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxr))))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxr))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxr))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxi))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxi))))),fe_add(fe_imul(3,fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(fe_mul(Xxr,Xxr))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dya,fe_abs(Xxr)))),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(fe_mul(Xxi,Xxi)))))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dya,fe_abs(Xxr))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxa,fe_abs(Xxi))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxa,fe_abs(Xxi))))),fe_add(fe_imul(-3,fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(fe_mul(Xxr,Xxr))))))),fe_add(fe_imul(3,fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(fe_mul(Xxi,Xxi))))))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxi))))),fe_add(fe_imul(6,fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr))))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_abs(Xxi)))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dya,fe_abs(Xxi))))),fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxr))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxr))))),fe_mul(fe_sgn(Xxi),fe_add(fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(fe_mul(Xxi,Xxr))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxi)))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dya,fe_abs(Xxi)))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr)))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxa,fe_abs(Xxr)))),fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxr))))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_add(fe_mul(dxa,fe_abs(Xxi)),fe_mul(dya,fe_abs(Xxr))))))),fe_add(fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxa,fe_abs(fe_mul(Xxi,Xxr)))))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxi)))))))))),fe_add(fe_imul(6,fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxi))))))),fe_add(fe_imul(-6,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxr)))))))),fe_add(fe_imul(-12,fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_add(fe_mul(dxa,fe_abs(Xxi)),fe_mul(dya,fe_abs(Xxr))))))),dba))))))))))))))))))))))))))));
dybn=fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(fe_mul(Xxr,Xxr)))))),fe_add(fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxb,fe_abs(fe_mul(Xxi,Xxi)))))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(fe_mul(Xxi,Xxi)))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxb,fe_abs(fe_mul(Xxr,Xxr)))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dyb,fe_abs(Xxr))))),fe_add(fe_mul(fe_sgn(Xxr),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(fe_mul(Xxi,Xxr)))))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dxb,fe_abs(Xxi))))))),fe_add(fe_imul(-2,fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxi))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dyb,fe_abs(fe_mul(Xxi,Xxr)))))),fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(dyb,fe_abs(Xxr)))),fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_add(fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(dxb,fe_abs(Xxi))),fe_mul(Xxi,fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxi)))),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr)))))))))))),fe_add(fe_imul(-2,fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxr))))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxr))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxr))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxi))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxi))))),fe_add(fe_imul(3,fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(fe_mul(Xxr,Xxr))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dyb,fe_abs(Xxr)))),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(fe_mul(Xxi,Xxi)))))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dyb,fe_abs(Xxr))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxb,fe_abs(Xxi))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxb,fe_abs(Xxi))))),fe_add(fe_imul(-3,fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(fe_mul(Xxr,Xxr))))))),fe_add(fe_imul(3,fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(fe_mul(Xxi,Xxi))))))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxi))))),fe_add(fe_imul(6,fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr))))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxi)))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxi))))),fe_mul(fe_abs(fe_mul(Xxr,Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxr))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxi)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxr))))),fe_mul(fe_sgn(Xxi),fe_add(fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(fe_mul(Xxi,Xxr))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxi)))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dyb,fe_abs(Xxi)))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr)))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxb,fe_abs(Xxr)))),fe_add(fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxr))))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_add(fe_mul(dxb,fe_abs(Xxi)),fe_mul(dyb,fe_abs(Xxr))))))),fe_add(fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxb,fe_abs(fe_mul(Xxi,Xxr)))))),fe_mul(fe_mul(fe_sgn(Xxr),fe_sgn(Xxr)),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxi)))))))))),fe_add(fe_imul(6,fe_mul(fe_mul(fe_sgn(Xxi),fe_sgn(Xxi)),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxi))))))),fe_add(fe_imul(-6,fe_mul(fe_sgn(Xxi),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxr)))))))),fe_add(fe_imul(-12,fe_mul(fe_abs(fe_mul(Xxi,Xxr)),fe_mul(Xxi,fe_mul(Xxr,fe_add(fe_mul(dxb,fe_abs(Xxi)),fe_mul(dyb,fe_abs(Xxr))))))),dbb))))))))))))))))))))))))))));
}

{xrn=fe_add(cr,fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xi,xi))),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xi,xi))),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr))),fe_add(fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))),fe_add(fe_imul(-2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi)))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xr,xr)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_add(fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))),fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi)))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_diffabs(Xr,xr)))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_diffabs(Xr,xr)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))))),fe_add(fe_imul(6,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_add(fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))),fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_add(fe_mul(Xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))),fe_mul(fe_mul(Xr,Xr),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xi,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_add(fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))),fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xi,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_add(fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))),fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))))))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(6,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))))))),fe_add(fe_imul(6,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))),fe_add(Xr,xr)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))))),fe_add(fe_imul(12,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(Xi,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))))),fe_add(fe_imul(12,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))))),fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))));
xin=fe_add(ci,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xr,xr))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi)))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xr,xr))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))))))),fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(Xi,xi))),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr))),fe_add(fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_add(fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))),fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))),fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr)))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))),fe_add(fe_imul(-3,fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))))))),fe_add(fe_imul(3,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_diffabs(Xi,xi))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_diffabs(Xi,xi))))),fe_add(fe_imul(-3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))),fe_add(fe_imul(3,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_add(fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_add(fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))),fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_add(fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))),fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi))))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_add(fe_mul(Xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xi,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(Xi,fe_mul(fe_mul(xr,xr),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))))),fe_add(fe_imul(6,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xi,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_add(fe_mul(fe_mul(xi,xi),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))),fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr))))))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))))),fe_add(fe_imul(6,fe_mul(fe_abs(fe_mul(Xi,Xi)),fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(-6,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_diffabs(fe_mul(Xr,Xr),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_mul(xr,xr)))))))),fe_add(fe_imul(6,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_diffabs(fe_mul(Xi,Xi),fe_add(fe_imul(2,fe_mul(Xi,xi)),fe_mul(xi,xi)))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_diffabs(Xr,xr)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_abs(fe_mul(Xi,Xr)),fe_add(fe_mul(Xi,fe_add(fe_mul(Xr,fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))),fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_add(fe_mul(Xr,fe_mul(xi,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))),fe_mul(xi,fe_mul(xr,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr)))))))))))),fe_mul(fe_abs(fe_mul(Xr,Xr)),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))))))))))))))))))))))))))))))))))))))))))))))))))))));
}

);

#if 0
static const char *perturbation_opencl_softfloat_66_6_0 = STR(

{xrn=sf_add(cr,sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xi,xi))),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xi,xi))),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr))),sf_add(sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi)))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xr,xr)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_add(sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))),sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi)))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_diffabs(Xr,xr)))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_diffabs(Xr,xr)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))))),sf_add(sf_imul(6,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_add(sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))),sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_add(sf_mul(Xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))),sf_mul(sf_mul(Xr,Xr),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xi,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_add(sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))),sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xi,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_add(sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))),sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))))))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(6,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))))))),sf_add(sf_imul(6,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))),sf_add(Xr,xr)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))))),sf_add(sf_imul(12,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(Xi,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))))),sf_add(sf_imul(12,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))))),sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))));
xin=sf_add(ci,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xr,xr))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi)))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xr,xr))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xi,xi))),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr))),sf_add(sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_add(sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))),sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))),sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr)))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_diffabs(Xi,xi))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_diffabs(Xi,xi))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_add(sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_add(sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))),sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_add(sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))),sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_add(sf_mul(Xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xi,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(Xi,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))))),sf_add(sf_imul(6,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xi,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_add(sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))),sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))))),sf_add(sf_imul(6,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))))))),sf_add(sf_imul(6,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_diffabs(Xr,xr)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_add(sf_mul(Xi,sf_add(sf_mul(Xr,sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))),sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_add(sf_mul(Xr,sf_mul(xi,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))),sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))))))),sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))))))))))))))))))))))))))))))))))))))))))))))))))))));
}

);
#endif


static const char *perturbation_opencl_double_67_6_0 = STR(

{xrn=d_add(cr,d_add(d_mul(d_mul(d_mul(xi,xi),d_mul(xi,xi)),d_abs(d_mul(Xr,d_add(Xr,xr)))),d_add(d_mul(d_abs(Xr),d_mul(d_diffabs(Xr,xr),d_add(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi)),d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr))))),d_add(d_mul(d_abs(d_add(Xr,xr)),d_mul(d_diffabs(Xr,xr),d_add(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi)),d_add(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr)),d_add(d_mul(d_mul(xi,xi),d_mul(xi,xi)),d_mul(d_mul(xr,xr),d_mul(xr,xr))))))),d_add(d_imul(-1,d_add(d_mul(d_mul(Xi,Xi),d_mul(d_mul(xr,xr),d_mul(xr,xr))),d_mul(d_mul(xi,xi),d_add(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr)),d_add(d_mul(d_mul(xi,xi),d_mul(xi,xi)),d_mul(d_mul(xr,xr),d_mul(xr,xr))))))),d_add(d_imul(-2,d_mul(Xi,d_mul(xi,d_add(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr)),d_mul(d_mul(xr,xr),d_mul(xr,xr)))))),d_add(d_imul(4,d_add(d_mul(d_abs(Xr),d_mul(Xr,d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(xr,d_mul(d_mul(xr,xr),d_diffabs(Xr,xr))))))),d_add(d_imul(-4,d_mul(Xr,d_mul(d_mul(xi,xi),d_mul(xr,d_mul(xr,xr))))),d_add(d_imul(4,d_add(d_mul(d_abs(Xr),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_mul(xr,d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_mul(xr,d_diffabs(Xr,xr))))))),d_add(d_imul(-4,d_mul(Xr,d_mul(d_mul(Xr,Xr),d_mul(d_mul(xi,xi),xr)))),d_add(d_imul(4,d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(xi,d_mul(d_mul(xi,xi),d_diffabs(Xr,xr))))))),d_add(d_imul(-4,d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(xr,d_add(d_mul(Xr,Xr),d_mul(xr,xr)))))),d_add(d_imul(4,d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(d_mul(Xi,Xi),d_mul(xi,d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(d_mul(Xi,Xi),d_mul(xi,d_diffabs(Xr,xr))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(Xr),d_mul(d_mul(xi,xi),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(xi,xi),d_mul(d_mul(xr,xr),d_diffabs(Xr,xr)))))),d_add(d_imul(6,d_add(d_mul(d_abs(Xi),d_mul(d_mul(xi,xi),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(Xr),d_mul(d_mul(Xr,Xr),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(xi,xi),d_mul(d_mul(xr,xr),d_diffabs(Xi,xi)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xr,Xr),d_mul(d_mul(xr,xr),d_diffabs(Xr,xr)))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(Xr),d_mul(d_mul(Xr,Xr),d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xr,Xr),d_mul(d_mul(xi,xi),d_diffabs(Xr,xr)))))),d_add(d_imul(6,d_add(d_mul(d_abs(Xi),d_mul(d_mul(Xr,Xr),d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xr,Xr),d_mul(d_mul(xi,xi),d_diffabs(Xi,xi)))))),d_add(d_imul(-6,d_add(d_mul(Xi,d_mul(xi,d_mul(d_mul(xi,xi),d_mul(xi,xi)))),d_add(d_mul(d_mul(Xr,Xr),d_mul(d_mul(xi,xi),d_mul(xr,xr))),d_add(d_mul(d_abs(Xr),d_mul(d_mul(Xi,Xi),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(d_mul(xr,xr),d_diffabs(Xr,xr)))))))),d_add(d_imul(6,d_add(d_mul(d_abs(Xi),d_mul(d_mul(Xi,Xi),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(Xr),d_mul(d_mul(Xi,Xi),d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xi,Xi),d_mul(d_mul(xr,xr),d_diffabs(Xi,xi)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(d_mul(xi,xi),d_diffabs(Xr,xr)))))))),d_add(d_imul(-6,d_mul(d_mul(d_mul(Xi,Xi),d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr))),d_add(d_abs(Xr),d_abs(d_add(Xr,xr))))),d_add(d_imul(6,d_mul(d_mul(d_mul(Xi,Xi),d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi))),d_add(d_abs(Xi),d_abs(d_add(Xi,xi))))),d_add(d_imul(-6,d_add(d_mul(Xi,d_mul(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi)),xi)),d_mul(d_mul(Xi,Xi),d_mul(d_mul(Xr,Xr),d_mul(xr,xr))))),d_add(d_imul(-8,d_add(d_mul(d_abs(Xi),d_mul(xi,d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xi,d_mul(xr,d_mul(d_mul(xr,xr),d_diffabs(Xi,xi))))))),d_add(d_imul(8,d_add(d_mul(d_abs(Xi),d_add(d_mul(Xr,d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_mul(xi,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr))))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xr,d_mul(xi,d_mul(d_mul(xi,xi),d_diffabs(Xi,xi)))),d_mul(xi,d_mul(d_mul(xi,xi),d_mul(xr,d_diffabs(Xi,xi)))))))),d_add(d_imul(-8,d_add(d_mul(Xi,d_mul(Xr,d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,xr)),d_mul(xi,d_mul(xr,d_mul(xr,xr)))))),d_add(d_mul(d_abs(Xi),d_add(d_mul(Xi,d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr))),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xr,xr))))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi))),d_mul(xr,d_mul(d_mul(xr,xr),d_diffabs(Xi,xi))))),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_mul(xi,d_diffabs(Xi,xi))))))))),d_add(d_imul(8,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(d_mul(Xi,Xi),d_add(d_mul(Xr,d_diffabs(Xr,xr)),d_mul(xr,d_abs(d_add(Xr,xr))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(d_mul(Xi,Xi),d_mul(d_diffabs(Xi,xi),d_add(Xr,xr))))))),d_add(d_imul(-12,d_add(d_mul(d_abs(Xr),d_mul(Xr,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(d_mul(xi,xi),d_mul(xr,d_diffabs(Xr,xr))))))),d_add(d_imul(12,d_add(d_mul(d_abs(Xi),d_mul(Xr,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xi,xi)))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(d_mul(xi,xi),d_mul(xr,d_diffabs(Xi,xi))))))),d_add(d_imul(-12,d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(xi,d_mul(d_mul(xr,xr),d_diffabs(Xr,xr))))))),d_add(d_imul(12,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(xi,d_mul(d_mul(xr,xr),d_diffabs(Xi,xi))))))),d_add(d_imul(-12,d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_mul(xi,d_diffabs(Xr,xr))))))),d_add(d_imul(12,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xi,xi)))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_mul(xi,d_diffabs(Xi,xi))))))),d_add(d_imul(-12,d_add(d_mul(Xi,d_mul(d_mul(Xr,Xr),d_mul(xi,d_mul(xr,xr)))),d_add(d_mul(d_abs(Xr),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(xr,d_diffabs(Xr,xr)))))))),d_add(d_imul(12,d_add(d_mul(d_abs(Xi),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(xr,d_abs(d_add(Xi,xi)))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(xr,d_diffabs(Xi,xi))))))),d_add(d_imul(-15,d_add(d_mul(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi)),d_mul(xi,xi)),d_mul(d_mul(Xi,Xi),d_mul(d_mul(xi,xi),d_mul(xi,xi))))),d_add(d_imul(-20,d_mul(Xi,d_mul(d_mul(Xi,Xi),d_mul(xi,d_mul(xi,xi))))),d_add(d_imul(-24,d_add(d_mul(d_abs(Xi),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(Xr,d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,d_mul(xr,d_diffabs(Xi,xi)))),d_mul(Xr,d_mul(xi,d_mul(d_mul(xr,xr),d_diffabs(Xi,xi)))))))),d_add(d_imul(24,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(d_mul(xi,xi),d_mul(xr,d_diffabs(Xi,xi))))))),d_add(d_imul(-24,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(Xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(Xr,d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(Xr,d_add(d_mul(xi,d_mul(xr,d_diffabs(Xr,xr))),d_mul(d_mul(xr,xr),d_diffabs(Xi,xi))))))))),d_add(d_imul(24,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(Xr,d_add(d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))),d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi)))))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(Xr,d_mul(xi,d_mul(xr,d_diffabs(Xi,xi)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(Xr,d_mul(d_mul(xi,xi),d_diffabs(Xi,xi)))))))),d_add(d_imul(-24,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_mul(xr,d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_mul(xr,d_diffabs(Xi,xi))))))),d_add(d_imul(24,d_add(d_mul(d_abs(Xi),d_mul(d_mul(Xi,Xi),d_add(d_mul(Xr,d_mul(xi,d_abs(d_add(Xr,xr)))),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_add(d_mul(Xr,d_mul(xi,d_diffabs(Xi,xi))),d_mul(xi,d_mul(xr,d_diffabs(Xi,xi)))))))),d_mul(d_mul(d_mul(xr,xr),d_mul(xr,xr)),d_abs(d_mul(Xr,d_add(Xr,xr))))))))))))))))))))))))))))))))))))))))))))));
xin=d_add(ci,d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,d_add(Xr,xr))),d_add(d_mul(d_mul(xi,xi),d_mul(xi,xi)),d_mul(d_mul(xr,xr),d_mul(xr,xr)))),d_add(d_mul(d_abs(Xi),d_mul(d_diffabs(Xr,xr),d_add(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi)),d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_diffabs(Xi,xi),d_add(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi)),d_add(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr)),d_mul(d_mul(xi,xi),d_mul(xi,xi))))))))),d_add(d_imul(4,d_add(d_mul(d_abs(Xr),d_mul(xi,d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xi,d_mul(xr,d_mul(d_mul(xr,xr),d_diffabs(Xr,xr))))))),d_add(d_imul(-4,d_add(d_mul(d_abs(Xi),d_mul(xi,d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_mul(d_abs(Xr),d_mul(xi,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(xi,d_mul(xr,d_mul(d_mul(xr,xr),d_diffabs(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xi,d_mul(d_mul(xi,xi),d_mul(xr,d_diffabs(Xr,xr))))))))),d_add(d_imul(4,d_add(d_mul(d_abs(Xi),d_mul(xi,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xi,xi)))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(xi,d_mul(d_mul(xi,xi),d_mul(xr,d_diffabs(Xi,xi))))))),d_add(d_imul(-4,d_add(d_mul(d_abs(Xr),d_mul(Xr,d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(xi,d_mul(d_mul(xi,xi),d_diffabs(Xr,xr))))))),d_add(d_imul(4,d_add(d_mul(d_abs(Xi),d_mul(Xr,d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))))),d_add(d_mul(d_abs(Xr),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(xi,d_mul(d_mul(xi,xi),d_diffabs(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_mul(xi,d_diffabs(Xr,xr))))))))),d_add(d_imul(-4,d_add(d_mul(d_abs(Xi),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xi,xi)))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_mul(xi,d_diffabs(Xi,xi))))))),d_add(d_imul(4,d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(xr,d_mul(d_mul(xr,xr),d_diffabs(Xr,xr))))))),d_add(d_imul(-4,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(xr,d_mul(d_mul(xr,xr),d_diffabs(Xi,xi))))))),d_add(d_imul(4,d_mul(d_mul(Xi,d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr)))),d_add(d_abs(Xr),d_abs(d_add(Xr,xr))))),d_add(d_imul(-4,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi))))),d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(d_mul(Xi,Xi),d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(d_mul(Xi,Xi),d_mul(xr,d_diffabs(Xr,xr))))))))),d_add(d_imul(4,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(d_mul(Xi,Xi),d_mul(xr,d_diffabs(Xi,xi)))))),d_add(d_imul(-4,d_mul(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_mul(Xr,d_diffabs(Xr,xr)))),d_add(d_abs(Xr),d_abs(d_add(Xr,xr))))),d_add(d_imul(4,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(d_mul(Xi,Xi),d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_mul(xr,d_abs(d_add(Xi,xi))))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(d_mul(Xi,Xi),d_mul(Xr,d_diffabs(Xi,xi))))))),d_add(d_imul(8,d_add(d_mul(d_abs(Xi),d_add(d_mul(Xi,d_add(d_mul(d_mul(Xi,Xi),d_mul(xi,d_abs(d_add(Xr,xr)))),d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))))),d_mul(Xr,d_add(d_mul(d_mul(Xr,Xr),d_mul(xr,d_abs(d_add(Xr,xr)))),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_add(d_mul(d_mul(Xi,Xi),d_mul(xi,d_diffabs(Xi,xi))),d_mul(xi,d_mul(d_mul(xi,xi),d_diffabs(Xi,xi))))),d_mul(Xr,d_add(d_mul(d_mul(Xr,Xr),d_mul(xr,d_diffabs(Xi,xi))),d_mul(xr,d_mul(d_mul(xr,xr),d_diffabs(Xi,xi))))))))),d_add(d_imul(-12,d_add(d_mul(d_abs(Xi),d_mul(d_mul(xi,xi),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(xi,xi),d_mul(d_mul(xr,xr),d_diffabs(Xi,xi)))))),d_add(d_imul(12,d_add(d_mul(d_abs(Xr),d_mul(Xr,d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(xi,d_mul(d_mul(xr,xr),d_diffabs(Xr,xr))))))),d_add(d_imul(-12,d_add(d_mul(d_abs(Xi),d_mul(Xr,d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(xi,d_mul(d_mul(xr,xr),d_diffabs(Xi,xi))))))),d_add(d_imul(12,d_add(d_mul(d_abs(Xi),d_mul(d_mul(Xr,Xr),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(Xr),d_mul(d_mul(Xr,Xr),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xr,Xr),d_add(d_mul(xi,d_mul(xr,d_diffabs(Xr,xr))),d_mul(d_mul(xr,xr),d_diffabs(Xi,xi)))))))),d_add(d_imul(-12,d_add(d_mul(d_abs(Xi),d_mul(d_mul(Xr,Xr),d_add(d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))),d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xr,Xr),d_mul(xi,d_mul(xr,d_diffabs(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_mul(d_mul(xi,xi),d_mul(xr,d_diffabs(Xr,xr)))),d_mul(d_mul(Xr,Xr),d_mul(d_mul(xi,xi),d_diffabs(Xi,xi))))))))),d_add(d_imul(12,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xi,xi)))))),d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(Xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(d_mul(xi,xi),d_mul(xr,d_diffabs(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(Xr,d_mul(d_mul(xr,xr),d_diffabs(Xr,xr))))))))),d_add(d_imul(-12,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(Xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(Xr,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(Xr,d_mul(d_mul(xr,xr),d_diffabs(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(Xr,d_mul(d_mul(xi,xi),d_diffabs(Xr,xr))))))))),d_add(d_imul(12,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(Xr,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))))),d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(Xr,d_mul(d_mul(xi,xi),d_diffabs(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_mul(xr,d_diffabs(Xr,xr))))))))),d_add(d_imul(-12,d_add(d_mul(d_abs(Xi),d_add(d_mul(d_mul(Xi,Xi),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_mul(d_abs(Xr),d_mul(d_mul(Xi,Xi),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_mul(xr,d_diffabs(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_add(d_mul(xi,d_mul(xr,d_diffabs(Xr,xr))),d_mul(d_mul(xr,xr),d_diffabs(Xi,xi))))))))),d_add(d_imul(12,d_add(d_mul(d_abs(Xi),d_mul(d_mul(Xi,Xi),d_add(d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))),d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xi,Xi),d_mul(xi,d_mul(xr,d_diffabs(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(d_mul(xi,xi),d_diffabs(Xi,xi))))))),d_add(d_imul(-12,d_add(d_mul(d_abs(Xr),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(xi,d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(xi,d_diffabs(Xr,xr))))))),d_add(d_imul(12,d_add(d_mul(d_abs(Xi),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(xi,d_abs(d_add(Xi,xi)))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(xi,d_diffabs(Xi,xi))))))),d_add(d_imul(-12,d_add(d_mul(d_abs(Xi),d_mul(d_mul(Xi,Xi),d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi)))))),d_add(d_imul(-24,d_add(d_mul(d_abs(Xi),d_add(d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(Xi,d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xr,xr)))),d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_mul(Xr,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr)))))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(xr,d_diffabs(Xi,xi)))),d_add(d_mul(Xi,d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,d_diffabs(Xi,xi))),d_mul(xi,d_mul(d_mul(xr,xr),d_diffabs(Xi,xi))))),d_mul(Xr,d_mul(d_mul(xi,xi),d_mul(xr,d_diffabs(Xi,xi))))))))),d_add(d_imul(-48,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(Xr,d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(Xr,d_mul(xi,d_mul(xr,d_diffabs(Xi,xi)))))))),d_imul(2,d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(d_mul(xr,xr),d_mul(xr,xr)),d_diffabs(Xi,xi)))))))))))))))))))))))))))))))))));
}

);

static const char *perturbation_opencl_double_67_6_1 = STR(

{dxan=d_add(d_imul(-2,d_mul(d_sgn(Xxi),d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dya,d_abs(Xxi))))),d_add(d_imul(2,d_mul(d_sgn(Xxr),d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dxa,d_abs(Xxr))))),d_add(d_imul(-2,d_mul(d_sgn(Xxi),d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(dya,d_abs(Xxi))))),d_add(d_imul(2,d_mul(d_sgn(Xxr),d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(dxa,d_abs(Xxr))))),d_add(d_imul(4,d_mul(d_abs(Xxr),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr)))))),d_add(d_imul(-4,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),dxa)))),d_add(d_imul(4,d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dya,d_abs(Xxr)))))),d_add(d_imul(-4,d_mul(Xxi,d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),dya))),d_add(d_imul(-8,d_add(d_mul(d_abs(Xxi),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxr))))),d_add(d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxr)))))),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxi))))))))),d_add(d_imul(8,d_add(d_mul(d_abs(Xxi),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dxa,d_abs(Xxr))))),d_add(d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dya,d_abs(Xxr)))))),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxa,d_abs(Xxi))))))))),d_add(d_imul(-12,d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxr)))))),d_add(d_imul(12,d_mul(d_abs(Xxi),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxi)))))),d_add(d_imul(-12,d_mul(d_abs(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxa,d_abs(Xxr)))))),d_add(d_imul(12,d_add(d_mul(d_abs(Xxi),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxa,d_abs(Xxi))))),d_mul(d_sgn(Xxi),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxi))))))),d_add(d_imul(-12,d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr)))))),d_add(d_imul(-24,d_mul(d_abs(Xxi),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr)))))),d_add(d_imul(24,d_mul(d_abs(Xxi),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dya,d_abs(Xxr)))))),daa)))))))))))))))));
dxbn=d_add(d_imul(-2,d_mul(d_sgn(Xxi),d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dyb,d_abs(Xxi))))),d_add(d_imul(2,d_mul(d_sgn(Xxr),d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dxb,d_abs(Xxr))))),d_add(d_imul(-2,d_mul(d_sgn(Xxi),d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(dyb,d_abs(Xxi))))),d_add(d_imul(2,d_mul(d_sgn(Xxr),d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(dxb,d_abs(Xxr))))),d_add(d_imul(4,d_mul(d_abs(Xxr),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr)))))),d_add(d_imul(-4,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),dxb)))),d_add(d_imul(4,d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dyb,d_abs(Xxr)))))),d_add(d_imul(-4,d_mul(Xxi,d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),dyb))),d_add(d_imul(-8,d_add(d_mul(d_abs(Xxi),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxr))))),d_add(d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxr)))))),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxi))))))))),d_add(d_imul(8,d_add(d_mul(d_abs(Xxi),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dxb,d_abs(Xxr))))),d_add(d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dyb,d_abs(Xxr)))))),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxb,d_abs(Xxi))))))))),d_add(d_imul(-12,d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxr)))))),d_add(d_imul(12,d_mul(d_abs(Xxi),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxi)))))),d_add(d_imul(-12,d_mul(d_abs(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxb,d_abs(Xxr)))))),d_add(d_imul(12,d_add(d_mul(d_abs(Xxi),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxb,d_abs(Xxi))))),d_mul(d_sgn(Xxi),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxi))))))),d_add(d_imul(-12,d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr)))))),d_add(d_imul(-24,d_mul(d_abs(Xxi),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr)))))),d_add(d_imul(24,d_mul(d_abs(Xxi),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dyb,d_abs(Xxr)))))),dab)))))))))))))))));
dyan=d_add(d_imul(2,d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(dya,d_abs(Xxr)),d_add(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr))))),d_mul(d_sgn(Xxr),d_mul(d_mul(dxa,d_abs(Xxi)),d_add(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr))))))),d_add(d_imul(4,d_mul(d_abs(Xxr),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxr)))))),d_add(d_imul(-4,d_add(d_mul(d_abs(Xxi),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxi))))),d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dxa,d_abs(Xxr))))))),d_add(d_imul(4,d_mul(d_abs(Xxi),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dxa,d_abs(Xxi)))))),d_add(d_imul(8,d_mul(d_abs(Xxi),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr)))))),d_add(d_imul(-8,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxi))))))),d_add(d_imul(8,d_add(d_mul(d_abs(Xxi),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dya,d_abs(Xxr))))),d_add(d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dya,d_abs(Xxi)))))),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr))))))))),d_add(d_imul(-8,d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxa,d_abs(Xxr))))))),d_add(d_imul(12,d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr)))))),d_add(d_imul(-12,d_add(d_mul(d_abs(Xxi),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxi))))),d_mul(d_abs(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dya,d_abs(Xxr))))))),d_add(d_imul(12,d_mul(d_abs(Xxi),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dya,d_abs(Xxi)))))),d_add(d_imul(-12,d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxr))))),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxi))))))),d_add(d_imul(-24,d_mul(d_abs(Xxi),d_add(d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxa,d_abs(Xxr)))),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxr))))))),dba)))))))))))));
dybn=d_add(d_imul(2,d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(dyb,d_abs(Xxr)),d_add(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr))))),d_mul(d_sgn(Xxr),d_mul(d_mul(dxb,d_abs(Xxi)),d_add(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr))))))),d_add(d_imul(4,d_mul(d_abs(Xxr),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxr)))))),d_add(d_imul(-4,d_add(d_mul(d_abs(Xxi),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxi))))),d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dxb,d_abs(Xxr))))))),d_add(d_imul(4,d_mul(d_abs(Xxi),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dxb,d_abs(Xxi)))))),d_add(d_imul(8,d_mul(d_abs(Xxi),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr)))))),d_add(d_imul(-8,d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxi))))))),d_add(d_imul(8,d_add(d_mul(d_abs(Xxi),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(dyb,d_abs(Xxr))))),d_add(d_mul(d_sgn(Xxi),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dyb,d_abs(Xxi)))))),d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr))))))))),d_add(d_imul(-8,d_mul(d_sgn(Xxr),d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxb,d_abs(Xxr))))))),d_add(d_imul(12,d_mul(d_abs(Xxr),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr)))))),d_add(d_imul(-12,d_add(d_mul(d_abs(Xxi),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxi))))),d_mul(d_abs(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dyb,d_abs(Xxr))))))),d_add(d_imul(12,d_mul(d_abs(Xxi),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dyb,d_abs(Xxi)))))),d_add(d_imul(-12,d_add(d_mul(d_sgn(Xxi),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxr))))),d_mul(d_sgn(Xxr),d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxi))))))),d_add(d_imul(-24,d_mul(d_abs(Xxi),d_add(d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxb,d_abs(Xxr)))),d_mul(Xxi,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxr))))))),dbb)))))))))))));
}

{xrn=d_add(cr,d_add(d_mul(d_mul(d_mul(xi,xi),d_mul(xi,xi)),d_abs(d_mul(Xr,d_add(Xr,xr)))),d_add(d_mul(d_abs(Xr),d_mul(d_diffabs(Xr,xr),d_add(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi)),d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr))))),d_add(d_mul(d_abs(d_add(Xr,xr)),d_mul(d_diffabs(Xr,xr),d_add(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi)),d_add(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr)),d_add(d_mul(d_mul(xi,xi),d_mul(xi,xi)),d_mul(d_mul(xr,xr),d_mul(xr,xr))))))),d_add(d_imul(-1,d_add(d_mul(d_mul(Xi,Xi),d_mul(d_mul(xr,xr),d_mul(xr,xr))),d_mul(d_mul(xi,xi),d_add(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr)),d_add(d_mul(d_mul(xi,xi),d_mul(xi,xi)),d_mul(d_mul(xr,xr),d_mul(xr,xr))))))),d_add(d_imul(-2,d_mul(Xi,d_mul(xi,d_add(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr)),d_mul(d_mul(xr,xr),d_mul(xr,xr)))))),d_add(d_imul(4,d_add(d_mul(d_abs(Xr),d_mul(Xr,d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(xr,d_mul(d_mul(xr,xr),d_diffabs(Xr,xr))))))),d_add(d_imul(-4,d_mul(Xr,d_mul(d_mul(xi,xi),d_mul(xr,d_mul(xr,xr))))),d_add(d_imul(4,d_add(d_mul(d_abs(Xr),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_mul(xr,d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_mul(xr,d_diffabs(Xr,xr))))))),d_add(d_imul(-4,d_mul(Xr,d_mul(d_mul(Xr,Xr),d_mul(d_mul(xi,xi),xr)))),d_add(d_imul(4,d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(xi,d_mul(d_mul(xi,xi),d_diffabs(Xr,xr))))))),d_add(d_imul(-4,d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(xr,d_add(d_mul(Xr,Xr),d_mul(xr,xr)))))),d_add(d_imul(4,d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(d_mul(Xi,Xi),d_mul(xi,d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(d_mul(Xi,Xi),d_mul(xi,d_diffabs(Xr,xr))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(Xr),d_mul(d_mul(xi,xi),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(xi,xi),d_mul(d_mul(xr,xr),d_diffabs(Xr,xr)))))),d_add(d_imul(6,d_add(d_mul(d_abs(Xi),d_mul(d_mul(xi,xi),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(Xr),d_mul(d_mul(Xr,Xr),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(xi,xi),d_mul(d_mul(xr,xr),d_diffabs(Xi,xi)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xr,Xr),d_mul(d_mul(xr,xr),d_diffabs(Xr,xr)))))))),d_add(d_imul(-6,d_add(d_mul(d_abs(Xr),d_mul(d_mul(Xr,Xr),d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xr,Xr),d_mul(d_mul(xi,xi),d_diffabs(Xr,xr)))))),d_add(d_imul(6,d_add(d_mul(d_abs(Xi),d_mul(d_mul(Xr,Xr),d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xr,Xr),d_mul(d_mul(xi,xi),d_diffabs(Xi,xi)))))),d_add(d_imul(-6,d_add(d_mul(Xi,d_mul(xi,d_mul(d_mul(xi,xi),d_mul(xi,xi)))),d_add(d_mul(d_mul(Xr,Xr),d_mul(d_mul(xi,xi),d_mul(xr,xr))),d_add(d_mul(d_abs(Xr),d_mul(d_mul(Xi,Xi),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(d_mul(xr,xr),d_diffabs(Xr,xr)))))))),d_add(d_imul(6,d_add(d_mul(d_abs(Xi),d_mul(d_mul(Xi,Xi),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))),d_add(d_mul(d_abs(Xr),d_mul(d_mul(Xi,Xi),d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xi,Xi),d_mul(d_mul(xr,xr),d_diffabs(Xi,xi)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(d_mul(xi,xi),d_diffabs(Xr,xr)))))))),d_add(d_imul(-6,d_mul(d_mul(d_mul(Xi,Xi),d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr))),d_add(d_abs(Xr),d_abs(d_add(Xr,xr))))),d_add(d_imul(6,d_mul(d_mul(d_mul(Xi,Xi),d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi))),d_add(d_abs(Xi),d_abs(d_add(Xi,xi))))),d_add(d_imul(-6,d_add(d_mul(Xi,d_mul(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi)),xi)),d_mul(d_mul(Xi,Xi),d_mul(d_mul(Xr,Xr),d_mul(xr,xr))))),d_add(d_imul(-8,d_add(d_mul(d_abs(Xi),d_mul(xi,d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xi,d_mul(xr,d_mul(d_mul(xr,xr),d_diffabs(Xi,xi))))))),d_add(d_imul(8,d_add(d_mul(d_abs(Xi),d_add(d_mul(Xr,d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))),d_mul(xi,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr))))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xr,d_mul(xi,d_mul(d_mul(xi,xi),d_diffabs(Xi,xi)))),d_mul(xi,d_mul(d_mul(xi,xi),d_mul(xr,d_diffabs(Xi,xi)))))))),d_add(d_imul(-8,d_add(d_mul(Xi,d_mul(Xr,d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,xr)),d_mul(xi,d_mul(xr,d_mul(xr,xr)))))),d_add(d_mul(d_abs(Xi),d_add(d_mul(Xi,d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr))),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xr,xr))))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi))),d_mul(xr,d_mul(d_mul(xr,xr),d_diffabs(Xi,xi))))),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_mul(xi,d_diffabs(Xi,xi))))))))),d_add(d_imul(8,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(d_mul(Xi,Xi),d_add(d_mul(Xr,d_diffabs(Xr,xr)),d_mul(xr,d_abs(d_add(Xr,xr))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(d_mul(Xi,Xi),d_mul(d_diffabs(Xi,xi),d_add(Xr,xr))))))),d_add(d_imul(-12,d_add(d_mul(d_abs(Xr),d_mul(Xr,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(d_mul(xi,xi),d_mul(xr,d_diffabs(Xr,xr))))))),d_add(d_imul(12,d_add(d_mul(d_abs(Xi),d_mul(Xr,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xi,xi)))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(d_mul(xi,xi),d_mul(xr,d_diffabs(Xi,xi))))))),d_add(d_imul(-12,d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(xi,d_mul(d_mul(xr,xr),d_diffabs(Xr,xr))))))),d_add(d_imul(12,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(xi,d_mul(d_mul(xr,xr),d_diffabs(Xi,xi))))))),d_add(d_imul(-12,d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_mul(xi,d_diffabs(Xr,xr))))))),d_add(d_imul(12,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xi,xi)))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_mul(xi,d_diffabs(Xi,xi))))))),d_add(d_imul(-12,d_add(d_mul(Xi,d_mul(d_mul(Xr,Xr),d_mul(xi,d_mul(xr,xr)))),d_add(d_mul(d_abs(Xr),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(xr,d_diffabs(Xr,xr)))))))),d_add(d_imul(12,d_add(d_mul(d_abs(Xi),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(xr,d_abs(d_add(Xi,xi)))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(xr,d_diffabs(Xi,xi))))))),d_add(d_imul(-15,d_add(d_mul(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi)),d_mul(xi,xi)),d_mul(d_mul(Xi,Xi),d_mul(d_mul(xi,xi),d_mul(xi,xi))))),d_add(d_imul(-20,d_mul(Xi,d_mul(d_mul(Xi,Xi),d_mul(xi,d_mul(xi,xi))))),d_add(d_imul(-24,d_add(d_mul(d_abs(Xi),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr))))),d_mul(Xr,d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,d_mul(xr,d_diffabs(Xi,xi)))),d_mul(Xr,d_mul(xi,d_mul(d_mul(xr,xr),d_diffabs(Xi,xi)))))))),d_add(d_imul(24,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(d_mul(xi,xi),d_mul(xr,d_diffabs(Xi,xi))))))),d_add(d_imul(-24,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(Xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(Xr,d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(Xr,d_add(d_mul(xi,d_mul(xr,d_diffabs(Xr,xr))),d_mul(d_mul(xr,xr),d_diffabs(Xi,xi))))))))),d_add(d_imul(24,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(Xr,d_add(d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))),d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi)))))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(Xr,d_mul(xi,d_mul(xr,d_diffabs(Xi,xi)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(Xr,d_mul(d_mul(xi,xi),d_diffabs(Xi,xi)))))))),d_add(d_imul(-24,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_mul(xr,d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_mul(xr,d_diffabs(Xi,xi))))))),d_add(d_imul(24,d_add(d_mul(d_abs(Xi),d_mul(d_mul(Xi,Xi),d_add(d_mul(Xr,d_mul(xi,d_abs(d_add(Xr,xr)))),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_add(d_mul(Xr,d_mul(xi,d_diffabs(Xi,xi))),d_mul(xi,d_mul(xr,d_diffabs(Xi,xi)))))))),d_mul(d_mul(d_mul(xr,xr),d_mul(xr,xr)),d_abs(d_mul(Xr,d_add(Xr,xr))))))))))))))))))))))))))))))))))))))))))))));
xin=d_add(ci,d_add(d_imul(2,d_add(d_mul(d_abs(d_mul(Xi,d_add(Xr,xr))),d_add(d_mul(d_mul(xi,xi),d_mul(xi,xi)),d_mul(d_mul(xr,xr),d_mul(xr,xr)))),d_add(d_mul(d_abs(Xi),d_mul(d_diffabs(Xr,xr),d_add(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi)),d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_diffabs(Xi,xi),d_add(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi)),d_add(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr)),d_mul(d_mul(xi,xi),d_mul(xi,xi))))))))),d_add(d_imul(4,d_add(d_mul(d_abs(Xr),d_mul(xi,d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xi,d_mul(xr,d_mul(d_mul(xr,xr),d_diffabs(Xr,xr))))))),d_add(d_imul(-4,d_add(d_mul(d_abs(Xi),d_mul(xi,d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_mul(d_abs(Xr),d_mul(xi,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(xi,d_mul(xr,d_mul(d_mul(xr,xr),d_diffabs(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(xi,d_mul(d_mul(xi,xi),d_mul(xr,d_diffabs(Xr,xr))))))))),d_add(d_imul(4,d_add(d_mul(d_abs(Xi),d_mul(xi,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xi,xi)))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(xi,d_mul(d_mul(xi,xi),d_mul(xr,d_diffabs(Xi,xi))))))),d_add(d_imul(-4,d_add(d_mul(d_abs(Xr),d_mul(Xr,d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(xi,d_mul(d_mul(xi,xi),d_diffabs(Xr,xr))))))),d_add(d_imul(4,d_add(d_mul(d_abs(Xi),d_mul(Xr,d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))))),d_add(d_mul(d_abs(Xr),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(xi,d_mul(d_mul(xi,xi),d_diffabs(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_mul(xi,d_diffabs(Xr,xr))))))))),d_add(d_imul(-4,d_add(d_mul(d_abs(Xi),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xi,xi)))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_mul(xi,d_diffabs(Xi,xi))))))),d_add(d_imul(4,d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(xr,d_mul(d_mul(xr,xr),d_diffabs(Xr,xr))))))),d_add(d_imul(-4,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(xr,d_mul(d_mul(xr,xr),d_diffabs(Xi,xi))))))),d_add(d_imul(4,d_mul(d_mul(Xi,d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr)))),d_add(d_abs(Xr),d_abs(d_add(Xr,xr))))),d_add(d_imul(-4,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi))))),d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(d_mul(Xi,Xi),d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(d_mul(Xi,Xi),d_mul(xr,d_diffabs(Xr,xr))))))))),d_add(d_imul(4,d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(d_mul(Xi,Xi),d_mul(xr,d_diffabs(Xi,xi)))))),d_add(d_imul(-4,d_mul(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_mul(Xr,d_diffabs(Xr,xr)))),d_add(d_abs(Xr),d_abs(d_add(Xr,xr))))),d_add(d_imul(4,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(d_mul(Xi,Xi),d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_mul(xr,d_abs(d_add(Xi,xi))))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(d_mul(Xi,Xi),d_mul(Xr,d_diffabs(Xi,xi))))))),d_add(d_imul(8,d_add(d_mul(d_abs(Xi),d_add(d_mul(Xi,d_add(d_mul(d_mul(Xi,Xi),d_mul(xi,d_abs(d_add(Xr,xr)))),d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))))),d_mul(Xr,d_add(d_mul(d_mul(Xr,Xr),d_mul(xr,d_abs(d_add(Xr,xr)))),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_add(d_mul(d_mul(Xi,Xi),d_mul(xi,d_diffabs(Xi,xi))),d_mul(xi,d_mul(d_mul(xi,xi),d_diffabs(Xi,xi))))),d_mul(Xr,d_add(d_mul(d_mul(Xr,Xr),d_mul(xr,d_diffabs(Xi,xi))),d_mul(xr,d_mul(d_mul(xr,xr),d_diffabs(Xi,xi))))))))),d_add(d_imul(-12,d_add(d_mul(d_abs(Xi),d_mul(d_mul(xi,xi),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(xi,xi),d_mul(d_mul(xr,xr),d_diffabs(Xi,xi)))))),d_add(d_imul(12,d_add(d_mul(d_abs(Xr),d_mul(Xr,d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xr,d_mul(xi,d_mul(d_mul(xr,xr),d_diffabs(Xr,xr))))))),d_add(d_imul(-12,d_add(d_mul(d_abs(Xi),d_mul(Xr,d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(Xr,d_mul(xi,d_mul(d_mul(xr,xr),d_diffabs(Xi,xi))))))),d_add(d_imul(12,d_add(d_mul(d_abs(Xi),d_mul(d_mul(Xr,Xr),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_abs(Xr),d_mul(d_mul(Xr,Xr),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xr,Xr),d_add(d_mul(xi,d_mul(xr,d_diffabs(Xr,xr))),d_mul(d_mul(xr,xr),d_diffabs(Xi,xi)))))))),d_add(d_imul(-12,d_add(d_mul(d_abs(Xi),d_mul(d_mul(Xr,Xr),d_add(d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))),d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xr,Xr),d_mul(xi,d_mul(xr,d_diffabs(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(Xi,d_mul(d_mul(xi,xi),d_mul(xr,d_diffabs(Xr,xr)))),d_mul(d_mul(Xr,Xr),d_mul(d_mul(xi,xi),d_diffabs(Xi,xi))))))))),d_add(d_imul(12,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xi,xi)))))),d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(Xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(d_mul(xi,xi),d_mul(xr,d_diffabs(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(Xr,d_mul(d_mul(xr,xr),d_diffabs(Xr,xr))))))))),d_add(d_imul(-12,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(Xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(Xr,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(Xr,d_mul(d_mul(xr,xr),d_diffabs(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(Xr,d_mul(d_mul(xi,xi),d_diffabs(Xr,xr))))))))),d_add(d_imul(12,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(Xr,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))))),d_add(d_mul(d_abs(Xr),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(Xr,d_mul(d_mul(xi,xi),d_diffabs(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_mul(xr,d_diffabs(Xr,xr))))))))),d_add(d_imul(-12,d_add(d_mul(d_abs(Xi),d_add(d_mul(d_mul(Xi,Xi),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_mul(d_abs(Xr),d_mul(d_mul(Xi,Xi),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_mul(xr,d_diffabs(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_add(d_mul(xi,d_mul(xr,d_diffabs(Xr,xr))),d_mul(d_mul(xr,xr),d_diffabs(Xi,xi))))))))),d_add(d_imul(12,d_add(d_mul(d_abs(Xi),d_mul(d_mul(Xi,Xi),d_add(d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))),d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xi,Xi),d_mul(xi,d_mul(xr,d_diffabs(Xi,xi))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(d_mul(xi,xi),d_diffabs(Xi,xi))))))),d_add(d_imul(-12,d_add(d_mul(d_abs(Xr),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(xi,d_abs(d_add(Xr,xr)))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(xi,d_diffabs(Xr,xr))))))),d_add(d_imul(12,d_add(d_mul(d_abs(Xi),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(xi,d_abs(d_add(Xi,xi)))))),d_mul(d_abs(d_add(Xi,xi)),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(xi,d_diffabs(Xi,xi))))))),d_add(d_imul(-12,d_add(d_mul(d_abs(Xi),d_mul(d_mul(Xi,Xi),d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr)))),d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(Xi,Xi),d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi)))))),d_add(d_imul(-24,d_add(d_mul(d_abs(Xi),d_add(d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr))))),d_add(d_mul(Xi,d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xr,xr)))),d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_mul(Xr,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr)))))))),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(xr,d_diffabs(Xi,xi)))),d_add(d_mul(Xi,d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,d_diffabs(Xi,xi))),d_mul(xi,d_mul(d_mul(xr,xr),d_diffabs(Xi,xi))))),d_mul(Xr,d_mul(d_mul(xi,xi),d_mul(xr,d_diffabs(Xi,xi))))))))),d_add(d_imul(-48,d_add(d_mul(d_abs(Xi),d_mul(Xi,d_mul(Xr,d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr))))))),d_mul(d_abs(d_add(Xr,xr)),d_mul(Xi,d_mul(Xr,d_mul(xi,d_mul(xr,d_diffabs(Xi,xi)))))))),d_imul(2,d_mul(d_abs(d_add(Xr,xr)),d_mul(d_mul(d_mul(xr,xr),d_mul(xr,xr)),d_diffabs(Xi,xi)))))))))))))))))))))))))))))))))));
}

);

static const char *perturbation_opencl_floatexp_67_6_0 = STR(

{xrn=fe_add(cr,fe_add(fe_mul(fe_mul(fe_mul(xi,xi),fe_mul(xi,xi)),fe_abs(fe_mul(Xr,fe_add(Xr,xr)))),fe_add(fe_mul(fe_abs(Xr),fe_mul(fe_diffabs(Xr,xr),fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi)),fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr))))),fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_diffabs(Xr,xr),fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi)),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr)),fe_add(fe_mul(fe_mul(xi,xi),fe_mul(xi,xi)),fe_mul(fe_mul(xr,xr),fe_mul(xr,xr))))))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(xr,xr),fe_mul(xr,xr))),fe_mul(fe_mul(xi,xi),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr)),fe_add(fe_mul(fe_mul(xi,xi),fe_mul(xi,xi)),fe_mul(fe_mul(xr,xr),fe_mul(xr,xr))))))),fe_add(fe_imul(-2,fe_mul(Xi,fe_mul(xi,fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr)),fe_mul(fe_mul(xr,xr),fe_mul(xr,xr)))))),fe_add(fe_imul(4,fe_add(fe_mul(fe_abs(Xr),fe_mul(Xr,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_diffabs(Xr,xr))))))),fe_add(fe_imul(-4,fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_mul(xr,xr))))),fe_add(fe_imul(4,fe_add(fe_mul(fe_abs(Xr),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_diffabs(Xr,xr))))))),fe_add(fe_imul(-4,fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xi,xi),xr)))),fe_add(fe_imul(4,fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_diffabs(Xr,xr))))))),fe_add(fe_imul(-4,fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(xr,fe_add(fe_mul(Xr,Xr),fe_mul(xr,xr)))))),fe_add(fe_imul(4,fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_diffabs(Xr,xr))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(Xr),fe_mul(fe_mul(xi,xi),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(xi,xi),fe_mul(fe_mul(xr,xr),fe_diffabs(Xr,xr)))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(xi,xi),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(xi,xi),fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xr,xr),fe_diffabs(Xr,xr)))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(Xr),fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xi,xi),fe_diffabs(Xr,xr)))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xi,xi),fe_diffabs(Xi,xi)))))),fe_add(fe_imul(-6,fe_add(fe_mul(Xi,fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_mul(xi,xi)))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xi,xi),fe_mul(xr,xr))),fe_add(fe_mul(fe_abs(Xr),fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(xr,xr),fe_diffabs(Xr,xr)))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(xi,xi),fe_diffabs(Xr,xr)))))))),fe_add(fe_imul(-6,fe_mul(fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr))),fe_add(fe_abs(Xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_imul(6,fe_mul(fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi))),fe_add(fe_abs(Xi),fe_abs(fe_add(Xi,xi))))),fe_add(fe_imul(-6,fe_add(fe_mul(Xi,fe_mul(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi)),xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(Xr,Xr),fe_mul(xr,xr))))),fe_add(fe_imul(-8,fe_add(fe_mul(fe_abs(Xi),fe_mul(xi,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xi,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi))))))),fe_add(fe_imul(8,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(Xr,fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xr,fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_diffabs(Xi,xi)))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_diffabs(Xi,xi)))))))),fe_add(fe_imul(-8,fe_add(fe_mul(Xi,fe_mul(Xr,fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,xr)),fe_mul(xi,fe_mul(xr,fe_mul(xr,xr)))))),fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(Xi,fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xr,xr))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi))))),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_diffabs(Xi,xi))))))))),fe_add(fe_imul(8,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(Xr,fe_diffabs(Xr,xr)),fe_mul(xr,fe_abs(fe_add(Xr,xr))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_mul(fe_diffabs(Xi,xi),fe_add(Xr,xr))))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_abs(Xr),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_diffabs(Xr,xr))))))),fe_add(fe_imul(12,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_diffabs(Xi,xi))))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_diffabs(Xr,xr))))))),fe_add(fe_imul(12,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi))))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_diffabs(Xr,xr))))))),fe_add(fe_imul(12,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_diffabs(Xi,xi))))))),fe_add(fe_imul(-12,fe_add(fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_mul(xr,xr)))),fe_add(fe_mul(fe_abs(Xr),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(xr,fe_diffabs(Xr,xr)))))))),fe_add(fe_imul(12,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(xr,fe_diffabs(Xi,xi))))))),fe_add(fe_imul(-15,fe_add(fe_mul(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi)),fe_mul(xi,xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(xi,xi),fe_mul(xi,xi))))),fe_add(fe_imul(-20,fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_mul(xi,xi))))),fe_add(fe_imul(-24,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(Xr,fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_mul(xr,fe_diffabs(Xi,xi)))),fe_mul(Xr,fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi)))))))),fe_add(fe_imul(24,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_diffabs(Xi,xi))))))),fe_add(fe_imul(-24,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(Xr,fe_add(fe_mul(xi,fe_mul(xr,fe_diffabs(Xr,xr))),fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi))))))))),fe_add(fe_imul(24,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(Xr,fe_add(fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi)))))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_diffabs(Xi,xi)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_diffabs(Xi,xi)))))))),fe_add(fe_imul(-24,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_diffabs(Xi,xi))))))),fe_add(fe_imul(24,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xr,xr)))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(Xr,fe_mul(xi,fe_diffabs(Xi,xi))),fe_mul(xi,fe_mul(xr,fe_diffabs(Xi,xi)))))))),fe_mul(fe_mul(fe_mul(xr,xr),fe_mul(xr,xr)),fe_abs(fe_mul(Xr,fe_add(Xr,xr))))))))))))))))))))))))))))))))))))))))))))));
xin=fe_add(ci,fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_add(Xr,xr))),fe_add(fe_mul(fe_mul(xi,xi),fe_mul(xi,xi)),fe_mul(fe_mul(xr,xr),fe_mul(xr,xr)))),fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_diffabs(Xr,xr),fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi)),fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_diffabs(Xi,xi),fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi)),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr)),fe_mul(fe_mul(xi,xi),fe_mul(xi,xi))))))))),fe_add(fe_imul(4,fe_add(fe_mul(fe_abs(Xr),fe_mul(xi,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xi,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_diffabs(Xr,xr))))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_abs(Xi),fe_mul(xi,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xi,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_diffabs(Xr,xr))))))))),fe_add(fe_imul(4,fe_add(fe_mul(fe_abs(Xi),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_diffabs(Xi,xi))))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_abs(Xr),fe_mul(Xr,fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_diffabs(Xr,xr))))))),fe_add(fe_imul(4,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xr,fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_diffabs(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_diffabs(Xr,xr))))))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_diffabs(Xi,xi))))))),fe_add(fe_imul(4,fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_diffabs(Xr,xr))))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi))))))),fe_add(fe_imul(4,fe_mul(fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr)))),fe_add(fe_abs(Xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_mul(xr,fe_diffabs(Xr,xr))))))))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_mul(xr,fe_diffabs(Xi,xi)))))),fe_add(fe_imul(-4,fe_mul(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_diffabs(Xr,xr)))),fe_add(fe_abs(Xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_imul(4,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_diffabs(Xi,xi))))))),fe_add(fe_imul(8,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(Xi,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_abs(fe_add(Xr,xr)))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))))),fe_mul(Xr,fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_diffabs(Xi,xi))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_diffabs(Xi,xi))))),fe_mul(Xr,fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_diffabs(Xi,xi))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi))))))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(xi,xi),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(xi,xi),fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi)))))),fe_add(fe_imul(12,fe_add(fe_mul(fe_abs(Xr),fe_mul(Xr,fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_diffabs(Xr,xr))))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xr,fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi))))))),fe_add(fe_imul(12,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xr,Xr),fe_add(fe_mul(xi,fe_mul(xr,fe_diffabs(Xr,xr))),fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi)))))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(Xr,Xr),fe_add(fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_mul(xr,fe_diffabs(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_diffabs(Xr,xr)))),fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xi,xi),fe_diffabs(Xi,xi))))))))),fe_add(fe_imul(12,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_diffabs(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_diffabs(Xr,xr))))))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_diffabs(Xr,xr))))))))),fe_add(fe_imul(12,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_diffabs(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_diffabs(Xr,xr))))))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_diffabs(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(xi,fe_mul(xr,fe_diffabs(Xr,xr))),fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi))))))))),fe_add(fe_imul(12,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_mul(xr,fe_diffabs(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(xi,xi),fe_diffabs(Xi,xi))))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_abs(Xr),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(xi,fe_diffabs(Xr,xr))))))),fe_add(fe_imul(12,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(xi,fe_diffabs(Xi,xi))))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi)))))),fe_add(fe_imul(-24,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(Xi,fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xr,xr)))),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr)))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(xr,fe_diffabs(Xi,xi)))),fe_add(fe_mul(Xi,fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_diffabs(Xi,xi))),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi))))),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_diffabs(Xi,xi))))))))),fe_add(fe_imul(-48,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_diffabs(Xi,xi)))))))),fe_imul(2,fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(fe_mul(xr,xr),fe_mul(xr,xr)),fe_diffabs(Xi,xi)))))))))))))))))))))))))))))))))));
}

);

static const char *perturbation_opencl_floatexp_67_6_1 = STR(

{dxan=fe_add(fe_imul(-2,fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dya,fe_abs(Xxi))))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dxa,fe_abs(Xxr))))),fe_add(fe_imul(-2,fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(dya,fe_abs(Xxi))))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(dxa,fe_abs(Xxr))))),fe_add(fe_imul(4,fe_mul(fe_abs(Xxr),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr)))))),fe_add(fe_imul(-4,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),dxa)))),fe_add(fe_imul(4,fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dya,fe_abs(Xxr)))))),fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),dya))),fe_add(fe_imul(-8,fe_add(fe_mul(fe_abs(Xxi),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxr))))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxr)))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxi))))))))),fe_add(fe_imul(8,fe_add(fe_mul(fe_abs(Xxi),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxa,fe_abs(Xxr))))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxr)))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxi))))))))),fe_add(fe_imul(-12,fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxr)))))),fe_add(fe_imul(12,fe_mul(fe_abs(Xxi),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxi)))))),fe_add(fe_imul(-12,fe_mul(fe_abs(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxr)))))),fe_add(fe_imul(12,fe_add(fe_mul(fe_abs(Xxi),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxi))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxi))))))),fe_add(fe_imul(-12,fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr)))))),fe_add(fe_imul(-24,fe_mul(fe_abs(Xxi),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr)))))),fe_add(fe_imul(24,fe_mul(fe_abs(Xxi),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxr)))))),daa)))))))))))))))));
dxbn=fe_add(fe_imul(-2,fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dyb,fe_abs(Xxi))))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dxb,fe_abs(Xxr))))),fe_add(fe_imul(-2,fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(dyb,fe_abs(Xxi))))),fe_add(fe_imul(2,fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(dxb,fe_abs(Xxr))))),fe_add(fe_imul(4,fe_mul(fe_abs(Xxr),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr)))))),fe_add(fe_imul(-4,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),dxb)))),fe_add(fe_imul(4,fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dyb,fe_abs(Xxr)))))),fe_add(fe_imul(-4,fe_mul(Xxi,fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),dyb))),fe_add(fe_imul(-8,fe_add(fe_mul(fe_abs(Xxi),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxr))))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxr)))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxi))))))))),fe_add(fe_imul(8,fe_add(fe_mul(fe_abs(Xxi),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxb,fe_abs(Xxr))))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxr)))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxi))))))))),fe_add(fe_imul(-12,fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxr)))))),fe_add(fe_imul(12,fe_mul(fe_abs(Xxi),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxi)))))),fe_add(fe_imul(-12,fe_mul(fe_abs(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxr)))))),fe_add(fe_imul(12,fe_add(fe_mul(fe_abs(Xxi),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxi))))),fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxi))))))),fe_add(fe_imul(-12,fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr)))))),fe_add(fe_imul(-24,fe_mul(fe_abs(Xxi),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr)))))),fe_add(fe_imul(24,fe_mul(fe_abs(Xxi),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxr)))))),dab)))))))))))))))));
dyan=fe_add(fe_imul(2,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(dya,fe_abs(Xxr)),fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr))))),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(dxa,fe_abs(Xxi)),fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr))))))),fe_add(fe_imul(4,fe_mul(fe_abs(Xxr),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxr)))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_abs(Xxi),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxi))))),fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxa,fe_abs(Xxr))))))),fe_add(fe_imul(4,fe_mul(fe_abs(Xxi),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxa,fe_abs(Xxi)))))),fe_add(fe_imul(8,fe_mul(fe_abs(Xxi),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr)))))),fe_add(fe_imul(-8,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxi))))))),fe_add(fe_imul(8,fe_add(fe_mul(fe_abs(Xxi),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dya,fe_abs(Xxr))))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxi)))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr))))))))),fe_add(fe_imul(-8,fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxr))))))),fe_add(fe_imul(12,fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr)))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_abs(Xxi),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxi))))),fe_mul(fe_abs(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxr))))))),fe_add(fe_imul(12,fe_mul(fe_abs(Xxi),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxi)))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxr))))),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxi))))))),fe_add(fe_imul(-24,fe_mul(fe_abs(Xxi),fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxr)))),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxr))))))),dba)))))))))))));
dybn=fe_add(fe_imul(2,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(dyb,fe_abs(Xxr)),fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr))))),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(dxb,fe_abs(Xxi)),fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr))))))),fe_add(fe_imul(4,fe_mul(fe_abs(Xxr),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxr)))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_abs(Xxi),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxi))))),fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxb,fe_abs(Xxr))))))),fe_add(fe_imul(4,fe_mul(fe_abs(Xxi),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dxb,fe_abs(Xxi)))))),fe_add(fe_imul(8,fe_mul(fe_abs(Xxi),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr)))))),fe_add(fe_imul(-8,fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxi))))))),fe_add(fe_imul(8,fe_add(fe_mul(fe_abs(Xxi),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(dyb,fe_abs(Xxr))))),fe_add(fe_mul(fe_sgn(Xxi),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxi)))))),fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr))))))))),fe_add(fe_imul(-8,fe_mul(fe_sgn(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxr))))))),fe_add(fe_imul(12,fe_mul(fe_abs(Xxr),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr)))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_abs(Xxi),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxi))))),fe_mul(fe_abs(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxr))))))),fe_add(fe_imul(12,fe_mul(fe_abs(Xxi),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxi)))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_sgn(Xxi),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxr))))),fe_mul(fe_sgn(Xxr),fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxi))))))),fe_add(fe_imul(-24,fe_mul(fe_abs(Xxi),fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxr)))),fe_mul(Xxi,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxr))))))),dbb)))))))))))));
}

{xrn=fe_add(cr,fe_add(fe_mul(fe_mul(fe_mul(xi,xi),fe_mul(xi,xi)),fe_abs(fe_mul(Xr,fe_add(Xr,xr)))),fe_add(fe_mul(fe_abs(Xr),fe_mul(fe_diffabs(Xr,xr),fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi)),fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr))))),fe_add(fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_diffabs(Xr,xr),fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi)),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr)),fe_add(fe_mul(fe_mul(xi,xi),fe_mul(xi,xi)),fe_mul(fe_mul(xr,xr),fe_mul(xr,xr))))))),fe_add(fe_imul(-1,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(xr,xr),fe_mul(xr,xr))),fe_mul(fe_mul(xi,xi),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr)),fe_add(fe_mul(fe_mul(xi,xi),fe_mul(xi,xi)),fe_mul(fe_mul(xr,xr),fe_mul(xr,xr))))))),fe_add(fe_imul(-2,fe_mul(Xi,fe_mul(xi,fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr)),fe_mul(fe_mul(xr,xr),fe_mul(xr,xr)))))),fe_add(fe_imul(4,fe_add(fe_mul(fe_abs(Xr),fe_mul(Xr,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_diffabs(Xr,xr))))))),fe_add(fe_imul(-4,fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_mul(xr,xr))))),fe_add(fe_imul(4,fe_add(fe_mul(fe_abs(Xr),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_diffabs(Xr,xr))))))),fe_add(fe_imul(-4,fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xi,xi),xr)))),fe_add(fe_imul(4,fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_diffabs(Xr,xr))))))),fe_add(fe_imul(-4,fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(xr,fe_add(fe_mul(Xr,Xr),fe_mul(xr,xr)))))),fe_add(fe_imul(4,fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_diffabs(Xr,xr))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(Xr),fe_mul(fe_mul(xi,xi),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(xi,xi),fe_mul(fe_mul(xr,xr),fe_diffabs(Xr,xr)))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(xi,xi),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(xi,xi),fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xr,xr),fe_diffabs(Xr,xr)))))))),fe_add(fe_imul(-6,fe_add(fe_mul(fe_abs(Xr),fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xi,xi),fe_diffabs(Xr,xr)))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xi,xi),fe_diffabs(Xi,xi)))))),fe_add(fe_imul(-6,fe_add(fe_mul(Xi,fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_mul(xi,xi)))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xi,xi),fe_mul(xr,xr))),fe_add(fe_mul(fe_abs(Xr),fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(xr,xr),fe_diffabs(Xr,xr)))))))),fe_add(fe_imul(6,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(xi,xi),fe_diffabs(Xr,xr)))))))),fe_add(fe_imul(-6,fe_mul(fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr))),fe_add(fe_abs(Xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_imul(6,fe_mul(fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi))),fe_add(fe_abs(Xi),fe_abs(fe_add(Xi,xi))))),fe_add(fe_imul(-6,fe_add(fe_mul(Xi,fe_mul(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi)),xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(Xr,Xr),fe_mul(xr,xr))))),fe_add(fe_imul(-8,fe_add(fe_mul(fe_abs(Xi),fe_mul(xi,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xi,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi))))))),fe_add(fe_imul(8,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(Xr,fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xr,fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_diffabs(Xi,xi)))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_diffabs(Xi,xi)))))))),fe_add(fe_imul(-8,fe_add(fe_mul(Xi,fe_mul(Xr,fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,xr)),fe_mul(xi,fe_mul(xr,fe_mul(xr,xr)))))),fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(Xi,fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xr,xr))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi))))),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_diffabs(Xi,xi))))))))),fe_add(fe_imul(8,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(Xr,fe_diffabs(Xr,xr)),fe_mul(xr,fe_abs(fe_add(Xr,xr))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_mul(fe_diffabs(Xi,xi),fe_add(Xr,xr))))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_abs(Xr),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_diffabs(Xr,xr))))))),fe_add(fe_imul(12,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_diffabs(Xi,xi))))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_diffabs(Xr,xr))))))),fe_add(fe_imul(12,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi))))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_diffabs(Xr,xr))))))),fe_add(fe_imul(12,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_diffabs(Xi,xi))))))),fe_add(fe_imul(-12,fe_add(fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_mul(xr,xr)))),fe_add(fe_mul(fe_abs(Xr),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(xr,fe_diffabs(Xr,xr)))))))),fe_add(fe_imul(12,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(xr,fe_diffabs(Xi,xi))))))),fe_add(fe_imul(-15,fe_add(fe_mul(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi)),fe_mul(xi,xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(xi,xi),fe_mul(xi,xi))))),fe_add(fe_imul(-20,fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_mul(xi,xi))))),fe_add(fe_imul(-24,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_mul(Xr,fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_mul(xr,fe_diffabs(Xi,xi)))),fe_mul(Xr,fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi)))))))),fe_add(fe_imul(24,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_diffabs(Xi,xi))))))),fe_add(fe_imul(-24,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(Xr,fe_add(fe_mul(xi,fe_mul(xr,fe_diffabs(Xr,xr))),fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi))))))))),fe_add(fe_imul(24,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(Xr,fe_add(fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi)))))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_diffabs(Xi,xi)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_diffabs(Xi,xi)))))))),fe_add(fe_imul(-24,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_diffabs(Xi,xi))))))),fe_add(fe_imul(24,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xr,xr)))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(Xr,fe_mul(xi,fe_diffabs(Xi,xi))),fe_mul(xi,fe_mul(xr,fe_diffabs(Xi,xi)))))))),fe_mul(fe_mul(fe_mul(xr,xr),fe_mul(xr,xr)),fe_abs(fe_mul(Xr,fe_add(Xr,xr))))))))))))))))))))))))))))))))))))))))))))));
xin=fe_add(ci,fe_add(fe_imul(2,fe_add(fe_mul(fe_abs(fe_mul(Xi,fe_add(Xr,xr))),fe_add(fe_mul(fe_mul(xi,xi),fe_mul(xi,xi)),fe_mul(fe_mul(xr,xr),fe_mul(xr,xr)))),fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_diffabs(Xr,xr),fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi)),fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_diffabs(Xi,xi),fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi)),fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr)),fe_mul(fe_mul(xi,xi),fe_mul(xi,xi))))))))),fe_add(fe_imul(4,fe_add(fe_mul(fe_abs(Xr),fe_mul(xi,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xi,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_diffabs(Xr,xr))))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_abs(Xi),fe_mul(xi,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xi,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_diffabs(Xr,xr))))))))),fe_add(fe_imul(4,fe_add(fe_mul(fe_abs(Xi),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_diffabs(Xi,xi))))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_abs(Xr),fe_mul(Xr,fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_diffabs(Xr,xr))))))),fe_add(fe_imul(4,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xr,fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_diffabs(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_diffabs(Xr,xr))))))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_diffabs(Xi,xi))))))),fe_add(fe_imul(4,fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_diffabs(Xr,xr))))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi))))))),fe_add(fe_imul(4,fe_mul(fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr)))),fe_add(fe_abs(Xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_imul(-4,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_mul(xr,fe_diffabs(Xr,xr))))))))),fe_add(fe_imul(4,fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_mul(xr,fe_diffabs(Xi,xi)))))),fe_add(fe_imul(-4,fe_mul(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_diffabs(Xr,xr)))),fe_add(fe_abs(Xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_imul(4,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_diffabs(Xi,xi))))))),fe_add(fe_imul(8,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(Xi,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_abs(fe_add(Xr,xr)))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))))),fe_mul(Xr,fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_diffabs(Xi,xi))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_diffabs(Xi,xi))))),fe_mul(Xr,fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_diffabs(Xi,xi))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi))))))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(xi,xi),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(xi,xi),fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi)))))),fe_add(fe_imul(12,fe_add(fe_mul(fe_abs(Xr),fe_mul(Xr,fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xr,fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_diffabs(Xr,xr))))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xr,fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xr,fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi))))))),fe_add(fe_imul(12,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xr,Xr),fe_add(fe_mul(xi,fe_mul(xr,fe_diffabs(Xr,xr))),fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi)))))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(Xr,Xr),fe_add(fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_mul(xr,fe_diffabs(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_diffabs(Xr,xr)))),fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xi,xi),fe_diffabs(Xi,xi))))))))),fe_add(fe_imul(12,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_diffabs(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_diffabs(Xr,xr))))))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_diffabs(Xr,xr))))))))),fe_add(fe_imul(12,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_diffabs(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_diffabs(Xr,xr))))))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_mul(fe_abs(Xr),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_diffabs(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(xi,fe_mul(xr,fe_diffabs(Xr,xr))),fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi))))))))),fe_add(fe_imul(12,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_mul(xr,fe_diffabs(Xi,xi))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(xi,xi),fe_diffabs(Xi,xi))))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_abs(Xr),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(xi,fe_diffabs(Xr,xr))))))),fe_add(fe_imul(12,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_mul(fe_abs(fe_add(Xi,xi)),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(xi,fe_diffabs(Xi,xi))))))),fe_add(fe_imul(-12,fe_add(fe_mul(fe_abs(Xi),fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr)))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi)))))),fe_add(fe_imul(-24,fe_add(fe_mul(fe_abs(Xi),fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(Xi,fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xr,xr)))),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr)))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(xr,fe_diffabs(Xi,xi)))),fe_add(fe_mul(Xi,fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_diffabs(Xi,xi))),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_diffabs(Xi,xi))))),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_diffabs(Xi,xi))))))))),fe_add(fe_imul(-48,fe_add(fe_mul(fe_abs(Xi),fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))))),fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_diffabs(Xi,xi)))))))),fe_imul(2,fe_mul(fe_abs(fe_add(Xr,xr)),fe_mul(fe_mul(fe_mul(xr,xr),fe_mul(xr,xr)),fe_diffabs(Xi,xi)))))))))))))))))))))))))))))))))));
}

);

#if 0
static const char *perturbation_opencl_softfloat_67_6_0 = STR(

{xrn=sf_add(cr,sf_add(sf_mul(sf_mul(sf_mul(xi,xi),sf_mul(xi,xi)),sf_abs(sf_mul(Xr,sf_add(Xr,xr)))),sf_add(sf_mul(sf_abs(Xr),sf_mul(sf_diffabs(Xr,xr),sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi)),sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr))))),sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_diffabs(Xr,xr),sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi)),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr)),sf_add(sf_mul(sf_mul(xi,xi),sf_mul(xi,xi)),sf_mul(sf_mul(xr,xr),sf_mul(xr,xr))))))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(xr,xr),sf_mul(xr,xr))),sf_mul(sf_mul(xi,xi),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr)),sf_add(sf_mul(sf_mul(xi,xi),sf_mul(xi,xi)),sf_mul(sf_mul(xr,xr),sf_mul(xr,xr))))))),sf_add(sf_imul(-2,sf_mul(Xi,sf_mul(xi,sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr)),sf_mul(sf_mul(xr,xr),sf_mul(xr,xr)))))),sf_add(sf_imul(4,sf_add(sf_mul(sf_abs(Xr),sf_mul(Xr,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_diffabs(Xr,xr))))))),sf_add(sf_imul(-4,sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_mul(xr,xr))))),sf_add(sf_imul(4,sf_add(sf_mul(sf_abs(Xr),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_diffabs(Xr,xr))))))),sf_add(sf_imul(-4,sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xi,xi),xr)))),sf_add(sf_imul(4,sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_diffabs(Xr,xr))))))),sf_add(sf_imul(-4,sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(xr,sf_add(sf_mul(Xr,Xr),sf_mul(xr,xr)))))),sf_add(sf_imul(4,sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_diffabs(Xr,xr))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(Xr),sf_mul(sf_mul(xi,xi),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(xi,xi),sf_mul(sf_mul(xr,xr),sf_diffabs(Xr,xr)))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(xi,xi),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(xi,xi),sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xr,xr),sf_diffabs(Xr,xr)))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(Xr),sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xi,xi),sf_diffabs(Xr,xr)))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xi,xi),sf_diffabs(Xi,xi)))))),sf_add(sf_imul(-6,sf_add(sf_mul(Xi,sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_mul(xi,xi)))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xi,xi),sf_mul(xr,xr))),sf_add(sf_mul(sf_abs(Xr),sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(xr,xr),sf_diffabs(Xr,xr)))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(xi,xi),sf_diffabs(Xr,xr)))))))),sf_add(sf_imul(-6,sf_mul(sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr))),sf_add(sf_abs(Xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_imul(6,sf_mul(sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi))),sf_add(sf_abs(Xi),sf_abs(sf_add(Xi,xi))))),sf_add(sf_imul(-6,sf_add(sf_mul(Xi,sf_mul(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi)),xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(Xr,Xr),sf_mul(xr,xr))))),sf_add(sf_imul(-8,sf_add(sf_mul(sf_abs(Xi),sf_mul(xi,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xi,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi))))))),sf_add(sf_imul(8,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(Xr,sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xr,sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_diffabs(Xi,xi)))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_diffabs(Xi,xi)))))))),sf_add(sf_imul(-8,sf_add(sf_mul(Xi,sf_mul(Xr,sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,xr)),sf_mul(xi,sf_mul(xr,sf_mul(xr,xr)))))),sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(Xi,sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xr,xr))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi))))),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_diffabs(Xi,xi))))))))),sf_add(sf_imul(8,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(Xr,sf_diffabs(Xr,xr)),sf_mul(xr,sf_abs(sf_add(Xr,xr))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_mul(sf_diffabs(Xi,xi),sf_add(Xr,xr))))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_abs(Xr),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_diffabs(Xr,xr))))))),sf_add(sf_imul(12,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_diffabs(Xi,xi))))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_diffabs(Xr,xr))))))),sf_add(sf_imul(12,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi))))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_diffabs(Xr,xr))))))),sf_add(sf_imul(12,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_diffabs(Xi,xi))))))),sf_add(sf_imul(-12,sf_add(sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_mul(xr,xr)))),sf_add(sf_mul(sf_abs(Xr),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(xr,sf_diffabs(Xr,xr)))))))),sf_add(sf_imul(12,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(xr,sf_diffabs(Xi,xi))))))),sf_add(sf_imul(-15,sf_add(sf_mul(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi)),sf_mul(xi,xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(xi,xi),sf_mul(xi,xi))))),sf_add(sf_imul(-20,sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_mul(xi,xi))))),sf_add(sf_imul(-24,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(Xr,sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_mul(xr,sf_diffabs(Xi,xi)))),sf_mul(Xr,sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi)))))))),sf_add(sf_imul(24,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_diffabs(Xi,xi))))))),sf_add(sf_imul(-24,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(Xr,sf_add(sf_mul(xi,sf_mul(xr,sf_diffabs(Xr,xr))),sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi))))))))),sf_add(sf_imul(24,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(Xr,sf_add(sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi)))))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_diffabs(Xi,xi)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_diffabs(Xi,xi)))))))),sf_add(sf_imul(-24,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_diffabs(Xi,xi))))))),sf_add(sf_imul(24,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xr,xr)))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(Xr,sf_mul(xi,sf_diffabs(Xi,xi))),sf_mul(xi,sf_mul(xr,sf_diffabs(Xi,xi)))))))),sf_mul(sf_mul(sf_mul(xr,xr),sf_mul(xr,xr)),sf_abs(sf_mul(Xr,sf_add(Xr,xr))))))))))))))))))))))))))))))))))))))))))))));
xin=sf_add(ci,sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_add(Xr,xr))),sf_add(sf_mul(sf_mul(xi,xi),sf_mul(xi,xi)),sf_mul(sf_mul(xr,xr),sf_mul(xr,xr)))),sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_diffabs(Xr,xr),sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi)),sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_diffabs(Xi,xi),sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi)),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr)),sf_mul(sf_mul(xi,xi),sf_mul(xi,xi))))))))),sf_add(sf_imul(4,sf_add(sf_mul(sf_abs(Xr),sf_mul(xi,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xi,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_diffabs(Xr,xr))))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_abs(Xi),sf_mul(xi,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xi,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_diffabs(Xr,xr))))))))),sf_add(sf_imul(4,sf_add(sf_mul(sf_abs(Xi),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_diffabs(Xi,xi))))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_abs(Xr),sf_mul(Xr,sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_diffabs(Xr,xr))))))),sf_add(sf_imul(4,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xr,sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_diffabs(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_diffabs(Xr,xr))))))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_diffabs(Xi,xi))))))),sf_add(sf_imul(4,sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_diffabs(Xr,xr))))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi))))))),sf_add(sf_imul(4,sf_mul(sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr)))),sf_add(sf_abs(Xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_mul(xr,sf_diffabs(Xr,xr))))))))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_mul(xr,sf_diffabs(Xi,xi)))))),sf_add(sf_imul(-4,sf_mul(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_diffabs(Xr,xr)))),sf_add(sf_abs(Xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_imul(4,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_diffabs(Xi,xi))))))),sf_add(sf_imul(8,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(Xi,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_abs(sf_add(Xr,xr)))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))))),sf_mul(Xr,sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_diffabs(Xi,xi))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_diffabs(Xi,xi))))),sf_mul(Xr,sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_diffabs(Xi,xi))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi))))))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(xi,xi),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(xi,xi),sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi)))))),sf_add(sf_imul(12,sf_add(sf_mul(sf_abs(Xr),sf_mul(Xr,sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_diffabs(Xr,xr))))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xr,sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi))))))),sf_add(sf_imul(12,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xr,Xr),sf_add(sf_mul(xi,sf_mul(xr,sf_diffabs(Xr,xr))),sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi)))))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(Xr,Xr),sf_add(sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_mul(xr,sf_diffabs(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_diffabs(Xr,xr)))),sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xi,xi),sf_diffabs(Xi,xi))))))))),sf_add(sf_imul(12,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_diffabs(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_diffabs(Xr,xr))))))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_diffabs(Xr,xr))))))))),sf_add(sf_imul(12,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_diffabs(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_diffabs(Xr,xr))))))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_diffabs(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(xi,sf_mul(xr,sf_diffabs(Xr,xr))),sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi))))))))),sf_add(sf_imul(12,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_mul(xr,sf_diffabs(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(xi,xi),sf_diffabs(Xi,xi))))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_abs(Xr),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(xi,sf_diffabs(Xr,xr))))))),sf_add(sf_imul(12,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(xi,sf_diffabs(Xi,xi))))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi)))))),sf_add(sf_imul(-24,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(Xi,sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xr,xr)))),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr)))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(xr,sf_diffabs(Xi,xi)))),sf_add(sf_mul(Xi,sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_diffabs(Xi,xi))),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi))))),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_diffabs(Xi,xi))))))))),sf_add(sf_imul(-48,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_diffabs(Xi,xi)))))))),sf_imul(2,sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(sf_mul(xr,xr),sf_mul(xr,xr)),sf_diffabs(Xi,xi)))))))))))))))))))))))))))))))))));
}

);
#endif


static const char *perturbation_opencl_double_68_6_0 = STR(

{xrn=d_add(cr,d_add(d_mul(Xr,d_mul(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr)),d_diffabs(Xr,xr))),d_add(d_imul(-1,d_add(d_mul(Xi,d_mul(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi)),d_diffabs(Xi,xi))),d_mul(xi,d_mul(d_mul(d_mul(xi,xi),d_mul(xi,xi)),d_abs(d_add(Xi,xi)))))),d_add(d_imul(-5,d_mul(xi,d_mul(d_mul(d_mul(xr,xr),d_mul(xr,xr)),d_abs(d_add(Xi,xi))))),d_add(d_imul(5,d_add(d_mul(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr)),d_mul(xr,d_abs(d_add(Xr,xr)))),d_add(d_mul(Xr,d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(d_mul(xi,xi),d_mul(xi,xi)),d_mul(d_mul(xr,xr),d_mul(xr,xr))))),d_mul(d_mul(d_mul(xi,xi),d_mul(xi,xi)),d_mul(xr,d_abs(d_add(Xr,xr))))))),d_add(d_imul(-5,d_add(d_mul(Xi,d_add(d_mul(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr)),d_diffabs(Xi,xi)),d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(d_mul(xi,xi),d_mul(xi,xi)),d_mul(d_mul(xr,xr),d_mul(xr,xr)))))),d_mul(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr)),d_mul(xi,d_abs(d_add(Xi,xi)))))),d_add(d_imul(5,d_mul(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi)),d_add(d_mul(Xr,d_diffabs(Xr,xr)),d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_imul(-5,d_mul(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi)),d_mul(xi,d_abs(d_add(Xi,xi))))),d_add(d_imul(-10,d_mul(d_mul(xi,xi),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_add(d_imul(10,d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_mul(Xr,Xr),d_add(d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_mul(xi,d_mul(d_mul(xi,xi),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))))),d_add(d_imul(-10,d_add(d_mul(d_mul(Xi,Xi),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr))),d_add(d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))))),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))))),d_add(d_imul(10,d_mul(Xi,d_mul(d_mul(Xi,Xi),d_add(d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi)),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))))),d_add(d_imul(-10,d_mul(Xi,d_mul(d_mul(Xi,Xi),d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))))),d_add(d_imul(-20,d_mul(Xr,d_mul(xi,d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))))),d_add(d_imul(20,d_mul(Xr,d_mul(xi,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_imul(-20,d_add(d_mul(Xi,d_mul(xi,d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi)))))))),d_add(d_imul(20,d_mul(Xi,d_mul(xi,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr))))))),d_add(d_imul(-20,d_mul(Xi,d_mul(Xr,d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))))),d_add(d_imul(20,d_mul(Xi,d_mul(Xr,d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))))),d_add(d_imul(-20,d_mul(Xi,d_mul(Xr,d_mul(d_mul(Xr,Xr),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi)))))))),d_add(d_imul(20,d_mul(Xi,d_mul(d_mul(Xi,Xi),d_add(d_mul(Xr,d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr)))))))),d_add(d_imul(-30,d_add(d_mul(d_mul(Xr,Xr),d_add(d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr)))),d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_mul(Xr,d_mul(d_mul(xi,xi),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))))),d_add(d_imul(30,d_mul(Xi,d_mul(d_mul(xi,xi),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_imul(-30,d_mul(Xi,d_mul(d_mul(Xr,Xr),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_imul(30,d_add(d_mul(d_mul(Xi,Xi),d_add(d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr)))),d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))))),d_add(d_imul(-30,d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_add(d_imul(30,d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))))),d_add(d_imul(-30,d_mul(d_mul(Xi,Xi),d_mul(d_mul(Xr,Xr),d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_imul(30,d_mul(d_mul(Xi,Xi),d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xi,xi)))))),d_add(d_imul(-60,d_mul(Xi,d_mul(Xr,d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))))),d_add(d_imul(60,d_mul(Xi,d_mul(Xr,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_imul(-60,d_mul(Xi,d_mul(d_mul(Xr,Xr),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr))))))),d_add(d_imul(60,d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))))),d_mul(xr,d_mul(d_mul(d_mul(xr,xr),d_mul(xr,xr)),d_abs(d_add(Xr,xr)))))))))))))))))))))))))))))))))))));
xin=d_add(ci,d_add(d_mul(Xi,d_mul(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi)),d_diffabs(Xr,xr))),d_add(d_mul(Xr,d_mul(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr)),d_diffabs(Xi,xi))),d_add(d_mul(xi,d_mul(d_mul(d_mul(xi,xi),d_mul(xi,xi)),d_abs(d_add(Xr,xr)))),d_add(d_imul(5,d_add(d_mul(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi)),d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi)))))),d_add(d_mul(Xi,d_add(d_mul(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr)),d_diffabs(Xr,xr)),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(d_mul(xi,xi),d_mul(xi,xi)),d_mul(d_mul(xr,xr),d_mul(xr,xr)))))),d_add(d_mul(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr)),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))),d_add(d_mul(Xr,d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(d_mul(xi,xi),d_mul(xi,xi)),d_mul(d_mul(xr,xr),d_mul(xr,xr))))),d_add(d_mul(d_mul(d_mul(xi,xi),d_mul(xi,xi)),d_mul(xr,d_abs(d_add(Xi,xi)))),d_mul(xi,d_mul(d_mul(d_mul(xr,xr),d_mul(xr,xr)),d_abs(d_add(Xr,xr)))))))))),d_add(d_imul(-10,d_add(d_mul(xi,d_mul(d_mul(xi,xi),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_mul(d_mul(xi,xi),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))))),d_add(d_imul(10,d_mul(d_mul(Xr,Xr),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_imul(-10,d_mul(d_mul(Xr,Xr),d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))))),d_add(d_imul(10,d_mul(Xr,d_mul(d_mul(Xr,Xr),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_imul(-10,d_add(d_mul(d_mul(Xi,Xi),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))))),d_add(d_imul(10,d_mul(d_mul(Xi,Xi),d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))))),d_add(d_imul(-10,d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_add(d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr)),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi)))))),d_add(d_imul(10,d_mul(Xi,d_mul(d_mul(Xi,Xi),d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))))),d_add(d_imul(20,d_mul(Xr,d_mul(xi,d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))))),d_add(d_imul(-20,d_mul(Xr,d_mul(xi,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr))))))),d_add(d_imul(20,d_mul(Xr,d_mul(d_mul(Xr,Xr),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr))))))),d_add(d_imul(-20,d_mul(Xi,d_mul(xi,d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))))),d_add(d_imul(20,d_mul(Xi,d_add(d_mul(Xr,d_add(d_mul(d_mul(Xr,Xr),d_mul(xr,d_abs(d_add(Xr,xr)))),d_add(d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))))),d_mul(xi,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xi,xi)))))))),d_add(d_imul(-20,d_mul(Xi,d_mul(Xr,d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xi,xi))))))),d_add(d_imul(20,d_mul(Xi,d_mul(d_mul(Xi,Xi),d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_imul(-20,d_mul(Xi,d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr))))))),d_add(d_imul(20,d_mul(Xi,d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(xi,d_abs(d_add(Xi,xi))))))),d_add(d_imul(-30,d_mul(Xr,d_mul(d_mul(xi,xi),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_imul(30,d_mul(d_mul(Xr,Xr),d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_add(d_imul(-30,d_add(d_mul(Xi,d_mul(d_mul(xi,xi),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_mul(d_mul(Xr,Xr),d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_imul(30,d_mul(Xi,d_mul(d_mul(Xr,Xr),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_add(d_imul(-30,d_add(d_mul(d_mul(Xi,Xi),d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))))),d_add(d_imul(30,d_mul(d_mul(Xi,Xi),d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xi,xi)))))),d_add(d_imul(-30,d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_imul(30,d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))))),d_add(d_imul(-30,d_mul(d_mul(Xi,Xi),d_mul(d_mul(Xr,Xr),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_imul(-60,d_add(d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_mul(Xi,d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(Xr,d_add(d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr)))),d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))))))),d_mul(xr,d_mul(d_mul(d_mul(xr,xr),d_mul(xr,xr)),d_abs(d_add(Xi,xi))))))))))))))))))))))))))))))))))));
}

);

static const char *perturbation_opencl_double_68_6_1 = STR(

{dxan=d_add(d_mul(Xxr,d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dxa,d_sgn(Xxr)))),d_add(d_imul(-1,d_mul(Xxi,d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(dya,d_sgn(Xxi))))),d_add(d_imul(-5,d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dya,d_abs(Xxi)))),d_add(d_imul(5,d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dxa,d_abs(Xxr)))),d_add(d_imul(-5,d_add(d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(dya,d_abs(Xxi))),d_mul(Xxi,d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dya,d_sgn(Xxi)))))),d_add(d_imul(5,d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_add(d_mul(Xxr,d_mul(dxa,d_sgn(Xxr))),d_mul(dxa,d_abs(Xxr))))),d_add(d_imul(-10,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_sgn(Xxr)))))),d_add(d_imul(10,d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_sgn(Xxi)))))),d_add(d_imul(-20,d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_add(d_mul(dxa,d_abs(Xxi)),d_mul(dya,d_abs(Xxr))))))),d_add(d_imul(20,d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_add(d_mul(dxa,d_abs(Xxi)),d_mul(dya,d_abs(Xxr))))))),d_add(d_imul(30,d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxi))))),d_add(d_imul(-30,d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr))))),daa))))))))))));
dxbn=d_add(d_mul(Xxr,d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dxb,d_sgn(Xxr)))),d_add(d_imul(-1,d_mul(Xxi,d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(dyb,d_sgn(Xxi))))),d_add(d_imul(-5,d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dyb,d_abs(Xxi)))),d_add(d_imul(5,d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dxb,d_abs(Xxr)))),d_add(d_imul(-5,d_add(d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(dyb,d_abs(Xxi))),d_mul(Xxi,d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dyb,d_sgn(Xxi)))))),d_add(d_imul(5,d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_add(d_mul(Xxr,d_mul(dxb,d_sgn(Xxr))),d_mul(dxb,d_abs(Xxr))))),d_add(d_imul(-10,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_sgn(Xxr)))))),d_add(d_imul(10,d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_sgn(Xxi)))))),d_add(d_imul(-20,d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_add(d_mul(dxb,d_abs(Xxi)),d_mul(dyb,d_abs(Xxr))))))),d_add(d_imul(20,d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_add(d_mul(dxb,d_abs(Xxi)),d_mul(dyb,d_abs(Xxr))))))),d_add(d_imul(30,d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxi))))),d_add(d_imul(-30,d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr))))),dab))))))))))));
dyan=d_add(d_mul(Xxi,d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(dxa,d_sgn(Xxr)))),d_add(d_mul(Xxr,d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dya,d_sgn(Xxi)))),d_add(d_imul(5,d_add(d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_add(d_mul(Xxr,d_mul(dya,d_sgn(Xxi))),d_add(d_mul(dxa,d_abs(Xxi)),d_mul(dya,d_abs(Xxr))))),d_add(d_mul(Xxi,d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dxa,d_sgn(Xxr)))),d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_add(d_mul(dxa,d_abs(Xxi)),d_mul(dya,d_abs(Xxr))))))),d_add(d_imul(-10,d_add(d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_sgn(Xxr))))),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_sgn(Xxi))))))),d_add(d_imul(-20,d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dya,d_abs(Xxi)))))),d_add(d_imul(20,d_mul(Xxi,d_add(d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dya,d_abs(Xxi)))),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxa,d_abs(Xxr))))))),d_add(d_imul(-20,d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxa,d_abs(Xxr)))))),d_add(d_imul(-30,d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_add(d_mul(dxa,d_abs(Xxi)),d_mul(dya,d_abs(Xxr)))))),dba))))))));
dybn=d_add(d_mul(Xxi,d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_mul(dxb,d_sgn(Xxr)))),d_add(d_mul(Xxr,d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dyb,d_sgn(Xxi)))),d_add(d_imul(5,d_add(d_mul(d_mul(d_mul(Xxi,Xxi),d_mul(Xxi,Xxi)),d_add(d_mul(Xxr,d_mul(dyb,d_sgn(Xxi))),d_add(d_mul(dxb,d_abs(Xxi)),d_mul(dyb,d_abs(Xxr))))),d_add(d_mul(Xxi,d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_mul(dxb,d_sgn(Xxr)))),d_mul(d_mul(d_mul(Xxr,Xxr),d_mul(Xxr,Xxr)),d_add(d_mul(dxb,d_abs(Xxi)),d_mul(dyb,d_abs(Xxr))))))),d_add(d_imul(-10,d_add(d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_sgn(Xxr))))),d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_sgn(Xxi))))))),d_add(d_imul(-20,d_mul(Xxi,d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dyb,d_abs(Xxi)))))),d_add(d_imul(20,d_mul(Xxi,d_add(d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dyb,d_abs(Xxi)))),d_mul(Xxr,d_mul(d_mul(Xxr,Xxr),d_mul(dxb,d_abs(Xxr))))))),d_add(d_imul(-20,d_mul(Xxi,d_mul(d_mul(Xxi,Xxi),d_mul(Xxr,d_mul(dxb,d_abs(Xxr)))))),d_add(d_imul(-30,d_mul(d_mul(Xxi,Xxi),d_mul(d_mul(Xxr,Xxr),d_add(d_mul(dxb,d_abs(Xxi)),d_mul(dyb,d_abs(Xxr)))))),dbb))))))));
}

{xrn=d_add(cr,d_add(d_mul(Xr,d_mul(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr)),d_diffabs(Xr,xr))),d_add(d_imul(-1,d_add(d_mul(Xi,d_mul(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi)),d_diffabs(Xi,xi))),d_mul(xi,d_mul(d_mul(d_mul(xi,xi),d_mul(xi,xi)),d_abs(d_add(Xi,xi)))))),d_add(d_imul(-5,d_mul(xi,d_mul(d_mul(d_mul(xr,xr),d_mul(xr,xr)),d_abs(d_add(Xi,xi))))),d_add(d_imul(5,d_add(d_mul(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr)),d_mul(xr,d_abs(d_add(Xr,xr)))),d_add(d_mul(Xr,d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(d_mul(xi,xi),d_mul(xi,xi)),d_mul(d_mul(xr,xr),d_mul(xr,xr))))),d_mul(d_mul(d_mul(xi,xi),d_mul(xi,xi)),d_mul(xr,d_abs(d_add(Xr,xr))))))),d_add(d_imul(-5,d_add(d_mul(Xi,d_add(d_mul(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr)),d_diffabs(Xi,xi)),d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(d_mul(xi,xi),d_mul(xi,xi)),d_mul(d_mul(xr,xr),d_mul(xr,xr)))))),d_mul(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr)),d_mul(xi,d_abs(d_add(Xi,xi)))))),d_add(d_imul(5,d_mul(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi)),d_add(d_mul(Xr,d_diffabs(Xr,xr)),d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_imul(-5,d_mul(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi)),d_mul(xi,d_abs(d_add(Xi,xi))))),d_add(d_imul(-10,d_mul(d_mul(xi,xi),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_add(d_imul(10,d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_add(d_mul(d_mul(Xr,Xr),d_add(d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_mul(xi,d_mul(d_mul(xi,xi),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))))),d_add(d_imul(-10,d_add(d_mul(d_mul(Xi,Xi),d_add(d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr))),d_add(d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))))),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))))),d_add(d_imul(10,d_mul(Xi,d_mul(d_mul(Xi,Xi),d_add(d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi)),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))))),d_add(d_imul(-10,d_mul(Xi,d_mul(d_mul(Xi,Xi),d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))))),d_add(d_imul(-20,d_mul(Xr,d_mul(xi,d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))))),d_add(d_imul(20,d_mul(Xr,d_mul(xi,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_imul(-20,d_add(d_mul(Xi,d_mul(xi,d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi)))))))),d_add(d_imul(20,d_mul(Xi,d_mul(xi,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr))))))),d_add(d_imul(-20,d_mul(Xi,d_mul(Xr,d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))))),d_add(d_imul(20,d_mul(Xi,d_mul(Xr,d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))))),d_add(d_imul(-20,d_mul(Xi,d_mul(Xr,d_mul(d_mul(Xr,Xr),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi)))))))),d_add(d_imul(20,d_mul(Xi,d_mul(d_mul(Xi,Xi),d_add(d_mul(Xr,d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr)))))))),d_add(d_imul(-30,d_add(d_mul(d_mul(Xr,Xr),d_add(d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr)))),d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_mul(Xr,d_mul(d_mul(xi,xi),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))))),d_add(d_imul(30,d_mul(Xi,d_mul(d_mul(xi,xi),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_imul(-30,d_mul(Xi,d_mul(d_mul(Xr,Xr),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_imul(30,d_add(d_mul(d_mul(Xi,Xi),d_add(d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr)))),d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))))),d_add(d_imul(-30,d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_add(d_imul(30,d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))))),d_add(d_imul(-30,d_mul(d_mul(Xi,Xi),d_mul(d_mul(Xr,Xr),d_mul(xr,d_abs(d_add(Xr,xr)))))),d_add(d_imul(30,d_mul(d_mul(Xi,Xi),d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xi,xi)))))),d_add(d_imul(-60,d_mul(Xi,d_mul(Xr,d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))))),d_add(d_imul(60,d_mul(Xi,d_mul(Xr,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_imul(-60,d_mul(Xi,d_mul(d_mul(Xr,Xr),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr))))))),d_add(d_imul(60,d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))))),d_mul(xr,d_mul(d_mul(d_mul(xr,xr),d_mul(xr,xr)),d_abs(d_add(Xr,xr)))))))))))))))))))))))))))))))))))));
xin=d_add(ci,d_add(d_mul(Xi,d_mul(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi)),d_diffabs(Xr,xr))),d_add(d_mul(Xr,d_mul(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr)),d_diffabs(Xi,xi))),d_add(d_mul(xi,d_mul(d_mul(d_mul(xi,xi),d_mul(xi,xi)),d_abs(d_add(Xr,xr)))),d_add(d_imul(5,d_add(d_mul(d_mul(d_mul(Xi,Xi),d_mul(Xi,Xi)),d_add(d_mul(Xr,d_diffabs(Xi,xi)),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi)))))),d_add(d_mul(Xi,d_add(d_mul(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr)),d_diffabs(Xr,xr)),d_mul(d_abs(d_add(Xr,xr)),d_add(d_mul(d_mul(xi,xi),d_mul(xi,xi)),d_mul(d_mul(xr,xr),d_mul(xr,xr)))))),d_add(d_mul(d_mul(d_mul(Xr,Xr),d_mul(Xr,Xr)),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))),d_add(d_mul(Xr,d_mul(d_abs(d_add(Xi,xi)),d_add(d_mul(d_mul(xi,xi),d_mul(xi,xi)),d_mul(d_mul(xr,xr),d_mul(xr,xr))))),d_add(d_mul(d_mul(d_mul(xi,xi),d_mul(xi,xi)),d_mul(xr,d_abs(d_add(Xi,xi)))),d_mul(xi,d_mul(d_mul(d_mul(xr,xr),d_mul(xr,xr)),d_abs(d_add(Xr,xr)))))))))),d_add(d_imul(-10,d_add(d_mul(xi,d_mul(d_mul(xi,xi),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_mul(d_mul(xi,xi),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))))),d_add(d_imul(10,d_mul(d_mul(Xr,Xr),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_imul(-10,d_mul(d_mul(Xr,Xr),d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))))),d_add(d_imul(10,d_mul(Xr,d_mul(d_mul(Xr,Xr),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_imul(-10,d_add(d_mul(d_mul(Xi,Xi),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi))))))),d_add(d_imul(10,d_mul(d_mul(Xi,Xi),d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))))),d_add(d_imul(-10,d_add(d_mul(Xi,d_mul(d_mul(Xi,Xi),d_add(d_mul(d_mul(Xr,Xr),d_diffabs(Xr,xr)),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(d_mul(Xr,Xr),d_diffabs(Xi,xi)))))),d_add(d_imul(10,d_mul(Xi,d_mul(d_mul(Xi,Xi),d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr)))))),d_add(d_imul(20,d_mul(Xr,d_mul(xi,d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))))),d_add(d_imul(-20,d_mul(Xr,d_mul(xi,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr))))))),d_add(d_imul(20,d_mul(Xr,d_mul(d_mul(Xr,Xr),d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr))))))),d_add(d_imul(-20,d_mul(Xi,d_mul(xi,d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi))))))),d_add(d_imul(20,d_mul(Xi,d_add(d_mul(Xr,d_add(d_mul(d_mul(Xr,Xr),d_mul(xr,d_abs(d_add(Xr,xr)))),d_add(d_mul(xi,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))),d_mul(xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))))),d_mul(xi,d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xi,xi)))))))),d_add(d_imul(-20,d_mul(Xi,d_mul(Xr,d_mul(d_mul(Xr,Xr),d_mul(xi,d_abs(d_add(Xi,xi))))))),d_add(d_imul(20,d_mul(Xi,d_mul(d_mul(Xi,Xi),d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_imul(-20,d_mul(Xi,d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(xr,d_abs(d_add(Xr,xr))))))),d_add(d_imul(20,d_mul(Xi,d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(xi,d_abs(d_add(Xi,xi))))))),d_add(d_imul(-30,d_mul(Xr,d_mul(d_mul(xi,xi),d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_imul(30,d_mul(d_mul(Xr,Xr),d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_add(d_imul(-30,d_add(d_mul(Xi,d_mul(d_mul(xi,xi),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_mul(d_mul(Xr,Xr),d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_imul(30,d_mul(Xi,d_mul(d_mul(Xr,Xr),d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr)))))),d_add(d_imul(-30,d_add(d_mul(d_mul(Xi,Xi),d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xr,xr))))),d_mul(Xi,d_mul(d_mul(Xr,Xr),d_mul(d_mul(xi,xi),d_abs(d_add(Xr,xr))))))),d_add(d_imul(30,d_mul(d_mul(Xi,Xi),d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xi,xi)))))),d_add(d_imul(-30,d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))),d_add(d_imul(30,d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(d_mul(xi,xi),d_abs(d_add(Xi,xi)))))),d_add(d_imul(-30,d_mul(d_mul(Xi,Xi),d_mul(d_mul(Xr,Xr),d_add(d_mul(xi,d_abs(d_add(Xr,xr))),d_mul(xr,d_abs(d_add(Xi,xi))))))),d_add(d_imul(-60,d_add(d_mul(d_mul(Xi,Xi),d_mul(Xr,d_mul(xi,d_mul(xr,d_abs(d_add(Xr,xr)))))),d_mul(Xi,d_add(d_mul(d_mul(Xr,Xr),d_mul(xi,d_mul(xr,d_abs(d_add(Xi,xi))))),d_mul(Xr,d_add(d_mul(d_mul(xi,xi),d_mul(xr,d_abs(d_add(Xr,xr)))),d_mul(xi,d_mul(d_mul(xr,xr),d_abs(d_add(Xi,xi)))))))))),d_mul(xr,d_mul(d_mul(d_mul(xr,xr),d_mul(xr,xr)),d_abs(d_add(Xi,xi))))))))))))))))))))))))))))))))))));
}

);

static const char *perturbation_opencl_floatexp_68_6_0 = STR(

{xrn=fe_add(cr,fe_add(fe_mul(Xr,fe_mul(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr)),fe_diffabs(Xr,xr))),fe_add(fe_imul(-1,fe_add(fe_mul(Xi,fe_mul(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi)),fe_diffabs(Xi,xi))),fe_mul(xi,fe_mul(fe_mul(fe_mul(xi,xi),fe_mul(xi,xi)),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-5,fe_mul(xi,fe_mul(fe_mul(fe_mul(xr,xr),fe_mul(xr,xr)),fe_abs(fe_add(Xi,xi))))),fe_add(fe_imul(5,fe_add(fe_mul(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr)),fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_add(fe_mul(Xr,fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(fe_mul(xi,xi),fe_mul(xi,xi)),fe_mul(fe_mul(xr,xr),fe_mul(xr,xr))))),fe_mul(fe_mul(fe_mul(xi,xi),fe_mul(xi,xi)),fe_mul(xr,fe_abs(fe_add(Xr,xr))))))),fe_add(fe_imul(-5,fe_add(fe_mul(Xi,fe_add(fe_mul(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr)),fe_diffabs(Xi,xi)),fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(fe_mul(xi,xi),fe_mul(xi,xi)),fe_mul(fe_mul(xr,xr),fe_mul(xr,xr)))))),fe_mul(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr)),fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(5,fe_mul(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi)),fe_add(fe_mul(Xr,fe_diffabs(Xr,xr)),fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(-5,fe_mul(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi)),fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_add(fe_imul(-10,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(10,fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_add(fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))))),fe_add(fe_imul(-10,fe_add(fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr))),fe_add(fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))))),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))))),fe_add(fe_imul(10,fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi)),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(-10,fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-20,fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(20,fe_mul(Xr,fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(-20,fe_add(fe_mul(Xi,fe_mul(xi,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi)))))))),fe_add(fe_imul(20,fe_mul(Xi,fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr))))))),fe_add(fe_imul(-20,fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(20,fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))))),fe_add(fe_imul(-20,fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))))),fe_add(fe_imul(20,fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(Xr,fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))))),fe_add(fe_imul(-30,fe_add(fe_mul(fe_mul(Xr,Xr),fe_add(fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))))),fe_add(fe_imul(30,fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-30,fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(30,fe_add(fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(-30,fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(30,fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(-30,fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(30,fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-60,fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))))),fe_add(fe_imul(60,fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(-60,fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))))),fe_add(fe_imul(60,fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_mul(xr,fe_mul(fe_mul(fe_mul(xr,xr),fe_mul(xr,xr)),fe_abs(fe_add(Xr,xr)))))))))))))))))))))))))))))))))))));
xin=fe_add(ci,fe_add(fe_mul(Xi,fe_mul(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi)),fe_diffabs(Xr,xr))),fe_add(fe_mul(Xr,fe_mul(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr)),fe_diffabs(Xi,xi))),fe_add(fe_mul(xi,fe_mul(fe_mul(fe_mul(xi,xi),fe_mul(xi,xi)),fe_abs(fe_add(Xr,xr)))),fe_add(fe_imul(5,fe_add(fe_mul(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi)),fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_mul(Xi,fe_add(fe_mul(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr)),fe_diffabs(Xr,xr)),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(fe_mul(xi,xi),fe_mul(xi,xi)),fe_mul(fe_mul(xr,xr),fe_mul(xr,xr)))))),fe_add(fe_mul(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr)),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(Xr,fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(fe_mul(xi,xi),fe_mul(xi,xi)),fe_mul(fe_mul(xr,xr),fe_mul(xr,xr))))),fe_add(fe_mul(fe_mul(fe_mul(xi,xi),fe_mul(xi,xi)),fe_mul(xr,fe_abs(fe_add(Xi,xi)))),fe_mul(xi,fe_mul(fe_mul(fe_mul(xr,xr),fe_mul(xr,xr)),fe_abs(fe_add(Xr,xr)))))))))),fe_add(fe_imul(-10,fe_add(fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(10,fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-10,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(10,fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-10,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(10,fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(-10,fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr)),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi)))))),fe_add(fe_imul(10,fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(20,fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))))),fe_add(fe_imul(-20,fe_mul(Xr,fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr))))))),fe_add(fe_imul(20,fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))))),fe_add(fe_imul(-20,fe_mul(Xi,fe_mul(xi,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(20,fe_mul(Xi,fe_add(fe_mul(Xr,fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_add(fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))))),fe_add(fe_imul(-20,fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(20,fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(-20,fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr))))))),fe_add(fe_imul(20,fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(-30,fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(30,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(-30,fe_add(fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(30,fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(-30,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))))),fe_add(fe_imul(30,fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-30,fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(30,fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-30,fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(Xr,Xr),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(-60,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_mul(Xi,fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(Xr,fe_add(fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))))))),fe_mul(xr,fe_mul(fe_mul(fe_mul(xr,xr),fe_mul(xr,xr)),fe_abs(fe_add(Xi,xi))))))))))))))))))))))))))))))))))));
}

);

static const char *perturbation_opencl_floatexp_68_6_1 = STR(

{dxan=fe_add(fe_mul(Xxr,fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dxa,fe_sgn(Xxr)))),fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(dya,fe_sgn(Xxi))))),fe_add(fe_imul(-5,fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dya,fe_abs(Xxi)))),fe_add(fe_imul(5,fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dxa,fe_abs(Xxr)))),fe_add(fe_imul(-5,fe_add(fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(dya,fe_abs(Xxi))),fe_mul(Xxi,fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dya,fe_sgn(Xxi)))))),fe_add(fe_imul(5,fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_add(fe_mul(Xxr,fe_mul(dxa,fe_sgn(Xxr))),fe_mul(dxa,fe_abs(Xxr))))),fe_add(fe_imul(-10,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_sgn(Xxr)))))),fe_add(fe_imul(10,fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_sgn(Xxi)))))),fe_add(fe_imul(-20,fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_add(fe_mul(dxa,fe_abs(Xxi)),fe_mul(dya,fe_abs(Xxr))))))),fe_add(fe_imul(20,fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_add(fe_mul(dxa,fe_abs(Xxi)),fe_mul(dya,fe_abs(Xxr))))))),fe_add(fe_imul(30,fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxi))))),fe_add(fe_imul(-30,fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr))))),daa))))))))))));
dxbn=fe_add(fe_mul(Xxr,fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dxb,fe_sgn(Xxr)))),fe_add(fe_imul(-1,fe_mul(Xxi,fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(dyb,fe_sgn(Xxi))))),fe_add(fe_imul(-5,fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dyb,fe_abs(Xxi)))),fe_add(fe_imul(5,fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dxb,fe_abs(Xxr)))),fe_add(fe_imul(-5,fe_add(fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(dyb,fe_abs(Xxi))),fe_mul(Xxi,fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dyb,fe_sgn(Xxi)))))),fe_add(fe_imul(5,fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_add(fe_mul(Xxr,fe_mul(dxb,fe_sgn(Xxr))),fe_mul(dxb,fe_abs(Xxr))))),fe_add(fe_imul(-10,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_sgn(Xxr)))))),fe_add(fe_imul(10,fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_sgn(Xxi)))))),fe_add(fe_imul(-20,fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_add(fe_mul(dxb,fe_abs(Xxi)),fe_mul(dyb,fe_abs(Xxr))))))),fe_add(fe_imul(20,fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_add(fe_mul(dxb,fe_abs(Xxi)),fe_mul(dyb,fe_abs(Xxr))))))),fe_add(fe_imul(30,fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxi))))),fe_add(fe_imul(-30,fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr))))),dab))))))))))));
dyan=fe_add(fe_mul(Xxi,fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(dxa,fe_sgn(Xxr)))),fe_add(fe_mul(Xxr,fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dya,fe_sgn(Xxi)))),fe_add(fe_imul(5,fe_add(fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_add(fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxi))),fe_add(fe_mul(dxa,fe_abs(Xxi)),fe_mul(dya,fe_abs(Xxr))))),fe_add(fe_mul(Xxi,fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dxa,fe_sgn(Xxr)))),fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_add(fe_mul(dxa,fe_abs(Xxi)),fe_mul(dya,fe_abs(Xxr))))))),fe_add(fe_imul(-10,fe_add(fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_sgn(Xxr))))),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_sgn(Xxi))))))),fe_add(fe_imul(-20,fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dya,fe_abs(Xxi)))))),fe_add(fe_imul(20,fe_mul(Xxi,fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dya,fe_abs(Xxi)))),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxa,fe_abs(Xxr))))))),fe_add(fe_imul(-20,fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxa,fe_abs(Xxr)))))),fe_add(fe_imul(-30,fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_add(fe_mul(dxa,fe_abs(Xxi)),fe_mul(dya,fe_abs(Xxr)))))),dba))))))));
dybn=fe_add(fe_mul(Xxi,fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_mul(dxb,fe_sgn(Xxr)))),fe_add(fe_mul(Xxr,fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dyb,fe_sgn(Xxi)))),fe_add(fe_imul(5,fe_add(fe_mul(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxi,Xxi)),fe_add(fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxi))),fe_add(fe_mul(dxb,fe_abs(Xxi)),fe_mul(dyb,fe_abs(Xxr))))),fe_add(fe_mul(Xxi,fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_mul(dxb,fe_sgn(Xxr)))),fe_mul(fe_mul(fe_mul(Xxr,Xxr),fe_mul(Xxr,Xxr)),fe_add(fe_mul(dxb,fe_abs(Xxi)),fe_mul(dyb,fe_abs(Xxr))))))),fe_add(fe_imul(-10,fe_add(fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_sgn(Xxr))))),fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_sgn(Xxi))))))),fe_add(fe_imul(-20,fe_mul(Xxi,fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dyb,fe_abs(Xxi)))))),fe_add(fe_imul(20,fe_mul(Xxi,fe_add(fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dyb,fe_abs(Xxi)))),fe_mul(Xxr,fe_mul(fe_mul(Xxr,Xxr),fe_mul(dxb,fe_abs(Xxr))))))),fe_add(fe_imul(-20,fe_mul(Xxi,fe_mul(fe_mul(Xxi,Xxi),fe_mul(Xxr,fe_mul(dxb,fe_abs(Xxr)))))),fe_add(fe_imul(-30,fe_mul(fe_mul(Xxi,Xxi),fe_mul(fe_mul(Xxr,Xxr),fe_add(fe_mul(dxb,fe_abs(Xxi)),fe_mul(dyb,fe_abs(Xxr)))))),dbb))))))));
}

{xrn=fe_add(cr,fe_add(fe_mul(Xr,fe_mul(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr)),fe_diffabs(Xr,xr))),fe_add(fe_imul(-1,fe_add(fe_mul(Xi,fe_mul(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi)),fe_diffabs(Xi,xi))),fe_mul(xi,fe_mul(fe_mul(fe_mul(xi,xi),fe_mul(xi,xi)),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-5,fe_mul(xi,fe_mul(fe_mul(fe_mul(xr,xr),fe_mul(xr,xr)),fe_abs(fe_add(Xi,xi))))),fe_add(fe_imul(5,fe_add(fe_mul(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr)),fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_add(fe_mul(Xr,fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(fe_mul(xi,xi),fe_mul(xi,xi)),fe_mul(fe_mul(xr,xr),fe_mul(xr,xr))))),fe_mul(fe_mul(fe_mul(xi,xi),fe_mul(xi,xi)),fe_mul(xr,fe_abs(fe_add(Xr,xr))))))),fe_add(fe_imul(-5,fe_add(fe_mul(Xi,fe_add(fe_mul(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr)),fe_diffabs(Xi,xi)),fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(fe_mul(xi,xi),fe_mul(xi,xi)),fe_mul(fe_mul(xr,xr),fe_mul(xr,xr)))))),fe_mul(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr)),fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(5,fe_mul(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi)),fe_add(fe_mul(Xr,fe_diffabs(Xr,xr)),fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(-5,fe_mul(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi)),fe_mul(xi,fe_abs(fe_add(Xi,xi))))),fe_add(fe_imul(-10,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(10,fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_add(fe_mul(fe_mul(Xr,Xr),fe_add(fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))))),fe_add(fe_imul(-10,fe_add(fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr))),fe_add(fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))))),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))))),fe_add(fe_imul(10,fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi)),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(-10,fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-20,fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(20,fe_mul(Xr,fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(-20,fe_add(fe_mul(Xi,fe_mul(xi,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi)))))))),fe_add(fe_imul(20,fe_mul(Xi,fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr))))))),fe_add(fe_imul(-20,fe_mul(Xi,fe_mul(Xr,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(20,fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))))),fe_add(fe_imul(-20,fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))))),fe_add(fe_imul(20,fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(Xr,fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))))),fe_add(fe_imul(-30,fe_add(fe_mul(fe_mul(Xr,Xr),fe_add(fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))))),fe_add(fe_imul(30,fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-30,fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(30,fe_add(fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(-30,fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(30,fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(-30,fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(30,fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-60,fe_mul(Xi,fe_mul(Xr,fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))))),fe_add(fe_imul(60,fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(-60,fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))))),fe_add(fe_imul(60,fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_mul(xr,fe_mul(fe_mul(fe_mul(xr,xr),fe_mul(xr,xr)),fe_abs(fe_add(Xr,xr)))))))))))))))))))))))))))))))))))));
xin=fe_add(ci,fe_add(fe_mul(Xi,fe_mul(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi)),fe_diffabs(Xr,xr))),fe_add(fe_mul(Xr,fe_mul(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr)),fe_diffabs(Xi,xi))),fe_add(fe_mul(xi,fe_mul(fe_mul(fe_mul(xi,xi),fe_mul(xi,xi)),fe_abs(fe_add(Xr,xr)))),fe_add(fe_imul(5,fe_add(fe_mul(fe_mul(fe_mul(Xi,Xi),fe_mul(Xi,Xi)),fe_add(fe_mul(Xr,fe_diffabs(Xi,xi)),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_mul(Xi,fe_add(fe_mul(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr)),fe_diffabs(Xr,xr)),fe_mul(fe_abs(fe_add(Xr,xr)),fe_add(fe_mul(fe_mul(xi,xi),fe_mul(xi,xi)),fe_mul(fe_mul(xr,xr),fe_mul(xr,xr)))))),fe_add(fe_mul(fe_mul(fe_mul(Xr,Xr),fe_mul(Xr,Xr)),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_add(fe_mul(Xr,fe_mul(fe_abs(fe_add(Xi,xi)),fe_add(fe_mul(fe_mul(xi,xi),fe_mul(xi,xi)),fe_mul(fe_mul(xr,xr),fe_mul(xr,xr))))),fe_add(fe_mul(fe_mul(fe_mul(xi,xi),fe_mul(xi,xi)),fe_mul(xr,fe_abs(fe_add(Xi,xi)))),fe_mul(xi,fe_mul(fe_mul(fe_mul(xr,xr),fe_mul(xr,xr)),fe_abs(fe_add(Xr,xr)))))))))),fe_add(fe_imul(-10,fe_add(fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(10,fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-10,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(10,fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-10,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(10,fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(-10,fe_add(fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_add(fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xr,xr)),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_diffabs(Xi,xi)))))),fe_add(fe_imul(10,fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(20,fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))))),fe_add(fe_imul(-20,fe_mul(Xr,fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr))))))),fe_add(fe_imul(20,fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr))))))),fe_add(fe_imul(-20,fe_mul(Xi,fe_mul(xi,fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(20,fe_mul(Xi,fe_add(fe_mul(Xr,fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_add(fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))),fe_mul(xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))))),fe_mul(xi,fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))))),fe_add(fe_imul(-20,fe_mul(Xi,fe_mul(Xr,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(20,fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(-20,fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(xr,fe_abs(fe_add(Xr,xr))))))),fe_add(fe_imul(20,fe_mul(Xi,fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(xi,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(-30,fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(30,fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(-30,fe_add(fe_mul(Xi,fe_mul(fe_mul(xi,xi),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(30,fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr)))))),fe_add(fe_imul(-30,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xr,xr))))),fe_mul(Xi,fe_mul(fe_mul(Xr,Xr),fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xr,xr))))))),fe_add(fe_imul(30,fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-30,fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(30,fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(fe_mul(xi,xi),fe_abs(fe_add(Xi,xi)))))),fe_add(fe_imul(-30,fe_mul(fe_mul(Xi,Xi),fe_mul(fe_mul(Xr,Xr),fe_add(fe_mul(xi,fe_abs(fe_add(Xr,xr))),fe_mul(xr,fe_abs(fe_add(Xi,xi))))))),fe_add(fe_imul(-60,fe_add(fe_mul(fe_mul(Xi,Xi),fe_mul(Xr,fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xr,xr)))))),fe_mul(Xi,fe_add(fe_mul(fe_mul(Xr,Xr),fe_mul(xi,fe_mul(xr,fe_abs(fe_add(Xi,xi))))),fe_mul(Xr,fe_add(fe_mul(fe_mul(xi,xi),fe_mul(xr,fe_abs(fe_add(Xr,xr)))),fe_mul(xi,fe_mul(fe_mul(xr,xr),fe_abs(fe_add(Xi,xi)))))))))),fe_mul(xr,fe_mul(fe_mul(fe_mul(xr,xr),fe_mul(xr,xr)),fe_abs(fe_add(Xi,xi))))))))))))))))))))))))))))))))))));
}

);

#if 0
static const char *perturbation_opencl_softfloat_68_6_0 = STR(

{xrn=sf_add(cr,sf_add(sf_mul(Xr,sf_mul(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr)),sf_diffabs(Xr,xr))),sf_add(sf_imul(-1,sf_add(sf_mul(Xi,sf_mul(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi)),sf_diffabs(Xi,xi))),sf_mul(xi,sf_mul(sf_mul(sf_mul(xi,xi),sf_mul(xi,xi)),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-5,sf_mul(xi,sf_mul(sf_mul(sf_mul(xr,xr),sf_mul(xr,xr)),sf_abs(sf_add(Xi,xi))))),sf_add(sf_imul(5,sf_add(sf_mul(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr)),sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_add(sf_mul(Xr,sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(sf_mul(xi,xi),sf_mul(xi,xi)),sf_mul(sf_mul(xr,xr),sf_mul(xr,xr))))),sf_mul(sf_mul(sf_mul(xi,xi),sf_mul(xi,xi)),sf_mul(xr,sf_abs(sf_add(Xr,xr))))))),sf_add(sf_imul(-5,sf_add(sf_mul(Xi,sf_add(sf_mul(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr)),sf_diffabs(Xi,xi)),sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(sf_mul(xi,xi),sf_mul(xi,xi)),sf_mul(sf_mul(xr,xr),sf_mul(xr,xr)))))),sf_mul(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr)),sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(5,sf_mul(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi)),sf_add(sf_mul(Xr,sf_diffabs(Xr,xr)),sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(-5,sf_mul(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi)),sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_add(sf_imul(-10,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(10,sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_add(sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))))),sf_add(sf_imul(-10,sf_add(sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr))),sf_add(sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))))),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))))),sf_add(sf_imul(10,sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi)),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(-10,sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-20,sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(20,sf_mul(Xr,sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(-20,sf_add(sf_mul(Xi,sf_mul(xi,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi)))))))),sf_add(sf_imul(20,sf_mul(Xi,sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr))))))),sf_add(sf_imul(-20,sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(20,sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))))),sf_add(sf_imul(-20,sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))))),sf_add(sf_imul(20,sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(Xr,sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))))),sf_add(sf_imul(-30,sf_add(sf_mul(sf_mul(Xr,Xr),sf_add(sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))))),sf_add(sf_imul(30,sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-30,sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(30,sf_add(sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(-30,sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(30,sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(-30,sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(30,sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-60,sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))))),sf_add(sf_imul(60,sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(-60,sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))))),sf_add(sf_imul(60,sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_mul(xr,sf_mul(sf_mul(sf_mul(xr,xr),sf_mul(xr,xr)),sf_abs(sf_add(Xr,xr)))))))))))))))))))))))))))))))))))));
xin=sf_add(ci,sf_add(sf_mul(Xi,sf_mul(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi)),sf_diffabs(Xr,xr))),sf_add(sf_mul(Xr,sf_mul(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr)),sf_diffabs(Xi,xi))),sf_add(sf_mul(xi,sf_mul(sf_mul(sf_mul(xi,xi),sf_mul(xi,xi)),sf_abs(sf_add(Xr,xr)))),sf_add(sf_imul(5,sf_add(sf_mul(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi)),sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_mul(Xi,sf_add(sf_mul(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr)),sf_diffabs(Xr,xr)),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(sf_mul(xi,xi),sf_mul(xi,xi)),sf_mul(sf_mul(xr,xr),sf_mul(xr,xr)))))),sf_add(sf_mul(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr)),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(Xr,sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(sf_mul(xi,xi),sf_mul(xi,xi)),sf_mul(sf_mul(xr,xr),sf_mul(xr,xr))))),sf_add(sf_mul(sf_mul(sf_mul(xi,xi),sf_mul(xi,xi)),sf_mul(xr,sf_abs(sf_add(Xi,xi)))),sf_mul(xi,sf_mul(sf_mul(sf_mul(xr,xr),sf_mul(xr,xr)),sf_abs(sf_add(Xr,xr)))))))))),sf_add(sf_imul(-10,sf_add(sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(10,sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-10,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(10,sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-10,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(10,sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(-10,sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr)),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi)))))),sf_add(sf_imul(10,sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(20,sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))))),sf_add(sf_imul(-20,sf_mul(Xr,sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr))))))),sf_add(sf_imul(20,sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))))),sf_add(sf_imul(-20,sf_mul(Xi,sf_mul(xi,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(20,sf_mul(Xi,sf_add(sf_mul(Xr,sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_add(sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))))),sf_add(sf_imul(-20,sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(20,sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(-20,sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr))))))),sf_add(sf_imul(20,sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(-30,sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(30,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(-30,sf_add(sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(30,sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(-30,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))))),sf_add(sf_imul(30,sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-30,sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(30,sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-30,sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(Xr,Xr),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(-60,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_mul(Xi,sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(Xr,sf_add(sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))))))),sf_mul(xr,sf_mul(sf_mul(sf_mul(xr,xr),sf_mul(xr,xr)),sf_abs(sf_add(Xi,xi))))))))))))))))))))))))))))))))))));
}

);
#endif


static const char *perturbation_opencl_double_69_2_0 = STR(

{xrn=d_add(cr,d_add(d_imul(-1,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xr,xr)),d_add(d_imul(-2,d_mul(Xi,xi)),d_mul(xr,xr)))));
xin=d_add(d_mul(Ai,d_mul(xr,xr)),d_add(d_imul(2,d_add(d_mul(Ai,d_mul(Xr,xr)),d_mul(Ar,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))),ci));
}

);

static const char *perturbation_opencl_double_69_2_1 = STR(

{dxan=d_add(d_imul(-2,d_mul(Xxi,dya)),d_add(d_imul(2,d_mul(Xxr,dxa)),daa));
dxbn=d_add(d_imul(-2,d_mul(Xxi,dyb)),d_add(d_imul(2,d_mul(Xxr,dxb)),dab));
dyan=d_add(d_imul(2,d_add(d_mul(g_FactorAI,d_mul(Xxr,dxa)),d_mul(d_sgn(Xxi),d_mul(g_FactorAR,d_add(d_mul(Xxi,d_mul(dxa,d_sgn(Xxr))),d_mul(Xxr,d_mul(dya,d_sgn(Xxr)))))))),dba);
dybn=d_add(d_imul(2,d_add(d_mul(g_FactorAI,d_mul(Xxr,dxb)),d_mul(d_sgn(Xxi),d_mul(g_FactorAR,d_add(d_mul(Xxi,d_mul(dxb,d_sgn(Xxr))),d_mul(Xxr,d_mul(dyb,d_sgn(Xxr)))))))),dbb);
}

{xrn=d_add(cr,d_add(d_imul(-1,d_mul(xi,xi)),d_add(d_imul(2,d_mul(Xr,xr)),d_add(d_imul(-2,d_mul(Xi,xi)),d_mul(xr,xr)))));
xin=d_add(d_mul(Ai,d_mul(xr,xr)),d_add(d_imul(2,d_add(d_mul(Ai,d_mul(Xr,xr)),d_mul(Ar,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))),ci));
}

);

static const char *perturbation_opencl_floatexp_69_2_0 = STR(

{xrn=fe_add(cr,fe_add(fe_imul(-1,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_add(fe_imul(-2,fe_mul(Xi,xi)),fe_mul(xr,xr)))));
xin=fe_add(fe_mul(Ai,fe_mul(xr,xr)),fe_add(fe_imul(2,fe_add(fe_mul(Ai,fe_mul(Xr,xr)),fe_mul(Ar,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))),ci));
}

);

static const char *perturbation_opencl_floatexp_69_2_1 = STR(

{dxan=fe_add(fe_imul(-2,fe_mul(Xxi,dya)),fe_add(fe_imul(2,fe_mul(Xxr,dxa)),daa));
dxbn=fe_add(fe_imul(-2,fe_mul(Xxi,dyb)),fe_add(fe_imul(2,fe_mul(Xxr,dxb)),dab));
dyan=fe_add(fe_imul(2,fe_add(fe_mul(g_FactorAI,fe_mul(Xxr,dxa)),fe_mul(fe_sgn(Xxi),fe_mul(g_FactorAR,fe_add(fe_mul(Xxi,fe_mul(dxa,fe_sgn(Xxr))),fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxr)))))))),dba);
dybn=fe_add(fe_imul(2,fe_add(fe_mul(g_FactorAI,fe_mul(Xxr,dxb)),fe_mul(fe_sgn(Xxi),fe_mul(g_FactorAR,fe_add(fe_mul(Xxi,fe_mul(dxb,fe_sgn(Xxr))),fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxr)))))))),dbb);
}

{xrn=fe_add(cr,fe_add(fe_imul(-1,fe_mul(xi,xi)),fe_add(fe_imul(2,fe_mul(Xr,xr)),fe_add(fe_imul(-2,fe_mul(Xi,xi)),fe_mul(xr,xr)))));
xin=fe_add(fe_mul(Ai,fe_mul(xr,xr)),fe_add(fe_imul(2,fe_add(fe_mul(Ai,fe_mul(Xr,xr)),fe_mul(Ar,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))),ci));
}

);

#if 0
static const char *perturbation_opencl_softfloat_69_2_0 = STR(

{xrn=sf_add(cr,sf_add(sf_imul(-1,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_add(sf_imul(-2,sf_mul(Xi,xi)),sf_mul(xr,xr)))));
xin=sf_add(sf_mul(Ai,sf_mul(xr,xr)),sf_add(sf_imul(2,sf_add(sf_mul(Ai,sf_mul(Xr,xr)),sf_mul(Ar,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))),ci));
}

);
#endif


static const char *perturbation_opencl_double_70_2_0 = STR(

{xrn=d_add(cr,d_add(d_mul(xi,xi),d_add(d_imul(2,d_add(d_mul(Xi,xi),d_mul(Xr,xr))),d_mul(xr,xr))));
xin=d_add(d_mul(Ai,d_mul(xr,xr)),d_add(d_imul(2,d_add(d_mul(Ai,d_mul(Xr,xr)),d_mul(Ar,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))),ci));
}

);

static const char *perturbation_opencl_double_70_2_1 = STR(

{dxan=d_add(d_imul(2,d_add(d_mul(Xxi,dya),d_mul(Xxr,dxa))),daa);
dxbn=d_add(d_imul(2,d_add(d_mul(Xxi,dyb),d_mul(Xxr,dxb))),dab);
dyan=d_add(d_imul(2,d_add(d_mul(g_FactorAI,d_mul(Xxr,dxa)),d_mul(d_sgn(Xxi),d_mul(g_FactorAR,d_add(d_mul(Xxi,d_mul(dxa,d_sgn(Xxr))),d_mul(Xxr,d_mul(dya,d_sgn(Xxr)))))))),dba);
dybn=d_add(d_imul(2,d_add(d_mul(g_FactorAI,d_mul(Xxr,dxb)),d_mul(d_sgn(Xxi),d_mul(g_FactorAR,d_add(d_mul(Xxi,d_mul(dxb,d_sgn(Xxr))),d_mul(Xxr,d_mul(dyb,d_sgn(Xxr)))))))),dbb);
}

{xrn=d_add(cr,d_add(d_mul(xi,xi),d_add(d_imul(2,d_add(d_mul(Xi,xi),d_mul(Xr,xr))),d_mul(xr,xr))));
xin=d_add(d_mul(Ai,d_mul(xr,xr)),d_add(d_imul(2,d_add(d_mul(Ai,d_mul(Xr,xr)),d_mul(Ar,d_diffabs(d_mul(Xi,Xr),d_add(d_mul(Xi,xr),d_mul(xi,d_add(Xr,xr))))))),ci));
}

);

static const char *perturbation_opencl_floatexp_70_2_0 = STR(

{xrn=fe_add(cr,fe_add(fe_mul(xi,xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,xi),fe_mul(Xr,xr))),fe_mul(xr,xr))));
xin=fe_add(fe_mul(Ai,fe_mul(xr,xr)),fe_add(fe_imul(2,fe_add(fe_mul(Ai,fe_mul(Xr,xr)),fe_mul(Ar,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))),ci));
}

);

static const char *perturbation_opencl_floatexp_70_2_1 = STR(

{dxan=fe_add(fe_imul(2,fe_add(fe_mul(Xxi,dya),fe_mul(Xxr,dxa))),daa);
dxbn=fe_add(fe_imul(2,fe_add(fe_mul(Xxi,dyb),fe_mul(Xxr,dxb))),dab);
dyan=fe_add(fe_imul(2,fe_add(fe_mul(g_FactorAI,fe_mul(Xxr,dxa)),fe_mul(fe_sgn(Xxi),fe_mul(g_FactorAR,fe_add(fe_mul(Xxi,fe_mul(dxa,fe_sgn(Xxr))),fe_mul(Xxr,fe_mul(dya,fe_sgn(Xxr)))))))),dba);
dybn=fe_add(fe_imul(2,fe_add(fe_mul(g_FactorAI,fe_mul(Xxr,dxb)),fe_mul(fe_sgn(Xxi),fe_mul(g_FactorAR,fe_add(fe_mul(Xxi,fe_mul(dxb,fe_sgn(Xxr))),fe_mul(Xxr,fe_mul(dyb,fe_sgn(Xxr)))))))),dbb);
}

{xrn=fe_add(cr,fe_add(fe_mul(xi,xi),fe_add(fe_imul(2,fe_add(fe_mul(Xi,xi),fe_mul(Xr,xr))),fe_mul(xr,xr))));
xin=fe_add(fe_mul(Ai,fe_mul(xr,xr)),fe_add(fe_imul(2,fe_add(fe_mul(Ai,fe_mul(Xr,xr)),fe_mul(Ar,fe_diffabs(fe_mul(Xi,Xr),fe_add(fe_mul(Xi,xr),fe_mul(xi,fe_add(Xr,xr))))))),ci));
}

);

#if 0
static const char *perturbation_opencl_softfloat_70_2_0 = STR(

{xrn=sf_add(cr,sf_add(sf_mul(xi,xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,xi),sf_mul(Xr,xr))),sf_mul(xr,xr))));
xin=sf_add(sf_mul(Ai,sf_mul(xr,xr)),sf_add(sf_imul(2,sf_add(sf_mul(Ai,sf_mul(Xr,xr)),sf_mul(Ar,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))),ci));
}

);
#endif


static const char *perturbation_opencl_double_71_2_0 = STR(

{
  const dcomplex X = { Xr COMMA Xi } COMMA x = { xr COMMA xi } COMMA Xx = { Xxr COMMA Xxi } COMMA c = { cr COMMA ci };
  dcomplex xn;
{xn=dc_add(dc_add(dc_mul(dc_mul(dc_add(x,dc_imul(2,X)),x),dc_exp(dc_div(dc_imul(2,A),Xx))),dc_mul(dc_mul(dc_imul(2,dc_powi(X,2)),dc_sinh(dc_div(dc_mul(dc_neg(A),x),dc_mul(Xx,X)))),dc_exp(dc_div(dc_mul(A,dc_add(x,dc_imul(2,X))),dc_mul(Xx,X))))),c);
}
  xrn = xn.re;
  xin = xn.im;
}

);

static const char *perturbation_opencl_double_71_2_1 = STR(

{dn=dc_add(dc_mul(dc_mul(dc_imul(2,dc_sub(Xx,A)),dc_exp(dc_div(dc_imul(2,A),Xx))),d),d0);
}

{xn=dc_add(dc_add(dc_mul(dc_mul(dc_add(x,dc_imul(2,X)),x),dc_exp(dc_div(dc_imul(2,A),Xx))),dc_mul(dc_mul(dc_imul(2,dc_powi(X,2)),dc_sinh(dc_div(dc_mul(dc_neg(A),x),dc_mul(Xx,X)))),dc_exp(dc_div(dc_mul(A,dc_add(x,dc_imul(2,X))),dc_mul(Xx,X))))),c);
}

);

static const char *perturbation_opencl_floatexp_71_2_0 = STR(

{
  const fecomplex X = { Xr COMMA Xi } COMMA x = { xr COMMA xi } COMMA Xx = { Xxr COMMA Xxi } COMMA c = { cr COMMA ci };
  fecomplex xn;
{xn=fec_add(fec_add(fec_mul(fec_mul(fec_add(x,fec_imul(2,X)),x),fec_exp(fec_div(fec_imul(2,A),Xx))),fec_mul(fec_mul(fec_imul(2,fec_powi(X,2)),fec_sinh(fec_div(fec_mul(fec_neg(A),x),fec_mul(Xx,X)))),fec_exp(fec_div(fec_mul(A,fec_add(x,fec_imul(2,X))),fec_mul(Xx,X))))),c);
}
  xrn = xn.re;
  xin = xn.im;
}

);

static const char *perturbation_opencl_floatexp_71_2_1 = STR(

{dn=fec_add(fec_mul(fec_mul(fec_imul(2,fec_sub(Xx,A)),fec_exp(fec_div(fec_imul(2,A),Xx))),d),d0);
}

{xn=fec_add(fec_add(fec_mul(fec_mul(fec_add(x,fec_imul(2,X)),x),fec_exp(fec_div(fec_imul(2,A),Xx))),fec_mul(fec_mul(fec_imul(2,fec_powi(X,2)),fec_sinh(fec_div(fec_mul(fec_neg(A),x),fec_mul(Xx,X)))),fec_exp(fec_div(fec_mul(A,fec_add(x,fec_imul(2,X))),fec_mul(Xx,X))))),c);
}

);

#if 0
static const char *perturbation_opencl_softfloat_71_2_0 = STR(

{xn=sfc_add(sfc_add(sfc_mul(sfc_mul(sfc_add(x,sfc_imul(2,X)),x),sfc_exp(sfc_div(sfc_imul(2,A),Xx))),sfc_mul(sfc_mul(sfc_imul(2,sfc_powi(X,2)),sfc_sinh(sfc_div(sfc_mul(sfc_neg(A),x),sfc_mul(Xx,X)))),sfc_exp(sfc_div(sfc_mul(A,sfc_add(x,sfc_imul(2,X))),sfc_mul(Xx,X))))),c);
}

);
#endif


#if 0

static const char *perturbation_opencl_softfloat_0_2_1 = STR(

{drn=sf_add(sf_imul(2,sf_sub(sf_mul(Xxr,dr),sf_mul(Xxi,di))),dr0);
din=sf_add(sf_imul(2,sf_add(sf_mul(Xxi,dr),sf_mul(Xxr,di))),di0);
}

{xrn=sf_add(sf_sub(sf_mul(sf_add(sf_imul(2,Xr),xr),xr),sf_mul(sf_add(sf_imul(2,Xi),xi),xi)),cr);
xin=sf_add(sf_imul(2,sf_add(sf_mul(Xxr,xi),sf_mul(Xi,xr))),ci);
}

);

static const char *perturbation_opencl_softfloat_0_3_1 = STR(

{drn=sf_add(sf_sub(sf_mul(sf_imul(3,sf_sub(Xxr2,Xxi2)),dr),sf_mul(sf_imul(6,sf_mul(Xxi,Xxr)),di)),dr0);
din=sf_add(sf_add(sf_mul(sf_imul(3,sf_sub(Xxr2,Xxi2)),di),sf_mul(sf_imul(6,sf_mul(Xxi,Xxr)),dr)),di0);
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_add(sf_imul(3,sf_add(sf_sub(sf_mul(sf_sub(Xr2,Xi2),xr),sf_mul(sf_mul(sf_imul(2,Xxr),Xi),xi)),sf_mul(Xr,sf_sub(xr2,xi2)))),sf_mul(xr,sf_sub(xr2,sf_imul(3,xi2)))),cr);
xin=sf_add(sf_add(sf_imul(3,sf_add(sf_add(sf_mul(sf_sub(Xr2,Xi2),xi),sf_mul(sf_mul(sf_imul(2,Xr),xr),Xxi)),sf_mul(Xi,sf_sub(xr2,xi2)))),sf_mul(xi,sf_sub(sf_imul(3,xr2),xi2))),ci);
}

);

static const char *perturbation_opencl_softfloat_0_4_1 = STR(

{dn=sfc_add(sfc_mul(sfc_imul(4,d),sfc_powi(Xx,3)),d0);
}

{xn=sfc_add(sfc_add(sfc_add(sfc_add(sfc_mul(sfc_imul(4,sfc_powi(X,3)),x),sfc_mul(sfc_imul(6,sfc_powi(X,2)),sfc_powi(x,2))),sfc_mul(sfc_imul(4,X),sfc_powi(x,3))),sfc_powi(x,4)),c);
}

);

static const char *perturbation_opencl_softfloat_0_5_1 = STR(

{dn=sfc_add(sfc_mul(sfc_imul(5,d),sfc_powi(Xx,4)),d0);
}

{xn=sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_mul(sfc_imul(5,sfc_powi(X,4)),x),sfc_mul(sfc_imul(10,sfc_powi(X,3)),sfc_powi(x,2))),sfc_mul(sfc_imul(10,sfc_powi(X,2)),sfc_powi(x,3))),sfc_mul(sfc_imul(5,X),sfc_powi(x,4))),sfc_powi(x,5)),c);
}

);

static const char *perturbation_opencl_softfloat_0_6_1 = STR(

{dn=sfc_add(sfc_mul(sfc_imul(6,d),sfc_powi(Xx,5)),d0);
}

{xn=sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_mul(sfc_imul(6,sfc_powi(X,5)),x),sfc_mul(sfc_imul(15,sfc_powi(X,4)),sfc_powi(x,2))),sfc_mul(sfc_imul(20,sfc_powi(X,3)),sfc_powi(x,3))),sfc_mul(sfc_imul(15,sfc_powi(X,2)),sfc_powi(x,4))),sfc_mul(sfc_imul(6,X),sfc_powi(x,5))),sfc_powi(x,6)),c);
}

);

static const char *perturbation_opencl_softfloat_0_7_1 = STR(

{dn=sfc_add(sfc_mul(sfc_imul(7,d),sfc_powi(Xx,6)),d0);
}

{xn=sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_mul(sfc_imul(7,sfc_powi(X,6)),x),sfc_mul(sfc_imul(21,sfc_powi(X,5)),sfc_powi(x,2))),sfc_mul(sfc_imul(35,sfc_powi(X,4)),sfc_powi(x,3))),sfc_mul(sfc_imul(35,sfc_powi(X,3)),sfc_powi(x,4))),sfc_mul(sfc_imul(21,sfc_powi(X,2)),sfc_powi(x,5))),sfc_mul(sfc_imul(7,X),sfc_powi(x,6))),sfc_powi(x,7)),c);
}

);

static const char *perturbation_opencl_softfloat_0_8_1 = STR(

{dn=sfc_add(sfc_mul(sfc_imul(8,d),sfc_powi(Xx,7)),d0);
}

{xn=sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_mul(sfc_imul(8,sfc_powi(X,7)),x),sfc_mul(sfc_imul(28,sfc_powi(X,6)),sfc_powi(x,2))),sfc_mul(sfc_imul(56,sfc_powi(X,5)),sfc_powi(x,3))),sfc_mul(sfc_imul(70,sfc_powi(X,4)),sfc_powi(x,4))),sfc_mul(sfc_imul(56,sfc_powi(X,3)),sfc_powi(x,5))),sfc_mul(sfc_imul(28,sfc_powi(X,2)),sfc_powi(x,6))),sfc_mul(sfc_imul(8,X),sfc_powi(x,7))),sfc_powi(x,8)),c);
}

);

static const char *perturbation_opencl_softfloat_0_9_1 = STR(

{dn=sfc_add(sfc_mul(sfc_imul(9,d),sfc_powi(Xx,8)),d0);
}

{xn=sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_mul(sfc_imul(9,sfc_powi(X,8)),x),sfc_mul(sfc_imul(36,sfc_powi(X,7)),sfc_powi(x,2))),sfc_mul(sfc_imul(84,sfc_powi(X,6)),sfc_powi(x,3))),sfc_mul(sfc_imul(126,sfc_powi(X,5)),sfc_powi(x,4))),sfc_mul(sfc_imul(126,sfc_powi(X,4)),sfc_powi(x,5))),sfc_mul(sfc_imul(84,sfc_powi(X,3)),sfc_powi(x,6))),sfc_mul(sfc_imul(36,sfc_powi(X,2)),sfc_powi(x,7))),sfc_mul(sfc_imul(9,X),sfc_powi(x,8))),sfc_powi(x,9)),c);
}

);

static const char *perturbation_opencl_softfloat_0_10_1 = STR(

{dn=sfc_add(sfc_mul(sfc_imul(10,d),sfc_powi(Xx,9)),d0);
}

{xn=sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_mul(sfc_imul(10,sfc_powi(X,9)),x),sfc_mul(sfc_imul(45,sfc_powi(X,8)),sfc_powi(x,2))),sfc_mul(sfc_imul(120,sfc_powi(X,7)),sfc_powi(x,3))),sfc_mul(sfc_imul(210,sfc_powi(X,6)),sfc_powi(x,4))),sfc_mul(sfc_imul(252,sfc_powi(X,5)),sfc_powi(x,5))),sfc_mul(sfc_imul(210,sfc_powi(X,4)),sfc_powi(x,6))),sfc_mul(sfc_imul(120,sfc_powi(X,3)),sfc_powi(x,7))),sfc_mul(sfc_imul(45,sfc_powi(X,2)),sfc_powi(x,8))),sfc_mul(sfc_imul(10,X),sfc_powi(x,9))),sfc_powi(x,10)),c);
}

);

static const char *perturbation_opencl_softfloat_1_2_1 = STR(

{dxan=sf_add(sf_imul(2,sf_mul(Xxr,dxa)),sf_add(sf_imul(-2,sf_mul(Xxi,dya)),daa));
dxbn=sf_add(sf_imul(2,sf_mul(Xxr,dxb)),sf_add(sf_imul(-2,sf_mul(Xxi,dyb)),dab));
dyan=sf_add(sf_imul(2,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(dxa,sf_sgn(Xxr))))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxi),sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxr))))),dba));
dybn=sf_add(sf_imul(2,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(dxb,sf_sgn(Xxr))))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxi),sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxr))))),dbb));
}

{xrn=sf_add(sf_sub(sf_mul(sf_add(sf_imul(2,Xr),xr),xr),sf_mul(sf_add(sf_imul(2,Xi),xi),xi)),cr);
xin=sf_add(sf_imul(2,sf_diffabs(sf_mul(Xr,Xi),sf_add(sf_add(sf_mul(Xr,xi),sf_mul(xr,Xi)),sf_mul(xr,xi)))),ci);
}

);

static const char *perturbation_opencl_softfloat_1_3_1 = STR(

{dxan=sf_add(sf_imul(3,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr))))))),sf_add(sf_imul(-3,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxa,sf_sgn(Xxr))))))),sf_add(sf_imul(-6,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxr))))))),daa)));
dxbn=sf_add(sf_imul(3,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr))))))),sf_add(sf_imul(-3,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxb,sf_sgn(Xxr))))))),sf_add(sf_imul(-6,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxr))))))),dab)));
dyan=sf_add(sf_imul(3,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxr))))))),sf_add(sf_imul(-3,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(dya,sf_sgn(Xxi))))))),sf_add(sf_imul(6,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr))))))),dba)));
dybn=sf_add(sf_imul(3,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxr))))))),sf_add(sf_imul(-3,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(dyb,sf_sgn(Xxi))))))),sf_add(sf_imul(6,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr))))))),dbb)));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_add(sf_mul(sf_sub(Xr2,sf_imul(3,Xi2)),sf_diffabs(Xr,xr)),sf_mul(sf_sub(sf_sub(sf_add(sf_mul(sf_imul(2,Xr),xr),xr2),sf_mul(sf_imul(6,Xi),xi)),sf_imul(3,xi2)),sf_abs(sf_add(Xr,xr)))),cr);
xin=sf_add(sf_add(sf_mul(sf_sub(sf_imul(3,Xr2),Xi2),sf_diffabs(Xi,xi)),sf_mul(sf_sub(sf_sub(sf_add(sf_mul(sf_imul(6,Xr),xr),sf_imul(3,xr2)),sf_mul(sf_imul(2,Xi),xi)),xi2),sf_abs(sf_add(Xi,xi)))),ci);
}

);

static const char *perturbation_opencl_softfloat_1_4_1 = STR(

{dxan=sf_add(sf_imul(4,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dya,sf_sgn(Xxi))))))))),sf_add(sf_imul(4,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr))))))))),sf_add(sf_imul(-12,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr))))))))),sf_add(sf_imul(-12,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxr))))))))),daa))));
dxbn=sf_add(sf_imul(4,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dyb,sf_sgn(Xxi))))))))),sf_add(sf_imul(4,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr))))))))),sf_add(sf_imul(-12,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr))))))))),sf_add(sf_imul(-12,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxr))))))))),dab))));
dyan=sf_add(sf_imul(4,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxr))))))))),sf_add(sf_imul(-4,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxa,sf_sgn(Xxr))))))))),sf_add(sf_imul(-12,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxr))))))))),sf_add(sf_imul(12,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr))))))))),dba))));
dybn=sf_add(sf_imul(4,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxr))))))))),sf_add(sf_imul(-4,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxb,sf_sgn(Xxr))))))))),sf_add(sf_imul(-12,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxr))))))))),sf_add(sf_imul(12,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr))))))))),dbb))));
}

{xrn=sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_mul(sf_imul(4,Xr),Xr),Xr),xr),sf_mul(sf_mul(sf_mul(sf_imul(6,Xr),Xr),xr),xr)),sf_mul(sf_mul(sf_mul(sf_imul(4,Xr),xr),xr),xr)),sf_mul(sf_mul(sf_mul(xr,xr),xr),xr)),sf_mul(sf_mul(sf_mul(sf_imul(4,Xi),Xi),Xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(6,Xi),Xi),xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(4,Xi),xi),xi),xi)),sf_mul(sf_mul(sf_mul(xi,xi),xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(12,Xr),Xr),Xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(6,Xr),Xr),xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(12,Xr),xr),Xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(24,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(12,Xr),xr),xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(6,xr),xr),Xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(12,xr),xr),Xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(6,xr),xr),xi),xi)),cr);
xin=sf_add(sf_add(sf_mul(sf_imul(4,sf_sub(sf_mul(Xr,Xr),sf_mul(Xi,Xi))),sf_diffabs(sf_mul(Xr,Xi),sf_add(sf_add(sf_mul(Xr,xi),sf_mul(xr,Xi)),sf_mul(xr,xi)))),sf_mul(sf_imul(4,sf_abs(sf_add(sf_add(sf_add(sf_mul(Xr,Xi),sf_mul(Xr,xi)),sf_mul(xr,Xi)),sf_mul(xr,xi)))),sf_sub(sf_sub(sf_add(sf_mul(sf_imul(2,xr),Xr),sf_mul(xr,xr)),sf_mul(sf_imul(2,xi),Xi)),sf_mul(xi,xi)))),ci);
}

);

static const char *perturbation_opencl_softfloat_1_5_1 = STR(

{dxan=sf_add(sf_imul(5,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxa,sf_sgn(Xxr))))))))))),sf_add(sf_imul(5,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr))))))))))),sf_add(sf_imul(-20,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxr))))))))))),sf_add(sf_imul(20,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxr))))))))))),sf_add(sf_imul(-30,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr))))))))))),daa)))));
dxbn=sf_add(sf_imul(5,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxb,sf_sgn(Xxr))))))))))),sf_add(sf_imul(5,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr))))))))))),sf_add(sf_imul(-20,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxr))))))))))),sf_add(sf_imul(20,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxr))))))))))),sf_add(sf_imul(-30,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr))))))))))),dab)))));
dyan=sf_add(sf_imul(5,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dya,sf_sgn(Xxi))))))))))),sf_add(sf_imul(5,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxr))))))))))),sf_add(sf_imul(20,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr))))))))))),sf_add(sf_imul(-20,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr))))))))))),sf_add(sf_imul(-30,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxr))))))))))),dba)))));
dybn=sf_add(sf_imul(5,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dyb,sf_sgn(Xxi))))))))))),sf_add(sf_imul(5,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxr))))))))))),sf_add(sf_imul(20,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr))))))))))),sf_add(sf_imul(-20,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr))))))))))),sf_add(sf_imul(-30,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxr))))))))))),dbb)))));
}

{xrn=sf_add(sf_add(sf_mul(sf_diffabs(Xr,xr),sf_add(sf_sub(sf_mul(sf_mul(sf_mul(Xr,Xr),Xr),Xr),sf_mul(sf_mul(sf_mul(sf_imul(10,Xr),Xr),Xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(5,Xi),Xi),Xi),Xi))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_add(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_mul(sf_imul(4,Xr),Xr),Xr),xr),sf_mul(sf_mul(sf_mul(sf_imul(6,Xr),Xr),xr),xr)),sf_mul(sf_mul(sf_mul(sf_imul(4,Xr),xr),xr),xr)),sf_mul(sf_mul(sf_mul(xr,xr),xr),xr)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xr),Xr),Xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(10,Xr),Xr),xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xr),xr),Xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(40,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xr),xr),xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(10,xr),xr),Xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(20,xr),xr),Xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(10,xr),xr),xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xi),Xi),Xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(30,Xi),Xi),xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xi),xi),xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(5,xi),xi),xi),xi)))),cr);
xin=sf_add(sf_add(sf_mul(sf_diffabs(Xi,xi),sf_add(sf_sub(sf_mul(sf_mul(sf_mul(sf_imul(5,Xr),Xr),Xr),Xr),sf_mul(sf_mul(sf_mul(sf_imul(10,Xr),Xr),Xi),Xi)),sf_mul(sf_mul(sf_mul(Xi,Xi),Xi),Xi))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_add(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_mul(sf_imul(20,Xr),Xr),Xr),xr),sf_mul(sf_mul(sf_mul(sf_imul(30,Xr),Xr),xr),xr)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xr),xr),xr),xr)),sf_mul(sf_mul(sf_mul(sf_imul(5,xr),xr),xr),xr)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xr),Xr),Xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(10,Xr),Xr),xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xr),xr),Xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(40,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xr),xr),xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(10,xr),xr),Xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(20,xr),xr),Xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(10,xr),xr),xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(4,Xi),Xi),Xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(6,Xi),Xi),xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(4,Xi),xi),xi),xi)),sf_mul(sf_mul(sf_mul(xi,xi),xi),xi)))),ci);
}

);

static const char *perturbation_opencl_softfloat_2_2_1 = STR(

{dxan=sf_add(sf_imul(2,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))),sf_add(sf_imul(-2,sf_mul(Xxi,sf_mul(dya,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))),daa));
dxbn=sf_add(sf_imul(2,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))),sf_add(sf_imul(-2,sf_mul(Xxi,sf_mul(dyb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))),dab));
dyan=sf_add(sf_imul(2,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(dxa,sf_sgn(Xxr))))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxi),sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxr))))),dba));
dybn=sf_add(sf_imul(2,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(dxb,sf_sgn(Xxr))))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxi),sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxr))))),dbb));
}

{xrn=sf_add(sf_diffabs(sf_sub(sf_mul(Xr,Xr),sf_mul(Xi,Xi)),sf_sub(sf_sub(sf_add(sf_mul(sf_imul(2,Xr),xr),sf_mul(xr,xr)),sf_mul(sf_imul(2,Xi),xi)),sf_mul(xi,xi))),cr);
xin=sf_add(sf_imul(2,sf_diffabs(sf_mul(Xr,Xi),sf_add(sf_add(sf_mul(Xr,xi),sf_mul(xr,Xi)),sf_mul(xr,xi)))),ci);
}

);

static const char *perturbation_opencl_softfloat_2_3_1 = STR(

{dxan=sf_add(sf_imul(3,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_imul(-3,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(-3,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxa,sf_sgn(sf_add(sf_imul(-3,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_imul(-3,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))),daa)));
dxbn=sf_add(sf_imul(3,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_imul(-3,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(-3,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxb,sf_sgn(sf_add(sf_imul(-3,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_imul(-3,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))),dab)));
dyan=sf_add(sf_imul(3,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_imul(3,sf_mul(Xxi,sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(-3,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dya,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_imul(3,sf_mul(Xxi,sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(6,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_imul(3,sf_mul(Xxi,sf_mul(Xxr,Xxr))))))))),dba)));
dybn=sf_add(sf_imul(3,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_imul(3,sf_mul(Xxi,sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(-3,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dyb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_imul(3,sf_mul(Xxi,sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(6,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_imul(3,sf_mul(Xxi,sf_mul(Xxr,Xxr))))))))),dbb)));
}

{xrn=sf_add(sf_diffabs(sf_mul(Xr,sf_sub(sf_mul(Xr,Xr),sf_mul(sf_imul(3,Xi),Xi))),sf_sub(sf_add(sf_mul(xr,sf_add(sf_mul(sf_imul(3,Xr),Xr),sf_mul(xr,xr))),sf_mul(sf_imul(3,Xr),sf_sub(sf_sub(sf_mul(xr,xr),sf_mul(sf_imul(2,Xi),xi)),sf_mul(xi,xi)))),sf_mul(sf_imul(3,xr),sf_add(sf_add(sf_mul(Xi,Xi),sf_mul(sf_imul(2,Xi),xi)),sf_mul(xi,xi))))),cr);
xin=sf_add(sf_diffabs(sf_mul(Xi,sf_sub(sf_mul(sf_imul(3,Xr),Xr),sf_mul(Xi,Xi))),sf_sub(sf_add(sf_mul(sf_imul(3,Xi),sf_sub(sf_add(sf_mul(sf_imul(2,Xr),xr),sf_mul(xr,xr)),sf_mul(xi,xi))),sf_mul(sf_imul(3,xi),sf_add(sf_add(sf_mul(Xr,Xr),sf_mul(sf_imul(2,Xr),xr)),sf_mul(xr,xr)))),sf_mul(xi,sf_add(sf_mul(sf_imul(3,Xi),Xi),sf_mul(xi,xi))))),ci);
}

);

static const char *perturbation_opencl_softfloat_2_4_1 = STR(

{dxan=sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dya,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),daa))));
dxbn=sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dyb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),dab))));
dyan=sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr)))),sf_imul(4,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxa,sf_sgn(sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr)))),sf_imul(4,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr)))),sf_imul(4,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr)))),sf_imul(4,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),dba))));
dybn=sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr)))),sf_imul(4,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxb,sf_sgn(sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr)))),sf_imul(4,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr)))),sf_imul(4,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr)))),sf_imul(4,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),dbb))));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_diffabs(sf_sub(sf_add(sf_mul(Xr2,Xr2),sf_mul(Xi2,Xi2)),sf_mul(sf_imul(6,Xr2),Xi2)),sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_mul(sf_imul(4,Xi),xi2),xi)),sf_mul(xi2,xi2)),sf_mul(sf_mul(sf_imul(12,Xr2),Xi),xi)),sf_mul(sf_imul(6,Xr2),xi2)),sf_mul(sf_mul(sf_imul(12,Xr),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(24,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_imul(12,Xr),xr),xi2)),sf_mul(sf_imul(6,xr2),Xi2)),sf_mul(sf_mul(sf_imul(12,xr2),Xi),xi)),sf_mul(sf_imul(6,xr2),xi2))),cr);
xin=sf_add(sf_diffabs(sf_sub(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),Xi),sf_mul(sf_mul(sf_imul(4,Xr),Xi2),Xi)),sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_mul(sf_mul(sf_imul(-4,xr),Xi2),Xi),sf_mul(sf_mul(sf_imul(12,xi),Xr),Xi2)),sf_mul(sf_mul(sf_imul(12,xr),xi),Xi2)),sf_mul(sf_mul(sf_imul(12,xr),Xr2),Xi)),sf_mul(sf_mul(sf_imul(12,xi2),Xr),Xi)),sf_mul(sf_mul(sf_imul(12,xr2),Xr),Xi)),sf_mul(sf_mul(sf_imul(12,xr),xi2),Xi)),sf_mul(sf_mul(sf_imul(4,xr2),xr),Xi)),sf_mul(sf_mul(sf_imul(4,xi),Xr2),Xr)),sf_mul(sf_mul(sf_imul(12,xr),xi),Xr2)),sf_mul(sf_mul(sf_imul(4,xi2),xi),Xr)),sf_mul(sf_mul(sf_imul(12,xr2),xi),Xr)),sf_mul(sf_mul(sf_imul(4,xr),xi2),xi)),sf_mul(sf_mul(sf_imul(4,xr2),xr),xi))),ci);
}

);

static const char *perturbation_opencl_softfloat_2_5_1 = STR(

{dxan=sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxa,sf_sgn(sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr))))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_add(sf_imul(5,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr))))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_add(sf_imul(-20,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr))))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_add(sf_imul(20,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr))))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_add(sf_imul(-30,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr))))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),daa)))));
dxbn=sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxb,sf_sgn(sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr))))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_add(sf_imul(5,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr))))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_add(sf_imul(-20,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr))))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_add(sf_imul(20,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr))))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_add(sf_imul(-30,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr))))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),dab)))));
dyan=sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dya,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr))))),sf_imul(5,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))))))))),sf_add(sf_imul(5,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr))))),sf_imul(5,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))))))))),sf_add(sf_imul(20,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr))))),sf_imul(5,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))))))))),sf_add(sf_imul(-20,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr))))),sf_imul(5,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))))))))),sf_add(sf_imul(-30,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr))))),sf_imul(5,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))))))))),dba)))));
dybn=sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dyb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr))))),sf_imul(5,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))))))))),sf_add(sf_imul(5,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr))))),sf_imul(5,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))))))))),sf_add(sf_imul(20,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr))))),sf_imul(5,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))))))))),sf_add(sf_imul(-20,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr))))),sf_imul(5,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))))))))),sf_add(sf_imul(-30,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr))))),sf_imul(5,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))))))))),dbb)))));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_diffabs(sf_add(sf_sub(sf_mul(sf_mul(sf_imul(5,Xr),Xi2),Xi2),sf_mul(sf_mul(sf_imul(10,Xr2),Xr),Xi2)),sf_mul(sf_mul(Xr2,Xr2),Xr)),sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_sub(sf_mul(sf_mul(sf_mul(sf_imul(20,Xr),xi),Xi2),Xi),sf_mul(sf_mul(sf_imul(30,Xr2),xr),Xi2)),sf_mul(sf_mul(sf_imul(30,Xr),xi2),Xi2)),sf_mul(sf_mul(sf_imul(30,Xr),xr2),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xr2),Xr),xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xr2),xr),xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xr),xi2),xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xr),xr2),xi),Xi)),sf_mul(sf_mul(sf_imul(5,Xr2),Xr2),xr)),sf_mul(sf_mul(sf_imul(10,Xr2),Xr),xi2)),sf_mul(sf_mul(sf_imul(10,Xr2),Xr),xr2)),sf_mul(sf_mul(sf_imul(30,Xr2),xr),xi2)),sf_mul(sf_mul(sf_imul(10,Xr2),xr2),xr)),sf_mul(sf_mul(sf_imul(5,Xr),xi2),xi2)),sf_mul(sf_mul(sf_imul(30,Xr),xr2),xi2)),sf_mul(sf_mul(sf_imul(5,Xr),xr2),xr2)),sf_mul(sf_mul(sf_imul(5,xr),Xi2),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xr),xi),Xi2),Xi)),sf_mul(sf_mul(sf_imul(30,xr),xi2),Xi2)),sf_mul(sf_mul(sf_imul(10,xr2),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xr),xi2),xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(20,xr2),xr),xi),Xi)),sf_mul(sf_mul(sf_imul(5,xr),xi2),xi2)),sf_mul(sf_mul(sf_imul(10,xr2),xr),xi2)),sf_mul(sf_mul(xr2,xr2),xr))),cr);
xin=sf_add(sf_diffabs(sf_add(sf_sub(sf_mul(sf_mul(Xi2,Xi2),Xi),sf_mul(sf_mul(sf_imul(10,Xi2),Xi),Xr2)),sf_mul(sf_mul(sf_imul(5,Xi),Xr2),Xr2)),sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_add(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_sub(sf_mul(sf_mul(sf_imul(5,Xi2),Xi2),xi),sf_mul(sf_mul(sf_mul(sf_imul(20,Xi2),Xi),xr),Xr)),sf_mul(sf_mul(sf_imul(10,Xi2),Xi),xi2)),sf_mul(sf_mul(sf_imul(10,Xi2),Xi),xr2)),sf_mul(sf_mul(sf_imul(30,Xi2),xi),Xr2)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xi2),xr),xi),Xr)),sf_mul(sf_mul(sf_imul(10,Xi2),xi2),xi)),sf_mul(sf_mul(sf_imul(30,Xi2),xr2),xi)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xi),xr),Xr2),Xr)),sf_mul(sf_mul(sf_imul(30,Xi),xi2),Xr2)),sf_mul(sf_mul(sf_imul(30,Xi),xr2),Xr2)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xi),xr),xi2),Xr)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xi),xr2),xr),Xr)),sf_mul(sf_mul(sf_imul(5,Xi),xi2),xi2)),sf_mul(sf_mul(sf_imul(30,Xi),xr2),xi2)),sf_mul(sf_mul(sf_imul(5,Xi),xr2),xr2)),sf_mul(sf_mul(sf_imul(5,xi),Xr2),Xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi),xr),Xr2),Xr)),sf_mul(sf_mul(sf_imul(10,xi2),xi),Xr2)),sf_mul(sf_mul(sf_imul(30,xi),xr2),Xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi2),xi),xr),Xr)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi),xr2),xr),Xr)),sf_mul(sf_mul(xi2,xi2),xi)),sf_mul(sf_mul(sf_imul(10,xi2),xi),xr2)),sf_mul(sf_mul(sf_imul(5,xi),xr2),xr2))),ci);
}

);

static const char *perturbation_opencl_softfloat_3_2_1 = STR(

{dxan=sf_add(sf_imul(2,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))),sf_add(sf_imul(-2,sf_mul(Xxi,sf_mul(dya,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))),daa));
dxbn=sf_add(sf_imul(2,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))),sf_add(sf_imul(-2,sf_mul(Xxi,sf_mul(dyb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))),dab));
dyan=sf_add(sf_imul(2,sf_mul(Xxi,dxa)),sf_add(sf_imul(2,sf_mul(Xxr,dya)),dba));
dybn=sf_add(sf_imul(2,sf_mul(Xxi,dxb)),sf_add(sf_imul(2,sf_mul(Xxr,dyb)),dbb));
}

{xrn=sf_add(sf_diffabs(sf_sub(sf_mul(Xr,Xr),sf_mul(Xi,Xi)),sf_sub(sf_mul(sf_add(sf_imul(2,Xr),xr),xr),sf_mul(sf_add(sf_imul(2,Xi),xi),xi))),cr);
xin=sf_add(sf_add(sf_mul(sf_imul(2,Xr),xi),sf_mul(sf_imul(2,xr),sf_add(Xi,xi))),ci);
}

);

static const char *perturbation_opencl_softfloat_3_3_1 = STR(

{dxan=sf_add(sf_imul(3,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_imul(-3,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(-3,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxa,sf_sgn(sf_add(sf_imul(-3,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_imul(-3,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))),daa)));
dxbn=sf_add(sf_imul(3,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_imul(-3,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(-3,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxb,sf_sgn(sf_add(sf_imul(-3,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_imul(-3,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))),dab)));
dyan=sf_add(sf_imul(3,sf_mul(Xxr,sf_mul(Xxr,dya))),sf_add(sf_imul(-3,sf_mul(Xxi,sf_mul(Xxi,dya))),sf_add(sf_imul(6,sf_mul(Xxi,sf_mul(Xxr,dxa))),dba)));
dybn=sf_add(sf_imul(3,sf_mul(Xxr,sf_mul(Xxr,dyb))),sf_add(sf_imul(-3,sf_mul(Xxi,sf_mul(Xxi,dyb))),sf_add(sf_imul(6,sf_mul(Xxi,sf_mul(Xxr,dxb))),dbb)));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_diffabs(sf_mul(Xr,sf_sub(Xr2,sf_imul(3,Xi2))),sf_sub(sf_add(sf_mul(xr,sf_add(sf_imul(3,Xr2),xr2)),sf_mul(sf_imul(3,Xr),sf_sub(sf_sub(xr2,sf_mul(sf_imul(2,Xi),xi)),xi2))),sf_mul(sf_imul(3,xr),sf_add(sf_add(Xi2,sf_mul(sf_imul(2,Xi),xi)),xi2)))),cr);
xin=sf_add(sf_sub(sf_add(sf_mul(sf_imul(3,Xi),sf_sub(sf_add(sf_mul(sf_imul(2,Xr),xr),xr2),xi2)),sf_mul(sf_imul(3,xi),sf_add(sf_add(Xr2,sf_mul(sf_imul(2,Xr),xr)),xr2))),sf_mul(xi,sf_add(xi2,sf_imul(3,Xi2)))),ci);
}

);

static const char *perturbation_opencl_softfloat_3_4_1 = STR(

{dxan=sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dya,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),daa))));
dxbn=sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dyb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),dab))));
dyan=sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dya)))),sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dxa)))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,dya)))),sf_add(sf_imul(12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,dxa)))),dba))));
dybn=sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dyb)))),sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dxb)))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,dyb)))),sf_add(sf_imul(12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,dxb)))),dbb))));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_diffabs(sf_sub(sf_add(sf_mul(Xr2,Xr2),sf_mul(Xi2,Xi2)),sf_mul(sf_imul(6,Xr2),Xi2)),sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_mul(sf_imul(4,Xi),xi2),xi)),sf_mul(xi2,xi2)),sf_mul(sf_mul(sf_imul(12,xr),Xr),Xi2)),sf_mul(sf_imul(6,xr2),Xi2)),sf_mul(sf_mul(sf_imul(12,xi),Xr2),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(24,xr),xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(12,xr2),xi),Xi)),sf_mul(sf_imul(6,xi2),Xr2)),sf_mul(sf_mul(sf_imul(12,xr),xi2),Xr)),sf_mul(sf_imul(6,xr2),xi2))),cr);
xin=sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_sub(sf_add(sf_add(sf_add(sf_sub(sf_sub(sf_add(sf_mul(sf_mul(sf_imul(12,Xr2),Xi),xr),sf_mul(sf_mul(sf_imul(12,Xr),Xi),xr2)),sf_mul(sf_mul(sf_imul(12,Xr),Xi2),xi)),sf_mul(sf_mul(sf_imul(12,Xr),Xi),xi2)),sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xi)),sf_mul(sf_mul(sf_imul(12,Xr2),xi),xr)),sf_mul(sf_mul(sf_imul(12,Xr),xi),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xi2),xi)),sf_mul(sf_mul(sf_imul(4,xr2),xr),Xi)),sf_mul(sf_mul(sf_imul(4,xr),Xi2),Xi)),sf_mul(sf_mul(sf_imul(12,xr),Xi2),xi)),sf_mul(sf_mul(sf_imul(12,xr),Xi),xi2)),sf_mul(sf_mul(sf_imul(4,xr2),xr),xi)),sf_mul(sf_mul(sf_imul(4,xr),xi2),xi)),ci);
}

);

static const char *perturbation_opencl_softfloat_3_5_1 = STR(

{dxan=sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxa,sf_sgn(sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr))))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_add(sf_imul(5,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr))))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_add(sf_imul(-20,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr))))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_add(sf_imul(20,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr))))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_add(sf_imul(-30,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr))))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),daa)))));
dxbn=sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxb,sf_sgn(sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr))))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_add(sf_imul(5,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr))))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_add(sf_imul(-20,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr))))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_add(sf_imul(20,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr))))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_add(sf_imul(-30,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr))))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),dab)))));
dyan=sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dya))))),sf_add(sf_imul(5,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dya))))),sf_add(sf_imul(20,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dxa))))),sf_add(sf_imul(-20,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,dxa))))),sf_add(sf_imul(-30,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,dya))))),dba)))));
dybn=sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dyb))))),sf_add(sf_imul(5,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dyb))))),sf_add(sf_imul(20,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dxb))))),sf_add(sf_imul(-20,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,dxb))))),sf_add(sf_imul(-30,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,dyb))))),dbb)))));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_diffabs(sf_add(sf_sub(sf_mul(sf_mul(Xr2,Xr2),Xr),sf_mul(sf_mul(sf_imul(10,Xr2),Xr),Xi2)),sf_mul(sf_mul(sf_imul(5,Xr),Xi2),Xi2)),sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_sub(sf_mul(sf_mul(sf_mul(sf_imul(20,Xr),xi),Xi2),Xi),sf_mul(sf_mul(sf_imul(30,Xr2),xr),Xi2)),sf_mul(sf_mul(sf_imul(30,Xr),xi2),Xi2)),sf_mul(sf_mul(sf_imul(30,Xr),xr2),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xr2),Xr),xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xr2),xr),xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xr),xi2),xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xr),xr2),xi),Xi)),sf_mul(sf_mul(sf_imul(5,Xr2),Xr2),xr)),sf_mul(sf_mul(sf_imul(10,Xr2),Xr),xi2)),sf_mul(sf_mul(sf_imul(10,Xr2),Xr),xr2)),sf_mul(sf_mul(sf_imul(30,Xr2),xr),xi2)),sf_mul(sf_mul(sf_imul(10,Xr2),xr2),xr)),sf_mul(sf_mul(sf_imul(5,Xr),xi2),xi2)),sf_mul(sf_mul(sf_imul(30,Xr),xr2),xi2)),sf_mul(sf_mul(sf_imul(5,Xr),xr2),xr2)),sf_mul(sf_mul(sf_imul(5,xr),Xi2),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xr),xi),Xi2),Xi)),sf_mul(sf_mul(sf_imul(30,xr),xi2),Xi2)),sf_mul(sf_mul(sf_imul(10,xr2),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xr),xi2),xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(20,xr2),xr),xi),Xi)),sf_mul(sf_mul(sf_imul(5,xr),xi2),xi2)),sf_mul(sf_mul(sf_imul(10,xr2),xr),xi2)),sf_mul(sf_mul(xr2,xr2),xr))),cr);
xin=sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_mul(sf_imul(20,Xi),Xr2),Xr),xr),sf_mul(sf_mul(sf_imul(30,Xi),Xr2),xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xi),Xr),xr2),xr)),sf_mul(sf_mul(sf_imul(5,Xi),xr2),xr2)),sf_mul(sf_mul(sf_imul(30,Xi2),Xr2),xi)),sf_mul(sf_mul(sf_imul(30,Xi),Xr2),xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xi2),Xi),Xr),xr)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xi2),Xr),xr),xi)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xi),Xr),xr),xi2)),sf_mul(sf_mul(sf_imul(10,Xi2),Xi),xr2)),sf_mul(sf_mul(sf_imul(30,Xi2),xr2),xi)),sf_mul(sf_mul(sf_imul(30,Xi),xr2),xi2)),sf_mul(sf_mul(sf_imul(5,Xi2),Xi2),xi)),sf_mul(sf_mul(sf_imul(10,Xi2),Xi),xi2)),sf_mul(sf_mul(sf_imul(10,Xi2),xi2),xi)),sf_mul(sf_mul(sf_imul(5,Xi),xi2),xi2)),sf_mul(sf_mul(sf_imul(5,xi),Xr2),Xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi),Xr2),Xr),xr)),sf_mul(sf_mul(sf_imul(30,xi),Xr2),xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi),Xr),xr2),xr)),sf_mul(sf_mul(sf_imul(5,xi),xr2),xr2)),sf_mul(sf_mul(sf_imul(10,xi2),xi),Xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi2),xi),Xr),xr)),sf_mul(sf_mul(sf_imul(10,xi2),xi),xr2)),sf_mul(sf_mul(xi2,xi2),xi)),ci);
}

);

static const char *perturbation_opencl_softfloat_4_2_1 = STR(

{dxan=sf_add(sf_imul(-2,sf_mul(Xxi,dya)),sf_add(sf_imul(2,sf_mul(Xxr,dxa)),daa));
dxbn=sf_add(sf_imul(-2,sf_mul(Xxi,dyb)),sf_add(sf_imul(2,sf_mul(Xxr,dxb)),dab));
dyan=sf_add(sf_imul(-2,sf_mul(Xxi,dxa)),sf_add(sf_imul(-2,sf_mul(Xxr,dya)),dba));
dybn=sf_add(sf_imul(-2,sf_mul(Xxi,dxb)),sf_add(sf_imul(-2,sf_mul(Xxr,dyb)),dbb));
}

{const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_sub(sf_sub(sf_add(sf_mul(sf_imul(2,Xr),xr),xr2),xi2),sf_mul(sf_imul(2,xi),Xi)),cr);
xin=sf_sub(ci,sf_imul(2,sf_add(sf_add(sf_mul(Xr,xi),sf_mul(xr,Xi)),sf_mul(xr,xi))));
}

);

static const char *perturbation_opencl_softfloat_4_3_1 = STR(

{dxan=sf_add(sf_imul(3,sf_mul(Xxr,sf_mul(Xxr,dxa))),sf_add(sf_imul(-3,sf_mul(Xxi,sf_mul(Xxi,dxa))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxr,dya))),daa)));
dxbn=sf_add(sf_imul(3,sf_mul(Xxr,sf_mul(Xxr,dxb))),sf_add(sf_imul(-3,sf_mul(Xxi,sf_mul(Xxi,dxb))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxr,dyb))),dab)));
dyan=sf_add(sf_imul(-3,sf_mul(Xxr,sf_mul(Xxr,dya))),sf_add(sf_imul(3,sf_mul(Xxi,sf_mul(Xxi,dya))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxr,dxa))),dba)));
dybn=sf_add(sf_imul(-3,sf_mul(Xxr,sf_mul(Xxr,dyb))),sf_add(sf_imul(3,sf_mul(Xxi,sf_mul(Xxi,dyb))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxr,dxb))),dbb)));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_add(sf_sub(cr,sf_mul(xr,sf_add(sf_imul(3,Xr2),xr2))),sf_mul(sf_imul(3,Xr),sf_sub(sf_add(xi2,sf_mul(sf_imul(2,Xi),xi)),xr2))),sf_mul(sf_imul(3,xr),sf_add(sf_add(Xi2,sf_mul(sf_imul(2,Xi),xi)),xi2)));
xin=sf_add(sf_sub(sf_add(sf_add(sf_add(sf_sub(sf_sub(sf_add(sf_mul(sf_mul(sf_imul(6,Xr),Xi),xr),sf_mul(sf_imul(3,Xi),xr2)),sf_mul(sf_imul(3,Xi2),xi)),sf_mul(sf_imul(3,Xi),xi2)),sf_mul(sf_imul(3,Xr2),xi)),sf_mul(sf_mul(sf_imul(6,Xr),xr),xi)),sf_mul(sf_imul(3,xr2),xi)),sf_mul(xi2,xi)),ci);
}

);

static const char *perturbation_opencl_softfloat_4_4_1 = STR(

{dxan=sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dya)))),sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dxa)))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,dxa)))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,dya)))),daa))));
dxbn=sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dyb)))),sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dxb)))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,dxb)))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,dyb)))),dab))));
dyan=sf_add(sf_imul(-4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dya)))),sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dxa)))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,dxa)))),sf_add(sf_imul(12,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,dya)))),dba))));
dybn=sf_add(sf_imul(-4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dyb)))),sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dxb)))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,dxb)))),sf_add(sf_imul(12,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,dyb)))),dbb))));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_mul(sf_imul(4,Xi),xi2),xi)),sf_mul(xi2,xi2)),sf_mul(sf_mul(sf_imul(12,Xr2),Xi),xi)),sf_mul(sf_imul(6,Xr2),xi2)),sf_mul(sf_mul(sf_imul(12,Xr),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(24,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_imul(12,Xr),xr),xi2)),sf_mul(sf_imul(6,xr2),Xi2)),sf_mul(sf_mul(sf_imul(12,xr2),Xi),xi)),sf_mul(sf_imul(6,xr2),xi2)),cr);
xin=sf_add(sf_add(sf_sub(sf_add(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_sub(sf_mul(sf_mul(sf_imul(-12,Xr2),Xi),xr),sf_mul(sf_mul(sf_imul(12,Xr),Xi),xr2)),sf_mul(sf_mul(sf_imul(12,Xr),Xi2),xi)),sf_mul(sf_mul(sf_imul(12,Xr),Xi),xi2)),sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xi)),sf_mul(sf_mul(sf_imul(12,Xr2),xi),xr)),sf_mul(sf_mul(sf_imul(12,Xr),xi),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xi2),xi)),sf_mul(sf_mul(sf_imul(4,xr2),xr),Xi)),sf_mul(sf_mul(sf_imul(4,xr),Xi2),Xi)),sf_mul(sf_mul(sf_imul(12,xr),Xi2),xi)),sf_mul(sf_mul(sf_imul(12,xr),Xi),xi2)),sf_mul(sf_mul(sf_imul(4,xr2),xr),xi)),sf_mul(sf_mul(sf_imul(4,xr),xi2),xi)),ci);
}

);

static const char *perturbation_opencl_softfloat_4_5_1 = STR(

{dxan=sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dxa))))),sf_add(sf_imul(5,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dxa))))),sf_add(sf_imul(20,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,dya))))),sf_add(sf_imul(-20,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dya))))),sf_add(sf_imul(-30,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,dxa))))),daa)))));
dxbn=sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dxb))))),sf_add(sf_imul(5,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dxb))))),sf_add(sf_imul(20,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,dyb))))),sf_add(sf_imul(-20,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dyb))))),sf_add(sf_imul(-30,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,dxb))))),dab)))));
dyan=sf_add(sf_imul(-5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dya))))),sf_add(sf_imul(-5,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dya))))),sf_add(sf_imul(20,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,dxa))))),sf_add(sf_imul(-20,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dxa))))),sf_add(sf_imul(30,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,dya))))),dba)))));
dybn=sf_add(sf_imul(-5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dyb))))),sf_add(sf_imul(-5,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dyb))))),sf_add(sf_imul(20,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,dxb))))),sf_add(sf_imul(-20,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dxb))))),sf_add(sf_imul(30,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,dyb))))),dbb)))));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(5,Xr2),Xr2),xr),sf_mul(sf_mul(sf_imul(10,Xr2),Xr),xr2)),sf_mul(sf_mul(sf_imul(10,Xr2),xr2),xr)),sf_mul(sf_mul(sf_imul(5,Xr),xr2),xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xr2),Xr),Xi),xi)),sf_mul(sf_mul(sf_imul(10,Xr2),Xr),xi2)),sf_mul(sf_mul(sf_imul(30,Xr2),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xr2),xr),Xi),xi)),sf_mul(sf_mul(sf_imul(30,Xr2),xr),xi2)),sf_mul(sf_mul(sf_imul(30,Xr),xr2),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xr),xr2),Xi),xi)),sf_mul(sf_mul(sf_imul(30,Xr),xr2),xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xr),Xi2),Xi),xi)),sf_mul(sf_mul(sf_imul(30,Xr),Xi2),xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xr),Xi),xi2),xi)),sf_mul(sf_mul(sf_imul(5,Xr),xi2),xi2)),sf_mul(sf_mul(xr2,xr2),xr)),sf_mul(sf_mul(sf_imul(10,xr2),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xr2),xr),Xi),xi)),sf_mul(sf_mul(sf_imul(10,xr2),xr),xi2)),sf_mul(sf_mul(sf_imul(5,xr),Xi2),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xr),Xi2),Xi),xi)),sf_mul(sf_mul(sf_imul(30,xr),Xi2),xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xr),Xi),xi2),xi)),sf_mul(sf_mul(sf_imul(5,xr),xi2),xi2)),cr);
xin=sf_add(sf_sub(sf_add(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_mul(sf_mul(sf_mul(sf_imul(-20,Xi),Xr2),Xr),xr),sf_mul(sf_mul(sf_imul(30,Xi),Xr2),xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xi),Xr),xr2),xr)),sf_mul(sf_mul(sf_imul(5,Xi),xr2),xr2)),sf_mul(sf_mul(sf_imul(30,Xi2),Xr2),xi)),sf_mul(sf_mul(sf_imul(30,Xi),Xr2),xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xi2),Xi),Xr),xr)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xi2),Xr),xr),xi)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xi),Xr),xr),xi2)),sf_mul(sf_mul(sf_imul(10,Xi2),Xi),xr2)),sf_mul(sf_mul(sf_imul(30,Xi2),xr2),xi)),sf_mul(sf_mul(sf_imul(30,Xi),xr2),xi2)),sf_mul(sf_mul(sf_imul(5,Xi2),Xi2),xi)),sf_mul(sf_mul(sf_imul(10,Xi2),Xi),xi2)),sf_mul(sf_mul(sf_imul(10,Xi2),xi2),xi)),sf_mul(sf_mul(sf_imul(5,Xi),xi2),xi2)),sf_mul(sf_mul(sf_imul(5,xi),Xr2),Xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi),Xr2),Xr),xr)),sf_mul(sf_mul(sf_imul(30,xi),Xr2),xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi),Xr),xr2),xr)),sf_mul(sf_mul(sf_imul(5,xi),xr2),xr2)),sf_mul(sf_mul(sf_imul(10,xi2),xi),Xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi2),xi),Xr),xr)),sf_mul(sf_mul(sf_imul(10,xi2),xi),xr2)),sf_mul(sf_mul(xi2,xi2),xi)),ci);
}

);

static const char *perturbation_opencl_softfloat_5_2_1 = STR(

{dxan=sf_add(sf_imul(2,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))),sf_add(sf_imul(-2,sf_mul(Xxi,sf_mul(dya,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))),daa));
dxbn=sf_add(sf_imul(2,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))),sf_add(sf_imul(-2,sf_mul(Xxi,sf_mul(dyb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))),dab));
dyan=sf_add(sf_imul(-2,sf_mul(Xxi,dxa)),sf_add(sf_imul(-2,sf_mul(Xxr,dya)),dba));
dybn=sf_add(sf_imul(-2,sf_mul(Xxi,dxb)),sf_add(sf_imul(-2,sf_mul(Xxr,dyb)),dbb));
}

{const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_diffabs(sf_sub(sf_mul(Xr,Xr),sf_mul(Xi,Xi)),sf_sub(sf_sub(sf_add(sf_mul(sf_imul(2,Xr),xr),xr2),sf_mul(sf_imul(2,Xi),xi)),xi2)),cr);
xin=sf_add(sf_muli(sf_add(sf_add(sf_mul(Xr,xi),sf_mul(xr,Xi)),sf_mul(xr,xi)),-2),ci);
}

);

static const char *perturbation_opencl_softfloat_6_2_1 = STR(

{dxan=sf_add(sf_imul(2,sf_mul(Xxr,dxa)),sf_add(sf_imul(-2,sf_mul(Xxi,dya)),daa));
dxbn=sf_add(sf_imul(2,sf_mul(Xxr,dxb)),sf_add(sf_imul(-2,sf_mul(Xxi,dyb)),dab));
dyan=sf_add(dba,sf_add(sf_imul(-2,sf_mul(Xxi,sf_mul(dxa,sf_sgn(Xxr)))),sf_imul(-2,sf_mul(sf_abs(Xxr),dya))));
dybn=sf_add(dbb,sf_add(sf_imul(-2,sf_mul(Xxi,sf_mul(dxb,sf_sgn(Xxr)))),sf_imul(-2,sf_mul(sf_abs(Xxr),dyb))));
}

{const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_sub(sf_sub(sf_add(sf_mul(sf_imul(2,Xr),xr),xr2),xi2),sf_mul(sf_imul(2,xi),Xi)),cr);
xin=sf_add(sf_add(sf_muli(sf_mul(sf_abs(sf_add(Xr,xr)),xi),-2),sf_muli(sf_mul(sf_diffabs(Xr,xr),Xi),-2)),ci);
}

);

static const char *perturbation_opencl_softfloat_7_2_1 = STR(

{dxan=sf_add(sf_imul(2,sf_mul(Xxr,dxa)),sf_add(sf_imul(-2,sf_mul(Xxi,dya)),daa));
dxbn=sf_add(sf_imul(2,sf_mul(Xxr,dxb)),sf_add(sf_imul(-2,sf_mul(Xxi,dyb)),dab));
dyan=sf_add(dba,sf_add(sf_imul(-2,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxi)))),sf_imul(-2,sf_mul(sf_abs(Xxi),dxa))));
dybn=sf_add(dbb,sf_add(sf_imul(-2,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxi)))),sf_imul(-2,sf_mul(sf_abs(Xxi),dxb))));
}

{const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_sub(sf_sub(sf_add(sf_mul(sf_imul(2,Xr),xr),xr2),xi2),sf_mul(sf_imul(2,xi),Xi)),cr);
xin=sf_add(sf_add(sf_muli(sf_mul(sf_diffabs(Xi,xi),Xr),-2),sf_muli(sf_mul(xr,sf_abs(sf_add(Xi,xi))),-2)),ci);
}

);

static const char *perturbation_opencl_softfloat_8_2_1 = STR(

{dxan=sf_add(sf_imul(2,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))),sf_add(sf_imul(-2,sf_mul(Xxi,sf_mul(dya,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))),daa));
dxbn=sf_add(sf_imul(2,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))),sf_add(sf_imul(-2,sf_mul(Xxi,sf_mul(dyb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))),dab));
dyan=sf_add(dba,sf_add(sf_imul(-2,sf_mul(Xxi,sf_mul(dxa,sf_sgn(Xxr)))),sf_imul(-2,sf_mul(sf_abs(Xxr),dya))));
dybn=sf_add(dbb,sf_add(sf_imul(-2,sf_mul(Xxi,sf_mul(dxb,sf_sgn(Xxr)))),sf_imul(-2,sf_mul(sf_abs(Xxr),dyb))));
}

{const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_diffabs(sf_sub(sf_mul(Xr,Xr),sf_mul(Xi,Xi)),sf_sub(sf_sub(sf_add(sf_mul(sf_imul(2,Xr),xr),xr2),sf_mul(sf_imul(2,Xi),xi)),xi2)),cr);
xin=sf_add(sf_add(sf_muli(sf_mul(sf_abs(sf_add(Xr,xr)),xi),-2),sf_muli(sf_mul(sf_diffabs(Xr,xr),Xi),-2)),ci);
}

);

static const char *perturbation_opencl_softfloat_9_2_1 = STR(

{dxan=sf_add(sf_imul(2,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))),sf_add(sf_imul(-2,sf_mul(Xxi,sf_mul(dya,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))),daa));
dxbn=sf_add(sf_imul(2,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))),sf_add(sf_imul(-2,sf_mul(Xxi,sf_mul(dyb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))),dab));
dyan=sf_add(dba,sf_add(sf_imul(-2,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxi)))),sf_imul(-2,sf_mul(sf_abs(Xxi),dxa))));
dybn=sf_add(dbb,sf_add(sf_imul(-2,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxi)))),sf_imul(-2,sf_mul(sf_abs(Xxi),dxb))));
}

{const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_diffabs(sf_sub(sf_mul(Xr,Xr),sf_mul(Xi,Xi)),sf_sub(sf_sub(sf_add(sf_mul(sf_imul(2,Xr),xr),xr2),sf_mul(sf_imul(2,Xi),xi)),xi2)),cr);
xin=sf_add(sf_add(sf_muli(sf_mul(sf_diffabs(Xi,xi),Xr),-2),sf_muli(sf_mul(xr,sf_abs(sf_add(Xi,xi))),-2)),ci);
}

);

static const char *perturbation_opencl_softfloat_10_3_1 = STR(

{dxan=sf_add(sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr)))),sf_add(sf_imul(2,sf_mul(sf_abs(Xxr),sf_mul(Xxr,dxa))),sf_add(sf_imul(-3,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxa,sf_sgn(Xxr))))),sf_add(sf_imul(-6,sf_mul(sf_abs(Xxr),sf_mul(Xxi,dya))),daa))));
dxbn=sf_add(sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr)))),sf_add(sf_imul(2,sf_mul(sf_abs(Xxr),sf_mul(Xxr,dxb))),sf_add(sf_imul(-3,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxb,sf_sgn(Xxr))))),sf_add(sf_imul(-6,sf_mul(sf_abs(Xxr),sf_mul(Xxi,dyb))),dab))));
dyan=sf_add(sf_imul(-3,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_imul(3,sf_mul(Xxi,sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(3,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dya,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_imul(3,sf_mul(Xxi,sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_imul(3,sf_mul(Xxi,sf_mul(Xxr,Xxr))))))))),dba)));
dybn=sf_add(sf_imul(-3,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_imul(3,sf_mul(Xxi,sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(3,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dyb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_imul(3,sf_mul(Xxi,sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_imul(3,sf_mul(Xxi,sf_mul(Xxr,Xxr))))))))),dbb)));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_add(sf_mul(sf_sub(Xr2,sf_imul(3,Xi2)),sf_diffabs(Xr,xr)),sf_mul(sf_sub(sf_sub(sf_add(sf_mul(sf_imul(2,xr),Xr),xr2),sf_mul(sf_imul(6,Xi),xi)),sf_imul(3,xi2)),sf_abs(sf_add(Xr,xr)))),cr);
xin=sf_sub(ci,sf_diffabs(sf_mul(Xi,sf_sub(sf_imul(3,Xr2),Xi2)),sf_sub(sf_add(sf_mul(sf_imul(3,Xi),sf_sub(sf_add(sf_mul(sf_imul(2,Xr),xr),xr2),xi2)),sf_mul(sf_imul(3,xi),sf_add(sf_add(Xr2,sf_mul(sf_imul(2,Xr),xr)),xr2))),sf_mul(xi,sf_add(sf_imul(3,Xi2),xi2)))));
}

);

static const char *perturbation_opencl_softfloat_11_3_1 = STR(

{dxan=sf_add(sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr)))),sf_add(sf_imul(2,sf_mul(sf_abs(Xxr),sf_mul(Xxr,dxa))),sf_add(sf_imul(-3,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxa,sf_sgn(Xxr))))),sf_add(sf_imul(-6,sf_mul(sf_abs(Xxr),sf_mul(Xxi,dya))),daa))));
dxbn=sf_add(sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr)))),sf_add(sf_imul(2,sf_mul(sf_abs(Xxr),sf_mul(Xxr,dxb))),sf_add(sf_imul(-3,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxb,sf_sgn(Xxr))))),sf_add(sf_imul(-6,sf_mul(sf_abs(Xxr),sf_mul(Xxi,dyb))),dab))));
dyan=sf_add(sf_imul(3,sf_mul(Xxr,sf_mul(Xxr,dya))),sf_add(sf_imul(-3,sf_mul(Xxi,sf_mul(Xxi,dya))),sf_add(sf_imul(6,sf_mul(Xxi,sf_mul(Xxr,dxa))),dba)));
dybn=sf_add(sf_imul(3,sf_mul(Xxr,sf_mul(Xxr,dyb))),sf_add(sf_imul(-3,sf_mul(Xxi,sf_mul(Xxi,dyb))),sf_add(sf_imul(6,sf_mul(Xxi,sf_mul(Xxr,dxb))),dbb)));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_add(sf_mul(sf_sub(Xr2,sf_imul(3,Xi2)),sf_diffabs(Xr,xr)),sf_mul(sf_sub(sf_sub(sf_add(sf_mul(sf_imul(2,xr),Xr),xr2),sf_mul(sf_imul(6,Xi),xi)),sf_imul(3,xi2)),sf_abs(sf_add(Xr,xr)))),cr);
xin=sf_add(sf_add(sf_add(sf_add(sf_mul(sf_imul(6,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xr,xi))),sf_mul(sf_imul(3,Xi),sf_sub(xr2,xi2))),sf_mul(sf_imul(3,xi),sf_sub(Xr2,Xi2))),sf_mul(xi,sf_sub(sf_imul(3,xr2),xi2))),ci);
}

);

static const char *perturbation_opencl_softfloat_12_3_1 = STR(

{dxan=sf_add(sf_imul(3,sf_mul(Xxr,sf_mul(Xxr,dxa))),sf_add(sf_imul(-3,sf_mul(Xxi,sf_mul(Xxi,dxa))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxr,dya))),daa)));
dxbn=sf_add(sf_imul(3,sf_mul(Xxr,sf_mul(Xxr,dxb))),sf_add(sf_imul(-3,sf_mul(Xxi,sf_mul(Xxi,dxb))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxr,dyb))),dab)));
dyan=sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dya,sf_sgn(Xxi))))),sf_add(sf_imul(-2,sf_mul(sf_abs(Xxi),sf_mul(Xxi,dya))),sf_add(sf_imul(3,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxi))))),sf_add(sf_imul(6,sf_mul(sf_abs(Xxi),sf_mul(Xxr,dxa))),dba))));
dybn=sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dyb,sf_sgn(Xxi))))),sf_add(sf_imul(-2,sf_mul(sf_abs(Xxi),sf_mul(Xxi,dyb))),sf_add(sf_imul(3,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxi))))),sf_add(sf_imul(6,sf_mul(sf_abs(Xxi),sf_mul(Xxr,dxb))),dbb))));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_sub(sf_sub(sf_add(sf_mul(sf_imul(3,Xr2),xr),sf_mul(sf_imul(3,Xr),xr2)),sf_mul(sf_mul(sf_imul(6,Xr),Xi),xi)),sf_mul(sf_imul(3,Xr),xi2)),sf_mul(xr,xr2)),sf_mul(sf_imul(3,Xi2),xr)),sf_mul(sf_mul(sf_imul(6,Xi),xr),xi)),sf_mul(sf_imul(3,xr),xi2)),cr);
xin=sf_add(sf_add(sf_mul(sf_sub(sf_imul(3,Xr2),Xi2),sf_diffabs(Xi,xi)),sf_mul(sf_sub(sf_sub(sf_add(sf_mul(sf_imul(6,xr),Xr),sf_imul(3,xr2)),sf_mul(sf_imul(2,Xi),xi)),xi2),sf_abs(sf_add(Xi,xi)))),ci);
}

);

static const char *perturbation_opencl_softfloat_13_3_1 = STR(

{dxan=sf_add(sf_imul(3,sf_mul(Xxr,sf_mul(Xxr,dxa))),sf_add(sf_imul(-3,sf_mul(Xxi,sf_mul(Xxi,dxa))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxr,dya))),daa)));
dxbn=sf_add(sf_imul(3,sf_mul(Xxr,sf_mul(Xxr,dxb))),sf_add(sf_imul(-3,sf_mul(Xxi,sf_mul(Xxi,dxb))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxr,dyb))),dab)));
dyan=sf_add(sf_imul(3,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_imul(3,sf_mul(Xxi,sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(-3,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dya,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_imul(3,sf_mul(Xxi,sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(6,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_imul(3,sf_mul(Xxi,sf_mul(Xxr,Xxr))))))))),dba)));
dybn=sf_add(sf_imul(3,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_imul(3,sf_mul(Xxi,sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(-3,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dyb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_imul(3,sf_mul(Xxi,sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(6,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_imul(3,sf_mul(Xxi,sf_mul(Xxr,Xxr))))))))),dbb)));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_sub(sf_sub(sf_add(sf_mul(sf_imul(3,Xr2),xr),sf_mul(sf_imul(3,Xr),xr2)),sf_mul(sf_mul(sf_imul(6,Xr),Xi),xi)),sf_mul(sf_imul(3,Xr),xi2)),sf_mul(xr,xr2)),sf_mul(sf_imul(3,Xi2),xr)),sf_mul(sf_mul(sf_imul(6,Xi),xr),xi)),sf_mul(sf_imul(3,xr),xi2)),cr);
xin=sf_add(sf_diffabs(sf_mul(Xi,sf_sub(sf_imul(3,Xr2),Xi2)),sf_sub(sf_add(sf_mul(sf_imul(3,Xi),sf_sub(sf_add(sf_mul(sf_imul(2,Xr),xr),xr2),xi2)),sf_mul(sf_imul(3,xi),sf_add(sf_add(Xr2,sf_mul(sf_imul(2,Xr),xr)),xr2))),sf_mul(xi,sf_add(sf_imul(3,Xi2),xi2)))),ci);
}

);

static const char *perturbation_opencl_softfloat_14_3_1 = STR(

{dxan=sf_add(sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr)))),sf_add(sf_imul(2,sf_mul(sf_abs(Xxr),sf_mul(Xxr,dxa))),sf_add(sf_imul(-3,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxa,sf_sgn(Xxr))))),sf_add(sf_imul(-6,sf_mul(sf_abs(Xxr),sf_mul(Xxi,dya))),daa))));
dxbn=sf_add(sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr)))),sf_add(sf_imul(2,sf_mul(sf_abs(Xxr),sf_mul(Xxr,dxb))),sf_add(sf_imul(-3,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxb,sf_sgn(Xxr))))),sf_add(sf_imul(-6,sf_mul(sf_abs(Xxr),sf_mul(Xxi,dyb))),dab))));
dyan=sf_add(dba,sf_add(sf_imul(2,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dya,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_imul(3,sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_imul(3,sf_mul(Xxr,Xxr)))))))),sf_imul(-1,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_imul(3,sf_mul(Xxr,Xxr)))),dya)))));
dybn=sf_add(dbb,sf_add(sf_imul(2,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dyb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_imul(3,sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_imul(3,sf_mul(Xxr,Xxr)))))))),sf_imul(-1,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_imul(3,sf_mul(Xxr,Xxr)))),dyb)))));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_add(sf_mul(sf_sub(Xr2,sf_imul(3,Xi2)),sf_diffabs(Xr,xr)),sf_mul(sf_sub(sf_sub(sf_add(sf_mul(sf_imul(2,xr),Xr),xr2),sf_mul(sf_imul(6,Xi),xi)),sf_imul(3,xi2)),sf_abs(sf_add(Xr,xr)))),cr);
xin=sf_sub(sf_sub(ci,sf_mul(sf_diffabs(sf_sub(sf_imul(3,Xr2),Xi2),sf_sub(sf_sub(sf_add(sf_mul(sf_imul(6,Xr),xr),sf_imul(3,xr2)),sf_mul(sf_imul(2,Xi),xi)),xi2)),Xi)),sf_mul(sf_abs(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_imul(3,Xr2),sf_mul(sf_imul(6,Xr),xr)),sf_imul(3,xr2)),Xi2),sf_mul(sf_imul(2,Xi),xi)),xi2)),xi));
}

);

static const char *perturbation_opencl_softfloat_15_4_1 = STR(

{dxan=sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dxa)))),sf_add(sf_imul(4,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dya,sf_sgn(Xxi))))))))),sf_add(sf_imul(-12,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxr,dxa))),sf_add(sf_imul(-12,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxi))))))),daa))));
dxbn=sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dxb)))),sf_add(sf_imul(4,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dyb,sf_sgn(Xxi))))))))),sf_add(sf_imul(-12,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxr,dxb))),sf_add(sf_imul(-12,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxi))))))),dab))));
dyan=sf_add(dba,sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxi)))))),sf_add(sf_imul(12,sf_mul(sf_abs(Xxi),sf_mul(Xxr,sf_mul(Xxr,dxa)))),sf_add(sf_imul(-12,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxi)))))))),sf_imul(-4,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))),dxa))))));
dybn=sf_add(dbb,sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxi)))))),sf_add(sf_imul(12,sf_mul(sf_abs(Xxi),sf_mul(Xxr,sf_mul(Xxr,dxb)))),sf_add(sf_imul(-12,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxi)))))))),sf_imul(-4,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))),dxb))))));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_mul(sf_imul(4,Xi),xi2),xi)),sf_mul(xi2,xi2)),sf_mul(sf_mul(sf_imul(12,Xr2),Xi),xi)),sf_mul(sf_imul(6,Xr2),xi2)),sf_mul(sf_mul(sf_imul(12,Xr),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(24,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_imul(12,Xr),xr),xi2)),sf_mul(sf_imul(6,xr2),Xi2)),sf_mul(sf_mul(sf_imul(12,xr2),Xi),xi)),sf_mul(sf_imul(6,xr2),xi2)),cr);
xin=sf_add(sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_mul(sf_imul(12,Xr2),xr),sf_mul(sf_imul(12,Xr),xr2)),sf_mul(sf_imul(4,xr2),xr)),sf_mul(sf_imul(4,xr),Xi2)),sf_mul(sf_mul(sf_imul(8,xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(8,xr),xi),Xi)),sf_mul(sf_imul(4,xi2),Xr)),sf_mul(sf_imul(4,xr),xi2))),sf_mul(sf_diffabs(Xi,xi),sf_sub(sf_mul(sf_imul(4,Xr2),Xr),sf_mul(sf_imul(4,Xr),Xi2)))),ci);
}

);

static const char *perturbation_opencl_softfloat_16_4_1 = STR(

{dxan=sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dya)))),sf_add(sf_imul(4,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr))))))))),sf_add(sf_imul(-12,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,dya))),sf_add(sf_imul(-12,sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr))))))),daa))));
dxbn=sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dyb)))),sf_add(sf_imul(4,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr))))))))),sf_add(sf_imul(-12,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,dyb))),sf_add(sf_imul(-12,sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr))))))),dab))));
dyan=sf_add(dba,sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxa,sf_sgn(Xxr)))))),sf_add(sf_imul(-12,sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(Xxi,dya)))),sf_add(sf_imul(12,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr)))))))),sf_imul(4,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),dya))))));
dybn=sf_add(dbb,sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxb,sf_sgn(Xxr)))))),sf_add(sf_imul(-12,sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(Xxi,dyb)))),sf_add(sf_imul(12,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr)))))))),sf_imul(4,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),dyb))))));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_mul(sf_imul(4,Xi),xi2),xi)),sf_mul(xi2,xi2)),sf_mul(sf_mul(sf_imul(12,Xr2),Xi),xi)),sf_mul(sf_imul(6,Xr2),xi2)),sf_mul(sf_mul(sf_imul(12,Xr),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(24,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_imul(12,Xr),xr),xi2)),sf_mul(sf_imul(6,xr2),Xi2)),sf_mul(sf_mul(sf_imul(12,xr2),Xi),xi)),sf_mul(sf_imul(6,xr2),xi2)),cr);
xin=sf_add(sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_imul(4,Xr2),xi),sf_mul(sf_mul(sf_imul(8,Xr),xr),Xi)),sf_mul(sf_mul(sf_imul(8,Xr),xr),xi)),sf_mul(sf_imul(4,xr2),Xi)),sf_mul(sf_imul(4,xr2),xi)),sf_mul(sf_imul(12,xi),Xi2)),sf_mul(sf_imul(12,xi2),Xi)),sf_mul(sf_imul(4,xi2),xi))),sf_mul(sf_diffabs(Xr,xr),sf_sub(sf_mul(sf_imul(4,Xr2),Xi),sf_mul(sf_imul(4,Xi2),Xi)))),ci);
}

);

static const char *perturbation_opencl_softfloat_17_4_1 = STR(

{dxan=sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dya)))),sf_add(sf_imul(4,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr))))))))),sf_add(sf_imul(-12,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,dya))),sf_add(sf_imul(-12,sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr))))))),daa))));
dxbn=sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dyb)))),sf_add(sf_imul(4,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr))))))))),sf_add(sf_imul(-12,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,dyb))),sf_add(sf_imul(-12,sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr))))))),dab))));
dyan=sf_add(dba,sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxa,sf_sgn(Xxr)))))),sf_add(sf_imul(12,sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(Xxi,dya)))),sf_add(sf_imul(-12,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr)))))))),sf_imul(-4,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),dya))))));
dybn=sf_add(dbb,sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxb,sf_sgn(Xxr)))))),sf_add(sf_imul(12,sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(Xxi,dyb)))),sf_add(sf_imul(-12,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr)))))))),sf_imul(-4,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),dyb))))));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_mul(sf_imul(4,Xi),xi2),xi)),sf_mul(xi2,xi2)),sf_mul(sf_mul(sf_imul(12,Xr2),Xi),xi)),sf_mul(sf_imul(6,Xr2),xi2)),sf_mul(sf_mul(sf_imul(12,Xr),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(24,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_imul(12,Xr),xr),xi2)),sf_mul(sf_imul(6,xr2),Xi2)),sf_mul(sf_mul(sf_imul(12,xr2),Xi),xi)),sf_mul(sf_imul(6,xr2),xi2)),cr);
xin=sf_add(sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_mul(sf_imul(12,Xi2),xi),sf_mul(sf_imul(12,Xi),xi2)),sf_mul(sf_imul(4,xi2),xi)),sf_mul(sf_mul(sf_imul(8,xr),Xr),Xi)),sf_mul(sf_imul(4,xr2),Xi)),sf_mul(sf_imul(4,xi),Xr2)),sf_mul(sf_mul(sf_imul(8,xr),xi),Xr)),sf_mul(sf_imul(4,xr2),xi))),sf_mul(sf_diffabs(Xr,xr),sf_sub(sf_mul(sf_imul(4,Xi2),Xi),sf_mul(sf_imul(4,Xr2),Xi)))),ci);
}

);

static const char *perturbation_opencl_softfloat_18_4_1 = STR(

{dxan=sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr))),sf_abs(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi)))))))))))),sf_add(sf_imul(4,sf_mul(sf_sgn(sf_add(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr))),sf_abs(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dya,sf_sgn(Xxi)))))))))),sf_add(sf_imul(-12,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(sf_sgn(sf_add(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr))),sf_abs(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))))))),sf_mul(Xxr,dxa)))),sf_add(sf_imul(-12,sf_mul(sf_sgn(sf_add(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr))),sf_abs(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))))))),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxi)))))))),daa))));
dxbn=sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr))),sf_abs(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi)))))))))))),sf_add(sf_imul(4,sf_mul(sf_sgn(sf_add(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr))),sf_abs(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dyb,sf_sgn(Xxi)))))))))),sf_add(sf_imul(-12,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(sf_sgn(sf_add(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr))),sf_abs(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))))))),sf_mul(Xxr,dxb)))),sf_add(sf_imul(-12,sf_mul(sf_sgn(sf_add(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr))),sf_abs(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))))))),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxi)))))))),dab))));
dyan=sf_add(dba,sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxi)))))),sf_add(sf_imul(12,sf_mul(sf_abs(Xxi),sf_mul(Xxr,sf_mul(Xxr,dxa)))),sf_add(sf_imul(-12,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxi)))))))),sf_imul(-4,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))),dxa))))));
dybn=sf_add(dbb,sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxi)))))),sf_add(sf_imul(12,sf_mul(sf_abs(Xxi),sf_mul(Xxr,sf_mul(Xxr,dxb)))),sf_add(sf_imul(-12,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxi)))))))),sf_imul(-4,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))),dxb))))));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_diffabs(sf_sub(sf_add(sf_mul(Xr2,Xr2),sf_mul(Xi2,Xi2)),sf_mul(sf_imul(6,Xr2),Xi2)),sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_mul(sf_imul(4,Xi),xi2),xi)),sf_mul(xi2,xi2)),sf_mul(sf_mul(sf_imul(12,xr),Xr),Xi2)),sf_mul(sf_imul(6,xr2),Xi2)),sf_mul(sf_mul(sf_imul(12,xi),Xr2),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(24,xr),xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(12,xr2),xi),Xi)),sf_mul(sf_imul(6,xi2),Xr2)),sf_mul(sf_mul(sf_imul(12,xr),xi2),Xr)),sf_mul(sf_imul(6,xr2),xi2))),cr);
xin=sf_add(sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_mul(sf_imul(12,Xr2),xr),sf_mul(sf_imul(12,Xr),xr2)),sf_mul(sf_imul(4,xr2),xr)),sf_mul(sf_imul(4,xr),Xi2)),sf_mul(sf_mul(sf_imul(8,xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(8,xr),xi),Xi)),sf_mul(sf_imul(4,xi2),Xr)),sf_mul(sf_imul(4,xr),xi2))),sf_mul(sf_diffabs(Xi,xi),sf_sub(sf_mul(sf_imul(4,Xr2),Xr),sf_mul(sf_imul(4,Xr),Xi2)))),ci);
}

);

static const char *perturbation_opencl_softfloat_19_4_1 = STR(

{dxan=sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dya,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,Xxi))),sf_abs(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))))))),sf_add(sf_imul(4,sf_mul(sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,Xxi))),sf_abs(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr)))))))))),sf_add(sf_imul(-12,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,Xxi))),sf_abs(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))),sf_mul(Xxi,dya)))),sf_add(sf_imul(-12,sf_mul(sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,Xxi))),sf_abs(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr)))))))),daa))));
dxbn=sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dyb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,Xxi))),sf_abs(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))))))),sf_add(sf_imul(4,sf_mul(sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,Xxi))),sf_abs(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr)))))))))),sf_add(sf_imul(-12,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,Xxi))),sf_abs(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))),sf_mul(Xxi,dyb)))),sf_add(sf_imul(-12,sf_mul(sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,Xxi))),sf_abs(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr)))))))),dab))));
dyan=sf_add(dba,sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxa,sf_sgn(Xxr)))))),sf_add(sf_imul(-12,sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(Xxi,dya)))),sf_add(sf_imul(12,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr)))))))),sf_imul(4,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),dya))))));
dybn=sf_add(dbb,sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxb,sf_sgn(Xxr)))))),sf_add(sf_imul(-12,sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(Xxi,dyb)))),sf_add(sf_imul(12,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr)))))))),sf_imul(4,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),dyb))))));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_diffabs(sf_sub(sf_add(sf_mul(Xr2,Xr2),sf_mul(Xi2,Xi2)),sf_mul(sf_imul(6,Xr2),Xi2)),sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_mul(sf_imul(4,Xi),xi2),xi)),sf_mul(xi2,xi2)),sf_mul(sf_mul(sf_imul(12,xr),Xr),Xi2)),sf_mul(sf_imul(6,xr2),Xi2)),sf_mul(sf_mul(sf_imul(12,xi),Xr2),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(24,xr),xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(12,xr2),xi),Xi)),sf_mul(sf_imul(6,xi2),Xr2)),sf_mul(sf_mul(sf_imul(12,xr),xi2),Xr)),sf_mul(sf_imul(6,xr2),xi2))),cr);
xin=sf_add(sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_imul(4,Xr2),xi),sf_mul(sf_mul(sf_imul(8,Xr),xr),Xi)),sf_mul(sf_mul(sf_imul(8,Xr),xr),xi)),sf_mul(sf_imul(4,xr2),Xi)),sf_mul(sf_imul(4,xr2),xi)),sf_mul(sf_imul(12,xi),Xi2)),sf_mul(sf_imul(12,xi2),Xi)),sf_mul(sf_imul(4,xi2),xi))),sf_mul(sf_diffabs(Xr,xr),sf_sub(sf_mul(sf_imul(4,Xr2),Xi),sf_mul(sf_imul(4,Xi2),Xi)))),ci);
}

);

static const char *perturbation_opencl_softfloat_20_4_1 = STR(

{dxan=sf_add(sf_imul(4,sf_mul(sf_sgn(sf_add(sf_abs(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_add(sf_muli(sf_abs(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),-6),sf_abs(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dya,sf_sgn(Xxi)))))))))),sf_add(sf_imul(4,sf_mul(sf_sgn(sf_add(sf_abs(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_add(sf_muli(sf_abs(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),-6),sf_abs(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr)))))))))),sf_add(sf_imul(-12,sf_mul(sf_sgn(sf_add(sf_abs(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_add(sf_muli(sf_abs(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),-6),sf_abs(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr)))))))))),sf_add(sf_imul(-12,sf_mul(sf_sgn(sf_add(sf_abs(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_add(sf_muli(sf_abs(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),-6),sf_abs(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxr)))))))))),daa))));
dxbn=sf_add(sf_imul(4,sf_mul(sf_sgn(sf_add(sf_abs(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_add(sf_muli(sf_abs(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),-6),sf_abs(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dyb,sf_sgn(Xxi)))))))))),sf_add(sf_imul(4,sf_mul(sf_sgn(sf_add(sf_abs(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_add(sf_muli(sf_abs(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),-6),sf_abs(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr)))))))))),sf_add(sf_imul(-12,sf_mul(sf_sgn(sf_add(sf_abs(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_add(sf_muli(sf_abs(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),-6),sf_abs(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr)))))))))),sf_add(sf_imul(-12,sf_mul(sf_sgn(sf_add(sf_abs(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_add(sf_muli(sf_abs(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),-6),sf_abs(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxr)))))))))),dab))));
dyan=sf_add(sf_imul(-4,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxr))))))))),sf_add(sf_imul(4,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxa,sf_sgn(Xxr))))))))),sf_add(sf_imul(12,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxr))))))))),sf_add(sf_imul(-12,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr))))))))),dba))));
dybn=sf_add(sf_imul(-4,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxr))))))))),sf_add(sf_imul(4,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxb,sf_sgn(Xxr))))))))),sf_add(sf_imul(12,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxr))))))))),sf_add(sf_imul(-12,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr))))))))),dbb))));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_diffabs(sf_sub(sf_add(sf_mul(Xr2,Xr2),sf_mul(Xi2,Xi2)),sf_mul(sf_imul(6,Xr2),Xi2)),sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_mul(sf_imul(4,Xi),xi2),xi)),sf_mul(xi2,xi2)),sf_mul(sf_mul(sf_imul(12,xr),Xr),Xi2)),sf_mul(sf_imul(6,xr2),Xi2)),sf_mul(sf_mul(sf_imul(12,xi),Xr2),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(24,xr),xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(12,xr2),xi),Xi)),sf_mul(sf_imul(6,xi2),Xr2)),sf_mul(sf_mul(sf_imul(12,xr),xi2),Xr)),sf_mul(sf_imul(6,xr2),xi2))),cr);
xin=sf_add(sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_mul(sf_imul(12,Xi2),xi),sf_mul(sf_imul(12,Xi),xi2)),sf_mul(sf_imul(4,xi2),xi)),sf_mul(sf_mul(sf_imul(8,xr),Xr),Xi)),sf_mul(sf_imul(4,xr2),Xi)),sf_mul(sf_imul(4,xi),Xr2)),sf_mul(sf_mul(sf_imul(8,xr),xi),Xr)),sf_mul(sf_imul(4,xr2),xi))),sf_mul(sf_diffabs(Xr,xr),sf_sub(sf_mul(sf_imul(4,Xi2),Xi),sf_mul(sf_imul(4,Xr2),Xi)))),ci);
}

);

static const char *perturbation_opencl_softfloat_21_4_1 = STR(

{dxan=sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dya)))),sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dxa)))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,dxa)))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,dya)))),daa))));
dxbn=sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dyb)))),sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dxb)))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,dxb)))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,dyb)))),dab))));
dyan=sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr)))),sf_imul(4,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxa,sf_sgn(sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr)))),sf_imul(4,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr)))),sf_imul(4,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr)))),sf_imul(4,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),dba))));
dybn=sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr)))),sf_imul(4,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxb,sf_sgn(sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr)))),sf_imul(4,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr)))),sf_imul(4,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr)))),sf_imul(4,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),dbb))));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_mul(sf_imul(4,Xi),xi2),xi)),sf_mul(xi2,xi2)),sf_mul(sf_mul(sf_imul(12,Xr2),Xi),xi)),sf_mul(sf_imul(6,Xr2),xi2)),sf_mul(sf_mul(sf_imul(12,Xr),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(24,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_imul(12,Xr),xr),xi2)),sf_mul(sf_imul(6,xr2),Xi2)),sf_mul(sf_mul(sf_imul(12,xr2),Xi),xi)),sf_mul(sf_imul(6,xr2),xi2)),cr);
xin=sf_add(sf_diffabs(sf_sub(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),Xi),sf_mul(sf_mul(sf_imul(4,Xr),Xi2),Xi)),sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_mul(sf_mul(sf_imul(-4,xr),Xi2),Xi),sf_mul(sf_mul(sf_imul(12,xi),Xr),Xi2)),sf_mul(sf_mul(sf_imul(12,xr),xi),Xi2)),sf_mul(sf_mul(sf_imul(12,xr),Xr2),Xi)),sf_mul(sf_mul(sf_imul(12,xi2),Xr),Xi)),sf_mul(sf_mul(sf_imul(12,xr2),Xr),Xi)),sf_mul(sf_mul(sf_imul(12,xr),xi2),Xi)),sf_mul(sf_mul(sf_imul(4,xr2),xr),Xi)),sf_mul(sf_mul(sf_imul(4,xi),Xr2),Xr)),sf_mul(sf_mul(sf_imul(12,xr),xi),Xr2)),sf_mul(sf_mul(sf_imul(4,xi2),xi),Xr)),sf_mul(sf_mul(sf_imul(12,xr2),xi),Xr)),sf_mul(sf_mul(sf_imul(4,xr),xi2),xi)),sf_mul(sf_mul(sf_imul(4,xr2),xr),xi))),ci);
}

);

static const char *perturbation_opencl_softfloat_22_4_1 = STR(

{dxan=sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dya,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),daa))));
dxbn=sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dyb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),dab))));
dyan=sf_add(sf_imul(-4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dya)))),sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dxa)))),sf_add(sf_imul(12,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,dya)))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,dxa)))),dba))));
dybn=sf_add(sf_imul(-4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dyb)))),sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dxb)))),sf_add(sf_imul(12,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,dyb)))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,dxb)))),dbb))));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_diffabs(sf_sub(sf_add(sf_mul(Xr2,Xr2),sf_mul(Xi2,Xi2)),sf_mul(sf_imul(6,Xr2),Xi2)),sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_mul(sf_imul(4,Xi),xi2),xi)),sf_mul(xi2,xi2)),sf_mul(sf_mul(sf_imul(12,xr),Xr),Xi2)),sf_mul(sf_imul(6,xr2),Xi2)),sf_mul(sf_mul(sf_imul(12,xi),Xr2),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(24,xr),xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(12,xr2),xi),Xi)),sf_mul(sf_imul(6,xi2),Xr2)),sf_mul(sf_mul(sf_imul(12,xr),xi2),Xr)),sf_mul(sf_imul(6,xr2),xi2))),cr);
xin=sf_sub(ci,sf_sub(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_sub(sf_add(sf_add(sf_add(sf_sub(sf_sub(sf_add(sf_mul(sf_mul(sf_imul(12,Xr2),Xi),xr),sf_mul(sf_mul(sf_imul(12,Xr),Xi),xr2)),sf_mul(sf_mul(sf_imul(12,Xr),Xi2),xi)),sf_mul(sf_mul(sf_imul(12,Xr),Xi),xi2)),sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xi)),sf_mul(sf_mul(sf_imul(12,Xr2),xi),xr)),sf_mul(sf_mul(sf_imul(12,Xr),xi),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xi2),xi)),sf_mul(sf_mul(sf_imul(4,xr2),xr),Xi)),sf_mul(sf_mul(sf_imul(4,xr),Xi2),Xi)),sf_mul(sf_mul(sf_imul(12,xr),Xi2),xi)),sf_mul(sf_mul(sf_imul(12,xr),Xi),xi2)),sf_mul(sf_mul(sf_imul(4,xr2),xr),xi)),sf_mul(sf_mul(sf_imul(4,xr),xi2),xi)));
}

);

static const char *perturbation_opencl_softfloat_23_4_1 = STR(

{dxan=sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dya)))),sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dxa)))),sf_add(sf_imul(-12,sf_mul(Xxr,sf_mul(Xxr,dya))),sf_add(sf_imul(-24,sf_mul(Xxi,sf_mul(Xxr,dxa))),daa))));
dxbn=sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dyb)))),sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dxb)))),sf_add(sf_imul(-12,sf_mul(Xxr,sf_mul(Xxr,dyb))),sf_add(sf_imul(-24,sf_mul(Xxi,sf_mul(Xxr,dxb))),dab))));
dyan=sf_add(sf_imul(-4,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr))),sf_mul(Xxi,dxa))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr))),sf_mul(Xxr,dya))),sf_add(sf_imul(-8,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(8,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))))),dba))));
dybn=sf_add(sf_imul(-4,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr))),sf_mul(Xxi,dxb))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr))),sf_mul(Xxr,dyb))),sf_add(sf_imul(-8,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(8,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))))),dbb))));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_mul(sf_imul(4,Xi),xi2),xi)),sf_mul(xi2,xi2)),sf_mul(sf_mul(sf_imul(12,Xr2),Xi),xi)),sf_mul(sf_imul(6,Xr2),xi2)),sf_mul(sf_mul(sf_imul(12,Xr),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(24,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_imul(12,Xr),xr),xi2)),sf_mul(sf_imul(6,xr2),Xi2)),sf_mul(sf_mul(sf_imul(12,xr2),Xi),xi)),sf_mul(sf_imul(6,xr2),xi2)),cr);
xin=sf_add(sf_sub(sf_mul(sf_neg(sf_mul(sf_imul(4,Xr),Xi)),sf_diffabs(sf_sub(Xr2,Xi2),sf_add(sf_sub(sf_add(sf_mul(sf_imul(-2,xi),Xi),sf_mul(sf_imul(2,xr),Xr)),xi2),xr2))),sf_mul(sf_add(sf_add(sf_mul(sf_imul(4,Xr),xi),sf_mul(sf_imul(4,xr),Xi)),sf_mul(sf_imul(4,xr),xi)),sf_abs(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_neg(Xi2),sf_mul(sf_imul(2,xi),Xi)),Xr2),sf_mul(sf_imul(2,xr),Xr)),xi2),xr2)))),ci);
}

);

static const char *perturbation_opencl_softfloat_24_4_1 = STR(

{dxan=sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dya)))),sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dxa)))),sf_add(sf_imul(-12,sf_mul(Xxr,sf_mul(Xxr,dya))),sf_add(sf_imul(-24,sf_mul(Xxi,sf_mul(Xxr,dxa))),daa))));
dxbn=sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dyb)))),sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dxb)))),sf_add(sf_imul(-12,sf_mul(Xxr,sf_mul(Xxr,dyb))),sf_add(sf_imul(-24,sf_mul(Xxi,sf_mul(Xxr,dxb))),dab))));
dyan=sf_add(sf_imul(4,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr))),sf_mul(Xxi,dxa))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr))),sf_mul(Xxr,dya))),sf_add(sf_imul(8,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(-8,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))))),dba))));
dybn=sf_add(sf_imul(4,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr))),sf_mul(Xxi,dxb))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr))),sf_mul(Xxr,dyb))),sf_add(sf_imul(8,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(-8,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))))),dbb))));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_mul(sf_imul(4,Xi),xi2),xi)),sf_mul(xi2,xi2)),sf_mul(sf_mul(sf_imul(12,Xr2),Xi),xi)),sf_mul(sf_imul(6,Xr2),xi2)),sf_mul(sf_mul(sf_imul(12,Xr),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(24,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_imul(12,Xr),xr),xi2)),sf_mul(sf_imul(6,xr2),Xi2)),sf_mul(sf_mul(sf_imul(12,xr2),Xi),xi)),sf_mul(sf_imul(6,xr2),xi2)),cr);
xin=sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr),Xi),sf_diffabs(sf_sub(Xr2,Xi2),sf_add(sf_sub(sf_add(sf_mul(sf_imul(-2,xi),Xi),sf_mul(sf_imul(2,xr),Xr)),xi2),xr2))),sf_mul(sf_add(sf_add(sf_mul(sf_imul(4,Xr),xi),sf_mul(sf_imul(4,xr),Xi)),sf_mul(sf_imul(4,xr),xi)),sf_abs(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_neg(Xi2),sf_mul(sf_imul(2,xi),Xi)),Xr2),sf_mul(sf_imul(2,xr),Xr)),xi2),xr2)))),ci);
}

);

static const char *perturbation_opencl_softfloat_25_4_1 = STR(

{dxan=sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dya,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-12,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))))),sf_add(sf_imul(-24,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))))),daa))));
dxbn=sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dyb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-12,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))))),sf_add(sf_imul(-24,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))))),dab))));
dyan=sf_add(sf_imul(-4,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr))),sf_mul(Xxi,dxa))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr))),sf_mul(Xxr,dya))),sf_add(sf_imul(-8,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(8,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))))),dba))));
dybn=sf_add(sf_imul(-4,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr))),sf_mul(Xxi,dxb))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr))),sf_mul(Xxr,dyb))),sf_add(sf_imul(-8,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(8,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))))),dbb))));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_diffabs(sf_sub(sf_add(sf_mul(Xr2,Xr2),sf_mul(Xi2,Xi2)),sf_mul(sf_imul(6,Xr2),Xi2)),sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_mul(sf_imul(4,Xi),xi2),xi)),sf_mul(xi2,xi2)),sf_mul(sf_mul(sf_imul(12,xr),Xr),Xi2)),sf_mul(sf_imul(6,xr2),Xi2)),sf_mul(sf_mul(sf_imul(12,xi),Xr2),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(24,xr),xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(12,xr2),xi),Xi)),sf_mul(sf_imul(6,xi2),Xr2)),sf_mul(sf_mul(sf_imul(12,xr),xi2),Xr)),sf_mul(sf_imul(6,xr2),xi2))),cr);
xin=sf_add(sf_sub(sf_mul(sf_neg(sf_mul(sf_imul(4,Xr),Xi)),sf_diffabs(sf_sub(Xr2,Xi2),sf_add(sf_sub(sf_add(sf_mul(sf_imul(-2,xi),Xi),sf_mul(sf_imul(2,xr),Xr)),xi2),xr2))),sf_mul(sf_add(sf_add(sf_mul(sf_imul(4,Xr),xi),sf_mul(sf_imul(4,xr),Xi)),sf_mul(sf_imul(4,xr),xi)),sf_abs(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_neg(Xi2),sf_mul(sf_imul(2,xi),Xi)),Xr2),sf_mul(sf_imul(2,xr),Xr)),xi2),xr2)))),ci);
}

);

static const char *perturbation_opencl_softfloat_26_4_1 = STR(

{dxan=sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dya,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-12,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))))),sf_add(sf_imul(-24,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))))),daa))));
dxbn=sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dyb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-12,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))))),sf_add(sf_imul(-24,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))))),dab))));
dyan=sf_add(sf_imul(4,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr))),sf_mul(Xxi,dxa))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr))),sf_mul(Xxr,dya))),sf_add(sf_imul(8,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(-8,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))))),dba))));
dybn=sf_add(sf_imul(4,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr))),sf_mul(Xxi,dxb))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr))),sf_mul(Xxr,dyb))),sf_add(sf_imul(8,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(-8,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))))),dbb))));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_diffabs(sf_sub(sf_add(sf_mul(Xr2,Xr2),sf_mul(Xi2,Xi2)),sf_mul(sf_imul(6,Xr2),Xi2)),sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_mul(sf_imul(4,Xi),xi2),xi)),sf_mul(xi2,xi2)),sf_mul(sf_mul(sf_imul(12,xr),Xr),Xi2)),sf_mul(sf_imul(6,xr2),Xi2)),sf_mul(sf_mul(sf_imul(12,xi),Xr2),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(24,xr),xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(12,xr2),xi),Xi)),sf_mul(sf_imul(6,xi2),Xr2)),sf_mul(sf_mul(sf_imul(12,xr),xi2),Xr)),sf_mul(sf_imul(6,xr2),xi2))),cr);
xin=sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr),Xi),sf_diffabs(sf_sub(Xr2,Xi2),sf_add(sf_sub(sf_add(sf_mul(sf_imul(-2,xi),Xi),sf_mul(sf_imul(2,xr),Xr)),xi2),xr2))),sf_mul(sf_add(sf_add(sf_mul(sf_imul(4,Xr),xi),sf_mul(sf_imul(4,xr),Xi)),sf_mul(sf_imul(4,xr),xi)),sf_abs(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_neg(Xi2),sf_mul(sf_imul(2,xi),Xi)),Xr2),sf_mul(sf_imul(2,xr),Xr)),xi2),xr2)))),ci);
}

);

static const char *perturbation_opencl_softfloat_27_5_1 = STR(

{dxan=sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxa,sf_sgn(Xxr))))))),sf_add(sf_imul(5,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr))))))))))),sf_add(sf_imul(20,sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dya))))),sf_add(sf_imul(-20,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(Xxi,dya))),sf_add(sf_imul(-30,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr))))))))),daa)))));
dxbn=sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxb,sf_sgn(Xxr))))))),sf_add(sf_imul(5,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr))))))))))),sf_add(sf_imul(20,sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dyb))))),sf_add(sf_imul(-20,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(Xxi,dyb))),sf_add(sf_imul(-30,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr))))))))),dab)))));
dyan=sf_add(dba,sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dya))))),sf_add(sf_imul(-20,sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr)))))))),sf_add(sf_imul(20,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr)))))))))),sf_add(sf_imul(-30,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,sf_mul(Xxi,dya)))),sf_imul(5,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr)))),dya)))))));
dybn=sf_add(dbb,sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dyb))))),sf_add(sf_imul(-20,sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr)))))))),sf_add(sf_imul(20,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr)))))))))),sf_add(sf_imul(-30,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,sf_mul(Xxi,dyb)))),sf_imul(5,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr)))),dyb)))))));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_add(sf_mul(sf_diffabs(Xr,xr),sf_add(sf_sub(sf_mul(Xr2,Xr2),sf_mul(sf_imul(10,Xr2),Xi2)),sf_mul(sf_imul(5,Xi2),Xi2))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_add(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(20,Xr2),Xi),xi)),sf_mul(sf_imul(10,Xr2),xi2)),sf_mul(sf_mul(sf_imul(20,Xr),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(40,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_imul(20,Xr),xr),xi2)),sf_mul(sf_imul(10,xr2),Xi2)),sf_mul(sf_mul(sf_imul(20,xr2),Xi),xi)),sf_mul(sf_imul(10,xr2),xi2)),sf_mul(sf_mul(sf_imul(20,Xi2),Xi),xi)),sf_mul(sf_imul(30,Xi2),xi2)),sf_mul(sf_mul(sf_imul(20,Xi),xi2),xi)),sf_mul(sf_imul(5,xi2),xi2)))),cr);
xin=sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_mul(sf_imul(20,Xi),Xr2),Xr),xr),sf_mul(sf_mul(sf_imul(30,Xi),Xr2),xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xi),Xr),xr2),xr)),sf_mul(sf_mul(sf_imul(5,Xi),xr2),xr2)),sf_mul(sf_mul(sf_imul(30,Xi2),Xr2),xi)),sf_mul(sf_mul(sf_imul(30,Xi),Xr2),xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xi2),Xi),Xr),xr)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xi2),Xr),xr),xi)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xi),Xr),xr),xi2)),sf_mul(sf_mul(sf_imul(10,Xi2),Xi),xr2)),sf_mul(sf_mul(sf_imul(30,Xi2),xr2),xi)),sf_mul(sf_mul(sf_imul(30,Xi),xr2),xi2)),sf_mul(sf_mul(sf_imul(5,Xi2),Xi2),xi)),sf_mul(sf_mul(sf_imul(10,Xi2),Xi),xi2)),sf_mul(sf_mul(sf_imul(10,Xi2),xi2),xi)),sf_mul(sf_mul(sf_imul(5,Xi),xi2),xi2)),sf_mul(sf_mul(sf_imul(5,xi),Xr2),Xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi),Xr2),Xr),xr)),sf_mul(sf_mul(sf_imul(30,xi),Xr2),xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi),Xr),xr2),xr)),sf_mul(sf_mul(sf_imul(5,xi),xr2),xr2)),sf_mul(sf_mul(sf_imul(10,xi2),xi),Xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi2),xi),Xr),xr)),sf_mul(sf_mul(sf_imul(10,xi2),xi),xr2)),sf_mul(sf_mul(xi2,xi2),xi)),ci);
}

);

static const char *perturbation_opencl_softfloat_28_5_1 = STR(

{dxan=sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxa,sf_sgn(Xxr))))))),sf_add(sf_imul(5,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr))))))))))),sf_add(sf_imul(20,sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dya))))),sf_add(sf_imul(-20,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(Xxi,dya))),sf_add(sf_imul(-30,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr))))))))),daa)))));
dxbn=sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxb,sf_sgn(Xxr))))))),sf_add(sf_imul(5,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr))))))))))),sf_add(sf_imul(20,sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dyb))))),sf_add(sf_imul(-20,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(Xxi,dyb))),sf_add(sf_imul(-30,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr))))))))),dab)))));
dyan=sf_add(dba,sf_add(sf_imul(-5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dya))))),sf_add(sf_imul(20,sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr)))))))),sf_add(sf_imul(-20,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr)))))))))),sf_add(sf_imul(30,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,sf_mul(Xxi,dya)))),sf_imul(-5,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr)))),dya)))))));
dybn=sf_add(dbb,sf_add(sf_imul(-5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dyb))))),sf_add(sf_imul(20,sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr)))))))),sf_add(sf_imul(-20,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr)))))))))),sf_add(sf_imul(30,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,sf_mul(Xxi,dyb)))),sf_imul(-5,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr)))),dyb)))))));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_add(sf_mul(sf_diffabs(Xr,xr),sf_add(sf_sub(sf_mul(Xr2,Xr2),sf_mul(sf_imul(10,Xr2),Xi2)),sf_mul(sf_imul(5,Xi2),Xi2))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_add(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(20,Xr2),Xi),xi)),sf_mul(sf_imul(10,Xr2),xi2)),sf_mul(sf_mul(sf_imul(20,Xr),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(40,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_imul(20,Xr),xr),xi2)),sf_mul(sf_imul(10,xr2),Xi2)),sf_mul(sf_mul(sf_imul(20,xr2),Xi),xi)),sf_mul(sf_imul(10,xr2),xi2)),sf_mul(sf_mul(sf_imul(20,Xi2),Xi),xi)),sf_mul(sf_imul(30,Xi2),xi2)),sf_mul(sf_mul(sf_imul(20,Xi),xi2),xi)),sf_mul(sf_imul(5,xi2),xi2)))),cr);
xin=sf_sub(ci,sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_mul(sf_imul(20,Xi),Xr2),Xr),xr),sf_mul(sf_mul(sf_imul(30,Xi),Xr2),xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xi),Xr),xr2),xr)),sf_mul(sf_mul(sf_imul(5,Xi),xr2),xr2)),sf_mul(sf_mul(sf_imul(30,Xi2),Xr2),xi)),sf_mul(sf_mul(sf_imul(30,Xi),Xr2),xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xi2),Xi),Xr),xr)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xi2),Xr),xr),xi)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xi),Xr),xr),xi2)),sf_mul(sf_mul(sf_imul(10,Xi2),Xi),xr2)),sf_mul(sf_mul(sf_imul(30,Xi2),xr2),xi)),sf_mul(sf_mul(sf_imul(30,Xi),xr2),xi2)),sf_mul(sf_mul(sf_imul(5,Xi2),Xi2),xi)),sf_mul(sf_mul(sf_imul(10,Xi2),Xi),xi2)),sf_mul(sf_mul(sf_imul(10,Xi2),xi2),xi)),sf_mul(sf_mul(sf_imul(5,Xi),xi2),xi2)),sf_mul(sf_mul(sf_imul(5,xi),Xr2),Xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi),Xr2),Xr),xr)),sf_mul(sf_mul(sf_imul(30,xi),Xr2),xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi),Xr),xr2),xr)),sf_mul(sf_mul(sf_imul(5,xi),xr2),xr2)),sf_mul(sf_mul(sf_imul(10,xi2),xi),Xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi2),xi),Xr),xr)),sf_mul(sf_mul(sf_imul(10,xi2),xi),xr2)),sf_mul(sf_mul(xi2,xi2),xi)));
}

);

static const char *perturbation_opencl_softfloat_29_5_1 = STR(

{dxan=sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxa,sf_sgn(sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr))))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_add(sf_imul(5,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr))))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_add(sf_imul(-20,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr))))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_add(sf_imul(20,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr))))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_add(sf_imul(-30,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr))))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),daa)))));
dxbn=sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxb,sf_sgn(sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr))))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_add(sf_imul(5,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr))))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_add(sf_imul(-20,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr))))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_add(sf_imul(20,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr))))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_add(sf_imul(-30,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxr))))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr))))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),dab)))));
dyan=sf_add(sf_imul(-5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dya))))),sf_add(sf_imul(-5,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dya))))),sf_add(sf_imul(-20,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dxa))))),sf_add(sf_imul(20,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,dxa))))),sf_add(sf_imul(30,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,dya))))),dba)))));
dybn=sf_add(sf_imul(-5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dyb))))),sf_add(sf_imul(-5,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dyb))))),sf_add(sf_imul(-20,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dxb))))),sf_add(sf_imul(20,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,dxb))))),sf_add(sf_imul(30,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,dyb))))),dbb)))));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_diffabs(sf_add(sf_sub(sf_mul(sf_mul(sf_imul(5,Xr),Xi2),Xi2),sf_mul(sf_mul(sf_imul(10,Xr2),Xr),Xi2)),sf_mul(sf_mul(Xr2,Xr2),Xr)),sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_sub(sf_mul(sf_mul(sf_mul(sf_imul(20,Xr),xi),Xi2),Xi),sf_mul(sf_mul(sf_imul(30,Xr2),xr),Xi2)),sf_mul(sf_mul(sf_imul(30,Xr),xi2),Xi2)),sf_mul(sf_mul(sf_imul(30,Xr),xr2),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xr2),Xr),xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xr2),xr),xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xr),xi2),xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xr),xr2),xi),Xi)),sf_mul(sf_mul(sf_imul(5,Xr2),Xr2),xr)),sf_mul(sf_mul(sf_imul(10,Xr2),Xr),xi2)),sf_mul(sf_mul(sf_imul(10,Xr2),Xr),xr2)),sf_mul(sf_mul(sf_imul(30,Xr2),xr),xi2)),sf_mul(sf_mul(sf_imul(10,Xr2),xr2),xr)),sf_mul(sf_mul(sf_imul(5,Xr),xi2),xi2)),sf_mul(sf_mul(sf_imul(30,Xr),xr2),xi2)),sf_mul(sf_mul(sf_imul(5,Xr),xr2),xr2)),sf_mul(sf_mul(sf_imul(5,xr),Xi2),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xr),xi),Xi2),Xi)),sf_mul(sf_mul(sf_imul(30,xr),xi2),Xi2)),sf_mul(sf_mul(sf_imul(10,xr2),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xr),xi2),xi),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(20,xr2),xr),xi),Xi)),sf_mul(sf_mul(sf_imul(5,xr),xi2),xi2)),sf_mul(sf_mul(sf_imul(10,xr2),xr),xi2)),sf_mul(sf_mul(xr2,xr2),xr))),cr);
xin=sf_sub(ci,sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_mul(sf_imul(20,Xi),Xr2),Xr),xr),sf_mul(sf_mul(sf_imul(30,Xi),Xr2),xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xi),Xr),xr2),xr)),sf_mul(sf_mul(sf_imul(5,Xi),xr2),xr2)),sf_mul(sf_mul(sf_imul(30,Xi2),Xr2),xi)),sf_mul(sf_mul(sf_imul(30,Xi),Xr2),xi2)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xi2),Xi),Xr),xr)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xi2),Xr),xr),xi)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xi),Xr),xr),xi2)),sf_mul(sf_mul(sf_imul(10,Xi2),Xi),xr2)),sf_mul(sf_mul(sf_imul(30,Xi2),xr2),xi)),sf_mul(sf_mul(sf_imul(30,Xi),xr2),xi2)),sf_mul(sf_mul(sf_imul(5,Xi2),Xi2),xi)),sf_mul(sf_mul(sf_imul(10,Xi2),Xi),xi2)),sf_mul(sf_mul(sf_imul(10,Xi2),xi2),xi)),sf_mul(sf_mul(sf_imul(5,Xi),xi2),xi2)),sf_mul(sf_mul(sf_imul(5,xi),Xr2),Xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi),Xr2),Xr),xr)),sf_mul(sf_mul(sf_imul(30,xi),Xr2),xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi),Xr),xr2),xr)),sf_mul(sf_mul(sf_imul(5,xi),xr2),xr2)),sf_mul(sf_mul(sf_imul(10,xi2),xi),Xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi2),xi),Xr),xr)),sf_mul(sf_mul(sf_imul(10,xi2),xi),xr2)),sf_mul(sf_mul(xi2,xi2),xi)));
}

);

static const char *perturbation_opencl_softfloat_30_5_1 = STR(

{dxan=sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxa,sf_sgn(Xxr))))))),sf_add(sf_imul(5,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr))))))))))),sf_add(sf_imul(20,sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dya))))),sf_add(sf_imul(-20,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(Xxi,dya))),sf_add(sf_imul(-30,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr))))))))),daa)))));
dxbn=sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxb,sf_sgn(Xxr))))))),sf_add(sf_imul(5,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr))))))))))),sf_add(sf_imul(20,sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dyb))))),sf_add(sf_imul(-20,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(Xxi,dyb))),sf_add(sf_imul(-30,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr))))))))),dab)))));
dyan=sf_add(dba,sf_add(sf_imul(-5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dya,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_add(sf_imul(-10,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_imul(5,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr)))),Xxi))))))))))),sf_add(sf_imul(20,sf_mul(sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_add(sf_imul(-10,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_imul(5,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr)))),Xxi))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr))))))))),sf_add(sf_imul(-20,sf_mul(sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_add(sf_imul(-10,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_imul(5,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr)))),Xxi))))),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr))))))))))),sf_add(sf_imul(30,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_add(sf_imul(-10,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_imul(5,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr)))),Xxi))))),sf_mul(Xxi,sf_mul(Xxi,dya))))),sf_imul(-5,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr)))),sf_mul(sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_add(sf_imul(-10,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_imul(5,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr)))),Xxi))))),dya))))))));
dybn=sf_add(dbb,sf_add(sf_imul(-5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dyb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_add(sf_imul(-10,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_imul(5,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr)))),Xxi))))))))))),sf_add(sf_imul(20,sf_mul(sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_add(sf_imul(-10,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_imul(5,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr)))),Xxi))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr))))))))),sf_add(sf_imul(-20,sf_mul(sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_add(sf_imul(-10,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_imul(5,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr)))),Xxi))))),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr))))))))))),sf_add(sf_imul(30,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_add(sf_imul(-10,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_imul(5,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr)))),Xxi))))),sf_mul(Xxi,sf_mul(Xxi,dyb))))),sf_imul(-5,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr)))),sf_mul(sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_add(sf_imul(-10,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,sf_mul(Xxi,Xxi)))),sf_imul(5,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr)))),Xxi))))),dyb))))))));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_add(sf_mul(sf_diffabs(Xr,xr),sf_add(sf_sub(sf_mul(Xr2,Xr2),sf_mul(sf_imul(10,Xr2),Xi2)),sf_mul(sf_imul(5,Xi2),Xi2))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_add(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(20,Xr2),Xi),xi)),sf_mul(sf_imul(10,Xr2),xi2)),sf_mul(sf_mul(sf_imul(20,Xr),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(40,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_imul(20,Xr),xr),xi2)),sf_mul(sf_imul(10,xr2),Xi2)),sf_mul(sf_mul(sf_imul(20,xr2),Xi),xi)),sf_mul(sf_imul(10,xr2),xi2)),sf_mul(sf_mul(sf_imul(20,Xi2),Xi),xi)),sf_mul(sf_imul(30,Xi2),xi2)),sf_mul(sf_mul(sf_imul(20,Xi),xi2),xi)),sf_mul(sf_imul(5,xi2),xi2)))),cr);
xin=sf_sub(ci,sf_diffabs(sf_add(sf_sub(sf_mul(sf_mul(Xi2,Xi2),Xi),sf_mul(sf_mul(sf_imul(10,Xi2),Xi),Xr2)),sf_mul(sf_mul(sf_imul(5,Xi),Xr2),Xr2)),sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_add(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_sub(sf_mul(sf_mul(sf_imul(5,Xi2),Xi2),xi),sf_mul(sf_mul(sf_mul(sf_imul(20,Xi2),Xi),xr),Xr)),sf_mul(sf_mul(sf_imul(10,Xi2),Xi),xi2)),sf_mul(sf_mul(sf_imul(10,Xi2),Xi),xr2)),sf_mul(sf_mul(sf_imul(30,Xi2),xi),Xr2)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xi2),xr),xi),Xr)),sf_mul(sf_mul(sf_imul(10,Xi2),xi2),xi)),sf_mul(sf_mul(sf_imul(30,Xi2),xr2),xi)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xi),xr),Xr2),Xr)),sf_mul(sf_mul(sf_imul(30,Xi),xi2),Xr2)),sf_mul(sf_mul(sf_imul(30,Xi),xr2),Xr2)),sf_mul(sf_mul(sf_mul(sf_imul(60,Xi),xr),xi2),Xr)),sf_mul(sf_mul(sf_mul(sf_imul(20,Xi),xr2),xr),Xr)),sf_mul(sf_mul(sf_imul(5,Xi),xi2),xi2)),sf_mul(sf_mul(sf_imul(30,Xi),xr2),xi2)),sf_mul(sf_mul(sf_imul(5,Xi),xr2),xr2)),sf_mul(sf_mul(sf_imul(5,xi),Xr2),Xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi),xr),Xr2),Xr)),sf_mul(sf_mul(sf_imul(10,xi2),xi),Xr2)),sf_mul(sf_mul(sf_imul(30,xi),xr2),Xr2)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi2),xi),xr),Xr)),sf_mul(sf_mul(sf_mul(sf_imul(20,xi),xr2),xr),Xr)),sf_mul(sf_mul(xi2,xi2),xi)),sf_mul(sf_mul(sf_imul(10,xi2),xi),xr2)),sf_mul(sf_mul(sf_imul(5,xi),xr2),xr2))));
}

);

static const char *perturbation_opencl_softfloat_31_5_1 = STR(

{dxan=sf_add(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr)))))),sf_add(sf_imul(4,sf_mul(sf_abs(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dxa))))),sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxa,sf_sgn(Xxr))))))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr))))))),sf_add(sf_imul(-20,sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,dxa))))),sf_add(sf_imul(-20,sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,dya))))),sf_add(sf_imul(20,sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dya))))),daa)))))));
dxbn=sf_add(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr)))))),sf_add(sf_imul(4,sf_mul(sf_abs(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dxb))))),sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxb,sf_sgn(Xxr))))))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr))))))),sf_add(sf_imul(-20,sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,dxb))))),sf_add(sf_imul(-20,sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,dyb))))),sf_add(sf_imul(20,sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dyb))))),dab)))))));
dyan=sf_add(dba,sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dya,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_imul(5,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_add(sf_imul(20,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_imul(5,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_add(sf_imul(-20,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_imul(5,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_add(sf_imul(20,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_imul(5,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_imul(-1,sf_mul(sf_abs(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_imul(5,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))),dya)))))));
dybn=sf_add(dbb,sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dyb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_imul(5,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_add(sf_imul(20,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_imul(5,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_add(sf_imul(-20,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_imul(5,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_add(sf_imul(20,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_imul(5,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_imul(-1,sf_mul(sf_abs(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_imul(5,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))),dyb)))))));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_add(sf_mul(sf_diffabs(Xr,xr),sf_add(sf_sub(sf_mul(Xr2,Xr2),sf_mul(sf_imul(10,Xr2),Xi2)),sf_mul(sf_imul(5,Xi2),Xi2))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_add(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(20,Xr2),Xi),xi)),sf_mul(sf_imul(10,Xr2),xi2)),sf_mul(sf_mul(sf_imul(20,Xr),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(40,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_imul(20,Xr),xr),xi2)),sf_mul(sf_imul(10,xr2),Xi2)),sf_mul(sf_mul(sf_imul(20,xr2),Xi),xi)),sf_mul(sf_imul(10,xr2),xi2)),sf_mul(sf_mul(sf_imul(20,Xi2),Xi),xi)),sf_mul(sf_imul(30,Xi2),xi2)),sf_mul(sf_mul(sf_imul(20,Xi),xi2),xi)),sf_mul(sf_imul(5,xi2),xi2)))),cr);
xin=sf_add(sf_sub(sf_mul(sf_neg(Xi),sf_diffabs(sf_add(sf_sub(sf_mul(sf_imul(5,Xr2),Xr2),sf_mul(sf_imul(10,Xr2),Xi2)),sf_mul(Xi2,Xi2)),sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_sub(sf_mul(sf_mul(sf_imul(4,xi),Xi2),Xi),sf_mul(sf_mul(sf_imul(20,xr),Xr),Xi2)),sf_mul(sf_imul(6,xi2),Xi2)),sf_mul(sf_imul(10,xr2),Xi2)),sf_mul(sf_mul(sf_imul(20,xi),Xr2),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(40,xr),xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(4,xi2),xi),Xi)),sf_mul(sf_mul(sf_imul(20,xr2),xi),Xi)),sf_mul(sf_mul(sf_imul(20,xr),Xr2),Xr)),sf_mul(sf_imul(10,xi2),Xr2)),sf_mul(sf_imul(30,xr2),Xr2)),sf_mul(sf_mul(sf_imul(20,xr),xi2),Xr)),sf_mul(sf_mul(sf_imul(20,xr2),xr),Xr)),sf_mul(xi2,xi2)),sf_mul(sf_imul(10,xr2),xi2)),sf_mul(sf_imul(5,xr2),xr2)))),sf_mul(xi,sf_abs(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_sub(sf_sub(sf_add(sf_mul(Xi2,Xi2),sf_mul(sf_mul(sf_imul(4,xi),Xi2),Xi)),sf_mul(sf_imul(10,Xr2),Xi2)),sf_mul(sf_mul(sf_imul(20,xr),Xr),Xi2)),sf_mul(sf_imul(6,xi2),Xi2)),sf_mul(sf_imul(10,xr2),Xi2)),sf_mul(sf_mul(sf_imul(20,xi),Xr2),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(40,xr),xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(4,xi2),xi),Xi)),sf_mul(sf_mul(sf_imul(20,xr2),xi),Xi)),sf_mul(sf_imul(5,Xr2),Xr2)),sf_mul(sf_mul(sf_imul(20,xr),Xr2),Xr)),sf_mul(sf_imul(10,xi2),Xr2)),sf_mul(sf_imul(30,xr2),Xr2)),sf_mul(sf_mul(sf_imul(20,xr),xi2),Xr)),sf_mul(sf_mul(sf_imul(20,xr2),xr),Xr)),sf_mul(xi2,xi2)),sf_mul(sf_imul(10,xr2),xi2)),sf_mul(sf_imul(5,xr2),xr2))))),ci);
}

);

static const char *perturbation_opencl_softfloat_32_5_1 = STR(

{dxan=sf_add(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr)))))),sf_add(sf_imul(4,sf_mul(sf_abs(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dxa))))),sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxa,sf_sgn(Xxr))))))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr))))))),sf_add(sf_imul(-20,sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,dxa))))),sf_add(sf_imul(-20,sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,dya))))),sf_add(sf_imul(20,sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dya))))),daa)))))));
dxbn=sf_add(sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr)))))),sf_add(sf_imul(4,sf_mul(sf_abs(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dxb))))),sf_add(sf_imul(5,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxb,sf_sgn(Xxr))))))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr))))))),sf_add(sf_imul(-20,sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,dxb))))),sf_add(sf_imul(-20,sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,dyb))))),sf_add(sf_imul(20,sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dyb))))),dab)))))));
dyan=sf_add(dba,sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dya,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_imul(5,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_add(sf_imul(-20,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_imul(5,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_add(sf_imul(20,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_imul(5,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_add(sf_imul(-20,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_imul(5,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_mul(sf_abs(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_imul(5,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))),dya))))));
dybn=sf_add(dbb,sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dyb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_imul(5,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_add(sf_imul(-20,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_imul(5,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_add(sf_imul(20,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_imul(5,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_add(sf_imul(-20,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_imul(5,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))))),sf_mul(sf_abs(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-10,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_imul(5,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))),dyb))))));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_add(sf_mul(sf_diffabs(Xr,xr),sf_add(sf_sub(sf_mul(Xr2,Xr2),sf_mul(sf_imul(10,Xr2),Xi2)),sf_mul(sf_imul(5,Xi2),Xi2))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_add(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(20,Xr2),Xi),xi)),sf_mul(sf_imul(10,Xr2),xi2)),sf_mul(sf_mul(sf_imul(20,Xr),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(40,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_imul(20,Xr),xr),xi2)),sf_mul(sf_imul(10,xr2),Xi2)),sf_mul(sf_mul(sf_imul(20,xr2),Xi),xi)),sf_mul(sf_imul(10,xr2),xi2)),sf_mul(sf_mul(sf_imul(20,Xi2),Xi),xi)),sf_mul(sf_imul(30,Xi2),xi2)),sf_mul(sf_mul(sf_imul(20,Xi),xi2),xi)),sf_mul(sf_imul(5,xi2),xi2)))),cr);
xin=sf_add(sf_add(sf_mul(Xi,sf_diffabs(sf_add(sf_sub(sf_mul(sf_imul(5,Xr2),Xr2),sf_mul(sf_imul(10,Xr2),Xi2)),sf_mul(Xi2,Xi2)),sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_sub(sf_mul(sf_mul(sf_imul(4,xi),Xi2),Xi),sf_mul(sf_mul(sf_imul(20,xr),Xr),Xi2)),sf_mul(sf_imul(6,xi2),Xi2)),sf_mul(sf_imul(10,xr2),Xi2)),sf_mul(sf_mul(sf_imul(20,xi),Xr2),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(40,xr),xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(4,xi2),xi),Xi)),sf_mul(sf_mul(sf_imul(20,xr2),xi),Xi)),sf_mul(sf_mul(sf_imul(20,xr),Xr2),Xr)),sf_mul(sf_imul(10,xi2),Xr2)),sf_mul(sf_imul(30,xr2),Xr2)),sf_mul(sf_mul(sf_imul(20,xr),xi2),Xr)),sf_mul(sf_mul(sf_imul(20,xr2),xr),Xr)),sf_mul(xi2,xi2)),sf_mul(sf_imul(10,xr2),xi2)),sf_mul(sf_imul(5,xr2),xr2)))),sf_mul(xi,sf_abs(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_sub(sf_sub(sf_add(sf_mul(Xi2,Xi2),sf_mul(sf_mul(sf_imul(4,xi),Xi2),Xi)),sf_mul(sf_imul(10,Xr2),Xi2)),sf_mul(sf_mul(sf_imul(20,xr),Xr),Xi2)),sf_mul(sf_imul(6,xi2),Xi2)),sf_mul(sf_imul(10,xr2),Xi2)),sf_mul(sf_mul(sf_imul(20,xi),Xr2),Xi)),sf_mul(sf_mul(sf_mul(sf_imul(40,xr),xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(4,xi2),xi),Xi)),sf_mul(sf_mul(sf_imul(20,xr2),xi),Xi)),sf_mul(sf_imul(5,Xr2),Xr2)),sf_mul(sf_mul(sf_imul(20,xr),Xr2),Xr)),sf_mul(sf_imul(10,xi2),Xr2)),sf_mul(sf_imul(30,xr2),Xr2)),sf_mul(sf_mul(sf_imul(20,xr),xi2),Xr)),sf_mul(sf_mul(sf_imul(20,xr2),xr),Xr)),sf_mul(xi2,xi2)),sf_mul(sf_imul(10,xr2),xi2)),sf_mul(sf_imul(5,xr2),xr2))))),ci);
}

);

static const char *perturbation_opencl_softfloat_33_4_1 = STR(

{dxan=sf_add(sf_imul(2,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxr,dxa))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxr,dxa))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr))))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,dya))),sf_add(sf_imul(2,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxi,dya))),sf_add(sf_imul(-2,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxi))))))),sf_add(sf_imul(-2,sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr))))))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dya,sf_sgn(Xxi))))))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(Xxi,dxa))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(Xxr,dya))),sf_add(sf_imul(-4,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr))))))),sf_add(sf_imul(-4,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxr))))))),daa))))))))))));
dxbn=sf_add(sf_imul(2,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxr,dxb))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxr,dxb))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr))))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,dyb))),sf_add(sf_imul(2,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxi,dyb))),sf_add(sf_imul(-2,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxi))))))),sf_add(sf_imul(-2,sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr))))))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dyb,sf_sgn(Xxi))))))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(Xxi,dxb))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(Xxr,dyb))),sf_add(sf_imul(-4,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr))))))),sf_add(sf_imul(-4,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxr))))))),dab))))))))))));
dyan=sf_add(sf_imul(2,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxr,dya))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxr,dya))),sf_add(sf_imul(2,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,dxa))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxi),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxr))))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxi,dxa))),sf_add(sf_imul(-2,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxa,sf_sgn(Xxr))))))),sf_add(sf_imul(-2,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxr))))))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr))))))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(Xxr,dxa))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(Xxi,dya))),sf_add(sf_imul(4,sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr))))))),sf_add(sf_imul(-4,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxi))))))),dba))))))))))));
dybn=sf_add(sf_imul(2,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxr,dyb))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxr,dyb))),sf_add(sf_imul(2,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,dxb))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxi),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxr))))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxi,dxb))),sf_add(sf_imul(-2,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxb,sf_sgn(Xxr))))))),sf_add(sf_imul(-2,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxr))))))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr))))))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(Xxr,dxb))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(Xxi,dyb))),sf_add(sf_imul(4,sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr))))))),sf_add(sf_imul(-4,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxi))))))),dbb))))))))))));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_mul(Xi2,sf_diffabs(Xi2,sf_add(sf_mul(sf_imul(2,xi),Xi),xi2))),sf_mul(sf_mul(sf_imul(4,Xi),Xr),sf_diffabs(sf_mul(Xr,Xi),sf_add(sf_add(sf_mul(Xr,xi),sf_mul(xr,Xi)),sf_mul(xr,xi))))),sf_mul(Xr2,sf_diffabs(Xi2,sf_add(sf_mul(sf_imul(2,xi),Xi),xi2)))),sf_mul(Xi2,sf_diffabs(Xr2,sf_add(sf_mul(sf_imul(2,Xr),xr),xr2)))),sf_mul(Xr2,sf_diffabs(Xr2,sf_add(sf_mul(sf_imul(2,Xr),xr),xr2)))),sf_mul(sf_add(sf_mul(sf_imul(2,xi),Xi),xi2),sf_abs(sf_add(sf_add(Xi2,sf_mul(sf_imul(2,xi),Xi)),xi2)))),sf_mul(sf_imul(4,sf_add(sf_add(sf_mul(Xi,xr),sf_mul(xi,Xr)),sf_mul(xi,xr))),sf_abs(sf_add(sf_add(sf_add(sf_mul(Xr,Xi),sf_mul(Xr,xi)),sf_mul(xr,Xi)),sf_mul(xr,xi))))),sf_mul(sf_add(sf_mul(sf_imul(2,Xr),xr),xr2),sf_abs(sf_add(sf_add(Xi2,sf_mul(sf_imul(2,xi),Xi)),xi2)))),sf_mul(sf_add(sf_mul(sf_imul(2,xi),Xi),xi2),sf_abs(sf_add(sf_add(Xr2,sf_mul(sf_imul(2,Xr),xr)),xr2)))),sf_mul(sf_add(sf_mul(sf_imul(2,Xr),xr),xr2),sf_abs(sf_add(sf_add(Xr2,sf_mul(sf_imul(2,Xr),xr)),xr2)))),cr);
xin=sf_add(sf_sub(sf_sub(sf_add(sf_add(sf_sub(sf_sub(sf_add(sf_mul(sf_imul(2,Xr2),sf_diffabs(sf_mul(Xr,Xi),sf_add(sf_add(sf_mul(Xr,xi),sf_mul(xr,Xi)),sf_mul(xr,xi)))),sf_mul(sf_mul(sf_imul(2,Xr),Xi),sf_diffabs(Xr2,sf_add(sf_mul(sf_imul(2,Xr),xr),xr2)))),sf_mul(sf_mul(sf_imul(2,Xr),Xi),sf_diffabs(Xi2,sf_add(sf_mul(sf_imul(2,xi),Xi),xi2)))),sf_mul(sf_imul(2,Xi2),sf_diffabs(sf_mul(Xr,Xi),sf_add(sf_add(sf_mul(Xr,xi),sf_mul(xr,Xi)),sf_mul(xr,xi))))),sf_mul(sf_imul(2,sf_add(sf_mul(sf_imul(2,Xr),xr),xr2)),sf_abs(sf_add(sf_add(sf_add(sf_mul(Xr,Xi),sf_mul(Xr,xi)),sf_mul(xr,Xi)),sf_mul(xr,xi))))),sf_mul(sf_imul(2,sf_add(sf_add(sf_mul(Xr,xi),sf_mul(xr,Xi)),sf_mul(xr,xi))),sf_abs(sf_add(sf_add(Xr2,sf_mul(sf_imul(2,Xr),xr)),xr2)))),sf_mul(sf_imul(2,sf_add(sf_add(sf_mul(Xr,xi),sf_mul(xr,Xi)),sf_mul(xr,xi))),sf_abs(sf_add(sf_add(Xi2,sf_mul(sf_imul(2,xi),Xi)),xi2)))),sf_mul(sf_imul(2,sf_add(sf_mul(sf_imul(2,xi),Xi),xi2)),sf_abs(sf_add(sf_add(sf_add(sf_mul(Xr,Xi),sf_mul(Xr,xi)),sf_mul(xr,Xi)),sf_mul(xr,xi))))),ci);
}

);

static const char *perturbation_opencl_softfloat_34_4_1 = STR(

{dxan=sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dya)))),sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dxa)))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,dxa)))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,dya)))),daa))));
dxbn=sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dyb)))),sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dxb)))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,dxb)))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,dyb)))),dab))));
dyan=sf_add(dba,sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxi,sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(8,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxi,sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxi,sf_mul(Xxr,Xxr))))))))),sf_imul(4,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxi,sf_mul(Xxr,Xxr)))),dxa))))));
dybn=sf_add(dbb,sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxi,sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(8,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxi,sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxi,sf_mul(Xxr,Xxr))))))))),sf_imul(4,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxi,sf_mul(Xxr,Xxr)))),dxb))))));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_mul(sf_imul(4,Xi),xi2),xi)),sf_mul(xi2,xi2)),sf_mul(sf_mul(sf_imul(12,Xr2),Xi),xi)),sf_mul(sf_imul(6,Xr2),xi2)),sf_mul(sf_mul(sf_imul(12,Xr),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(24,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_imul(12,Xr),xr),xi2)),sf_mul(sf_imul(6,xr2),Xi2)),sf_mul(sf_mul(sf_imul(12,xr2),Xi),xi)),sf_mul(sf_imul(6,xr2),xi2)),cr);
xin=sf_add(sf_add(sf_mul(sf_imul(4,xr),sf_abs(sf_add(sf_sub(sf_add(sf_add(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_mul(sf_neg(Xi2),Xi),sf_mul(sf_imul(3,xi),Xi2)),sf_mul(Xr2,Xi)),sf_mul(sf_mul(sf_imul(2,xr),Xr),Xi)),sf_mul(sf_imul(3,xi2),Xi)),sf_mul(xr2,Xi)),sf_mul(xi,Xr2)),sf_mul(sf_mul(sf_imul(2,xr),xi),Xr)),sf_mul(xi2,xi)),sf_mul(xr2,xi)))),sf_mul(sf_imul(4,Xr),sf_diffabs(sf_add(sf_mul(sf_neg(Xi2),Xi),sf_mul(Xr2,Xi)),sf_add(sf_sub(sf_add(sf_add(sf_add(sf_sub(sf_add(sf_mul(sf_imul(-3,xi),Xi2),sf_mul(sf_mul(sf_imul(2,xr),Xr),Xi)),sf_mul(sf_imul(3,xi2),Xi)),sf_mul(xr2,Xi)),sf_mul(xi,Xr2)),sf_mul(sf_mul(sf_imul(2,xr),xi),Xr)),sf_mul(xi2,xi)),sf_mul(xr2,xi))))),ci);
}

);

static const char *perturbation_opencl_softfloat_35_4_1 = STR(

{dxan=sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dya)))),sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dxa)))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,dxa)))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,dya)))),daa))));
dxbn=sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dyb)))),sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dxb)))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,dxb)))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,dyb)))),dab))));
dyan=sf_add(dba,sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxa,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(8,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))),sf_imul(-4,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr)))),dya))))));
dybn=sf_add(dbb,sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(8,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))),sf_imul(-4,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr)))),dyb))))));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_mul(sf_imul(4,Xi),xi2),xi)),sf_mul(xi2,xi2)),sf_mul(sf_mul(sf_imul(12,Xr2),Xi),xi)),sf_mul(sf_imul(6,Xr2),xi2)),sf_mul(sf_mul(sf_imul(12,Xr),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(24,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_imul(12,Xr),xr),xi2)),sf_mul(sf_imul(6,xr2),Xi2)),sf_mul(sf_mul(sf_imul(12,xr2),Xi),xi)),sf_mul(sf_imul(6,xr2),xi2)),cr);
xin=sf_add(sf_sub(sf_mul(sf_imul(-4,Xi),sf_diffabs(sf_sub(sf_mul(Xr2,Xr),sf_mul(Xr,Xi2)),sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_mul(sf_neg(xr),Xi2),sf_mul(sf_mul(sf_imul(2,xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(2,xr),xi),Xi)),sf_mul(sf_imul(3,xr),Xr2)),sf_mul(xi2,Xr)),sf_mul(sf_imul(3,xr2),Xr)),sf_mul(xr,xi2)),sf_mul(xr2,xr)))),sf_mul(sf_imul(4,xi),sf_abs(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_mul(sf_neg(Xr),Xi2),sf_mul(xr,Xi2)),sf_mul(sf_mul(sf_imul(2,xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(2,xr),xi),Xi)),sf_mul(Xr2,Xr)),sf_mul(sf_imul(3,xr),Xr2)),sf_mul(xi2,Xr)),sf_mul(sf_imul(3,xr2),Xr)),sf_mul(xr,xi2)),sf_mul(xr2,xr))))),ci);
}

);

static const char *perturbation_opencl_softfloat_36_4_1 = STR(

{dxan=sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dya)))),sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dxa)))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,dxa)))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,dya)))),daa))));
dxbn=sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,dyb)))),sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,dxb)))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,dxb)))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,dyb)))),dab))));
dyan=sf_add(dba,sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxa,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(-8,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))),sf_imul(4,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr)))),dya))))));
dybn=sf_add(dbb,sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(-8,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))),sf_imul(4,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr)))),dyb))))));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(4,Xr),xr2),xr)),sf_mul(xr2,xr2)),sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_mul(sf_imul(4,Xi),xi2),xi)),sf_mul(xi2,xi2)),sf_mul(sf_mul(sf_imul(12,Xr2),Xi),xi)),sf_mul(sf_imul(6,Xr2),xi2)),sf_mul(sf_mul(sf_imul(12,Xr),xr),Xi2)),sf_mul(sf_mul(sf_mul(sf_imul(24,Xr),xr),Xi),xi)),sf_mul(sf_mul(sf_imul(12,Xr),xr),xi2)),sf_mul(sf_imul(6,xr2),Xi2)),sf_mul(sf_mul(sf_imul(12,xr2),Xi),xi)),sf_mul(sf_imul(6,xr2),xi2)),cr);
xin=sf_add(sf_add(sf_mul(sf_imul(4,Xi),sf_diffabs(sf_sub(sf_mul(Xr2,Xr),sf_mul(Xr,Xi2)),sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_mul(sf_neg(xr),Xi2),sf_mul(sf_mul(sf_imul(2,xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(2,xr),xi),Xi)),sf_mul(sf_imul(3,xr),Xr2)),sf_mul(xi2,Xr)),sf_mul(sf_imul(3,xr2),Xr)),sf_mul(xr,xi2)),sf_mul(xr2,xr)))),sf_mul(sf_imul(4,xi),sf_abs(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_mul(sf_neg(Xr),Xi2),sf_mul(xr,Xi2)),sf_mul(sf_mul(sf_imul(2,xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(2,xr),xi),Xi)),sf_mul(Xr2,Xr)),sf_mul(sf_imul(3,xr),Xr2)),sf_mul(xi2,Xr)),sf_mul(sf_imul(3,xr2),Xr)),sf_mul(xr,xi2)),sf_mul(xr2,xr))))),ci);
}

);

static const char *perturbation_opencl_softfloat_37_4_1 = STR(

{dxan=sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dya,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),daa))));
dxbn=sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dyb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),dab))));
dyan=sf_add(dba,sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxi,sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(8,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxi,sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxi,sf_mul(Xxr,Xxr))))))))),sf_imul(4,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxi,sf_mul(Xxr,Xxr)))),dxa))))));
dybn=sf_add(dbb,sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxi,sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(8,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxi,sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxi,sf_mul(Xxr,Xxr))))))))),sf_imul(4,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxi,sf_mul(Xxr,Xxr)))),dxb))))));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_diffabs(sf_sub(sf_add(sf_mul(Xr2,Xr2),sf_mul(Xi2,Xi2)),sf_mul(sf_imul(6,Xr2),Xi2)),sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_sub(sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi),sf_mul(sf_mul(sf_imul(12,Xi2),xr),Xr)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_imul(6,Xi2),xr2)),sf_mul(sf_mul(sf_imul(12,Xr2),Xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(24,Xr),Xi),xr),xi)),sf_mul(sf_mul(sf_imul(4,xi2),xi),Xi)),sf_mul(sf_mul(sf_imul(12,xi),Xi),xr2)),sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr)),sf_mul(sf_imul(6,Xr2),xi2)),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(12,xi2),Xr),xr)),sf_mul(sf_mul(sf_imul(4,xr2),xr),Xr)),sf_mul(xi2,xi2)),sf_mul(sf_imul(6,xi2),xr2)),sf_mul(xr2,xr2))),cr);
xin=sf_add(sf_add(sf_mul(sf_imul(4,xr),sf_abs(sf_add(sf_sub(sf_add(sf_add(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_mul(sf_neg(Xi2),Xi),sf_mul(sf_imul(3,xi),Xi2)),sf_mul(Xr2,Xi)),sf_mul(sf_mul(sf_imul(2,xr),Xr),Xi)),sf_mul(sf_imul(3,xi2),Xi)),sf_mul(xr2,Xi)),sf_mul(xi,Xr2)),sf_mul(sf_mul(sf_imul(2,xr),xi),Xr)),sf_mul(xi2,xi)),sf_mul(xr2,xi)))),sf_mul(sf_imul(4,Xr),sf_diffabs(sf_add(sf_mul(sf_neg(Xi2),Xi),sf_mul(Xr2,Xi)),sf_add(sf_sub(sf_add(sf_add(sf_add(sf_sub(sf_add(sf_mul(sf_imul(-3,xi),Xi2),sf_mul(sf_mul(sf_imul(2,xr),Xr),Xi)),sf_mul(sf_imul(3,xi2),Xi)),sf_mul(xr2,Xi)),sf_mul(xi,Xr2)),sf_mul(sf_mul(sf_imul(2,xr),xi),Xr)),sf_mul(xi2,xi)),sf_mul(xr2,xi))))),ci);
}

);

static const char *perturbation_opencl_softfloat_38_4_1 = STR(

{dxan=sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dya,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),daa))));
dxbn=sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dyb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),dab))));
dyan=sf_add(dba,sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxa,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(8,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))),sf_imul(-4,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr)))),dya))))));
dybn=sf_add(dbb,sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(8,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))),sf_imul(-4,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr)))),dyb))))));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_diffabs(sf_sub(sf_add(sf_mul(Xr2,Xr2),sf_mul(Xi2,Xi2)),sf_mul(sf_imul(6,Xr2),Xi2)),sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_sub(sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi),sf_mul(sf_mul(sf_imul(12,Xi2),xr),Xr)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_imul(6,Xi2),xr2)),sf_mul(sf_mul(sf_imul(12,Xr2),Xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(24,Xr),Xi),xr),xi)),sf_mul(sf_mul(sf_imul(4,xi2),xi),Xi)),sf_mul(sf_mul(sf_imul(12,xi),Xi),xr2)),sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr)),sf_mul(sf_imul(6,Xr2),xi2)),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(12,xi2),Xr),xr)),sf_mul(sf_mul(sf_imul(4,xr2),xr),Xr)),sf_mul(xi2,xi2)),sf_mul(sf_imul(6,xi2),xr2)),sf_mul(xr2,xr2))),cr);
xin=sf_add(sf_sub(sf_mul(sf_imul(-4,Xi),sf_diffabs(sf_sub(sf_mul(Xr2,Xr),sf_mul(Xr,Xi2)),sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_mul(sf_neg(xr),Xi2),sf_mul(sf_mul(sf_imul(2,xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(2,xr),xi),Xi)),sf_mul(sf_imul(3,xr),Xr2)),sf_mul(xi2,Xr)),sf_mul(sf_imul(3,xr2),Xr)),sf_mul(xr,xi2)),sf_mul(xr2,xr)))),sf_mul(sf_imul(4,xi),sf_abs(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_mul(sf_neg(Xr),Xi2),sf_mul(xr,Xi2)),sf_mul(sf_mul(sf_imul(2,xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(2,xr),xi),Xi)),sf_mul(Xr2,Xr)),sf_mul(sf_imul(3,xr),Xr2)),sf_mul(xi2,Xr)),sf_mul(sf_imul(3,xr2),Xr)),sf_mul(xr,xi2)),sf_mul(xr2,xr))))),ci);
}

);

static const char *perturbation_opencl_softfloat_39_4_1 = STR(

{dxan=sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dya,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),daa))));
dxbn=sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dyb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,Xxr)))),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),dab))));
dyan=sf_add(dba,sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxa,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(-8,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))),sf_imul(4,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr)))),dya))))));
dybn=sf_add(dbb,sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(-8,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(12,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))),sf_imul(4,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,Xxr)))),dyb))))));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_diffabs(sf_sub(sf_add(sf_mul(Xr2,Xr2),sf_mul(Xi2,Xi2)),sf_mul(sf_imul(6,Xr2),Xi2)),sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_sub(sf_mul(sf_mul(sf_imul(4,Xi2),Xi),xi),sf_mul(sf_mul(sf_imul(12,Xi2),xr),Xr)),sf_mul(sf_imul(6,Xi2),xi2)),sf_mul(sf_imul(6,Xi2),xr2)),sf_mul(sf_mul(sf_imul(12,Xr2),Xi),xi)),sf_mul(sf_mul(sf_mul(sf_imul(24,Xr),Xi),xr),xi)),sf_mul(sf_mul(sf_imul(4,xi2),xi),Xi)),sf_mul(sf_mul(sf_imul(12,xi),Xi),xr2)),sf_mul(sf_mul(sf_imul(4,Xr2),Xr),xr)),sf_mul(sf_imul(6,Xr2),xi2)),sf_mul(sf_imul(6,Xr2),xr2)),sf_mul(sf_mul(sf_imul(12,xi2),Xr),xr)),sf_mul(sf_mul(sf_imul(4,xr2),xr),Xr)),sf_mul(xi2,xi2)),sf_mul(sf_imul(6,xi2),xr2)),sf_mul(xr2,xr2))),cr);
xin=sf_add(sf_add(sf_mul(sf_imul(4,Xi),sf_diffabs(sf_sub(sf_mul(Xr2,Xr),sf_mul(Xr,Xi2)),sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_sub(sf_mul(sf_neg(xr),Xi2),sf_mul(sf_mul(sf_imul(2,xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(2,xr),xi),Xi)),sf_mul(sf_imul(3,xr),Xr2)),sf_mul(xi2,Xr)),sf_mul(sf_imul(3,xr2),Xr)),sf_mul(xr,xi2)),sf_mul(xr2,xr)))),sf_mul(sf_imul(4,xi),sf_abs(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_mul(sf_neg(Xr),Xi2),sf_mul(xr,Xi2)),sf_mul(sf_mul(sf_imul(2,xi),Xr),Xi)),sf_mul(sf_mul(sf_imul(2,xr),xi),Xi)),sf_mul(Xr2,Xr)),sf_mul(sf_imul(3,xr),Xr2)),sf_mul(xi2,Xr)),sf_mul(sf_imul(3,xr2),Xr)),sf_mul(xr,xi2)),sf_mul(xr2,xr))))),ci);
}

);

static const char *perturbation_opencl_softfloat_40_6_1 = STR(

{dxan=sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxr,sf_mul(Xxr,dya)))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_mul(Xxr,dxa)))),sf_add(sf_imul(3,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr)))))))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxi,sf_mul(Xxi,dya)))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(Xxi,sf_mul(Xxi,dxa)))),sf_add(sf_imul(-3,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr)))))))))),sf_add(sf_imul(3,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxr)))))))))),sf_add(sf_imul(-3,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dya,sf_sgn(Xxi)))))))))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(Xxi,sf_mul(Xxr,dya)))),sf_add(sf_imul(6,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxi,sf_mul(Xxr,dxa)))),sf_add(sf_imul(-6,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxr)))))))))),sf_add(sf_imul(6,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr)))))))))),sf_add(sf_imul(-9,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,dxa)))),sf_add(sf_imul(-9,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_mul(Xxr,dya)))),sf_add(sf_imul(-9,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxr)))))))))),sf_add(sf_imul(9,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxi,sf_mul(Xxi,dxa)))),sf_add(sf_imul(9,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxi,sf_mul(Xxi,dya)))),sf_add(sf_imul(-9,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr)))))))))),sf_add(sf_imul(9,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr)))))))))),sf_add(sf_imul(9,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxi)))))))))),sf_add(sf_imul(18,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxi,sf_mul(Xxr,dya)))),sf_add(sf_imul(-18,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxi,sf_mul(Xxr,dxa)))),sf_add(sf_imul(-18,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr)))))))))),sf_add(sf_imul(18,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxr)))))))))),daa))))))))))))))))))))))));
dxbn=sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxr,sf_mul(Xxr,dyb)))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_mul(Xxr,dxb)))),sf_add(sf_imul(3,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr)))))))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxi,sf_mul(Xxi,dyb)))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(Xxi,sf_mul(Xxi,dxb)))),sf_add(sf_imul(-3,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr)))))))))),sf_add(sf_imul(3,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxr)))))))))),sf_add(sf_imul(-3,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dyb,sf_sgn(Xxi)))))))))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(Xxi,sf_mul(Xxr,dyb)))),sf_add(sf_imul(6,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxi,sf_mul(Xxr,dxb)))),sf_add(sf_imul(-6,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxr)))))))))),sf_add(sf_imul(6,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr)))))))))),sf_add(sf_imul(-9,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,dxb)))),sf_add(sf_imul(-9,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_mul(Xxr,dyb)))),sf_add(sf_imul(-9,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxr)))))))))),sf_add(sf_imul(9,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxi,sf_mul(Xxi,dxb)))),sf_add(sf_imul(9,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxi,sf_mul(Xxi,dyb)))),sf_add(sf_imul(-9,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr)))))))))),sf_add(sf_imul(9,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr)))))))))),sf_add(sf_imul(9,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxi)))))))))),sf_add(sf_imul(18,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxi,sf_mul(Xxr,dyb)))),sf_add(sf_imul(-18,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxi,sf_mul(Xxr,dxb)))),sf_add(sf_imul(-18,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr)))))))))),sf_add(sf_imul(18,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxr)))))))))),dab))))))))))))))))))))))));
dyan=sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_mul(Xxr,dya)))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxr,sf_mul(Xxr,dxa)))),sf_add(sf_imul(3,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxr)))))))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(Xxi,sf_mul(Xxi,dya)))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxi,sf_mul(Xxi,dxa)))),sf_add(sf_imul(-3,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxi)))))))))),sf_add(sf_imul(-3,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr)))))))))),sf_add(sf_imul(3,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxa,sf_sgn(Xxr)))))))))),sf_add(sf_imul(6,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxi,sf_mul(Xxr,dya)))),sf_add(sf_imul(6,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(Xxi,sf_mul(Xxr,dxa)))),sf_add(sf_imul(6,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxr)))))))))),sf_add(sf_imul(6,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr)))))))))),sf_add(sf_imul(-9,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,dya)))),sf_add(sf_imul(9,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxi,sf_mul(Xxi,dya)))),sf_add(sf_imul(9,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_mul(Xxr,dxa)))),sf_add(sf_imul(9,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr)))))))))),sf_add(sf_imul(-9,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxi,sf_mul(Xxi,dxa)))),sf_add(sf_imul(-9,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxr)))))))))),sf_add(sf_imul(9,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxi)))))))))),sf_add(sf_imul(-9,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr)))))))))),sf_add(sf_imul(-18,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxi,sf_mul(Xxr,dxa)))),sf_add(sf_imul(-18,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxi,sf_mul(Xxr,dya)))),sf_add(sf_imul(-18,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxr)))))))))),sf_add(sf_imul(-18,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr)))))))))),dba))))))))))))))))))))))));
dybn=sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_mul(Xxr,dyb)))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxr,sf_mul(Xxr,dxb)))),sf_add(sf_imul(3,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxr)))))))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(Xxi,sf_mul(Xxi,dyb)))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxi,sf_mul(Xxi,dxb)))),sf_add(sf_imul(-3,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxi)))))))))),sf_add(sf_imul(-3,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr)))))))))),sf_add(sf_imul(3,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxb,sf_sgn(Xxr)))))))))),sf_add(sf_imul(6,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxi,sf_mul(Xxr,dyb)))),sf_add(sf_imul(6,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(Xxi,sf_mul(Xxr,dxb)))),sf_add(sf_imul(6,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxr)))))))))),sf_add(sf_imul(6,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr)))))))))),sf_add(sf_imul(-9,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxr,sf_mul(Xxr,dyb)))),sf_add(sf_imul(9,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxi,sf_mul(Xxi,dyb)))),sf_add(sf_imul(9,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_mul(Xxr,dxb)))),sf_add(sf_imul(9,sf_mul(sf_sgn(Xxr),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr)))))))))),sf_add(sf_imul(-9,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxi,sf_mul(Xxi,dxb)))),sf_add(sf_imul(-9,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxr)))))))))),sf_add(sf_imul(9,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxi)))))))))),sf_add(sf_imul(-9,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr)))))))))),sf_add(sf_imul(-18,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxr))),sf_mul(Xxi,sf_mul(Xxr,dxb)))),sf_add(sf_imul(-18,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxi,sf_mul(Xxr,dyb)))),sf_add(sf_imul(-18,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxr)))))))))),sf_add(sf_imul(-18,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr)))))))))),dbb))))))))))))))))))))))));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_add(sf_sub(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_sub(sf_add(sf_sub(sf_add(sf_sub(sf_mul(sf_imul(3,sf_diffabs(sf_mul(Xr2,Xi),sf_add(sf_add(sf_add(sf_add(sf_mul(Xr2,xi),sf_mul(sf_mul(sf_imul(2,Xr),xr),Xi)),sf_mul(sf_mul(sf_imul(2,Xr),xr),xi)),sf_mul(xr2,Xi)),sf_mul(xr2,xi)))),sf_mul(Xi2,Xi)),sf_mul(sf_diffabs(sf_mul(Xi2,Xi),sf_add(sf_add(sf_mul(sf_imul(3,Xi2),xi),sf_mul(sf_imul(3,Xi),xi2)),sf_mul(xi2,xi))),sf_mul(Xi2,Xi))),sf_mul(sf_imul(9,sf_diffabs(sf_mul(Xr,Xi2),sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(2,Xr),Xi),xi),sf_mul(Xr,xi2)),sf_mul(xr,Xi2)),sf_mul(sf_mul(sf_imul(2,xr),Xi),xi)),sf_mul(xr,xi2)))),sf_mul(Xr,Xi2))),sf_mul(sf_imul(3,sf_diffabs(sf_mul(Xr2,Xr),sf_add(sf_add(sf_mul(sf_imul(3,Xr2),xr),sf_mul(sf_imul(3,Xr),xr2)),sf_mul(xr2,xr)))),sf_mul(Xr,Xi2))),sf_mul(sf_imul(3,sf_diffabs(sf_mul(Xi2,Xi),sf_add(sf_add(sf_mul(sf_imul(3,Xi2),xi),sf_mul(sf_imul(3,Xi),xi2)),sf_mul(xi2,xi)))),sf_mul(Xr2,Xi))),sf_mul(sf_imul(9,sf_diffabs(sf_mul(Xr2,Xi),sf_add(sf_add(sf_add(sf_add(sf_mul(Xr2,xi),sf_mul(sf_mul(sf_imul(2,Xr),xr),Xi)),sf_mul(sf_mul(sf_imul(2,Xr),xr),xi)),sf_mul(xr2,Xi)),sf_mul(xr2,xi)))),sf_mul(Xr2,Xi))),sf_mul(sf_imul(3,sf_diffabs(sf_mul(Xr,Xi2),sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(2,Xr),Xi),xi),sf_mul(Xr,xi2)),sf_mul(xr,Xi2)),sf_mul(sf_mul(sf_imul(2,xr),Xi),xi)),sf_mul(xr,xi2)))),sf_mul(Xr2,Xr))),sf_mul(sf_diffabs(sf_mul(Xr2,Xr),sf_add(sf_add(sf_mul(sf_imul(3,Xr2),xr),sf_mul(sf_imul(3,Xr),xr2)),sf_mul(xr2,xr))),sf_mul(Xr2,Xr))),sf_mul(sf_imul(3,sf_abs(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(Xr2,Xi),sf_mul(Xr2,xi)),sf_mul(sf_mul(sf_imul(2,Xr),xr),Xi)),sf_mul(sf_mul(sf_imul(2,Xr),xr),xi)),sf_mul(xr2,Xi)),sf_mul(xr2,xi)))),sf_add(sf_add(sf_mul(sf_imul(3,Xi2),xi),sf_mul(sf_imul(3,Xi),xi2)),sf_mul(xi2,xi)))),sf_mul(sf_abs(sf_add(sf_add(sf_add(sf_mul(Xi2,Xi),sf_mul(sf_imul(3,Xi2),xi)),sf_mul(sf_imul(3,Xi),xi2)),sf_mul(xi2,xi))),sf_add(sf_add(sf_mul(sf_imul(3,Xi2),xi),sf_mul(sf_imul(3,Xi),xi2)),sf_mul(xi2,xi)))),sf_mul(sf_imul(9,sf_abs(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(Xr,Xi2),sf_mul(sf_mul(sf_imul(2,Xr),Xi),xi)),sf_mul(Xr,xi2)),sf_mul(xr,Xi2)),sf_mul(sf_mul(sf_imul(2,xr),Xi),xi)),sf_mul(xr,xi2)))),sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(2,Xr),Xi),xi),sf_mul(Xr,xi2)),sf_mul(xr,Xi2)),sf_mul(sf_mul(sf_imul(2,xr),Xi),xi)),sf_mul(xr,xi2)))),sf_mul(sf_imul(3,sf_abs(sf_add(sf_add(sf_add(sf_mul(Xr2,Xr),sf_mul(sf_imul(3,Xr2),xr)),sf_mul(sf_imul(3,Xr),xr2)),sf_mul(xr2,xr)))),sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(2,Xr),Xi),xi),sf_mul(Xr,xi2)),sf_mul(xr,Xi2)),sf_mul(sf_mul(sf_imul(2,xr),Xi),xi)),sf_mul(xr,xi2)))),sf_mul(sf_imul(3,sf_abs(sf_add(sf_add(sf_add(sf_mul(Xi2,Xi),sf_mul(sf_imul(3,Xi2),xi)),sf_mul(sf_imul(3,Xi),xi2)),sf_mul(xi2,xi)))),sf_add(sf_add(sf_add(sf_add(sf_mul(Xr2,xi),sf_mul(sf_mul(sf_imul(2,Xr),xr),Xi)),sf_mul(sf_mul(sf_imul(2,Xr),xr),xi)),sf_mul(xr2,Xi)),sf_mul(xr2,xi)))),sf_mul(sf_imul(9,sf_abs(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(Xr2,Xi),sf_mul(Xr2,xi)),sf_mul(sf_mul(sf_imul(2,Xr),xr),Xi)),sf_mul(sf_mul(sf_imul(2,Xr),xr),xi)),sf_mul(xr2,Xi)),sf_mul(xr2,xi)))),sf_add(sf_add(sf_add(sf_add(sf_mul(Xr2,xi),sf_mul(sf_mul(sf_imul(2,Xr),xr),Xi)),sf_mul(sf_mul(sf_imul(2,Xr),xr),xi)),sf_mul(xr2,Xi)),sf_mul(xr2,xi)))),sf_mul(sf_imul(3,sf_abs(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(Xr,Xi2),sf_mul(sf_mul(sf_imul(2,Xr),Xi),xi)),sf_mul(Xr,xi2)),sf_mul(xr,Xi2)),sf_mul(sf_mul(sf_imul(2,xr),Xi),xi)),sf_mul(xr,xi2)))),sf_add(sf_add(sf_mul(sf_imul(3,Xr2),xr),sf_mul(sf_imul(3,Xr),xr2)),sf_mul(xr2,xr)))),sf_mul(sf_abs(sf_add(sf_add(sf_add(sf_mul(Xr2,Xr),sf_mul(sf_imul(3,Xr2),xr)),sf_mul(sf_imul(3,Xr),xr2)),sf_mul(xr2,xr))),sf_add(sf_add(sf_mul(sf_imul(3,Xr2),xr),sf_mul(sf_imul(3,Xr),xr2)),sf_mul(xr2,xr)))),cr);
xin=sf_add(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_add(sf_add(sf_sub(sf_add(sf_add(sf_sub(sf_sub(sf_sub(sf_mul(sf_imul(3,sf_diffabs(sf_mul(Xr,Xi2),sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(2,Xr),Xi),xi),sf_mul(Xr,xi2)),sf_mul(xr,Xi2)),sf_mul(sf_mul(sf_imul(2,xr),Xi),xi)),sf_mul(xr,xi2)))),sf_mul(Xi2,Xi)),sf_mul(sf_diffabs(sf_mul(Xr2,Xr),sf_add(sf_add(sf_mul(sf_imul(3,Xr2),xr),sf_mul(sf_imul(3,Xr),xr2)),sf_mul(xr2,xr))),sf_mul(Xi2,Xi))),sf_mul(sf_imul(9,sf_diffabs(sf_mul(Xr2,Xi),sf_add(sf_add(sf_add(sf_add(sf_mul(Xr2,xi),sf_mul(sf_mul(sf_imul(2,Xr),xr),Xi)),sf_mul(sf_mul(sf_imul(2,Xr),xr),xi)),sf_mul(xr2,Xi)),sf_mul(xr2,xi)))),sf_mul(Xr,Xi2))),sf_mul(sf_imul(9,sf_diffabs(sf_mul(Xr,Xi2),sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(2,Xr),Xi),xi),sf_mul(Xr,xi2)),sf_mul(xr,Xi2)),sf_mul(sf_mul(sf_imul(2,xr),Xi),xi)),sf_mul(xr,xi2)))),sf_mul(Xr2,Xi))),sf_mul(sf_imul(3,sf_diffabs(sf_mul(Xr2,Xr),sf_add(sf_add(sf_mul(sf_imul(3,Xr2),xr),sf_mul(sf_imul(3,Xr),xr2)),sf_mul(xr2,xr)))),sf_mul(Xr2,Xi))),sf_mul(sf_imul(3,sf_diffabs(sf_mul(Xi2,Xi),sf_add(sf_add(sf_mul(sf_imul(3,Xi2),xi),sf_mul(sf_imul(3,Xi),xi2)),sf_mul(xi2,xi)))),sf_mul(Xr,Xi2))),sf_mul(sf_diffabs(sf_mul(Xi2,Xi),sf_add(sf_add(sf_mul(sf_imul(3,Xi2),xi),sf_mul(sf_imul(3,Xi),xi2)),sf_mul(xi2,xi))),sf_mul(Xr2,Xr))),sf_mul(sf_imul(3,sf_diffabs(sf_mul(Xr2,Xi),sf_add(sf_add(sf_add(sf_add(sf_mul(Xr2,xi),sf_mul(sf_mul(sf_imul(2,Xr),xr),Xi)),sf_mul(sf_mul(sf_imul(2,Xr),xr),xi)),sf_mul(xr2,Xi)),sf_mul(xr2,xi)))),sf_mul(Xr2,Xr))),sf_mul(sf_imul(3,sf_abs(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(Xr,Xi2),sf_mul(sf_mul(sf_imul(2,Xr),Xi),xi)),sf_mul(Xr,xi2)),sf_mul(xr,Xi2)),sf_mul(sf_mul(sf_imul(2,xr),Xi),xi)),sf_mul(xr,xi2)))),sf_add(sf_add(sf_mul(sf_imul(3,Xi2),xi),sf_mul(sf_imul(3,Xi),xi2)),sf_mul(xi2,xi)))),sf_mul(sf_abs(sf_add(sf_add(sf_add(sf_mul(Xr2,Xr),sf_mul(sf_imul(3,Xr2),xr)),sf_mul(sf_imul(3,Xr),xr2)),sf_mul(xr2,xr))),sf_add(sf_add(sf_mul(sf_imul(3,Xi2),xi),sf_mul(sf_imul(3,Xi),xi2)),sf_mul(xi2,xi)))),sf_mul(sf_imul(9,sf_abs(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(Xr2,Xi),sf_mul(Xr2,xi)),sf_mul(sf_mul(sf_imul(2,Xr),xr),Xi)),sf_mul(sf_mul(sf_imul(2,Xr),xr),xi)),sf_mul(xr2,Xi)),sf_mul(xr2,xi)))),sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(2,Xr),Xi),xi),sf_mul(Xr,xi2)),sf_mul(xr,Xi2)),sf_mul(sf_mul(sf_imul(2,xr),Xi),xi)),sf_mul(xr,xi2)))),sf_mul(sf_imul(9,sf_abs(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(Xr,Xi2),sf_mul(sf_mul(sf_imul(2,Xr),Xi),xi)),sf_mul(Xr,xi2)),sf_mul(xr,Xi2)),sf_mul(sf_mul(sf_imul(2,xr),Xi),xi)),sf_mul(xr,xi2)))),sf_add(sf_add(sf_add(sf_add(sf_mul(Xr2,xi),sf_mul(sf_mul(sf_imul(2,Xr),xr),Xi)),sf_mul(sf_mul(sf_imul(2,Xr),xr),xi)),sf_mul(xr2,Xi)),sf_mul(xr2,xi)))),sf_mul(sf_imul(3,sf_abs(sf_add(sf_add(sf_add(sf_mul(Xr2,Xr),sf_mul(sf_imul(3,Xr2),xr)),sf_mul(sf_imul(3,Xr),xr2)),sf_mul(xr2,xr)))),sf_add(sf_add(sf_add(sf_add(sf_mul(Xr2,xi),sf_mul(sf_mul(sf_imul(2,Xr),xr),Xi)),sf_mul(sf_mul(sf_imul(2,Xr),xr),xi)),sf_mul(xr2,Xi)),sf_mul(xr2,xi)))),sf_mul(sf_imul(3,sf_abs(sf_add(sf_add(sf_add(sf_mul(Xi2,Xi),sf_mul(sf_imul(3,Xi2),xi)),sf_mul(sf_imul(3,Xi),xi2)),sf_mul(xi2,xi)))),sf_add(sf_add(sf_add(sf_add(sf_mul(sf_mul(sf_imul(2,Xr),Xi),xi),sf_mul(Xr,xi2)),sf_mul(xr,Xi2)),sf_mul(sf_mul(sf_imul(2,xr),Xi),xi)),sf_mul(xr,xi2)))),sf_mul(sf_abs(sf_add(sf_add(sf_add(sf_mul(Xi2,Xi),sf_mul(sf_imul(3,Xi2),xi)),sf_mul(sf_imul(3,Xi),xi2)),sf_mul(xi2,xi))),sf_add(sf_add(sf_mul(sf_imul(3,Xr2),xr),sf_mul(sf_imul(3,Xr),xr2)),sf_mul(xr2,xr)))),sf_mul(sf_imul(3,sf_abs(sf_add(sf_add(sf_add(sf_add(sf_add(sf_mul(Xr2,Xi),sf_mul(Xr2,xi)),sf_mul(sf_mul(sf_imul(2,Xr),xr),Xi)),sf_mul(sf_mul(sf_imul(2,Xr),xr),xi)),sf_mul(xr2,Xi)),sf_mul(xr2,xi)))),sf_add(sf_add(sf_mul(sf_imul(3,Xr2),xr),sf_mul(sf_imul(3,Xr),xr2)),sf_mul(xr2,xr)))),ci);
}

);

static const char *perturbation_opencl_softfloat_41_2_1 = STR(

{dxan=sf_add(daa,sf_add(sf_imul(2,sf_mul(Xxr,dxa)),sf_add(sf_imul(-2,sf_mul(Xxi,dya)),sf_imul(-1,sf_mul(dxa,sf_sgn(Xxr))))));
dxbn=sf_add(dab,sf_add(sf_imul(2,sf_mul(Xxr,dxb)),sf_add(sf_imul(-2,sf_mul(Xxi,dyb)),sf_imul(-1,sf_mul(dxb,sf_sgn(Xxr))))));
dyan=sf_add(dba,sf_add(sf_imul(2,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(dxa,sf_sgn(Xxr))))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxi),sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxr))))),sf_imul(-1,sf_mul(dya,sf_sgn(Xxi))))));
dybn=sf_add(dbb,sf_add(sf_imul(2,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(dxb,sf_sgn(Xxr))))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxi),sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxr))))),sf_imul(-1,sf_mul(dyb,sf_sgn(Xxi))))));
}

{xrn=sf_add(sf_sub(sf_sub(sf_mul(xr,sf_add(sf_imul(2,Xr),xr)),sf_mul(xi,sf_add(xi,sf_imul(2,Xi)))),sf_diffabs(Xr,xr)),cr);
xin=sf_add(sf_sub(sf_muli(sf_diffabs(sf_mul(Xr,Xi),sf_add(sf_add(sf_mul(Xr,xi),sf_mul(xr,Xi)),sf_mul(xr,xi))),2),sf_diffabs(Xi,xi)),ci);
}

);

static const char *perturbation_opencl_softfloat_42_3_1 = STR(

{const sfcomplex X2 = sfc_sqr(X);
dn=sfc_add(sfc_mul(sfc_add(sfc_mul(A,sfc_imul(2,X)),sfc_imul(3,X2)),d),d0);
}

{const sfcomplex X2 = sfc_sqr(X);
const sfcomplex x2 = sfc_sqr(x);
xn=sfc_add(sfc_add(sfc_add(sfc_add(sfc_mul(A,sfc_add(sfc_mul(sfc_imul(2,X),x),x2)),sfc_mul(sfc_imul(3,X2),x)),sfc_mul(sfc_imul(3,X),x2)),sfc_mul(x2,x)),c);
}

);

static const char *perturbation_opencl_softfloat_43_3_1 = STR(

{const sfcomplex X2 = sfc_sqr(X);
dn=sfc_add(sfc_mul(sfc_sub(sfc_mul(A,sfc_imul(2,X)),sfc_imul(3,X2)),d),d0);
}

{const sfcomplex X2 = sfc_sqr(X);
const sfcomplex x2 = sfc_sqr(x);
xn=sfc_add(sfc_sub(sfc_sub(sfc_sub(sfc_mul(A,sfc_add(sfc_mul(sfc_imul(2,X),x),x2)),sfc_mul(sfc_imul(3,X2),x)),sfc_mul(sfc_imul(3,X),x2)),sfc_mul(x2,x)),c);
}

);

static const char *perturbation_opencl_softfloat_44_3_1 = STR(

{const sfcomplex X2 = sfc_sqr(X);
dn=sfc_add(sfc_mul(sfc_sub(sfc_imul(4,X),sfc_imul(3,X2)),d),d0);
}

{const sfcomplex X2 = sfc_sqr(X);
const sfcomplex x2 = sfc_sqr(x);
xn=sfc_add(sfc_sub(sfc_sub(sfc_sub(sfc_imul(2,sfc_add(sfc_mul(sfc_imul(2,X),x),x2)),sfc_mul(sfc_imul(3,X2),x)),sfc_mul(sfc_imul(3,X),x2)),sfc_mul(x2,x)),c);
}

);

static const char *perturbation_opencl_softfloat_45_4_1 = STR(

{const sfcomplex X2 = sfc_sqr(X);
dn=sfc_add(sfc_mul(sfc_mul(sfc_add(sfc_muli(A,2),sfc_imul(4,X2)),X),d),d0);
}

{const sfcomplex x2 = sfc_sqr(x);
xn=sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_mul(A,sfc_add(sfc_mul(sfc_imul(2,X),x),x2)),sfc_mul(sfc_imul(4,sfc_powi(X,3)),x)),sfc_mul(sfc_imul(6,sfc_powi(X,2)),x2)),sfc_mul(sfc_mul(sfc_imul(4,X),x2),x)),sfc_powi(x2,2)),c);
}

);

static const char *perturbation_opencl_softfloat_46_4_1 = STR(

{const sfcomplex X2 = sfc_sqr(X);
dn=sfc_add(sfc_mul(sfc_mul(sfc_sub(sfc_muli(A,2),sfc_imul(4,X2)),X),d),d0);
}

{const sfcomplex x2 = sfc_sqr(x);
xn=sfc_add(sfc_sub(sfc_sub(sfc_sub(sfc_sub(sfc_mul(A,sfc_add(sfc_mul(sfc_imul(2,X),x),x2)),sfc_mul(sfc_imul(4,sfc_powi(X,3)),x)),sfc_mul(sfc_imul(6,sfc_powi(X,2)),x2)),sfc_mul(sfc_mul(sfc_imul(4,X),x2),x)),sfc_powi(x2,2)),c);
}

);

static const char *perturbation_opencl_softfloat_47_5_1 = STR(

{const sfcomplex X2 = sfc_sqr(X);
dn=sfc_add(sfc_mul(sfc_mul(sfc_add(sfc_muli(A,2),sfc_mul(sfc_imul(5,X2),X)),X),d),d0);
}

{const sfcomplex x2 = sfc_sqr(x);
xn=sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_mul(A,sfc_add(sfc_mul(sfc_imul(2,X),x),x2)),sfc_mul(sfc_imul(5,sfc_powi(X,4)),x)),sfc_mul(sfc_imul(10,sfc_powi(X,3)),x2)),sfc_mul(sfc_mul(sfc_imul(10,sfc_powi(X,2)),x2),x)),sfc_mul(sfc_imul(5,X),sfc_powi(x2,2))),sfc_mul(sfc_mul(x2,x2),x)),c);
}

);

static const char *perturbation_opencl_softfloat_48_5_1 = STR(

{const sfcomplex X2 = sfc_sqr(X);
dn=sfc_add(sfc_mul(sfc_mul(sfc_sub(sfc_muli(A,2),sfc_mul(sfc_imul(5,X2),X)),X),d),d0);
}

{const sfcomplex x2 = sfc_sqr(x);
xn=sfc_add(sfc_sub(sfc_sub(sfc_sub(sfc_sub(sfc_sub(sfc_mul(A,sfc_add(sfc_mul(sfc_imul(2,X),x),x2)),sfc_mul(sfc_imul(5,sfc_powi(X,4)),x)),sfc_mul(sfc_imul(10,sfc_powi(X,3)),x2)),sfc_mul(sfc_mul(sfc_imul(10,sfc_powi(X,2)),x2),x)),sfc_mul(sfc_imul(5,X),sfc_powi(x2,2))),sfc_mul(sfc_mul(x2,x2),x)),c);
}

);

static const char *perturbation_opencl_softfloat_49_6_1 = STR(

{const sfcomplex X2 = sfc_sqr(X);
dn=sfc_add(sfc_mul(sfc_mul(sfc_add(sfc_muli(A,2),sfc_mul(sfc_imul(6,X2),X2)),X),d),d0);
}

{const sfcomplex x2 = sfc_sqr(x);
xn=sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_add(sfc_mul(A,sfc_add(sfc_mul(sfc_imul(2,X),x),x2)),sfc_mul(sfc_imul(6,sfc_powi(X,5)),x)),sfc_mul(sfc_imul(15,sfc_powi(X,4)),x2)),sfc_mul(sfc_imul(20,sfc_powi(X,3)),sfc_mul(x2,x))),sfc_mul(sfc_imul(15,sfc_powi(X,2)),sfc_powi(x2,2))),sfc_mul(sfc_imul(6,X),sfc_mul(sfc_mul(x2,x2),x))),sfc_powi(x2,3)),c);
}

);

static const char *perturbation_opencl_softfloat_50_6_1 = STR(

{const sfcomplex X2 = sfc_sqr(X);
dn=sfc_add(sfc_mul(sfc_mul(sfc_sub(sfc_muli(A,2),sfc_mul(sfc_imul(6,X2),X2)),X),d),d0);
}

{xn=sfc_add(sfc_sub(sfc_sub(sfc_sub(sfc_sub(sfc_sub(sfc_sub(sfc_mul(A,sfc_add(sfc_mul(sfc_imul(2,X),x),sfc_powi(x,2))),sfc_mul(sfc_imul(6,sfc_powi(X,5)),x)),sfc_mul(sfc_imul(15,sfc_powi(X,4)),sfc_powi(x,2))),sfc_mul(sfc_imul(20,sfc_powi(X,3)),sfc_powi(x,3))),sfc_mul(sfc_imul(15,sfc_powi(X,2)),sfc_powi(x,4))),sfc_mul(sfc_imul(6,X),sfc_powi(x,5))),sfc_powi(x,6)),c);
}

);

static const char *perturbation_opencl_softfloat_51_4_1 = STR(

{dxan=sf_add(sf_imul(2,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(2,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr))),sf_mul(Xxr,dxa))),sf_add(sf_imul(-2,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(-2,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr))),sf_mul(Xxi,dya))),sf_add(sf_imul(2,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dya,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(Xxi,dxa))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(Xxr,dya))),sf_add(sf_imul(-4,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr))))))),sf_add(sf_imul(-4,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxr))))))),daa))))))))));
dxbn=sf_add(sf_imul(2,sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(2,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr))),sf_mul(Xxr,dxb))),sf_add(sf_imul(-2,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(-2,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr))),sf_mul(Xxi,dyb))),sf_add(sf_imul(2,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dyb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(Xxi,dxb))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(Xxr,dyb))),sf_add(sf_imul(-4,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr))))))),sf_add(sf_imul(-4,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxr))))))),dab))))))))));
dyan=sf_add(sf_imul(2,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr))),sf_mul(Xxi,dxa))),sf_add(sf_imul(2,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr))),sf_mul(Xxr,dya))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr))))))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxi),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxr))))))),sf_add(sf_imul(-2,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxa,sf_sgn(Xxr))))))),sf_add(sf_imul(-2,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxr))))))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(Xxr,dxa))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(Xxi,dya))),sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxa,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))))),dba))))))))));
dybn=sf_add(sf_imul(2,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr))),sf_mul(Xxi,dxb))),sf_add(sf_imul(2,sf_mul(sf_abs(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr))),sf_mul(Xxr,dyb))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr))))))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxi),sf_mul(Xxr,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxr))))))),sf_add(sf_imul(-2,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxi,sf_mul(dxb,sf_sgn(Xxr))))))),sf_add(sf_imul(-2,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxr))))))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(Xxr,dxb))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(Xxi,dyb))),sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,sf_mul(dxb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_sgn(sf_add(sf_imul(-1,sf_mul(Xxi,Xxi)),sf_mul(Xxr,Xxr)))))))),dbb))))))))));
}

{const softfloat Xr2 = sf_sqr(Xr);
const softfloat Xi2 = sf_sqr(Xi);
const softfloat xr2 = sf_sqr(xr);
const softfloat xi2 = sf_sqr(xi);
xrn=sf_add(sf_sub(sf_sub(sf_add(sf_mul(sf_sub(Xr2,Xi2),sf_diffabs(sf_sub(Xr2,Xi2),sf_sub(sf_sub(sf_add(sf_mul(sf_imul(2,Xr),xr),xr2),sf_mul(sf_imul(2,Xi),xi)),xi2))),sf_mul(sf_sub(sf_sub(sf_add(sf_mul(sf_imul(2,Xr),xr),xr2),sf_mul(sf_imul(2,Xi),xi)),xi2),sf_abs(sf_sub(sf_sub(sf_sub(sf_add(sf_add(Xr2,sf_mul(sf_imul(2,Xr),xr)),xr2),Xi2),sf_mul(sf_imul(2,Xi),xi)),xi2)))),sf_mul(sf_mul(sf_imul(2,Xr),Xi),sf_diffabs(sf_mul(sf_imul(2,Xr),Xi),sf_add(sf_add(sf_mul(sf_imul(2,Xr),xi),sf_mul(sf_imul(2,xr),Xi)),sf_mul(sf_imul(2,xr),xi))))),sf_mul(sf_add(sf_add(sf_mul(sf_imul(2,Xr),xi),sf_mul(sf_imul(2,xr),Xi)),sf_mul(sf_imul(2,xr),xi)),sf_abs(sf_add(sf_add(sf_add(sf_mul(sf_imul(2,Xr),Xi),sf_mul(sf_imul(2,Xr),xi)),sf_mul(sf_imul(2,xr),Xi)),sf_mul(sf_imul(2,xr),xi))))),cr);
xin=sf_add(sf_add(sf_add(sf_add(sf_mul(sf_sub(Xr2,Xi2),sf_diffabs(sf_mul(sf_imul(2,Xr),Xi),sf_add(sf_add(sf_mul(sf_imul(2,Xr),xi),sf_mul(sf_imul(2,xr),Xi)),sf_mul(sf_imul(2,xr),xi)))),sf_mul(sf_sub(sf_sub(sf_add(sf_mul(sf_imul(2,Xr),xr),xr2),sf_mul(sf_imul(2,Xi),xi)),xi2),sf_abs(sf_add(sf_add(sf_add(sf_mul(sf_imul(2,Xr),Xi),sf_mul(sf_imul(2,Xr),xi)),sf_mul(sf_imul(2,xr),Xi)),sf_mul(sf_imul(2,xr),xi))))),sf_mul(sf_mul(sf_imul(2,Xr),Xi),sf_diffabs(sf_sub(Xr2,Xi2),sf_sub(sf_sub(sf_add(sf_mul(sf_imul(2,Xr),xr),xr2),sf_mul(sf_imul(2,Xi),xi)),xi2)))),sf_mul(sf_add(sf_add(sf_mul(sf_imul(2,Xr),xi),sf_mul(sf_imul(2,xr),Xi)),sf_mul(sf_imul(2,xr),xi)),sf_abs(sf_sub(sf_sub(sf_add(sf_add(sf_sub(Xr2,Xi2),sf_mul(sf_imul(2,Xr),xr)),xr2),sf_mul(sf_imul(2,Xi),xi)),xi2)))),ci);
}

);

static const char *perturbation_opencl_softfloat_52_2_1 = STR(

{dxan=sf_add(sf_add(sf_imul(-2,sf_mul(Xxi,dya)),sf_imul(2,sf_mul(Xxr,dxa))),daa);
dxbn=sf_add(sf_add(sf_imul(-2,sf_mul(Xxi,dyb)),sf_imul(2,sf_mul(Xxr,dxb))),dab);
dyan=sf_add(sf_add(sf_imul(2,sf_mul(Xxi,sf_mul(dxa,g_FactorAR))),sf_add(sf_imul(2,sf_mul(Xxr,sf_mul(dxa,g_FactorAI))),sf_imul(2,sf_mul(Xxr,sf_mul(dya,g_FactorAR))))),dba);
dybn=sf_add(sf_add(sf_imul(2,sf_mul(Xxi,sf_mul(dxb,g_FactorAR))),sf_add(sf_imul(2,sf_mul(Xxr,sf_mul(dxb,g_FactorAI))),sf_imul(2,sf_mul(Xxr,sf_mul(dyb,g_FactorAR))))),dbb);
}

{xrn=sf_add(sf_sub(sf_sub(sf_add(sf_mul(sf_imul(2,xr),Xr),sf_mul(xr,xr)),sf_mul(sf_imul(2,Xi),xi)),sf_mul(xi,xi)),cr);
xin=sf_add(sf_add(sf_mul(sf_imul(2,Ar),sf_add(sf_add(sf_mul(Xr,xi),sf_mul(xr,Xi)),sf_mul(xr,xi))),sf_mul(Ai,sf_add(sf_mul(sf_imul(2,xr),Xr),sf_mul(xr,xr)))),ci);
}

);

static const char *perturbation_opencl_softfloat_53_2_1 = STR(

{dxan=sf_add(sf_add(sf_imul(2,sf_mul(Xxi,dya)),sf_imul(2,sf_mul(Xxr,dxa))),daa);
dxbn=sf_add(sf_add(sf_imul(2,sf_mul(Xxi,dyb)),sf_imul(2,sf_mul(Xxr,dxb))),dab);
dyan=sf_add(sf_add(sf_imul(2,sf_mul(Xxi,sf_mul(dxa,g_FactorAR))),sf_add(sf_imul(2,sf_mul(Xxr,sf_mul(dxa,g_FactorAI))),sf_imul(2,sf_mul(Xxr,sf_mul(dya,g_FactorAR))))),dba);
dybn=sf_add(sf_add(sf_imul(2,sf_mul(Xxi,sf_mul(dxb,g_FactorAR))),sf_add(sf_imul(2,sf_mul(Xxr,sf_mul(dxb,g_FactorAI))),sf_imul(2,sf_mul(Xxr,sf_mul(dyb,g_FactorAR))))),dbb);
}

{xrn=sf_add(sf_add(sf_add(sf_add(sf_mul(sf_imul(2,xr),Xr),sf_mul(xr,xr)),sf_mul(sf_imul(2,Xi),xi)),sf_mul(xi,xi)),cr);
xin=sf_add(sf_add(sf_mul(sf_imul(2,Ar),sf_add(sf_add(sf_mul(Xr,xi),sf_mul(xr,Xi)),sf_mul(xr,xi))),sf_mul(Ai,sf_add(sf_mul(sf_imul(2,xr),Xr),sf_mul(xr,xr)))),ci);
}

);

static const char *perturbation_opencl_softfloat_54_2_1 = STR(

{dxan=sf_add(daa,sf_add(sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr))),sf_add(sf_mul(dxa,sf_abs(Xxr)),sf_imul(-1,sf_add(sf_mul(Xxi,sf_mul(dya,sf_sgn(Xxi))),sf_mul(dya,sf_abs(Xxi)))))));
dxbn=sf_add(dab,sf_add(sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr))),sf_add(sf_mul(dxb,sf_abs(Xxr)),sf_imul(-1,sf_add(sf_mul(Xxi,sf_mul(dyb,sf_sgn(Xxi))),sf_mul(dyb,sf_abs(Xxi)))))));
dyan=sf_add(dba,sf_add(sf_mul(Xxi,sf_mul(dxa,sf_sgn(Xxr))),sf_add(sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxi))),sf_add(sf_mul(dxa,sf_abs(Xxi)),sf_mul(dya,sf_abs(Xxr))))));
dybn=sf_add(dbb,sf_add(sf_mul(Xxi,sf_mul(dxb,sf_sgn(Xxr))),sf_add(sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxi))),sf_add(sf_mul(dxb,sf_abs(Xxi)),sf_mul(dyb,sf_abs(Xxr))))));
}

{xrn=sf_add(cr,sf_add(sf_mul(Xr,sf_diffabs(Xr,xr)),sf_add(sf_imul(-1,sf_add(sf_mul(Xi,sf_diffabs(Xi,xi)),sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_mul(xr,sf_abs(sf_add(Xr,xr))))));
xin=sf_add(ci,sf_add(sf_mul(Xi,sf_diffabs(Xr,xr)),sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))));
}

);

static const char *perturbation_opencl_softfloat_55_3_1 = STR(

{dxan=sf_add(daa,sf_add(sf_mul(sf_abs(Xxr),sf_mul(dxa,sf_abs(Xxr))),sf_add(sf_imul(-1,sf_mul(sf_abs(Xxi),sf_mul(dxa,sf_abs(Xxi)))),sf_add(sf_imul(-2,sf_mul(sf_sgn(Xxi),sf_add(sf_mul(Xxi,sf_mul(dya,sf_abs(Xxr))),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxi)))))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxr))))),sf_imul(-2,sf_add(sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(dxa,sf_abs(Xxi)))),sf_mul(sf_abs(Xxi),sf_mul(dya,sf_abs(Xxr))))))))));
dxbn=sf_add(dab,sf_add(sf_mul(sf_abs(Xxr),sf_mul(dxb,sf_abs(Xxr))),sf_add(sf_imul(-1,sf_mul(sf_abs(Xxi),sf_mul(dxb,sf_abs(Xxi)))),sf_add(sf_imul(-2,sf_mul(sf_sgn(Xxi),sf_add(sf_mul(Xxi,sf_mul(dyb,sf_abs(Xxr))),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxi)))))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxr))))),sf_imul(-2,sf_add(sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(dxb,sf_abs(Xxi)))),sf_mul(sf_abs(Xxi),sf_mul(dyb,sf_abs(Xxr))))))))));
dyan=sf_add(dba,sf_add(sf_imul(-1,sf_mul(sf_abs(Xxi),sf_mul(dya,sf_abs(Xxi)))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(Xxi),sf_mul(dxa,sf_abs(Xxr))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxr)))),sf_mul(sf_sgn(Xxr),sf_add(sf_mul(Xxi,sf_mul(dxa,sf_abs(Xxr))),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxi)))))))),sf_add(sf_imul(-2,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(dya,sf_abs(Xxi))))),sf_mul(sf_abs(Xxr),sf_mul(dya,sf_abs(Xxr)))))));
dybn=sf_add(dbb,sf_add(sf_imul(-1,sf_mul(sf_abs(Xxi),sf_mul(dyb,sf_abs(Xxi)))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(Xxi),sf_mul(dxb,sf_abs(Xxr))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxr)))),sf_mul(sf_sgn(Xxr),sf_add(sf_mul(Xxi,sf_mul(dxb,sf_abs(Xxr))),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxi)))))))),sf_add(sf_imul(-2,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(dyb,sf_abs(Xxi))))),sf_mul(sf_abs(Xxr),sf_mul(dyb,sf_abs(Xxr)))))));
}

{xrn=sf_add(cr,sf_add(sf_mul(sf_abs(Xr),sf_add(sf_mul(Xr,sf_diffabs(Xr,xr)),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_diffabs(Xr,xr))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_diffabs(Xi,xi),sf_add(Xr,xr))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(Xi,sf_diffabs(Xr,xr)),sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_diffabs(Xi,xi),sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xr,sf_diffabs(Xr,xr))))))));
xin=sf_add(ci,sf_add(sf_mul(sf_abs(Xr),sf_add(sf_mul(Xi,sf_diffabs(Xr,xr)),sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_diffabs(Xr,xr),sf_add(Xi,xi))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(Xi,sf_diffabs(Xi,xi)),sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_diffabs(Xi,xi),sf_add(Xi,xi))))),sf_imul(2,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(Xr,sf_diffabs(Xr,xr)),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_diffabs(Xi,xi),sf_add(Xr,xr)))))))));
}

);

static const char *perturbation_opencl_softfloat_56_3_1 = STR(

{dxan=sf_add(sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_sgn(Xxr))),sf_add(sf_imul(-1,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxa,sf_sgn(Xxr)))),sf_add(sf_imul(-2,sf_mul(Xxr,sf_mul(dya,sf_abs(Xxi)))),sf_add(sf_imul(2,sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxr)))),sf_add(sf_imul(-2,sf_mul(Xxi,sf_add(sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxi))),sf_add(sf_mul(dxa,sf_abs(Xxi)),sf_mul(dya,sf_abs(Xxr)))))),daa)))));
dxbn=sf_add(sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_sgn(Xxr))),sf_add(sf_imul(-1,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxb,sf_sgn(Xxr)))),sf_add(sf_imul(-2,sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxi)))),sf_add(sf_imul(2,sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxr)))),sf_add(sf_imul(-2,sf_mul(Xxi,sf_add(sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxi))),sf_add(sf_mul(dxb,sf_abs(Xxi)),sf_mul(dyb,sf_abs(Xxr)))))),dab)))));
dyan=sf_add(sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_sgn(Xxi))),sf_add(sf_imul(-1,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dya,sf_sgn(Xxi)))),sf_add(sf_imul(2,sf_mul(Xxr,sf_add(sf_mul(dxa,sf_abs(Xxi)),sf_mul(dya,sf_abs(Xxr))))),sf_add(sf_imul(-2,sf_mul(Xxi,sf_mul(dya,sf_abs(Xxi)))),sf_add(sf_imul(2,sf_mul(Xxi,sf_add(sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr))),sf_mul(dxa,sf_abs(Xxr))))),dba)))));
dybn=sf_add(sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_sgn(Xxi))),sf_add(sf_imul(-1,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dyb,sf_sgn(Xxi)))),sf_add(sf_imul(2,sf_mul(Xxr,sf_add(sf_mul(dxb,sf_abs(Xxi)),sf_mul(dyb,sf_abs(Xxr))))),sf_add(sf_imul(-2,sf_mul(Xxi,sf_mul(dyb,sf_abs(Xxi)))),sf_add(sf_imul(2,sf_mul(Xxi,sf_add(sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr))),sf_mul(dxb,sf_abs(Xxr))))),dbb)))));
}

{xrn=sf_add(cr,sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr)),sf_add(sf_imul(-1,sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xr,xr)),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_add(sf_imul(-2,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_add(sf_imul(2,sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_imul(-2,sf_add(sf_mul(Xi,sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))))));
xin=sf_add(ci,sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi)),sf_add(sf_imul(-1,sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xi,xi)),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_add(sf_mul(Xr,sf_diffabs(Xr,xr)),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(Xr,sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))))),sf_add(sf_imul(-2,sf_mul(Xi,sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))))));
}

);

static const char *perturbation_opencl_softfloat_57_4_1 = STR(

{dxan=sf_add(daa,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(dya,sf_abs(Xxi))),sf_add(sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(dxa,sf_abs(Xxr))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(dya,sf_abs(sf_mul(Xxi,Xxi))))),sf_add(sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(dxa,sf_abs(sf_mul(Xxr,Xxr))))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(dxa,sf_abs(Xxr))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(dya,sf_abs(sf_mul(Xxr,Xxr))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(dxa,sf_abs(sf_mul(Xxi,Xxi)))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_add(sf_mul(dxa,sf_abs(Xxi)),sf_mul(dya,sf_abs(Xxr)))),sf_mul(sf_sgn(Xxi),sf_add(sf_mul(Xxr,sf_mul(dya,sf_abs(sf_mul(Xxi,Xxr)))),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxi)))))))),sf_add(sf_imul(2,sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_abs(Xxr))))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxa,sf_abs(Xxr))),sf_mul(Xxi,sf_mul(Xxr,sf_add(sf_mul(dxa,sf_abs(Xxi)),sf_mul(dya,sf_abs(Xxr)))))))),sf_add(sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(dxa,sf_abs(sf_mul(Xxi,Xxr))))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxi))))))))),sf_add(sf_imul(2,sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dya,sf_abs(Xxi))))),sf_imul(-1,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(dya,sf_abs(Xxi))))))))))))));
dxbn=sf_add(dab,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(dyb,sf_abs(Xxi))),sf_add(sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(dxb,sf_abs(Xxr))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(dyb,sf_abs(sf_mul(Xxi,Xxi))))),sf_add(sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(dxb,sf_abs(sf_mul(Xxr,Xxr))))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(dxb,sf_abs(Xxr))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(dyb,sf_abs(sf_mul(Xxr,Xxr))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(dxb,sf_abs(sf_mul(Xxi,Xxi)))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_add(sf_mul(dxb,sf_abs(Xxi)),sf_mul(dyb,sf_abs(Xxr)))),sf_mul(sf_sgn(Xxi),sf_add(sf_mul(Xxr,sf_mul(dyb,sf_abs(sf_mul(Xxi,Xxr)))),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxi)))))))),sf_add(sf_imul(2,sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxr))))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxb,sf_abs(Xxr))),sf_mul(Xxi,sf_mul(Xxr,sf_add(sf_mul(dxb,sf_abs(Xxi)),sf_mul(dyb,sf_abs(Xxr)))))))),sf_add(sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(dxb,sf_abs(sf_mul(Xxi,Xxr))))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxi))))))))),sf_add(sf_imul(2,sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dyb,sf_abs(Xxi))))),sf_imul(-1,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(dyb,sf_abs(Xxi))))))))))))));
dyan=sf_add(dba,sf_add(sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(dxa,sf_abs(Xxi))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(sf_mul(Xxr,Xxr))))),sf_add(sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(dxa,sf_abs(sf_mul(Xxr,Xxr))))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_add(sf_mul(dxa,sf_abs(Xxi)),sf_mul(dya,sf_abs(Xxr)))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(sf_mul(Xxi,Xxi))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(dxa,sf_abs(sf_mul(Xxi,Xxi)))))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(dya,sf_abs(Xxi)))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(dxa,sf_abs(Xxr))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxr))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(dxa,sf_abs(sf_mul(Xxi,Xxr)))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(dya,sf_abs(sf_mul(Xxi,Xxr))))),sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_abs(Xxi))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_abs(Xxi))))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxr)))))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_add(sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxr)))),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxi))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dya,sf_abs(Xxr)))),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxa,sf_abs(Xxi))))))),sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(dya,sf_abs(Xxr)))))))))))));
dybn=sf_add(dbb,sf_add(sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(dxb,sf_abs(Xxi))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(sf_mul(Xxr,Xxr))))),sf_add(sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(dxb,sf_abs(sf_mul(Xxr,Xxr))))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_add(sf_mul(dxb,sf_abs(Xxi)),sf_mul(dyb,sf_abs(Xxr)))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(sf_mul(Xxi,Xxi))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(dxb,sf_abs(sf_mul(Xxi,Xxi)))))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(dyb,sf_abs(Xxi)))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(dxb,sf_abs(Xxr))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxr))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(dxb,sf_abs(sf_mul(Xxi,Xxr)))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(dyb,sf_abs(sf_mul(Xxi,Xxr))))),sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxi))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxi))))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxr)))))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_add(sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxr)))),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxi))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dyb,sf_abs(Xxr)))),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxb,sf_abs(Xxi))))))),sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(dyb,sf_abs(Xxr)))))))))))));
}

{xrn=sf_add(cr,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_add(sf_mul(Xi,sf_diffabs(Xi,xi)),sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xr,sf_diffabs(Xr,xr))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))),sf_add(Xi,xi))),sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))),sf_add(Xr,xr))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_add(sf_mul(Xr,sf_diffabs(Xr,xr)),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_diffabs(Xi,xi)),sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))),sf_add(Xi,xi))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))),sf_add(Xr,xr))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_add(sf_mul(Xi,sf_diffabs(Xr,xr)),sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))),sf_add(Xr,xr))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))),sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(xr,sf_abs(sf_add(Xr,xr)))))))))));
xin=sf_add(ci,sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_diffabs(Xr,xr)),sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_mul(xi,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))),sf_add(Xr,xr))),sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))),sf_add(Xi,xi))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_add(sf_mul(Xi,sf_diffabs(Xr,xr)),sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))),sf_add(Xr,xr))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))),sf_add(Xi,xi)))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(xi,sf_abs(sf_add(Xi,xi)))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xi,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(Xr,sf_diffabs(Xr,xr))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(Xi,sf_diffabs(Xi,xi))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))),sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))))))))));
}

);

static const char *perturbation_opencl_softfloat_58_4_1 = STR(

{dxan=sf_add(sf_imul(2,sf_mul(sf_abs(Xxr),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxr))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(Xxi),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxi)))),sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxi)))))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(dya,sf_abs(Xxr)))),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxa,sf_abs(Xxr)))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(Xxi),sf_mul(Xxi,sf_mul(dya,sf_abs(Xxi)))),sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dya,sf_abs(Xxi)))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_abs(Xxi),sf_add(sf_mul(Xxi,sf_mul(dxa,sf_abs(Xxr))),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxr))))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_abs(Xxr))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxi)))))))),daa))))));
dxbn=sf_add(sf_imul(2,sf_mul(sf_abs(Xxr),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxr))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(Xxi),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxi)))),sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxi)))))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(dyb,sf_abs(Xxr)))),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxb,sf_abs(Xxr)))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(Xxi),sf_mul(Xxi,sf_mul(dyb,sf_abs(Xxi)))),sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dyb,sf_abs(Xxi)))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_abs(Xxi),sf_add(sf_mul(Xxi,sf_mul(dxb,sf_abs(Xxr))),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxr))))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxr))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxi)))))))),dab))))));
dyan=sf_add(sf_imul(2,sf_mul(sf_abs(Xxr),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxr))))),sf_add(sf_imul(-2,sf_mul(sf_abs(Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxi))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(dxa,sf_abs(Xxr)))),sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxr)))))),sf_add(sf_imul(-2,sf_mul(sf_abs(Xxi),sf_mul(Xxi,sf_mul(dxa,sf_abs(Xxi))))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxi))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dya,sf_abs(Xxr)))),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxa,sf_abs(Xxi)))))),sf_add(sf_imul(4,sf_mul(sf_abs(Xxi),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxr))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_abs(Xxi),sf_mul(Xxi,sf_mul(dya,sf_abs(Xxr)))),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_abs(Xxi))))))),sf_add(sf_imul(4,sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxr)))))),dba)))))))));
dybn=sf_add(sf_imul(2,sf_mul(sf_abs(Xxr),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxr))))),sf_add(sf_imul(-2,sf_mul(sf_abs(Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxi))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(dxb,sf_abs(Xxr)))),sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxr)))))),sf_add(sf_imul(-2,sf_mul(sf_abs(Xxi),sf_mul(Xxi,sf_mul(dxb,sf_abs(Xxi))))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxi))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dyb,sf_abs(Xxr)))),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxb,sf_abs(Xxi)))))),sf_add(sf_imul(4,sf_mul(sf_abs(Xxi),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxr))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_abs(Xxi),sf_mul(Xxi,sf_mul(dyb,sf_abs(Xxr)))),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxi))))))),sf_add(sf_imul(4,sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxr)))))),dbb)))))))));
}

{xrn=sf_add(cr,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xi,xi)),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(Xr),sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr)),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_diffabs(Xi,xi),sf_add(sf_mul(Xi,Xi),sf_mul(xi,xi)))),sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi)),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(Xr),sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xr,xr)),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_diffabs(Xi,xi),sf_add(sf_mul(Xr,Xr),sf_mul(xr,xr)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_diffabs(Xr,xr),sf_add(sf_mul(Xi,Xi),sf_mul(xi,xi)))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(Xr),sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(xr,sf_diffabs(Xr,xr)))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(xr,sf_diffabs(Xi,xi)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(xi,sf_diffabs(Xr,xr)))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(xi,sf_diffabs(Xi,xi)))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(Xi,sf_add(sf_mul(Xr,sf_diffabs(Xr,xr)),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xr,xr)))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_mul(sf_diffabs(Xi,xi),sf_add(Xr,xr))),sf_add(sf_mul(Xr,sf_mul(xi,sf_diffabs(Xi,xi))),sf_mul(xi,sf_mul(xr,sf_diffabs(Xi,xi)))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(xr,xr),sf_diffabs(Xr,xr)))))))))))));
xin=sf_add(ci,sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))),sf_add(sf_mul(sf_abs(Xr),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xi,sf_mul(xr,sf_diffabs(Xr,xr))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xi,sf_mul(xr,sf_diffabs(Xi,xi)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(xi,xi),sf_diffabs(Xi,xi)))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(Xr),sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(xi,sf_diffabs(Xr,xr)))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(xi,sf_diffabs(Xi,xi)))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr))),sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_mul(xr,sf_diffabs(Xr,xr))),sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi))))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(xr,sf_diffabs(Xi,xi))))),sf_add(sf_imul(2,sf_mul(sf_mul(Xi,sf_mul(Xr,sf_diffabs(Xr,xr))),sf_add(sf_abs(Xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xr,xr)),sf_mul(Xi,sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(Xi,xi)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xi,xi)))))),sf_add(sf_imul(4,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(xr,sf_diffabs(Xi,xi)))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(xi,sf_diffabs(Xi,xi)))))),sf_imul(2,sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi)))))))))))))));
}

);

static const char *perturbation_opencl_softfloat_59_4_1 = STR(

{dxan=sf_add(sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dya,sf_sgn(Xxi)))),sf_add(sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_sgn(Xxr)))),sf_add(sf_imul(-3,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxi)))),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(dya,sf_abs(Xxi))),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_add(sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr))),sf_mul(dxa,sf_abs(Xxr)))),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_sgn(Xxi)))))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxr,sf_add(sf_mul(dxa,sf_abs(Xxi)),sf_mul(dya,sf_abs(Xxr)))))),daa))))));
dxbn=sf_add(sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dyb,sf_sgn(Xxi)))),sf_add(sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_sgn(Xxr)))),sf_add(sf_imul(-3,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxi)))),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(dyb,sf_abs(Xxi))),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_add(sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr))),sf_mul(dxb,sf_abs(Xxr)))),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_sgn(Xxi)))))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxr,sf_add(sf_mul(dxb,sf_abs(Xxi)),sf_mul(dyb,sf_abs(Xxr)))))),dab))))));
dyan=sf_add(sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_sgn(Xxi)))),sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxa,sf_sgn(Xxr))))),sf_add(sf_imul(3,sf_mul(sf_mul(Xxr,Xxr),sf_add(sf_mul(dxa,sf_abs(Xxi)),sf_mul(dya,sf_abs(Xxr))))),sf_add(sf_imul(-3,sf_mul(sf_mul(Xxi,Xxi),sf_add(sf_mul(dxa,sf_abs(Xxi)),sf_mul(dya,sf_abs(Xxr))))),sf_add(sf_imul(3,sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_sgn(Xxr))))),sf_add(sf_imul(-3,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxi))))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_abs(Xxi))))),sf_add(sf_imul(6,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxr))))),dba))))))));
dybn=sf_add(sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_sgn(Xxi)))),sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxb,sf_sgn(Xxr))))),sf_add(sf_imul(3,sf_mul(sf_mul(Xxr,Xxr),sf_add(sf_mul(dxb,sf_abs(Xxi)),sf_mul(dyb,sf_abs(Xxr))))),sf_add(sf_imul(-3,sf_mul(sf_mul(Xxi,Xxi),sf_add(sf_mul(dxb,sf_abs(Xxi)),sf_mul(dyb,sf_abs(Xxr))))),sf_add(sf_imul(3,sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_sgn(Xxr))))),sf_add(sf_imul(-3,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxi))))),sf_add(sf_imul(-6,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxi))))),sf_add(sf_imul(6,sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxr))))),dbb))))))));
}

{xrn=sf_add(cr,sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xi,xi))),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr))),sf_add(sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(3,sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_imul(-3,sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_add(sf_imul(3,sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_imul(-3,sf_add(sf_mul(Xi,sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi)),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(3,sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))),sf_add(sf_imul(-3,sf_mul(sf_mul(Xi,Xi),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_imul(3,sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_add(sf_imul(-3,sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_diffabs(Xr,xr)))),sf_add(sf_imul(-6,sf_add(sf_mul(Xi,sf_add(sf_mul(Xr,sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))))))))))))))));
xin=sf_add(ci,sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi))),sf_add(sf_imul(-1,sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xr,xr))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(3,sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_imul(-3,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_add(sf_imul(3,sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))),sf_add(sf_imul(-3,sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))),sf_add(sf_imul(3,sf_add(sf_mul(Xi,sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr)),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_mul(Xr,Xr),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(6,sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(-6,sf_mul(Xi,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(6,sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(-6,sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))))))))))))));
}

);

static const char *perturbation_opencl_softfloat_60_5_1 = STR(

{dxan=sf_add(daa,sf_add(sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_mul(dxa,sf_abs(Xxi)),sf_mul(dya,sf_abs(Xxr)))),sf_add(sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(dxa,sf_abs(Xxr))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi)))))),sf_add(sf_mul(sf_sgn(Xxr),sf_add(sf_mul(Xxi,sf_mul(dxa,sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))))),sf_mul(Xxr,sf_mul(dxa,sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))))))),sf_add(sf_imul(-1,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(dya,sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(dya,sf_abs(Xxr)))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr)),sf_mul(dya,sf_abs(Xxi)))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr)),sf_mul(dxa,sf_abs(Xxr))),sf_add(sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(dxa,sf_abs(Xxi))),sf_add(sf_mul(sf_sgn(Xxi),sf_add(sf_mul(Xxr,sf_mul(dya,sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxi))))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(dxa,sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr))))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(dya,sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr))))),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr)))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxr)))))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxr)))))),sf_mul(sf_sgn(Xxr),sf_add(sf_mul(Xxi,sf_mul(dxa,sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxi)))))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_add(sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dya,sf_abs(Xxr)))),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxi))))))),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxa,sf_abs(Xxi)))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxr)))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxi)))))))),sf_add(sf_imul(6,sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxi))))))),sf_add(sf_imul(-6,sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxr))))))),sf_imul(-1,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(dya,sf_abs(Xxi)))))))))))))))))));
dxbn=sf_add(dab,sf_add(sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_add(sf_mul(dxb,sf_abs(Xxi)),sf_mul(dyb,sf_abs(Xxr)))),sf_add(sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(dxb,sf_abs(Xxr))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi)))))),sf_add(sf_mul(sf_sgn(Xxr),sf_add(sf_mul(Xxi,sf_mul(dxb,sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))))),sf_mul(Xxr,sf_mul(dxb,sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))))))),sf_add(sf_imul(-1,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(dyb,sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(dyb,sf_abs(Xxr)))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr)),sf_mul(dyb,sf_abs(Xxi)))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr)),sf_mul(dxb,sf_abs(Xxr))),sf_add(sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(dxb,sf_abs(Xxi))),sf_add(sf_mul(sf_sgn(Xxi),sf_add(sf_mul(Xxr,sf_mul(dyb,sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxi))))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(dxb,sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr))))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(dyb,sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr))))),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr)))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxr)))))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxr)))))),sf_mul(sf_sgn(Xxr),sf_add(sf_mul(Xxi,sf_mul(dxb,sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxi)))))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_add(sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dyb,sf_abs(Xxr)))),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxi))))))),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxb,sf_abs(Xxi)))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxr)))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxi)))))))),sf_add(sf_imul(6,sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxi))))))),sf_add(sf_imul(-6,sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxr))))))),sf_imul(-1,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(dyb,sf_abs(Xxi)))))))))))))))))));
dyan=sf_add(dba,sf_add(sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(dya,sf_abs(Xxi))),sf_add(sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(dxa,sf_abs(Xxi))),sf_add(sf_mul(sf_sgn(Xxi),sf_add(sf_mul(Xxi,sf_mul(dya,sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))))),sf_mul(Xxr,sf_mul(dya,sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))))))),sf_add(sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(dxa,sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr)))))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(dxa,sf_abs(Xxr))),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(dxa,sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi)))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr)),sf_mul(dya,sf_abs(Xxr))),sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(dya,sf_abs(Xxi))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(dxa,sf_abs(Xxr)))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr)),sf_mul(dxa,sf_abs(Xxi))),sf_mul(sf_sgn(Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxr)))))),sf_mul(sf_sgn(Xxr),sf_add(sf_mul(Xxr,sf_mul(dxa,sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxi))))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_sgn(Xxi),sf_add(sf_mul(Xxi,sf_mul(dya,sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxi))))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(dxa,sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dya,sf_abs(Xxi)))))),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr)))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxr)))))),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_add(sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxa,sf_abs(Xxr)))),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxi))))))))),sf_add(sf_imul(-6,sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxi))))))),sf_add(sf_imul(6,sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxr)))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxi)))))))),sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(dya,sf_abs(Xxr)))))))))))))))))));
dybn=sf_add(dbb,sf_add(sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(dyb,sf_abs(Xxi))),sf_add(sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(dxb,sf_abs(Xxi))),sf_add(sf_mul(sf_sgn(Xxi),sf_add(sf_mul(Xxi,sf_mul(dyb,sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))))),sf_mul(Xxr,sf_mul(dyb,sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))))))),sf_add(sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(dxb,sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr)))))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(dxb,sf_abs(Xxr))),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(dxb,sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi)))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr)),sf_mul(dyb,sf_abs(Xxr))),sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(dyb,sf_abs(Xxi))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(dxb,sf_abs(Xxr)))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr)),sf_mul(dxb,sf_abs(Xxi))),sf_mul(sf_sgn(Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxr)))))),sf_mul(sf_sgn(Xxr),sf_add(sf_mul(Xxr,sf_mul(dxb,sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxi))))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_sgn(Xxi),sf_add(sf_mul(Xxi,sf_mul(dyb,sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxi))))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(dxb,sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dyb,sf_abs(Xxi)))))),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr)))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxr)))))),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_add(sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxb,sf_abs(Xxr)))),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxi))))))))),sf_add(sf_imul(-6,sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxi))))))),sf_add(sf_imul(6,sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxr)))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxi)))))))),sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(dyb,sf_abs(Xxr)))))))))))))))))));
}

{xrn=sf_add(cr,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xi,Xi))),sf_add(sf_mul(Xi,sf_diffabs(Xr,xr)),sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_mul(Xr,sf_diffabs(Xr,xr))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi)))),sf_add(Xr,xr))),sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi))))),sf_add(sf_mul(Xr,sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr))))),sf_add(sf_mul(xi,sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi))))),sf_mul(xr,sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr))))))))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_add(sf_mul(Xi,sf_diffabs(Xi,xi)),sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr)))),sf_add(Xi,xi))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xr,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr)))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(xi,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr))))))),sf_mul(xr,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr)))))))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(xi,sf_abs(sf_add(Xi,xi)))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xi,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr))))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(Xr,sf_diffabs(Xr,xr))),sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_add(sf_mul(Xi,sf_diffabs(Xr,xr)),sf_mul(Xr,sf_diffabs(Xi,xi)))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr)))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr))))))),sf_mul(Xr,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr)))))))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(Xi,sf_diffabs(Xi,xi))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr))))))))),sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_mul(xr,sf_abs(sf_add(Xr,xr))))))))))))));
xin=sf_add(ci,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xi,Xi))),sf_add(sf_mul(Xi,sf_diffabs(Xi,xi)),sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_add(sf_mul(Xi,sf_diffabs(Xr,xr)),sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_mul(xi,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(Xi,sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi))))),sf_add(sf_mul(Xr,sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr))))),sf_add(sf_mul(xi,sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi))))),sf_mul(xr,sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr))))))))),sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr)))),sf_add(Xi,xi))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xi,Xi))),sf_add(sf_mul(Xr,sf_diffabs(Xr,xr)),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi)))),sf_add(Xr,xr))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xr,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr)))))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(xi,sf_abs(sf_add(Xi,xi)))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(xi,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr))))))),sf_mul(xr,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr)))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xi,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr))))))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(Xr,sf_diffabs(Xr,xr))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr)))))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_add(sf_mul(Xi,sf_diffabs(Xr,xr)),sf_mul(Xr,sf_diffabs(Xi,xi)))),sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(Xi,sf_diffabs(Xi,xi))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(Xi,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr))))))),sf_mul(Xr,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr)))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr))))))))))),sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))))))))));
}

);

static const char *perturbation_opencl_softfloat_61_5_1 = STR(

{dxan=sf_add(sf_mul(sf_sgn(Xxr),sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxa,sf_abs(sf_mul(Xxi,Xxi)))),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(sf_mul(Xxr,Xxr)))))),sf_add(sf_imul(-1,sf_mul(sf_sgn(Xxr),sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxa,sf_abs(sf_mul(Xxr,Xxr)))),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(sf_mul(Xxi,Xxi))))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxi))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxi)))),sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxr)))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxr)))),sf_mul(sf_sgn(Xxi),sf_add(sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(sf_mul(Xxi,Xxr)))),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxi))))))))),sf_add(sf_imul(2,sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr)))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,sf_mul(dya,sf_abs(Xxr))))),sf_add(sf_imul(2,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxi,sf_mul(dya,sf_abs(Xxr))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,sf_mul(dxa,sf_abs(Xxi))))),sf_add(sf_imul(2,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxi,sf_mul(dxa,sf_abs(Xxi))))),sf_add(sf_imul(-2,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_abs(sf_mul(Xxr,Xxr))))))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_abs(sf_mul(Xxi,Xxi))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxr))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxi)))))))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxi),sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(dya,sf_abs(sf_mul(Xxi,Xxr)))),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxi)))))))),sf_add(sf_imul(-2,sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxr)))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dya,sf_abs(Xxr))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxa,sf_abs(Xxi)))))))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(Xxr,sf_add(sf_mul(dxa,sf_abs(Xxi)),sf_mul(dya,sf_abs(Xxr)))))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(Xxi,sf_mul(dya,sf_abs(Xxi))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(Xxi,sf_mul(dxa,sf_abs(Xxr)))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxr)))))),sf_add(sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_abs(sf_mul(Xxi,Xxr)))))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxi))))))))),sf_add(sf_imul(4,sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxi)))))),sf_add(sf_imul(-4,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxr))))))),daa)))))))))))))))))))));
dxbn=sf_add(sf_mul(sf_sgn(Xxr),sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxb,sf_abs(sf_mul(Xxi,Xxi)))),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(sf_mul(Xxr,Xxr)))))),sf_add(sf_imul(-1,sf_mul(sf_sgn(Xxr),sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxb,sf_abs(sf_mul(Xxr,Xxr)))),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(sf_mul(Xxi,Xxi))))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxi))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxi)))),sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxr)))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxr)))),sf_mul(sf_sgn(Xxi),sf_add(sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(sf_mul(Xxi,Xxr)))),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxi))))))))),sf_add(sf_imul(2,sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr)))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,sf_mul(dyb,sf_abs(Xxr))))),sf_add(sf_imul(2,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxi,sf_mul(dyb,sf_abs(Xxr))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,sf_mul(dxb,sf_abs(Xxi))))),sf_add(sf_imul(2,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxi,sf_mul(dxb,sf_abs(Xxi))))),sf_add(sf_imul(-2,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_abs(sf_mul(Xxr,Xxr))))))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_abs(sf_mul(Xxi,Xxi))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxr))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxi)))))))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxi),sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(dyb,sf_abs(sf_mul(Xxi,Xxr)))),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxi)))))))),sf_add(sf_imul(-2,sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxr)))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dyb,sf_abs(Xxr))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxb,sf_abs(Xxi)))))))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(Xxr,sf_add(sf_mul(dxb,sf_abs(Xxi)),sf_mul(dyb,sf_abs(Xxr)))))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(Xxi,sf_mul(dyb,sf_abs(Xxi))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(Xxi,sf_mul(dxb,sf_abs(Xxr)))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxr)))))),sf_add(sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_abs(sf_mul(Xxi,Xxr)))))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxi))))))))),sf_add(sf_imul(4,sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxi)))))),sf_add(sf_imul(-4,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxr))))))),dab)))))))))))))))))))));
dyan=sf_add(sf_mul(sf_sgn(Xxi),sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(dya,sf_abs(sf_mul(Xxi,Xxi)))),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(sf_mul(Xxr,Xxr)))))),sf_add(sf_imul(-1,sf_mul(sf_sgn(Xxi),sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(dya,sf_abs(sf_mul(Xxr,Xxr)))),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(sf_mul(Xxi,Xxi))))))),sf_add(sf_imul(2,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxr))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxr))))),sf_add(sf_imul(2,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxi))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxi))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxr)))))),sf_add(sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(sf_mul(Xxi,Xxr))))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxi)))))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,sf_mul(dya,sf_abs(Xxi))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxi,sf_mul(dya,sf_abs(Xxi)))),sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,sf_mul(dxa,sf_abs(Xxr)))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxi,sf_mul(dxa,sf_abs(Xxr))))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_abs(sf_mul(Xxr,Xxr))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxi))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_abs(sf_mul(Xxi,Xxi)))))))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxr)))))),sf_add(sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxa,sf_abs(sf_mul(Xxi,Xxr))))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxi)))))))),sf_add(sf_imul(2,sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dya,sf_abs(Xxi)))))),sf_add(sf_imul(-2,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxa,sf_abs(Xxr))))))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxi))))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxr))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(Xxi,sf_add(sf_mul(dxa,sf_abs(Xxi)),sf_mul(dya,sf_abs(Xxr))))),sf_mul(sf_sgn(Xxi),sf_add(sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_abs(sf_mul(Xxi,Xxr))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxi))))))))),sf_add(sf_imul(4,sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr)))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxr))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxi)))))))),dba)))))))))))))))))))));
dybn=sf_add(sf_mul(sf_sgn(Xxi),sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(dyb,sf_abs(sf_mul(Xxi,Xxi)))),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(sf_mul(Xxr,Xxr)))))),sf_add(sf_imul(-1,sf_mul(sf_sgn(Xxi),sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(dyb,sf_abs(sf_mul(Xxr,Xxr)))),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(sf_mul(Xxi,Xxi))))))),sf_add(sf_imul(2,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxr))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxr))))),sf_add(sf_imul(2,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxi))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxi))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxr)))))),sf_add(sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(sf_mul(Xxi,Xxr))))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxi)))))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,sf_mul(dyb,sf_abs(Xxi))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxi,sf_mul(dyb,sf_abs(Xxi)))),sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,sf_mul(dxb,sf_abs(Xxr)))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxi,sf_mul(dxb,sf_abs(Xxr))))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_abs(sf_mul(Xxr,Xxr))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxi))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_abs(sf_mul(Xxi,Xxi)))))))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxr)))))),sf_add(sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxb,sf_abs(sf_mul(Xxi,Xxr))))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxi)))))))),sf_add(sf_imul(2,sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dyb,sf_abs(Xxi)))))),sf_add(sf_imul(-2,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxb,sf_abs(Xxr))))))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxi))))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxr))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(Xxi,sf_add(sf_mul(dxb,sf_abs(Xxi)),sf_mul(dyb,sf_abs(Xxr))))),sf_mul(sf_sgn(Xxi),sf_add(sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_abs(sf_mul(Xxi,Xxr))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxi))))))))),sf_add(sf_imul(4,sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr)))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxr))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxi)))))))),dbb)))))))))))))))))))));
}

{xrn=sf_add(cr,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xr,xr)),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr))),sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))),sf_add(sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))),sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))))))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr)),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xr,xr)),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))),sf_add(sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))),sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))),sf_add(sf_imul(2,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))),sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))))),sf_add(sf_imul(2,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(xi,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(2,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(xi,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))),sf_add(sf_imul(2,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xi,sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(2,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xi,sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(xi,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xi,sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(xi,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(Xi,xi))))),sf_add(sf_imul(2,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(Xi,xi))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xi,xi))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))),sf_mul(Xi,sf_mul(Xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_add(sf_mul(Xr,sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))),sf_add(sf_mul(Xr,sf_mul(xi,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))),sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))))))),sf_add(sf_imul(4,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(Xi,sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(xi,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(Xr,xr)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))),sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))))))))))))))))))))))))))));
xin=sf_add(ci,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xi,xi)),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))),sf_add(sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))),sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))))))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi)),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xi,xi)),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))),sf_add(sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))),sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))),sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))),sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))))),sf_add(sf_imul(2,sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(2,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(xi,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(xi,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_mul(xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))),sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xi,sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))))),sf_add(sf_imul(2,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xi,sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(xi,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(Xr,xr)))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(xi,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(Xr,xr)))),sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xr,xr))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))),sf_mul(Xi,sf_mul(Xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))),sf_add(sf_imul(4,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_add(sf_mul(Xi,sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(Xi,sf_mul(sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))),sf_add(Xr,xr))),sf_mul(Xr,sf_mul(xi,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(xi,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))))),sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))))))))))))))))))))))));
}

);

static const char *perturbation_opencl_softfloat_62_5_1 = STR(

{dxan=sf_add(sf_imul(-2,sf_mul(sf_sgn(Xxi),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxi)))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dya,sf_abs(Xxr))))),sf_mul(sf_sgn(Xxr),sf_add(sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxa,sf_abs(Xxi)))),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr)))))))),sf_add(sf_imul(3,sf_mul(sf_abs(Xxr),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxi)))),sf_mul(sf_abs(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxa,sf_abs(Xxr)))))),sf_add(sf_imul(3,sf_mul(sf_abs(Xxi),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxa,sf_abs(Xxi))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxr)))),sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_abs(Xxr))))))),sf_add(sf_imul(6,sf_mul(sf_abs(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_abs(Xxi)))))),sf_add(sf_imul(-6,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxr)))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(Xxi),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dya,sf_abs(Xxr)))),sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxi))))))),sf_add(sf_imul(-6,sf_mul(sf_sgn(Xxr),sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxr)))),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxi))))))),sf_add(sf_imul(-12,sf_mul(sf_abs(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxr)))))),daa)))))))))));
dxbn=sf_add(sf_imul(-2,sf_mul(sf_sgn(Xxi),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxi)))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dyb,sf_abs(Xxr))))),sf_mul(sf_sgn(Xxr),sf_add(sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxb,sf_abs(Xxi)))),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr)))))))),sf_add(sf_imul(3,sf_mul(sf_abs(Xxr),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxi)))),sf_mul(sf_abs(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxb,sf_abs(Xxr)))))),sf_add(sf_imul(3,sf_mul(sf_abs(Xxi),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxb,sf_abs(Xxi))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxr)))),sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxr))))))),sf_add(sf_imul(6,sf_mul(sf_abs(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxi)))))),sf_add(sf_imul(-6,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxr)))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(Xxi),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dyb,sf_abs(Xxr)))),sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxi))))))),sf_add(sf_imul(-6,sf_mul(sf_sgn(Xxr),sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxr)))),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxi))))))),sf_add(sf_imul(-12,sf_mul(sf_abs(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxr)))))),dab)))))))))));
dyan=sf_add(sf_imul(2,sf_add(sf_mul(sf_sgn(Xxi),sf_add(sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dya,sf_abs(Xxi)))),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxr)))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxi))))))),sf_add(sf_imul(-2,sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxa,sf_abs(Xxr)))))),sf_add(sf_imul(3,sf_mul(sf_abs(Xxr),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxr))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxi)))),sf_mul(sf_abs(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dya,sf_abs(Xxr)))))),sf_add(sf_imul(3,sf_mul(sf_abs(Xxi),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dya,sf_abs(Xxi))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr)))),sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxr))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxi))))),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxi))))))),sf_add(sf_imul(6,sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr)))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(Xxi),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxa,sf_abs(Xxr)))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxr))))),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxi)))))))),sf_add(sf_imul(-12,sf_mul(sf_abs(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_abs(Xxr)))))),dba))))))))));
dybn=sf_add(sf_imul(2,sf_add(sf_mul(sf_sgn(Xxi),sf_add(sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dyb,sf_abs(Xxi)))),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxr)))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxi))))))),sf_add(sf_imul(-2,sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxb,sf_abs(Xxr)))))),sf_add(sf_imul(3,sf_mul(sf_abs(Xxr),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxr))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxi)))),sf_mul(sf_abs(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dyb,sf_abs(Xxr)))))),sf_add(sf_imul(3,sf_mul(sf_abs(Xxi),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dyb,sf_abs(Xxi))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr)))),sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxr))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxi))))),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxi))))))),sf_add(sf_imul(6,sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr)))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(Xxi),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxb,sf_abs(Xxr)))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxr))))),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxi)))))))),sf_add(sf_imul(-12,sf_mul(sf_abs(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxr)))))),dbb))))))))));
}

{xrn=sf_add(cr,sf_add(sf_mul(sf_abs(Xr),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr)))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xr,xr))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xi,xi))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_diffabs(Xi,xi))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(Xr),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_diffabs(Xr,xr)))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_diffabs(Xi,xi)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_diffabs(Xr,xr)))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_diffabs(Xr,xr)))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_diffabs(Xi,xi)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_diffabs(Xr,xr)))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(sf_mul(Xi,Xi),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_diffabs(Xi,xi)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(xr,sf_diffabs(Xr,xr)))))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(xr,sf_diffabs(Xi,xi))))),sf_add(sf_imul(-3,sf_mul(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_diffabs(Xr,xr))),sf_add(sf_abs(Xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_diffabs(Xi,xi)))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(Xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xr,xr)))),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_add(sf_mul(xi,sf_mul(xr,sf_diffabs(Xr,xr))),sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi)))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_diffabs(Xi,xi))),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_add(sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(xi,sf_mul(xr,sf_diffabs(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_diffabs(Xi,xi))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_diffabs(Xr,xr))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_diffabs(Xi,xi))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi)))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_diffabs(Xi,xi)))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_diffabs(Xi,xi)))),sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_diffabs(Xi,xi)))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_diffabs(Xr,xr))))))))))))))))))))))));
xin=sf_add(ci,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xi,xi))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xi,xi))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_diffabs(Xi,xi))))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(Xr),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xr,xr))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xr,xr))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_diffabs(Xr,xr))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi)))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(Xr),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_diffabs(Xr,xr)))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(Xi),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi)))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(Xr),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_diffabs(Xr,xr)))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_diffabs(Xi,xi)))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(sf_mul(xr,xr),sf_diffabs(Xr,xr)))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_diffabs(Xr,xr)))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr)))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_diffabs(Xi,xi)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr)))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi)))),sf_add(sf_mul(sf_abs(Xr),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_diffabs(Xr,xr)))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_diffabs(Xi,xi)))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_diffabs(Xi,xi)))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_add(sf_mul(xi,sf_mul(xr,sf_diffabs(Xr,xr))),sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi)))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xr,sf_add(sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_diffabs(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_diffabs(Xi,xi))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_diffabs(Xr,xr)))),sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_diffabs(Xi,xi)))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(Xr,sf_diffabs(Xr,xr)),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_diffabs(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(sf_diffabs(Xi,xi),sf_add(Xr,xr))))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_add(sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xr,xr)))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_add(sf_mul(Xr,sf_mul(xi,sf_diffabs(Xi,xi))),sf_mul(xi,sf_mul(xr,sf_diffabs(Xi,xi)))))))),sf_imul(2,sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi)))))))))))))))))))))))));
}

);

static const char *perturbation_opencl_softfloat_63_5_1 = STR(

{dxan=sf_add(sf_mul(sf_mul(dxa,sf_sgn(Xxr)),sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)))),sf_add(sf_imul(-4,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxi))))),sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr))))),sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_sgn(Xxi)))))),sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_add(sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxi))),sf_add(sf_mul(dxa,sf_abs(Xxi)),sf_mul(dya,sf_abs(Xxr))))))),sf_add(sf_imul(-6,sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_sgn(Xxr))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_add(sf_mul(dxa,sf_abs(Xxi)),sf_mul(dya,sf_abs(Xxr)))))),sf_add(sf_imul(12,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxi))))),sf_add(sf_imul(-12,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxr))))),daa)))))))));
dxbn=sf_add(sf_mul(sf_mul(dxb,sf_sgn(Xxr)),sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)))),sf_add(sf_imul(-4,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxi))))),sf_add(sf_imul(4,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr))))),sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_sgn(Xxi)))))),sf_add(sf_imul(4,sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_add(sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxi))),sf_add(sf_mul(dxb,sf_abs(Xxi)),sf_mul(dyb,sf_abs(Xxr))))))),sf_add(sf_imul(-6,sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_sgn(Xxr))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_add(sf_mul(dxb,sf_abs(Xxi)),sf_mul(dyb,sf_abs(Xxr)))))),sf_add(sf_imul(12,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxi))))),sf_add(sf_imul(-12,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxr))))),dab)))))))));
dyan=sf_add(sf_mul(sf_mul(dya,sf_sgn(Xxi)),sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)))),sf_add(sf_imul(4,sf_add(sf_mul(Xxi,sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(dya,sf_abs(Xxi))),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_sgn(Xxr)))))),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_add(sf_mul(dxa,sf_abs(Xxi)),sf_mul(dya,sf_abs(Xxr))))))),sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_add(sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr))),sf_mul(dxa,sf_abs(Xxr)))))),sf_add(sf_imul(-6,sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_sgn(Xxi))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxi))))),sf_add(sf_imul(12,sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr))))),sf_add(sf_imul(-12,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_add(sf_mul(dxa,sf_abs(Xxi)),sf_mul(dya,sf_abs(Xxr)))))),dba)))))));
dybn=sf_add(sf_mul(sf_mul(dyb,sf_sgn(Xxi)),sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)))),sf_add(sf_imul(4,sf_add(sf_mul(Xxi,sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(dyb,sf_abs(Xxi))),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_sgn(Xxr)))))),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_add(sf_mul(dxb,sf_abs(Xxi)),sf_mul(dyb,sf_abs(Xxr))))))),sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_add(sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr))),sf_mul(dxb,sf_abs(Xxr)))))),sf_add(sf_imul(-6,sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_sgn(Xxi))))),sf_add(sf_imul(-12,sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxi))))),sf_add(sf_imul(12,sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr))))),sf_add(sf_imul(-12,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_add(sf_mul(dxb,sf_abs(Xxi)),sf_mul(dyb,sf_abs(Xxr)))))),dbb)))))));
}

{xrn=sf_add(cr,sf_add(sf_mul(sf_diffabs(Xr,xr),sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi)),sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr)))),sf_add(sf_mul(sf_mul(sf_mul(xi,xi),sf_mul(xi,xi)),sf_abs(sf_add(Xr,xr))),sf_add(sf_imul(-4,sf_mul(xi,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(4,sf_add(sf_mul(Xr,sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_add(sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(-4,sf_add(sf_mul(Xi,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(4,sf_mul(Xi,sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(-4,sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi))))),sf_add(sf_imul(4,sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))))),sf_add(sf_imul(-6,sf_mul(sf_mul(xi,xi),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_imul(6,sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr)),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(6,sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_add(sf_imul(-12,sf_add(sf_mul(Xi,sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(Xr,sf_add(sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))))))),sf_add(sf_imul(12,sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-12,sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(12,sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-12,sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(12,sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-12,sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(12,sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-24,sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))))),sf_mul(sf_mul(sf_mul(xr,xr),sf_mul(xr,xr)),sf_abs(sf_add(Xr,xr)))))))))))))))))))))))));
xin=sf_add(ci,sf_add(sf_mul(sf_diffabs(Xi,xi),sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi)),sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr)))),sf_add(sf_mul(sf_mul(sf_mul(xi,xi),sf_mul(xi,xi)),sf_abs(sf_add(Xi,xi))),sf_add(sf_imul(4,sf_mul(xi,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(-4,sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(4,sf_mul(Xr,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-4,sf_mul(Xr,sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(4,sf_add(sf_mul(Xi,sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr))),sf_add(sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))))),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))))),sf_add(sf_imul(-4,sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(Xr,sf_diffabs(Xr,xr)),sf_mul(xr,sf_abs(sf_add(Xr,xr))))))),sf_add(sf_imul(4,sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-6,sf_mul(sf_mul(xi,xi),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))),sf_add(sf_imul(6,sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi)),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))),sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(6,sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))),sf_add(sf_imul(12,sf_mul(Xr,sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(-12,sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(12,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(-12,sf_mul(Xi,sf_add(sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(12,sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(-12,sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(12,sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(Xr,sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(-24,sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_mul(sf_mul(sf_mul(xr,xr),sf_mul(xr,xr)),sf_abs(sf_add(Xi,xi))))))))))))))))))))))))));
}

);

static const char *perturbation_opencl_softfloat_64_6_1 = STR(

{dxan=sf_add(daa,sf_add(sf_mul(sf_mul(dxa,sf_abs(Xxr)),sf_add(sf_abs(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi))),sf_abs(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr))))),sf_add(sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(dxa,sf_add(sf_abs(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi))),sf_abs(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr))))))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi))),sf_mul(dya,sf_abs(Xxi))),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(dya,sf_add(sf_abs(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi))),sf_abs(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr)))),sf_mul(dya,sf_abs(Xxr)))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),Xxr))),sf_mul(dya,sf_abs(Xxr)))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr)))),sf_mul(dxa,sf_abs(Xxi)))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),Xxr))),sf_mul(dxa,sf_abs(Xxi)))),sf_add(sf_imul(-4,sf_mul(sf_sgn(Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(4,sf_mul(sf_sgn(Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),Xxr))))))),sf_add(sf_imul(-4,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dya,sf_abs(Xxi))))))),sf_add(sf_imul(4,sf_mul(sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_sgn(Xxr),sf_sgn(Xxr))),sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dxa,sf_abs(Xxr))))),sf_add(sf_imul(-4,sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(dxa,sf_abs(sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(4,sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(dxa,sf_abs(sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),Xxr))))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxr)))))))),sf_mul(sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_sgn(Xxr),sf_sgn(Xxr))),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxi)))))))),sf_add(sf_imul(4,sf_add(sf_mul(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxi),sf_sgn(Xxi))),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxr)))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_add(sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(dxa,sf_abs(Xxr))),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxi))))))))))),sf_add(sf_imul(-4,sf_mul(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxi),sf_sgn(Xxi))),sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(dya,sf_abs(Xxi))))),sf_add(sf_imul(6,sf_mul(sf_abs(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,Xxr))),sf_mul(dya,sf_abs(Xxi)))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,Xxr))),sf_mul(dxa,sf_abs(Xxr))),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(dxa,sf_abs(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(6,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(dya,sf_abs(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,Xxr))))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxr))))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxi)))))))))),sf_add(sf_imul(12,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxi))))))),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxi)))))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr)))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr))))))))),sf_add(sf_imul(12,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxr)))))))),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxi))))))))),sf_imul(-1,sf_mul(sf_abs(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr))),sf_mul(dya,sf_abs(Xxi))))))))))))))))))))))))))));
dxbn=sf_add(dab,sf_add(sf_mul(sf_mul(dxb,sf_abs(Xxr)),sf_add(sf_abs(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi))),sf_abs(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr))))),sf_add(sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(dxb,sf_add(sf_abs(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi))),sf_abs(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr))))))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi))),sf_mul(dyb,sf_abs(Xxi))),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(dyb,sf_add(sf_abs(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi))),sf_abs(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr)))),sf_mul(dyb,sf_abs(Xxr)))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),Xxr))),sf_mul(dyb,sf_abs(Xxr)))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr)))),sf_mul(dxb,sf_abs(Xxi)))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),Xxr))),sf_mul(dxb,sf_abs(Xxi)))),sf_add(sf_imul(-4,sf_mul(sf_sgn(Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(4,sf_mul(sf_sgn(Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),Xxr))))))),sf_add(sf_imul(-4,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dyb,sf_abs(Xxi))))))),sf_add(sf_imul(4,sf_mul(sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_sgn(Xxr),sf_sgn(Xxr))),sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dxb,sf_abs(Xxr))))),sf_add(sf_imul(-4,sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(dxb,sf_abs(sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(4,sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(dxb,sf_abs(sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),Xxr))))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxr)))))))),sf_mul(sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_sgn(Xxr),sf_sgn(Xxr))),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxi)))))))),sf_add(sf_imul(4,sf_add(sf_mul(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxi),sf_sgn(Xxi))),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxr)))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_add(sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(dxb,sf_abs(Xxr))),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxi))))))))))),sf_add(sf_imul(-4,sf_mul(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxi),sf_sgn(Xxi))),sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(dyb,sf_abs(Xxi))))),sf_add(sf_imul(6,sf_mul(sf_abs(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,Xxr))),sf_mul(dyb,sf_abs(Xxi)))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,Xxr))),sf_mul(dxb,sf_abs(Xxr))),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(dxb,sf_abs(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(6,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(dyb,sf_abs(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,Xxr))))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxr))))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxi)))))))))),sf_add(sf_imul(12,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxi))))))),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxi)))))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr)))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr))))))))),sf_add(sf_imul(12,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxr)))))))),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxi))))))))),sf_imul(-1,sf_mul(sf_abs(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr))),sf_mul(dyb,sf_abs(Xxi))))))))))))))))))))))))))));
dyan=sf_add(dba,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi))),sf_add(sf_mul(dxa,sf_abs(Xxi)),sf_mul(dya,sf_abs(Xxr)))),sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr))),sf_mul(dxa,sf_abs(Xxi))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxr,sf_mul(dya,sf_add(sf_abs(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi))),sf_abs(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr))))))),sf_add(sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(dxa,sf_add(sf_abs(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi))),sf_abs(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr))))))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr)))),sf_mul(dya,sf_abs(Xxi)))),sf_add(sf_imul(4,sf_add(sf_mul(sf_abs(sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),Xxr))),sf_mul(dya,sf_abs(Xxi))),sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr)))),sf_mul(dxa,sf_abs(Xxr))))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),Xxr))),sf_mul(dxa,sf_abs(Xxr)))),sf_add(sf_imul(4,sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(dxa,sf_abs(sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(-4,sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(dxa,sf_abs(sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),Xxr))))))),sf_add(sf_imul(4,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dya,sf_abs(Xxr)))))),sf_mul(sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_sgn(Xxr),sf_sgn(Xxr))),sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dxa,sf_abs(Xxi)))))),sf_add(sf_imul(-4,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(dya,sf_abs(sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(4,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(dya,sf_abs(sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),Xxr))))))),sf_add(sf_imul(-4,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxi))))))))),sf_add(sf_imul(4,sf_add(sf_mul(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxi),sf_sgn(Xxi))),sf_add(sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(dya,sf_abs(Xxr))),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxi))))))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(dxa,sf_abs(Xxi)))))),sf_mul(sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_sgn(Xxr),sf_sgn(Xxr))),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr))))))))),sf_add(sf_imul(-4,sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxr))))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,Xxr))),sf_add(sf_mul(dxa,sf_abs(Xxi)),sf_mul(dya,sf_abs(Xxr)))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,Xxr)))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(dxa,sf_abs(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(-12,sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxi)))))))),sf_add(sf_imul(12,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr))))))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxr))))))),sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_add(sf_mul(dxa,sf_abs(Xxi)),sf_mul(dya,sf_abs(Xxr))))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxi)))))))))),sf_add(sf_imul(12,sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxi))))))))),sf_add(sf_imul(-12,sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxr)))))))),sf_mul(sf_abs(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr))),sf_mul(dya,sf_abs(Xxr)))))))))))))))))))))))));
dybn=sf_add(dbb,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi))),sf_add(sf_mul(dxb,sf_abs(Xxi)),sf_mul(dyb,sf_abs(Xxr)))),sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr))),sf_mul(dxb,sf_abs(Xxi))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxr,sf_mul(dyb,sf_add(sf_abs(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi))),sf_abs(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr))))))),sf_add(sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(dxb,sf_add(sf_abs(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi))),sf_abs(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr))))))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr)))),sf_mul(dyb,sf_abs(Xxi)))),sf_add(sf_imul(4,sf_add(sf_mul(sf_abs(sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),Xxr))),sf_mul(dyb,sf_abs(Xxi))),sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr)))),sf_mul(dxb,sf_abs(Xxr))))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),Xxr))),sf_mul(dxb,sf_abs(Xxr)))),sf_add(sf_imul(4,sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(dxb,sf_abs(sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(-4,sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(dxb,sf_abs(sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),Xxr))))))),sf_add(sf_imul(4,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dyb,sf_abs(Xxr)))))),sf_mul(sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_sgn(Xxr),sf_sgn(Xxr))),sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dxb,sf_abs(Xxi)))))),sf_add(sf_imul(-4,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(dyb,sf_abs(sf_mul(Xxi,sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(4,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(dyb,sf_abs(sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),Xxr))))))),sf_add(sf_imul(-4,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxi))))))))),sf_add(sf_imul(4,sf_add(sf_mul(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxi),sf_sgn(Xxi))),sf_add(sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(dyb,sf_abs(Xxr))),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxi))))))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(dxb,sf_abs(Xxi)))))),sf_mul(sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_sgn(Xxr),sf_sgn(Xxr))),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr))))))))),sf_add(sf_imul(-4,sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxr))))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,Xxr))),sf_add(sf_mul(dxb,sf_abs(Xxi)),sf_mul(dyb,sf_abs(Xxr)))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,Xxr)))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(dxb,sf_abs(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,Xxr))))))))),sf_add(sf_imul(-12,sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxi)))))))),sf_add(sf_imul(12,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr))))))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxr))))))),sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_add(sf_mul(dxb,sf_abs(Xxi)),sf_mul(dyb,sf_abs(Xxr))))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxi)))))))))),sf_add(sf_imul(12,sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxi))))))))),sf_add(sf_imul(-12,sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxr)))))))),sf_mul(sf_abs(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr))),sf_mul(dyb,sf_abs(Xxr)))))))))))))))))))))))));
}

{xrn=sf_add(cr,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi))),sf_add(sf_mul(Xr,sf_diffabs(Xr,xr)),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr))),sf_mul(Xr,sf_diffabs(Xr,xr))),sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_add(sf_diffabs(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi)),sf_add(sf_imul(4,sf_mul(Xi,sf_mul(xi,sf_add(sf_mul(Xi,Xi),sf_mul(xi,xi))))),sf_add(sf_imul(6,sf_mul(sf_mul(Xi,Xi),sf_mul(xi,xi))),sf_mul(sf_mul(xi,xi),sf_mul(xi,xi))))),sf_diffabs(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr)),sf_add(sf_imul(4,sf_mul(Xr,sf_mul(xr,sf_add(sf_mul(Xr,Xr),sf_mul(xr,xr))))),sf_add(sf_imul(6,sf_mul(sf_mul(Xr,Xr),sf_mul(xr,xr))),sf_mul(sf_mul(xr,xr),sf_mul(xr,xr)))))),sf_add(Xr,xr))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_add(sf_diffabs(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi)),sf_add(sf_imul(4,sf_mul(Xi,sf_mul(xi,sf_add(sf_mul(Xi,Xi),sf_mul(xi,xi))))),sf_add(sf_imul(6,sf_mul(sf_mul(Xi,Xi),sf_mul(xi,xi))),sf_mul(sf_mul(xi,xi),sf_mul(xi,xi))))),sf_diffabs(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr)),sf_add(sf_imul(4,sf_mul(Xr,sf_mul(xr,sf_add(sf_mul(Xr,Xr),sf_mul(xr,xr))))),sf_add(sf_imul(6,sf_mul(sf_mul(Xr,Xr),sf_mul(xr,xr))),sf_mul(sf_mul(xr,xr),sf_mul(xr,xr)))))))),sf_mul(sf_add(sf_mul(Xi,sf_diffabs(Xi,xi)),sf_mul(xi,sf_abs(sf_add(Xi,xi)))),sf_add(sf_abs(sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi)),sf_add(sf_imul(4,sf_mul(Xi,sf_mul(xi,sf_add(sf_mul(Xi,Xi),sf_mul(xi,xi))))),sf_add(sf_imul(6,sf_mul(sf_mul(Xi,Xi),sf_mul(xi,xi))),sf_mul(sf_mul(xi,xi),sf_mul(xi,xi)))))),sf_abs(sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr)),sf_add(sf_imul(4,sf_mul(Xr,sf_mul(xr,sf_add(sf_mul(Xr,Xr),sf_mul(xr,xr))))),sf_add(sf_imul(6,sf_mul(sf_mul(Xr,Xr),sf_mul(xr,xr))),sf_mul(sf_mul(xr,xr),sf_mul(xr,xr)))))))))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,sf_mul(Xr,Xr)))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),Xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xr,sf_diffabs(sf_mul(Xi,sf_mul(Xr,sf_mul(Xr,Xr))),sf_add(sf_mul(Xi,sf_mul(xr,sf_mul(xr,xr))),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),xi)),sf_add(sf_imul(3,sf_add(sf_mul(Xi,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,xr)),sf_mul(Xr,sf_mul(xi,sf_mul(xr,xr)))))),sf_mul(xi,sf_mul(xr,sf_mul(xr,xr)))))))))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xr,sf_diffabs(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),Xr)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),xr)),sf_add(sf_mul(Xr,sf_mul(xi,sf_mul(xi,xi))),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_add(Xr,xr))),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_add(Xr,xr))))),sf_mul(xi,sf_mul(sf_mul(xi,xi),xr))))))))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xi,sf_diffabs(sf_mul(Xi,sf_mul(Xr,sf_mul(Xr,Xr))),sf_add(sf_mul(Xi,sf_mul(xr,sf_mul(xr,xr))),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),xi)),sf_add(sf_imul(3,sf_add(sf_mul(Xi,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,xr)),sf_mul(Xr,sf_mul(xi,sf_mul(xr,xr)))))),sf_mul(xi,sf_mul(xr,sf_mul(xr,xr)))))))))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xi,sf_diffabs(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),Xr)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),xr)),sf_add(sf_mul(Xr,sf_mul(xi,sf_mul(xi,xi))),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_add(Xr,xr))),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_add(Xr,xr))))),sf_mul(xi,sf_mul(sf_mul(xi,xi),xr))))))))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,sf_mul(Xr,Xr)))),sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),Xr))),sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,sf_mul(Xr,Xr)))),sf_mul(Xr,sf_diffabs(Xi,xi)))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),Xr))),sf_mul(Xr,sf_diffabs(Xi,xi)))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_diffabs(sf_mul(Xi,sf_mul(Xr,sf_mul(Xr,Xr))),sf_add(sf_mul(Xi,sf_mul(xr,sf_mul(xr,xr))),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),xi)),sf_add(sf_imul(3,sf_add(sf_mul(Xi,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,xr)),sf_mul(Xr,sf_mul(xi,sf_mul(xr,xr)))))),sf_mul(xi,sf_mul(xr,sf_mul(xr,xr)))))))))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_diffabs(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),Xr)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),xr)),sf_add(sf_mul(Xr,sf_mul(xi,sf_mul(xi,xi))),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_add(Xr,xr))),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_add(Xr,xr))))),sf_mul(xi,sf_mul(sf_mul(xi,xi),xr))))))))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_diffabs(sf_mul(Xi,sf_mul(Xr,sf_mul(Xr,Xr))),sf_add(sf_mul(Xi,sf_mul(xr,sf_mul(xr,xr))),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),xi)),sf_add(sf_imul(3,sf_add(sf_mul(Xi,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,xr)),sf_mul(Xr,sf_mul(xi,sf_mul(xr,xr)))))),sf_mul(xi,sf_mul(xr,sf_mul(xr,xr)))))))))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_diffabs(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),Xr)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),xr)),sf_add(sf_mul(Xr,sf_mul(xi,sf_mul(xi,xi))),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_add(Xr,xr))),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_add(Xr,xr))))),sf_mul(xi,sf_mul(sf_mul(xi,xi),xr))))))))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,sf_mul(Xr,Xr)))),sf_mul(Xi,sf_diffabs(Xr,xr)))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),Xr))),sf_mul(Xi,sf_diffabs(Xr,xr)))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,Xr))),sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xr,sf_diffabs(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,Xr)),sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,xi)),sf_add(sf_imul(2,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,xr)),sf_add(sf_mul(Xi,sf_mul(xi,sf_add(sf_mul(Xr,Xr),sf_mul(xr,xr)))),sf_mul(Xr,sf_mul(sf_mul(xi,xi),xr))))),sf_add(sf_imul(4,sf_mul(Xi,sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(sf_mul(xi,xi),sf_mul(xr,xr))))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,Xr))),sf_mul(xi,sf_abs(sf_add(Xi,xi)))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xi,sf_diffabs(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,Xr)),sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,xi)),sf_add(sf_imul(2,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,xr)),sf_add(sf_mul(Xi,sf_mul(xi,sf_add(sf_mul(Xr,Xr),sf_mul(xr,xr)))),sf_mul(Xr,sf_mul(sf_mul(xi,xi),xr))))),sf_add(sf_imul(4,sf_mul(Xi,sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(sf_mul(xi,xi),sf_mul(xr,xr))))))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,Xr))),sf_mul(Xr,sf_diffabs(Xr,xr))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_diffabs(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,Xr)),sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,xi)),sf_add(sf_imul(2,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,xr)),sf_add(sf_mul(Xi,sf_mul(xi,sf_add(sf_mul(Xr,Xr),sf_mul(xr,xr)))),sf_mul(Xr,sf_mul(sf_mul(xi,xi),xr))))),sf_add(sf_imul(4,sf_mul(Xi,sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(sf_mul(xi,xi),sf_mul(xr,xr))))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,Xr))),sf_mul(Xi,sf_diffabs(Xi,xi))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_diffabs(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,Xr)),sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,xi)),sf_add(sf_imul(2,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,xr)),sf_add(sf_mul(Xi,sf_mul(xi,sf_add(sf_mul(Xr,Xr),sf_mul(xr,xr)))),sf_mul(Xr,sf_mul(sf_mul(xi,xi),xr))))),sf_add(sf_imul(4,sf_mul(Xi,sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(sf_mul(xi,xi),sf_mul(xr,xr))))))))))),sf_mul(sf_abs(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr))),sf_mul(xr,sf_abs(sf_add(Xr,xr)))))))))))))))))))))))))))));
xin=sf_add(ci,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi))),sf_add(sf_mul(Xi,sf_diffabs(Xr,xr)),sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr))),sf_add(sf_mul(Xi,sf_diffabs(Xr,xr)),sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_mul(xi,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_add(sf_diffabs(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi)),sf_add(sf_imul(4,sf_mul(Xi,sf_mul(xi,sf_add(sf_mul(Xi,Xi),sf_mul(xi,xi))))),sf_add(sf_imul(6,sf_mul(sf_mul(Xi,Xi),sf_mul(xi,xi))),sf_mul(sf_mul(xi,xi),sf_mul(xi,xi))))),sf_diffabs(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr)),sf_add(sf_imul(4,sf_mul(Xr,sf_mul(xr,sf_add(sf_mul(Xr,Xr),sf_mul(xr,xr))))),sf_add(sf_imul(6,sf_mul(sf_mul(Xr,Xr),sf_mul(xr,xr))),sf_mul(sf_mul(xr,xr),sf_mul(xr,xr)))))),sf_add(Xr,xr))),sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_add(sf_diffabs(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi)),sf_add(sf_imul(4,sf_mul(Xi,sf_mul(xi,sf_add(sf_mul(Xi,Xi),sf_mul(xi,xi))))),sf_add(sf_imul(6,sf_mul(sf_mul(Xi,Xi),sf_mul(xi,xi))),sf_mul(sf_mul(xi,xi),sf_mul(xi,xi))))),sf_diffabs(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr)),sf_add(sf_imul(4,sf_mul(Xr,sf_mul(xr,sf_add(sf_mul(Xr,Xr),sf_mul(xr,xr))))),sf_add(sf_imul(6,sf_mul(sf_mul(Xr,Xr),sf_mul(xr,xr))),sf_mul(sf_mul(xr,xr),sf_mul(xr,xr)))))),sf_add(Xi,xi))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xr,sf_diffabs(sf_mul(Xi,sf_mul(Xr,sf_mul(Xr,Xr))),sf_add(sf_mul(Xi,sf_mul(xr,sf_mul(xr,xr))),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),xi)),sf_add(sf_imul(3,sf_add(sf_mul(Xi,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,xr)),sf_mul(Xr,sf_mul(xi,sf_mul(xr,xr)))))),sf_mul(xi,sf_mul(xr,sf_mul(xr,xr)))))))))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xr,sf_diffabs(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),Xr)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),xr)),sf_add(sf_mul(Xr,sf_mul(xi,sf_mul(xi,xi))),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_add(Xr,xr))),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_add(Xr,xr))))),sf_mul(xi,sf_mul(sf_mul(xi,xi),xr))))))))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,sf_mul(Xr,Xr)))),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),Xr))),sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,sf_mul(Xr,Xr)))),sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),Xr))),sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xi,sf_diffabs(sf_mul(Xi,sf_mul(Xr,sf_mul(Xr,Xr))),sf_add(sf_mul(Xi,sf_mul(xr,sf_mul(xr,xr))),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),xi)),sf_add(sf_imul(3,sf_add(sf_mul(Xi,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,xr)),sf_mul(Xr,sf_mul(xi,sf_mul(xr,xr)))))),sf_mul(xi,sf_mul(xr,sf_mul(xr,xr)))))))))),sf_add(sf_imul(4,sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xi,sf_diffabs(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),Xr)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),xr)),sf_add(sf_mul(Xr,sf_mul(xi,sf_mul(xi,xi))),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_add(Xr,xr))),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_add(Xr,xr))))),sf_mul(xi,sf_mul(sf_mul(xi,xi),xr)))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_diffabs(sf_mul(Xi,sf_mul(Xr,sf_mul(Xr,Xr))),sf_add(sf_mul(Xi,sf_mul(xr,sf_mul(xr,xr))),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),xi)),sf_add(sf_imul(3,sf_add(sf_mul(Xi,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,xr)),sf_mul(Xr,sf_mul(xi,sf_mul(xr,xr)))))),sf_mul(xi,sf_mul(xr,sf_mul(xr,xr))))))))))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_diffabs(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),Xr)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),xr)),sf_add(sf_mul(Xr,sf_mul(xi,sf_mul(xi,xi))),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_add(Xr,xr))),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_add(Xr,xr))))),sf_mul(xi,sf_mul(sf_mul(xi,xi),xr))))))))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,sf_mul(Xr,Xr)))),sf_mul(Xr,sf_diffabs(Xr,xr)))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),Xr))),sf_mul(Xr,sf_diffabs(Xr,xr))),sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,sf_mul(Xr,Xr)))),sf_mul(Xi,sf_diffabs(Xi,xi))))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_diffabs(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),Xr)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),xr)),sf_add(sf_mul(Xr,sf_mul(xi,sf_mul(xi,xi))),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_add(Xr,xr))),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_add(Xr,xr))))),sf_mul(xi,sf_mul(sf_mul(xi,xi),xr))))))))),sf_add(sf_imul(-4,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_diffabs(sf_mul(Xi,sf_mul(Xr,sf_mul(Xr,Xr))),sf_add(sf_mul(Xi,sf_mul(xr,sf_mul(xr,xr))),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),xi)),sf_add(sf_imul(3,sf_add(sf_mul(Xi,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,xr)),sf_mul(Xr,sf_mul(xi,sf_mul(xr,xr)))))),sf_mul(xi,sf_mul(xr,sf_mul(xr,xr)))))))))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),Xr))),sf_mul(Xi,sf_diffabs(Xi,xi)))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,Xr))),sf_add(sf_mul(Xi,sf_diffabs(Xr,xr)),sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_diffabs(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,Xr)),sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,xi)),sf_add(sf_imul(2,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,xr)),sf_add(sf_mul(Xi,sf_mul(xi,sf_add(sf_mul(Xr,Xr),sf_mul(xr,xr)))),sf_mul(Xr,sf_mul(sf_mul(xi,xi),xr))))),sf_add(sf_imul(4,sf_mul(Xi,sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(sf_mul(xi,xi),sf_mul(xr,xr))))))),sf_add(Xr,xr))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_diffabs(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,Xr)),sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,xi)),sf_add(sf_imul(2,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,xr)),sf_add(sf_mul(Xi,sf_mul(xi,sf_add(sf_mul(Xr,Xr),sf_mul(xr,xr)))),sf_mul(Xr,sf_mul(sf_mul(xi,xi),xr))))),sf_add(sf_imul(4,sf_mul(Xi,sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(sf_mul(xi,xi),sf_mul(xr,xr))))))),sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))))))))))))))))))));
}

);

static const char *perturbation_opencl_softfloat_65_6_1 = STR(

{dxan=sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi)))))),sf_add(sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr)))))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dya,sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi)))))),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxa,sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxi))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxr,sf_add(sf_mul(dxa,sf_abs(Xxi)),sf_mul(dya,sf_abs(Xxr))))),sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxr)))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxi,sf_mul(dya,sf_abs(Xxi)))),sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(Xxi,sf_add(sf_mul(dxa,sf_abs(Xxi)),sf_mul(dya,sf_abs(Xxr))))))),sf_add(sf_imul(2,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxi,sf_mul(dxa,sf_abs(Xxr))))),sf_add(sf_imul(-2,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi)))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_sgn(Xxi),sf_add(sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dya,sf_abs(Xxi)))))),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_sgn(Xxi),sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(dya,sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))))),sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxi)))),sf_add(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)))))),sf_mul(sf_sgn(Xxr),sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxa,sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr)))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dxa,sf_abs(Xxr)))))))),sf_add(sf_imul(-3,sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr))))))),sf_add(sf_imul(3,sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(dxa,sf_abs(Xxr)))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(dya,sf_abs(Xxi))))),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr)))))))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxr))))),sf_add(sf_imul(6,sf_mul(sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr)),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxi))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr)),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxr)))),sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxi)))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr)),sf_mul(Xxi,sf_mul(dya,sf_abs(Xxr)))),sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxi,sf_mul(dya,sf_abs(Xxi)))))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxi,sf_mul(dxa,sf_abs(Xxr))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr)),sf_mul(Xxi,sf_mul(dxa,sf_abs(Xxi)))),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr)))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxr))))))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_add(sf_mul(dxa,sf_abs(Xxi)),sf_mul(dya,sf_abs(Xxr)))))))),sf_mul(sf_sgn(Xxr),sf_add(sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr)))))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxi))))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxr))))))),sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_add(sf_mul(dxa,sf_abs(Xxi)),sf_mul(dya,sf_abs(Xxr)))))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxi)))))))))),sf_add(sf_imul(12,sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxi))))))),sf_add(sf_imul(-12,sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr))))))),daa))))))))))))))))))))))));
dxbn=sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi)))))),sf_add(sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr)))))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dyb,sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi)))))),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxb,sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxi))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxr,sf_add(sf_mul(dxb,sf_abs(Xxi)),sf_mul(dyb,sf_abs(Xxr))))),sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxr)))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxi,sf_mul(dyb,sf_abs(Xxi)))),sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(Xxi,sf_add(sf_mul(dxb,sf_abs(Xxi)),sf_mul(dyb,sf_abs(Xxr))))))),sf_add(sf_imul(2,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxi,sf_mul(dxb,sf_abs(Xxr))))),sf_add(sf_imul(-2,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi)))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_sgn(Xxi),sf_add(sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dyb,sf_abs(Xxi)))))),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_sgn(Xxi),sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(dyb,sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))))),sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxi)))),sf_add(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)))))),sf_mul(sf_sgn(Xxr),sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxb,sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr)))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dxb,sf_abs(Xxr)))))))),sf_add(sf_imul(-3,sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr))))))),sf_add(sf_imul(3,sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(dxb,sf_abs(Xxr)))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(dyb,sf_abs(Xxi))))),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr)))))))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxr))))),sf_add(sf_imul(6,sf_mul(sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr)),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxi))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr)),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxr)))),sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxi)))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr)),sf_mul(Xxi,sf_mul(dyb,sf_abs(Xxr)))),sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxi,sf_mul(dyb,sf_abs(Xxi)))))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxi,sf_mul(dxb,sf_abs(Xxr))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr)),sf_mul(Xxi,sf_mul(dxb,sf_abs(Xxi)))),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr)))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxr))))))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_add(sf_mul(dxb,sf_abs(Xxi)),sf_mul(dyb,sf_abs(Xxr)))))))),sf_mul(sf_sgn(Xxr),sf_add(sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr)))))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxi))))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxr))))))),sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_add(sf_mul(dxb,sf_abs(Xxi)),sf_mul(dyb,sf_abs(Xxr)))))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxi)))))))))),sf_add(sf_imul(12,sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxi))))))),sf_add(sf_imul(-12,sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr))))))),dab))))))))))))))))))))))));
dyan=sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr)))))),sf_add(sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxa,sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi)))))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dya,sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr)))))),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi)))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxi)))),sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_add(sf_mul(dxa,sf_abs(Xxi)),sf_mul(dya,sf_abs(Xxr))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxr)))),sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(Xxi,sf_mul(dya,sf_abs(Xxi)))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxi,sf_add(sf_mul(dxa,sf_abs(Xxi)),sf_mul(dya,sf_abs(Xxr))))),sf_add(sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(Xxi,sf_mul(dxa,sf_abs(Xxr)))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-3,sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr)))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_sgn(Xxi),sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(dya,sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr)))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dya,sf_abs(Xxr)))))),sf_mul(sf_sgn(Xxr),sf_add(sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dxa,sf_abs(Xxi)))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxr)))),sf_add(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_sgn(Xxr))))),sf_mul(sf_sgn(Xxr),sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxa,sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxi))))))))),sf_add(sf_imul(3,sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(dya,sf_abs(Xxr)))))),sf_add(sf_imul(-3,sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxi))))))),sf_add(sf_imul(3,sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(dxa,sf_abs(Xxi)))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr)),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxr)))),sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxi)))))),sf_add(sf_imul(6,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxr))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr)),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxi)))),sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxi,sf_mul(dya,sf_abs(Xxr)))))),sf_add(sf_imul(6,sf_mul(sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr)),sf_mul(Xxi,sf_mul(dya,sf_abs(Xxi))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr)),sf_mul(Xxi,sf_mul(dxa,sf_abs(Xxr)))),sf_add(sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxi,sf_mul(dxa,sf_abs(Xxi)))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))))))),sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxi))))))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxi))))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr)))))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxi))))))),sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxi))))))),sf_mul(sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr)))))),sf_add(sf_sgn(Xxi),sf_sgn(Xxr)))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxr))))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxr))))))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxr)))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxi)))))))),dba))))))))))))))))))));
dybn=sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr)))))),sf_add(sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxb,sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi)))))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dyb,sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr)))))),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi)))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxi)))),sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_add(sf_mul(dxb,sf_abs(Xxi)),sf_mul(dyb,sf_abs(Xxr))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxr)))),sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(Xxi,sf_mul(dyb,sf_abs(Xxi)))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))),sf_mul(Xxi,sf_add(sf_mul(dxb,sf_abs(Xxi)),sf_mul(dyb,sf_abs(Xxr))))),sf_add(sf_mul(sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))),sf_mul(Xxi,sf_mul(dxb,sf_abs(Xxr)))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_abs(sf_mul(Xxi,sf_mul(Xxi,Xxi))))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_abs(sf_mul(Xxr,sf_mul(Xxr,Xxr))))))))))),sf_add(sf_imul(-3,sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr)))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_sgn(Xxi),sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(dyb,sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr)))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dyb,sf_abs(Xxr)))))),sf_mul(sf_sgn(Xxr),sf_add(sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dxb,sf_abs(Xxi)))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxr)))),sf_add(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_sgn(Xxr))))),sf_mul(sf_sgn(Xxr),sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxb,sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxi))))))))),sf_add(sf_imul(3,sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(dyb,sf_abs(Xxr)))))),sf_add(sf_imul(-3,sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxi))))))),sf_add(sf_imul(3,sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(dxb,sf_abs(Xxi)))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr)),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxr)))),sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxi)))))),sf_add(sf_imul(6,sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxr))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr)),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxi)))),sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxi,sf_mul(dyb,sf_abs(Xxr)))))),sf_add(sf_imul(6,sf_mul(sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr)),sf_mul(Xxi,sf_mul(dyb,sf_abs(Xxi))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr)),sf_mul(Xxi,sf_mul(dxb,sf_abs(Xxr)))),sf_add(sf_mul(sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))),sf_mul(Xxi,sf_mul(dxb,sf_abs(Xxi)))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_abs(sf_mul(Xxi,sf_mul(Xxr,Xxr))))))),sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxi))))))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxi))))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_abs(sf_mul(sf_mul(Xxi,Xxi),Xxr)))))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxi))))))),sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxi))))))),sf_mul(sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr)))))),sf_add(sf_sgn(Xxi),sf_sgn(Xxr)))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxr))))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxr))))))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxr)))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxi)))))))),dbb))))))))))))))))))));
}

{xrn=sf_add(cr,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xi,Xi))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi)),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi)))),sf_add(sf_mul(Xr,Xr),sf_mul(xr,xr)))),sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr)))),sf_add(sf_mul(Xr,Xr),sf_mul(xr,xr)))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xi,Xi))),sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xi,xi)),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xr,xr)),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi)))),sf_add(sf_mul(Xi,Xi),sf_mul(xi,xi)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr)))),sf_add(sf_mul(Xi,Xi),sf_mul(xi,xi)))))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xi,Xi))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi))))))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr)))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xi,Xi))),sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(xr,sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(xr,sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr))))))))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xi,Xi))),sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(xi,sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi))))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_mul(Xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(xi,sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr))))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xi,Xi))),sf_mul(Xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi))))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xi,Xi))),sf_mul(Xi,sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_mul(Xi,sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_mul(xi,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_add(sf_mul(xi,sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi))))),sf_mul(xr,sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr)))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(xi,sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr))))))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xi,Xi))),sf_mul(Xi,sf_mul(Xr,sf_diffabs(Xr,xr)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi))))))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr)))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))),sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr)))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr))))))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))),sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr)))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr))))))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr))),sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr)))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr))))))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xr,xr))),sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xi,xi))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xi,Xi),sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr)))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr))))))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr))))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr)))))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(Xr,sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(xr,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr))))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_add(sf_mul(xi,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr))))))),sf_mul(xr,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr))))))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(xi,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr)))))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(Xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr))))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(Xi,sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(Xi,sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_add(sf_mul(xi,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr))))))),sf_mul(xr,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr))))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(xi,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr)))))))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(Xi,sf_mul(Xr,sf_diffabs(Xr,xr)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr))))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(Xi,xi)))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr)))))))))),sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))))))))))))))))))))))))))))));
xin=sf_add(ci,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xi,Xi))),sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xr,xr)),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr)))),sf_add(sf_mul(Xr,Xr),sf_mul(xr,xr)))),sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi)))),sf_add(sf_mul(Xi,Xi),sf_mul(xi,xi)))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xi,Xi))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr)),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_add(sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xi,xi)),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr)))),sf_add(sf_mul(Xi,Xi),sf_mul(xi,xi)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi)))),sf_add(sf_mul(Xr,Xr),sf_mul(xr,xr)))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xi,Xi))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_add(sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xi,xi)))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr))))))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xi,Xi))),sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(xr,sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi))))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xi,Xi))),sf_add(sf_mul(Xi,sf_mul(xr,sf_abs(sf_add(Xi,xi)))),sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_add(sf_mul(Xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(Xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi)))))),sf_mul(Xr,sf_add(sf_mul(xi,sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi))))),sf_mul(xr,sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr))))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_mul(xr,sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr)))))),sf_mul(Xr,sf_mul(xi,sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr)))))))))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_mul(Xi,sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xi,Xi))),sf_mul(Xi,sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(xi,sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi))))))))),sf_add(sf_imul(-2,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(xi,sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr)))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xi,Xi))),sf_mul(Xi,sf_mul(Xr,sf_diffabs(Xi,xi)))),sf_add(sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_mul(Xi,sf_mul(Xr,sf_diffabs(Xr,xr)))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(sf_mul(Xi,sf_mul(Xi,Xi)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xi,Xi),xi),sf_mul(Xi,sf_mul(xi,xi)))),sf_mul(xi,sf_mul(xi,xi))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(sf_mul(Xr,sf_mul(Xr,Xr)),sf_add(sf_imul(3,sf_add(sf_mul(sf_mul(Xr,Xr),xr),sf_mul(Xr,sf_mul(xr,xr)))),sf_mul(xr,sf_mul(xr,xr))))))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr)))))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))),sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr)))))))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))),sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr)))))))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi))),sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xr,xr))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr)))))))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xi,xi))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xi,Xi),sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr))))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr))))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr)))))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(xr,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr))))))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_add(sf_mul(Xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_mul(Xr,sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_add(sf_mul(Xi,sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(Xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr)))))))),sf_mul(Xr,sf_add(sf_mul(xi,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr))))))),sf_mul(xr,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr)))))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_add(sf_mul(xi,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr))))))),sf_mul(xr,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr)))))))),sf_mul(Xr,sf_mul(xi,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr))))))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(Xi,sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(xi,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr)))))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(sf_mul(Xi,Xi),Xr)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(Xr,xr)))),sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_mul(Xr,Xr))),sf_mul(Xi,sf_mul(Xr,sf_diffabs(Xi,xi)))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(sf_mul(Xi,sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,sf_mul(Xr,xr)),sf_mul(Xr,sf_mul(xi,xr)))),sf_mul(xi,sf_mul(xr,xr))))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(Xr,sf_diffabs(sf_mul(sf_mul(Xi,Xi),Xr),sf_add(sf_mul(sf_mul(Xi,Xi),xr),sf_add(sf_mul(Xr,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xi,sf_mul(xi,sf_add(Xr,xr)))),sf_mul(sf_mul(xi,xi),xr)))))))))))),sf_mul(sf_abs(sf_mul(Xr,sf_mul(Xr,Xr))),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))))))))))))))))))))))));
}

);

static const char *perturbation_opencl_softfloat_66_6_1 = STR(

{dxan=sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dya,sf_abs(sf_mul(Xxr,Xxr)))))),sf_add(sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(sf_mul(Xxr,Xxr)))))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dya,sf_abs(sf_mul(Xxi,Xxi)))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(sf_mul(Xxi,Xxi)))))))),sf_add(sf_imul(-2,sf_mul(sf_sgn(Xxi),sf_add(sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(sf_mul(Xxi,Xxr))))),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dya,sf_abs(Xxi))))))),sf_add(sf_imul(2,sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dxa,sf_abs(Xxr))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxr)))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxi))))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_add(sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(dxa,sf_abs(Xxr))),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxr)))))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxa,sf_abs(sf_mul(Xxi,Xxr)))))))),sf_add(sf_imul(-2,sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(dya,sf_abs(Xxi))))),sf_add(sf_imul(2,sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxi))))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxi))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxi)))),sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr)))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr)))),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dya,sf_abs(Xxi)))),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(sf_mul(Xxi,Xxi)))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dya,sf_abs(Xxi)))),sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxa,sf_abs(Xxr)))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxa,sf_abs(Xxr))))),sf_add(sf_imul(-3,sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxa,sf_abs(sf_mul(Xxr,Xxr))))))),sf_add(sf_imul(3,sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxa,sf_abs(sf_mul(Xxi,Xxi))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(sf_mul(Xxr,Xxr),sf_add(sf_mul(dxa,sf_abs(Xxi)),sf_mul(dya,sf_abs(Xxr))))),sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_abs(Xxr))))))),sf_add(sf_imul(6,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_abs(Xxr)))))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxi)))))),sf_add(sf_imul(6,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxi)))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxr))))))),sf_add(sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(sf_mul(Xxi,Xxr)))))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxi))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_add(sf_mul(dxa,sf_abs(Xxi)),sf_mul(dya,sf_abs(Xxr))))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(sf_mul(Xxi,Xxr)))))),sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxi))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxi)))))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr)))))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxr)))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxi))))))))),sf_add(sf_imul(12,sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_abs(Xxi)))))),sf_add(sf_imul(-12,sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxr)))))),daa)))))))))))))))))))))))))));
dxbn=sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dyb,sf_abs(sf_mul(Xxr,Xxr)))))),sf_add(sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(sf_mul(Xxr,Xxr)))))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dyb,sf_abs(sf_mul(Xxi,Xxi)))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(sf_mul(Xxi,Xxi)))))))),sf_add(sf_imul(-2,sf_mul(sf_sgn(Xxi),sf_add(sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(sf_mul(Xxi,Xxr))))),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dyb,sf_abs(Xxi))))))),sf_add(sf_imul(2,sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dxb,sf_abs(Xxr))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxr)))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxi))))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_add(sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(dxb,sf_abs(Xxr))),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxr)))))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxb,sf_abs(sf_mul(Xxi,Xxr)))))))),sf_add(sf_imul(-2,sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(dyb,sf_abs(Xxi))))),sf_add(sf_imul(2,sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxi))))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxi))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxi)))),sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr)))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr)))),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dyb,sf_abs(Xxi)))),sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(sf_mul(Xxi,Xxi)))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dyb,sf_abs(Xxi)))),sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxb,sf_abs(Xxr)))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxb,sf_abs(Xxr))))),sf_add(sf_imul(-3,sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxb,sf_abs(sf_mul(Xxr,Xxr))))))),sf_add(sf_imul(3,sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxb,sf_abs(sf_mul(Xxi,Xxi))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(sf_mul(Xxr,Xxr),sf_add(sf_mul(dxb,sf_abs(Xxi)),sf_mul(dyb,sf_abs(Xxr))))),sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxr))))))),sf_add(sf_imul(6,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxr)))))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxi)))))),sf_add(sf_imul(6,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxi)))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxr))))))),sf_add(sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(sf_mul(Xxi,Xxr)))))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxi))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_add(sf_mul(dxb,sf_abs(Xxi)),sf_mul(dyb,sf_abs(Xxr))))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(sf_mul(Xxi,Xxr)))))),sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxi))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxi)))))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr)))))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxr)))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxi))))))))),sf_add(sf_imul(12,sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxi)))))),sf_add(sf_imul(-12,sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxr)))))),dab)))))))))))))))))))))))))));
dyan=sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(sf_mul(Xxr,Xxr)))))),sf_add(sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxa,sf_abs(sf_mul(Xxi,Xxi)))))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(sf_mul(Xxi,Xxi)))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxa,sf_abs(sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dya,sf_abs(Xxr))))),sf_add(sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(sf_mul(Xxi,Xxr)))))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dxa,sf_abs(Xxi))))))),sf_add(sf_imul(-2,sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxi))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dya,sf_abs(sf_mul(Xxi,Xxr)))))),sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(dya,sf_abs(Xxr)))),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_add(sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(dxa,sf_abs(Xxi))),sf_mul(Xxi,sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxi)))),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr)))))))))))),sf_add(sf_imul(-2,sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxr))))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxr))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxr))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxi))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxi))))),sf_add(sf_imul(3,sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(sf_mul(Xxr,Xxr))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dya,sf_abs(Xxr)))),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(sf_mul(Xxi,Xxi)))))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dya,sf_abs(Xxr))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxa,sf_abs(Xxi))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxa,sf_abs(Xxi))))),sf_add(sf_imul(-3,sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(sf_mul(Xxr,Xxr))))))),sf_add(sf_imul(3,sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(sf_mul(Xxi,Xxi))))))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxi))))),sf_add(sf_imul(6,sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr))))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_abs(Xxi)))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dya,sf_abs(Xxi))))),sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxr))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxr))))),sf_mul(sf_sgn(Xxi),sf_add(sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(sf_mul(Xxi,Xxr))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxi)))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dya,sf_abs(Xxi)))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr)))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxa,sf_abs(Xxr)))),sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxr))))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_add(sf_mul(dxa,sf_abs(Xxi)),sf_mul(dya,sf_abs(Xxr))))))),sf_add(sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxa,sf_abs(sf_mul(Xxi,Xxr)))))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxi)))))))))),sf_add(sf_imul(6,sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxi))))))),sf_add(sf_imul(-6,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxr)))))))),sf_add(sf_imul(-12,sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_add(sf_mul(dxa,sf_abs(Xxi)),sf_mul(dya,sf_abs(Xxr))))))),dba))))))))))))))))))))))))))));
dybn=sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(sf_mul(Xxr,Xxr)))))),sf_add(sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxb,sf_abs(sf_mul(Xxi,Xxi)))))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(sf_mul(Xxi,Xxi)))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxb,sf_abs(sf_mul(Xxr,Xxr)))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dyb,sf_abs(Xxr))))),sf_add(sf_mul(sf_sgn(Xxr),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(sf_mul(Xxi,Xxr)))))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dxb,sf_abs(Xxi))))))),sf_add(sf_imul(-2,sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxi))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dyb,sf_abs(sf_mul(Xxi,Xxr)))))),sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(dyb,sf_abs(Xxr)))),sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_add(sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(dxb,sf_abs(Xxi))),sf_mul(Xxi,sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxi)))),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr)))))))))))),sf_add(sf_imul(-2,sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxr))))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxr))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxr))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxi))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxi))))),sf_add(sf_imul(3,sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(sf_mul(Xxr,Xxr))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dyb,sf_abs(Xxr)))),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(sf_mul(Xxi,Xxi)))))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dyb,sf_abs(Xxr))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxb,sf_abs(Xxi))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxb,sf_abs(Xxi))))),sf_add(sf_imul(-3,sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(sf_mul(Xxr,Xxr))))))),sf_add(sf_imul(3,sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(sf_mul(Xxi,Xxi))))))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxi))))),sf_add(sf_imul(6,sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr))))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxi)))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxi))))),sf_mul(sf_abs(sf_mul(Xxr,Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxr))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxi)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxr))))),sf_mul(sf_sgn(Xxi),sf_add(sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(sf_mul(Xxi,Xxr))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxi)))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dyb,sf_abs(Xxi)))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr)))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxb,sf_abs(Xxr)))),sf_add(sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxr))))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_add(sf_mul(dxb,sf_abs(Xxi)),sf_mul(dyb,sf_abs(Xxr))))))),sf_add(sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxb,sf_abs(sf_mul(Xxi,Xxr)))))),sf_mul(sf_mul(sf_sgn(Xxr),sf_sgn(Xxr)),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxi)))))))))),sf_add(sf_imul(6,sf_mul(sf_mul(sf_sgn(Xxi),sf_sgn(Xxi)),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxi))))))),sf_add(sf_imul(-6,sf_mul(sf_sgn(Xxi),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxr)))))))),sf_add(sf_imul(-12,sf_mul(sf_abs(sf_mul(Xxi,Xxr)),sf_mul(Xxi,sf_mul(Xxr,sf_add(sf_mul(dxb,sf_abs(Xxi)),sf_mul(dyb,sf_abs(Xxr))))))),dbb))))))))))))))))))))))))))));
}

{xrn=sf_add(cr,sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xi,xi))),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xi,xi))),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr))),sf_add(sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))),sf_add(sf_imul(-2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi)))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xr,xr)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_add(sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))),sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi)))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_diffabs(Xr,xr)))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_diffabs(Xr,xr)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))))),sf_add(sf_imul(6,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_add(sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))),sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_add(sf_mul(Xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))),sf_mul(sf_mul(Xr,Xr),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xi,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_add(sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))),sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xi,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_add(sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))),sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))))))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(6,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))))))),sf_add(sf_imul(6,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))),sf_add(Xr,xr)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))))),sf_add(sf_imul(12,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(Xi,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))))),sf_add(sf_imul(12,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))))),sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))));
xin=sf_add(ci,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xr,xr))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi)))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xr,xr))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))))))),sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(Xi,xi))),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr))),sf_add(sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_add(sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))),sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))),sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr)))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))),sf_add(sf_imul(-3,sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))))))),sf_add(sf_imul(3,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_diffabs(Xi,xi))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_diffabs(Xi,xi))))),sf_add(sf_imul(-3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))),sf_add(sf_imul(3,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_add(sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_add(sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))),sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_add(sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))),sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi))))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_add(sf_mul(Xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xi,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(Xi,sf_mul(sf_mul(xr,xr),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))))),sf_add(sf_imul(6,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xi,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_add(sf_mul(sf_mul(xi,xi),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))),sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr))))))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))))),sf_add(sf_imul(6,sf_mul(sf_abs(sf_mul(Xi,Xi)),sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(-6,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_diffabs(sf_mul(Xr,Xr),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_mul(xr,xr)))))))),sf_add(sf_imul(6,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_diffabs(sf_mul(Xi,Xi),sf_add(sf_imul(2,sf_mul(Xi,xi)),sf_mul(xi,xi)))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_diffabs(Xr,xr)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_abs(sf_mul(Xi,Xr)),sf_add(sf_mul(Xi,sf_add(sf_mul(Xr,sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))),sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_add(sf_mul(Xr,sf_mul(xi,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))),sf_mul(xi,sf_mul(xr,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr)))))))))))),sf_mul(sf_abs(sf_mul(Xr,Xr)),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))))))))))))))))))))))))))))))))))))))))))))))))))))));
}

);

static const char *perturbation_opencl_softfloat_67_6_1 = STR(

{dxan=sf_add(sf_imul(-2,sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dya,sf_abs(Xxi))))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dxa,sf_abs(Xxr))))),sf_add(sf_imul(-2,sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(dya,sf_abs(Xxi))))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(dxa,sf_abs(Xxr))))),sf_add(sf_imul(4,sf_mul(sf_abs(Xxr),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr)))))),sf_add(sf_imul(-4,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),dxa)))),sf_add(sf_imul(4,sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dya,sf_abs(Xxr)))))),sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),dya))),sf_add(sf_imul(-8,sf_add(sf_mul(sf_abs(Xxi),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxr))))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxr)))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxi))))))))),sf_add(sf_imul(8,sf_add(sf_mul(sf_abs(Xxi),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxa,sf_abs(Xxr))))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxr)))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxi))))))))),sf_add(sf_imul(-12,sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxr)))))),sf_add(sf_imul(12,sf_mul(sf_abs(Xxi),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxi)))))),sf_add(sf_imul(-12,sf_mul(sf_abs(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxr)))))),sf_add(sf_imul(12,sf_add(sf_mul(sf_abs(Xxi),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxi))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxi))))))),sf_add(sf_imul(-12,sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr)))))),sf_add(sf_imul(-24,sf_mul(sf_abs(Xxi),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr)))))),sf_add(sf_imul(24,sf_mul(sf_abs(Xxi),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxr)))))),daa)))))))))))))))));
dxbn=sf_add(sf_imul(-2,sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dyb,sf_abs(Xxi))))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dxb,sf_abs(Xxr))))),sf_add(sf_imul(-2,sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(dyb,sf_abs(Xxi))))),sf_add(sf_imul(2,sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(dxb,sf_abs(Xxr))))),sf_add(sf_imul(4,sf_mul(sf_abs(Xxr),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr)))))),sf_add(sf_imul(-4,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),dxb)))),sf_add(sf_imul(4,sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dyb,sf_abs(Xxr)))))),sf_add(sf_imul(-4,sf_mul(Xxi,sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),dyb))),sf_add(sf_imul(-8,sf_add(sf_mul(sf_abs(Xxi),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxr))))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxr)))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxi))))))))),sf_add(sf_imul(8,sf_add(sf_mul(sf_abs(Xxi),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxb,sf_abs(Xxr))))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxr)))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxi))))))))),sf_add(sf_imul(-12,sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxr)))))),sf_add(sf_imul(12,sf_mul(sf_abs(Xxi),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxi)))))),sf_add(sf_imul(-12,sf_mul(sf_abs(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxr)))))),sf_add(sf_imul(12,sf_add(sf_mul(sf_abs(Xxi),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxi))))),sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxi))))))),sf_add(sf_imul(-12,sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr)))))),sf_add(sf_imul(-24,sf_mul(sf_abs(Xxi),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr)))))),sf_add(sf_imul(24,sf_mul(sf_abs(Xxi),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxr)))))),dab)))))))))))))))));
dyan=sf_add(sf_imul(2,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(dya,sf_abs(Xxr)),sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr))))),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(dxa,sf_abs(Xxi)),sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr))))))),sf_add(sf_imul(4,sf_mul(sf_abs(Xxr),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxr)))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_abs(Xxi),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxi))))),sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxa,sf_abs(Xxr))))))),sf_add(sf_imul(4,sf_mul(sf_abs(Xxi),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxa,sf_abs(Xxi)))))),sf_add(sf_imul(8,sf_mul(sf_abs(Xxi),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr)))))),sf_add(sf_imul(-8,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxi))))))),sf_add(sf_imul(8,sf_add(sf_mul(sf_abs(Xxi),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dya,sf_abs(Xxr))))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxi)))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr))))))))),sf_add(sf_imul(-8,sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxr))))))),sf_add(sf_imul(12,sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr)))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_abs(Xxi),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxi))))),sf_mul(sf_abs(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxr))))))),sf_add(sf_imul(12,sf_mul(sf_abs(Xxi),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxi)))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxr))))),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxi))))))),sf_add(sf_imul(-24,sf_mul(sf_abs(Xxi),sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxr)))),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxr))))))),dba)))))))))))));
dybn=sf_add(sf_imul(2,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(dyb,sf_abs(Xxr)),sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr))))),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(dxb,sf_abs(Xxi)),sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr))))))),sf_add(sf_imul(4,sf_mul(sf_abs(Xxr),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxr)))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_abs(Xxi),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxi))))),sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxb,sf_abs(Xxr))))))),sf_add(sf_imul(4,sf_mul(sf_abs(Xxi),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dxb,sf_abs(Xxi)))))),sf_add(sf_imul(8,sf_mul(sf_abs(Xxi),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr)))))),sf_add(sf_imul(-8,sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxi))))))),sf_add(sf_imul(8,sf_add(sf_mul(sf_abs(Xxi),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(dyb,sf_abs(Xxr))))),sf_add(sf_mul(sf_sgn(Xxi),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxi)))))),sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr))))))))),sf_add(sf_imul(-8,sf_mul(sf_sgn(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxr))))))),sf_add(sf_imul(12,sf_mul(sf_abs(Xxr),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr)))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_abs(Xxi),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxi))))),sf_mul(sf_abs(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxr))))))),sf_add(sf_imul(12,sf_mul(sf_abs(Xxi),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxi)))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_sgn(Xxi),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxr))))),sf_mul(sf_sgn(Xxr),sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxi))))))),sf_add(sf_imul(-24,sf_mul(sf_abs(Xxi),sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxr)))),sf_mul(Xxi,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxr))))))),dbb)))))))))))));
}

{xrn=sf_add(cr,sf_add(sf_mul(sf_mul(sf_mul(xi,xi),sf_mul(xi,xi)),sf_abs(sf_mul(Xr,sf_add(Xr,xr)))),sf_add(sf_mul(sf_abs(Xr),sf_mul(sf_diffabs(Xr,xr),sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi)),sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr))))),sf_add(sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_diffabs(Xr,xr),sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi)),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr)),sf_add(sf_mul(sf_mul(xi,xi),sf_mul(xi,xi)),sf_mul(sf_mul(xr,xr),sf_mul(xr,xr))))))),sf_add(sf_imul(-1,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(xr,xr),sf_mul(xr,xr))),sf_mul(sf_mul(xi,xi),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr)),sf_add(sf_mul(sf_mul(xi,xi),sf_mul(xi,xi)),sf_mul(sf_mul(xr,xr),sf_mul(xr,xr))))))),sf_add(sf_imul(-2,sf_mul(Xi,sf_mul(xi,sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr)),sf_mul(sf_mul(xr,xr),sf_mul(xr,xr)))))),sf_add(sf_imul(4,sf_add(sf_mul(sf_abs(Xr),sf_mul(Xr,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_diffabs(Xr,xr))))))),sf_add(sf_imul(-4,sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_mul(xr,xr))))),sf_add(sf_imul(4,sf_add(sf_mul(sf_abs(Xr),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_diffabs(Xr,xr))))))),sf_add(sf_imul(-4,sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xi,xi),xr)))),sf_add(sf_imul(4,sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_diffabs(Xr,xr))))))),sf_add(sf_imul(-4,sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(xr,sf_add(sf_mul(Xr,Xr),sf_mul(xr,xr)))))),sf_add(sf_imul(4,sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_diffabs(Xr,xr))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(Xr),sf_mul(sf_mul(xi,xi),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(xi,xi),sf_mul(sf_mul(xr,xr),sf_diffabs(Xr,xr)))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(xi,xi),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(xi,xi),sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xr,xr),sf_diffabs(Xr,xr)))))))),sf_add(sf_imul(-6,sf_add(sf_mul(sf_abs(Xr),sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xi,xi),sf_diffabs(Xr,xr)))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xi,xi),sf_diffabs(Xi,xi)))))),sf_add(sf_imul(-6,sf_add(sf_mul(Xi,sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_mul(xi,xi)))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xi,xi),sf_mul(xr,xr))),sf_add(sf_mul(sf_abs(Xr),sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(xr,xr),sf_diffabs(Xr,xr)))))))),sf_add(sf_imul(6,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(xi,xi),sf_diffabs(Xr,xr)))))))),sf_add(sf_imul(-6,sf_mul(sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr))),sf_add(sf_abs(Xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_imul(6,sf_mul(sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi))),sf_add(sf_abs(Xi),sf_abs(sf_add(Xi,xi))))),sf_add(sf_imul(-6,sf_add(sf_mul(Xi,sf_mul(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi)),xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(Xr,Xr),sf_mul(xr,xr))))),sf_add(sf_imul(-8,sf_add(sf_mul(sf_abs(Xi),sf_mul(xi,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xi,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi))))))),sf_add(sf_imul(8,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(Xr,sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xr,sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_diffabs(Xi,xi)))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_diffabs(Xi,xi)))))))),sf_add(sf_imul(-8,sf_add(sf_mul(Xi,sf_mul(Xr,sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,xr)),sf_mul(xi,sf_mul(xr,sf_mul(xr,xr)))))),sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(Xi,sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xr,xr))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi))))),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_diffabs(Xi,xi))))))))),sf_add(sf_imul(8,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(Xr,sf_diffabs(Xr,xr)),sf_mul(xr,sf_abs(sf_add(Xr,xr))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_mul(sf_diffabs(Xi,xi),sf_add(Xr,xr))))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_abs(Xr),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_diffabs(Xr,xr))))))),sf_add(sf_imul(12,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_diffabs(Xi,xi))))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_diffabs(Xr,xr))))))),sf_add(sf_imul(12,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi))))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_diffabs(Xr,xr))))))),sf_add(sf_imul(12,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_diffabs(Xi,xi))))))),sf_add(sf_imul(-12,sf_add(sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_mul(xr,xr)))),sf_add(sf_mul(sf_abs(Xr),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(xr,sf_diffabs(Xr,xr)))))))),sf_add(sf_imul(12,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(xr,sf_diffabs(Xi,xi))))))),sf_add(sf_imul(-15,sf_add(sf_mul(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi)),sf_mul(xi,xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(xi,xi),sf_mul(xi,xi))))),sf_add(sf_imul(-20,sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_mul(xi,xi))))),sf_add(sf_imul(-24,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_mul(Xr,sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_mul(xr,sf_diffabs(Xi,xi)))),sf_mul(Xr,sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi)))))))),sf_add(sf_imul(24,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_diffabs(Xi,xi))))))),sf_add(sf_imul(-24,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(Xr,sf_add(sf_mul(xi,sf_mul(xr,sf_diffabs(Xr,xr))),sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi))))))))),sf_add(sf_imul(24,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(Xr,sf_add(sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi)))))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_diffabs(Xi,xi)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_diffabs(Xi,xi)))))))),sf_add(sf_imul(-24,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_diffabs(Xi,xi))))))),sf_add(sf_imul(24,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xr,xr)))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(Xr,sf_mul(xi,sf_diffabs(Xi,xi))),sf_mul(xi,sf_mul(xr,sf_diffabs(Xi,xi)))))))),sf_mul(sf_mul(sf_mul(xr,xr),sf_mul(xr,xr)),sf_abs(sf_mul(Xr,sf_add(Xr,xr))))))))))))))))))))))))))))))))))))))))))))));
xin=sf_add(ci,sf_add(sf_imul(2,sf_add(sf_mul(sf_abs(sf_mul(Xi,sf_add(Xr,xr))),sf_add(sf_mul(sf_mul(xi,xi),sf_mul(xi,xi)),sf_mul(sf_mul(xr,xr),sf_mul(xr,xr)))),sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_diffabs(Xr,xr),sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi)),sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_diffabs(Xi,xi),sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi)),sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr)),sf_mul(sf_mul(xi,xi),sf_mul(xi,xi))))))))),sf_add(sf_imul(4,sf_add(sf_mul(sf_abs(Xr),sf_mul(xi,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xi,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_diffabs(Xr,xr))))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_abs(Xi),sf_mul(xi,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xi,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_diffabs(Xr,xr))))))))),sf_add(sf_imul(4,sf_add(sf_mul(sf_abs(Xi),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_diffabs(Xi,xi))))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_abs(Xr),sf_mul(Xr,sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_diffabs(Xr,xr))))))),sf_add(sf_imul(4,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xr,sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_diffabs(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_diffabs(Xr,xr))))))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_diffabs(Xi,xi))))))),sf_add(sf_imul(4,sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_diffabs(Xr,xr))))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi))))))),sf_add(sf_imul(4,sf_mul(sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr)))),sf_add(sf_abs(Xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_imul(-4,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_mul(xr,sf_diffabs(Xr,xr))))))))),sf_add(sf_imul(4,sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_mul(xr,sf_diffabs(Xi,xi)))))),sf_add(sf_imul(-4,sf_mul(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_diffabs(Xr,xr)))),sf_add(sf_abs(Xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_imul(4,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_diffabs(Xi,xi))))))),sf_add(sf_imul(8,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(Xi,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_abs(sf_add(Xr,xr)))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))))),sf_mul(Xr,sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_diffabs(Xi,xi))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_diffabs(Xi,xi))))),sf_mul(Xr,sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_diffabs(Xi,xi))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi))))))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(xi,xi),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(xi,xi),sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi)))))),sf_add(sf_imul(12,sf_add(sf_mul(sf_abs(Xr),sf_mul(Xr,sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xr,sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_diffabs(Xr,xr))))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xr,sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xr,sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi))))))),sf_add(sf_imul(12,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xr,Xr),sf_add(sf_mul(xi,sf_mul(xr,sf_diffabs(Xr,xr))),sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi)))))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(Xr,Xr),sf_add(sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_mul(xr,sf_diffabs(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_diffabs(Xr,xr)))),sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xi,xi),sf_diffabs(Xi,xi))))))))),sf_add(sf_imul(12,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_diffabs(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_diffabs(Xr,xr))))))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_diffabs(Xr,xr))))))))),sf_add(sf_imul(12,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_diffabs(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_diffabs(Xr,xr))))))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_mul(sf_abs(Xr),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_diffabs(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(xi,sf_mul(xr,sf_diffabs(Xr,xr))),sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi))))))))),sf_add(sf_imul(12,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_mul(xr,sf_diffabs(Xi,xi))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(xi,xi),sf_diffabs(Xi,xi))))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_abs(Xr),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(xi,sf_diffabs(Xr,xr))))))),sf_add(sf_imul(12,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_mul(sf_abs(sf_add(Xi,xi)),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(xi,sf_diffabs(Xi,xi))))))),sf_add(sf_imul(-12,sf_add(sf_mul(sf_abs(Xi),sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr)))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi)))))),sf_add(sf_imul(-24,sf_add(sf_mul(sf_abs(Xi),sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(Xi,sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xr,xr)))),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr)))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(xr,sf_diffabs(Xi,xi)))),sf_add(sf_mul(Xi,sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_diffabs(Xi,xi))),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_diffabs(Xi,xi))))),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_diffabs(Xi,xi))))))))),sf_add(sf_imul(-48,sf_add(sf_mul(sf_abs(Xi),sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))))),sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_diffabs(Xi,xi)))))))),sf_imul(2,sf_mul(sf_abs(sf_add(Xr,xr)),sf_mul(sf_mul(sf_mul(xr,xr),sf_mul(xr,xr)),sf_diffabs(Xi,xi)))))))))))))))))))))))))))))))))));
}

);

static const char *perturbation_opencl_softfloat_68_6_1 = STR(

{dxan=sf_add(sf_mul(Xxr,sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dxa,sf_sgn(Xxr)))),sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(dya,sf_sgn(Xxi))))),sf_add(sf_imul(-5,sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dya,sf_abs(Xxi)))),sf_add(sf_imul(5,sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dxa,sf_abs(Xxr)))),sf_add(sf_imul(-5,sf_add(sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(dya,sf_abs(Xxi))),sf_mul(Xxi,sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dya,sf_sgn(Xxi)))))),sf_add(sf_imul(5,sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_add(sf_mul(Xxr,sf_mul(dxa,sf_sgn(Xxr))),sf_mul(dxa,sf_abs(Xxr))))),sf_add(sf_imul(-10,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_sgn(Xxr)))))),sf_add(sf_imul(10,sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_sgn(Xxi)))))),sf_add(sf_imul(-20,sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_add(sf_mul(dxa,sf_abs(Xxi)),sf_mul(dya,sf_abs(Xxr))))))),sf_add(sf_imul(20,sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_add(sf_mul(dxa,sf_abs(Xxi)),sf_mul(dya,sf_abs(Xxr))))))),sf_add(sf_imul(30,sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxi))))),sf_add(sf_imul(-30,sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr))))),daa))))))))))));
dxbn=sf_add(sf_mul(Xxr,sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dxb,sf_sgn(Xxr)))),sf_add(sf_imul(-1,sf_mul(Xxi,sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(dyb,sf_sgn(Xxi))))),sf_add(sf_imul(-5,sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dyb,sf_abs(Xxi)))),sf_add(sf_imul(5,sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dxb,sf_abs(Xxr)))),sf_add(sf_imul(-5,sf_add(sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(dyb,sf_abs(Xxi))),sf_mul(Xxi,sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dyb,sf_sgn(Xxi)))))),sf_add(sf_imul(5,sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_add(sf_mul(Xxr,sf_mul(dxb,sf_sgn(Xxr))),sf_mul(dxb,sf_abs(Xxr))))),sf_add(sf_imul(-10,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_sgn(Xxr)))))),sf_add(sf_imul(10,sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_sgn(Xxi)))))),sf_add(sf_imul(-20,sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_add(sf_mul(dxb,sf_abs(Xxi)),sf_mul(dyb,sf_abs(Xxr))))))),sf_add(sf_imul(20,sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_add(sf_mul(dxb,sf_abs(Xxi)),sf_mul(dyb,sf_abs(Xxr))))))),sf_add(sf_imul(30,sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxi))))),sf_add(sf_imul(-30,sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr))))),dab))))))))))));
dyan=sf_add(sf_mul(Xxi,sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(dxa,sf_sgn(Xxr)))),sf_add(sf_mul(Xxr,sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dya,sf_sgn(Xxi)))),sf_add(sf_imul(5,sf_add(sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_add(sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxi))),sf_add(sf_mul(dxa,sf_abs(Xxi)),sf_mul(dya,sf_abs(Xxr))))),sf_add(sf_mul(Xxi,sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dxa,sf_sgn(Xxr)))),sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_add(sf_mul(dxa,sf_abs(Xxi)),sf_mul(dya,sf_abs(Xxr))))))),sf_add(sf_imul(-10,sf_add(sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_sgn(Xxr))))),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_sgn(Xxi))))))),sf_add(sf_imul(-20,sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dya,sf_abs(Xxi)))))),sf_add(sf_imul(20,sf_mul(Xxi,sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dya,sf_abs(Xxi)))),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxa,sf_abs(Xxr))))))),sf_add(sf_imul(-20,sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxa,sf_abs(Xxr)))))),sf_add(sf_imul(-30,sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_add(sf_mul(dxa,sf_abs(Xxi)),sf_mul(dya,sf_abs(Xxr)))))),dba))))))));
dybn=sf_add(sf_mul(Xxi,sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_mul(dxb,sf_sgn(Xxr)))),sf_add(sf_mul(Xxr,sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dyb,sf_sgn(Xxi)))),sf_add(sf_imul(5,sf_add(sf_mul(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxi,Xxi)),sf_add(sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxi))),sf_add(sf_mul(dxb,sf_abs(Xxi)),sf_mul(dyb,sf_abs(Xxr))))),sf_add(sf_mul(Xxi,sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_mul(dxb,sf_sgn(Xxr)))),sf_mul(sf_mul(sf_mul(Xxr,Xxr),sf_mul(Xxr,Xxr)),sf_add(sf_mul(dxb,sf_abs(Xxi)),sf_mul(dyb,sf_abs(Xxr))))))),sf_add(sf_imul(-10,sf_add(sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_sgn(Xxr))))),sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_sgn(Xxi))))))),sf_add(sf_imul(-20,sf_mul(Xxi,sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dyb,sf_abs(Xxi)))))),sf_add(sf_imul(20,sf_mul(Xxi,sf_add(sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dyb,sf_abs(Xxi)))),sf_mul(Xxr,sf_mul(sf_mul(Xxr,Xxr),sf_mul(dxb,sf_abs(Xxr))))))),sf_add(sf_imul(-20,sf_mul(Xxi,sf_mul(sf_mul(Xxi,Xxi),sf_mul(Xxr,sf_mul(dxb,sf_abs(Xxr)))))),sf_add(sf_imul(-30,sf_mul(sf_mul(Xxi,Xxi),sf_mul(sf_mul(Xxr,Xxr),sf_add(sf_mul(dxb,sf_abs(Xxi)),sf_mul(dyb,sf_abs(Xxr)))))),dbb))))))));
}

{xrn=sf_add(cr,sf_add(sf_mul(Xr,sf_mul(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr)),sf_diffabs(Xr,xr))),sf_add(sf_imul(-1,sf_add(sf_mul(Xi,sf_mul(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi)),sf_diffabs(Xi,xi))),sf_mul(xi,sf_mul(sf_mul(sf_mul(xi,xi),sf_mul(xi,xi)),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-5,sf_mul(xi,sf_mul(sf_mul(sf_mul(xr,xr),sf_mul(xr,xr)),sf_abs(sf_add(Xi,xi))))),sf_add(sf_imul(5,sf_add(sf_mul(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr)),sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_add(sf_mul(Xr,sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(sf_mul(xi,xi),sf_mul(xi,xi)),sf_mul(sf_mul(xr,xr),sf_mul(xr,xr))))),sf_mul(sf_mul(sf_mul(xi,xi),sf_mul(xi,xi)),sf_mul(xr,sf_abs(sf_add(Xr,xr))))))),sf_add(sf_imul(-5,sf_add(sf_mul(Xi,sf_add(sf_mul(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr)),sf_diffabs(Xi,xi)),sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(sf_mul(xi,xi),sf_mul(xi,xi)),sf_mul(sf_mul(xr,xr),sf_mul(xr,xr)))))),sf_mul(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr)),sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(5,sf_mul(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi)),sf_add(sf_mul(Xr,sf_diffabs(Xr,xr)),sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(-5,sf_mul(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi)),sf_mul(xi,sf_abs(sf_add(Xi,xi))))),sf_add(sf_imul(-10,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(10,sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_add(sf_mul(sf_mul(Xr,Xr),sf_add(sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))))),sf_add(sf_imul(-10,sf_add(sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr))),sf_add(sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))))),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))))),sf_add(sf_imul(10,sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi)),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(-10,sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-20,sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(20,sf_mul(Xr,sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(-20,sf_add(sf_mul(Xi,sf_mul(xi,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi)))))))),sf_add(sf_imul(20,sf_mul(Xi,sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr))))))),sf_add(sf_imul(-20,sf_mul(Xi,sf_mul(Xr,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(20,sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))))),sf_add(sf_imul(-20,sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))))),sf_add(sf_imul(20,sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(Xr,sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))))),sf_add(sf_imul(-30,sf_add(sf_mul(sf_mul(Xr,Xr),sf_add(sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))))),sf_add(sf_imul(30,sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-30,sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(30,sf_add(sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(-30,sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(30,sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(-30,sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(30,sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-60,sf_mul(Xi,sf_mul(Xr,sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))))),sf_add(sf_imul(60,sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(-60,sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))))),sf_add(sf_imul(60,sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_mul(xr,sf_mul(sf_mul(sf_mul(xr,xr),sf_mul(xr,xr)),sf_abs(sf_add(Xr,xr)))))))))))))))))))))))))))))))))))));
xin=sf_add(ci,sf_add(sf_mul(Xi,sf_mul(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi)),sf_diffabs(Xr,xr))),sf_add(sf_mul(Xr,sf_mul(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr)),sf_diffabs(Xi,xi))),sf_add(sf_mul(xi,sf_mul(sf_mul(sf_mul(xi,xi),sf_mul(xi,xi)),sf_abs(sf_add(Xr,xr)))),sf_add(sf_imul(5,sf_add(sf_mul(sf_mul(sf_mul(Xi,Xi),sf_mul(Xi,Xi)),sf_add(sf_mul(Xr,sf_diffabs(Xi,xi)),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_mul(Xi,sf_add(sf_mul(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr)),sf_diffabs(Xr,xr)),sf_mul(sf_abs(sf_add(Xr,xr)),sf_add(sf_mul(sf_mul(xi,xi),sf_mul(xi,xi)),sf_mul(sf_mul(xr,xr),sf_mul(xr,xr)))))),sf_add(sf_mul(sf_mul(sf_mul(Xr,Xr),sf_mul(Xr,Xr)),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_add(sf_mul(Xr,sf_mul(sf_abs(sf_add(Xi,xi)),sf_add(sf_mul(sf_mul(xi,xi),sf_mul(xi,xi)),sf_mul(sf_mul(xr,xr),sf_mul(xr,xr))))),sf_add(sf_mul(sf_mul(sf_mul(xi,xi),sf_mul(xi,xi)),sf_mul(xr,sf_abs(sf_add(Xi,xi)))),sf_mul(xi,sf_mul(sf_mul(sf_mul(xr,xr),sf_mul(xr,xr)),sf_abs(sf_add(Xr,xr)))))))))),sf_add(sf_imul(-10,sf_add(sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(10,sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-10,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(10,sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-10,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(10,sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(-10,sf_add(sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_add(sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xr,xr)),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_diffabs(Xi,xi)))))),sf_add(sf_imul(10,sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(20,sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))))),sf_add(sf_imul(-20,sf_mul(Xr,sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr))))))),sf_add(sf_imul(20,sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr))))))),sf_add(sf_imul(-20,sf_mul(Xi,sf_mul(xi,sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(20,sf_mul(Xi,sf_add(sf_mul(Xr,sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_add(sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))),sf_mul(xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))))),sf_mul(xi,sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))))),sf_add(sf_imul(-20,sf_mul(Xi,sf_mul(Xr,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(20,sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(-20,sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(xr,sf_abs(sf_add(Xr,xr))))))),sf_add(sf_imul(20,sf_mul(Xi,sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(xi,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(-30,sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(30,sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(-30,sf_add(sf_mul(Xi,sf_mul(sf_mul(xi,xi),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(30,sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr)))))),sf_add(sf_imul(-30,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xr,xr))))),sf_mul(Xi,sf_mul(sf_mul(Xr,Xr),sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xr,xr))))))),sf_add(sf_imul(30,sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-30,sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(30,sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(sf_mul(xi,xi),sf_abs(sf_add(Xi,xi)))))),sf_add(sf_imul(-30,sf_mul(sf_mul(Xi,Xi),sf_mul(sf_mul(Xr,Xr),sf_add(sf_mul(xi,sf_abs(sf_add(Xr,xr))),sf_mul(xr,sf_abs(sf_add(Xi,xi))))))),sf_add(sf_imul(-60,sf_add(sf_mul(sf_mul(Xi,Xi),sf_mul(Xr,sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xr,xr)))))),sf_mul(Xi,sf_add(sf_mul(sf_mul(Xr,Xr),sf_mul(xi,sf_mul(xr,sf_abs(sf_add(Xi,xi))))),sf_mul(Xr,sf_add(sf_mul(sf_mul(xi,xi),sf_mul(xr,sf_abs(sf_add(Xr,xr)))),sf_mul(xi,sf_mul(sf_mul(xr,xr),sf_abs(sf_add(Xi,xi)))))))))),sf_mul(xr,sf_mul(sf_mul(sf_mul(xr,xr),sf_mul(xr,xr)),sf_abs(sf_add(Xi,xi))))))))))))))))))))))))))))))))))));
}

);

static const char *perturbation_opencl_softfloat_69_2_1 = STR(

{dxan=sf_add(sf_imul(-2,sf_mul(Xxi,dya)),sf_add(sf_imul(2,sf_mul(Xxr,dxa)),daa));
dxbn=sf_add(sf_imul(-2,sf_mul(Xxi,dyb)),sf_add(sf_imul(2,sf_mul(Xxr,dxb)),dab));
dyan=sf_add(sf_imul(2,sf_add(sf_mul(g_FactorAI,sf_mul(Xxr,dxa)),sf_mul(sf_sgn(Xxi),sf_mul(g_FactorAR,sf_add(sf_mul(Xxi,sf_mul(dxa,sf_sgn(Xxr))),sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxr)))))))),dba);
dybn=sf_add(sf_imul(2,sf_add(sf_mul(g_FactorAI,sf_mul(Xxr,dxb)),sf_mul(sf_sgn(Xxi),sf_mul(g_FactorAR,sf_add(sf_mul(Xxi,sf_mul(dxb,sf_sgn(Xxr))),sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxr)))))))),dbb);
}

{xrn=sf_add(cr,sf_add(sf_imul(-1,sf_mul(xi,xi)),sf_add(sf_imul(2,sf_mul(Xr,xr)),sf_add(sf_imul(-2,sf_mul(Xi,xi)),sf_mul(xr,xr)))));
xin=sf_add(sf_mul(Ai,sf_mul(xr,xr)),sf_add(sf_imul(2,sf_add(sf_mul(Ai,sf_mul(Xr,xr)),sf_mul(Ar,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))),ci));
}

);

static const char *perturbation_opencl_softfloat_70_2_1 = STR(

{dxan=sf_add(sf_imul(2,sf_add(sf_mul(Xxi,dya),sf_mul(Xxr,dxa))),daa);
dxbn=sf_add(sf_imul(2,sf_add(sf_mul(Xxi,dyb),sf_mul(Xxr,dxb))),dab);
dyan=sf_add(sf_imul(2,sf_add(sf_mul(g_FactorAI,sf_mul(Xxr,dxa)),sf_mul(sf_sgn(Xxi),sf_mul(g_FactorAR,sf_add(sf_mul(Xxi,sf_mul(dxa,sf_sgn(Xxr))),sf_mul(Xxr,sf_mul(dya,sf_sgn(Xxr)))))))),dba);
dybn=sf_add(sf_imul(2,sf_add(sf_mul(g_FactorAI,sf_mul(Xxr,dxb)),sf_mul(sf_sgn(Xxi),sf_mul(g_FactorAR,sf_add(sf_mul(Xxi,sf_mul(dxb,sf_sgn(Xxr))),sf_mul(Xxr,sf_mul(dyb,sf_sgn(Xxr)))))))),dbb);
}

{xrn=sf_add(cr,sf_add(sf_mul(xi,xi),sf_add(sf_imul(2,sf_add(sf_mul(Xi,xi),sf_mul(Xr,xr))),sf_mul(xr,xr))));
xin=sf_add(sf_mul(Ai,sf_mul(xr,xr)),sf_add(sf_imul(2,sf_add(sf_mul(Ai,sf_mul(Xr,xr)),sf_mul(Ar,sf_diffabs(sf_mul(Xi,Xr),sf_add(sf_mul(Xi,xr),sf_mul(xi,sf_add(Xr,xr))))))),ci));
}

);

static const char *perturbation_opencl_softfloat_71_2_1 = STR(

{dn=sfc_add(sfc_mul(sfc_mul(sfc_imul(2,sfc_sub(Xx,A)),sfc_exp(sfc_div(sfc_imul(2,A),Xx))),d),d0);
}

{xn=sfc_add(sfc_add(sfc_mul(sfc_mul(sfc_add(x,sfc_imul(2,X)),x),sfc_exp(sfc_div(sfc_imul(2,A),Xx))),sfc_mul(sfc_mul(sfc_imul(2,sfc_powi(X,2)),sfc_sinh(sfc_div(sfc_mul(sfc_neg(A),x),sfc_mul(Xx,X)))),sfc_exp(sfc_div(sfc_mul(A,sfc_add(x,sfc_imul(2,X))),sfc_mul(Xx,X))))),c);
}

);

#endif

static const std::string perturbation_opencl_error = "#error unsupported fractal type and power\n";

extern std::string perturbation_opencl(int m_nFractalType, int m_nPower, int derivatives)
{
  switch (m_nFractalType)
  {
  
    // Mandelbrot
    case 0:
      switch (m_nPower)
      {
      
        case 2:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_r;

            o << perturbation_opencl_double_0_2_1;

            o << perturbation_opencl_double_post_r;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_0_2_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_r;

            o << perturbation_opencl_floatexp_0_2_1;

            o << perturbation_opencl_floatexp_post_r;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_0_2_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_r;

            o << perturbation_opencl_softfloat_0_2_1;

            o << perturbation_opencl_softfloat_post_r;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_0_2_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
        case 3:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_r;

            o << perturbation_opencl_double_0_3_1;

            o << perturbation_opencl_double_post_r;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_0_3_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_r;

            o << perturbation_opencl_floatexp_0_3_1;

            o << perturbation_opencl_floatexp_post_r;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_0_3_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_r;

            o << perturbation_opencl_softfloat_0_3_1;

            o << perturbation_opencl_softfloat_post_r;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_0_3_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
        case 4:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_c;

            o << perturbation_opencl_double_0_4_1;

            o << perturbation_opencl_double_post_c;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_0_4_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_c;

            o << perturbation_opencl_floatexp_0_4_1;

            o << perturbation_opencl_floatexp_post_c;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_0_4_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_c;

            o << perturbation_opencl_softfloat_0_4_1;

            o << perturbation_opencl_softfloat_post_c;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_0_4_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
        case 5:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_c;

            o << perturbation_opencl_double_0_5_1;

            o << perturbation_opencl_double_post_c;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_0_5_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_c;

            o << perturbation_opencl_floatexp_0_5_1;

            o << perturbation_opencl_floatexp_post_c;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_0_5_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_c;

            o << perturbation_opencl_softfloat_0_5_1;

            o << perturbation_opencl_softfloat_post_c;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_0_5_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
        case 6:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_c;

            o << perturbation_opencl_double_0_6_1;

            o << perturbation_opencl_double_post_c;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_0_6_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_c;

            o << perturbation_opencl_floatexp_0_6_1;

            o << perturbation_opencl_floatexp_post_c;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_0_6_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_c;

            o << perturbation_opencl_softfloat_0_6_1;

            o << perturbation_opencl_softfloat_post_c;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_0_6_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
        case 7:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_c;

            o << perturbation_opencl_double_0_7_1;

            o << perturbation_opencl_double_post_c;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_0_7_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_c;

            o << perturbation_opencl_floatexp_0_7_1;

            o << perturbation_opencl_floatexp_post_c;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_0_7_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_c;

            o << perturbation_opencl_softfloat_0_7_1;

            o << perturbation_opencl_softfloat_post_c;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_0_7_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
        case 8:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_c;

            o << perturbation_opencl_double_0_8_1;

            o << perturbation_opencl_double_post_c;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_0_8_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_c;

            o << perturbation_opencl_floatexp_0_8_1;

            o << perturbation_opencl_floatexp_post_c;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_0_8_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_c;

            o << perturbation_opencl_softfloat_0_8_1;

            o << perturbation_opencl_softfloat_post_c;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_0_8_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
        case 9:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_c;

            o << perturbation_opencl_double_0_9_1;

            o << perturbation_opencl_double_post_c;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_0_9_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_c;

            o << perturbation_opencl_floatexp_0_9_1;

            o << perturbation_opencl_floatexp_post_c;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_0_9_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_c;

            o << perturbation_opencl_softfloat_0_9_1;

            o << perturbation_opencl_softfloat_post_c;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_0_9_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
        case 10:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_c;

            o << perturbation_opencl_double_0_10_1;

            o << perturbation_opencl_double_post_c;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_0_10_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_c;

            o << perturbation_opencl_floatexp_0_10_1;

            o << perturbation_opencl_floatexp_post_c;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_0_10_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_c;

            o << perturbation_opencl_softfloat_0_10_1;

            o << perturbation_opencl_softfloat_post_c;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_0_10_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // Burning Ship
    case 1:
      switch (m_nPower)
      {
      
        case 2:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_1_2_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_1_2_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_1_2_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_1_2_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_1_2_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_1_2_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
        case 3:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_1_3_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_1_3_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_1_3_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_1_3_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_1_3_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_1_3_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
        case 4:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_1_4_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_1_4_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_1_4_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_1_4_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_1_4_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_1_4_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
        case 5:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_1_5_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_1_5_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_1_5_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_1_5_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_1_5_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_1_5_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // Buffalo
    case 2:
      switch (m_nPower)
      {
      
        case 2:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_2_2_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_2_2_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_2_2_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_2_2_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_2_2_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_2_2_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
        case 3:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_2_3_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_2_3_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_2_3_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_2_3_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_2_3_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_2_3_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
        case 4:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_2_4_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_2_4_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_2_4_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_2_4_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_2_4_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_2_4_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
        case 5:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_2_5_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_2_5_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_2_5_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_2_5_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_2_5_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_2_5_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // Celtic
    case 3:
      switch (m_nPower)
      {
      
        case 2:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_3_2_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_3_2_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_3_2_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_3_2_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_3_2_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_3_2_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
        case 3:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_3_3_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_3_3_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_3_3_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_3_3_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_3_3_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_3_3_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
        case 4:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_3_4_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_3_4_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_3_4_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_3_4_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_3_4_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_3_4_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
        case 5:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_3_5_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_3_5_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_3_5_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_3_5_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_3_5_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_3_5_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // Mandelbar
    case 4:
      switch (m_nPower)
      {
      
        case 2:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_4_2_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_4_2_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_4_2_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_4_2_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_4_2_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_4_2_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
        case 3:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_4_3_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_4_3_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_4_3_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_4_3_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_4_3_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_4_3_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
        case 4:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_4_4_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_4_4_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_4_4_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_4_4_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_4_4_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_4_4_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
        case 5:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_4_5_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_4_5_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_4_5_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_4_5_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_4_5_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_4_5_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // Mandelbar Celtic
    case 5:
      switch (m_nPower)
      {
      
        case 2:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_5_2_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_5_2_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_5_2_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_5_2_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_5_2_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_5_2_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // Perpendicular Mandelbrot
    case 6:
      switch (m_nPower)
      {
      
        case 2:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_6_2_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_6_2_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_6_2_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_6_2_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_6_2_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_6_2_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // Perpendicular Burning Ship
    case 7:
      switch (m_nPower)
      {
      
        case 2:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_7_2_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_7_2_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_7_2_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_7_2_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_7_2_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_7_2_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // Perpendicular Celtic
    case 8:
      switch (m_nPower)
      {
      
        case 2:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_8_2_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_8_2_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_8_2_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_8_2_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_8_2_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_8_2_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // Perpendicular Buffalo
    case 9:
      switch (m_nPower)
      {
      
        case 2:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_9_2_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_9_2_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_9_2_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_9_2_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_9_2_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_9_2_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // Cubic Quasi Burning Ship
    case 10:
      switch (m_nPower)
      {
      
        case 3:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_10_3_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_10_3_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_10_3_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_10_3_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_10_3_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_10_3_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // Cubic Partial BS Real
    case 11:
      switch (m_nPower)
      {
      
        case 3:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_11_3_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_11_3_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_11_3_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_11_3_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_11_3_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_11_3_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // Cubic Partial BS Imag
    case 12:
      switch (m_nPower)
      {
      
        case 3:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_12_3_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_12_3_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_12_3_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_12_3_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_12_3_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_12_3_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // Cubic Flying Squirrel (Buffalo Imag)
    case 13:
      switch (m_nPower)
      {
      
        case 3:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_13_3_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_13_3_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_13_3_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_13_3_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_13_3_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_13_3_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // Cubic Quasi Perpendicular
    case 14:
      switch (m_nPower)
      {
      
        case 3:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_14_3_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_14_3_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_14_3_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_14_3_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_14_3_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_14_3_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // 4th Burning Ship Partial Imag
    case 15:
      switch (m_nPower)
      {
      
        case 4:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_15_4_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_15_4_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_15_4_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_15_4_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_15_4_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_15_4_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // 4th Burning Ship Partial Real
    case 16:
      switch (m_nPower)
      {
      
        case 4:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_16_4_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_16_4_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_16_4_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_16_4_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_16_4_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_16_4_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // 4th Burning Ship Partial Real Mbar
    case 17:
      switch (m_nPower)
      {
      
        case 4:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_17_4_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_17_4_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_17_4_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_17_4_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_17_4_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_17_4_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Imag
    case 18:
      switch (m_nPower)
      {
      
        case 4:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_18_4_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_18_4_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_18_4_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_18_4_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_18_4_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_18_4_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real
    case 19:
      switch (m_nPower)
      {
      
        case 4:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_19_4_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_19_4_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_19_4_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_19_4_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_19_4_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_19_4_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real Mbar
    case 20:
      switch (m_nPower)
      {
      
        case 4:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_20_4_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_20_4_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_20_4_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_20_4_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_20_4_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_20_4_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // 4th Buffalo Partial Imag
    case 21:
      switch (m_nPower)
      {
      
        case 4:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_21_4_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_21_4_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_21_4_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_21_4_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_21_4_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_21_4_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // 4th Celtic Mbar
    case 22:
      switch (m_nPower)
      {
      
        case 4:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_22_4_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_22_4_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_22_4_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_22_4_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_22_4_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_22_4_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // 4th False Quasi Perpendicular
    case 23:
      switch (m_nPower)
      {
      
        case 4:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_23_4_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_23_4_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_23_4_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_23_4_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_23_4_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_23_4_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // 4th False Quasi Heart
    case 24:
      switch (m_nPower)
      {
      
        case 4:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_24_4_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_24_4_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_24_4_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_24_4_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_24_4_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_24_4_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // 4th Celtic False Quasi Perpendicular
    case 25:
      switch (m_nPower)
      {
      
        case 4:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_25_4_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_25_4_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_25_4_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_25_4_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_25_4_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_25_4_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // 4th Celtic False Quasi Heart
    case 26:
      switch (m_nPower)
      {
      
        case 4:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_26_4_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_26_4_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_26_4_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_26_4_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_26_4_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_26_4_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // 5th Burning Ship Partial
    case 27:
      switch (m_nPower)
      {
      
        case 5:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_27_5_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_27_5_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_27_5_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_27_5_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_27_5_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_27_5_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // 5th Burning Ship Partial Mbar
    case 28:
      switch (m_nPower)
      {
      
        case 5:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_28_5_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_28_5_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_28_5_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_28_5_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_28_5_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_28_5_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // 5th Celtic Mbar
    case 29:
      switch (m_nPower)
      {
      
        case 5:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_29_5_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_29_5_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_29_5_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_29_5_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_29_5_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_29_5_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // 5th Quasi Burning Ship (BS/Buffalo Hybrid)
    case 30:
      switch (m_nPower)
      {
      
        case 5:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_30_5_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_30_5_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_30_5_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_30_5_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_30_5_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_30_5_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // 5th Quasi Perpendicular
    case 31:
      switch (m_nPower)
      {
      
        case 5:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_31_5_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_31_5_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_31_5_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_31_5_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_31_5_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_31_5_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // 5th Quasi Heart
    case 32:
      switch (m_nPower)
      {
      
        case 5:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_32_5_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_32_5_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_32_5_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_32_5_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_32_5_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_32_5_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // SimonBrot 4th
    case 33:
      switch (m_nPower)
      {
      
        case 4:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_33_4_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_33_4_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_33_4_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_33_4_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_33_4_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_33_4_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // 4th Imag Quasi Perpendicular / Heart
    case 34:
      switch (m_nPower)
      {
      
        case 4:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_34_4_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_34_4_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_34_4_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_34_4_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_34_4_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_34_4_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // 4th Real Quasi Perpendicular
    case 35:
      switch (m_nPower)
      {
      
        case 4:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_35_4_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_35_4_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_35_4_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_35_4_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_35_4_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_35_4_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // 4th Real Quasi Heart
    case 36:
      switch (m_nPower)
      {
      
        case 4:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_36_4_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_36_4_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_36_4_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_36_4_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_36_4_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_36_4_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // 4th Celtic Imag Quasi Perpendicular / Heart
    case 37:
      switch (m_nPower)
      {
      
        case 4:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_37_4_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_37_4_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_37_4_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_37_4_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_37_4_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_37_4_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // 4th Celtic Real Quasi Perpendicular
    case 38:
      switch (m_nPower)
      {
      
        case 4:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_38_4_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_38_4_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_38_4_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_38_4_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_38_4_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_38_4_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // 4th Celtic Real Quasi Heart
    case 39:
      switch (m_nPower)
      {
      
        case 4:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_39_4_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_39_4_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_39_4_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_39_4_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_39_4_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_39_4_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // SimonBrot 6th
    case 40:
      switch (m_nPower)
      {
      
        case 6:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_40_6_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_40_6_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_40_6_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_40_6_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_40_6_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_40_6_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // HPDZ Buffalo
    case 41:
      switch (m_nPower)
      {
      
        case 2:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_41_2_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_41_2_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_41_2_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_41_2_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_41_2_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_41_2_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // TheRedshiftRider 1: a * z^2 + z^3 + c
    case 42:
      switch (m_nPower)
      {
      
        case 3:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_c;

            o << perturbation_opencl_double_42_3_1;

            o << perturbation_opencl_double_post_c;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_42_3_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_c;

            o << perturbation_opencl_floatexp_42_3_1;

            o << perturbation_opencl_floatexp_post_c;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_42_3_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_c;

            o << perturbation_opencl_softfloat_42_3_1;

            o << perturbation_opencl_softfloat_post_c;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_42_3_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // TheRedshiftRider 2: a * z^2 - z^3 + c
    case 43:
      switch (m_nPower)
      {
      
        case 3:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_c;

            o << perturbation_opencl_double_43_3_1;

            o << perturbation_opencl_double_post_c;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_43_3_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_c;

            o << perturbation_opencl_floatexp_43_3_1;

            o << perturbation_opencl_floatexp_post_c;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_43_3_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_c;

            o << perturbation_opencl_softfloat_43_3_1;

            o << perturbation_opencl_softfloat_post_c;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_43_3_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // TheRedshiftRider 3: 2 * z^2 - z^3 + c
    case 44:
      switch (m_nPower)
      {
      
        case 3:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_c;

            o << perturbation_opencl_double_44_3_1;

            o << perturbation_opencl_double_post_c;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_44_3_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_c;

            o << perturbation_opencl_floatexp_44_3_1;

            o << perturbation_opencl_floatexp_post_c;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_44_3_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_c;

            o << perturbation_opencl_softfloat_44_3_1;

            o << perturbation_opencl_softfloat_post_c;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_44_3_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // TheRedshiftRider 4: a * z^2 + z^4 + c
    case 45:
      switch (m_nPower)
      {
      
        case 4:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_c;

            o << perturbation_opencl_double_45_4_1;

            o << perturbation_opencl_double_post_c;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_45_4_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_c;

            o << perturbation_opencl_floatexp_45_4_1;

            o << perturbation_opencl_floatexp_post_c;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_45_4_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_c;

            o << perturbation_opencl_softfloat_45_4_1;

            o << perturbation_opencl_softfloat_post_c;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_45_4_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // TheRedshiftRider 5: a * z^2 - z^4 + c
    case 46:
      switch (m_nPower)
      {
      
        case 4:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_c;

            o << perturbation_opencl_double_46_4_1;

            o << perturbation_opencl_double_post_c;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_46_4_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_c;

            o << perturbation_opencl_floatexp_46_4_1;

            o << perturbation_opencl_floatexp_post_c;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_46_4_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_c;

            o << perturbation_opencl_softfloat_46_4_1;

            o << perturbation_opencl_softfloat_post_c;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_46_4_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // TheRedshiftRider 6: a * z^2 + z^5 + c
    case 47:
      switch (m_nPower)
      {
      
        case 5:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_c;

            o << perturbation_opencl_double_47_5_1;

            o << perturbation_opencl_double_post_c;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_47_5_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_c;

            o << perturbation_opencl_floatexp_47_5_1;

            o << perturbation_opencl_floatexp_post_c;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_47_5_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_c;

            o << perturbation_opencl_softfloat_47_5_1;

            o << perturbation_opencl_softfloat_post_c;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_47_5_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // TheRedshiftRider 7: a * z^2 - z^5 + c
    case 48:
      switch (m_nPower)
      {
      
        case 5:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_c;

            o << perturbation_opencl_double_48_5_1;

            o << perturbation_opencl_double_post_c;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_48_5_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_c;

            o << perturbation_opencl_floatexp_48_5_1;

            o << perturbation_opencl_floatexp_post_c;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_48_5_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_c;

            o << perturbation_opencl_softfloat_48_5_1;

            o << perturbation_opencl_softfloat_post_c;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_48_5_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // TheRedshiftRider 8: a * z^2 + z^6 + c
    case 49:
      switch (m_nPower)
      {
      
        case 6:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_c;

            o << perturbation_opencl_double_49_6_1;

            o << perturbation_opencl_double_post_c;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_49_6_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_c;

            o << perturbation_opencl_floatexp_49_6_1;

            o << perturbation_opencl_floatexp_post_c;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_49_6_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_c;

            o << perturbation_opencl_softfloat_49_6_1;

            o << perturbation_opencl_softfloat_post_c;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_49_6_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // TheRedshiftRider 9: a * z^2 - z^6 + c
    case 50:
      switch (m_nPower)
      {
      
        case 6:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_c;

            o << perturbation_opencl_double_50_6_1;

            o << perturbation_opencl_double_post_c;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_50_6_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_c;

            o << perturbation_opencl_floatexp_50_6_1;

            o << perturbation_opencl_floatexp_post_c;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_50_6_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_c;

            o << perturbation_opencl_softfloat_50_6_1;

            o << perturbation_opencl_softfloat_post_c;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_50_6_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // SimonBrot2 4th
    case 51:
      switch (m_nPower)
      {
      
        case 4:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_51_4_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_51_4_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_51_4_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_51_4_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_51_4_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_51_4_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // General Quadratic Minus
    case 52:
      switch (m_nPower)
      {
      
        case 2:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_52_2_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_52_2_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_52_2_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_52_2_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_52_2_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_52_2_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // General Quadratic Plus
    case 53:
      switch (m_nPower)
      {
      
        case 2:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_53_2_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_53_2_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_53_2_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_53_2_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_53_2_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_53_2_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // Mothbrot 2nd 1x1
    case 54:
      switch (m_nPower)
      {
      
        case 2:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_54_2_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_54_2_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_54_2_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_54_2_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_54_2_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_54_2_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // Mothbrot 3rd 1x2
    case 55:
      switch (m_nPower)
      {
      
        case 3:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_55_3_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_55_3_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_55_3_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_55_3_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_55_3_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_55_3_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // Mothbrot 3rd 2x1
    case 56:
      switch (m_nPower)
      {
      
        case 3:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_56_3_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_56_3_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_56_3_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_56_3_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_56_3_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_56_3_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // Mothbrot 4th 1x3
    case 57:
      switch (m_nPower)
      {
      
        case 4:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_57_4_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_57_4_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_57_4_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_57_4_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_57_4_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_57_4_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // Mothbrot 4th 2x2 (aka SimonBrot 4th)
    case 58:
      switch (m_nPower)
      {
      
        case 4:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_58_4_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_58_4_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_58_4_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_58_4_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_58_4_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_58_4_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // Mothbrot 4th 3x1
    case 59:
      switch (m_nPower)
      {
      
        case 4:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_59_4_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_59_4_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_59_4_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_59_4_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_59_4_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_59_4_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // Mothbrot 5th 1x4
    case 60:
      switch (m_nPower)
      {
      
        case 5:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_60_5_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_60_5_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_60_5_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_60_5_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_60_5_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_60_5_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // Mothbrot 5th 2x3
    case 61:
      switch (m_nPower)
      {
      
        case 5:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_61_5_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_61_5_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_61_5_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_61_5_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_61_5_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_61_5_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // Mothbrot 5th 3x2
    case 62:
      switch (m_nPower)
      {
      
        case 5:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_62_5_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_62_5_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_62_5_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_62_5_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_62_5_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_62_5_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // Mothbrot 5th 4x1
    case 63:
      switch (m_nPower)
      {
      
        case 5:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_63_5_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_63_5_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_63_5_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_63_5_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_63_5_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_63_5_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // Mothbrot 6th 1x5
    case 64:
      switch (m_nPower)
      {
      
        case 6:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_64_6_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_64_6_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_64_6_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_64_6_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_64_6_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_64_6_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // Mothbrot 6th 2x4 (Simon's Mothbrot)
    case 65:
      switch (m_nPower)
      {
      
        case 6:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_65_6_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_65_6_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_65_6_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_65_6_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_65_6_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_65_6_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // Mothbrot 6th 3x3 (aka SimonBrot 6th)
    case 66:
      switch (m_nPower)
      {
      
        case 6:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_66_6_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_66_6_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_66_6_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_66_6_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_66_6_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_66_6_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // Mothbrot 6th 4x2
    case 67:
      switch (m_nPower)
      {
      
        case 6:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_67_6_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_67_6_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_67_6_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_67_6_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_67_6_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_67_6_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // Mothbrot 6th 5x1
    case 68:
      switch (m_nPower)
      {
      
        case 6:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_68_6_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_68_6_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_68_6_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_68_6_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_68_6_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_68_6_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // General Abs Quadratic Minus
    case 69:
      switch (m_nPower)
      {
      
        case 2:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_69_2_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_69_2_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_69_2_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_69_2_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_69_2_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_69_2_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // General Abs Quadratic Plus
    case 70:
      switch (m_nPower)
      {
      
        case 2:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_m;

            o << perturbation_opencl_double_70_2_1;

            o << perturbation_opencl_double_post_m;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_70_2_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_m;

            o << perturbation_opencl_floatexp_70_2_1;

            o << perturbation_opencl_floatexp_post_m;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_70_2_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_m;

            o << perturbation_opencl_softfloat_70_2_1;

            o << perturbation_opencl_softfloat_post_m;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_70_2_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
    // z^2 exp(2 a / z) + c
    case 71:
      switch (m_nPower)
      {
      
        case 2:
        {
          std::ostringstream o;
          o << perturbation_opencl_common;

          if (derivatives)
          {

            o << perturbation_opencl_double_pre_c;

            o << perturbation_opencl_double_71_2_1;

            o << perturbation_opencl_double_post_c;

          }
          else
          {
            o << perturbation_opencl_double_pre;
            o << perturbation_opencl_double_71_2_0;
            o << perturbation_opencl_double_post;
          }

          if (derivatives)
          {

            o << perturbation_opencl_floatexp_pre_c;

            o << perturbation_opencl_floatexp_71_2_1;

            o << perturbation_opencl_floatexp_post_c;

          }
          else
          {
            o << perturbation_opencl_floatexp_pre;
            o << perturbation_opencl_floatexp_71_2_0;
            o << perturbation_opencl_floatexp_post;
          }

#if 0
          if (derivatives)
          {

            o << perturbation_opencl_softfloat_pre_c;

            o << perturbation_opencl_softfloat_71_2_1;

            o << perturbation_opencl_softfloat_post_c;

          }
          else
          {
            o << perturbation_opencl_softfloat_pre;
            o << perturbation_opencl_softfloat_71_2_0;
            o << perturbation_opencl_softfloat_post;
          }
#endif

          return o.str();
        }
      
      }
      break;
  
  }
  return perturbation_opencl_error;
}

